<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->HasRight ('admin/errorlog', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/errorlog', true);
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function errorlog_ConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_ERRORLOG_TITLE);
	$menu->InsertEntry (_ERRORLOG_MAIN, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'errorlog') );
	$menu->InsertEntry (_ERRORLOG_SETTINGS, $opnConfig['opn_url'] . '/admin/errorlog/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function errorlog_show () {

	global $opnTables, $opnConfig;

	$sortby = 'desc_error_time';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(error_id) AS counter FROM ' . $opnTables['opn_error_log'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	$justforcounting->Close ();
	unset ($justforcounting);
	unset ($sql);
	$sql = 'SELECT error_id, error_time, error_messages, error_level, error_modul FROM ' . $opnTables['opn_error_log'];
	$sortby1 = _ERRORLOG_ORDERBY . ' ';
	switch ($sortby) {
		case 'asc_error_id':
			$sortby1 .= _ERRORLOG_ID . '&nbsp;' . _ERRORLOG_ORDERASC;
			break;
		case 'desc_error_id':
			$sortby1 .= _ERRORLOG_ID . '&nbsp;' . _ERRORLOG_ORDERDESC;
			break;
		case 'asc_error_time':
			$sortby1 .= _ERRORLOG_DATE . '&nbsp;' . _ERRORLOG_ORDERASC;
			break;
		case 'desc_error_time':
			$sortby1 .= _ERRORLOG_DATE . '&nbsp;' . _ERRORLOG_ORDERDESC;
			break;
		case 'asc_error_messages':
			$sortby1 .= _ERRORLOG_MESSAGE . '&nbsp;' . _ERRORLOG_ORDERASC;
			break;
		case 'desc_error_messages':
			$sortby1 .= _ERRORLOG_MESSAGE . '&nbsp;' . _ERRORLOG_ORDERDESC;
			break;
		case 'asc_error_level':
			$sortby1 .= _ERRORLOG_LEVEL . '&nbsp;' . _ERRORLOG_ORDERASC;
			break;
		case 'desc_error_level':
			$sortby1 .= _ERRORLOG_LEVEL . '&nbsp;' . _ERRORLOG_ORDERDESC;
			break;
	}
	$boxtxt = '<br /><br />';
	$boxtxt .= '<div class="centertag">' . $sortby1 . '</div><br /><br />';
	$progurl = array ($opnConfig['opn_url'] . '/admin.php',
			'fct' => 'errorlog',
			'op' => 'showerror');
	$newsort = $sortby;
	$table = & new opn_TableClass ('alternator');
	$order = '';
	$table->get_sort_order ($order, array ('error_id',
						'error_time',
						'error_messages',
						'error_level'),
						$newsort);
	$table->AddHeaderRow (array ($table->get_sort_feld ('error_id', _ERRORLOG_ID, $progurl), $table->get_sort_feld ('error_time', _ERRORLOG_DATE, $progurl), $table->get_sort_feld ('error_messages', _ERRORLOG_MESSAGE, $progurl), $table->get_sort_feld ('error_level', _ERRORLOG_LEVEL, $progurl) ) );
	$hresult = &$opnConfig['database']->SelectLimit ($sql . $order, $maxperpage, $offset);
	if ($hresult !== false) {
		while (! $hresult->EOF) {
			$id = $hresult->fields['error_id'];
			$date = $hresult->fields['error_time'];
			$message = $hresult->fields['error_messages'];
			$module = $hresult->fields['error_modul'];
			$opnConfig['opndate']->sqlToopnData ($date);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_FORUMDATESTRING2);
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="' . $table->currentclass . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
														'fct' => 'errorlog',
														'op' => 'showerror',
														_OPN_VAR_TABLE_SORT_VAR => $sortby,
														'id' => $id) ) . '">' . $id . '</a>');
			$table->AddDataCol ($date);
			$message = str_replace (_OPN_HTML_NL, '<br />', $message);
			if ($module != '') {
				$module = $module . ' - ';
			}
			$table->AddDataCol ($module . $message);
			$table->AddDataCol ($hresult->fields['error_level']);
			$table->AddCloseRow ();
			$hresult->MoveNext ();
		}
	}
	$hresult->close ();
	unset ($message);
	unset ($id);
	unset ($date);
	unset ($message);
	unset ($hresult);
	$table->AddOpenFootRow ();
	$table->AddFooterCol (_ERRORLOG_FUNCTION, '', '', '', '', 'alternatorfoot');
	$table->AddFooterCol ($opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/admin.php',
										'fct' => 'errorlog',
										'op' => 'ErrorDelAll',
										'ok' => '0'), 'alternatorfoot', _ERRORLOG_DELETEALL ));
	$table->AddFooterCol ('&nbsp;');
	$table->AddFooterCol ('&nbsp;');
	$table->AddCloseRow ();
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/admin.php',
					'fct' => 'errorlog',
					'op' => 'showerror',
					_OPN_VAR_TABLE_SORT_VAR => $sortby),
					$reccount,
					$maxperpage,
					$offset);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_ERRORLOG_20_';
	$_display_dat['module'] = 'admin/errorlog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ERRORLOG_TITLE, $boxtxt);
	unset ($boxtxt);
	unset ($sql);
	unset ($order);
	unset ($sortby1);
	unset ($reccount);

}

function errorlog_showerror () {

	global $opnTables, $opnConfig;

	$showid = 0;
	get_var ('id', $showid, 'url', _OOBJ_DTYPE_INT);
	$boxtitle = _ERRORLOG_TITLE;
	$sql = 'SELECT error_id, error_time, error_messages, error_level FROM ' . $opnTables['opn_error_log'] . " WHERE error_id=" . $showid;
	$table = & new opn_TableClass ('listalternator');
	$hresult = $opnConfig['database']->Execute ($sql);
	$hasoutput = false;
	if ($hresult !== false) {
		while (! $hresult->EOF) {
			$id = $hresult->fields['error_id'];
			$date = $hresult->fields['error_time'];
			$message = $hresult->fields['error_messages'];
			$level = $hresult->fields['error_level'];
			$opnConfig['opndate']->sqlToopnData ($date);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_FORUMDATESTRING2);
			$table->AddOpenRow ();
			$table->AddDataCol (_ERRORLOG_ID);
			$table->AddDataCol ('<a class="' . $table->currentclass . '" href="' . encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=errorlog') . '">' . $id . '</a>');
			$table->AddChangeRow ();
			$table->AddDataCol (_ERRORLOG_DATE);
			$table->AddDataCol ($date);
			$table->AddChangeRow ();
			$message = str_replace (_OPN_HTML_NL, '<br />', $message);
			$table->AddDataCol (_ERRORLOG_MESSAGE);
			$table->AddDataCol ($message);
			$table->AddChangeRow ();
			$table->AddDataCol (_ERRORLOG_LEVEL);
			$table->AddDataCol ($level);
			$table->AddCloseRow ();
			$table->AddOpenFootRow ();
			$table->AddFooterCol (_ERRORLOG_FUNCTION);
			$table->AddFooterCol ($opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/admin.php',
													'fct' => 'errorlog',
													'op' => 'ErrorDel',
													'id' => $id,
													'ok' => '0'), 'listalternatorfoot' ));
			$table->AddCloseRow ();
			$hresult->MoveNext ();
			$hasoutput = true;
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	if ($hasoutput === true) {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_ERRORLOG_30_';
		$_display_dat['module'] = 'admin/errorlog';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	}

}

function ErrorDel () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_error_log'] . ' WHERE error_id=' . $id);
	} else {
		$boxtxt = '<div class="centertag"><br />';
		$boxtxt .= '<span class="alerttext">' . _DELDATA_WARNING . '</span><br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
										'fct' => 'errorlog',
										'op' => 'ErrorDel',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=errorlog') . '">' . _NO . '</a><br /><br /></div>';
	}
	return $boxtxt;

}

function ErrorDelAll () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_error_log']);
	} else {
		$boxtxt = '<div class="centertag"><br />';
		$boxtxt .= '<span class="alerttext">';
		$boxtxt .= _ERRORLOG_WARNING_ALL . '</span><br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
										'fct' => 'errorlog',
										'op' => 'ErrorDelAll',
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=errorlog') . '">' . _NO . '</a><br /><br /></div>';
	}
	return $boxtxt;

}

?>