<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.adminmenu.php');
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.settings_masterinterface.php');
$opnConfig['permission']->HasRight ('admin/masterinterfaceaccess', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/masterinterfaceaccess', true);

function masterinterfaceaccess_ConfigHeader () {

	global $opnConfig, $opnTables;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_10_';
	$_display_dat['module'] = 'admin/masterinterfaceaccess';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$menu = & new OPN_Adminmenu (_MIF_ADMIN);
	$menu->InsertEntry (_MIF_MAIN, array ($opnConfig['opn_url'] . '/admin.php', 'fct' => 'masterinterfaceaccess') );
	$menu->InsertEntry (_MIF_SETTINGS, $opnConfig['opn_url'] . '/admin/masterinterfaceaccess/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function sortboxarray ($a, $b) {

	$a1 = $a['name'];
	$b1 = $b['name'];
	return strcollcase ($a1, $b1);

}

function get_masterinterfaceaccess () {

	global $opnConfig;

	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'webinterfacehost');
	foreach ($plug as $var1) {
		if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . '/opn_item.php') ) {
			include_once (_OPN_ROOT_PATH . $var1['plugin'] . '/opn_item.php');
			$myfunc = $var1['module'] . '_get_admin_config';
			$help = array ();
			$myfunc ($help);
			$desc = $help['description'];
			unset ($help);
		} else {
			$desc = '';
		}
		$name = $var1['plugin'];
		$mytypearr[$name] = array ('desc' => $desc,
					'plugin' => $var1['plugin'],
					'name' => $name,
					'module' => $var1['module']);
	}
	return $mytypearr;

}

function masterinterfaceaccessAdmin () {

	global $opnConfig;

	$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
	$masterinterfaceaccess = get_masterinterfaceaccess ();
	usort ($masterinterfaceaccess, 'sortboxarray');
	$table = & new opn_TableClass ('alternator');
	if ( ($opnConfig['permission']->UserInfo ('uid') == 2) && ($opnConfig['opn_multihome'] == 1) ) {
		$table->AddHeaderRow (array (_MIF_MODULE, _MIF_WEBINTERFACEHOST, _MIF_WEBINTERFACEGET, _MIF_WEBINTERFACESEARCH, _MIF_WEBINTERFACEPLUGIN) );
	} else {
		$table->AddHeaderRow (array (_MIF_MODULE, _MIF_WEBINTERFACEHOST, _MIF_WEBINTERFACEGET, _MIF_WEBINTERFACESEARCH) );
	}
	$i = 1;
	$module = & new MyModules;
	foreach ($masterinterfaceaccess as $page) {
		$i++;
		$module->SetModuleName ($page['plugin']);
		$module->LoadPrivateSettings ();
		$psett = $module->privatesettings;
		if (!is_array ($psett) ) {
			$psett = array ();
		}
		$table->AddOpenRow ();
		$table->AddDataCol ('<a class="' . $table->currentclass . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
													'fct' => 'masterinterfaceaccess',
													'op' => 'masterinterfaceaccessEdit',
													'modulename' => $page['plugin']) ) . '">' . $page['name'] . '</a>');
		if ( (!isset ($psett['OPN_PL_MIF_webinterfacehost']) ) || ($psett['OPN_PL_MIF_webinterfacehost'] == 0) ) {
			$table->AddDataCol (_NO);
		} else {
			$table->AddDataCol (_YES);
		}
		if ( (!isset ($psett['OPN_PL_MIF_webinterfaceget']) ) || ($psett['OPN_PL_MIF_webinterfaceget'] == 0) ) {
			$table->AddDataCol (_NO);
		} else {
			$table->AddDataCol (_YES);
		}
		if ( (!isset ($psett['OPN_PL_MIF_webinterfacesearch']) ) || ($psett['OPN_PL_MIF_webinterfacesearch'] == 0) ) {
			$table->AddDataCol (_NO);
		} else {
			$table->AddDataCol (_YES);
		}
		if ( ($opnConfig['permission']->UserInfo ('uid') == 2) && ($opnConfig['opn_multihome'] == 1) ) {
			if ( (!isset ($psett['OPN_PL_MIF_webinterfaceplugin']) ) || ($psett['OPN_PL_MIF_webinterfaceplugin'] == 0) ) {
				$table->AddDataCol (_NO);
			} else {
				$table->AddDataCol (_YES);
			}
		}
		$table->AddCloseRow ();
	}
	$help = '';
	$table->GetTable ($help);
	$help .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_50_';
	$_display_dat['module'] = 'admin/masterinterfaceaccess';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MIF_ADMIN, $help);

}

function masterinterfaceaccess_allhiddens ($wichSave, $settings) {

	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'module',
			'value' => $wichSave);
	foreach ($settings as $key => $value) {
		if ( ($key != 'OPN_PL_MIF_webinterfacesearch') && ($key != 'OPN_PL_MIF_webinterfaceget') && ($key != 'OPN_PL_MIF_webinterfaceplugin') && ($key != 'OPN_PL_MIF_webinterfacehost') ) {
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => $key,
					'value' => $value);
		}
	}
	$nav[_MIF_SAVE] = _MIF_SAVE;
	$nav[_MIF_ADMIN] = _MIF_ADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function masterinterfaceaccessEdit () {

	global $opnConfig;

	$modulename = '';
	get_var ('modulename', $modulename, 'url', _OOBJ_DTYPE_CLEAN);
	$mod = & new MyModules;
	$mod->SetModuleName ($modulename);
	$mod->LoadPrivateSettings ();
	$sett = $mod->privatesettings;
	if (!is_array ($sett) ) {
		$sett = array ();
	}
	if (!isset ($sett['OPN_PL_MIF_webinterfacehost']) ) {
		$sett['OPN_PL_MIF_webinterfacehost'] = 0;
	}
	if (!isset ($sett['OPN_PL_MIF_webinterfaceget']) ) {
		$sett['OPN_PL_MIF_webinterfaceget'] = 0;
	}
	if (!isset ($sett['OPN_PL_MIF_webinterfacesearch']) ) {
		$sett['OPN_PL_MIF_webinterfacesearch'] = 0;
	}
	if (!isset ($sett['OPN_PL_MIF_webinterfaceplugin']) ) {
		$sett['OPN_PL_MIF_webinterfaceplugin'] = 0;
	}
	$set = & new MySettings_Masterinterface;
	$values = $set->GetMasterinterfaceForm ($sett);
	$help = '<a class="listalternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'masterinterfaceaccess',
									'op' => 'PasswordManagerAdmin',
									'module' => $modulename) ) . '">' . _MIF_MODULPASSWORDMANAGER . '</a>';
	$help .= '<br />';
	$help .= '<br />';
	$help .= '<a class="listalternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'masterinterfaceaccess',
									'op' => 'LicenseManagerAdmin',
									'module' => $modulename) ) . '">' . _MIF_MODULLICENSEMANAGER . '</a>';
	$values[] = array ('type' => _INPUT_HEADERLINE,
			'value' => $help);
	$values = array_merge ($values, masterinterfaceaccess_allhiddens ($modulename, $sett) );
	$set->GetTheForm (_MIF_SETTINGS, encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess'), $values);

}

function masterinterfaceaccessEditSave () {

	global $opnConfig, ${$opnConfig['opn_post_vars']};

	$vars = ${$opnConfig['opn_post_vars']};
	if ($vars['op'] != _MIF_ADMIN) {
		$mod = & new MyModules;
		$mod->SetModuleName ($vars['module']);
		unset ($vars['op']);
		unset ($vars['module']);
		$mod->privatesettings = $vars;
		$mod->SavePrivateSettings ();
	}
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess', false) );

}
// Password Manager

function PasswordManagerConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MIF_MODULPASSWORDMANAGER);
	$menu->InsertEntry (_MIF_ADMIN, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'masterinterfaceaccess') );
	$menu->InsertEntry (_MIF_MODULPASSWORDMANAGER, array ($opnConfig['opn_url'] . '/admin.php',
								'fct' => 'masterinterfaceaccess',
								'op' => 'PasswordManagerAdmin') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function PasswordManagerAdmin () {

	global $opnTables, $opnConfig;

	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_MIF_PASSID, _MIF_PASS_MODUL, _MIF_PASS_PASS, _MIF_PASS_EMAIL, '&nbsp;') );
	$result = &$opnConfig['database']->Execute ('SELECT pass_id, pass_modul, pass_pass, pass_email FROM ' . $opnTables['opn_masterinterface_pass'] . ' ORDER BY pass_id');
	while (! $result->EOF) {
		$pass_id = $result->fields['pass_id'];
		$pass_modul = $result->fields['pass_modul'];
		$pass_pass = $result->fields['pass_pass'];
		$pass_email = $result->fields['pass_email'];
		$table->AddOpenRow ();
		$table->AddDataCol ($pass_id);
		$table->AddDataCol ($pass_modul);
		$table->AddDataCol ($pass_pass);
		$table->AddDataCol ($pass_email);
		$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/admin.php',
													'fct' => 'masterinterfaceaccess',
													'op' => 'PasswordManagerEdit',
													'pass_id' => $pass_id), $table->currentclass) . ' ' .
							$opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/admin.php',																																'fct' => 'masterinterfaceaccess',
													'op' => 'PasswordManagerDel',
													'pass_id' => $pass_id,
													'ok' => '0'), $table->currentclass));
		$table->AddCloseRow ();
		$result->MoveNext ();
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br /><span class="extratextbold">' . _MIF_ADDPASS . '<br /><br /></span><div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_60_', 'passwordmanager');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess') );
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$options = array ();
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'webinterfacehost');
	foreach ($plug as $var1) {
		$options[$var1['module']] = $var1['module'];
	}
	asort ($options);
	$form->AddLabel ('pass_modul', _MIF_PASS_MODUL . ' ');
	$form->AddSelect ('pass_modul', $options);
	$form->AddChangeRow ();
	$form->AddLabel ('pass_pass', _MIF_PASS_PASS . ' ');
	$form->AddTextfield ('pass_pass', 31);
	$form->AddChangeRow ();
	$form->AddLabel ('pass_email', _MIF_PASS_EMAIL . ' ');
	$form->AddTextfield ('pass_email', 31);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'PasswordManagerAdd');
	$form->AddSubmit ('submit', _MIF_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$help = '';
	$form->GetFormular ($help);
	$help .= '</div>';
	$boxtxt .= $help;
	return $boxtxt;

}

function PasswordManagerAdd () {

	global $opnTables, $opnConfig;

	$pass_modul = '';
	get_var ('pass_modul', $pass_modul, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_pass = '';
	get_var ('pass_pass', $pass_pass, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_email = '';
	get_var ('pass_email', $pass_email, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_id = $opnConfig['opnSQL']->get_new_number ('opn_masterinterface_pass', 'pass_id');
	$pass_modul = $opnConfig['opnSQL']->qstr ($pass_modul);
	$pass_pass = $opnConfig['opnSQL']->qstr ($pass_pass);
	$pass_email = $opnConfig['opnSQL']->qstr ($pass_email);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_masterinterface_pass'] . " values ($pass_id, $pass_modul, $pass_pass, $pass_email)");

}

function PasswordManagerEdit () {

	global $opnTables, $opnConfig;

	$pass_id = 0;
	get_var ('pass_id', $pass_id, 'url', _OOBJ_DTYPE_INT);
	$result = $opnConfig['database']->Execute ('SELECT pass_id, pass_modul, pass_pass, pass_email FROM ' . $opnTables['opn_masterinterface_pass'] . ' WHERE pass_id=' . $pass_id);
	$pass_id = $result->fields['pass_id'];
	$pass_modul = $result->fields['pass_modul'];
	$pass_pass = $result->fields['pass_pass'];
	$pass_email = $result->fields['pass_email'];
	$boxtxt = '<div class="extratextbold">' . _MIF_EDITPASSWORD . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_70_', 'passwordmanageredit');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess') );
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$options = array ();
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'webinterfacehost');
	foreach ($plug as $var1) {
		$options[$var1['module']] = $var1['module'];
	}
	asort ($options);
	$form->AddLabel ('pass_modul', _MIF_PASS_MODUL . ' ');
	$form->AddSelect ('pass_modul', $options, $pass_modul);
	$form->AddChangeRow ();
	$form->AddLabel ('pass_pass', _MIF_PASS_PASS . ' ');
	$form->AddTextfield ('pass_pass', 31, 0, $pass_pass);
	$form->AddChangeRow ();
	$form->AddLabel ('pass_email', _MIF_PASS_EMAIL . ' ');
	$form->AddTextfield ('pass_email', 31, 0, $pass_email);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('pass_id', $pass_id);
	$form->AddHidden ('op', 'PasswordManagerSave');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _MIF_SAVECHANGES);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function PasswordManagerSave () {

	global $opnTables, $opnConfig;

	$pass_id = 0;
	get_var ('pass_id', $pass_id, 'form', _OOBJ_DTYPE_INT);
	$pass_modul = '';
	get_var ('pass_modul', $pass_modul, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_pass = '';
	get_var ('pass_pass', $pass_pass, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_email = '';
	get_var ('pass_email', $pass_email, 'form', _OOBJ_DTYPE_CLEAN);
	$pass_modul = $opnConfig['opnSQL']->qstr ($pass_modul);
	$pass_pass = $opnConfig['opnSQL']->qstr ($pass_pass);
	$pass_email = $opnConfig['opnSQL']->qstr ($pass_email);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_masterinterface_pass'] . " SET pass_modul=$pass_modul,pass_pass=$pass_pass,pass_email=$pass_email WHERE pass_id=$pass_id");

}

function PasswordManagerDel () {

	global $opnTables, $opnConfig;

	$pass_id = 0;
	get_var ('pass_id', $pass_id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_masterinterface_pass'] . ' WHERE pass_id=' . $pass_id);
		return '';
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= '' . _MIF_WARNING . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'masterinterfaceaccess',
									'op' => 'PasswordManagerDel',
									'pass_id' => $pass_id,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
														'fct' => 'masterinterfaceaccess',
														'op' => 'PasswordManagerAdmin') ) . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}
// License Manager

function LicenseManagerConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MIF_MODULPASSWORDMANAGER);
	$menu->InsertEntry (_MIF_ADMIN, array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'masterinterfaceaccess') );
	$menu->InsertEntry (_MIF_MODULLICENSEMANAGER, array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'masterinterfaceaccess',
							'op' => 'LicenseManagerAdmin') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function LicenseManagerAdmin () {

	global $opnTables, $opnConfig;

	$module = '';
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	$_module = $opnConfig['opnSQL']->qstr ($module);
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array ('&nbsp;', _MIF_LICENSE_PROG, _MIF_LICENSE_LICENSE, _MIF_LICENSE_CODE, '&nbsp;') );
	$result = &$opnConfig['database']->Execute ('SELECT lid, prog, license, code FROM ' . $opnTables['opn_license'] . ' WHERE prog = ' . $_module . ' ORDER BY lid');
	while (! $result->EOF) {
		$lid = $result->fields['lid'];
		$prog = $result->fields['prog'];
		$license = $result->fields['license'];
		$code = $result->fields['code'];
		$table->AddOpenRow ();
		$table->AddDataCol ($lid);
		$table->AddDataCol ($prog);
		$table->AddDataCol ($license);
		$table->AddDataCol ($code);
		$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/admin.php',
													'fct' => 'masterinterfaceaccess',
													'op' => 'LicenseManagerEdit',
													'lid' => $lid), $table->currentclass) . ' ' .
							$opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/admin.php',																																'fct' => 'masterinterfaceaccess',
													'op' => 'LicenseManagerDel',
													'lid' => $lid,
													'ok' => '0'), $table->currentclass));
		$table->AddCloseRow ();
		$result->MoveNext ();
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br /><span class="extratextbold">' . _MIF_ADDLICENSE . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_80_', 'licensemanager');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess') );
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('prog', _MIF_LICENSE_PROG);
	$form->AddTextfield ('prog', 31, 0, $module);
	$form->AddChangeRow ();
	$form->AddLabel ('license', _MIF_LICENSE_LICENSE);
	$form->AddTextfield ('license', 31);
	$form->AddChangeRow ();
	$form->AddLabel ('code', _MIF_LICENSE_CODE);
	$form->AddTextfield ('code', 31);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'LicenseManagerAdd');
	$form->AddHidden ('module', $module);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _MIF_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$help = '';
	$form->GetFormular ($help);
	$boxtxt .= $help;
	return $boxtxt;

}

function LicenseManagerAdd () {

	global $opnTables, $opnConfig;

	$prog = '';
	get_var ('prog', $prog, 'form', _OOBJ_DTYPE_CLEAN);
	$code = '';
	get_var ('code', $code, 'form', _OOBJ_DTYPE_CLEAN);
	$license = '';
	get_var ('license', $license, 'form', _OOBJ_DTYPE_CLEAN);
	$lid = $opnConfig['opnSQL']->get_new_number ('opn_license', 'lid');
	$prog = $opnConfig['opnSQL']->qstr ($prog);
	$code = $opnConfig['opnSQL']->qstr ($code);
	$license = $opnConfig['opnSQL']->qstr ($license);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_license'] . " values ($lid, $prog, $license, $code)");

}

function LicenseManagerSave () {

	global $opnTables, $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$prog = '';
	get_var ('prog', $prog, 'form', _OOBJ_DTYPE_CLEAN);
	$code = '';
	get_var ('code', $code, 'form', _OOBJ_DTYPE_CLEAN);
	$license = '';
	get_var ('license', $license, 'form', _OOBJ_DTYPE_CLEAN);
	$prog = $opnConfig['opnSQL']->qstr ($prog);
	$code = $opnConfig['opnSQL']->qstr ($code);
	$license = $opnConfig['opnSQL']->qstr ($license);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_license'] . " SET prog=$prog, license=$license, code=$code WHERE lid=$lid");

}

function LicenseManagerDel () {

	global $opnTables, $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_license'] . ' WHERE lid=' . $lid);
		return '';
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= '' . _MIF_WARNING . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'masterinterfaceaccess',
									'op' => 'LicenseManagerDel',
									'lid' => $lid,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
														'fct' => 'masterinterfaceaccess',
														'op' => 'PasswordManagerAdmin') ) . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function LicenseManagerEdit () {

	global $opnTables, $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT lid, prog, license, code FROM ' . $opnTables['opn_license'] . ' WHERE lid = ' . $lid);
	$prog = $result->fields['prog'];
	$license = $result->fields['license'];
	$code = $result->fields['code'];
	$boxtxt = '<div class="extratextbold">' . _MIF_EDITLICENSE . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MASTERINTERFACEACCESS_90_', 'passwordmanageredit');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=masterinterfaceaccess') );
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('prog', _MIF_LICENSE_PROG);
	$form->AddTextfield ('prog', 31, 0, $prog);
	$form->AddChangeRow ();
	$form->AddLabel ('license', _MIF_LICENSE_LICENSE);
	$form->AddTextfield ('license', 31, 0, $license);
	$form->AddChangeRow ();
	$form->AddLabel ('code', _MIF_LICENSE_CODE);
	$form->AddTextfield ('code', 31, 0, $code);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('lid', $lid);
	$form->AddHidden ('module', $prog);
	$form->AddHidden ('op', 'LicenseManagerSave');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _MIF_SAVECHANGES);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

?>