<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');
$opnConfig['permission']->HasRight ('admin/middlebox', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/middlebox', true);
getLanguageDef (_OPN_ROOT_PATH . 'admin/middlebox/language/');

function middleboxAdmin () {

	global $opnTables, $opnConfig;

	$filterside = -1;
	$offset = 0;
	$boxviewmodule = '';
	$module = '';
	$viewthemegroup = '0';
	get_var ('filterside', $filterside, 'both', _OOBJ_DTYPE_CLEAN);
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_CLEAN);
	get_var ('boxviewmodule', $boxviewmodule, 'both', _OOBJ_DTYPE_CLEAN);
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	get_var ('viewthemegroup', $viewthemegroup, 'both', _OOBJ_DTYPE_INT);

	$mymiddleboxtypes = get_all_box_types_from_modul ($boxviewmodule);
	usort ($mymiddleboxtypes, 'sortboxarray');
	$pagesize = $opnConfig['opn_gfx_defaultlistrows'];
	$min = $offset;
	// This is WHERE we start our record set from
	$max = $pagesize;
	// This is how many rows to select
	$prev_pos = '';

	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MIDDLEBOX_70_', 'middlebox_modul');
	$form->Init ($opnConfig['opn_url'] . '/admin.php');
	$options = get_theme_tpl_options ();
	$form->AddLabel ('module', _PLUGIN_PLUGIN);
	$form->AddSelect ('module', $options, $module);
	$form->AddText ('&nbsp;&nbsp;');

	$options = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('viewthemegroup', _MID_CATEGORY);
	$form->AddSelect ('viewthemegroup', $options, $viewthemegroup);

	$text_pos[-1] = _OPN_ALL;
	$text_pos[0] = _MID_LEFT;
	$text_pos[1] = _MID_RIGHT;
	$text_pos[2] = _MID_CENTER;

	$form->AddLabel ('filterside', _MID_MIDE2);
	$form->AddSelect ('filterside', $text_pos, $filterside);

	$form->AddSubmit ('submity', _MID_ACTIVATE);
	$form->AddHidden ('fct', 'middlebox');
	$form->AddHidden ('boxviewmodule', $boxviewmodule);
	$form->AddFormEnd ();
	$help = '';
	$form->GetFormular ($help);

	$help .= '<br />';
	$boxtxt = $help . '<br />' . _OPN_HTML_NL;
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol (_MID_TYPE, '', '2');
	$table->AddHeaderCol (_MID_TITLE);
	$table->AddHeaderCol (_MID_SECLEVEL);
	$table->AddHeaderCol (_MID_MIDE, '', '2');
	$table->AddHeaderCol (_MID_POSITION);
	$table->AddHeaderCol (_MID_REMOVE);
	$table->AddHeaderCol (_MID_ANKER);
	$table->AddHeaderCol (_MID_THEMEID);
	$table->AddHeaderCol (_MID_USELANG);
	$table->AddHeaderCol (_PLUGIN_PLUGIN);
	$table->AddCloseRow ();
	// middlebox position images
	$side[0] = '<img src="' . $opnConfig['opn_url'] . '/admin/middlebox/images/box_small_left.gif" class="imgtag" title="' . _MID_LEFTBLOCK . '" alt="' . _MID_LEFTBLOCK . '" />';
	$side[1] = '<img src="' . $opnConfig['opn_url'] . '/admin/middlebox/images/box_small_right.gif" class="imgtag" title="' . _MID_RIGHTBLOCK . '" alt="' . _MID_RIGHTBLOCK . '" />';
	$side[2] = '<img src="' . $opnConfig['opn_url'] . '/admin/middlebox/images/box_small_center.gif" class="imgtag" title="' . _MID_FULLBLOCK . '" alt="' . _MID_FULLBLOCK . '" />';
	$switchside[0] = '<img src="' . $opnConfig['opn_default_images'] . 'box_small_to_right.gif" class="imgtag" title="' . _MID_SWITCHTORIGHTBLOCK . '" alt="' . _MID_SWITCHTORIGHTBLOCK . '" />';
	$switchside[1] = '<img src="' . $opnConfig['opn_default_images'] . 'box_small_to_center.gif" class="imgtag" title="' . _MID_SWITCHTOFULLBLOCK . '" alt="' . _MID_SWITCHTOFULLBLOCK . '" />';
	$switchside[2] = '<img src="' . $opnConfig['opn_default_images'] . 'box_small_to_left.gif" class="imgtag" title="' . _MID_SWITCHTOLEFTBLOCK . '" alt="' . _MID_SWITCHTOLEFTBLOCK . '" />';
	// highest weight for each position (better to do it here then to keep doing it in the loop)
	$filter_weight = '';
	$result = &$opnConfig['database']->Execute ('SELECT position1 FROM ' . $opnTables['opn_middlebox'] . " WHERE side=0 $filter_weight ORDER BY position1 DESC");
	$high[0] = $result->GetRowAssoc ('0');
	$result = &$opnConfig['database']->Execute ('SELECT position1 FROM ' . $opnTables['opn_middlebox'] . " WHERE side=1 $filter_weight ORDER BY position1 DESC");
	$high[1] = $result->GetRowAssoc ('0');
	$result = &$opnConfig['database']->Execute ('SELECT position1 FROM ' . $opnTables['opn_middlebox'] . " WHERE side=2 $filter_weight ORDER BY position1 DESC");
	$high[2] = $result->GetRowAssoc ('0');
	$result = &$opnConfig['database']->Execute ('SELECT position1 FROM ' . $opnTables['opn_middlebox'] . " ORDER BY position1 DESC");
	$high[3] = $result->GetRowAssoc ('0');
	if ($module != '') {
		$_module = $opnConfig['opnSQL']->qstr ($module);
		$filter = " WHERE  (module=$_module)";
	} else {
		$filter = "WHERE ((module<>'') OR (module=''))";
	}
	if ( ($filterside == 0) or ($filterside == 1) ) {
		$filter .= ' AND side=' . $filterside;
	}
	$like_search = $opnConfig['opnSQL']->AddLike ('-'.$viewthemegroup.'-');
	if ($viewthemegroup>=1) {
		$filter .= " AND ((themegroup='".$viewthemegroup."') OR (themegroup='0') OR (themegroup='-0-') OR (themegroup LIKE $like_search) ) ";
	}
	$query = 'SELECT sbid, sbtype, sbpath, visible, seclevel, category, side, position1, options, anker, themegroup, width, module, info_text FROM ' . $opnTables['opn_middlebox'] . " " . $filter;
	$result = &$opnConfig['database']->Execute ($query);
	if (is_object ($result) ) {
		$maxrows = $result->RecordCount ();
		$result->Close ();
	} else {
		$maxrows = 0;
	}
	$result = &$opnConfig['database']->SelectLimit ($query . ' ORDER BY position1', $max, $min);
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		// side
		$move_up = '';
		$move_down = '';
		$move_space = '';
		if ( ( ($prev_pos != '') ) && ($row['position1'] != $prev_pos) ) {
			$move_up = $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'middlebox',
											'op' => 'middleboxOrder',
											'sbid' => $row['sbid'],
											'side' => $row['side'],
											'new_position' => ($row['position1']-1.5) ) );
		}
		if ($row['position1'] != $high[3]['position1']) {
			$move_down = $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'middlebox',
											'op' => 'middleboxOrder',
											'sbid' => $row['sbid'],
											'side' => $row['side'],
											'new_position' => ($row['position1']+1.5) ) );
		}
		if ($row['position1'] == $prev_pos && $row['position1'] != $high[3]['position1']) {
			$move_space = '&nbsp;';
		}
		// start table row
		$myrow = stripslashesinarray (unserialize ($row['options']) );
		if (!isset ($myrow['themeid']) ) {
			$myrow['themeid'] = '&nbsp;';
		}
		if ( (!isset ($myrow['box_use_lang']) ) OR ($myrow['box_use_lang'] == '0') ) {
			$myrow['box_use_lang'] = _MID_ALL;
		}
		if ( (!isset ($myrow['box_use_login']) ) OR ($myrow['box_use_login'] == '0') ) {
			$secplus = '';
		} elseif ($myrow['box_use_login'] == 1) {
			$secplus = ' / A';
		} else {
			$secplus = ' / U';
		}

		$templink = array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'middlebox',
											'op' => 'ChangeStatus',
											'mode' => 'visible',
											'filterside' => $filterside,
											'viewthemegroup' => $viewthemegroup,
											'module' => $module,
											'boxviewmodule' => $boxviewmodule,
											'sbid' => $row['sbid']);

		$table->AddOpenRow ();
		$table->AddDataCol ($opnConfig['defimages']->get_activate_deactivate_link ($templink, $row['visible']),'center');
		$table->AddDataCol ($row['sbtype'].'&nbsp;'.$row['width'].'%', 'left', '', '', '', '', $row['info_text']);
		$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'middlebox',
											'op' => 'middleboxEdit',
											'filterside' => $filterside,
											'viewthemegroup' => $viewthemegroup,
											'module' => $module,
											'boxviewmodule' => $boxviewmodule,
											'sbid' => $row['sbid']), '', '', $myrow['title']));
		$templink['mode'] = 'seclevel';
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($templink) . '">' . $row['seclevel'] . $secplus . '</a>','center');
		$table->AddDataCol ($side[$row['side']], 'center');

		$templink['mode'] = 'side';
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($templink) . '">' . $switchside[$row['side']] . '</a>',
											'center');
		$table->AddDataCol ($move_up . $move_space . $move_down, 'center');
		$table->AddDataCol ($opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'middlebox',
											'op' => 'middleboxDelete',
											'sbid' => $row['sbid']) ),
											'center');
		if ($row['anker'] == 0) {
			$change = _MID_ACTIVATE;
			$change_img = $opnConfig['opn_default_images'] . 'anker_off.gif';
		} else {
			$change = _MID_DEACTIVATE;
			$change_img = $opnConfig['opn_default_images'] . 'anker_on.gif';
		}
		$templink['mode'] = 'anker';
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($templink) . '">' . '<img src="' . $change_img . '" class="imgtag" title="' . $change . '" alt="' . $change . '" /></a>',
											'center');
		$table->AddDataCol ($myrow['themeid'], 'center');
		$table->AddDataCol ($myrow['box_use_lang'], 'center');
		if ( (!isset ($row['module']) ) OR ($row['module'] == '') ) {
			$row['module'] = _MID_ALL;
		}
		$table->AddDataCol ($row['module'], 'center');
		$table->AddCloseRow ();
		$prev_pos = $row['position1'];
		unset ($myrow);
		$result->MoveNext ();
	}
	$help = '';
	$table->GetTable ($help);
	$boxtxt .= $help . '<br />';
	include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
	$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/admin.php',
					'fct' => 'middlebox',
					'filterside' => $filterside,
					'viewthemegroup' => $viewthemegroup,
					'module' => $module,
					'boxviewmodule' => $boxviewmodule),
					$maxrows,
					$pagesize,
					$offset);
	$boxtxt .= '<br />';

	/* Add New block */

	$options = array ();
	$help = '<script type="text/javascript">' . _OPN_HTML_NL;
	$help .= '<!--' . _OPN_HTML_NL;
	$help .= 'function showpreviewimage() {' . _OPN_HTML_NL;
	$help .= '   mypath = new Array();' . _OPN_HTML_NL;
	foreach ($mymiddleboxtypes as $mytypeinfo) {
		$options[$mytypeinfo['path']] = $mytypeinfo['name'];
		if (substr_count ($mytypeinfo['preview'], $opnConfig['opn_url'])>0) {
			$preview = $mytypeinfo['preview'];
		} else {
			$preview = $opnConfig['opn_url'] . '/' . $mytypeinfo['preview'];
		}
		$help .= '  mypath["' . $mytypeinfo['path'] . '"] = "' . $preview . '";' . _OPN_HTML_NL;
	}
	$help .= '  if (!document.images)' . _OPN_HTML_NL;
	$help .= '    return;' . _OPN_HTML_NL;
	$help .= '  document.images.previewimage.src=';
	$help .= 'mypath[document.sideboxadmin.sbpath.options[document.sideboxadmin.sbpath.selectedIndex].value]' . _OPN_HTML_NL;
	$help .= '}' . _OPN_HTML_NL;
	$help .= '//-->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
	$help .= '<span class="normaltextbold">';
	$help .= _MID_ADDNEWBOX . '&nbsp;&nbsp;' . '(' . count ($options) . ')';
	$help .= '</span><br />' . _OPN_HTML_NL;
	$table = & new opn_TableClass ('default');
	$table->AddOpenRow ();
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MIDDLEBOX_80_', 'middlebox');
	$form->Init ($opnConfig['opn_url'] . '/admin.php', 'post', 'sideboxadmin');
	$form->AddSelect ('sbpath', $options, '', 'showpreviewimage()', count ($options) );
	$form->AddText ('&nbsp;&nbsp;');
	$form->AddSubmit ('submity', _MID_CREATEBOX);
	$form->AddHidden ('fct', 'middlebox');
	$form->AddHidden ('module', $module);
	$form->AddHidden ('op', 'middleboxEdit');
	$form->AddFormEnd ();
	$help1 = '';
	$form->GetFormular ($help1);
	$table->AddDataCol ($help1);
	$help1 = '<span class="normaltextbold">';
	$help1 .= _MID_PRESELECT;
	$help1 .= '</span><br />' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MIDDLEBOX_90_', 'middlebox_modul');
	$form->Init ($opnConfig['opn_url'] . '/admin.php');
	$options = array ();
	$options['opnindex'] = _MID_STARTPAGE;
	$options[''] = _MID_ALL;
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'middlebox');
	foreach ($plug as $var1) {
		$options[$var1['plugin']] = $var1['module'];
	}
	$form->AddSelect ('boxviewmodule', $options, $boxviewmodule, '', count ($options) );
	$form->AddText ('&nbsp;&nbsp;');
	$form->AddSubmit ('submity', _MID_ACTIVATE);
	$form->AddHidden ('fct', 'middlebox');
	$form->AddHidden ('filterside', $filterside);
	$form->AddHidden ('viewthemegroup', $viewthemegroup);
	$form->AddHidden ('module', $module);
	$form->AddFormEnd ();
	$form->GetFormular ($help1);
	$table->AddDataCol ($help1, '', '', 'top');
	$table->AddCloseRow ();
	$table->GetTable ($help);
	$boxtxt .= $help;
	$boxtxt .= '<br /><br /><img src="' . $opnConfig['opn_url'] . '/admin/sidebox/images/no_preview.jpg" class="imgtag" name="previewimage" alt="" />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MIDDLEBOX_100_';
	$_display_dat['module'] = 'admin/middlebox';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MID_ADMIN, $boxtxt);

}

function ChangeStatus () {

	global $opnTables, $opnConfig;

	$sbid = 0;
	$mode = 'visible';
	$makecenter = 0;
	get_var ('sbid', $sbid, 'url', _OOBJ_DTYPE_INT);
	get_var ('mode', $mode, 'url', _OOBJ_DTYPE_CLEAN);
	get_var ('makecenter', $makecenter, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT ' . $mode . ' from ' . $opnTables['opn_middlebox'] . ' WHERE sbid=' . $sbid);
	$row = $result->GetRowAssoc ('0');
	switch ($mode) {
		case 'visible':
		case 'anker':
			if ($row[$mode] == 0) {
				$var = 1;
			} else {
				$var = 0;
			}
			break;
		case 'side':
			if ($makecenter == 2) {
				$var = 2;
			} else {
				if ($row[$mode] == 0) {
					$var = 1;
				} elseif ($row[$mode] == 1) {
					$var = 2;
				} else {
					$var = 0;
				}
			}
			break;
		case 'seclevel':
			if ($row[$mode]<10) {
				$var = $row[$mode]+1;
			} else {
				$var = 0;
			}
			break;
		default:
			$var = 0;
			break;
	}
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_middlebox'] . ' SET ' . $mode . "=$var WHERE sbid=" . $sbid);

}

function middleboxEdit () {

	global $opnConfig, ${$opnConfig['opn_post_vars']}, $opnTables;

	$boxtxt = '';
	$sbid = 0;
	get_var ('sbid', $sbid, 'url', _OOBJ_DTYPE_INT);
	$text_pos[0] = _MID_LEFT;
	$text_pos[1] = _MID_RIGHT;
	$text_pos[2] = _MID_CENTER;
	$side[0] = '';
	$side[1] = '';
	$side[2] = '';
	$anker[0] = '';
	$anker[1] = '';
	$visible[0] = '';
	$visible[1] = '';
	$row = ${$opnConfig['opn_post_vars']};
	$error = 0;
	if ( (isset ($row['sbpath']) ) && ($row['sbpath'] != '') ) {
		$boxtitle = '<span class="normaltextbold">' . _MID_INSERTBOX . '</span>';
		$retval = include_once (_OPN_ROOT_PATH . $row['sbpath'] . '/typedata.php');
		if (isset ($retval['name']) ) {
			$title = $retval['name'];
		} else {
			$title = '***';
		}
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _MID_BOX . ': ' . $title . '</span></div><br /><br />';
		$row['sbtype'] = $title;
		$row['visible'] = 1;
		$row['anker'] = 1;
		$row['seclevel'] = 0;
		$row['themegroup'] = array('0');
		$row['side'] = 1;
		$row['position1'] = 0.5;
		$row['width'] = '50';
		if (!isset ($row['module']) ) {
			$row['module'] = '';
		}
		$myoptions['themeid'] = 0;
		$row['sbid'] = 0;
		$row['info_text'] = '';
		$op = 'middleboxAdd';
	} elseif ($sbid != '') {
		$boxtitle = '<span class="normaltextbold">' . _MID_EDITBOX . '</span>';
		$result = &$opnConfig['database']->Execute ('SELECT sbid, sbtype, sbpath, visible, seclevel, category, side, position1, options, anker, themegroup, width, module, info_text FROM ' . $opnTables['opn_middlebox'] . " WHERE sbid=$sbid");
		$row = $result->GetRowAssoc ('0');
		$myoptions = stripslashesinarray (unserialize ($row['options']) );
		$side[$row['side']] = ' selected';
		$visible[$row['visible']] = ' checked';
		$anker[$row['anker']] = ' checked';
		$op = 'middleboxEditSave';
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _MID_BOX . ': ' . $myoptions['title'] . ' (' . $row['sbtype'] . ')</span></div><br />';
		$row['themegroup'] = str_replace ('-', '', $row['themegroup']);
		$row['themegroup'] = explode (',',$row['themegroup']);
	} else {
		$boxtitle = '';
		$boxtxt .= _MID_NOBOXSELECT . '<br /><br />';
		$boxtxt .= '<a href="javascript:history.go(-1)">' . _MID_GOBACK . '</a><br />';
		$error = 1;
	}
	if ($error != 1) {
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MIDDLEBOX_110_', 'middlebox');
		$form->Init ($opnConfig['opn_url'] . '/admin.php');
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenHeadRow ();
		$form->AddHeaderCol (_MID_GENERAL, '', '2');
		$form->AddCloseRow ();
		$form->AddOpenRow ();
		$form->AddLabel ('visible', _MID_VISIBLE);
		$form->AddCheckbox ('visible', 1, ($row['visible'] == 1?1 : 0) );
		$form->AddChangeRow ();
		$form->AddLabel ('anker', _MID_ANKER);
		$form->AddCheckbox ('anker', 1, ($row['anker'] == 1?1 : 0) );
		$groups = $opnConfig['permission']->UserGroups;
		$options = array ();
		foreach ($groups as $group) {
			$options[$group['id']] = $group['name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('seclevel', _MID_SECLEVEL2);
		$form->AddSelect ('seclevel', $options, intval ($row['seclevel']) );
		$options = array ();
		$groups = $opnConfig['theme_groups'];
		foreach ($groups as $group) {
			$options[$group['theme_group_id']] = $group['theme_group_text'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('themegroup[]', _MID_CATEGORY);
		$form->AddSelect ('themegroup[]', $options, $row['themegroup'],'',5,1);

		$form->AddChangeRow ();
		$form->AddLabel ('side', _MID_MIDE2);
		$form->AddSelect ('side', $text_pos, intval ($row['side']) );
		$options = array ();
		$options[0]['key'] = $row['position1'];
		$options[0]['text'] = _MID_CURRENT;
		$options[1]['key'] = -0.5;
		$options[1]['text'] = _MID_BOTTOM;
		$options[2]['key'] = 0.5;
		$options[2]['text'] = _MID_TOP;
		$i = 3;
		$result = &$opnConfig['database']->Execute ('SELECT position1, side, options FROM ' . $opnTables['opn_middlebox'] . " ORDER BY side,position1");
		while (! $result->EOF) {
			$position_row = $result->GetRowAssoc ('0');
			$myrowoptions = stripslashesinarray (unserialize ($position_row['options']) );
			$options[$i]['key'] = ($position_row['position1']+0.5);
			$options[$i]['text'] = _MID_AFTER . " " . $myrowoptions['title'] . " (" . $text_pos[$position_row['side']] . ")";
			$i++;
			$result->MoveNext ();
		}
		$form->AddChangeRow ();
		$form->AddLabel ('position', _MID_POSITION2);
		$form->AddSelectspecial ('position', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('width', _MID_WIDTH);
		$form->AddTextfield ('width', 10, 10, $row['width']);
		if (!isset ($myoptions['themeid']) ) {
			$myoptions['themeid'] = '';
		}
		$form->AddChangeRow ();
		$form->AddLabel ('themeid', _MID_THEMEID);
		$form->AddTextfield ('themeid', 30, 30, $myoptions['themeid']);
		$options = get_theme_tpl_options ();
		if (!isset ($row['module']) ) {
			$row['module'] = '';
		}
		$form->AddChangeRow ();
		$form->AddLabel ('module', _PLUGIN_PLUGIN);
		$form->AddSelect ('module', $options, $row['module']);
		$form->AddChangeRow ();
		$form->AddLabel ('info_text', _MID_INFO_TEXT);
		$form->AddTextfield ('info_text', 30, 30, $row['info_text']);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddText ('<br /><br />');
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->ResetAlternate ();
		$form->AddOpenHeadRow ();
		$form->AddHeaderCol (_MID_MIDDLEBOXDETAIL, '', '2');
		$form->AddCloseRow ();
		include_once (_OPN_ROOT_PATH . $row['sbpath'] . '/editbox.php');
		if (!isset ($myoptions) ) {
			$myoptions = array ();
		}
		$_box_array_dat = array ();
		$_box_array_dat['box_options'] = $myoptions;
		$_box_array_dat['box_form'] = $form;
		$_box_array_dat['box_type'] = 'center';
		if (function_exists ('send_middlebox_edit') ) {
			send_middlebox_edit ($_box_array_dat);
		} else {
			send_sidebox_edit ($_box_array_dat);
		}
		$myoptions = $_box_array_dat['box_options'];
		$form = $_box_array_dat['box_form'];
		$form->AddTableClose ();
		send_box_edit_defaults ($myoptions, $form, 'middlebox');
		$form->AddHidden ('sbid', $row['sbid']);
		$form->AddHidden ('sbtype', $row['sbtype']);
		$form->AddHidden ('sbpath', $row['sbpath']);
		$form->AddHidden ('fct', 'middlebox');
		$form->AddHidden ('op', $op);
		$form->AddSubmit ('submity', _MID_SAVEBOX);
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	if (!isset ($boxtitle) ) {
		$boxtitle = '';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MIDDLEBOX_120_';
	$_display_dat['module'] = 'admin/middlebox';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);

}

function middleboxOrder ($vars = '') {

	global $opnTables, $opnConfig;

	$new_position = 0;
	$sbid = 0;
	$side = 0;
	get_var ('new_position', $new_position, 'url', _OOBJ_DTYPE_CLEAN);
	get_var ('sbid', $sbid, 'url', _OOBJ_DTYPE_INT);
	get_var ('side', $side, 'url', _OOBJ_DTYPE_INT);
	if ($vars == '') {
		$vars['side'] = $side;
	};
	if ($new_position) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_middlebox'] . " SET position1=$new_position WHERE sbid=$sbid");
		$vars['side'] = $side;
	}
	$result = &$opnConfig['database']->Execute ('SELECT sbid FROM ' . $opnTables['opn_middlebox'] . " ORDER BY position1");
	$c = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$c++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_middlebox'] . " SET position1=$c WHERE sbid=" . $row['sbid'] . "");
		$result->MoveNext ();
	}

}

function middleboxDelete () {

	global $opnTables, $opnConfig;

	$sbid = 0;
	$ok = 0;
	get_var ('sbid', $sbid, 'url', _OOBJ_DTYPE_INT);
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_middlebox'] . ' WHERE sbid=' . $sbid);
		return '';
	}
	$result = &$opnConfig['database']->Execute ('SELECT sbid, sbtype, sbpath, visible, seclevel, category, side, position1, options, anker, themegroup, width, module FROM ' . $opnTables['opn_middlebox'] . " WHERE sbid=$sbid");
	$row = $result->GetRowAssoc ('0');
	$myoptions = stripslashesinarray (unserialize ($row['options']) );
	$boxtxt = sprintf (_MID_SUREDELBLOCK, $myoptions['title']) . '<br /><br /><br />';
	$boxtxt .= '<div class="centertag">';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'middlebox',
									'op' => 'middleboxDelete',
									'sbid' => $sbid,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/admin.php?fct=middlebox') . '">' . _NO . '</a>';
	$boxtxt .= '</div>';
	$boxtxt .= '<br />' . _OPN_HTML_NL;
	return $boxtxt;

}

?>