<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/openphpnuke', true);
include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');

$opnConfig['module']->InitModule ('admin/openphpnuke', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();

getLanguageDef (_OPN_ROOT_PATH . 'admin/openphpnuke/language/');
$opnConfig['opnOutput']->SetDisplayToAdminDisplay ();

function get_logo_options () {

	global $opnConfig;

	$options = array ();
	$options['&nbsp;'] = '';
	$filelist = get_file_list ($opnConfig['root_path_datasave'] . 'logo/');
	if (count ($filelist) ) {
		natcasesort ($filelist);
		reset ($filelist);
		foreach ($filelist as $file) {
			$options[$file] = $file;
		}
	}
	return $options;

}

function get_encodings (&$l) {

	$l['&nbsp;'] = '';
	$l[_OPN_ISO_8859_1] = 'iso-8859-1';
	$l[_OPN_ISO_8859_2] = 'iso-8859-2';
	$l[_OPN_ISO_8859_3] = 'iso-8859-3';
	$l[_OPN_ISO_8859_4] = 'iso-8859-4';
	$l[_OPN_ISO_8859_5] = 'iso-8859-5';
	$l[_OPN_ISO_8859_6] = 'iso-8859-6';
	$l[_OPN_ISO_8859_7] = 'iso-8859-7';
	$l[_OPN_ISO_8859_8] = 'iso-8859-8';
	$l[_OPN_ISO_8859_9] = 'iso-8859-9';
	$l[_OPN_ISO_8859_10] = 'iso-8859-10';
	$l[_OPN_ISO_8859_11] = 'iso-8859-11';
	$l[_OPN_ISO_8859_13] = 'iso-8859-13';
	$l[_OPN_ISO_8859_14] = 'iso-8859-14';
	$l[_OPN_ISO_8859_15] = 'iso-8859-15';
	$l[_OPN_ISO_8859_16] = 'iso-8859-16';
	$l['UTF-8'] = 'utf-8';
	$l['KOI8-R'] = 'koi8-r';
	$l['KOI8-U'] = 'koi8-u';

}

function openphpnuke_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => $wichSave);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _OPN_SAVE);
	return $values;

}

function openphpnuke_makenavbar ($nonav) {

	global $opnConfig;

	$nav[_OPN_NAVGENERAL] = _OPN_NAVGENERAL;
	$nav[_OPN_NAVLOCALE] = _OPN_NAVLOCALE;
	$nav[_OPN_NAVUSER] = _OPN_NAVUSER;
	$nav[_OPN_NAVCONTACT] = _OPN_NAVCONTACT;
	$nav[_OPN_NAVFOOTER] = _OPN_NAVFOOTER;
	$nav[_OPN_NAVGRAPHIC] = _OPN_NAVGRAPHIC;
	$nav[_OPN_NAVFILTER] = _OPN_NAVFILTER;
	if ($opnConfig['opn_expert_mode'] == 1) {
		$nav[_OPN_NAVSAFETYFILTER] = _OPN_NAVSAFETYFILTER;
		$nav[_OPN_NAVMACROFILTER] = _OPN_NAVMACROFILTER;
		$nav[_OPN_NAVHTMLFILTER] = _OPN_NAVHTMLFILTER;
		$nav[_OPN_NAVMACROS] = _OPN_NAVMACROS;
		$nav[_OPN_NAVSYSTEM] = _OPN_NAVSYSTEM;
	}
	$nav[_OPN_NAVAUTOSTART] = _OPN_NAVAUTOSTART;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/sitemap') ) {
		$nav[_OPN_NAVSITEMAP] = _OPN_NAVSITEMAP;
	}
	$nav[_OPN_NAVHTML] = _OPN_NAVHTML;
	$nav[_OPN_NAVMISC] = _OPN_NAVMISC;
	$nav[_OPN_NAVMASTERINTERFACE] = _OPN_NAVMASTERINTERFACE;
	$nav[_OPN_NAVUPLOAD] = _OPN_NAVUPLOAD;
	$nav[_OPN_NAVEMAIL] = _OPN_NAVEMAIL;
	$nav[_OPN_NAVSECURITY] = _OPN_NAVSECURITY;
	$nav[$nonav] = '';
	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function generalsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_GENERALSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SITENAME,
			'name' => 'sitename',
			'value' => $opnConfig['sitename'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SITEURL,
			'name' => 'opn_url',
			'value' => $opnConfig['opn_url'],
			'size' => 50,
			'maxlength' => 200);
	$options = get_logo_options ();
	if ( ($opnConfig['site_logo'] == '&nbsp;') || $opnConfig['site_logo'] == chr (160) ) {
		$opnConfig['site_logo'] = '';
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_SITELOGO . '<br />(' . wordwrap ($opnConfig['root_path_datasave'] . 'logo/',
			30,
			'<br />',
			1) . ')',
			'name' => 'site_logo',
			'options' => $options,
			'selected' => trim ($opnConfig['site_logo']) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SITESLOGAN,
			'name' => 'slogan',
			'value' => $opnConfig['slogan'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_STARTDATE,
			'name' => 'startdate',
			'value' => $opnConfig['startdate'],
			'size' => 20,
			'maxlength' => 30);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_ADMINMAIL,
			'name' => 'adminmail',
			'value' => $opnConfig['adminmail'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_TOPPAGE,
			'name' => 'top',
			'value' => $opnConfig['top'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_FETCHINGREQUEST,
			'name' => 'opn_display_fetching_request',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_display_fetching_request'] == 1?true : false),
			 ($opnConfig['opn_display_fetching_request'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_COMPLETEADMIN,
			'name' => 'display_complete_adminmenu',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['display_complete_adminmenu'] == 1?true : false),
			 ($opnConfig['display_complete_adminmenu'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_AUTOMATICTITLE,
			'name' => 'opn_generateautomatictitle',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_generateautomatictitle'] == 1?true : false),
			 ($opnConfig['opn_generateautomatictitle'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'opn_time_prefix',
			'value' => $opnConfig['opn_time_prefix']);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVGENERAL) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVGENERAL) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function emailsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_EMASILSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_EMAILSETTINGS);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_ACTIVATEMAIL,
			'name' => 'opn_activate_email',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_activate_email'] == 1?true : false),
			 ($opnConfig['opn_activate_email'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_MAILCHECK,
			'name' => 'opn_use_checkemail',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_use_checkemail'] == 1?true : false),
			 ($opnConfig['opn_use_checkemail'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_ACTIVATEMAILDEBUG,
			'name' => 'opn_activate_email_debug',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_activate_email_debug'] == 1?true : false),
			 ($opnConfig['opn_activate_email_debug'] == 0?true : false) ) );
	$l = array ();
	$l[_OPN_EMAIL_VIA_MAIL] = 'mail';
	$l[_OPN_EMAIL_VIA_SENDMAIL] = 'sendmail';
	$l[_OPN_EMAIL_VIA_SMTP] = 'smtp';
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_EMAIL_SEND_VIA,
			'name' => 'send_email_via',
			'options' => $l,
			'selected' => $opnConfig['send_email_via']);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SENDMAIL,
			'name' => 'opn_use_sendmail',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_use_sendmail'] == 1?true : false),
			 ($opnConfig['opn_use_sendmail'] == 0?true : false) ) );
	$l = array ();
	get_encodings ($l);
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_EMAIL_CHARSET_ENCODING,
			'name' => 'opn_email_charset_encoding',
			'options' => $l,
			'selected' => $opnConfig['opn_email_charset_encoding']);
	$l = array ();
	$l[''] = '';
	$l['base64'] = 'base64';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_EMAIL_SUBJECT_ENCODING,
			'name' => 'opn_email_subject_encoding',
			'options' => $l,
			'selected' => strval ($opnConfig['opn_email_subject_encoding']) );
	$l = array ();
	$l['7bit'] = '7bit';
	$l['8bit'] = '8bit';
	$l['quoted-printable'] = 'quoted-printable';
	$l['base64'] = 'base64';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_EMAIL_BODY_ENCODING,
			'name' => 'opn_email_body_encoding',
			'options' => $l,
			'selected' => $opnConfig['opn_email_body_encoding']);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_GENERATEMESSAGEID,
			'name' => 'opn_emailgeneratemessageid',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_emailgeneratemessageid'] == 1?true : false),
			 ($opnConfig['opn_emailgeneratemessageid'] == 0?true : false) ) );
	$l = array ();
	$l[_OPN_EMAIL_HIGH] = 1;
	$l[_OPN_EMAIL_NORMAL] = 3;
	$l[_OPN_EMAIL_LOW] = 4;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_EMAIL_PRIORITY,
			'name' => 'opn_emailpriority',
			'options' => $l,
			'selected' => $opnConfig['opn_emailpriority']);
	$values[] = array ('type' => _INPUT_HEADERLINE,
			'value' => _OPN_SENDMAIL_SETTINGS);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SENDMAIL_PATH,
			'name' => 'sendmail_path',
			'value' => $opnConfig['sendmail_path'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SENDMAIL_ARGS,
			'name' => 'sendmail_args',
			'value' => $opnConfig['sendmail_args'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_HEADERLINE,
			'value' => _OPN_SMTP_SETTINGS);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SMTP_SERVER,
			'name' => 'smtp_host',
			'value' => $opnConfig['smtp_host'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SMTP_PORT,
			'name' => 'smtp_port',
			'value' => $opnConfig['smtp_port'],
			'size' => 5,
			'maxlength' => 5);
	$l = array ();
	$l['none'] = false;
	$l[_OPN_SMTP_AUTH_BEST] = true;
	$l[_OPN_SMTP_AUTH_PLAIN] = 'plain';
	$l[_OPN_SMTP_AUTH_LOGIN] = 'login';
	$l[_OPN_SMTP_AUTH_CRAMMD5] = 'crammd5';
	$l[_OPN_SMTP_AUTH_DIGESTMD5] = 'digestmd5';
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_SMTP_AUTH,
			'name' => 'smtp_auth',
			'options' => $l,
			'selected' => $opnConfig['smtp_auth']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SMTP_USER,
			'name' => 'smtp_username',
			'value' => $opnConfig['smtp_username'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_PASSWORD,
			'display' => _OPN_SMTP_PASS,
			'name' => 'smtp_password',
			'value' => $opnConfig['smtp_password'],
			'size' => 50,
			'maxlength' => 150);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	if ( (!isset ($opnConfig['opn_all_email_to_admin']) ) ) {
		$opnConfig['opn_all_email_to_admin'] = 0;
	}
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_EMAIL_ALL_EMAIL_TO_ADMIN,
			'name' => 'opn_all_email_to_admin',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_all_email_to_admin'] == 1?true : false),
			 ($opnConfig['opn_all_email_to_admin'] == 0?true : false) ) );
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVEMAIL) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVEMAIL) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function serversettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_SERVERSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_LOCALE);
	$languageslist = get_dir_list (_OPN_ROOT_PATH . 'language', '', '/^lang\-(.+)\.php/');
	usort ($languageslist, 'strcollcase');
	$dirmanagementtype = array (_OPN_DIRMANAGE_PHP => 0,
				_OPN_DIRMANAGE_PEARL => 1,
				_OPN_DIRMANAGE_PHPFTP => 2,
				_OPN_DIRMANAGE_SIMFTP => 3);
	if (!isset ($opnConfig['opn_dirmanage']) ) {
		$opnConfig['opn_dirmanage'] = $opnConfig['opn_use_perl_mkdir'];
	}
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_LANGUAGE,
			'name' => 'language',
			'options' => $languageslist,
			'selected' => $pubsettings['language']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_TIMEFORMAT,
			'name' => 'locale',
			'value' => $opnConfig['locale'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SETTIMEZONE,
			'name' => 'opn_set_timezone',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_set_timezone'] == 1?true : false),
			 ($opnConfig['opn_set_timezone'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_WHICHTIMEZONE,
			'name' => 'opn_timezone',
			'rowspan' => 2,
			'value' => $opnConfig['opn_timezone'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_TIMEZONELIST);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_PCONNECT,
			'name' => 'opn_mysql_pconnect',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_mysql_pconnect'] == 1?true : false),
			 ($opnConfig['opn_mysql_pconnect'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_INDEXRIGHT,
			'name' => 'opn_db_index_right',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_db_index_right'] == 1?true : false),
			 ($opnConfig['opn_db_index_right'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_USESAFEDB,
			'name' => 'opn_db_safe_use',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_db_safe_use'] == 1?true : false),
			 ($opnConfig['opn_db_safe_use'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_USELOCKDB,
			'name' => 'opn_db_lock_use',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_db_lock_use'] == 1?true : false),
			 ($opnConfig['opn_db_lock_use'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SAFEMODE,
			'name' => 'opn_host_use_safemode',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_host_use_safemode'] == 1?true : false),
			 ($opnConfig['opn_host_use_safemode'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_DIRMANAGE,
			'name' => 'opn_dirmanage',
			'options' => $dirmanagementtype,
			'selected' => intval ($opnConfig['opn_dirmanage']) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_FTPUSERNAME,
			'name' => 'opn_ftpusername',
			'value' => $opnConfig['opn_ftpusername'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_PASSWORD,
			'display' => _OPN_FTPPASSWORD,
			'name' => 'opn_ftppassword',
			'value' => $opnConfig['opn_ftppassword'],
			'size' => 50,
			'maxlength' => 150);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_FTPHOST,
			'name' => 'opn_ftphost',
			'value' => $opnConfig['opn_ftphost'],
			'size' => 50,
			'maxlength' => 200);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_FTPPORT,
			'name' => 'opn_ftpport',
			'value' => $opnConfig['opn_ftpport'],
			'size' => 5,
			'maxlength' => 5);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_FTPHOMEDIR,
			'name' => 'opn_ftpdir',
			'value' => $opnConfig['opn_ftpdir'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_FTPCHMOD,
			'name' => 'opn_ftpchmod',
			'value' => $opnConfig['opn_ftpchmod'],
			'size' => 4,
			'maxlength' => 4);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_FTPPASV,
			'name' => 'opn_ftppasv',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_ftppasv'] == 1?true : false),
			 ($opnConfig['opn_ftppasv'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_FTPMODE,
			'name' => 'opn_ftpmode',
			'values' => array (1,
			0),
			'titles' => array (_OPN_FTPMODEBIN,
			_OPN_FTPMODEASCII),
			'checked' => array ( ($opnConfig['opn_ftpmode'] == 1?true : false),
			 ($opnConfig['opn_ftpmode'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_PHP5_MIGRATION,
			'name' => 'opn_php5_migration',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_php5_migration'] == 1?true : false),
			 ($opnConfig['opn_php5_migration'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SERVERIP,
			'name' => 'opn_ServerIP',
			'value' => $opnConfig['opn_ServerIP'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_USEPROXY,
			'name' => 'opn_useProxy',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['update_useProxy'] == 1?true : false),
			 ($opnConfig['update_useProxy'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_PROXYIP,
			'name' => 'ProxyIP',
			'value' => $opnConfig['update_ProxyIP'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_PROXYPORT,
			'name' => 'ProxyPort',
			'value' => $opnConfig['update_ProxyPort'],
			'size' => 20,
			'maxlength' => 40);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVLOCALE) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVLOCALE) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function usersettings () {

	global $opnConfig, ${$opnConfig['opn_server_vars']}, $opnTables;

	$server = ${$opnConfig['opn_server_vars']};
	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_USERSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_USER);
	$options[_OPN_STRICT] = 0;
	$options[_OPN_MEDIUM] = 1;
	$options[_OPN_LOOSE] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_STRICTNICKNAME,
			'rowspan' => 5,
			'name' => 'opn_uname_test_level',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_uname_test_level']) );
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_ALLOWCHAR);
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_STRICT . ': a-z, A-Z, 0-9, _');
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_MEDIUM . ': a-z, A-Z, 0-9, _, <, >, ,, ., $, %, #, @, !, \', "');
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_LOOSE . ' : a-z, A-Z, 0-9, _, <, >, ,, ., $, %, #, @, !, \', ", ?, {, }, [, ], (, ), ^, &amp;, *, `, ~, ;, :, \\, +, =');
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_ALLOW_SPACEC,
			'name' => 'opn_uname_allow_spaces',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_uname_allow_spaces'] == 1?true : false),
			 ($opnConfig['opn_uname_allow_spaces'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$options = array ();
	$options[_SEARCH_ALL] = 0;
	$result = &$opnConfig['database']->Execute ('SELECT theme_group_id, theme_group_text FROM ' . $opnTables['opn_theme_group'] . ' ORDER BY theme_group_pos');
	while (! $result->EOF) {
		$theme_group_id = $result->fields['theme_group_id'];
		$theme_group_text = $result->fields['theme_group_text'];
		$options[$theme_group_text] = $theme_group_id;
		$result->MoveNext ();
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_STARTTHEMEGROUP,
			'name' => 'opn_startthemegroup',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_startthemegroup']) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_MINPASS,
			'name' => 'minpass',
			'value' => $opnConfig['minpass'],
			'size' => 3,
			'maxlength' => 3);
	$options = array ();
	$options[_OPN_AUTOACTV] = 0;
	$options[_OPN_USERACTV] = 1;
	$options[_OPN_ADMINACTV] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_ACTVTYPE,
			'name' => 'opn_activatetype',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_activatetype']) );
	if ($opnConfig['opn_activate_email'] == 1) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _OPN_USERNOTIFY,
				'name' => 'opn_new_user_notify',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($opnConfig['opn_new_user_notify'] == 1?true : false),
				 ($opnConfig['opn_new_user_notify'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_new_user_notify',
				'value' => 0);
	}
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_ANONID,
			'name' => 'opn_anonymous_id',
			'value' => $opnConfig['opn_anonymous_id'],
			'size' => 5,
			'maxlength' => 5);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_ANONNAME,
			'name' => 'opn_anonymous_name',
			'value' => $opnConfig['opn_anonymous_name'],
			'size' => 15,
			'maxlength' => 25);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_DELID,
			'name' => 'opn_deleted_user',
			'value' => $opnConfig['opn_deleted_user'],
			'size' => 5,
			'maxlength' => 5);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_BOTID,
			'name' => 'opn_bot_user',
			'value' => $opnConfig['opn_bot_user'],
			'size' => 5,
			'maxlength' => 5);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SESSIONEXPIRE_TIME,
			'name' => 'sessionexpire',
			'value' => (int) $opnConfig['sessionexpire'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SESSIONEXPIRE_TIME_BONUS,
			'name' => 'sessionexpire_bonus',
			'value' => (int) $opnConfig['sessionexpire_bonus'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	if ( (strtolower ($server['HTTP_HOST']) != 'localhost') && (substr ($server['HTTP_HOST'], 0, 6) != '127.0.') ) {
		$temp = parse_url ($opnConfig['opn_url']);
		$dummy = explode ('.', $temp['host']);
		$dummymax = count ($dummy);
		$text0 = $dummy[$dummymax-2] . '.' . $dummy[$dummymax-1];
		$text1 = $temp['host'];

		/*		$text2 = $dummy[$dummymax-2]; */
	} else {
		$text0 = $server['HTTP_HOST'];
		$text1 = $server['HTTP_HOST'];

		/*		$text2 = $HTTP_HOST;*/
	}
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_COOKIEDOMAINNAME,
			'name' => 'opn_cookie_domainname',
			'values' => array (0,
			1),
			'titles' => array ($text0,
			$text1),
			'checked' => array ( ($opnConfig['opn_cookie_domainname'] == 0?true : false),
			 ($opnConfig['opn_cookie_domainname'] == 1?true : false) ) );

	/*	$values[]=array('type'=>_INPUT_RADIO,'display'=>_OPN_COOKIEDOMAINNAME,'name'=>'opn_cookie_domainname', 'values'=>array(0,1,2),'titles'=>array($text0,$text1,$text2),'checked'=>array(($opnConfig['opn_cookie_domainname'] == 0 ? true : false),($opnConfig['opn_cookie_domainname'] == 1 ? true : false),($opnConfig['opn_cookie_domainname'] == 2 ? true : false)));*/

	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_ACTASBLACKLIST,
			'rowspan' => 2,
			'name' => 'opn_new_user_actasblacklist',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_new_user_actasblacklist'] == 1?true : false),
			 ($opnConfig['opn_new_user_actasblacklist'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _OPN_ACTASBLACKLISTINFO);
	if ( (!isset ($opnConfig['opn_list_domainname']) ) || !is_array ($opnConfig['opn_list_domainname']) ) {
		$opnConfig['opn_list_domainname'] = array ();
	}
	foreach ($opnConfig['opn_list_domainname'] as $key => $value) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _OPN_DOMAINNAME,
				'name' => 'listdomainname_' . $key,
				'value' => $value,
				'size' => 40,
				'maxlength' => 60);
	}
	$mycount = count ($opnConfig['opn_list_domainname'])+1;
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_DOMAINNAME,
			'name' => 'listdomainname_' . $mycount,
			'value' => '',
			'size' => 40,
			'maxlength' => 60);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVUSER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVUSER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function contactsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_CONTACTSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_CONTACT);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_WEBMASTERNAME,
			'name' => 'opn_webmaster_name',
			'value' => $opnConfig['opn_webmaster_name'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_CONTACTEMAIL,
			'name' => 'opn_contact_email',
			'value' => $opnConfig['opn_contact_email'],
			'size' => 50,
			'maxlength' => 100);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVCONTACT) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVCONTACT) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function footersettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_FOOTERSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_FOOTER);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _OPN_FOOTER1,
			'name' => 'foot1',
			'value' => $opnConfig['foot1'],
			'wrap' => '',
			'cols' => 60,
			'rows' => 5);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _OPN_FOOTER2,
			'name' => 'foot2',
			'value' => $opnConfig['foot2'],
			'wrap' => '',
			'cols' => 60,
			'rows' => 5);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _OPN_FOOTER3,
			'name' => 'foot3',
			'value' => $opnConfig['foot3'],
			'wrap' => '',
			'cols' => 60,
			'rows' => 5);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _OPN_FOOTER4,
			'name' => 'foot4',
			'value' => $opnConfig['foot4'],
			'wrap' => '',
			'cols' => 60,
			'rows' => 5);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVFOOTER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVFOOTER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function graphicsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_GRAPHICSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_GRAPHICSTUFF);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_ADMINGRAPHIC,
			'name' => 'admingraphic',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['admingraphic'] == 1?true : false),
			 ($opnConfig['admingraphic'] == 0?true : false) ) );
	$l = array ();
	$l['imagecreate'] = 'imagecreate';
	$l['imagecreatetruecolor'] = 'imagecreatetruecolor';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULTGDLIBUSEDIMAGE,
			'name' => 'opn_gfx_imagecreate',
			'options' => $l,
			'selected' => $opnConfig['opn_gfx_imagecreate']);
	$l = array ();
	$l['imagecopyresized'] = 'imagecopyresized';
	$l['imagecopyresampled'] = 'imagecopyresampled';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULTGDLIBUSEDIMAGE,
			'name' => 'opn_gfx_imagecopyresized',
			'options' => $l,
			'selected' => $opnConfig['opn_gfx_imagecopyresized']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_DEFAULTLISTROWS,
			'name' => 'opn_gfx_defaultlistrows',
			'value' => $opnConfig['opn_gfx_defaultlistrows'],
			'size' => 3,
			'maxlength' => 3);
	$l = array ();
	get_encodings ($l);
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_CHARSET_ENCODING,
			'name' => 'opn_charset_encoding',
			'options' => $l,
			'selected' => $pubsettings['opn_charset_encoding']);
	$themelist = array ();
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'theme');
	foreach ($plug as $var1) {
		$themelist[$var1['module']] = $var1['module'];
	}
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULTTHEME,
			'name' => 'Default_Theme',
			'options' => $themelist,
			'selected' => $opnConfig['Default_Theme']);
	$options = get_logo_options ();
	if ( ($opnConfig['opn-theme-logo'] == '&nbsp;') || $opnConfig['opn-theme-logo'] == chr (160) ) {
		$opnConfig['opn-theme-logo'] = '';
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_DEFAULTTHEMELOGO . '<br />(' . wordwrap ($opnConfig['root_path_datasave'] . '/logo/',
			30,
			'<br />',
			1) . ')',
			'name' => 'opnthemelogo',
			'options' => $options,
			'selected' => $opnConfig['opn-theme-logo']);
	$options = get_accessibility_options ();
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_DEFAULT_ACCESSIBILITY,
			'name' => 'opn_default_accessibility',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_default_accessibility']) );
	$options = array ();
	$options['&nbsp;'] = '';
	$options['apache'] = $opnConfig['opn_default_images'] . 'meta_file_icon_set/apache/';
	$options['winxp'] = $opnConfig['opn_default_images'] . 'meta_file_icon_set/winxp/';
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_WHITCH_FILE_ICON_SET,
			'name' => 'opn_meta_file_icon_set',
			'options' => $options,
			'selected' => $opnConfig['opn_meta_file_icon_set']);
	$options = array ();
	$options[_OPN_LOOSE] = 0;
	$options[_OPN_STRICT] = 1;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_PURE_HTML_GUIDELINES,
			'name' => 'opn_pure_html_guidelines',
			'options' => $options,
			'selected' => $opnConfig['opn_pure_html_guidelines']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_TEXTAREA_ROWS,
			'name' => 'opn_textarea_row',
			'value' => $opnConfig['opn_textarea_row'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_TEXTAREA_COLS,
			'name' => 'opn_textarea_col',
			'value' => $opnConfig['opn_textarea_col'],
			'size' => 3,
			'maxlength' => 3);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVGRAPHIC) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVGRAPHIC) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function miscsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_MISCSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_MISC);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_FORMAUTOCOMPLETE,
			'name' => 'Form_autocomplete',
			'values' => array (1,
			0),
			'titles' => array (_ON,
			_OFF),
			'checked' => array ( ($opnConfig['Form_autocomplete'] == 1?true : false),
			 ($opnConfig['Form_autocomplete'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_HTML_BUTTONWORD,
			'name' => 'Form_HTML_BUTTONWORD',
			'values' => array (1,
			0),
			'titles' => array (_ON,
			_OFF),
			'checked' => array ( ($opnConfig['Form_HTML_BUTTONWORD'] == 1?true : false),
			 ($opnConfig['Form_HTML_BUTTONWORD'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_HTML_BUTTONEXCEL,
			'name' => 'Form_HTML_BUTTONEXCEL',
			'values' => array (1,
			0),
			'titles' => array (_ON,
			_OFF),
			'checked' => array ( ($opnConfig['Form_HTML_BUTTONEXCEL'] == 1?true : false),
			 ($opnConfig['Form_HTML_BUTTONEXCEL'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SHOWLOADTIME,
			'name' => 'show_loadtime',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['show_loadtime'] == 1?true : false),
			 ($opnConfig['show_loadtime'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SHOWADMINMODERNART,
			'name' => 'opn_showadminmodernart',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_showadminmodernart'] == 1?true : false),
			 ($opnConfig['opn_showadminmodernart'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_DEVDEBUG,
			'name' => 'opn_use_coredevdebug',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_use_coredevdebug'] == 1?true : false),
			 ($opnConfig['opn_use_coredevdebug'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_WEEK_START,
			'name' => 'opn_start_day',
			'values' => array (1,
			0),
			'titles' => array ($opnConfig['opndate']->_days[1],
			$opnConfig['opndate']->_days[0]),
			'checked' => array ( ($opnConfig['opn_start_day'] == 1?true : false),
			 ($opnConfig['opn_start_day'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_EXPERT_MODE,
			'name' => 'opn_expert_mode',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_expert_mode'] == 1?true : false),
			 ($opnConfig['opn_expert_mode'] == 0?true : false) ) );
	if ($opnConfig['opn_expert_mode'] == 1) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _OPN_EXPERT_AUTOREPAIR,
				'name' => 'opn_expert_autorepair',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($opnConfig['opn_expert_autorepair'] == 1?true : false),
				 ($opnConfig['opn_expert_autorepair'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_expert_autorepair',
				'value' => 0);
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVMISC) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVMISC) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function masterinterfacesettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_MASTERINTERFACESETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_MASTERINTERFACE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_MASTERINTERFACE,
			'name' => 'OPN_masterinterface',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['OPN_masterinterface'] == 1?true : false),
			 ($opnConfig['OPN_masterinterface'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_MASTERINTERFACE_POPCHECK,
			'name' => 'opn_masterinterface_popcheck',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_masterinterface_popcheck'] == 1?true : false),
			 ($opnConfig['opn_masterinterface_popcheck'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_MAILSERVERIP,
			'name' => 'opn_MailServerIP',
			'value' => $opnConfig['opn_MailServerIP'],
			'size' => 20,
			'maxlength' => 40);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_OPNMAIL,
			'name' => 'opnmail',
			'value' => $opnConfig['opnmail'],
			'size' => 20,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_PASSWORD,
			'display' => _OPN_OPNMAILPASS,
			'name' => 'opnmailpass',
			'value' => $opnConfig['opnmailpass'],
			'size' => 20,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_PASSWORD,
			'display' => _OPN_OPNPASS,
			'name' => 'opnpass',
			'value' => $opnConfig['opnpass'],
			'size' => 20,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_SUPPORTER,
			'name' => 'opn_supporter',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['opn_supporter'] == 1?true : false),
			 ($opnConfig['opn_supporter'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SUPPORTER_EMAIL,
			'name' => 'opn_supporter_email',
			'value' => $opnConfig['opn_supporter_email'],
			'size' => 60,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SUPPORTER_NAME,
			'name' => 'opn_supporter_name',
			'value' => $opnConfig['opn_supporter_name'],
			'size' => 60,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SUPPORTER_CUSTOMER,
			'name' => 'opn_supporter_customer',
			'value' => $opnConfig['opn_supporter_customer'],
			'size' => 30,
			'maxlength' => 100);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVMASTERINTERFACE) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVMASTERINTERFACE) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function uploadsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_UPLOADSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_UPLOADSETTINGS);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_UPLOAD_SIZE_LIMIT,
			'name' => 'opn_upload_size_limit',
			'value' => $opnConfig['opn_upload_size_limit'],
			'size' => 30,
			'maxlength' => 100);
	$l = array ();
	$l['0644'] = '0644';
	$l['0664'] = '0664';
	$l['0666'] = '0666';
	$l['0777'] = '0777';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULTCHMODFILESET,
			'name' => 'opn_server_chmod',
			'options' => $l,
			'selected' => $opnConfig['opn_server_chmod']);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVUPLOAD) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVUPLOAD) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function htmlsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_HTMLSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$set->Col1Width = '20%';
	$set->Col2Width = '80%';
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_HTML);
	$values[] = array ('type' => _INPUT_COMMENTLINE,
			'value' => _OPN_EMPTYTAG);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	if (is_array ($opnConfig['AllowableHTML']) ) {
		foreach ($opnConfig['AllowableHTML'] as $key => $value) {
			$values[] = array ('type' => _INPUT_TEXTRADIO,
					'display' => 'HTML Tag:',
					'name' => 'tag_' . $key,
					'value' => $key,
					'size' => 15,
					'maxlength' => 15,
					'radioname' => 'allow_' . $key,
					'values' => array (1,
					2,
					3),
					'titles' => array (_OPN_TAGONLY,
					_OPN_ALLQUALI,
					_OPN_ALLQUALIJS),
					'checked' => array ( ($value == 1?true : false),
					 ($value == 2?true : false),
					 ($value == 3?true : false) ) );
		}
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _OPN_ADDTAG);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVHTML) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVHTML) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function filtersettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_FILTERSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_FILTER);
	$values[] = array ('type' => _INPUT_COMMENTLINE,
			'value' => _OPN_FILTER_SPAM);
	$options[_OPN_NOFILTER] = 0;
	$options['1'] = 1;
	$options['2'] = 2;
	$options['3'] = 3;
	$options['4'] = 4;
	$options['5'] = 5;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_FILTER_SPAM_SCORE,
			'name' => 'opn_filter_spam_score',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_filter_spam_score']) );

	$values[] = array ('type' => _INPUT_BLANKLINE);
	$options[_OPN_NOFILTER] = 0;
	$options[_OPN_FILTER1] = 1;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_CENSORMODE,
			'name' => 'CensorMode',
			'options' => $options,
			'selected' => intval ($opnConfig['CensorMode']) );
	if (is_array ($opnConfig['CensorList']) ) {
		$max = count ($opnConfig['CensorList']);
		for ($i = 0; $i< $max; $i++) {
			$values[] = array ('type' => _INPUT_TEXTMULTIPLE,
					'display' => array (_OPN_CENSORWORD,
					_OPN_REPLACEMENT),
					'name' => array ('CensorList' . $i,
					'ReplacementList' . $i),
					'value' => array ($opnConfig['CensorList'][$i],
					$opnConfig['ReplacementList'][$i]),
					'size' => array (30,
					30),
					'maxlength' => array (100,
						100) );
		}
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _OPN_ADDWORD);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVFILTER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVFILTER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function safety_filtersettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_SAFETY_FILTER_SETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_SAFETYFILTER);
	$options[_OPN_NOFILTER] = 0;
	$options[_OPN_FILTER1] = 1;
	$options[_OPN_OPNFILTER1] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_SAFETYMODE,
			'name' => 'safety_filtersetting',
			'options' => $options,
			'selected' => $opnConfig['safety_filtersetting']);
	if (is_array ($opnConfig['safety_filtersetting_list']) ) {
		$max = count ($opnConfig['safety_filtersetting_list']);
		for ($i = 0; $i< $max; $i++) {
			$values[] = array ('type' => _INPUT_TEXTMULTIPLE,
					'display' => array (_OPN_SAFETYTAG),
					'name' => array ('safety_filtersetting_list' . $i),
					'value' => array ($opnConfig['safety_filtersetting_list'][$i]),
					'size' => array (30),
					'maxlength' => array (100) );
		}
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _OPN_ADDSAFETY);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVSAFETYFILTER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVSAFETYFILTER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function autostartsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_AUTOSTARTSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_AUTOSTART);
	$options[_NO_SUBMIT] = 0;
	$options[_YES_SUBMIT] = 1;
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'autostart');
	foreach ($plug as $var) {
		if (!isset ($opnConfig['_opn_autostart_' . $var['plugin']]) ) {
			$opnConfig['_opn_autostart_' . $var['plugin']] = 1;
		}
		$values[] = array ('type' => _INPUT_SELECT_KEY,
				'display' => _OPN_AUTOSTART_MODUL . ' ' . $var['plugin'],
				'name' => '_opn_autostart_' . $var['plugin'],
				'options' => $options,
				'selected' => $opnConfig['_opn_autostart_' . $var['plugin']]);
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVAUTOSTART) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVAUTOSTART) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function sitemapsettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_SITEMAPSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_SITEMAP);
	$options[_NO_SUBMIT] = 0;
	$options[_YES_SUBMIT] = 1;
	$opnConfig['opnSQL']->opn_dbcoreloader ('plugin.sitemap', 0);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'menu');
	foreach ($plug as $var) {
		$myfunc = $var['module'] . '_get_menu';
		if (function_exists ($myfunc) ) {
			if (!isset ($opnConfig['_opn_sitemap_' . $var['plugin']]) ) {
				$opnConfig['_opn_sitemap_' . $var['plugin']] = 1;
			}
			$values[] = array ('type' => _INPUT_SELECT_KEY,
					'display' => _OPN_SITEMAP_MODUL . ' ' . $var['plugin'],
					'name' => '_opn_sitemap_' . $var['plugin'],
					'options' => $options,
					'selected' => $opnConfig['_opn_sitemap_' . $var['plugin']]);
		}
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVSITEMAP) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVSITEMAP) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function htmlfiltersettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_HTMLFILTERSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_HTMLFILTER);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'repair');
	foreach ($plug as $var) {
		if (!isset ($opnConfig['_opn_basehtmlfilter_' . $var['plugin']]) ) {
			$opnConfig['_opn_basehtmlfilter_' . $var['plugin']] = 0;
		}
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _OPN_HTMLFILTER_MODUL . ' ' . $var['plugin'],
				'name' => '_opn_basehtmlfilter_' . $var['plugin'],
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($opnConfig['_opn_basehtmlfilter_' . $var['plugin']] == 1?true : false),
				 ($opnConfig['_opn_basehtmlfilter_' . $var['plugin']] == 0?true : false) ) );
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVHTMLFILTER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVHTMLFILTER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function macrofiltersettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_MACROFILTERSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_MACROFILTER);
	if (!isset ($opnConfig['_opn_macrofilter_opnindex']) ) {
		$opnConfig['_opn_macrofilter_opnindex'] = 0;
	}
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_MACROFILTER_MODUL . ' ' . 'opnindex',
			'name' => '_opn_macrofilter_opnindex',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['_opn_macrofilter_opnindex'] == 1?true : false),
			 ($opnConfig['_opn_macrofilter_opnindex'] == 0?true : false) ) );
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'macrofilter');
	foreach ($plug as $var) {
		if (!isset ($opnConfig['_opn_macrofilter_' . $var['plugin']]) ) {
			$opnConfig['_opn_macrofilter_' . $var['plugin']] = 0;
		}
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _OPN_MACROFILTER_MODUL . ' ' . $var['plugin'],
				'name' => '_opn_macrofilter_' . $var['plugin'],
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($opnConfig['_opn_macrofilter_' . $var['plugin']] == 1?true : false),
				 ($opnConfig['_opn_macrofilter_' . $var['plugin']] == 0?true : false) ) );
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVMACROFILTER) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVMACROFILTER) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function macrossettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_MACROSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_MACROS);
	$dir2scan = _OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'macros/';
	$filterDir = opendir ($dir2scan);
	while ($filterDirEntry = readdir ($filterDir) ) {
		if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
			$filterName = explode ('.', $filterDirEntry);
			$className = '_opn_marco_' . $filterName[0];
			if (!isset ($opnConfig[$className]) ) {
				$opnConfig[$className] = 0;
			}
			$values[] = array ('type' => _INPUT_RADIO,
					'display' => _OPN_MACROFILTER_MODUL . ' ' . $filterName[0],
					'name' => $className,
					'values' => array (1,
					0),
					'titles' => array (_YES,
					_NO),
					'checked' => array ( ($opnConfig[$className] == 1?true : false),
					 ($opnConfig[$className] == 0?true : false) ) );
		}
	}
	closedir ($filterDir);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'macrofilter_xt');
	foreach ($plug as $var) {
		$dir2scan = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/macros/';
		$filterDir = opendir ($dir2scan);
		while ($filterDirEntry = readdir ($filterDir) ) {
			if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
				$filterName = explode ('.', $filterDirEntry);
				$className = '_opn_marco_' . $filterName[0];
				if (!isset ($opnConfig[$className]) ) {
					$opnConfig[$className] = 0;
				}
				$values[] = array ('type' => _INPUT_RADIO,
						'display' => _OPN_MACROFILTER_MODUL . ' ' . $filterName[0],
						'name' => $className,
						'values' => array (1,
						0),
						'titles' => array (_YES,
						_NO),
						'checked' => array ( ($opnConfig[$className] == 1?true : false),
						 ($opnConfig[$className] == 0?true : false) ) );
			}
		}
		closedir ($filterDir);
	}
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVMACROS) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVMACROS) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function coresystemsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_SECURITYSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE, 'title' => _OPN_NAVSYSTEM);

	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_CMD_APACHE,
			'name' => 'cmd_apache',
			'value' => $privsettings['cmd_apache'],
			'size' => 30,
			'maxlength' => 100);

	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_PATH_TO_VHOST,
			'name' => 'path_to_vhost',
			'value' => $privsettings['path_to_vhost'],
			'size' => 30,
			'maxlength' => 100);

	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SPOOL_ID_OF_VHOST,
			'name' => 'spool_id_of_vhost',
			'value' => $privsettings['spool_id_of_vhost'],
			'size' => 20,
			'maxlength' => 100);

	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_CMD_MYSQL,
			'name' => 'cmd_mysql',
			'value' => $privsettings['cmd_mysql'],
			'size' => 30,
			'maxlength' => 100);

	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _OPN_SPOOL_ID_OF_MYSQL,
			'name' => 'spool_id_of_mysql',
			'value' => $privsettings['spool_id_of_mysql'],
			'size' => 20,
			'maxlength' => 100);

	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVSYSTEM) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVSYSTEM) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function securitysettings () {

	global $opnConfig;

	$set = & new MySettings;
	$set->SetModule ('admin/openphpnuke');
	$set->SetHelpID ('_OPNDOCID_ADMIN_OPENPHPNUKE_SECURITYSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _OPN_SECURITY);
	$options = array ();
	$options[_NO_SUBMIT] = 0;
	$options[_YES_SUBMIT] = 1;
	$options[_OPN_SHORT_CODE] = 3;
	$options['Do not Use (Sometime in the future)'] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_ENCODEURL,
			'name' => 'encodeurl',
			'options' => $options,
			'selected' => intval ($opnConfig['encodeurl']) );
	$options = array ();
	$options[_OPN_LOOSE] = '0';
	$options[_OPN_MEDIUM] = '1';
	$options[_OPN_STRICT] = '2';
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_CRYPTADJUSTMENT,
			'name' => 'opn_cryptadjustment',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_cryptadjustment']) );
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_SAFETYADJUSTMENT,
			'name' => 'opn_safetyadjustment',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_safetyadjustment']) );
	$options = array ();
	$options[_OPN_GRAPHIC_SECURITY_CODE_NO] = 0;
	$options[_OPN_GRAPHIC_SECURITY_CODE_LOGIN] = 1;
	$options[_OPN_GRAPHIC_SECURITY_CODE_REGISTER] = 2;
	$options[_OPN_GRAPHIC_SECURITY_CODE_REGISTERANDLOGIN] = 3;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _OPN_GRAPHIC_SECURITY_CODE,
			'name' => 'opn_graphic_security_code',
			'options' => $options,
			'selected' => intval ($opnConfig['opn_graphic_security_code']) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_CHECKDOCROOT,
			'name' => 'opn_checkdocroot',
			'values' => array (1,
			0),
			'titles' => array (_ON,
			_OFF),
			'checked' => array ( ($opnConfig['opn_checkdocroot'] == 1?true : false),
			 ($opnConfig['opn_checkdocroot'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_BLOCK_FILTER,
			'name' => 'block_filter',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['block_filter'] == 1?true : false),
			 ($opnConfig['block_filter'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _OPN_DEFAULT_DOS_TESTING,
			'name' => 'dos_testing',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['dos_testing'] == 1?true : false),
			 ($opnConfig['dos_testing'] == 0?true : false) ) );
	$l = array ();
	$l['1'] = '1';
	$l['2'] = '2';
	$l['3'] = '3';
	$l['4'] = '4';
	$l['5'] = '5';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULT_DOS_EXPIRE_TIME,
			'name' => 'dos_expire_time',
			'options' => $l,
			'selected' => $opnConfig['dos_expire_time']);
	$l = array ();
	$l['5'] = '5';
	$l['10'] = '10';
	$l['15'] = '15';
	$l['20'] = '20';
	$l['25'] = '25';
	$values[] = array ('type' => _INPUT_SELECT,
			'display' => _OPN_DEFAULT_DOS_EXPIRE_TOTAL,
			'name' => 'dos_expire_total',
			'options' => $l,
			'selected' => $opnConfig['dos_expire_total']);
	$values = array_merge ($values, openphpnuke_makenavbar (_OPN_NAVSECURITY) );
	$values = array_merge ($values, openphpnuke_allhiddens (_OPN_NAVSECURITY) );
	$set->GetTheForm (_OPN_SETTINGS, encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
							'fct' => 'openphpnuke') ),
							$values);

}

function openphpnuke_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SavePublicsettings ();

	retrieveconfig ();

}

function openphpnuke_dosavegeneral ($vars) {

	global $opnConfig, $pubsettings;
	
	$vars['sitename'] = htmlentities($vars['sitename']);
	$vars['sitename'] = stripslashes($vars['sitename']);
	$vars['slogan'] = htmlentities($vars['slogan']);
	$vars['slogan'] = stripslashes($vars['slogan']);

	$pubsettings['sitename'] = $vars['sitename'];
	$pubsettings['opn_url'] = $vars['opn_url'];
	$pubsettings['site_logo'] = $vars['site_logo'];
	$pubsettings['slogan'] = $vars['slogan'];
	$pubsettings['startdate'] = $vars['startdate'];
	$pubsettings['adminmail'] = $vars['adminmail'];
	$pubsettings['top'] = $vars['top'];
	$pubsettings['opn_display_fetching_request'] = $vars['opn_display_fetching_request'];
	$pubsettings['display_complete_adminmenu'] = $vars['display_complete_adminmenu'];
	$pubsettings['opn_time_prefix'] = $vars['opn_time_prefix'];
	$pubsettings['opn_generateautomatictitle'] = $vars['opn_generateautomatictitle'];
	openphpnuke_dosavesettings ();
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_filedb.php');
	$ex = & new filedb;
	$ex->filename = $opnConfig['root_path_datasave'] . 'opnfallback.php';
	$ex->ReadDB ();
	$index = $ex->FindIndex ('fallback', 0, 'adminmail');
	if ($index !== false) {
		$ex->db['fallback'][$index] = array ('adminmail',
						$vars['adminmail']);
	} else {
		$ex->insert ('fallback', array ('adminmail',
						$vars['adminmail']) );
	}
	$ex->WriteDB ();
	unset ($ex);

}

function openphpnuke_dosavesecurity ($vars) {

	global $pubsettings;

	$pubsettings['encodeurl'] = $vars['encodeurl'];
	$pubsettings['opn_safetyadjustment'] = $vars['opn_safetyadjustment'];
	$pubsettings['opn_cryptadjustment'] = $vars['opn_cryptadjustment'];
	if (extension_loaded ('gd') ) {
		$pubsettings['opn_graphic_security_code'] = $vars['opn_graphic_security_code'];
	} else {
		$pubsettings['opn_graphic_security_code'] = 0;
	}
	$pubsettings['opn_checkdocroot'] = $vars['opn_checkdocroot'];
	$pubsettings['block_filter'] = $vars['block_filter'];
	$pubsettings['dos_testing'] = $vars['dos_testing'];
	$pubsettings['dos_expire_time'] = $vars['dos_expire_time'];
	$pubsettings['dos_expire_total'] = $vars['dos_expire_total'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosaveemail ($vars) {

	global $opnConfig, $pubsettings;

	$pubsettings['opn_activate_email'] = $vars['opn_activate_email'];
	$pubsettings['opn_activate_email_debug'] = $vars['opn_activate_email_debug'];
	$pubsettings['opn_use_sendmail'] = $vars['opn_use_sendmail'];
	$pubsettings['opn_use_checkemail'] = $vars['opn_use_checkemail'];
	$pubsettings['opn_email_charset_encoding'] = $vars['opn_email_charset_encoding'];
	$pubsettings['opn_email_subject_encoding'] = $vars['opn_email_subject_encoding'];
	$pubsettings['opn_email_body_encoding'] = $vars['opn_email_body_encoding'];
	$pubsettings['opn_emailgeneratemessageid'] = $vars['opn_emailgeneratemessageid'];
	$pubsettings['opn_emailpriority'] = $vars['opn_emailpriority'];
	if ($pubsettings['smtp_password'] != $vars['smtp_password']) {
		$vars['smtp_password'] = make_the_secret (md5 ($opnConfig['encoder']), $vars['smtp_password']);
	}
	$pubsettings['smtp_password'] = $vars['smtp_password'];
	$pubsettings['smtp_username'] = $vars['smtp_username'];
	$pubsettings['smtp_auth'] = $vars['smtp_auth'];
	$pubsettings['smtp_port'] = $vars['smtp_port'];
	$pubsettings['smtp_host'] = $vars['smtp_host'];
	$pubsettings['sendmail_args'] = $vars['sendmail_args'];
	$pubsettings['sendmail_path'] = $vars['sendmail_path'];
	$pubsettings['send_email_via'] = $vars['send_email_via'];
	$pubsettings['opn_all_email_to_admin'] = $vars['opn_all_email_to_admin'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosaveserver ($vars) {

	global $pubsettings, $opnConfig;

	$pubsettings['language'] = $vars['language'];
	$pubsettings['locale'] = $vars['locale'];
	$pubsettings['opn_set_timezone'] = $vars['opn_set_timezone'];
	$pubsettings['opn_timezone'] = $vars['opn_timezone'];
	$pubsettings['opn_mysql_pconnect'] = $vars['opn_mysql_pconnect'];
	$pubsettings['opn_db_index_right'] = $vars['opn_db_index_right'];
	$pubsettings['opn_db_safe_use'] = $vars['opn_db_safe_use'];
	$pubsettings['opn_db_lock_use'] = $vars['opn_db_lock_use'];
	$pubsettings['opn_host_use_safemode'] = $vars['opn_host_use_safemode'];
	$pubsettings['opn_php5_migration'] = $vars['opn_php5_migration'];
	$pubsettings['opn_ServerIP'] = $vars['opn_ServerIP'];
	$pubsettings['update_useProxy'] = $vars['opn_useProxy'];
	$pubsettings['update_ProxyIP'] = $vars['ProxyIP'];
	$pubsettings['update_ProxyPort'] = $vars['ProxyPort'];
	$pubsettings['opn_dirmanage'] = $vars['opn_dirmanage'];
	$pubsettings['opn_ftpusername'] = $vars['opn_ftpusername'];
	if ($pubsettings['opn_ftppassword'] != $vars['opn_ftppassword']) {
		$vars['opn_ftppassword'] = make_the_secret (md5 ($opnConfig['encoder']), $vars['opn_ftppassword']);
	}
	$pubsettings['opn_ftppassword'] = $vars['opn_ftppassword'];
	$pubsettings['opn_ftphost'] = $vars['opn_ftphost'];
	$pubsettings['opn_ftpport'] = $vars['opn_ftpport'];
	$pubsettings['opn_ftpdir'] = $vars['opn_ftpdir'];
	$pubsettings['opn_ftpchmod'] = $vars['opn_ftpchmod'];
	$pubsettings['opn_ftppasv'] = $vars['opn_ftppasv'];
	$pubsettings['opn_ftpmode'] = $vars['opn_ftpmode'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosaveuser ($vars) {

	global $pubsettings;

	$pubsettings['opn_startthemegroup'] = $vars['opn_startthemegroup'];
	$pubsettings['opn_uname_test_level'] = $vars['opn_uname_test_level'];
	$pubsettings['minpass'] = $vars['minpass'];
	$pubsettings['opn_activatetype'] = $vars['opn_activatetype'];
	$pubsettings['opn_new_user_notify'] = $vars['opn_new_user_notify'];
	$pubsettings['opn_anonymous_id'] = $vars['opn_anonymous_id'];
	$pubsettings['opn_anonymous_name'] = $vars['opn_anonymous_name'];
	$pubsettings['opn_deleted_user'] = $vars['opn_deleted_user'];
	$pubsettings['opn_bot_user'] = $vars['opn_bot_user'];
	$pubsettings['sessionexpire'] = (int) $vars['sessionexpire'];
	$pubsettings['sessionexpire_bonus'] = (int) $vars['sessionexpire_bonus'];
	$pubsettings['opn_cookie_domainname'] = $vars['opn_cookie_domainname'];
	$pubsettings['opn_new_user_actasblacklist'] = $vars['opn_new_user_actasblacklist'];
	$pubsettings['opn_uname_allow_spaces'] = $vars['opn_uname_allow_spaces'];
	$pubsettings['opn_list_domainname'] = array ();
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'listdomainname')>0) {
			if ($value != '') {
				$pubsettings['opn_list_domainname'][] = $value;
			}
		}
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavecontact ($vars) {

	global $pubsettings;

	$pubsettings['opn_webmaster_name'] = $vars['opn_webmaster_name'];
	$pubsettings['opn_contact_email'] = $vars['opn_contact_email'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavefooter ($vars) {

	global $pubsettings;

	$pubsettings['foot1'] = $vars['foot1'];
	$pubsettings['foot2'] = $vars['foot2'];
	$pubsettings['foot3'] = $vars['foot3'];
	$pubsettings['foot4'] = $vars['foot4'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosaveautostart ($vars) {

	global $pubsettings, $opnConfig;

	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'autostart');
	foreach ($plug as $var) {
		if (!isset ($vars['_opn_autostart_' . $var['plugin']]) ) {
			$vars['_opn_autostart_' . $var['plugin']] = 1;
		}
		$pubsettings['_opn_autostart_' . $var['plugin']] = $vars['_opn_autostart_' . $var['plugin']];
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavesitemap ($vars) {

	global $pubsettings, $opnConfig;

	$opnConfig['opnSQL']->opn_dbcoreloader ('plugin.sitemap', 0);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'menu');
	foreach ($plug as $var) {
		$myfunc = $var['module'] . '_get_menu';
		if (function_exists ($myfunc) ) {
			if (!isset ($vars['_opn_sitemap_' . $var['plugin']]) ) {
				$vars['_opn_sitemap_' . $var['plugin']] = 1;
			}
			$pubsettings['_opn_sitemap_' . $var['plugin']] = $vars['_opn_sitemap_' . $var['plugin']];
		}
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavehtmlfilter ($vars) {

	global $pubsettings, $opnConfig;

	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'repair');
	foreach ($plug as $var) {
		if (!isset ($vars['_opn_basehtmlfilter_' . $var['plugin']]) ) {
			$vars['_opn_basehtmlfilter_' . $var['plugin']] = 0;
		}
		$pubsettings['_opn_basehtmlfilter_' . $var['plugin']] = $vars['_opn_basehtmlfilter_' . $var['plugin']];
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavemacrofilter ($vars) {

	global $pubsettings, $opnConfig;
	if (!isset ($vars['_opn_macrofilter_opnindex']) ) {
		$vars['_opn_macrofilter_opnindex'] = 0;
	}
	$pubsettings['_opn_macrofilter_opnindex'] = $vars['_opn_macrofilter_opnindex'];
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'macrofilter');
	foreach ($plug as $var) {
		if (!isset ($vars['_opn_macrofilter_' . $var['plugin']]) ) {
			$vars['_opn_macrofilter_' . $var['plugin']] = 0;
		}
		$pubsettings['_opn_macrofilter_' . $var['plugin']] = $vars['_opn_macrofilter_' . $var['plugin']];
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavemacros ($vars) {

	global $pubsettings, $opnConfig;

	$dir2scan = _OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'macros/';
	$filterDir = opendir ($dir2scan);
	while ($filterDirEntry = readdir ($filterDir) ) {
		if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
			$filterName = explode ('.', $filterDirEntry);
			$className = '_opn_marco_' . $filterName[0];
			if (!isset ($vars[$className]) ) {
				$vars[$className] = 0;
			}
			$pubsettings[$className] = $vars[$className];
		}
	}
	closedir ($filterDir);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'macrofilter_xt');
	foreach ($plug as $var) {
		$dir2scan = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/macros/';
		$filterDir = opendir ($dir2scan);
		while ($filterDirEntry = readdir ($filterDir) ) {
			if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
				$filterName = explode ('.', $filterDirEntry);
				$className = '_opn_marco_' . $filterName[0];
				if (!isset ($vars[$className]) ) {
					$vars[$className] = 0;
				}
				$pubsettings[$className] = $vars[$className];
			}
		}
		closedir ($filterDir);
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavegraphic ($vars) {

	global $pubsettings;

	$pubsettings['admingraphic'] = $vars['admingraphic'];
	$pubsettings['opn_gfx_imagecreate'] = $vars['opn_gfx_imagecreate'];
	$pubsettings['opn_gfx_imagecopyresized'] = $vars['opn_gfx_imagecopyresized'];
	$pubsettings['opn_gfx_defaultlistrows'] = $vars['opn_gfx_defaultlistrows'];
	$pubsettings['opn_charset_encoding'] = $vars['opn_charset_encoding'];
	$pubsettings['Default_Theme'] = $vars['Default_Theme'];
	$pubsettings['opn-theme-logo'] = $vars['opnthemelogo'];
	$pubsettings['opn_default_accessibility'] = $vars['opn_default_accessibility'];
	$pubsettings['opn_meta_file_icon_set'] = $vars['opn_meta_file_icon_set'];
	$pubsettings['opn_pure_html_guidelines'] = $vars['opn_pure_html_guidelines'];
	$pubsettings['opn_textarea_row'] = $vars['opn_textarea_row'];
	$pubsettings['opn_textarea_col'] = $vars['opn_textarea_col'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavemisc ($vars) {

	global $pubsettings;

	$pubsettings['Form_autocomplete'] = $vars['Form_autocomplete'];
	$pubsettings['Form_HTML_BUTTONWORD'] = $vars['Form_HTML_BUTTONWORD'];
	$pubsettings['Form_HTML_BUTTONEXCEL'] = $vars['Form_HTML_BUTTONEXCEL'];
	$pubsettings['show_loadtime'] = $vars['show_loadtime'];
	$pubsettings['opn_showadminmodernart'] = $vars['opn_showadminmodernart'];
	$pubsettings['opn_use_coredevdebug'] = $vars['opn_use_coredevdebug'];
	$pubsettings['opn_expert_mode'] = $vars['opn_expert_mode'];
	$pubsettings['opn_start_day'] = $vars['opn_start_day'];
	if ($vars['opn_expert_mode'] == 1) {
		$pubsettings['opn_expert_autorepair'] = $vars['opn_expert_autorepair'];
	} else {
		$pubsettings['opn_expert_autorepair'] = 0;
	}
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosaveupload ($vars) {

	global $pubsettings;

	$pubsettings['opn_upload_size_limit'] = $vars['opn_upload_size_limit'];
	$pubsettings['opn_server_chmod'] = $vars['opn_server_chmod'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavemasterinterface ($vars) {

	global $pubsettings;

	$pubsettings['OPN_masterinterface'] = $vars['OPN_masterinterface'];
	$pubsettings['opn_masterinterface_popcheck'] = $vars['opn_masterinterface_popcheck'];
	$pubsettings['opn_MailServerIP'] = $vars['opn_MailServerIP'];
	$pubsettings['opnmail'] = $vars['opnmail'];
	$pubsettings['opnmailpass'] = $vars['opnmailpass'];
	$pubsettings['opnpass'] = $vars['opnpass'];
	$pubsettings['opn_supporter'] = $vars['opn_supporter'];
	$pubsettings['opn_supporter_email'] = $vars['opn_supporter_email'];
	$pubsettings['opn_supporter_name'] = $vars['opn_supporter_name'];
	$pubsettings['opn_supporter_customer'] = $vars['opn_supporter_customer'];
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavehtml ($vars) {

	global $pubsettings;

	$pubsettings['AllowableHTML'] = array ();
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'tag')>0) {
			if ($key <> 'tag_') {
				$help = str_replace ('tag_', 'allow_', $key);
				$pubsettings['AllowableHTML'][$value] = $vars[$help];
			}
		}
	}
	openphpnuke_dosavesettings ();

}

function filtercensor ($var) {

	$rc = 0;
	if ($var != '') {
		$rc = 1;
	}
	return $rc;

}

function openphpnuke_dosavefilter ($vars) {

	global $pubsettings, $opnConfig;

	$pubsettings['opn_filter_spam_score'] = $vars['opn_filter_spam_score'];
	$pubsettings['CensorMode'] = $vars['CensorMode'];
	$pubsettings['CensorList'] = array ();
	if (is_array ($opnConfig['CensorList']) ) {
		$max = count ($opnConfig['CensorList']);
		for ($i = 0; $i< $max; $i++) {
			$pubsettings['CensorList'][$i] = $vars['CensorList' . $i];
		}
	}
	$pubsettings['ReplacementList'] = array ();
	if (is_array ($opnConfig['ReplacementList']) ) {
		$max = count ($opnConfig['ReplacementList']);
		for ($i = 0; $i< $max; $i++) {
			$pubsettings['ReplacementList'][$i] = $vars['ReplacementList' . $i];
		}
	}
	arrayfilter ($pubsettings['CensorList'], $pubsettings['CensorList'], 'filtercensor');
	arrayfilter ($pubsettings['ReplacementList'], $pubsettings['ReplacementList'], 'filtercensor');
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavesafety_filter ($vars) {

	global $pubsettings, $opnConfig;

	$pubsettings['safety_filtersetting'] = $vars['safety_filtersetting'];
	$pubsettings['safety_filtersetting_list'] = array ();
	if (is_array ($opnConfig['safety_filtersetting_list']) ) {
		$max = count ($opnConfig['safety_filtersetting_list']);
		for ($i = 0; $i< $max; $i++) {
			$pubsettings['safety_filtersetting_list'][$i] = $vars['safety_filtersetting_list' . $i];
		}
	}
	arrayfilter ($pubsettings['safety_filtersetting_list'], $pubsettings['safety_filtersetting_list'], 'filtercensor');
	openphpnuke_dosavesettings ();

}

function openphpnuke_dosavecoresystem ($vars) {

	global $pubsettings, $privsettings;

	$privsettings['path_to_vhost'] = $vars['path_to_vhost'];
	$privsettings['spool_id_of_vhost'] = $vars['spool_id_of_vhost'];
	$privsettings['spool_id_of_mysql'] = $vars['spool_id_of_mysql'];
	$privsettings['cmd_apache'] = $vars['cmd_apache'];
	$privsettings['cmd_mysql'] = $vars['cmd_mysql'];

	openphpnuke_dosavesettings ();

}

function openphpnuke_dosave ($returns) {
	if ( (isset ($returns['save']) ) ) {
		switch ($returns['save']) {
			case _OPN_NAVGENERAL:
				openphpnuke_dosavegeneral ($returns);
				break;
			case _OPN_NAVLOCALE:
				openphpnuke_dosaveserver ($returns);
				break;
			case _OPN_NAVUSER:
				openphpnuke_dosaveuser ($returns);
				break;
			case _OPN_NAVCONTACT:
				openphpnuke_dosavecontact ($returns);
				break;
			case _OPN_NAVFOOTER:
				openphpnuke_dosavefooter ($returns);
				break;
			case _OPN_NAVEMAIL:
				openphpnuke_dosaveemail ($returns);
				break;
			case _OPN_NAVGRAPHIC:
				openphpnuke_dosavegraphic ($returns);
				break;
			case _OPN_NAVMASTERINTERFACE:
				openphpnuke_dosavemasterinterface ($returns);
				break;
			case _OPN_NAVMISC:
				openphpnuke_dosavemisc ($returns);
				break;
			case _OPN_NAVUPLOAD:
				openphpnuke_dosaveupload ($returns);
				break;
			case _OPN_NAVFILTER:
				openphpnuke_dosavefilter ($returns);
				break;
			case _OPN_NAVSAFETYFILTER:
				openphpnuke_dosavesafety_filter ($returns);
				break;
			case _OPN_NAVAUTOSTART:
				openphpnuke_dosaveautostart ($returns);
				break;
			case _OPN_NAVSITEMAP:
				openphpnuke_dosavesitemap ($returns);
				break;
			case _OPN_NAVHTMLFILTER:
				openphpnuke_dosavehtmlfilter ($returns);
				break;
			case _OPN_NAVMACROFILTER:
				openphpnuke_dosavemacrofilter ($returns);
				break;
			case _OPN_NAVMACROS:
				openphpnuke_dosavemacros ($returns);
				break;
			case _OPN_NAVHTML:
				openphpnuke_dosavehtml ($returns);
				break;
			case _OPN_NAVSECURITY:
				openphpnuke_dosavesecurity ($returns);
				break;
			case _OPN_NAVSYSTEM:
				openphpnuke_dosavecoresystem ($returns);
				break;
		}
	}

}
global $opnTables;

$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . " SET uname='" . $opnConfig['opn_anonymous_name'] . "' WHERE uid=" . $opnConfig['opn_anonymous_id']);
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		openphpnuke_dosave ($result);
	} else {
		$result = '';
	}
}
switch ($op) {
	case _OPN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
								'fct' => 'openphpnuke',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _OPN_ADDTAG:
		if (!is_array ($pubsettings['AllowableHTML']) ) {
			$pubsettings['AllowableHTML'] = array ();
		}
		$pubsettings['AllowableHTML']['New'] = 1;
		openphpnuke_dosavesettings ();
		htmlsettings ();
		break;
	case _OPN_ADDWORD:
		$pubsettings['CensorList'][count ($pubsettings['CensorList'])] = 'New';
		$pubsettings['ReplacementList'][count ($pubsettings['ReplacementList'])] = '**beep**';
		openphpnuke_dosavesettings ();
		filtersettings ();
		break;
	case _OPN_NAVGENERAL:
		generalsettings ();
		break;
	case _OPN_NAVEMAIL:
		emailsettings ();
		break;
	case _OPN_NAVLOCALE:
		serversettings ();
		break;
	case _OPN_NAVUSER:
		usersettings ();
		break;
	case _OPN_NAVCONTACT:
		contactsettings ();
		break;
	case _OPN_NAVFOOTER:
		footersettings ();
		break;
	case _OPN_NAVGRAPHIC:
		graphicsettings ();
		break;
	case _OPN_NAVMISC:
		miscsettings ();
		break;
	case _OPN_NAVUPLOAD:
		uploadsettings ();
		break;
	case _OPN_NAVMASTERINTERFACE:
		masterinterfacesettings ();
		break;
	case _OPN_NAVHTML:
		htmlsettings ();
		break;
	case _OPN_NAVFILTER:
		filtersettings ();
		break;
	case _OPN_ADDSAFETY:
		$pubsettings['safety_filtersetting_list'][count ($pubsettings['safety_filtersetting_list'])] = 'New';
		openphpnuke_dosavesettings ();
		safety_filtersettings ();
		break;
	case _OPN_NAVSAFETYFILTER:
		safety_filtersettings ();
		break;
	case _OPN_NAVAUTOSTART:
		autostartsettings ();
		break;
	case _OPN_NAVSITEMAP:
		sitemapsettings ();
		break;
	case _OPN_NAVHTMLFILTER:
		htmlfiltersettings ();
		break;
	case _OPN_NAVMACROFILTER:
		macrofiltersettings ();
		break;
	case _OPN_NAVMACROS:
		macrossettings ();
		break;
	case _OPN_NAVSECURITY:
		securitysettings ();
		break;
	case _OPN_NAVSYSTEM:
		coresystemsettings ();
		break;
	default:
		generalsettings ();
		break;
}

?>