<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'admin/openphpnuke/plugin/user/language/');

function openphpnuke_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$query = &$opnConfig['database']->SelectLimit ('SELECT user_debug FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr, 1);
	if (is_object ($query) ) {
		$user_debug_addon = $query->fields['user_debug'];
		$query->Close ();
	}
	unset ($query);
	$opnConfig['opnOption']['form']->AddOpenHeadRow ();
	$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->ResetAlternate ();
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddLabel ('user_debug_addon', _ADMINOPN_ADUSERINFODEBUGLEVEL);
	$options['0'] = _OFF;
	$options['1'] = 'Step 1 - ONLY HTML';
	$options['2'] = 'Step 2 - ONLY SQL/INCLUDE';
	$options['3'] = 'Step 3 - ONLY SQL/CONSTANTS';
	$options['4'] = 'Step 4 - ONLY SQL/FUNCTIONS';
	$options['5'] = 'Step 5 - ONLY SQL/STATEMENTS';
	$options['6'] = 'Step 6 - DEBUG BENCHMARK';
	$options['7'] = 'Step 7 - ONLY EVAL DEBUG';
	$options['8'] = 'Step 8 - ONLY SESSION DEBUG';
	$opnConfig['opnOption']['form']->AddSelect ('user_debug_addon', $options, intval ($user_debug_addon) );
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function openphpnuke_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_debug_addon = 0;
	get_var ('user_debug_addon', $user_debug_addon, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . " SET user_debug =$user_debug_addon WHERE uid=$usernr");

}

function openphpnuke_show_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$help = '<br />';
	$query = &$opnConfig['database']->Execute ('SELECT user_debug FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr);
	if (is_object ($query) ) {
		$user_debug_addon = $query->fields['user_debug'];
		$query->Close ();
		if ($user_debug_addon != '') {
			$help = '<span class="normaltextbold">' . _ADMINOPN_ADUSERINFODEBUGLEVEL . '</span><br />' . $user_debug_addon . '<br /><br />' . _OPN_HTML_NL;
		}
	}
	unset ($query);
	return $help;

}

function openphpnuke_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_debug_addon = 0;
	get_var ('user_debug_addon', $user_debug_addon, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	if ($user_debug_addon != 0) {
		$opnConfig['opnOption']['form']->AddText ('<span class="normaltextbold">' . _ADMINOPN_ADUSERINFODEBUGLEVEL . '</span>');
		$opnConfig['opnOption']['form']->AddText ($user_debug_addon);
		$opnConfig['opnOption']['form']->AddChangeRow ();
	}
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_debug_addon', $user_debug_addon);
	$opnConfig['opnOption']['form']->AddCloseRow ();
	return '';

}

function openphpnuke_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			openphpnuke_get_the_user_addon_info ($uid);
			break;
		case 'save':
			openphpnuke_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			openphpnuke_confirm_the_user_addon_info ();
			break;
		case 'show_page':
			$option['content'] = openphpnuke_show_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>