<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_AUTH_COMMON_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_AUTH_COMMON_INCLUDED', 1);

	class opn_auth_common {

		/**
		*
		* @return string
		*/

		function getResponse () {
			return '';

		}

		/**
		* FUNCTION: _hmac_md5
		* Function which implements HMAC MD5 digest
		*
		* @param  string $key  The secret key
		* @param  string $data The data to protect
		* @return string	   The HMAC MD5 digest
		* @access private
		*/

		function _hmac_md5 ($key, $data) {
			if (strlen ($key)>64) {
				$key = pack ('H32', md5 ($key) );
			}
			if (strlen ($key)<64) {
				$key = str_pad ($key, 64, chr (0) );
			}
			$k_ipad = substr ($key, 0, 64)^str_repeat (chr (0x36), 64);
			$k_opad = substr ($key, 0, 64)^str_repeat (chr (0x5C), 64);
			$inner = pack ('H32', md5 ($k_ipad . $data) );
			$digest = md5 ($k_opad . $inner);
			return $digest;

		}
		// end function

	}
	// end class
}

?>