<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_FORMULAR_INCLUDED') ) {
	define ('_OPN_CLASS_FORMULAR_INCLUDED', 1);

	class opn_Formular {

		/**
		* Private properties. Do not set outside this class.
		**/

		/*<{php4}>
		var $formular = array();
		<{php4/}>*/

		/*<{php5}>
		public $formular = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $formular = array();
		/*<{delete/}>*/

		/**
		* opn_Formular::Init()
		* Add the form-Tag
		*
		* @param $action
		* @param string $method
		* @param string $formname
		* @param string $enctype
		* @param string $onsubmit
		* @param string $target
		* @param string $class
		*
		**/

		function Init ($action, $method = 'post', $formname = '', $enctype = '', $onsubmit = '', $target = '', $class = 'form') {

			$this->formular = array ();
			$formtag['type'] = 'formtag';
			$formtag['action'] = $action;
			$formtag['method'] = $method;
			$formtag['name'] = $formname;
			$formtag['enctype'] = $enctype;
			$formtag['onsubmit'] = $onsubmit;
			$formtag['target'] = $target;
			$formtag['class'] = $class;
			$this->formular[] = $formtag;
			unset ($formtag);

		}

		/**
		* opn_Formular::Init2()
		* Add the form-Tag
		*
		* @param string $formname
		*
		**/

		function Init2 ($formname = '') {

			$this->formular = array ();
			$formtag['type'] = 'formtag2';
			$formtag['name'] = $formname;
			$this->formular[] = $formtag;
			unset ($formtag);

		}

		function _buildid ($prefix, $formname = false) {

			mt_srand ((double)microtime ()*1000000);
			$idsuffix = mt_rand ();
			if (!$formname) {
				return $prefix . '-id-' . $idsuffix;
			}
			return $prefix . 'id' . $idsuffix;

		}

		/**
		* opn_Formular::AddText()
		* Add a textline
		*
		* @param $text
		* @param string $class
		**/

		function AddText ($text, $class = '') {

			$text1['type'] = 'text';
			if ($class != '') {
				$before = '<span class="' . $class . '">';
				$after = '</span>';
			} else {
				$before = '';
				$after = '';
			}
			$text1['text'] = $before . $text . $after;
			$this->formular[] = $text1;
			unset ($text1);
			unset ($before);
			unset ($after);

		}

		/**
		* opn_Formular::AddOpenTable()
		* Add a OpenTable function
		*
		**/

		function AddOpenTable () {

			$text1['type'] = 'OpenTable';
			$this->formular[] = $text1;
			unset ($text1);

		}

		/**
		* opn_Formular::CloseOpenTable()
		* Add a CloseTable function
		*
		**/

		function AddCloseTable () {

			$text1['type'] = 'CloseTable';
			$this->formular[] = $text1;
			unset ($text1);

		}

		/**
		* opn_Formular::AddNewline()
		* Add some br-Tags
		*
		* @param integer $count
		**/

		function AddNewline ($count = 1) {

			$newline['type'] = 'newline';
			$newline['count'] = $count;
			$this->formular[] = $newline;
			unset ($newline);

		}

		/**
		* opn_Formular::AddLabel()
		*  Add some br-Tags
		*
		* @param $id
		* @param $text
		* @param integer $after
		**/

		function AddLabel ($id, $text, $after = 0) {

			$t = $id;
			$text1['type'] = 'label';
			$text1['after'] = $after;
			$text1['text'] = $text;
			$this->formular[] = $text1;
			unset ($text1);

		}

		/**
		* AddTextfield()
		* Add a input type=text tag
		*
		* @param $name
		* @param integer $size
		* @param integer $maxlength
		* @param string $value
		* @param integer $readonly
		* @param string $id
		* @param string $class
		* @param string $onfocus
		**/

		function AddTextfield ($name, $size = 0, $maxlength = 0, $value = '', $readonly = 0, $id = '', $class = 'textfield', $onfocus = '') {

			$text['type'] = 'textfield';
			$text['name'] = $name;
			$text['size'] = $size;
			$text['maxlength'] = $maxlength;
			$text['class'] = $class;
			$text['readonly'] = $readonly;
			$text['value'] = $value;
			$text['onfocus'] = $onfocus;
			if ($id != '') {
				$text['id'] = $id;
			} else {
				$text['id'] = $this->_buildid ('text');
			}
			$this->formular[] = $text;
			unset ($text);

		}

		/**
		* AddPassword()
		* Add a input type=password tag
		*
		* @param $name
		* @param $size
		* @param integer $maxlength
		* @param string $class
		* @param string $value
		* @param string $onfocus
		**/

		function AddPassword ($name, $size, $maxlength = 0, $class = 'textfield', $value = '', $onfocus = '') {

			$pass['type'] = 'password';
			$pass['name'] = $name;
			$pass['size'] = $size;
			$pass['maxlength'] = $maxlength;
			$pass['class'] = $class;
			$pass['value'] = $value;
			$pass['onfocus'] = $onfocus;
			$pass['id'] = $this->_buildid ('pass');
			$this->formular[] = $pass;
			unset ($pass);

		}

		/**
		* AddTextarea()
		* Add a texarea tag
		*
		* @param $name
		* @param $cols
		* @param $rows
		* @param string $wrap
		* @param string $value
		* @param string $onselect
		* @param string $onclick
		* @param string $onkeyup
		* @param string $class
		* @param integer $readonly
		**/

		function AddTextarea ($name, $cols, $rows, $wrap = '', $value = '', $onselect = '', $onclick = '', $onkeyup = '', $class = 'textarea', $readonly = 0) {

			$text['type'] = 'textarea';
			$text['name'] = $name;
			$text['cols'] = $cols;
			$text['rows'] = $rows;
			$text['class'] = $class;
			$text['wrap'] = $wrap;
			$text['value'] = $value;
			$text['onselect'] = $onselect;
			$text['onclick'] = $onclick;
			$text['onkeyup'] = $onkeyup;
			$text['readonly'] = $readonly;
			$text['id'] = $this->_buildid ('textarea');
			$this->formular[] = $text;
			unset ($text);

		}

		/**
		* AddSelect()
		* Add a select tag and the needed option tags
		* The keys of the options array are the values of the
		* option tags.
		*
		* @param $name
		* @param $options
		* @param string $selected
		* @param string $onchange
		* @param integer $size
		* @param integer $multiple
		* @param integer $compname
		* @param string $class
		**/

		function AddSelect ($name, $options, $selected = '', $onchange = '', $size = 0, $multiple = 0, $compname = 0, $class = 'select') {

			$select['type'] = 'select';
			$select['name'] = $name;
			$select['options'] = $options;
			$select['selected'] = $selected;
			$select['onchange'] = $onchange;
			$select['size'] = $size;
			$select['multiple'] = $multiple;
			$select['compname'] = $compname;
			$select['class'] = $class;
			$select['id'] = $this->_buildid ('select');
			$this->formular[] = $select;
			unset ($select);

		}

		/**
		* AddSelect()
		* Add a select tag and the needed option tags
		* The keys of the options array are the values of the
		* option tags.
		*
		* @param $name
		* @param &$result
		* @param string $selected
		* @param string $onchange
		* @param integer $size
		* @param integer $multiple
		* @param integer $compname
		* @param string $class
		**/

		function AddSelectDB ($name, &$result, $selected = '', $onchange = '', $size = 0, $multiple = 0, $compname = 0, $class = 'select') {

			$options = array ();
			while (! $result->EOF) {
				$fields = $result->FieldTypesArray ();
				$options[$result->fields[strtolower ($fields[0]->name)]] = $result->fields[strtolower ($fields[1]->name)];
				$result->MoveNext ();
			}
			$select['type'] = 'select';
			$select['name'] = $name;
			$select['options'] = $options;
			$select['selected'] = $selected;
			$select['onchange'] = $onchange;
			$select['size'] = $size;
			$select['multiple'] = $multiple;
			$select['compname'] = $compname;
			$select['class'] = $class;
			$select['id'] = $this->_buildid ('select');
			$this->formular[] = $select;
			unset ($select);

		}

		/**
		* opn_Formular::AddSelectspecial()
		* Add a select tag and the needed option tags.
		* The options array is an two dimensonal array.
		* The first dimension is numeric.
		* The second dimension is assoc (value and text)
		*
		* @param $name
		* @param $options
		* @param string $selected
		* @param string $onchange
		* @param integer $size
		* @param string $class
		**/

		function AddSelectspecial ($name, $options, $selected = '', $onchange = '', $size = 0, $class = 'selectbox') {

			$select['type'] = 'selectspecial';
			$select['name'] = $name;
			$select['options'] = $options;
			$select['selected'] = $selected;
			$select['onchange'] = $onchange;
			$select['size'] = $size;
			$select['class'] = $class;
			$select['id'] = $this->_buildid ('select');
			$this->formular[] = $select;
			unset ($select);

		}

		/**
		* AddSelectnokey()
		* Add a select tag and the needed <otpion> tags
		* The option tags are without a value attribute.
		*
		* @param $name
		* @param $options
		* @param string $selected
		* @param string $onchange
		* @param integer $size
		* @param string $class
		**/

		function AddSelectnokey ($name, $options, $selected = '', $onchange = '', $size = 0, $class = 'selectbox') {

			$select['type'] = 'selectnokey';
			$select['name'] = $name;
			$select['options'] = $options;
			$select['selected'] = $selected;
			$select['onchange'] = $onchange;
			$select['size'] = $size;
			$select['class'] = $class;
			$select['id'] = $this->_buildid ('select');
			$this->formular[] = $select;
			unset ($select);

		}

		/**
		* AddFile()
		* Add a input type=file.. tag.
		*
		* @param $name
		* @param string $class
		* @param integer $size
		* @param integer $width
		**/

		function AddFile ($name, $class = 'inputfile', $size = 0, $width = 0) {

			$file['type'] = 'file';
			$file['name'] = $name;
			$file['class'] = $class;
			$file['size'] = $size;
			$file['width'] = $width;
			$file['id'] = $this->_buildid ('file');
			$this->formular[] = $file;
			unset ($file);

		}

		/**
		* AddSubmit()
		* Add a Submitbutton
		*
		* @param $name
		* @param $value
		* @param string $onclick
		* @param string $class
		* @param string $onmouseover
		* @param string $onmouseout
		**/

		function AddSubmit ($name, $value = '', $onclick = '', $class = 'inputbuttons', $onmouseover = "this.className='inputbuttonshover';", $onmouseout = "this.className='inputbuttons';") {

			$submit['type'] = 'submit';
			$submit['name'] = $name;
			$submit['value'] = $value;
			$submit['onclick'] = $onclick;
			$submit['class'] = $class;
			$submit['onmouseover'] = $onmouseover;
			$submit['onmouseout'] = $onmouseout;
			$this->formular[] = $submit;
			unset ($submit);

		}

		/**
		* AddHidden()
		* Add a input type=hidden tag.
		*
		* @param $name
		* @param $value
		**/

		function AddHidden ($name, $value) {

			$hidden['type'] = 'hidden';
			$hidden['name'] = $name;
			$hidden['value'] = $value;
			$this->formular[] = $hidden;
			unset ($hidden);

		}

		/**
		* AddCheckbox()
		* Add a input type=checkbox tag.
		*
		* @param $name
		* @param $value
		* @param integer $checked
		* @param string $onclick
		* @param string $class
		**/

		function AddCheckbox ($name, $value, $checked = 0, $onclick = '', $class = 'checkbuttons') {

			$checkbox['type'] = 'checkbox';
			$checkbox['name'] = $name;
			$checkbox['value'] = $value;
			$checkbox['checked'] = $checked;
			$checkbox['onclick'] = $onclick;
			$checkbox['class'] = $class;
			$checkbox['id'] = $this->_buildid ('checkbox');
			$this->formular[] = $checkbox;
			unset ($checkbox);

		}

		/**
		* AddRadio()
		* Add a input type=radio tag
		*
		* @param $name
		* @param $value
		* @param integer $checked
		* @param string $class
		* @param string $id
		* @param string $onclick
		**/

		function AddRadio ($name, $value, $checked = 0, $class = 'radiobuttons', $id = '', $onclick = '') {

			$radio['type'] = 'radio';
			$radio['name'] = $name;
			$radio['value'] = $value;
			$radio['checked'] = $checked;
			$radio['class'] = $class;
			$radio['onclick'] = $onclick;
			if ($id != '') {
				$radio['id'] = $id;
			} else {
				$radio['id'] = $this->_buildid ('radio');
			}
			$this->formular[] = $radio;
			unset ($radio);

		}

		/**
		* AddShowImage()
		* Add a image.
		*
		* @param $name
		* @param $src
		* @param integer $width
		* @param integer $height
		* @param string $alt
		* @param integer $border
		* @param string $align
		* @param string $class
		**/

		function AddShowImage ($name, $src, $width = 0, $height = 0, $alt = '', $border = '0', $align = '', $class = '') {

			$image['type'] = 'showimage';
			$image['name'] = $name;
			$image['src'] = $src;
			$image['width'] = $width;
			$image['height'] = $height;
			$image['border'] = $border;
			$image['alt'] = $alt;
			$image['align'] = $align;
			$image['class'] = $class;
			$image['id'] = $this->_buildid ('simage');
			$this->formular[] = $image;
			unset ($image);

		}

		/**
		* AddImage()
		* Add a input type=image tag.
		*
		* @param $name
		* @param $value
		* @param $src
		* @param integer $width
		* @param integer $height
		* @param string $alt
		* @param integer $border
		* @param string $align
		* @param string $class
		**/

		function AddImage ($name, $value, $src, $width = 0, $height = 0, $alt = '', $border = '0', $align = '', $class = '') {

			$t = $align;
			$t = $border;
			$t = $height;
			$t = $width;
			$image['type'] = 'image';
			$image['name'] = $name;
			$image['value'] = $value;
			$image['src'] = $src;
			// $image['width']=$width;
			// $image['height']=$height;
			// $image['border']=$border;
			$image['alt'] = $alt;
			// $image['align']=$align;
			$image['class'] = $class;
			$image['id'] = $this->_buildid ('image');
			$this->formular[] = $image;
			unset ($image);

		}

		/**
		* AddButton()
		* Add a input type=button tag.
		*
		* @param $name
		* @param string $value
		* @param string $title
		* @param string $accesskey
		* @param string $onClick
		* @param string $class
		**/

		function AddButton ($name, $value = '', $title = '', $accesskey = '', $onClick = '', $class = 'inputbuttons') {

			$button['type'] = 'button';
			$button['name'] = $name;
			$button['value'] = $value;
			$button['title'] = $title;
			$button['accesskey'] = $accesskey;
			$button['onclick'] = $onClick;
			$button['class'] = $class;
			$this->formular[] = $button;
			unset ($button);

		}

		/**
		* AddImgButton()
		* Add a <button> tag.
		*
		* @param $name
		* @param string $value
		* @param string $title
		* @param string $accesskey
		* @param string $onClick
		* @param string $class
		**/

		function AddImgButton ($name, $value = '', $title = '', $accesskey = '', $onClick = '', $class = 'inputbuttons') {

			$imgbutton['type'] = 'imgbutton';
			$imgbutton['name'] = $name;
			$imgbutton['value'] = $value;
			$imgbutton['title'] = $title;
			$imgbutton['accesskey'] = $accesskey;
			$imgbutton['onclick'] = $onClick;
			$imgbutton['class'] = $class;
			$this->formular[] = $imgbutton;
			unset ($imgbutton);

		}

		/**
		* AddFormEnd()
		* Add a /form tag
		*
		**/

		function AddFormEnd () {

			$end['type'] = 'formend';
			$this->formular[] = $end;
			unset ($end);

		}

		/**
		* AddReset()
		* Add a Resetbutton.
		*
		* @param $name
		* @param string $value
		* @param string $class
		**/

		function AddReset ($name, $value = '', $class = 'inputbuttons') {

			$reset['type'] = 'reset';
			$reset['name'] = $name;
			$reset['value'] = $value;
			$reset['class'] = $class;
			$this->formular[] = $reset;
			unset ($reset);

		}

		/**
		* AddTable()
		*
		*
		* @param integer $width
		* @param string $border
		* @param string $cellspacing
		* @param string $cellpadding
		* @param string $class
		**/

		function AddTable ($width = 0, $border = '', $cellspacing = '', $cellpadding = '', $class = '') {

			$formtag['type'] = 'AddTable';
			$formtag['width'] = $width;
			$formtag['border'] = $border;
			$formtag['cellspacing'] = $cellspacing;
			$formtag['cellpadding'] = $cellpadding;
			$formtag['class'] = $class;
			$this->formular[] = $formtag;
			unset ($formtag);

		}

		/**
		* AddTableEnd()
		*
		*
		**/

		function AddTableEnd () {

			$end['type'] = 'AddTableEnd';
			$this->formular[] = $end;
			unset ($end);

		}

		/**
		* AddTableChangeCell()
		*
		*
		* @param string $class
		* @param integer $width
		* @param integer $colspan
		**/

		function AddTableChangeCell ($class = '', $width = 0, $colspan = 0) {

			$r['type'] = 'AddTableChangeCell';
			$r['class'] = $class;
			$r['width'] = $width;
			$r['colspan'] = $colspan;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableOpenCell()
		*
		*
		* @param string $class
		* @param integer $width
		* @param string $align
		* @param integer $colspan
		**/

		function AddTableOpenCell ($class = '', $width = 0, $align = '', $colspan = 0) {

			$r['type'] = 'AddTableOpenCell';
			$r['class'] = $class;
			$r['width'] = $width;
			$r['align'] = $align;
			$r['colspan'] = $colspan;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableCloseCell()
		*
		*
		**/

		function AddTableCloseCell () {

			$r['type'] = 'AddTableCloseCell';
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableChangeRow()
		*
		*
		* @param string $class
		* @param integer $width
		* @param integer $colspan
		**/

		function AddTableChangeRow ($class = '', $width = 0, $colspan = 0) {

			$r['type'] = 'AddTableChangeRow';
			$r['class'] = $class;
			$r['width'] = $width;
			$r['colspan'] = $colspan;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableOpenRows()
		*
		*
		* @param string $class
		* @param integer $width
		* @param integer $colspan
		**/

		function AddTableOpenRows ($class = '', $width = 0, $colspan = 0) {

			$r['type'] = 'AddTableOpenRows';
			$r['class'] = $class;
			$r['width'] = $width;
			$r['colspan'] = $colspan;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableCloseRows()
		*
		**/

		function AddTableCloseRows () {

			$r['type'] = 'AddTableCloseRows';
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableOpenRow()
		*
		*
		* @param string $class
		**/

		function AddTableOpenRow ($class = '') {

			$r['type'] = 'AddTableOpenRow';
			$r['class'] = $class;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* AddTableCloseRow()
		*
		**/

		function AddTableCloseRow () {

			$r['type'] = 'AddTableCloseRow';
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* OpenJSMenu()
		*
		*
		* @param $name
		**/

		function OpenJSMenu ($name) {

			$r['type'] = 'OpenJSMenu';
			$r['name'] = $name;
			$r['id'] = $this->_buildid ('JSMenu');
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* PointJSMenu()
		*
		*
		* @param $name
		* @param string $alt
		**/

		function PointJSMenu ($name, $alt = '') {

			$r['type'] = 'PointJSMenu';
			$r['name'] = $name;
			$r['alt'] = $alt;
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* CloseJSMenu()
		*
		*
		**/

		function CloseJSMenu () {

			$r['type'] = 'CloseJSMenu';
			$this->formular[] = $r;
			unset ($r);

		}

		/**
		* GetFormular()
		* Generate the needed formtags.
		*
		* @param &$text
		**/

		function GetFormular (&$text) {

			global $opnConfig;
			if ( (!isset ($opnConfig['Form_autocomplete']) ) OR ($opnConfig['Form_autocomplete'] == 0) ) {
				// $Form_autocomplete=' autocomplete="off"';
			} else {
				$Form_autocomplete = ' autocomplete="on"';
			}
			$line = $this->formular;
			$max = count ($line);
			for ($i = 0; $i< $max; $i++) {
				if ( ($line[$i]['type'] != 'textarea') && ($line[$i]['type'] != 'text') ) {
					if ( (isset ($line[$i]['value']) ) && ($line[$i]['value'] != '') ) {
						// $line[$i]['value'] = str_replace('"', "'", $line[$i]['value']);
						$line[$i]['origvalue'] = $line[$i]['value'];
						$line[$i]['value'] = str_replace ('"', '&quot;', $line[$i]['value']);
					}
				}
				switch ($line[$i]['type']) {
					case 'text':
						$text .= $line[$i]['text'] . _OPN_HTML_NL;
						break;
					case 'textfield':
						$txt = '<input type="text" name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						if ($line[$i]['size'] != 0) {
							$txt .= ' size="' . $line[$i]['size'] . '"';
						}
						$txt .= ' class="' . $line[$i]['class'] . '"';
						if ($line[$i]['maxlength'] != 0) {
							$txt .= ' maxlength="' . $line[$i]['maxlength'] . '"';
						}
						if ($line[$i]['value'] != '') {
							$txt .= ' value="' . $line[$i]['value'] . '"';
						}
						if ($line[$i]['readonly'] != 0) {
							$txt .= ' readonly="readonly"';
						}
						if ($line[$i]['onfocus'] != '') {
							$txt .= ' onfocus="' . $line[$i]['onfocus'] . '"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'text', $txt, $line[$i]['class']);
						break;
					case 'reset':
						$text .= '<input type="reset" name="' . $line[$i]['name'] . '"';
						if ($line[$i]['value'] != '') {
							$text .= ' value="' . $line[$i]['value'] . '"';
						}
						$text .= ' class="' . $line[$i]['class'] . '"';
						$text .= ' />' . _OPN_HTML_NL;
						break;
					case 'formend':
						$text .= '</div>' . _OPN_HTML_NL;
						$text .= '</form>' . _OPN_HTML_NL;
						break;
					case 'button':
						$txt = '<input type="button" name="' . $line[$i]['name'] . '" class="' . $line[$i]['class'] . '"';
						if ($line[$i]['value'] != '') {
							$txt .= ' value="' . $line[$i]['value'] . '"';
						}
						if ($line[$i]['title'] != '') {
							$txt .= ' title="' . $line[$i]['title'] . '"';
						}
						if ($line[$i]['accesskey'] != '') {
							$txt .= ' accesskey="' . $line[$i]['accesskey'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'button', $txt, $line[$i]['class']);
						break;
					case 'imgbutton':
						$txt = '<button type="button" name="' . $line[$i]['name'] . '" class="' . $line[$i]['class'] . '"';
						if ($line[$i]['title'] != '') {
							$txt .= ' title="' . $line[$i]['title'] . '"';
						}
						if ($line[$i]['accesskey'] != '') {
							$txt .= ' accesskey="' . $line[$i]['accesskey'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						$txt .= '>' . _OPN_HTML_NL;
						if ($line[$i]['origvalue'] != '') {
							$txt .= $line[$i]['origvalue'];
						}
						$txt .= '</button>';
						$text .= showhelp ($line[$i]['name'], 'button', $txt, $line[$i]['class']);
						break;
					case 'image':
						$text .= '<input type="image" name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						$text .= ' src="' . $line[$i]['src'] . '"';
						// if ($line[$i]['height'] !=0) {$text.=' height="'.$line[$i]['height'].'"';}
						// if ($line[$i]['width'] !=0) {$text.=' width="'.$line[$i]['width'].'"';}
						if ($line[$i]['alt'] != '') {
							$text .= ' title="' . $line[$i]['alt'] . '"';
						}
						if ($line[$i]['alt'] != '') {
							$text .= ' alt="' . $line[$i]['alt'] . '"';
						}
						// if ($line[$i]['border'] !='') {$text.=' border="'.$line[$i]['border'].'"';}
						// if ($line[$i]['align']!='') {$text.=' align="'.$line[$i]['align'].'"';}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= ' />' . _OPN_HTML_NL;
						break;
					case 'radio':
						$txt = '<input type="radio" name="' . $line[$i]['name'];
						$txt .= '" id="' . $line[$i]['id'] . '"';
						$txt .= ' value="' . $line[$i]['value'] . '"';
						if ($line[$i]['class'] != '') {
							$txt .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						if ($line[$i]['checked'] != 0) {
							$txt .= ' checked="checked"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'radio', $txt, $line[$i]['class']);
						break;
					case 'checkbox':
						$txt = '<input type="checkbox" name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						$txt .= ' value="' . $line[$i]['value'] . '"';
						if ($line[$i]['class'] != '') {
							$txt .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						if ($line[$i]['checked'] != 0) {
							$txt .= ' checked="checked"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'checkbox', $txt, $line[$i]['class']);
						break;
					case 'hidden':
						$text .= '<input type="hidden" name="' . $line[$i]['name'] . '"';
						$text .= ' value="' . $line[$i]['value'] . '" />' . _OPN_HTML_NL;
						break;
					case 'submit':
						$txt = '<input type="submit" name="' . $line[$i]['name'] . '"';
						if ($line[$i]['value'] != '') {
							$txt .= ' value="' . $line[$i]['value'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						$txt .= ' class="' . $line[$i]['class'] . '" ';
						$txt .= ' onmouseover="' . $line[$i]['onmouseover'] . '" ';
						$txt .= ' onmouseout="' . $line[$i]['onmouseout'] . '" />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'submit', $txt, $line[$i]['class']);
						break;
					case 'file':
						$txt = '<input type="file" name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						$txt .= ' class="' . $line[$i]['class'] . '"';
						if ($line[$i]['size'] != 0) {
							$txt .= ' size="' . $line[$i]['size'] . '"';
						}
						if ($line[$i]['width'] != 0) {
							$txt .= ' width="' . $line[$i]['width'] . '"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'file', $txt, $line[$i]['class']);
						break;
					case 'select':
						$txt = '<select name="' . $line[$i]['name'] . '" class="' . $line[$i]['class'] . '" id="' . $line[$i]['id'] . '"';
						if ($line[$i]['size'] != 0) {
							$txt .= ' size="' . $line[$i]['size'] . '"';
						}
						if ($line[$i]['onchange'] != '') {
							$txt .= ' onchange="' . $line[$i]['onchange'] . '"';
						}
						if ($line[$i]['multiple'] != 0) {
							$txt .= ' multiple="multiple"';
						}
						$txt .= '>';
						foreach ($line[$i]['options'] as $key => $opttext) {
							$sel = '';
							if ($line[$i]['compname'] != 0) {
								if ($opttext == $line[$i]['selected']) {
									$sel = ' selected="selected"';
								}
							} else {
								if ($key == $line[$i]['selected']) {
									$sel = ' selected="selected"';
								}
							}
							$txt .= '<option';
							$txt .= ' value="' . $key . '"' . $sel . '>' . $opttext . '</option>' . _OPN_HTML_NL;
						}
						$txt .= '</select>' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'select', $txt, $line[$i]['class']);
						break;
					case 'selectspecial':
						$txt = '<select name="' . $line[$i]['name'] . '" class="' . $line[$i]['class'] . '" id="' . $line[$i]['id'] . '"';
						if ($line[$i]['size'] != 0) {
							$txt .= ' size="' . $line[$i]['size'] . '"';
						}
						if ($line[$i]['onchange'] != '') {
							$txt .= ' onchange="' . $line[$i]['onchange'] . '"';
						}
						$txt .= '>';
						foreach ($line[$i]['options'] as $option) {
							if ($option['key'] == $line[$i]['selected']) {
								$sel = ' selected="selected"';
							} else {
								$sel = '';
							}
							$txt .= '<option value="' . $option['key'] . '"' . $sel . '>' . $option['text'] . '</option>' . _OPN_HTML_NL;
						}
						$txt .= '</select>' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'selectspecial', $txt, $line[$i]['class']);
						break;
					case 'selectnokey':
						$txt = '<select name="' . $line[$i]['name'] . '" class="' . $line[$i]['class'] . '" id="' . $line[$i]['id'] . '"';
						if ($line[$i]['size'] != 0) {
							$txt .= ' size="' . $line[$i]['size'] . '"';
						}
						if ($line[$i]['onchange'] != '') {
							$txt .= ' onchange="' . $line[$i]['onchange'] . '"';
						}
						$txt .= '>';
						foreach ($line[$i]['options'] as $opttext) {
							if ($opttext == $line[$i]['selected']) {
								$sel = ' selected="selected"';
							} else {
								$sel = '';
							}
							$txt .= '<option' . $sel . '>' . $opttext . '</option>' . _OPN_HTML_NL;
						}
						$txt .= '</select>' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'selectnokey', $txt, $line[$i]['class']);
						break;
					case 'textarea':
						$txt = '<textarea name="' . $line[$i]['name'] . '" cols="' . $line[$i]['cols'] . '" id="' . $line[$i]['id'] . '"';
						$txt .= ' rows="' . $line[$i]['rows'] . '" class="' . $line[$i]['class'] . '"';
						if ($line[$i]['wrap'] != '') {
							$txt .= ' wrap="' . $line[$i]['wrap'] . '"';
						}
						if ($line[$i]['onselect'] != '') {
							$txt .= ' onselect="' . $line[$i]['onselect'] . '"';
						}
						if ($line[$i]['onclick'] != '') {
							$txt .= ' onclick="' . $line[$i]['onclick'] . '"';
						}
						if ($line[$i]['onkeyup'] != '') {
							$txt .= ' onkeyup="' . $line[$i]['onkeyup'] . '"';
						}
						if ($line[$i]['readonly'] != 0) {
							$txt .= ' readonly="readonly"';
						}
						$txt .= '>';
						if ($line[$i]['value'] != '') {
							$txt .= $line[$i]['value'];
						}
						$txt .= '</textarea>' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'textarea', $txt, $line[$i]['class']);
						break;
					case 'password':
						$txt = '<input type="password" name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						$txt .= ' size="' . $line[$i]['size'] . '"';
						$txt .= ' class="' . $line[$i]['class'] . '"';
						if ($line[$i]['maxlength'] != 0) {
							$txt .= ' maxlength="' . $line[$i]['maxlength'] . '"';
						}
						if ($line[$i]['value'] != '') {
							$txt .= ' value="' . $line[$i]['value'] . '"';
						}
						if ($line[$i]['onfocus'] != '') {
							$txt .= ' onfocus="' . $line[$i]['onfocus'] . '"';
						}
						$txt .= ' />' . _OPN_HTML_NL;
						$text .= showhelp ($line[$i]['name'], 'password', $txt, $line[$i]['class']);
						break;
					case 'label':
						if ($line[$i]['after']) {
							$idnum = $i-1;
							if ( ($line[$idnum]['type'] == 'newline') || ($line[$idnum]['type'] == 'text') ) {
								$idnum--;
							}
						} else {
							$idnum = $i+1;
							for ($idnum = $i+1; ( ($idnum< $max) AND (!isset ($line[$idnum]['id']) ) ); $idnum++) {
							}
							// if (($line[$idnum]['type']=='newline') || ($line[$idnum]['type']=='text')) {$idnum++;}
						}
						$text .= '<label for="' . $line[$idnum]['id'] . '">' . $line[$i]['text'] . '</label>' . _OPN_HTML_NL;
						break;
					case 'newline':
						for ($j = 0, $max1 = $line[$i]['count']; $j< $max1; $j++) {
							$text .= '<br />' . _OPN_HTML_NL;
						}
						break;
					case 'showimage':
						$text .= '<img name="' . $line[$i]['name'] . '" id="' . $line[$i]['id'] . '"';
						$text .= ' src="' . $line[$i]['src'] . '"';
						if ($line[$i]['height'] != 0) {
							$text .= ' height="' . $line[$i]['height'] . '"';
						}
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						$text .= ' title="' . $line[$i]['alt'] . '"';
						$text .= ' alt="' . $line[$i]['alt'] . '"';
						if ($line[$i]['border'] != '') {
							$text .= ' border="' . $line[$i]['border'] . '"';
						}
						if ($line[$i]['align'] != '') {
							$text .= ' align="' . $line[$i]['align'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= ' />' . _OPN_HTML_NL;
						break;
					case 'OpenTable':
						OpenTable ($text);
						// .=$line[$i]['text']._OPN_HTML_NL;
						break;
					case 'CloseTable':
						CloseTable ($text);
						// .=$line[$i]['text']._OPN_HTML_NL;
						break;
					case 'formtag2':
						$text .= '<form name="' . $line[$i]['name'] . '" action="" class="form"';
						if (isset ($Form_autocomplete) ) {
							$text .= $Form_autocomplete;
						}
						$text .= '>' . _OPN_HTML_NL;
						$text .= '<div class="nobreakinform">' . _OPN_HTML_NL;
						break;
					case 'formtag':
						$text .= '<form action="' . $line[$i]['action'] . '"';
						$text .= ' method="' . $line[$i]['method'] . '"';
						if ($line[$i]['name'] != '') {
							$text .= ' name="' . $line[$i]['name'] . '"';
						}
						if ($line[$i]['enctype'] != '') {
							$text .= ' enctype="' . $line[$i]['enctype'] . '"';
						}
						if ($line[$i]['onsubmit'] != '') {
							$text .= ' onsubmit="' . $line[$i]['onsubmit'] . '"';
						}
						if ($line[$i]['target'] != '') {
							$text .= ' target="' . $line[$i]['target'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						if (isset ($Form_autocomplete) ) {
							$text .= $Form_autocomplete;
						}
						$text .= '>' . _OPN_HTML_NL;
						$text .= '<div class="nobreakinform">' . _OPN_HTML_NL;
						break;
					case 'AddTable':
						$text .= '<table';
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						if ($line[$i]['border'] != '') {
							$text .= ' border="' . $line[$i]['border'] . '"';
						}
						if ($line[$i]['cellspacing'] != '') {
							$text .= ' cellspacing="' . $line[$i]['cellspacing'] . '"';
						}
						if ($line[$i]['cellpadding'] != '') {
							$text .= ' cellpadding="' . $line[$i]['cellpadding'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableEnd':
						$text .= '</table>' . _OPN_HTML_NL;
						break;
					case 'AddTableChangeCell':
						$text .= '</td><td';
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['colspan'] != '') {
							$text .= ' colspan="' . $line[$i]['colspan'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableOpenCell':
						$text .= '<td';
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['align'] != '') {
							$text .= ' align="' . $line[$i]['align'] . '"';
						}
						if ($line[$i]['colspan'] != '') {
							$text .= ' colspan="' . $line[$i]['colspan'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableCloseCell':
						$text .= '</td>' . _OPN_HTML_NL;
						break;
					case 'AddTableChangeRow':
						$text .= '</td></tr><tr';
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= '><td';
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['colspan'] != '') {
							$text .= ' colspan="' . $line[$i]['colspan'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableOpenRows':
						$text .= '<tr';
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= '><td';
						if ($line[$i]['width'] != 0) {
							$text .= ' width="' . $line[$i]['width'] . '"';
						}
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						if ($line[$i]['colspan'] != '') {
							$text .= ' colspan="' . $line[$i]['colspan'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableCloseRows':
						$text .= '</td></tr>' . _OPN_HTML_NL;
						break;
					case 'AddTableOpenRow':
						$text .= '<tr';
						if ($line[$i]['class'] != '') {
							$text .= ' class="' . $line[$i]['class'] . '"';
						}
						$text .= '>' . _OPN_HTML_NL;
						break;
					case 'AddTableCloseRow':
						$text .= '</tr>' . _OPN_HTML_NL;
						break;
					case 'OpenJSMenu':
						$text .= '';
						$text .= '<a href="javascript:toggle_opnmenu(\'' . $line[$i]['id'] . '\',\'' . $opnConfig['opn_url'] . '/themes/opn_themes_include/\');"><img id="' . $line[$i]['id'] . '_sign" name="' . $line[$i]['id'] . '_sign" src="' . $opnConfig['opn_url'] . '/themes/opn_themes_include/images/menu/minus.gif" height="9" width="9" align="middle" class="imgtag" alt="" /></a> ';
						$text .= "<img id='" . $line[$i]['id'] . "_folder' name='" . $line[$i]['id'] . "_folder' src='" . $opnConfig['opn_url'] . "/themes/opn_themes_include/images/menu/tree_open.gif' alt='' /> " . $line[$i]['name'];
						$text .= '<span id="' . $line[$i]['id'] . '_sub" style="display:inline;">';
						break;
					case 'PointJSMenu':
						$text .= '<br /> <img src="' . $opnConfig['opn_url'] . '/themes/opn_themes_include/images/menu/d_tree_content.gif" alt="' . $line[$i]['alt'] . '" /> ' . $line[$i]['name'];
						break;
					case 'CloseJSMenu':
						$text .= '<br /></span>' . _OPN_HTML_NL;
						break;
				}
				// switch
			}

		}

	}

	/**
	* _buildid()
	*
	*
	* @param $prefix
	*
	* @return string
	**/

	function _buildid ($prefix) {

		mt_srand ((double)microtime ()*1000000);
		$idsuffix = mt_rand ();
		return $prefix . '-id-' . $idsuffix;

	}
}

?>