<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* based on
*  PHP FTP Client Class By TOMO ( groove@spencernetwork.org )
*  Version 0.13 (2002/06/19)
*/
if (!defined ('_OPN_CLASS_EMUL_FTP_INCLUDED') ) {
	if (!defined ('FTP_BINARY') ) {
		define ('FTP_BINARY', 1);
	}
	if (!defined ('FTP_ASCII') ) {
		define ('FTP_ASCII', 0);
	}
	define ('_OPN_CLASS_EMUL_FTP_INCLUDED', 1);

	class opn_ftp {

		/*<{php4}>
		var $timeout; // fsockopen() time-out
		var $pw;
		var $host;
		var $port;
		var $cwd;
		var $pasv;
		var $user;

		// Private variables
		var $_sock;
		var $_datasock;
		var $_resp;
		var $_buf;
		var $_ip_port;
		var $FTP_MODE = FTP_BINARY; // FTP_ASCII (0) or FTP_BINARY (1)
		<{php4/}>*/

		/*<{php5}>
		public $timeout; // fsockopen() time-out
		public $pw;
		public $host;
		public $port;
		public $cwd;
		public $pasv;
		public $user;

		// Private variables
		public $_sock;
		public $_datasock;
		public $_resp;
		public $_buf;
		public $_ip_port;
		public $FTP_MODE = FTP_BINARY; // FTP_ASCII (0) or FTP_BINARY (1)
		<{php5/}>*/

		/*<{delete}>*/
		var $timeout; // fsockopen() time-out
		var $pw;
		var $host;
		var $port;
		var $cwd;
		var $pasv;
		var $user;

		// Private variables
		var $_sock;
		var $_datasock;
		var $_resp;
		var $_buf;
		var $_ip_port;
		var $FTP_MODE = FTP_BINARY; // FTP_ASCII (0) or FTP_BINARY (1)
		/*<{delete/}>*/

		/* constructor */

		function opn_ftp (&$error, $ftpmode = 1, $timeout = 30) {

			global $opnConfig;

			$this->timeout = $timeout;
			$this->FTP_MODE = $ftpmode;
			if (!defined ('FTP_BINARY') ) {
				define ('FTP_BINARY', 1);
			}
			if (!defined ('FTP_ASCII') ) {
				define ('FTP_ASCII', 0);
			}
			$this->_sock = false;
			$this->_resp = '';
			$this->_buf = 4096;
			$this->host = $opnConfig['opn_ftphost'];
			$this->user = $opnConfig['opn_ftpusername'];
			$this->pw = open_the_secret (md5 ($opnConfig['encoder']), $opnConfig['opn_ftppassword']);
			$this->port = $opnConfig['opn_ftpport'];
			$this->pasv = $opnConfig['opn_ftppasv'];
			$myerror = '';
			$this->connectftpemul ($myerror);
			if ($myerror == '') {
				$this->cwd = $this->ftp_pwd ($myerror);
			}
			$error = $myerror;

		}

		function connectftpemul (&$error) {

			$errno = '';
			$errstr = '';
			$this->_sock = @fsockopen ($this->host, $this->port, $errno, $errstr, $this->timeout);
			if (!$this->_sock || !$this->_ok () ) {
				$error .= 'Error: Cannot connect to remote host ' . $this->host . ':' . $this->port . '<br />';
				$error .= 'Error: fsockopen() ' . $errstr . ' (' . $errno . ')<br />';
			} else {
				if ($this->login ($error) ) {
					$this->pasv ($error);
					return;
				}
				$error .= 'User ' . $this->user . ' cannot login to host ' . $this->host . '<br />';
			}

		}

		function login (&$error) {

			$this->_putcmd ('USER', $this->user);
			if (!$this->_ok () ) {
				$error .= 'Error: USER command failed<br />';
				return false;
			}
			$this->_putcmd ('PASS', $this->pw);
			if (!$this->_ok () ) {
				$error .= 'Error: PASS command failed<br />';
				return false;
			}
			return true;

		}

		function pasv (&$error) {

			$this->_putcmd ('PASV');
			if (!$this->_ok () ) {
				$error .= 'Error: PASV command failed';
			}
			$this->_ip_port = preg_replace ("/^.+ \\(?([0-9]{1,3},[0-9]{1,3},[0-9]{1,3},[0-9]{1,3},[0-9]+,[0-9]+)\\)?.*\r\n$/", "\\1", $this->_resp);

		}

		function ftp_pwd (&$error) {

			$this->_putcmd ('PWD');
			if (!$this->_ok () ) {
				$error .= 'Error: PWD command failed<br />';
				return '';
			}
			return preg_replace ("/^[0-9]{3} \"(.+)\" .+\r\n/", "\\1", $this->_resp);

		}

		function cd (&$error, $pathname) {
			if (substr_count ($pathname, '/')>0) {
				$d = explode ('/', $pathname);
				$max = count ($d);
				for ($i = 0; $i< $max; $i++) {
					if (trim ($d[$i]) != '') {
						$this->_putcmd ('CWD', $d[$i]);
					}
				}
			} else {
				$this->_putcmd ('CWD', $pathname);
			}
			if (!$this->_ok () ) {
				$error .= 'Error: CWD command failed (' . $this->_resp . ')<br />';
			}

		}

		function cd_up (&$error) {

			$this->_putcmd ('CDUP', '');
			if (!$this->_ok () ) {
				$error .= 'Error CDUP command failed<br />';
			}

		}

		function mk_dir (&$error, $pathname) {

			$this->_putcmd ('MKD', $pathname);
			if (!$this->_ok () ) {
				$error .= 'Error: MKD command failed (' . $this->_resp . ')<br />';
			}

		}

		function rm_dir (&$error, $pathname) {

			$this->_putcmd ('RMD', $pathname);
			if (!$this->_ok () ) {
				$error .= 'Error: RMD command failed (' . $this->_resp . ')<br />';
			}

		}

		function ch_mod (&$error, $obj, $num) {

			$chmod_cmd = 'CHMOD ' . $num . ' ' . $obj;
			$success = $this->site ($error, $chmod_cmd);
			if (!$success) {
				$error .= 'Error: CHMOD command failed<br />';
			}

		}

		function site (&$error, $command) {

			$this->_putcmd ('SITE', $command);
			if (!$this->_ok () ) {
				$error .= 'Error: SITE command failed (' . $this->_resp . ')<br />';
				return false;
			}
			return true;

		}

		function upload_file (&$error, $filename, $source) {
			// function ftp_put($remotefile, $localfile, $mode = 1) {
			if (!@file_exists ($source) ) {
				$error .= 'Error : No such file or directory ' . $source . '<br />';
				$error .= 'Error : PUT command failed<br />';
				return false;
			}
			$fp = @fopen ($source, "rb");
			if (!$fp) {
				$error .= 'Error : Cannot read file ' . $source . '<br />';
				$error .= 'Error : PUT command failed<br />';
				return false;
			}
			$this->_type ($error, $this->FTP_MODE);
			if ($error != '') {
				$error .= 'Error : PUT command failed. Mode set<br />';
				return false;
			}
			$this->_putcmd ("STOR", $filename);
			$this->_ftp_open_data_connection ($error);
			if ($error != '') {
				return true;
			}
			while (!feof ($fp) ) {
				fwrite ($this->_datasock, fread ($fp, $this->_buf) );
			}
			fclose ($fp);
			$this->_ftp_close_data_connection ();
			if (!$this->_ok () ) {
				$error .= 'Error : PUT command failed<br />';
				return false;
			}
			return true;

		}

		function close (&$error) {

			$this->_putcmd ('QUIT');
			if (!$this->_ok () || !fclose ($this->_sock) ) {
				$error .= 'Error: QUIT command failed<br />';
			}

		}

		function make_ftpdir ($dirname, &$ftpdir) {

			global $opnConfig;

			$help = str_replace (_OPN_ROOT_PATH, '', $dirname);
			$help = explode ('/', $help);

			#			$newdir = $help[count($help)-1];

			$ftpdir = $opnConfig['opn_ftpdir'];
			for ($i = 0, $max = count ($help)-1; $i< $max; $i++) {
				$ftpdir .= '/' . $help[$i];
			}

		}

		function copy_file (&$error, $source, $dest, $num = '') {

			$dirname = dirname ($dest) . '/';
			$filename = basename ($dest);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->upload_file ($error, $filename, $source);
			if ($num != '') {
				$this->ch_mod ($error, $filename, $num);
			}
			usleep (2);

		}

		function rename_file (&$error, $source, $dest, $num = '') {

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$dest = basename ($dest);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->_putcmd ('RNFR', $filename);
			if (!$this->_ok ()) {
				$error .= 'Can not rename file ' . $source . '<br />';
			} else {
				$this->_putcmd ('RNTO', $dest);
				if (!$this->_ok ()) {
					$error .= 'Can not rename file ' . $source . '<br />';
				} else {
					if ($num != '') {
						$this->ch_mod ($error, $dest, $num);
					}
				}
			}
			usleep (2);
		}

		function move_file (&$error, $source, $dest, $num = '') {

			global $opnConfig;

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$dest = str_replace($opnConfig['root_path_datasave'], '../', $dest);
			$this->cd ($error, $basedir);
			$this->_putcmd ('RNFR', $filename);
			if (!$this->_ok ()) {
				$error .= 'Can not rename file ' . $source . '<br />';
			} else {
				$this->_putcmd ('RNTO', $dest);
				if (!$this->_ok ()) {
					$error .= 'Can not rename file ' . $source . '<br />';
				} else {
					if ($num != '') {
						$this->ch_mod ($error, $dest, $num);
					}
				}
			}
			usleep (2);
		}

		function delete_file (&$error, $source) {

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->_putcmd ("DELE", $filename);
			if (!$this->_ok () ) {
				$error .= 'Can not delete file ' . $source . '<br />';
			}

		}

		function chmod (&$error, $obj, $num) {

			$dirname = dirname ($obj) . '/';
			$filename = basename ($obj);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->ch_mod ($error, $filename, $num);

		}

		/* Private Functions */

		function _putcmd ($cmd, $arg = '') {
			if ($arg != '') {
				$cmd = $cmd . ' ' . $arg;
			}
			fwrite ($this->_sock, $cmd . "\r\n");

		}

		function _type (&$error, $mode) {
			if ($mode) {
				$type = "I";
				// Binary mode
			} else {
				$type = "A";
				// ASCII mode
			}
			$this->_putcmd ("TYPE", $type);
			if (!$this->_ok () ) {
				$error .= 'Error : TYPE command failed<br />';
			}

		}

		function _ok () {

			$this->_resp = '';
			do {
				$res = fgets ($this->_sock, 512);
				$this->_resp .= $res;
			}
			while (substr ($res, 3, 1) != ' ');
			if (!ereg ('^[123]', $this->_resp) ) {
				return false;
			}
			return true;

		}

		function _ftp_close_data_connection () {
			return fclose ($this->_datasock);

		}

		function _ftp_open_data_connection (&$error) {
			if (!ereg ("[0-9]{1,3},[0-9]{1,3},[0-9]{1,3},[0-9]{1,3},[0-9]+,[0-9]+", $this->_ip_port) ) {
				$error .= 'Error : Illegal ip-port format(' . $this->_ip_port . ')<br />';
				return false;
			}
			$DATA = explode (",", $this->_ip_port);
			$ipaddr = $DATA[0] . "." . $DATA[1] . "." . $DATA[2] . "." . $DATA[3];
			$port = $DATA[4]*256+ $DATA[5];
			$errno = '';
			$errstr = '';
			$this->_datasock = @fsockopen ($ipaddr, $port, $errno, $errstr);
			if (!$this->_datasock) {
				$error .= 'Error : Cannot open data connection to ' . $ipaddr . ':' . $port . '<br/ >';
				$error .= 'Error : ' . $errstr . ' (' . $errno . ')<br />';
				return false;
			}
			return true;

		}

	}
}

?>