<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_MEMBERLIST_INCLUDED') ) {
	define ('_OPN_CLASS_MEMBERLIST_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'include/module.usermemberlist.php');
	getLanguageDef (_OPN_ROOT_PATH . 'language/opn_memberlist_class/language/');

	class opn_Memberlist {

		/*<{php4}>
		var $letter='';
		var $sortby='';
		var $sortfield='';
		var $sortorder='';
		var $query='';
		var $displaynames=array();
		var $sortnames=array();
		var $search='';
		var $nrows=0;
		var $offset=0;
		var $IsAdmin=false;
		<{php4/}>*/

		/*<{php5}>
		public $letter='';
		public $sortby='';
		public $sortfield='';
		public $sortorder='';
		public $query='';
		public $displaynames=array();
		public $sortnames=array();
		public $search='';
		public $nrows=0;
		public $offset=0;
		public $IsAdmin=false;
		<{php5/}>*/

		/*<{delete}>*/
		var $letter='';
		var $sortby='';
		var $sortfield='';
		var $sortorder='';
		var $query='';
		var $displaynames=array();
		var $sortnames=array();
		var $search='';
		var $nrows=0;
		var $offset=0;
		var $IsAdmin=false;
		/*<{delete/}>*/

		function Init () {

			$this->GetDisplaynames ();
			$this->SetSortfield (' ORDER BY u.uname ASC');

		}

		function GetDisplaynames () {

			global $opnConfig;

			$this->displaynames[0] = _ML_NICKNAME;
			$this->sortnames[0] = 'u.uname';
			$plug = array();
			$opnConfig['installedPlugins']->getplugin ($plug, 'userindex');
			foreach ($plug as $var) {
				$searchPath = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/user';
				getLanguageDef ($searchPath . '/language/');
				include_once ($searchPath . '/index.php');
				$myfunc = $var['module'] . '_user_dat_api';
				if (function_exists ($myfunc) ) {
					$option = array ();
					$option['op'] = 'memberlist';
					$option['uid'] = 1;
					$option['data'] = '';
					$option['content'] = '';
					$option['addon_info'] = array ();
					$option['fielddescriptions'] = '';
					$option['fieldtypes'] = '';
					$option['tags'] = array ();
					$myfunc ($option);
					$result = $option['fielddescriptions'];
					if (!empty ($result) ) {
						$j = 0;
						$max = count ($result);
						for ($i = 0; $i< $max; $j++) {
							$tags[] = $result[$i];
							$tags1[] = $result[$i+1];
							$i = $i+2;
						}
						$tags = array_merge ($this->displaynames, $tags);
						$tags1 = array_merge ($this->sortnames, $tags1);
						$this->displaynames = $tags;
						$this->sortnames = $tags1;
						unset ($tags);
						unset ($tags1);
					}
				}
			}

		}

		function SetSortfield ($value) {
			if ($value != $this->sortby) {
				$this->sortfield = $value;
				$this->sortby = $value;
			}

		}

		function SetQuery ($value) {

			$this->query = $value;

		}

		function SetSearch ($value) {

			$this->search = $value;

		}

		function SetLimit ($nrows, $offset) {

			$this->nrows = $nrows;
			$this->offset = $offset;

		}

		function GetTotalUsers () {

			global $opnConfig;

			$sql = 'SELECT COUNT(u.uid) AS total';
			$sql .= $this->buildtables (1);
			$sql .= $this->buildwhere (1);
			$result = &$opnConfig['database']->Execute ($sql);
			if (isset ($result->fields['total']) ) {
				$counter = $result->fields['total'];
			} else {
				$counter = 0;
			}
			$result->Close ();
			return $counter;

		}

		function GetLimitedUsers () {

			global $opnConfig;

			$sql = 'SELECT u.uid AS uid';
			$sql .= $this->buildtables (1);
			$sql .= $this->buildwhere (1);
			$result = &$opnConfig['database']->SelectLimit ($sql, $this->nrows, $this->offset);
			$counter = $result->RecordCount ();
			$result->Close ();
			return $counter;

		}

		function getLastRegisterUser () {

			global $opnConfig;

			$sql = 'SELECT u.uname AS uname';
			if ($this->search != '') {
				$sql .= $this->buildtables (1);
				$sql .= $this->buildwhere (1);
			} else {
				$sql .= $this->buildtables (0);
				$sql .= $this->buildwhere (0);
			}
			$sql .= ' ORDER BY u.uid desc';
			$result = &$opnConfig['database']->SelectLimit ($sql, 1, 0);
			$name = $result->fields['uname'];
			$result->Close ();
			return $name;

		}

		function getExtendedInfo ($usernr) {

			global $opnConfig;

			$plug = array();
			$opnConfig['installedPlugins']->getplugin ($plug, 'userindex');
			$fields = array ();
			foreach ($plug as $var) {
				$searchPath = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/user';
				getLanguageDef ($searchPath . '/language/');
				include_once ($searchPath . '/index.php');
				$myfunc = $var['module'] . '_user_dat_api';
				if (function_exists ($myfunc) ) {
					$option = array ();
					$option['op'] = 'memberlist';
					$option['uid'] = $usernr;
					$option['data'] = '';
					$option['content'] = '';
					$option['addon_info'] = array ();
					$option['fielddescriptions'] = '';
					$option['fieldtypes'] = '';
					$option['tags'] = array ();
					$myfunc ($option);
					$types = $option['fieldtypes'];
					$tags = $option['tags'];
					$result = $option['addon_info'];
					if (!empty ($result) ) {
						$i = 0;
						foreach ($result as $value) {
							$fields[] = formatValue ($types[$i], $tags[$i], $value);
							$i++;
						}
						unset ($tags);
						unset ($types);
					}
				}
			}
			return $fields;

		}

		function GetDisplayvals (&$fields) {

			global $opnConfig;

			$sql = 'select';
			$sql .= $this->buildfields ();
			$sql .= $this->buildtables (1);
			$sql .= $this->buildwhere (1);
			$sql .= $this->buildorder ();
			$result = &$opnConfig['database']->SelectLimit ($sql, $this->nrows, $this->offset);
			while (! $result->EOF) {
				$uid = $result->fields['uid'];
				$uname = $result->fields['uname'];
				$fields[][0] = $uname;
				$c = count ($fields)-1;
				$fields[$c] = array_merge ($fields[$c], $this->getExtendedInfo ($uid) );
				$result->MoveNext ();
			}
			$result->Close ();
			return $fields;

		}

		function GetTotal () {

			global $opnConfig;

			$sql = 'SELECT COUNT(u.uid) AS total';
			$sql .= $this->buildtables (0);
			$sql .= $this->buildwhere (0);
			$result = &$opnConfig['database']->Execute ($sql);
			$counter = $result->fields['total'];
			$result->Close ();
			return $counter;

		}

		function buildwhere ($full = 1) {

			global $opnConfig;

			$hlp = ' WHERE ((us.level1<>0) AND (u.uid<>' . $opnConfig['opn_anonymous_id'] . ')';
			if ($full == 1) {
				if ($this->query != '') {
					if ($this->query == 'NUMBER') {
						$alpha = array ('A',
								'B',
								'C',
								'D',
								'E',
								'F',
								'G',
								'H',
								'I',
								'J',
								'K',
								'L',
								'M',
								'N',
								'O',
								'P',
								'Q',
								'R',
								'S',
								'T',
								'U',
								'V',
								'W',
								'X',
								'Y',
								'Z');
						$hlp .= ' AND NOT (';
						foreach ($alpha as $letter) {
							$hlp .= "(u.uname LIKE '$letter%') OR ";
						}
						$hlp = substr ($hlp, 0, (strlen ($hlp)-4) );
						$hlp .= ')';
					} else {
						$like_search = $opnConfig['opnSQL']->AddLike ($this->query, '', '%');
						$hlp .= ' AND (u.uname LIKE ' . $like_search . ')';
					}
				} elseif ($this->search != '') {
					$plug = array();
					$opnConfig['installedPlugins']->getplugin ($plug, 'userindex');
					$like_search = $opnConfig['opnSQL']->AddLike ($this->search);
					$hlp .= ' AND ((u.uname LIKE ' . $like_search . ')';
					if ($this->IsAdmin) {
						$hlp .= ' OR (u.email LIKE ' . $like_search . ')';
					}
					foreach ($plug as $var) {
						$searchPath = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/user';
						getLanguageDef ($searchPath . '/language/');
						include_once ($searchPath . '/index.php');
						$myfunc = $var['module'] . '_user_dat_api';
						if (function_exists ($myfunc) ) {
							$option = array ();
							$option['op'] = 'get_search';
							$option['uid'] = 1;
							$option['data'] = '';
							$option['content'] = '';
							$option['search'] = $this->search;
							$myfunc ($option);
							$sql_search = $option['data'];
							if ($sql_search != '') {
								$hlp .= ' OR ' . $sql_search;
							}
						}
					}
					$hlp .= ')';
				}
			}
			$hlp .= ')';
			return $hlp;

		}

		function buildtables ($full = 1) {

			global $opnConfig, $opnTables;

			$hlp = ' FROM ' . $opnTables['users'] . ' u LEFT JOIN ' . $opnTables['users_status'] . ' us ON us.uid=u.uid';
			if ($full == 1) {
				$plug = array();
				$opnConfig['installedPlugins']->getplugin ($plug, 'userindex');
				foreach ($plug as $var) {
					$searchPath = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/user';
					getLanguageDef ($searchPath . '/language/');
					include_once ($searchPath . '/index.php');
					$myFunc = $var['module'] . '_get_tables';
					if (function_exists ($myFunc) ) {
						$hlp .= $myFunc ();
					}
				}
			}
			return $hlp;

		}

		function buildfields () {

			$hlp = ' u.uid as uid, u.uname as uname';
			return $hlp;

		}

		function buildorder () {
			return $this->sortfield;

		}

	}
}

?>