<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* some parts taken from class.csv.php from Waldemar Derr mail@onanyzer.net */
if (!defined ('_OPN_CSV_INCLUDE') ) {
	define ('_OPN_CSV_INCLUDE', 1);
	getLanguageDef (_OPN_ROOT_PATH . 'language/opn_csv_class/language/');

	class opn_csv {

		/*<{php4}>
		var $_browser = '';
		var $_crlf = '';
		var $_mimetype = '';
		var $_csvstring = '';

		var $CSVFile;
		var $CSVData;
		var $CSVError;
		var $FieldNames;
		var $Fields;
		var $FieldTypes;
		var $fetchCursor;
		var $FieldDelim;
		<{php4/}>*/

		/*<{php5}>
		public $_browser = '';
		public $_crlf = '';
		public $_mimetype = '';
		public $_csvstring = '';

		public $CSVFile;
		public $CSVData;
		public $CSVError;
		public $FieldNames;
		public $Fields;
		public $FieldTypes;
		public $fetchCursor;
		public $FieldDelim;
		<{php5/}>*/

		/*<{delete}>*/
		var $_browser = '';
		var $_crlf = '';
		var $_mimetype = '';
		var $_csvstring = '';

		var $CSVFile;
		var $CSVData;
		var $CSVError;
		var $FieldNames;
		var $Fields;
		var $FieldTypes;
		var $fetchCursor;
		var $FieldDelim;
		/*<{delete/}>*/

		/**
		* @access private
		* @author hhombergs
		* @desc class constructor
		**/

		function opn_csv () {

			global $opnConfig;

			$ua = '';
			get_var ('HTTP_USER_AGENT', $ua, 'server');
			if (strstr (strtolower ($ua), 'win') ) {
				$this->_crlf = _OPN_HTML_CRLF;
			} elseif (strstr (strtolower ($ua), 'mac') ) {
				$this->_crlf = _OPN_HTML_LF;
			} else {
				$this->_crlf = _OPN_HTML_NL;
			}
			$log_version = '';
			$isie = false;
			if (($opnConfig['opnOption']['client']->property ('long_name') == 'msie') || ($opnConfig['opnOption']['client']->property ('long_name') == 'opera')) {
				$isie = true;
			}
			$this->_mimetype = ($isie)?'application/octetstream' : 'application/octet-stream';
			$this->CSVError = array ();
			$this->CSVData = '';
			$this->Filter = array ();

		}

		/**
		* @desc Takes an array and build the CSV string
		* @access public
		* @param Array $array The input array.
		* @param String $separator Fieldseparator (default is ';').
		* @param String $trim If the cells should be trimmed, default is 'both'. It can also be 'left', 'right' or 'both'. 'none makes it faster since omits many function calls.
		**/

		function arrayToCSV ($array, $separator = ';', $trim = 'both') {
			if ( (!is_array ($array) ) || (empty ($array) ) ) {
				$this->_csvstring = '';
			} else {
				switch ($trim) {
					case 'none':
						$trimfunction = false;
						break;
					case 'left':
						$trimfunction = 'ltrim';
						break;
					case 'right':
						$trimfunction = 'rtrim';
						break;
					default:
						$trimfunction = 'trim';
						break;
				}
				$ret = array ();
				reset ($array);
				if (is_array (current ($array) ) ) {
					foreach ($array as $linearr) {
						if (!is_array ($linearr) ) {
							$ret[] = array ();
						} else {
							$subarr = array ();
							foreach ($linearr as $val) {
								$val = $this->_valToCSVHelper ($val, $separator, $trimfunction);
								$subarr[] = $val;
							}
							$ret[] = join ($separator, $subarr);
						}
					}
					$this->_csvstring = join ($this->_crlf, $ret);
				} else {
					foreach ($array as $val) {
						$val = $this->_valToCSVHelper ($val, $separator, $trimfunction);
						$ret[] = $val;
					}
					$this->_csvstring = join ($separator, $ret);
				}
			}

		}

		/**
		* @desc Works on a string to include in a CSV string.
		* @access private
		* @param String $val
		* @param String $separator
		* @param Mixed $trimfunction
		* @return String
		* @see arrayToCSV
		**/

		function _valToCSVHelper ($val, $separator, $trimfunction) {
			if ($trimfunction) {
				$val = $trimfunction ($val);
			}
			$needquote = false;
			do {
				if (strpos ($val, '"') !== false) {
					$val = str_replace ('"', '""', $val);
					$needquote = true;
					break;
				}
				if (strpos ($val, $separator) !== false) {
					$needquote = true;
					break;
				}
				if ( (strpos ($val, _OPN_HTML_NL) !== false) || (strpos ($val, _OPN_HTML_LF) !== false) ) {
					$needquote = true;
					break;
				}
			}
			while (false);
			if ($needquote) {
				$val = '"' . $val . '"';
			}
			return $val;

		}

		/**
		* @desc Generate the CSV File and send it to the browser or download it as a file.
		* @access public
		* @param String $filename Filename to use when downloading the file. Default="dump". If it set to "". the dump is displayed on the browser.
		* @param String $ext Extension to use when downloading the File. Default='csv'.
		**/

		function dump ($filename = 'dump', $ext = 'csv') {

			$now = gmdate ('D, d M y H:i:s GMT');
			if ($filename != '') {
				header ('Content-Type: ' . $this->_mimetype);
				header ('Expires: ' . $now);
				if ($this->_browser == 'ie') {
					header ('Content-Disposition: inline; filename="' . $filename . '.' . $ext . '"');
					header ('Cache-Control: must-revalidate, post-check=0, pre-check=0');
					header ('Pragma: public');
				} else {
					header ('Content-Disposition: attachment; filename="' . $filename . '.' . $ext . '"');
					header ('Pragma: no-cache');
				}
				echo $this->_csvstring;
			} else {
				echo '<html><body><pre>';
				echo htmlspecialchars ($this->_csvstring);
				echo '</pre></body></html>';
			}

		}

		/**
		* @desc Writes the CSV Data into a file.
		* @access public
		* @param string $file
		*/

		function writeFile ($file) {

			$f = fopen ($file, 'w');
			fwrite ($f, $this->_csvstring);
			fclose ($f);

		}

		/**
		* sets the csv file and loads the files contents into
		* CSVData as string
		*
		* @access public
		* @param string $file - filename to use
		* @return bool - success
		**/

		function setFile ($file) {

			$this->CSVFile = $file;
			if (file_exists ($this->CSVFile) && ($this->CSVFile != 'none') && !empty ($this->CSVFile) ) {
				$this->setData (implode ('', file ($this->CSVFile) ) );
				return true;
			}
			$this->CSVError[] = sprintf (_OPN_CLASS_OPN_CSV_ERRORFILENOTEXIST, $file);
			return false;

		}

		/**
		* sets the csv data into CSVData - can also be used
		* to load the csv data directly via string
		*
		* @access public
		* @param string $datastring - holding the data as string
		* @return void
		**/

		function setData ($datastring) {

			$this->CSVData = $datastring;
			$this->Fields = array ();
			$this->FieldTypes = array ();
			$this->FieldNames = array ();

		}

		/**
		* sets the field delimiter
		*
		* @access private
		* @param string $delimiter - char for data separation
		* @return void
		**/

		function setDelim ($delimiter = ';') {

			$this->FieldDelim = $delimiter;

		}

		/**
		* parses the csv data and creates the data array
		* Fields (containing the data)
		* Fieldnames (containing the fieldnames)
		*
		* @access public
		* @param string $delimiter - char for data separation
		* @param bool $importfirstlineasfieldnames - use firstline as fieldnames
		* @param int $maxrows - maximum rows to import
		* @param int $offset - row to start with
		* @param bool $trimouterquotes - if the complete line is in quotes
		* @return bool - success
		**/

		function parseCSV ($delimiter = ';', $importfirstlineasfieldnames = true, $maxrows = true, $trimouterquotes = false) {
			if ($this->CSVData != '') {
				$this->setDelim ($delimiter);
				$curr_line = 0;
				$curr_field = 0;
				$curr_field_value = '';
				$last_char = '';
				$quote = 0;
				$field_input = 0;
				$head_complete = false;
				$end_cc = strlen ($this->CSVData);
				for ($cc = 0; $cc< $end_cc; $cc++) {
					if ($maxrows !== true) {
						if ($curr_line>intval ($maxrows)-1) {
							break;
						}
					}
					$curr_char = substr ($this->CSVData, $cc, 1);
					if ( ($curr_field == 0) && ($trimouterquotes) && ($curr_char == '"') ) {
						continue;
					}
					if ( ($curr_char == '"') && ($last_char != "\\") ) {
						$preview = substr ($this->CSVData, $cc+1, 1);
						if ( ( ($trimouterquotes) && ( (substr ($this->CSVData, $cc+1, 1) == "\n") || (substr ($this->CSVData, $cc+1, 1) == "\r") || ( ($cc+1) == $end_cc) ) ) ) {
							continue;
						}
						$quote = ! $quote;
						$curr_char = '';
					}
					if (!$quote) {
						if ($curr_char == $this->FieldDelim) {
							$field_input = ! $field_input;
							$curr_char = '';
							$curr_field++;
							if ($curr_field == 1 && !isset ($this->FieldNames[0]) ) {
								$this->FieldNames[0] = '';
							}
							$curr_field_value = '';
						} elseif ( ($curr_char == "\\") && $field_input) {
							$field_input++;
							$quote++;
						} elseif ($curr_char == '"') {
							$quote--;
							if ($field_input) {
								$field_input--;
							} else {
								$field_input++;
							}
						} elseif ($curr_char == "\n") {
							$check = $this->CSVNumFields ();
							if ($head_complete && ( ($curr_field+1)>$check) ) {
								$this->CSVError[] = _OPN_CLASS_OPN_CSV_ERRORONLINE . ': ' . ($curr_line+2) . ' [' . $check . ' / ' . ($curr_field+1) . ']';
							}
							$curr_line++;
							$curr_field = 0;
							if (!$head_complete) {
								$curr_line = 0;
							}
							$head_complete = true;
							$curr_char = '';
							$curr_field_value = '';
						} elseif ($curr_char == "\n") {
							$curr_char = '';
						}
					}
					$last_char = $curr_char;
					if ($curr_char == "\\") {
						$curr_char = '';
					}
					$curr_field_value .= $curr_char;
					if ($head_complete) {
						$this->Fields[$curr_line][$curr_field] = trim ($curr_field_value);
					} elseif ($importfirstlineasfieldnames) {
						$this->FieldNames[$curr_field] = trim ($curr_field_value);
					} else {
						$this->Fields[$curr_line][$curr_field] = trim ($curr_field_value);
						$this->FieldNames[$curr_field] = $curr_field;
					}
				}
				if (!$curr_field) {
					unset ($this->Fields[$curr_line]);
				}
				$this->fetchCursor = 0;
				$this->CSVData = '';
				return true;
			}
			$this->CSVError[] = _OPN_CLASS_OPN_CSV_ERRORNODATAFOUND;
			return false;

		}

		/**
		* counts the number of records
		*
		* @access public
		* @return int - num of records
		**/

		function CSVNumRows () {
			return count ($this->Fields);

		}

		/**
		* counts the number of fields in a row
		*
		* @access public
		* @return int - num of records
		**/

		function CSVNumFields () {
			return count ($this->FieldNames);

		}

		/**
		* returns one complete row as indexed array
		* and incement the line couter
		* it will return false if there no more line
		*
		* @access public
		* @return array - line data fields
		**/

		function CSVFetchRow () {
			if ($this->fetchCursor<=$this->CSVNumRows () ) {
				$r = $this->Fields[$this->fetchCursor];
				$this->fetchCursor++;
				return $r;
			}
			$this->CSVError[] = _OPN_CLASS_OPN_CSV_ERRORNOMORERECORDS;
			return false;

		}

		/**
		* returns the parsed fieldsarray
		*
		* @access public
		* @return array - fields data
		**/

		function get_Fields () {
			return $this->Fields;

		}

		/**
		* returns the parsed fieldnames array
		*
		* @access public
		* @return array - fieldnames
		**/

		function get_Fieldnames () {
			return $this->FieldNames;

		}

		/**
		* checks if there are any errors so far
		* and returns them. Returns false if no errors are
		* stored
		*
		* @access public
		* @return array - errors
		**/

		function isError () {
			if (count ($this->CSVError)>0) {
				return $this->CSVError;
			}
			return false;

		}

	}
}

?>