<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_DATE_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_DATE_INCLUDED', 1);

	class opn_date {

		/*<{php4}>
		var $_days=array();
		var $_daysabbr=array();
		var $_months=array();
		var $_suffixes=array();
		var $date='';
		var $time='';
		var $timestamp='';
		var $_days1='';
		var $_interval=0;
		<{php4/}>*/

		/*<{php5}>
		public $_days=array();
		public $_daysabbr=array();
		public $_months=array();
		public $_suffixes=array();
		public $date='';
		public $time='';
		public $timestamp='';
		public $_days1='';
		public $_interval=0;
		<{php5/}>*/

		/*<{delete}>*/
		var $_days=array();
		var $_daysabbr=array();
		var $_months=array();
		var $_suffixes=array();
		var $date='';
		var $time='';
		var $timestamp='';
		var $_days1='';
		var $_interval=0;
		/*<{delete/}>*/

		function opn_date () {

			global $opnConfig;

			$this->_days = $opnConfig['option']['days'];
			$this->_daysabbr = $opnConfig['option']['daysabbr'];
			$this->_months = $opnConfig['option']['months'];
			$this->_suffixes = $opnConfig['option']['suffixes'];
			unset ($opnConfig['option']['days']);
			unset ($opnConfig['option']['daysabbr']);
			unset ($opnConfig['option']['months']);
			unset ($opnConfig['option']['suffixes']);
			if (isset ($opnConfig['locale']) ) {
				if (phpversion ()<'4.0.5') {
					setlocale ('LC_TIME', $opnConfig['locale']);
					setlocale ('LC_COLLATE', $opnConfig['locale']);
					setlocale ('LC_CTYPE', $opnConfig['locale']);
				} else {
					setlocale (LC_TIME, $opnConfig['locale']);
					setlocale (LC_COLLATE, $opnConfig['locale']);
					setlocale (LC_CTYPE, $opnConfig['locale']);
				}
			}
			if (phpversion () > '5.1.0') {
				if ((!isset ($opnConfig['opn_timezone'])) || ($opnConfig['opn_timezone'] == '')) {
					$opnConfig['opn_timezone'] = 'Europe/London';
				}
				ini_set ('date.timezone', $opnConfig['opn_timezone']);
				date_default_timezone_set ($opnConfig['opn_timezone']);
			}

		}

		function setDate ($date) {

			$this->date = $date;
			$this->timestamp = $this->date . ' ' . $this->time;

		}

		function getDate (&$ret) {

			$ret = $this->date;

		}

		function setTime ($time) {

			$this->time = $time;
			$this->timestamp = $this->date . ' ' . $this->time;

		}

		function getTime (&$ret) {

			$ret = $this->time;

		}

		function setTimestamp ($timestamp) {

			$this->timestamp = $timestamp;
			$d = $this->_breaktimestamp ($timestamp);
			if (isset ($d[0]) ) {
				$this->date = $d[0];
			} else {
				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->write_error_log ('date Error detected: $d[0] not set timestamp=' . $timestamp);
				unset ($eh);
			}
			if (isset ($d[1]) ) {
				$this->time = $d[1];
			} else {
				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->write_error_log ('date Error detected: $d[1] not set timestamp=' . $timestamp);
				unset ($eh);
			}

		}

		function getTimestamp (&$ret) {

			$ret = $this->timestamp;

		}

		/**
		* FUNCTION: now
		*
		* returns the current day and time.
		*
		* @access public
		*/

		function now () {

			$this->setTimestamp ($this->_dateNow ('%Y-%m-%d') . ' ' . $this->_dateNow ('%H:%M:%S') );

		}

		/**
		* FUNCTION: getLongYear
		*
		* @param string $year in YY format
		* @return string year in YYYY format
		* @access public
		*/

		function getLongYear (&$ret, $year) {
			if (strlen ($year) == 1) {
				return ('200' . $year);
			}
			if ($year>50) {
				$ret = ('19' . $year);
			} else {
				$ret = ('20' . $year);
			}
			return '';

		}

		function formatTimestamp (&$ret, $format = '%Y-%m-%d %H:%M:%S') {

			$this->formatDate ($ret, $this->timestamp, $format);

		}

		/**
		* FUNCTION: formatDate
		*
		* Formats the date like strftime(), but can handle dates from year 0001 - 9999
		* and can display dates in different languages.
		*
		* formatting options:
		*
		* %a		abbreviated weekday name according to the current language setting (Mon, Tue..)
		* %A		full weekday name according to the current language setting (Sunday, Monday, Tuesday...)
		* %b		abbreviated month name according to the current  (Jan, Feb, Mar)
		* %B		full month name according to the current  (January, February, March)
		* %d		day of the month as a decimal number  (range 01 to 31)
		* %e		day of the month as a decimal number  (range 1 to 31)
		* %E		number of days since unspecified epoch (integer)
		*			  (%E is useful for storing a date in a Db/Session ..etc as an integer value.
		*			   Then use daysToDate() to convert back to a date.)
		* %H		hour as a decimal number using a 24-hour clock (range 00 to 23)
		* %j		day of the year as a decimal number  (range 001 to 366)
		* %m		month as decimal number (range 01 to 12)
		* %M		minute as a decimal number
		* %n		newline character
		* %N		month as decimal number (range 1 to 12)
		* %s		ordinal suffix for day of month
		* %S		second as a decimal number
		* %t		tab character
		* %T		Tmezomesetting
		* %U		week number of current year as a decimal number, starting with the first Sunday
		*			 as the first day of the first week.
		* %w		weekday as decimal (0 = Sunday)
		* %y		year as a decimal number without a   (range 00 to 99)
		* %Y		year as a decimal number including the century (range 0000 to 9999)
		* %%		literal '%'
		*
		* @param string $timestamp opn_date timestamp
		* @param string $format for returned string
		* @return string date in $format
		* @access public
		*/

		function formatDate (&$ret, $timestamp, $format) {

			$timestamp = $this->_breakTimestamp ($timestamp);
			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp[0]) );
			list ($hour, $minute, $second) = array_values ($this->_breakTime ($timestamp[1]) );
			if (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			if (empty ($month) == true) {
				$month = $this->_dateNow ('%m');
			}
			if (empty ($day) == true) {
				$day = $this->_dateNow ('%d');
			}
			if (empty ($hour) == true) {
				$hour = $this->_dateNow ('%H');
			}
			if (empty ($minute) == true) {
				$minute = $this->_dateNow ('%M');
			}
			if (empty ($second) == true) {
				$second = $this->_dateNow ('%S');
			}
			$ret = '';
			$max = strlen ($format);
			for ($strpos = 0; $strpos< $max; $strpos++) {
				$char = substr ($format, $strpos, 1);
				if ($char == '%') {
					$nextchar = substr ($format, $strpos+1, 1);
					switch ($nextchar) {
						case 'a':
							$this->getWeekdayAbbrname ($ret, $timestamp[0]);
							break;
						case 'A':
							$this->getWeekdayFullname ($ret, $timestamp[0]);
							break;
						case 'b':
							$this->getMonthAbbrname ($ret, $timestamp[0]);
							break;
						case 'B':
							$this->getMonthFullname ($ret, $timestamp[0]);
							break;
						case 'd':
							$ret .= sprintf ('%02d', $day);
							break;
						case 'e':
							$ret .= sprintf ('%01d', $day);
							break;
						case 'E':
							$this->dateToDays ($ret, $timestamp[0]);
							break;
						case 'H':
							$ret .= sprintf ('%02d', $hour);
							break;
						case 'j':
							$this->julianDate ($ret, $timestamp[0]);
							break;
						case 'm':
							$ret .= sprintf ('%02d', $month);
							break;
						case 'M':
							$ret .= sprintf ('%02d', $minute);
							break;
						case 'n':
							$ret .= _OPN_HTML_NL;
							break;
						case 'N':
							$ret .= sprintf ('%01d', $month);
							break;
						case 's':
							$this->getSuffix ($ret, $timestamp[0]);
							break;
						case 'S':
							$ret .= sprintf ('%02d', $second);
							break;
						case 't':
							$ret .= _OPN_HTML_TAB;
							break;
						case 'T':
							$diff = date ('Z');
							if ($diff<0) {
								$sign = '-';
								$diff = abs ($diff);
							} else {
								$sign = '+';
							}
							$diffmin = 0;
							$diffhour = $diff/3600;
							$ret .= sprintf ('%s%02d%02d', $sign, $diffhour, $diffmin);
							break;
						case 'U':
							$this->weekOfYear ($ret, $timestamp[0]);
							break;
						case 'w':
							$this->dayOfWeek ($ret, $timestamp[0]);
							break;
						case 'W':
							$this->weekOfYear ($ret, $timestamp[0], true);
							break;
						case 'y':
							$ret .= substr ($year, 2, 2);
							break;
						case 'Y':
							$ret .= $year;
							break;
						case '%':
							$ret .= '%';
							break;
						default:
							$ret .= $char . $nextchar;
						}
						$strpos++;
					} else {
						$ret .= $char;
					}
				}
			}

			function GetRFC822Date (&$date) {

				$this->formatTimestamp ($date, '%a, %d %b %Y %H:%M:%S %T');

			}
			// function

			function GetISO8601Date (&$date) {

				$this->formatTimestamp ($date, '%Y-%m-%dT%H:%M:%S%T');
				$date = substr ($date, 0, 22) . ':' . substr ($date, -2);

			}
			// function

			function GetFirstDayinMonth () {

				list (, $month, $year) = array_values ($this->_breakDate ($this->date) );
				$this->setDate ($year . '-' . $month . '-01');

			}

			function getMonthFullnameod (&$ret, $month) {

				$ret .= $this->_months[ ($month-1)];

			}

			/**
			* FUNCTION: getMonthFullname
			*
			* @param string $timestamp opn_date timestamp
			* @return string full month name
			* @access public
			*/

			function getMonthFullname (&$ret, $timestamp) {

				list (, $month, ) = array_values ($this->_breakDate ($timestamp) );
				if ( (empty ($month) ) OR ($month == '') OR (!isset ($this->_months[ ($month-1)]) ) ) {
					$month = $this->_dateNow ('%m');
				}
				$ret .= $this->_months[ ($month-1)];

			}

			/**
			* FUNCTION: getMonthAbbrname
			*
			* Returns the abbreviated month name for the opn_date $timestamp.
			*
			* @param string $timestamp opn_date timestamp
			* @param int $ length of abbreviation, default=3
			* @return string abbreviated month name
			* @access public
			*/

			function getMonthAbbrname (&$ret, $timestamp, $length = 3) {

				list (, $month, ) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				$ret .= substr ($this->_months[ ($month-1)], 0, $length);

			}

			function getWeekdayFullnameod (&$ret, $weekday) {

				$ret .= $this->_days[$weekday];

			}

			/**
			* FUNCTION: getWeekdayFullname
			*
			* Returns the full weekday name for the opn_date $timestamp.
			*
			* @param string $timestamp opn_date timestamp
			* @return string full weekday name
			* @access public
			*/

			function getWeekdayFullname (&$ret, $timestamp) {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				$weekday = '';
				$this->dayOfWeek ($weekday, $year . '-' . $month . '-' . $day);
				$ret .= $this->_days[$weekday];

			}

			function getWeekdayAbbrnameod (&$ret, $weekday, $length = 3) {
				if (!empty ($this->_daysabbr) ) {
					$ret .= ($this->_daysabbr[$weekday]);
				} else {
					$ret .= substr ($this->_days[$weekday], 0, $length);
				}

			}

			function getWeekdayAbbrnameodspecial (&$ret, $weekday, $length = 3) {

				global $opnConfig;
				if (!isset ($opnConfig['opn_start_day']) ) {
					$opnConfig['opn_start_day'] = 1;
				}
				if ($opnConfig['opn_start_day']) {
					$weekday++;
					if ($weekday>6) {
						$weekday = 0;
					}
				}
				if (!empty ($this->_daysabbr) ) {
					$ret .= ($this->_daysabbr[$weekday]);
				} else {
					$ret .= substr ($this->_days[$weekday], 0, $length);
				}

			}

			/**
			* FUNCTION: getWeekdayAbbrname
			*
			* Returns the abbreviated weekday name for the opn_date $timestamp.
			*
			* @param string $timestamp opn_date timestamp
			* @param int $ length of abbreviation, default=3
			* @return string abbreviated weekday name
			* @access public
			*/

			function getWeekdayAbbrname (&$ret, $timestamp, $length = 3) {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				$weekday = '';
				$this->dayOfWeek ($weekday, $year . '-' . $month . '-' . $day);
				if (!empty ($this->_daysabbr) ) {
					$ret .= ($this->_daysabbr[$weekday]);
				} else {
					$ret .= substr ($this->_days[$weekday], 0, $length);
				}

			}

			/**
			* FUNCTION: getSuffix
			*
			* returns the suffix for the day of the month, i.e. 03 = rd (in english)
			*
			* @param string $timestamp opn_date timestamp
			* @param string $ suffix
			* @access public
			*/

			function getSuffix (&$ret, $timestamp) {

				list ($day, , ) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				$ret .= $this->_suffixes[ ($day-1)];

			}

			/**
			* converts a given date to iso date based upon $datestr and
			* $datedelim(eter). If the date won't match to the datestr,
			* the return value is false, so you can test if the date
			* matches
			*
			* @param string $ret your date that shuld be converted
			* @param string $datestr containing the expected element order
			* @param string $datedelim delimter for the values
			* @access public
			*/

			function anydatetoisodate (&$ret, $datestr = _DATE_LOCALEDATEFORMAT, $datedelim = _DATE_DATEDELIMITER) {

				$tempdate = explode ($datedelim, $ret);
				$tempformat = explode ($datedelim, $datestr);
				if (count ($tempdate) == count ($tempformat) ) {
					foreach ($tempformat as $position => $ident) {
						$tempdate[$ident] = $tempdate[$position];
					}
					$ret = '';
					$this->mkTimestamp ($ret, $tempdate['y'], $tempdate['m'], $tempdate['d'], '00', '00', '00');
				} else {
					$ret = false;
				}

			}

			/**
			* @access private
			*/

			function locale2iso (&$ret, $sqlready = false) {
				if ($ret != '') {
					if (substr_count ($ret, '@')>0) {
						$line = explode ('@', $ret);
						$line[0] = trim ($line[0]);
						$line[1] = trim ($line[1]);
					} elseif (substr_count ($ret, ' ')>0) {
						$line = explode (' ', $ret);
						$line[0] = trim ($line[0]);
						$line[1] = trim ($line[1]);
					} else {
						$line = array ();
						$line[0] = trim ($ret);
						$line[1] = '00' . _DATE_TIMEDELIMITER . '00' . _DATE_TIMEDELIMITER . '00';
					}
					$tempdate = explode (_DATE_DATEDELIMITER, $line[0]);
					$dummy = explode (_DATE_DATEDELIMITER, _DATE_LOCALEDATEFORMAT);
					if (count ($tempdate) != count ($dummy) ) {
						if (!isset ($tempdate[0]) ) {
							$tempdate[0] = '00';
						}
						if (!isset ($tempdate[1]) ) {
							$tempdate[1] = '00';
						}
						if (!isset ($tempdate[2]) ) {
							$tempdate[2] = '2000';
						}
					}
					$temptime = explode (_DATE_TIMEDELIMITER, $line[1]);
					$dummy = explode (_DATE_TIMEDELIMITER, _DATE_LOCALETIMEFORMAT);
					if (count ($tempdate) != count ($dummy) ) {
						if (!isset ($temptime[0]) ) {
							$temptime[0] = '00';
						}
						if (!isset ($temptime[1]) ) {
							$temptime[1] = '00';
						}
						if (!isset ($temptime[2]) ) {
							$temptime[2] = '00';
						}
					}
					if ( (strlen ($tempdate[2]) )<=2) {
						$tempdate[2] = '20' . $tempdate[2];
					}
					$this->setTimestamp (sprintf ("%04d-%02d-%02d %02d:%02d:%02d", $tempdate[2], $tempdate[1], $tempdate[0], $temptime[0], $temptime[1], $temptime[2]) );
					if ($sqlready === true) {
						$this->opnDataTosql ($ret);
					}
				} else {
					if ($sqlready === true) {
						$ret = "''";
					}
				}

			}

			/**
			* given the day, month and year of a date will return a opn_date timestamp.
			*
			* @param string $year in YY or YYYY format
			* @param string $month in M or MM format
			* @param string $day in D or DD format
			* @param string $hour in H or HH format
			* @param string $minute in M or MM format
			* @param string $second in S or SS format
			* @return string opn_date timestamp
			* @access public
			*/

			function mkTimestamp (&$ret, $year = '', $month = '', $day = '', $hour = '', $minute = '', $second = '') {
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				if (empty ($hour) == true) {
					$hour = $this->_dateNow ('%H');
				}
				if (empty ($minute) == true) {
					$minute = $this->_dateNow ('%M');
				}
				if (empty ($second) == true) {
					$second = $this->_dateNow ('%S');
				}
				$ret .= sprintf ('%04d-%02d-%02d %02d:%02d:%02d', $year, $month, $day, $hour, $minute, $second);

			}

			/**
			* FUNCTION: fromUnixTime
			*
			* returns a opn_date timestamp from a given unix timestamp.
			*
			* @param int $unixtime
			* @return string opn_date timestamp
			* @access public
			*/

			function fromUnixTime (&$ret, $unixtime) {

				$ret .= strftime ('%Y-%m-%d %H:%M:%S', $unixtime);

			}

			/**
			* FUNCTION: addInterval
			*
			* this function adds a specified interval to the specified timestamp.
			* allowed intervals are DAY[S], WEEK[S], MONTH[S], YEAR[S]
			* and CENTURY [CENTURIES].
			* example of usage:
			*		$date = & new opn_date ();
			*		$now = $date->now();
			*		$nextweek = $date->addInterval('1 WEEK');
			*		$nextweeknextyear = $date->addInterval('1 WEEK 1 YEAR');
			*
			* you can use any combination of intervals.
			*
			* @param string $interval desired interval
			* @return string opn_date timestamp
			* @access public
			*/

			function addInterval ($interval) {

				$timestamp = $this->_breakTimestamp ($this->timestamp);
				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp[0]) );
				// these vars hold the temporary values as we calculate
				$this->_day = $day;
				$this->_month = $month;
				$this->_year = $year;
				$this->_interval = 0;
				$this->_days1 = '';
				$this->dateToDays ($this->_days1, $this->date);
				preg_replace ('/([\d]+)\s*([\w]+)/xSe', "\$this->_calcAddInterval('\\1', '\\2');", $interval);
				if ($this->_interval >= 1) {
					$days = $this->_days1+ $this->_interval;
					$temp = '';
					$this->daysToDate ($temp, $days);
					$temp .= ' ' . $timestamp[1];
					$this->setTimestamp ($temp);
				}

			}

			/**
			* FUNCTION: subInterval
			*
			* this function subtracts a specified interval from the specified timestamp.
			* allowed intervals are DAY[S], WEEK[S], MONTH[S], YEAR[S]
			* and CENTURY [CENTURIES].
			* example of usage:
			*		$date = & new opn_date ();
			*		$now = $date->now();
			*		$date->subInterval('1 WEEK');
			*		$date->subInterval('1 WEEK 1 YEAR');
			*
			* you can use any combination of intervals.
			*
			* @param string $timestamp opn_date timestamp
			* @param string $interval desired interval
			* @return string opn_date timestamp
			* @access public
			*/

			function subInterval ($interval) {

				$timestamp = $this->_breakTimestamp ($this->timestamp);
				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp[0]) );
				// these vars hold the temporary values as we calculate
				$this->_day = $day;
				$this->_month = $month;
				$this->_year = $year;
				$this->_interval = 0;
				$this->_days1 = '';
				$this->dateToDays ($this->_days1, $this->date);
				preg_replace ('/([\d]+)\s*([\w]+)/xSe', "\$this->_calcSubInterval('\\1', '\\2');", $interval);
				if ($this->_interval >= 1) {
					$days = $this->_days1- $this->_interval;
					$temp = '';
					$this->daysToDate ($temp, $days);
					$temp .= ' ' . $timestamp[1];
					$this->setTimestamp ($temp);
				}

			}

			/**
			* FUNCTION: nextDay
			*
			* Returns a opn_date timestamp for the day after $timestamp.
			* If format is specified, then that format is returned instead
			* of the timestamp.
			*
			* @param string $timestamp opn_date timestamp
			* @param string $format for returned date
			* @return string if  date in given format or opn_date timestamp
			* @access public
			*/

			function nextDay (&$ret, $timestamp, $format = '%Y-%m-%d') {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				$days = '';
				$this->dateToDays ($days, $year . '-' . $month . '-' . $day);
				$this->daysToDate ($ret, $days+1, $format);

			}

			/**
			* FUNCTION: prevDay
			*
			* Returns a opn_date timestamp for the day before $timestamp.
			* If format is specified, the that format is returned instead
			* of the timestamp.
			*
			* @param string $timestamp opn_date timestamp
			* @param string $format for returned date
			* @return string if  date in given format or opn_date timestamp
			* @access public
			*/

			function prevDay (&$ret, $timestamp, $format = '%Y-%m-%d') {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
				if (empty ($day) == true) {
					$day = $this->_dateNow ('%d');
				}
				$days = '';
				$this->dateToDays ($days, $year . '-' . $month . '-' . $day);
				$this->daysToDate ($ret, $days-1, $format);

			}

			/**
			* FUNCTION: isFutureDate
			*
			* @param string $timestamp opn_date timestamp
			* @return boolean true/false
			* @access public
			*/

			function isFutureDate (&$ret, $timestamp) {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				$this_year = $this->_dateNow ('%Y');
				$this_month = $this->_dateNow ('%m');
				$this_day = $this->_dateNow ('%d');
				$ret = FALSE;
				if ($year>$this_year) {
					$ret = TRUE;
				} elseif ($year == $this_year) {
					if ($month>$this_month) {
						$ret = TRUE;
					} elseif ($month == $this_month) {
						if ($day>$this_day) {
							$ret = TRUE;
						}
					}
				}

			}

			/**
			* FUNCTION: isPastDate
			*
			* @param string $timestamp opn_date timestamp
			* @return boolean true/false
			* @access public
			*/

			function isPastDate (&$ret, $timestamp) {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				$this_year = $this->_dateNow ('%Y');
				$this_month = $this->_dateNow ('%m');
				$this_day = $this->_dateNow ('%d');
				$ret = FALSE;
				if ($year<$this_year) {
					$ret = TRUE;
				} elseif ($year == $this_year) {
					if ($month<$this_month) {
						$ret = TRUE;
					} elseif ($month == $this_month) {
						if ($day<$this_day) {
							$ret = TRUE;
						}
					}
				}

			}

			/**
			* FUNCTION: isDate
			*
			* @param string $timestamp opn_date timestamp
			* @return boolean true/false
			* @access public
			*/

			function isDate ($timestamp) {

				list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
				if (empty ($year) || empty ($month) || empty ($day) ) {
					return false;
				}
				if ($year<0 || $year>9999) {
					return false;
				}
				if ($month<1 || $month>12) {
					return false;
				}
				$temp = 0;
				$this->daysInMonth ($temp, $month, $year);
				if ($day<1 || $day>$temp) {
					return false;
				}
				return true;

		}

		/**
		* FUNCTION: isLeapYear
		*
		* Returns true if $year is a leap year.
		*
		* @param string $year in format YYYY or a opn_date timestamp
		* @return boolean true/false
		* @access public
		*/

		function isLeapYear (&$ret, $year = '') {
			if (strlen ($year)>4) {
				// timestamp has bee parsed
				list (, , $year) = array_values ($this->_breakDate ($year) );

			} elseif (strlen ($year) == 2) {
				$this->getLongYear ($year, $year);
			} elseif (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			// if (preg_match('/\D/', $year)) return false;
			$ret = ( ($year%4 == 0 && $year%100 != 0) || $year%400 == 0);

		}

		/**
		* FUNCTION: dayOfWeek
		*
		* Returns day of week for the timestamp: 0=Sunday ... 6=Saturday
		*
		* @param string $timestamp opn_date timestamp
		* @return int $weekday_number
		* @access public
		*/

		function dayOfWeek (&$ret, $timestamp) {

			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			if (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			if (empty ($month) == true) {
				$month = $this->_dateNow ('%m');
			}
			if (empty ($day) == true) {
				$day = $this->_dateNow ('%d');
			}
			if ($month>2) {
				$month -= 2;
			} else {
				$month += 10;
				$year--;
			}
			$day = (floor ( (13* $month-1)/5)+ $day+ ($year%100)+floor ( ($year%100)/4)+floor ( ($year/100)/4)-2*floor ($year/100)+77);
			$weekday_number = ( ($day-7*floor ($day/7) ) );
			$ret .= $weekday_number;

		}

		/**
		* FUNCTION: weekOfYear
		*
		* Returns week of the year.
		* If $start_monday is true, then the first week of the Year starts with the first
		* Monday of the year, otherwise it's the first Sunday.
		*
		* @param string $timestamp opn_date timestamp
		* @param bool $start_monday
		* @return integer $week_number
		* @access public
		*/

		function weekOfYear (&$ret, $timestamp, $start_monday = false) {

			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			if (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			if (empty ($month) == true) {
				$month = $this->_dateNow ('%m');
			}
			if (empty ($day) == true) {
				$day = $this->_dateNow ('%d');
			}
			$week_year = $year-1501;
			$capt_days = ($start_monday)?29873 : 29872;
			$week_day = $week_year*365+floor ($week_year/4)- $capt_days+1-floor ($week_year/100)+floor ( ($week_year-300)/400);
			$temp = '';
			$this->julianDate ($temp, $year . '-' . $month . '-' . $day);
			$week_number = floor ( ($temp+floor ( ($week_day+4)%7) )/7);
			if ($week_number == 0) {
				$week_number = 1;
			}
			$ret .= $week_number;

		}

		/**
		* FUNCTION: julianDate
		*
		* Returns number of days since (and including) 1st January of the year
		* in the given timestamp.
		*
		* @param string $timestamp opn_date timestamp
		* @return int $julian
		* @access public
		*/

		function julianDate (&$ret, $timestamp) {

			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			if (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			if (empty ($month) == true) {
				$month = $this->_dateNow ('%m');
			}
			if (empty ($day) == true) {
				$day = $this->_dateNow ('%d');
			}
			$days = array (0,
					31,
					59,
					90,
					120,
					151,
					181,
					212,
					243,
					273,
					304,
					334);
			$julian = ($days[$month-1]+ $day);
			$temp = FALSE;
			$this->isLeapYear ($temp, $year);
			if ($month>2 && $temp) {
				$julian++;
			}
			$ret .= $julian;

		}

		/**
		* FUNCTION: quarterOfYear
		*
		* Returns quarter of the year for given timestamp.
		*
		* @param string $timestamp opn_date timestamp
		* @return int $year_quarter
		* @access public
		*/

		function quarterOfYear (&$ret, $timestamp) {

			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			if (empty ($year) == true) {
				$year = $this->_dateNow ('%Y');
			}
			if (empty ($month) == true) {
				$month = $this->_dateNow ('%m');
			}
			if (empty ($day) == true) {
				$day = $this->_dateNow ('%d');
			}
			$year_quarter = (intval ( ($month-1)/3+1) );
			$ret = $year_quarter;

		}

		/**
		* FUNCTION: diffInDays
		*
		* Returns number of days between two given dates.
		*
		* @param string $timestamp1 opn_date timestamp
		* @param string $timestamp2 opn_date timestamp
		* @return int absolute number of days between dates, or false on error
		* @access public
		*/

		function diffInDays (&$ret, $timestamp1, $timestamp2) {
			if (!$this->isDate ($timestamp1) ) {
				return false;
			}
			if (!$this->isDate ($timestamp2) ) {
				return false;
			}
			$temp1 = '';
			$temp2 = '';
			$this->dateToDays ($temp1, $timestamp1);
			$this->dateToDays ($temp2, $timestamp2);
			$ret = (abs ( ($temp1)- ($temp2) ) );
			return true;

		}

		/**
		* Function getDiff
		*
		* Returns the difference between two dates
		* @param number		$ret
		* @param number		$timestamp1	Date in OPN Format
		* @param number		$timestamp2	Date in OPN Format
		*/

		function getDiff (&$ret, $timestamp1, $timestamp2) {

			$ret = ( ($timestamp1*86400)- ($timestamp2*86400) )/86400;

		}

		/**
		* FUNCTION: daysInMonth
		*
		* Find the number of days in the $month.
		*
		* @param mixed $ int month in MM format or a string opn_date timestamp
		* @param string $ year in YYYY format
		* @return int number of days
		* @access public
		*/

		function daysInMonth (&$ret, $month = '', $year = '') {
			if (strlen ($month)>2) {
				// timestamp has bee parsed
				list (, $month, $year) = array_values ($this->_breakDate ($month) );
			} else {
				if (empty ($year) == true) {
					$year = $this->_dateNow ('%Y');
				}
				if (empty ($month) == true) {
					$month = $this->_dateNow ('%m');
				}
			}
			$months = array (31,
					28,
					31,
					30,
					31,
					30,
					31,
					31,
					30,
					31,
					30,
					31);
			$days = $months[ ($month-1)];
			$temp = FALSE;
			$this->isLeapYear ($temp, $year);
			$ret = ( ($month == 2 && $temp)? ($days+1) : $days);

		}

		/**
		* FUNCTION: dateToDays
		*
		* Converts a opn_date timestamp to a number of days since a long
		* distant epoch.
		* You can use this to store dates or to pass dates from 1
		* URL to another.
		*
		* @param string $timestamp opn_date timestamp
		* @return int number of days
		* @access public
		*/

		function dateToDays (&$ret, $timestamp) {

			list ($day, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			$century = substr ($year, 0, 2);
			$year = substr ($year, 2, 2);
			if ($month>2) {
				$month -= 3;
			} else {
				$month += 9;
				if ($year) {
					$year--;
				} else {
					$year = 99;
					$century--;
				}
			}
			$ret .= (floor ( (146097* $century)/4)+floor ( (1461* $year)/4)+floor ( (153* $month+2)/5)+ $day+1721119);

		}

		/**
		* FUNCTION: encodeDate
		*
		* alias for dateToDays().
		*/

		function encodeDate (&$ret, $timestamp) {

			$ret = '';
			$this->dateToDays ($ret, $timestamp);

		}

		/**
		* FUNCTION: daysToDate
		*
		* Converts a number of days since a long distant epoch
		* to a opn_date timestamp or to a format specified by $format.
		*
		* @param int $days days since long distant epoch
		* @return string opn_date timestamp or other $format
		* @access public
		*/

		function daysToDate (&$ret, $days, $format = '%Y-%m-%d') {

			$days -= 1721119;
			$century = floor ( (4* $days-1)/146097);
			$days = floor (4* $days-1-146097* $century);
			$day = floor ($days/4);
			$year = floor ( (4* $day+3)/1461);
			$day = floor (4* $day+3-1461* $year);
			$day = floor ( ($day+4)/4);
			$month = floor ( (5* $day-3)/153);
			$day = floor (5* $day-3-153* $month);
			$day = floor ( ($day+5)/5);
			if ($month<10) {
				$month += 3;
			} else {
				$month -= 9;
				if ($year++ == 99) {
					$year = 0;
					$century++;
				}
			}
			$century = sprintf ('%02d', $century);
			$year = sprintf ('%02d', $year);
			$month = sprintf ('%02d', $month);
			$day = sprintf ('%02d', $day);
			$this->formatDate ($ret, $century . $year . '-' . $month . '-' . $day, $format);

		}

		/**
		* FUNCTION: decodeDate
		*
		* alias for daysToDate().
		*/

		function decodeDate (&$ret, $days, $format = '%Y-%m-%d') {

			$ret = '';
			$this->daysToDate ($ret, $days, $format);

		}

		/**
		* FUNCTION: getYear
		*
		* Returns the year in YYYY format
		*
		* @return string year in YYYY format
		* @access public
		*/

		function getYear (&$ret) {

			$ret = $this->_breakDate ($this->date);
			$ret = ($ret['year'] == ''?'0000' : sprintf ('%04d', $ret['year']) );

		}

		/**
		* FUNCTION: getMonth
		*
		* Returns the month in MM format
		*
		* @return string month in MM format
		* @access public
		*/

		function getMonth (&$ret) {

			$ret = $this->_breakDate ($this->date);
			$ret = ($ret['month'] == ''?'01' : sprintf ('%02d', $ret['month']) );

		}

		/**
		* FUNCTION: getDay
		*
		* Returns the day in DD format
		*
		* @return string day in DD format
		* @access public
		*/

		function getDay (&$ret) {

			$ret = $this->_breakDate ($this->date);
			$ret = ($ret['day'] == ''?'01' : sprintf ('%02d', $ret['day']) );

		}

		/**
		* FUNCTION: getHour
		*
		* Returns the hour in hh format
		*
		* @return string hour in hh format
		* @access public
		*/

		function getHour (&$ret) {

			$ret = $this->_breakTime ($this->time);
			$ret = ($ret['hour'] == ''?'00' : sprintf ('%02d', $ret['hour']) );

		}

		/**
		* FUNCTION: getMinute
		*
		* Returns the minute in mm format
		*
		* @return string minute in mm format
		* @access public
		*/

		function getMinute (&$ret) {

			$ret = $this->_breakTime ($this->time);
			$ret = ($ret['minute'] == ''?'00' : sprintf ('%02d', $ret['minute']) );

		}

		/**
		* FUNCTION: getSecond
		*
		* Returns the seconds in ss format
		*
		* @return string seconds in ss format
		* @access public
		*/

		function getSecond (&$ret) {

			$ret = $this->_breakTime ($this->time);
			$ret = ($ret['second'] == ''?'00' : sprintf ('%02d', $ret['second']) );

		}

		/**
		* Transform hours like '1:50' into the total number of minutes, '110'.
		*
		* @param string $hours
		* @access private
		* @return $totalMinutes : total number of minutes
		*/

		function hoursToMinutes (&$ret, $hours) {
			if (strstr ($hours, ':') ) {
				// Split hours and minutes.
				$separatedData = split (':', $hours);
				$minutesInHours = $separatedData[0]*60;
				$minutesInDecimals = $separatedData[1];
				$ret = $minutesInHours+ $minutesInDecimals;
			} else {
				$ret .= $hours*60;
			}

		}

		/**
		* Transform minutes like '110' into hours like '1:50'.
		*
		* @param string $hours
		* @access private
		* @return $totalMinutes : total number of minutes
		*/

		function minutesToHours (&$ret, $minutes) {

			$hours = floor ($minutes/60);
			$decimalMinutes = floor ($minutes-floor ($minutes/60)*60);
			// Put it together.
			$ret .= sprintf ('%d:%02.0f', $hours, $decimalMinutes);

		}

		/**
		* Transform sec like '60' into minutes like '1'.
		*
		* @param string $sec
		* @access private
		* @return $totalMinutes : total number of minutes
		*/

		function SecTominutes (&$ret, $sec) {

			$ret = floor ($sec/60);

		}

		/**
		* Transform min like '1' into sec like '60'.
		*
		* @param string $min
		* @access private
		* @return $totalSec : total number of Sec
		*/

		function minutesToSec (&$ret, $min) {

			$ret = floor ($min*60);

		}

		function opnDataTosql (&$ret) {

			$sql = 0;
			$sql2 = 0;
			if ($this->date != '') {
				$this->DateToDays ($sql, $this->date);
			}
			if ($this->time != '') {
				$sql2 = ($this->_timeTosave ($this->time) )/100000;
			}
			$sql += $sql2;
			$ret = $sql;

		}

		function sqlToopnData ($sql = 0) {
			if ($sql == 0) {
				$this->setTimestamp ('0000-00-00 00:00:00');
			} else {
				$sql = number_format ($sql, 5, '.', '');
				$separatedData = explode ('.', $sql);
				$temp = '';
				if ($separatedData[0] != 0) {
					$this->daysToDate ($temp, $separatedData[0]);
				}
				$this->setTimestamp ($temp . ' ' . $this->_saveTotime ($separatedData[1]) );
			}
			// $this->formatTimestamp();

		}

		function ConvertDateToDBDate (&$ret, $date, $time = '') {

			global $opnConfig;

			$da = $this->_GetDateArray ($date);
			if ($time != '') {
				$ta = $this->_GetTimeArray ($time);
				$ts = mktime ($ta['h'], $ta['m'], $ta['s'], $da['m'], $da['d'], $da['y']);
			} else {
				$ts = mktime (0, 0, 0, $da['m'], $da['d'], $da['y']);
			}
			$h = $opnConfig['database']->DBTimeStamp ($ts);
			$ret = str_replace ("'", '', $h);

		}

		/**
		* -----------------------------------------------------------------------------\
		* |						   private functions								|
		* \-----------------------------------------------------------------------------
		*/

		/**
		* FUNCTION: _calcSubInterval
		*
		* does the calculations for $this->subInterval();
		*
		* @param int $number number of $interval's
		* @param string $interval type of interval, i.e. DAY, MONTH ...etc.
		* @access private
		*/

		function _calcSubInterval ($number, $interval) {

			$interval = strtoupper ($interval);
			if (substr ($interval, -1, 1) == 'S') {
				$interval = substr ($interval, 0, -1);
			}

			/**
			* retreive the timestamp with the interval added so we can keep track
			* of the current year and month of calculation
			*/

			$timestamp = '';
			$this->daysToDate ($timestamp, ($this->_days1- $this->_interval) );
			list (, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			switch ($interval) {
				case 'DAY':
				case 'DAYS':
					if ($number>0) {
						$this->_interval += $number;
					}
					break;
				case 'WEEK':
				case 'WEEKS':
					if ($number>0) {
						$this->_interval += ($number*7);
					}
					break;
				case 'MONTH':
				case 'MONTHS':
					if ($number>0) {
						for ($i = 0; $i< $number; $i++) {
							// first we goto prev month
							if ($month != 1) {
								$month--;
							} else {
								$month = 12;
								$year--;
							}
							$sub = 0;
							$this->daysInMonth ($sub, $month, $year);
							$this->_interval += $sub;
						}
					}
					break;
				case 'CENTURIE':
				case 'CENTURIES':
					$interval = 'CENTURY';
					break;
				case 'CENTURY':
				case 'CENTURYS':
					$interval = 'YEAR';
					$number *= 100;
					break;
				case 'YEAR':
				case 'YEARS':
					if ($number>0) {
						$temp = FALSE;
						$temp2 = FALSE;
						for ($i = 0; $i< $number; $i++) {
							$this->isLeapYear ($temp, $year);
							$this->isLeapYear ($temp2, $year-1);
							if ( ($month<3 && $temp2) or ($month>2 && $temp) ) {
								$this->_interval += 366;
							} else {
								$this->_interval += 365;
							}
							$year--;;
							// goto previous year
						}
					}
					break;
			}
			return;

		}

		/**
		* FUNCTION: _calcAddInterval
		*
		* does the calculations for $this->addInterval();
		*
		* @param int $number number of $interval's
		* @param string $interval type of interval, i.e. DAY, MONTH ...etc.
		* @access private
		*/

		function _calcAddInterval ($number, $interval) {

			$interval = strtoupper ($interval);
			if (substr ($interval, -1, 1) == 'S') {
				$interval = substr ($interval, 0, -1);
			}

			/**
			* retreive the timestamp with the interval added so we can keep track
			* of the current year and month of calculation
			*/

			$timestamp = '';
			$this->daysToDate ($timestamp, ($this->_days1+ $this->_interval) );
			list (, $month, $year) = array_values ($this->_breakDate ($timestamp) );
			switch ($interval) {
				case 'DAY':
				case 'DAYS':
					if ($number>0) {
						$this->_interval += $number;
					}
					break;
				case 'WEEK':
				case 'WEEKS':
					if ($number>0) {
						$this->_interval += ($number*7);
					}
					break;
				case 'MONTH':
				case 'MONTHS':
					if ($number>0) {
						for ($i = 0; $i< $number; $i++) {
							$add = 0;
							$this->daysInMonth ($add, $month, $year);
							$this->_interval += $add;
							if ($month<12) {
								$month++;
							} else {
								$month = 1;
								$year++;
							}
						}
					}
					break;
				case 'CENTURIE':
				case 'CENTURIES':
					$interval = 'CENTURY';
					break;
				case 'CENTURY':
				case 'CENTURYS':
					$interval = 'YEAR';
					$number *= 100;
					break;
				case 'YEAR':
				case 'YEARS':
					if ($number>0) {
						$temp = FALSE;
						$temp2 = FALSE;
						for ($i = 0; $i< $number; $i++) {
							$this->isLeapYear ($temp, $year);
							$this->isLeapYear ($temp2, $year+1);
							if ( ($month<3 && $temp) or ($month>2 && $temp2) ) {
								$this->_interval += 366;
							} else {
								$this->_interval += 365;
							}
							$year++;
						}
					}
					break;
			}
			return;

		}

		/**
		* FUNCTION: timeTosave
		*/

		function _timeTosave ($otime) {
			if (strstr ($otime, ':') ) {
				if (substr_count ($otime, ':') == 1) {
					$otime = $otime . ':00';
				}
				$separatedData = split (':', $otime);
				$save = '';
				$this->hoursToMinutes ($save, $separatedData[0] . ':' . $separatedData[1]);
				$this->minutesToSec ($save, $save);
				$save += $separatedData[2];
				return $save;
			}
			return 0;

		}

		/**
		* FUNCTION: saveTotime
		*/

		function _saveToTime ($otime) {

			$minutes = '';
			$this->SecTominutes ($minutes, $otime);
			$hours = floor ($minutes/60);
			$decimalMinutes = floor ($minutes-floor ($minutes/60)*60);
			$decimalSec = floor ($otime- ($minutes*60) );
			// Put it together.
			$hoursMinutes = sprintf ('%02.0f:%02.0f:%02.0f', $hours, $decimalMinutes, $decimalSec);
			return $hoursMinutes;

		}

		/**
		* @param string $ the strftime() format to return the date
		* @access private
		* @return string the current date in specified format
		*/

		function _dateNow ($format = '%Y%m%d') {
			return (strftime ($format, time () ) );

		}

		function _breakTimestamp ($timestamp) {
			if ( (substr_count ($timestamp, '-')>0) && (substr_count ($timestamp, ':')>0) ) {
				return explode (' ', $timestamp);
			}
			if (substr_count ($timestamp, '-')>0) {
				return array ($timestamp,
						'');
			}
			if (substr_count ($timestamp, ':')>0) {
				return array ('',
						$timestamp);
			}
			if (substr_count ($timestamp, '/')>1) {
				$timestamp = str_replace ('/', '-', $timestamp);
				return array ($timestamp,
						'');
			}
			return '';

		}

		/**
		* Returns an array with day, month, year key values for a date.
		*
		* @param string $date
		* @access private
		* @return array associative array with date values.
		*/

		function _breakDate ($date) {

			$n = explode ('-', $date);
			// remove all non digits
			if (count ($n) == 3) {
				// if ( ($n[2] <= 32) && ($n[1] <= 13) && (strlen($n[0]) <= 2) ) {
				return array ('day' => $n[2],
						'month' => $n[1],
						'year' => $n[0]);
				// }
				// return array('day' => $n[1], 'month' => $n[0], 'year' => $n[2]);
			}
			return array ('day' => '',
					'month' => '',
					'year' => '');

		}

		/**
		* Returns an array with hour, minute, second key values for a time.
		*
		* @param string $time
		* @access private
		* @return array associative array with time values.
		*/

		function _breakTime ($time) {

			$n = explode (':', $time);
			// remove all non digits
			if (count ($n) == 3) {
				return array ('hour' => $n[0],
						'minute' => $n[1],
						'second' => $n[2]);
			}
			return array ('hour' => '',
					'minute' => '',
					'second' => '');

		}

		function _BuildArray ($value, $format) {

			$sep = substr ($format, 1, 1);
			$p1 = strpos ($format, $sep);
			$p2 = strpos ($format, $sep, $p1+1);
			$pos1 = substr ($format, 0, $p1);
			$pos2 = substr ($format, $p1+1, $p2- $p1-1);
			$pos3 = substr ($format, $p2+1);
			$p1 = strpos ($value, $sep);
			$p2 = strpos ($value, $sep, $p1+1);
			$x = substr ($value, 0, $p1);
			$y = substr ($value, $p1+1, $p2- $p1-1);
			$z = substr ($value, $p2+1);
			$d[$pos1] = $x;
			$d[$pos2] = $y;
			$d[$pos3] = $z;
			return $d;

		}

		function _GetDateArray ($date) {

			$d = $this->_BuildArray ($date, _DATE_LOCALEDATEFORMAT);
			if (intval ($d['y'])<100) {
				if ($d['y']>69) {
					$d['y'] = strval (1900+intval ($d['y']) );
				} else {
					$d['y'] = strval (2000+intval ($d['y']) );
				}
			}
			$d['d'] = sprintf ('%02d', $d['d']);
			$d['m'] = sprintf ('%02d', $d['m']);
			return $d;

		}

		function _GetTimeArray ($time) {

			$d = $this->_BuildArray ($time, _DATE_LOCALETIMEFORMAT);
			$d['h'] = sprintf ('%02d', $d['h']);
			$d['m'] = sprintf ('%02d', $d['m']);
			$d['s'] = sprintf ('%02d', $d['s']);
			return $d;

		}

	}
	// class
}
// if

?>