<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_PROTECTOR_INCLUDED') ) {
	define ('_OPN_CLASS_PROTECTOR_INCLUDED', 1);

	class protector {

		/*<{php4}>
		var $_ip = '';
		var $_uid = 0;
		var $_requri = '';
		var $_browser = '';
		<{php4/}>*/

		/*<{php5}>
		public $_ip = '';
		public $_uid = 0;
		public $_requri = '';
		public $_browser = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $_ip = '';
		var $_uid = 0;
		var $_requri = '';
		var $_browser = '';
		/*<{delete/}>*/

		function protector () {

			global $opnConfig;

			$this->_ip = get_real_IP ();
			if ($opnConfig['opnOption']['user_login']) {
				$userinfo = $opnConfig['permission']->GetUserinfo ();
				$this->_uid = $userinfo['uid'];
			}
			$PATH_INFO = getenv ('PATH_INFO');
			if ($PATH_INFO != '') {
				$QUERY_STRING = '';
				get_var ('QUERY_STRING', $QUERY_STRING, 'server');
				if ($QUERY_STRING != '') {
					$this->_requri = $PATH_INFO . "?" . $QUERY_STRING;
				} else {
					$this->_requri = $PATH_INFO;
				}
			} else {
				$this->_requri = '';
				get_var ('REQUEST_URI', $this->_requri, 'server');
			}
			if ($opnConfig['opnOption']['client']) {
				$this->_browser = $opnConfig['opnOption']['client']->property ('long_name');
			}

		}

		function run_protector () {

			global $opnConfig, ${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_post_vars']};
			if ( (isset ($opnConfig['dos_testing']) ) && ($opnConfig['dos_testing'] == 1) ) {
				$this->check_dos_attack ();
			}
			if ( (isset ($opnConfig['opn_safetyadjustment']) ) && ($opnConfig['opn_safetyadjustment'] == 2) ) {
				foreach (${$opnConfig['opn_get_vars']} as $seccheck) {
					if (is_array ($seccheck) ) {
						$seccheck = implode (',', $seccheck);
					}
					if ( (preg_match ("/<[^>]*script*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*object*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*iframe*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*applet*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*meta*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*style*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*form*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/\([^>]*\"?[^)]*\)/i", $seccheck) ) || (preg_match ("/\"/", $seccheck) ) ) {
						die ('The html tags you attempted to use are not allowed');
					}
				}
				foreach (${$opnConfig['opn_post_vars']} as $seccheck) {
					if (is_array ($seccheck) ) {
						$seccheck = implode (',', $seccheck);
					}
					if (!is_array ($seccheck) ) {
						if ( (preg_match ("/<[^>]*script*\"?[^>]*>/i", $seccheck) ) || (preg_match ("/<[^>]*style*\"?[^>]*>/i", $seccheck) ) ) {
							die ('The html tags you attempted to use are not allowed');
						}
					}
				}
			}
			if ( (isset ($opnConfig['opn_checkdocroot']) ) && ($opnConfig['opn_checkdocroot'] == 1) ) {
				$DOCUMENT_ROOT = '';
				get_var ('DOCUMENT_ROOT', $DOCUMENT_ROOT, 'server');
				if (! (substr_count (_OPN_ROOT_PATH, $DOCUMENT_ROOT)>0) ) {
					opn_reload_Header ('html/error_hack.html');
				}
			}

		}

		function check_dos_attack () {

			global $opnConfig, $opnTables;

			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$opnConfig['opndate']->setTimestamp ('00:' . sprintf ('%02d', $opnConfig['dos_expire_time']) . ':00');
			$time1 = '';
			$opnConfig['opndate']->opnDataTosql ($time1);
			$time2 = $time- $time1;
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_protector_access'] . " WHERE expire < $time2");
			$ip = $opnConfig['opnSQL']->qstr ($this->_ip);
			$request_uri = $opnConfig['opnSQL']->qstr ($this->_requri);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_protector_access'] . " (ip, request_uri, expire) VALUES ($ip, $request_uri, $time)");
			$numrows = 0;
			$result = &$opnConfig['database']->Execute ('SELECT ip FROM ' . $opnTables['opn_protector_access'] . " WHERE ip=$ip AND request_uri=$request_uri");
			if ($result !== false) {
				$numrows = $result->RecordCount ();
			}
			if ($numrows>$opnConfig['dos_expire_total']) {
				if ($this->_browser != 'BOT') {
					sleep (5);
				}
			} else {
				// echo $numrows;
			}

		}

	}
}

?>