<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_TIMER_INCLUDED') ) {
	define ('_OPN_CLASS_TIMER_INCLUDED', 1);

	class timer {

		/*<{php4}>
		var $_enabled = true;
		var $_timing_start_times = array ();
		var $_timing_stop_times = array ();
		<{php4/}>*/

		/*<{php5}>
		public $_enabled = true;
		public $_timing_start_times = array ();
		public $_timing_stop_times = array ();
		<{php5/}>*/

		/*<{delete}>*/
		var $_enabled = true;
		var $_timing_start_times = array ();
		var $_timing_stop_times = array ();
		/*<{delete/}>*/

		function timer () {

			$this->_enabled = true;
			$this->_timing_start_times = array ();
			$this->_timing_stop_times = array ();

		}

		function start ($name = 'default') {
			if ($this->_enabled) {
				$this->_timing_start_times[$name] = explode (' ', microtime () );
			}

		}

		function stop ($name = 'default') {
			if ($this->_enabled) {
				$this->_timing_stop_times[$name] = explode (' ', microtime () );
			}

		}

		function get_current ($name = 'default') {
			if ($this->_enabled) {
				if (!isset ($this->_timing_start_times[$name]) ) {
					return 0;
				}
				if (!isset ($this->_timing_stop_times[$name]) ) {
					$stop_time = explode (' ', microtime () );
				} else {
					$stop_time = $this->_timing_stop_times[$name];
				}
				$current = $stop_time[1]- $this->_timing_start_times[$name][1];
				$current += $stop_time[0]- $this->_timing_start_times[$name][0];
				return sprintf ('%.10f', $current);
			}
			return 0;

		}

	}

	class debugbenchmark {

		/*<{php4}>
		var $_BENCHMARK = array();
		<{php4/}>*/

		/*<{php5}>
		public $_BENCHMARK = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $_BENCHMARK = array();
		/*<{delete/}>*/

		function debugbenchmark () {

			$this->set_debugbenchmark ('START');

		}

		function set_debugbenchmark ($strID) {

			$strTemp = microtime ();
			$strTemp = explode (' ', $strTemp);
			$strTemp = abs ($strTemp[0]+ $strTemp[1]);
			if (function_exists ('memory_get_usage') ) {
				$this->_BENCHMARK[$strID] = array ('TIME' => $strTemp,
								'MEMORY' => memory_get_usage () );
			} else {
				$this->_BENCHMARK[$strID] = array ('TIME' => $strTemp,
								'MEMORY' => NULL);
			}

		}

		function get_debugbenchmark_result (&$txt) {

			$this->set_debugbenchmark ('ENDE');
			$BENCH = number_format ( ($this->_BENCHMARK['ENDE']['TIME']- $this->_BENCHMARK['START']['TIME']), 3);
			$cache_time = number_format ($this->_BENCHMARK['START']['TIME']- $this->_BENCHMARK['START']['TIME'], 3);
			$cache_ram = number_format ($this->_BENCHMARK['START']['MEMORY']- $this->_BENCHMARK['START']['MEMORY'], 3);
			$txt = '<br />';
			$txt .= '<strong>Benchmark-Zeiten</strong><br /><br />';
			$txt .= '<em>Gesamtzeit:</em> ' . $BENCH . ' Sekunden<br /><br />';
			$table =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_TableClass ('alternator');
			$table->AddHeaderRow (array ('Zeitmarke', 'Zeitstempel', 'Vergangen,Dauer', 'Anteil', 'RAM-Verbrauch', 'RAM-nderung') );
			foreach ($this->_BENCHMARK as $bid => $bval) {
				$transfer = number_format ($bval['TIME']- $this->_BENCHMARK['START']['TIME'], 3);
				$predur = number_format ($transfer- $cache_time, 3);
				$preram = ($bval['MEMORY']- $cache_ram);
				$percentage_total = number_format ($transfer/ $BENCH*100, 1);
				$percentage_part = number_format ($predur/ $BENCH*100, 1);
				 ($preram<0)? $ram_purge = '<span style="color: #00aa00">' . number_format ($preram, 0, _DEC_POINT, _THOUSANDS_SEP) . '</span>' : $ram_purge = '<span style="color: #aa0000">+' . number_format ($preram, 0, _DEC_POINT, _THOUSANDS_SEP) . '</span>';
				$table->AddDataRow (array ($bid, $bval['TIME'], '+' . $transfer . 's,' . $predur . 's:' . $percentage_total, $percentage_part . '%', $bval['MEMORY'] . ' Bytes', $ram_purge), array ('center', 'right', 'right', 'right', 'right', 'right') );
				$cache_time = $transfer;
				$cache_ram = $bval['MEMORY'];
			}
			$table->GetTable ($txt);

		}

	}
}

?>