<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_UBBCODE_INCLUDED') ) {
	define ('_OPN_CLASS_UBBCODE_INCLUDED', 1);

	/**
	* Convert HTML entities to all applicable characters
	*
	* @access public
	* @param string $string
	* @return string
	**/

	function un_htmlentities1 ($string) {

		$ts = array_flip (get_html_translation_table (HTML_ENTITIES) );
		return strtr ($string, $ts);

	}

	/*
	* @access   public
	*/

	class UBBCode {

		/*<{php4}>
		var $_tags = array();
		var $_elem = '';
		<{php4/}>*/

		/*<{php5}>
		private $_tags = array();
		private $_elem = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $_tags = array();
		var $_elem = array();
		/*<{delete/}>*/

		function _setQuote ($author = '', $date = '', $text) {

			global $opnConfig;

			$return = '';
			if ($date != '') {
				$opnConfig['opndate']->setTimestamp ($date);
				$tempdate = '';
				$opnConfig['opndate']->formatTimestamp ($tempdate, _DATE_DATESTRING4);
				$temptime = '';
				$opnConfig['opndate']->formatTimestamp ($temptime, _DATE_DATESTRING9);
				if ($author != '') {
					$return = sprintf (_BBCODE_QUOTETIMEAUTHOR, $author, $tempdate, $temptime);
				} else {
					$return = sprintf (_BBCODE_QUOTETIME, $tempdate, $temptime);
				}
			} elseif ($author != '') {
				$return = sprintf (_BBCODE_QUOTEAUTHOR, $author);
			}
			if ($return != '') {
				$return = '<span class="quoteheader">' . $return . '</span>';
			}
			$return = $return . '<blockquote>' . $text;
			return $return;

		}

		function _getQuote ($author, $date, $time, $text) {

			global $opnConfig;

			$stamp = $date . ' ' . $time;
			$opnConfig['opndate']->locale2iso ($stamp);
			$opnConfig['opndate']->formatTimestamp ($stamp);
			if ($author != '') {
				return '[quote author=' . $author . ' date=' . $stamp . ']' . $text;
			}
			return '[quote date=' . $stamp . ']' . $text;

		}

		/**
		* Encodes the string
		* Removes all html tags and exchanges only the ubb tags and with html tags.
		*
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbencode (&$str) {
			if ($str <> '') {
				$vstr = $str;

				$search = array ('[bull]',
								'[trade]',
								'[euro]',
								'[sect]',
								'[copy]',
								'[reg]',
								'[deg]',
								'[hellip]',
								'[lt]',
								'[gt]',
								'[permil]',
								'[*]',
								'[/*]',
								'[hr]',
								'[table]',
								'[/table]',
								'[tr]',
								'[/tr]',
								'[td]',
								'[/td]',
								'[list]',
								'[/list]',
								'[dl]',
								'[/dl]',
								'[dt]',
								'[/dt]',
								'[dd]',
								'[/dd]',
								'[b]',
								'[/b]',
								'[move]',
								'[/move]',
								'[s]',
								'[/s]',
								'[i]',
								'[/i]',
								'[sup]',
								'[/sup]',
								'[sub]',
								'[/sub]',
								'[tt]',
								'[/tt]',
								'[pre]',
								'[/pre]',
								'[u]',
								'[/u]',
								'[left]',
								'[/left]',
								'[right]',
								'[/right]',
								'[center]',
								'[/center]',
								'[justify]',
								'[/justify]',
								'[olist=a]',
								'[olist=1]',
								'[olist]',
								'[/olist]');
				$replace = array ('&bull;',
								'&trade;',
								'&euro;',
								'&sect;',
								'&copy;',
								'&reg;',
								'&deg;',
								'&hellip;',
								'&lt;',
								'&gt;',
								'&permil;',
								'<li>',
								'</li>',
								'<hr />',
								'<table>',
								'</table>',
								'<tr>',
								'</tr>',
								'<td>',
								'</td>',
								'<ul>',
								'</ul>',
								'<dl>',
								'</dl>',
								'<dt>',
								'</dt>',
								'<dd>',
								'</dd>',
								'<strong>',
								'</strong>',
								'<marquee>',
								'</marquee>',
								'<del>',
								'</del>',
								'<em>',
								'</em>',
								'<sup>',
								'</sup>',
								'<sub>',
								'</sub>',
								'<tt>',
								'</tt>',
								'<pre>',
								'</pre>',
								'<ins>',
								'</ins>',
								'<div align="left">',
								'</div>',
								'<div align="right">',
								'</div>',
								'<div align="center">',
								'</div>',
								'<div align="justify">',
								'</div>',
								'<ol type="a">',
								'<ol type="1">',
								'<ol>',
								'</ol>');

				$str = str_replace ($search, $replace, $str);

				$search = array ("#\[code\](.*?)\[/code\]#sie",
								"#\[google\](.*?)\[/google\]#ise",
								"#\[yahoo\](.*?)\[/yahoo\]#ise",
								"#\[vivisimo\](.*?)\[/vivisimo\]#ise");
				$replace = array ("'<code>'.htmlspecialchars(un_htmlentities1('\\1')).'</code>'",
								"'<a class=\"opncenterbox\" href=\"http://www.google.com/search?q=' . urlencode(str_replace('\\\"', '\"', '\\1')) . '\" target=\"_blank\">' . str_replace('\\\"', '\"', '\\1') . '</a>'",
								"'<a class=\"opncenterbox\" href=\"http://search.yahoo.com/search?p=' . urlencode(str_replace('\\\"', '\"', '\\1')) . '\" target=\"_blank\">' . str_replace('\\\"', '\"', '\\1') . '</a>'",
								"'<a class=\"opncenterbox\" href=\"http://vivisimo.com/search?query=' . urlencode(str_replace('\\\"', '\"', '\\1')) . '&v%3Asources=Web\" target=\"_blank\">' . str_replace('\\\"', '\"', '\\1') . '</a>'");

				$str = preg_replace ($search, $replace, $str);
				if ($vstr != $str) {
					$vstr = true;
				}
				$lang = 'en';
				if (defined ('_OPN_WIKI_LANG') ) {
					$lang = _OPN_WIKI_LANG;
				}
				$search = array ("#\[align=(.*?)\](.*?)\[/align\]#si",
								"#\[size=(.*?)\](.*?)\[/size\]#si",
								"#\[font=(.*?)\](.*?)\[/font\]#si",
								"#\[url\]http://(.*?)\[/url\]#si",
								"#\[url\](.*?)\[/url\]#si",
								"#\[url=(http://)?(.*?)\](.*?)\[/url\]#si",
								"#\[url=?(.*?)\](.*?)\[/url\]#si",
								"#\[color=(.*?)\](.*?)\[/color\]#si",
								"#\[email\](.*?)\[/email\]#si",
								"#\[email=?(.*?)\](.*?)\[/email\]#si",
								"#\[img\](.*?)\[/img\]#si",
								"#\[img=?(.*?)\](.*?)\[/img\]#si",
								"#\[wikipedia\](.*?)\[/wikipedia\]#si",
								"#\[wikipedia=?(.*?)\](.*?)\[/wikipedia\]#si",
								"#\[wikibook\](.*?)\[/wikibook\]#si",
								"#\[wikibook=?(.*?)\](.*?)\[/wikibook\]#si",
								"#\[quote author=?(.*?) date=?(.*?)\](.*?)#sie",
								"#\[quote author=?(.*?)\](.*?)#sie",
								"#\[quote=?(.*?)\](.*?)#sie",
								"#\[quote date=?(.*?)\](.*?)#sie",
								"#\[quote](.*?)#sie",
								"/quote\\]/i",
								"/\[quote\]\r\n/i",
								"/\[quote\]/i",
								"/\[\/quote\]\r\n/i");
				$replace = array ("<div align=\"\\1\">\\2</div>",
								"<span style=\"font-size: \\1;\">\\2</span>",
								"<span style=\"font-family: \\1;\">\\2</span>",
								"<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\1</a>",
								"<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\1</a>",
								"<a class=\"opncenterbox\" href=\"http://\\2\" target=\"_blank\">\\3</a>",
								"<a class=\"opncenterbox\" href=\"http://\\1\" target=\"_blank\">\\2</a>",
								"<span style=\"color: \\1;\">\\2</span>",
								"<a class=\"opncenterbox\" href=\"mailto:\\1\">\\1</a>",
								"<a class=\"opncenterbox\" href=\"mailto:\\1\">\\2</a>",
								"<img src=\"\\1\" alt=\"\" title=\"\" border=\"0\" />",
								"<img src=\"\\2\" alt=\"\\1\" title=\"\\1\" border=\"0\" />",
								"<a class=\"wiki\" href=\"http://" . $lang . ".wikipedia.org/wiki/\\1\" target=\"_blank\">\\1</a>",
								"<a class=\"wiki\" href=\"http://\\1.wikipedia.org/wiki/\\2\" target=\"_blank\">\\2</a>",
								"<a class=\"wiki\" href=\"http://" . $lang . ".wikibooks.org/wiki/\\1\" target=\"_blank\">\\1</a>",
								"<a class=\"wiki\" href=\"http://\\1.wikibooks.org/wiki/\\2\" target=\"_blank\">\\2</a>",
								"\$this->_setQuote('\\1', '\\2', '\\3');",
								"\$this->_setQuote('\\1', '', '\\2');",
								"\$this->_setQuote('\\1', '', '\\2');",
								"\$this->_setQuote('', '\\1', '\\2');",
								"\$this->_setQuote('', '', '\\1');",
								"quote]",
								'<blockquote>' . _BBCODE_QUOTE . '<br />',
								'<blockquote>' . _BBCODE_QUOTE . '<br />',
								"</blockquote>\r\n");

				$str = preg_replace ($search, $replace, $str);
				unset ($search);
				unset ($replace);
				// make lower case
				$str = str_replace ('[/quote]', '</blockquote>', $str);
				// $str = str_replace(_OPN_HTML_NL, '<br />', $str);
				// opn_nl2br($str);
				if ($vstr === true) {
					$str = str_replace ('\\&quot;', '&quot;', $str);
				}
			}

		}

		/**
		* Replace the occurence of a BBCode Tag with placeholders.
		*
		* @param $str		The string where the BBCode should be replaced
		* @param $tag		The Tag to be replaced
		* @param $tagarray	The Resultarray with the Tags for restoring the tags
		*/

		function replace_ubb_tag (&$str, $tag, &$tagarray) {

			preg_match_all ("=\[" . $tag . "[^\]]*\](.*)\[/" . $tag . "\]=si", $str, $tagarray);
			$max = count ($tagarray[0]);
			for ($i = 0; $i< $max; $i++) {
				$str = preg_replace ('=' . preg_quote ($tagarray[0][$i]) . '=siU', ':' . $tag . $i . ':', $str);
			}

		}

		/**
		* Replace the placeholders with the BBCode Tag
		*
		* @param $str			The string where the Placeholders should be replaced
		* @param $replacment	The BBCode Tag for replacement
		* @param $tagarray		The Tagarray with the Tag content
		*/

		function restore_ubb_tag (&$str, $replacment, $tagarray) {
			$max = count ($tagarray[0]);
			for ($i = 0; $i< $max; $i++) {
				$str = preg_replace ('=' . preg_quote (':' . $replacment . $i . ':') . '=siU', $tagarray[0][$i], $str);
			}

		}

		/**
		* Replace the [wikipedia] tags
		*
		* @param $content
		*/

		function Replace_WikiCode (&$content) {

			$this->replace_ubb_tag ($content, 'wikipedia', $this->_tags['wikipedia'] = array () );
			$this->replace_ubb_tag ($content, 'wikibook', $this->_tags['wikibook'] = array () );

		}

		/**
		* Restore the [wikipedia] tags
		*
		* @param $content
		*/

		function Restore_WikiCode (&$content) {

			$this->restore_ubb_tag ($content, 'wikipedia', $this->_tags['wikipedia']);
			$this->restore_ubb_tag ($content, 'wikibook', $this->_tags['wikibook']);
			$this->_tags['wikipedia'] = array ();
			$this->_tags['wikivooks'] = array ();

		}

		/**
		* Replace the [url] tags
		*
		* @param $content
		*/

		function Replace_UrlCode (&$content) {

			$this->replace_ubb_tag ($content, 'url', $this->_tags['url'] = array () );

		}

		/**
		* Restore the [url] tags
		*
		* @param $content
		*/

		function Restore_UrlCode (&$content) {

			$this->restore_ubb_tag ($content, 'url', $this->_tags['url']);
			$this->_tags['url'] = array ();

		}

		/**
		* Replace the [email] tags
		*
		* @param $content
		*/

		function Replace_EmailCode (&$content) {

			$this->replace_ubb_tag ($content, 'email', $this->_tags['email'] = array () );

		}

		/**
		* Restore the [email] tags
		*
		* @param $content
		*/

		function Restore_EmailCode (&$content) {

			$this->restore_ubb_tag ($content, 'email', $this->_tags['email']);
			$this->_tags['email'] = array ();

		}

		/**
		* Replace the [quote] tags
		*
		* @param $content
		*/

		function Replace_QuoteCode (&$content) {

			$this->replace_ubb_tag ($content, 'quote', $this->_tags['quote'] = array () );

		}

		/**
		* Restore the [quote] tags
		*
		* @param $content
		*/

		function Restore_QuoteCode (&$content) {

			$this->restore_ubb_tag ($content, 'quote', $this->_tags['quote']);
			$this->_tags['quote'] = array ();

		}

		/**
		* Replace the [code] tags
		*
		* @param $content
		*/

		function Replace_CodeCode (&$content) {

			$this->replace_ubb_tag ($content, 'code', $this->_tags['code'] = array () );

		}

		/**
		* Restore the [code] tags
		*
		* @param $content
		*/

		function Restore_CodeCode (&$content) {

			$this->restore_ubb_tag ($content, 'code', $this->_tags['code']);
			$this->_tags['code'] = array ();

		}

		/**
		* Replace special BBCode Tags
		*
		* @param $content
		*/

		function Replace_SpecialCodes (&$content) {

			$this->Replace_WikiCode ($content);
			$this->Replace_EmailCode ($content);
			$this->Replace_UrlCode ($content);
			$this->Replace_CodeCode ($content);
			$this->Replace_QuoteCode ($content);

		}

		/**
		* Restore special BBCode Tags
		*
		* @param $content
		*/

		function Restore_SpecialCodes (&$content) {

			$this->Restore_QuoteCode ($content);
			$this->Restore_CodeCode ($content);
			$this->Restore_UrlCode ($content);
			$this->Restore_EmailCode ($content);
			$this->Restore_WikiCode ($content);

		}

		/**
		* Strips all UBB tags
		* Removes all ubb tags and leaves only plain text
		*
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbstrip (&$str) {
			if ($str <> '') {
				$str = preg_replace ("[\[(.*?)\]]", "", $str);
			}

		}

		/**
		* Decodes the string
		* Removes the html tags and replaces them with ubb code tags
		*
		* @access   public
		* @param	String	  $str
		*/

		function ubbdecode (&$str) {
			if ($str <> '') {
				$search = array ('&bull;',
								'&trade;',
								'&euro;',
								'&sect;',
								'&copy;',
								'&reg;',
								'&deg',
								'&hellip;',
								'&lt;',
								'&gt;',
								'&permil;',
								'<marquee>',
								'</marquee>',
								'<table>',
								'</table>',
								'<tr>',
								'</tr>',
								'<td>',
								'</td>',
								'<strong>',
								'</strong>',
								'<b>',
								'</b>',
								'<sup>',
								'</sup>',
								'<sub>',
								'</sub>',
								'<tt>',
								'</tt>',
								'<pre>',
								'</pre>',
								'<del>',
								'</del>',
								'<em>',
								'</em>',
								'<i>',
								'</i>',
								'<ins>',
								'</ins>',
								'<dl>',
								'</dl>',
								'<dt>',
								'</dt>',
								'<dd>',
								'</dd>',
								'<hr />',
								'<code>',
								'</code>',
								'<blockquote>' . _BBCODE_QUOTE . '<br />',
								'<blockquote>' . _BBCODE_QUOTE . '<br>',
								'<blockquote>' . _BBCODE_QUOTE . _OPN_HTML_NL,
								'<blockquote>',
								'</blockquote>',
								'<ul>',
								'</ul>',
								'<ol type="a">',
								'<ol type="1">',
								'<ol>',
								'</ol>',
								'<li>',
								'</li>',
								'<br />' . _OPN_HTML_NL,
								'<br />',
								'<br>');
				$replace = array ('[bull]',
								'[trade]',
								'[euro]',
								'[sect]',
								'[copy]',
								'[reg]',
								'[deg]',
								'[hellip]',
								'[lt]',
								'[gt]',
								'[permil]',
								'[move]',
								'[/move]',
								'[table]',
								'[/table]',
								'[tr]',
								'[/tr]',
								'[td]',
								'[/td]',
								'[b]',
								'[/b]',
								'[b]',
								'[/b]',
								'[sup]',
								'[/sup]',
								'[sub]',
								'[/sub]',
								'[tt]',
								'[/tt]',
								'[pre]',
								'[/pre]',
								'[s]',
								'[/s]',
								'[i]',
								'[/i]',
								'[i]',
								'[/i]',
								'[u]',
								'[/u]',
								'[dl]',
								'[/dl]',
								'[dt]',
								'[/dt]',
								'[dd]',
								'[/dd]',
								'[hr]',
								'[code]',
								'[/code]',
								'[quote]',
								'[quote]',
								'[quote]',
								'[quote]',
								'[/quote]',
								'[list]',
								'[/list]',
								'[olist=a]',
								'[olist=1]',
								'[olist]',
								'[/olist]',
								'[*]',
								'[/*]',
								_OPN_HTML_NL,
								_OPN_HTML_NL,
								_OPN_HTML_NL);

				$str = str_replace ($search, $replace, $str);

				$search = array ("#<div align=\"left\">(.*?)</div>#si",
								"#<div align=\"right\">(.*?)</div>#si",
								"#<div align=\"center\">(.*?)</div>#si",
								"#<div align=\"justify\">(.*?)</div>#si",
								"#<div align=\"(.*?)\">(.*?)</div>#si",
								"#<span style=\"font-size: (.*?);\">(.*?)</span>#si",
								"#<span style=\"font-family: (.*?);\">(.*?)</span>#si",
								"#<span style=\"color: (.*?);\">(.*?)</span>#si",
								"#<a class=\"opncenterbox\" href=\"http://www\.google\.com/search\?q=(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a class=\"opncenterbox\" href=\"http://search\.yahoo\.com/search\?p=(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a class=\"opncenterbox\" href=\"http://vivisimo\.com/search\?query=(.*?)&v%3Asources=Web\" target=\"_blank\">(.*?)</a>#si",
								"#<a class=\"wiki\" href=\"http://(.*?).wikipedia.org/wiki/(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a class=\"wiki\" href=\"http://(.*?).wikibooks.org/wiki/(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a href=\"(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a class=\"opncenterbox\" href=\"(.*?)\" target=\"_blank\">(.*?)</a>#si",
								"#<a href=\"mailto:(.*?)\">(.*?)</a>#si",
								"#<a class=\"opncenterbox\" href=\"mailto:(.*?)\">(.*?)</a>#si",
								"#<img src=\"(.*?)\" alt=\"\" />#si",
								"#<img src=\"(.*?)\" alt=\"\" border=\"0\" />#si",
								"#<img src=\"(.*?)\" alt=\"\" title=\"\" border=\"0\" />#si",
								"#<img src=\"(.*?)\" alt=\"(.*?)\" title=\"(.*?)\" border=\"0\" />#si",
								"#<img src=\"(.*?)\" alt=\"(.*?)\" border=\"0\" />#si",
								"#<img src=\"(.*?)\" alt=\"(.*?)\" />#si",
								"#<img src=\"(.*?)\" />#si",
								"#<img src=\"(.*?)\">#si",
								"#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTEAUTHOR, '(.*?)') . '</span><blockquote>(.*?)#si',
								"#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTETIME, '(.*?)', '(.*?)') . '</span><blockquote>(.*?)#sie',
								"#<span class=\"quoteheader\">" . sprintf (_BBCODE_QUOTETIMEAUTHOR, '(.*?)', '(.*?)', '(.*?)') . '</span><blockquote>(.*?)#sie');
				$replace = array ("[left]\\1[/left]",
								"[right]\\1[/right]",
								"[center]\\1[/center]",
								"[justify]\\1[/justify]",
								"[align=\\1]\\2[/align]",
								"[size=\\1]\\2[/size]",
								"[font=\\1]\\2[/font]",
								"[color=\\1]\\2[/color]",
								"[google]\\2[/google]",
								"[yahoo]\\2[/yahoo]",
								"[vivisimo]\\2[/vivisimo]",
								"[wikipedia=\\1]\\3[/wikipedia]",
								"[wikibook=\\1]\\3[/wikibook]",
								"[url=\\1]\\2[/url]",
								"[url=\\1]\\2[/url]",
								"[email=\\1]\\2[/email]",
								"[email=\\1]\\2[/email]",
								"[img]\\1[/img]",
								"[img]\\1[/img]",
								"[img]\\1[/img]",
								"[img=\\2]\\1[/img]",
								"[img=\\2]\\1[/img]",
								"[img=\\2]\\1[/img]",
								"[img]\\1[/img]",
								"[img]\\1[/img]",
								'[quote=\\1]\\2',
								"\$this->_getQuote('','\\1','\\2','\\3')",
								"\$this->_getQuote('\\1','\\2','\\3','\\4')");

				$str = preg_replace ($search, $replace, $str);
				unset ($search);
				unset ($replace);
			}

		}

		/**
		* Dumps the code tags
		* Displays a <pre> block with the "ubb_def" css style class
		*
		* @access   public
		* @param	String	  $str
		*/

		function listCodes (&$str) {

			getLanguageDef (_OPN_ROOT_PATH . 'language/ubbcode/language/');
			$str = '<div style="margin-left:10px; margin-right:10px;"><div class="normaltextbold" align="center">' . _BBCODE_DEF_WHATISBBCODE . '</div><br />';
			$table =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_TableClass ('default');
			$table->AddDataRow (array (_BBCODE_DEF_BBCODEDESCRIPTION . '<br />' . _BBCODE_DEF_DISPLAY_BBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_CURRENTBBCODES . '</span>'), array ('center') );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_URLHYPERLINKING . '</span>') );
			$hlp = _BBCODE_DEF_URLHYPERLINKINGINBBCODE;
			$hlp .= '<ul><li>http://' . _BBCODE_DEF_YOURDOMAINEXAMPLE . '</li><li>' . _BBCODE_DEF_YOURDOMAINEXAMPLE . '</li></ul>';
			$table->AddDataRow (array ($hlp) );
			$table->AddDataRow (array (_BBCODE_DEF_URLHYPERLINKINGEXAMPLES) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_EMAILLINK . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_EMAILLINKINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_ADDINGIMAGE . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_ADDINGIMAGEINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_BOLDANDITALICS . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_BOLDANDITALICSINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_BULLETSLISTS . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_BULLETSLISTSINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_QUOTING . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_QUOTINGINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array ('<span class="normaltextbold">' . _BBCODE_DEF_CODETAG . '</span>') );
			$table->AddDataRow (array (_BBCODE_DEF_CODETAGINBBCODE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array (_BBCODE_DEF_OFNOTE) );
			$table->AddDataRow (array ('&nbsp;') );
			$table->AddDataRow (array (_BBCODE_DEF_INCORRECTBBCODE) );
			$table->GetTable ($str);
			$str .= '</div>';

		}

		function putbbcode ($tabindex, $elem, $smilieid = '', $userimagesid = '') {

			getLanguageDef (_OPN_ROOT_PATH . 'language/ubbcode/language/');
			$this->_elem = 'document.' . $elem;
			$form =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_FormularClass ('default');
			$form->AddTable ();
			$form->AddOpenRow ();
			$form->SetValign ('middle');
			$form->SetValignTab ('middle');
			$form->SetSameCol ();
			$this->build_bbcode1_image (_BBCODE_BOLD, _BBCODE_HTML_BOLD, 'b', 'bold.gif', $form);
			$this->build_bbcode1_image (_BBCODE_ITALIC, _BBCODE_HTML_ITALIC, 'i', 'italicize.gif', $form);
			$this->build_bbcode1_image (_BBCODE_UNDERLINE, _BBCODE_HTML_UNDERLINE, 'u', 'underline.gif', $form);
			$this->build_bbcode1_image (_BBCODE_STRIKE, _BBCODE_HTML_STRIKE, 's', 'strike.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_SUPERSCRIPT, _BBCODE_HTML_SUPERSCRIPT, 'sup', 'sup.gif', $form);
			$this->build_bbcode1_image (_BBCODE_SUBSCRIPT, _BBCODE_HTML_SUBSCRIPT, 'sub', 'sub.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TT, _BBCODE_HTML_TT, 'tt', 'tele.gif', $form);
			$this->build_bbcode1_image (_BBCODE_MARQUEE, '', 'move', 'move.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_PRE, _BBCODE_HTML_PRE, 'pre', 'pre.gif', $form);
			$this->build_bbcode1_image (_BBCODE_LEFT, '', 'left', 'left.gif', $form);
			$this->build_bbcode1_image (_BBCODE_CENTER, '', 'center', 'center.gif', $form);
			$this->build_bbcode1_image (_BBCODE_RIGHT, '', 'right', 'right.gif', $form);
			$this->build_bbcode1_image (_BBCODE_JUSTIFY, '', 'justify', 'justify.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_HR, '', 'hr', 'hr.gif', $form);
			// $this->_add_bbcode_ruler ($form);
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$this->build_bbcode_image (_BBCODE_IMAGE, 'image', 'img.gif', $form);
			$this->build_bbcode_image (_BBCODE_EMAIL, 'email', 'email.gif', $form);
			$this->build_bbcode_image (_BBCODE_URL, 'url', 'url.gif', $form);
			$this->build_bbcode_image (_BBCODE_WIKI, 'wikipedia', 'wiki.png', $form);
			$this->build_bbcode_image (_BBCODE_WIKIBOOK, 'wikibook', 'wiki.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_QUOTE1, '', 'quote', 'quote.gif', $form);
			$this->build_bbcode1_image (_BBCODE_CODE, '', 'code', 'code.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_LIST, '', 'list', 'ul.png', $form);
			$this->build_bbcode1_image (_BBCODE_LISTORDER, '', 'olist', 'ol.png', $form);
			$this->build_bbcode_image (_BBCODE_LISTITEM, 'listitem', 'list.gif', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_DEFLIST, '', 'dl', 'dl.png', $form);
			$this->build_bbcode1_image (_BBCODE_DEFTERM, '', 'dt', 'dt.png', $form);
			$this->build_bbcode1_image (_BBCODE_DEFDEFINITION, '', 'dd', 'dd.png', $form);
			$this->_add_bbcode_ruler ($form);
			$this->build_bbcode1_image (_BBCODE_TABLE, '', 'table', 'table.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TABLEROW, '', 'tr', 'tr.gif', $form);
			$this->build_bbcode1_image (_BBCODE_TABLECOL, '', 'td', 'td.gif', $form);
			if ( ($smilieid != '') || ($userimagesid != '') ) {
				$this->_add_bbcode_ruler ($form);
				if ($smilieid != '') {
					$url = '';
					$this->_build_bbcode_image ($url, 'smilie.gif', _BBCODE_SMILIESSHOW);
					$url = '<a href="javascript:blocking(\'' . $smilieid . '\')">' . $url . '</a>';
					$form->AddText ($url);
				}
				if ($userimagesid != '') {
					$url = '';
					$this->_build_bbcode_image ($url, 'imgpool.gif', _BBCODE_IMGSHOW);
					$url = '<a href="javascript:blocking(\'' . $userimagesid . '\')">' . $url . '</a>';
					$form->AddText ($url);
				}
			}
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$options = array ();
			$options[''] = _BBCODE_FONTSIZE;
			for ($i = 8; $i<25; $i++) {
				$options[$i] = $i;
			}
			$elem1 = explode ('.', $elem);
			$elem1 = $elem1[0];
			$form->AddSelect ('size', $options, _BBCODE_FONTSIZE, 'setbbcodefontsize(document.' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex);
			$options = array ();
			$options[''] = _BBCODE_FONT;
			$options['Arial'] = _BBCODE_FONT_ARIAL;
			$options['Courier'] = _BBCODE_FONT_COURIER;
			$options['Geneva'] = _BBCODE_FONT_GENEVA;
			$options['Helvetica'] = _BBCODE_FONT_HELVETICA;
			$options['Impact'] = _BBCODE_FONT_IMPACT;
			$options['Monospace'] = _BBCODE_FONT_MONOSPACE;
			$options['Optima'] = _BBCODE_FONT_OPTIMA;
			$options['Times'] = _BBCODE_FONT_TIMES;
			$options['Times New Roman'] = _BBCODE_FONT_TIMES_NEW_ROMAN;
			$options['Verdana'] = _BBCODE_FONT_VERDANA;
			$form->AddSelect ('font', $options, _BBCODE_FONT, 'setbbcodefont(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex, '', 'font-family');
			$options = array ();
			$options[''] = _BBCODE_SELECT_COLOR;
			$options['Black'] = _BBCODE_BLACK;
			$options['Red'] = _BBCODE_RED;
			$options['Yellow'] = _BBCODE_YELLOW;
			$options['Pink'] = _BBCODE_PINK;
			$options['Green'] = _BBCODE_GREEN;
			$options['Orange'] = _BBCODE_ORANGE;
			$options['Purple'] = _BBCODE_PURPLE;
			$options['Blue'] = _BBCODE_BLUE;
			$options['Beige'] = _BBCODE_BEIGE;
			$options['Brown'] = _BBCODE_BROWN;
			$options['Teal'] = _BBCODE_TEAL;
			$options['Navy'] = _BBCODE_NAVY;
			$options['Maroon'] = _BBCODE_MAROON;
			$options['LimeGreen'] = _BBCODE_LIMEGREEN;
			$form->AddSelect ('color', $options, _BBCODE_SELECT_COLOR, 'setbbcodecolor(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex, '', 'color');
			$options = array ();
			$options[''] = _BBCODE_SPECIAL_CHARS;
			$options['lt'] = _BBCODE_SPECIAL_LESS;
			$options['gt'] = _BBCODE_SPECIAL_GREATER;
			$options['bull'] = _BBCODE_SPECIAL_BULLET;
			$options['euro'] = _BBCODE_SPECIAL_EURO;
			$options['sect'] = _BBCODE_SPECIAL_PARAGRAPH;
			$options['copy'] = _BBCODE_SPECIAL_COPYRIGTH;
			$options['reg'] = _BBCODE_SPECIAL_REGISTERED;
			$options['trade'] = _BBCODE_SPECIAL_TRADEMARK;
			$options['deg'] = _BBCODE_SPECIAL_DEGREE;
			$options['permil'] = _BBCODE_SPECIAL_PERMILLE;
			$options['hellip'] = _BBCODE_SPECIA_HELL;
			$form->AddSelect ('chars', $options, _BBCODE_SPECIAL_CHARS, 'setbbcodechar(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex);
			$options = array ();
			$options[''] = _BBCODE_SEARCHENGINES;
			$options['google'] = _BBCODE_SEARCHENGINES_GOOGLE;
			$options['yahoo'] = _BBCODE_SEARCHENGINES_YAHOO;
			$options['vivisimo'] = _BBCODE_SEARCHENGINES_VIVISIMO;
			$form->AddSelect ('search', $options, _BBCODE_SEARCHENGINES, 'setbbcodesearch(' . $elem . ', this' . ');this.selectedIndex=0', 0, 0, 1, 'select', $tabindex);
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$txt = '';
			$form->GetFormular ($txt);

			/*			$txt .= '<script type="text/javascript">'._OPN_HTML_NL;
			$txt .= '<!--'._OPN_HTML_NL;
			$txt .= 'addInfobox();'._OPN_HTML_NL;
			$txt .= '//-->'._OPN_HTML_NL.'</script>'._OPN_HTML_NL; */
			return $txt;

		}

		function build_bbcode_setspan_image ($text, $what, $what1, $image, &$form) {

			$wichFunction = 'setbbcodespan(' . $this->_elem . ',\'%s\',\'%s\');';
			$url = sprintf ($wichFunction, $what, $what1);
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function build_bbcode_image ($text, $what, $image, &$form) {

			$url = 'DoPromptBBcode(' . $this->_elem . ',\'' . $what . '\');';
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function build_bbcode1_image ($text, $text1, $bbcode, $image, &$form) {

			$t = $text1;
			$url = 'setbbcode(' . $this->_elem . ',\'' . $bbcode . '\');';
			$this->_build_bbcode_image ($url, $image, $text);
			$form->AddText ($url);

		}

		function _build_bbcode_image (&$url, $image, $text) {

			global $opnConfig;

			$url = '<img onclick="' . $url . '"onmouseover="bbc_highlight(this, true);" onmouseout="if (window.bbc_highlight) bbc_highlight(this, false);"';
			$url .= ' src="' . $opnConfig['opn_default_images'] . 'bbcode/' . $image . '"';
			$url .= ' width="23" height="22" alt="' . $text . '" title="' . $text . '"';
			$url .= ' style="background-image: url(' . $opnConfig['opn_default_images'] . 'bbcode/bbc_bg.gif);" class="editorimage" />';

		}

		function _add_bbcode_ruler (&$form) {

			global $opnConfig;

			$form->AddText ('<img src="' . $opnConfig['opn_default_images'] . 'bbcode/divider.gif" alt="|" style="margin: 0 3px 0 3px;" />');

		}

	}
}

?>