<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* Abstract base class for forms
*
* @author		Stefan Kaletta	stefan@kaletta.de
*
*
* @package	 engine
* @subpackage  form
*/

class opnForm {

	/**
	* @access  private
	*/

	/**
	* "action" attribute for the html form
	* @var string $_action
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_action;

	/**
	* "method" attribute for the form.
	* @var string $_method
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_method;

	/**
	* "name" attribute of the form
	* @var string $_name
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_name;

	/**
	* title for the form
	* @var string $_title
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_title;

	/**
	* class for the form
	* @var string $_class
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_class;

	/**
	* enctype for the form
	* @var string $_enctype
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_enctype;

	/**
	* class for the form
	* @var string $_onsubmit
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_onsubmit;

	/**
	* class for the form
	* @var string $_target
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_target;

	/**
	* array of {@link opnFormElement} objects
	* @var  array $_elements
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_elements = array ();

	/**
	* extra information for the <form> tag
	* @var string $_extra
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_extra;

	/**
	* required elements
	* @var array $_required
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_required = array ();

	/**
	* required elements
	* @var array $default_set
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $default_set = 'default';

	/**
	* required elements
	* @var array $form
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $form = false;

	/**
	* required opn_Object
	* @var object $_opn_object element typ opn_Object
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_opn_object = false;

	/**
	* constructor
	*
	* @param	string  $title  title of the form
	* @param	string  $name   "name" attribute for the <form> tag
	* @param	string  $action "action" attribute for the <form> tag
	* @param   string  $method "method" attribute for the <form> tag
	* @param   string  $method "enctype" attribute for the <form> tag
	* @param   string  $method "onsubmit" attribute for the <form> tag
	* @param   string  $method "target" attribute for the <form> tag
	* @param   string  $method "class" attribute for the <form> tag
	* @param   bool	$addtoken whether to add a security token to the form
	*/

	function opnForm ($title, $name, $action, $method = "post", $enctype = '', $onsubmit = '', $target = '', $class = 'form', $addtoken = false) {

		$this->_title = $title;
		$this->_name = $name;
		$this->_action = $action;
		$this->_method = $method;
		$this->_enctype = $enctype;
		$this->_onsubmit = $onsubmit;
		$this->_target = $target;
		$this->_class = $class;
		if ($addtoken != false) {
			// later
		}
		$this->form =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_FormularClass ($this->default_set);

	}

	/**
	* return the title of the form
	*
	* @return string
	*/

	function getTitle () {
		return $this->_title;

	}

	/**
	* return the class of the form
	*
	* @return string
	*/

	function getClass () {
		return $this->_class;

	}

	/**
	* get the "name" attribute for the <form> tag
	*
	* @return string
	*/

	function getName () {
		return $this->_name;

	}

	/**
	* get the "action" attribute for the <form> tag
	*
	* @return string
	*/

	function getAction () {
		return $this->_action;

	}

	/**
	* get the "method" attribute for the <form> tag
	*
	* @return string
	*/

	function getMethod () {
		return $this->_method;

	}

	/**
	* Add an element to the form
	*
	* @param	object  &$formElement	reference to a {@link opnFormElement}
	* @param	bool	$required	   is this a "required" element?
	*/

	function addElement (&$formElement, $required = false) {
		if (is_string ($formElement) ) {
			$this->_elements[] = $formElement;
		} elseif (is_subclass_of ($formElement, 'opnFormelement') ) {
			$this->_elements[] = &$formElement;
			if ($required) {
				if (!$formElement->isContainer () ) {
					$this->_required[] = &$formElement;
				} else {
					$required_elements = &$formElement->getRequired ();
					$count = count ($required_elements);
					for ($i = 0; $i< $count; $i++) {
						$this->_required[] = &$required_elements[$i];
					}
				}
			}
		}
		$formElement->_formname = $this->getName ();

	}

	/**
	* get an array of forms elements
	*
	* @param	bool	get elements recursively?
	* @return	array   array of {@link opnFormElement}s
	*/

	function &getElements ($recurse = false) {
		if (!$recurse) {
			return $this->_elements;
		}
		$ret = array ();
		$count = count ($this->_elements);
		for ($i = 0; $i< $count; $i++) {
			if (!$this->_elements[$i]->isContainer () ) {
				$ret[] = &$this->_elements[$i];
			} else {
				$elements = &$this->_elements[$i]->getElements (true);
				$count2 = count ($elements);
				for ($j = 0; $j< $count2; $j++) {
					$ret[] = &$elements[$j];
				}
				unset ($elements);
			}
		}
		return $ret;

	}

	/**
	* get an array of "name" attributes of form elements
	*
	* @return	array   array of form element names
	*/

	function getElementNames () {

		$ret = array ();
		$elements = &$this->getElements (true);
		$count = count ($elements);
		for ($i = 0; $i< $count; $i++) {
			$ret[] = $elements[$i]->getName ();
		}
		return $ret;

	}

	/**
	* get a reference to a {@link opnFormElement} object by its "name"
	*
	* @param  string  $name	"name" attribute assigned to a {@link opnFormElement}
	* @return object
	*/

	function &getElementByName ($name) {

		$elements = &$this->getElements (true);
		$count = count ($elements);
		$ret = false;
		for ($i = 0; $i< $count; $i++) {
			if ($name == $elements[$i]->getName () ) {
				$ret = $elements[$i];
			}
		}
		return $ret;

	}

	/**
	* Sets the "value" attribute of a form element
	*
	* @param	string $name	the "name" attribute of a form element
	* @param	string $value	the "value" attribute of a form element
	*/

	function setElementValue ($name, $value) {

		$ele = &$this->getElementByName ($name);
		if (is_object ($ele) && method_exists ($ele, 'setValue') ) {
			$ele->setValue ($value);
		}

	}

	/**
	* Sets the "value" attribute of form elements in a batch
	*
	* @param	array $values	array of name/value pairs to be assigned to form elements
	*/

	function setElementValues ($values) {
		if (is_array ($values) && !empty ($values) ) {
			// will not use getElementByName() for performance..
			$elements = &$this->getElements (true);
			$count = count ($elements);
			for ($i = 0; $i< $count; $i++) {
				$name = $elements[$i]->getName ();
				if ($name && isset ($values[$name]) && method_exists ($elements[$i], 'setValue') ) {
					$elements[$i]->setValue ($values[$name]);
				}
			}
		}

	}

	/**
	* Gets the "value" attribute of a form element
	*
	* @param	string 	$name	the "name" attribute of a form element
	* @return string 	the "value" attribute assigned to a form element, null if not set
	*/

	function &getElementValue ($name) {

		$ele = &$this->getElementByName ($name);
		if (is_object ($ele) && method_exists ($ele, 'getValue') ) {
			return $ele->getValue ();
		}
		return;

	}

	/**
	* gets the "value" attribute of all form elements
	*
	* @return	array 	array of name/value pairs assigned to form elements
	*/

	function &getElementValues () {
		// will not use getElementByName() for performance..
		$elements = &$this->getElements (true);
		$count = count ($elements);
		$values = array ();
		for ($i = 0; $i< $count; $i++) {
			$name = $elements[$i]->getName ();
			if ($name && method_exists ($elements[$i], 'getValue') ) {
				$values[$name] = &$elements[$i]->getValue ();
			}
		}
		return $values;

	}

	/**
	* set the extra attributes for the <form> tag
	*
	* @param	string  $extra  extra attributes for the <form> tag
	*/

	function setExtra ($extra) {

		$this->_extra = " " . $extra;

	}

	/**
	* get the extra attributes for the <form> tag
	*
	* @return string
	*/

	function &getExtra () {
		if (isset ($this->_extra) ) {
			return $this->_extra;
		}
		return '';

	}

	/**
	* make an element "required"
	*
	* @param	object  &$formElement	reference to a {@link opnFormElement}
	*/

	function setRequired (&$formElement) {

		$this->_required[] = &$formElement;

	}

	/**
	* get an array of "required" form elements
	*
	* @return	array   array of {@link opnFormElement}s
	*/

	function &getRequired () {
		return $this->_required;

	}

	/**
	* set the Object
	*
	* @param	object  &$opnobject	reference to a {@link opn_object}
	*/

	function setObject (&$opnobject) {

		$this->_opn_object = &$opnobject;

	}

	/**
	* get the Object
	*
	* @return	object  &$opnobject	reference to a {@link opn_object}
	*/

	function getObject () {
		return $this->_opn_object;

	}

	/**
	* insert a break in the form
	*
	* This method is abstract. It must be overwritten in the child classes.
	*
	* @param	string  $extra  extra information for the break
	* @abstract
	*/

	function insertBreak ($extra = null) {

		$x = $extra;

	}

	/**
	* returns renderered form
	*
	* This method is abstract. It must be overwritten in the child classes.
	*
	* @abstract
	*/

	function render () {

	}

	/**
	* displays rendered form
	*/

	function display (&$boxtxt) {

		$boxtxt .= $this->render ();

	}

}

?>