<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
*
* select for opn date form field
*
* @package engine
* @subpackage form
*
* @author Stefan Kaletta stefan@kaletta.de
*
*/

class opnFormopndate extends opnFormElement {

	/**
	* Initial text
	* @var string
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_value;

	/**
	* Constructor
	*
	* @param	string	$caption	Caption
	* @param	string	$name		"name" attribute
	* @param	string	$value		Initial	text
	*/

	function opnFormopndate ($caption, $name, $value = '') {

		$this->setCaption ($caption);
		$this->setName ($name);
		$this->setValue ($value);

	}

	/**
	* Get initial text value
	*
	* @return string
	*/

	function getValue () {
		return $this->_value;

	}

	/**
	* Set initial text	value
	*
	* @param	$value	string
	*/

	function setValue ($value) {

		$this->_value = $value;

	}

	/**
	* Prepare HTML	for	output
	*
	* @return string	HTML
	*/

	function render (&$form) {

		global $opnConfig;

		$opnConfig['opndate']->now ();
		if (!isset ($month) ) {
			$month = 0;
		}
		if ($month == 0) {
			$opnConfig['opndate']->getMonth ($month);
		}
		if (!isset ($day) ) {
			$day = 0;
		}
		if ($day == 0) {
			$opnConfig['opndate']->getDay ($day);
		}
		if (!isset ($hour) ) {
			$hour = 0;
		}
		if ($hour == 0) {
			$opnConfig['opndate']->getHour ($hour);
		}
		if (!isset ($min) ) {
			$min = 0;
		}
		if ($min == 0) {
			$opnConfig['opndate']->getMinute ($min);
		}
		if (!isset ($year) ) {
			$year = 0;
		}
		if ($year == '') {
			$opnConfig['opndate']->getYear ($year);
		}
		$form->AddText ($this->getCaption () );
		$temp = '';
		$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
		$form->SetSameCol ();
		$options = array ();
		$xday = 1;
		while ($xday<=31) {
			$day1 = sprintf ('%02d', $xday);
			$options[$day1] = $day1;
			$xday++;
		}
		$form->AddLabel ($this->getName () . 'day', _OPN_ENGINE_FORM_DAY);
		$form->AddSelect ($this->getName () . 'day', $options, sprintf ('%02d', $day) );
		$xmonth = 1;
		$options = array ();
		while ($xmonth<=12) {
			$month1 = sprintf ('%02d', $xmonth);
			$options[$month1] = $month1;
			$xmonth++;
		}
		$form->AddLabel ($this->getName () . 'month', _OPN_ENGINE_FORM_MONTH);
		$form->AddSelect ($this->getName () . 'month', $options, sprintf ('%02d', $month) );
		$form->AddLabel ($this->getName () . 'year', _OPN_ENGINE_FORM_YEAR);
		$form->AddTextfield ($this->getName () . 'year', 5, 4, $year);
		$xhour = 0;
		$options = array ();
		while ($xhour<=23) {
			$hour1 = sprintf ('%02d', $xhour);
			$options[$hour1] = $hour1;
			$xhour++;
		}
		$form->AddLabel ($this->getName () . 'hour', _OPN_ENGINE_FORM_HOUR);
		$form->AddSelect ($this->getName () . 'hour', $options, sprintf ('%02d', $hour) );
		$xmin = 0;
		$options = array ();
		while ($xmin<=59) {
			$min1 = sprintf ('%02d', $xmin);
			$options[$min1] = $min1;
			$xmin = $xmin+5;
		}
		$min = floor ($min/5)*5;
		$form->AddLabel ($this->getName () . 'min', ' : ');
		$form->AddSelect ($this->getName () . 'min', $options, sprintf ('%02d', $min) );
		$form->AddText (' : 00');
		$form->SetEndCol ();
		// $form->AddLabel($this->getName(), $this->getCaption());
		// $form->AddSelect($this->getName(),$options,$this->getValue());

	}

}

?>