<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* A select field
*
* @package engine
* @subpackage form
*
* @author Stefan Kaletta stefan@kaletta.de
*
*/

class opnFormSelect extends opnFormElement {

	/**
	* Options
	* @var array
	* @access	private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_options = array ();

	/**
	* Allow multiple selections?
	* @var	bool
	* @access	private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_multiple = false;

	/**
	* Number of rows. "1" makes a dropdown list.
	* @var	int
	* @access	private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_size;

	/**
	* Value
	* @var string
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_value;

	/**
	* Constructor
	*
	* @param	string	$caption	Caption
	* @param	string	$name       "name" attribute
	* @param	mixed	$value	    Pre-selected value (or array of them).
	* @param	int	$size	    Number or rows. "1" makes a drop-down-list
	* @param	bool    $multiple   Allow multiple selections?
	*/

	function opnFormSelect ($caption, $name, $value = null, $size = 1, $multiple = false) {

		$this->setCaption ($caption);
		$this->setName ($name);
		$this->_multiple = $multiple;
		$this->_size = intval ($size);
		if (isset ($value) ) {
			$this->setValue ($value);
		}

	}

	/**
	* Are multiple selections allowed?
	*
	* @return	bool
	*/

	function isMultiple () {
		return $this->_multiple;

	}

	/**
	* Get the size
	*
	* @return	int
	*/

	function getSize () {
		return $this->_size;

	}

	/**
	* Get the "value" attribute
	*
	* @return string
	*/

	function getValue () {
		return $this->_value;

	}

	/**
	* Set pre-selected values
	*
	* @param	$value	mixed
	*/

	function setValue ($value) {
		if (is_array ($value) ) {
			foreach ($value as $v) {
				$this->_value[] = $v;
			}
		} else {
			$this->_value[] = $value;
		}

	}

	/**
	* Add an option
	*
	* @param	string  $value  "value" attribute
	* @param	string  $name   "name" attribute
	*/

	function addOption ($value, $name = "") {
		if ($name != "") {
			$this->_options[$value] = $name;
		} else {
			$this->_options[$value] = $value;
		}

	}

	/**
	* Add multiple options
	*
	* @param	array   $options    Associative array of value->name pairs
	*/

	function addOptionArray ($options) {
		if (is_array ($options) ) {
			foreach ($options as $k => $v) {
				$this->addOption ($k, $v);
			}
		}

	}

	/**
	* Get all options
	*
	* @return	array   Associative array of value->name pairs
	*/

	function getOptions () {
		return $this->_options;

	}

	/**
	* Prepare HTML	for	output
	*
	* @return string	HTML
	*/

	function render (&$form) {

		$form->AddSelect ($this->getName (), $this->getOptions (), $this->getValue (), '', $this->getSize (), $this->isMultiple () );

	}

}

?>