<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* Base class for all objects in the openphpnuke engine
*
* @author Stefan Kaletta
*
**/

class opn_Object {

	/**
	* is it a newly created object?
	*
	* @var bool
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_isNew = false;

	/**
	* has any of the values been modified?
	*
	* @var bool
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_isDirty = false;

	/**
	* holds all variables and properties of an object
	*
	* @var array
	* @access protected
	**/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $vars = array ();

	/**
	* variables	cleaned for store in DB
	*
	* @var array
	* @access protected
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $cleanVars = array ();

	/**
	* holds the possible prefix for all variables and properties of this object
	*
	* @var_prefix string
	* @access protected
	**/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_var_prefix = '';

	/**
	* holds the possible id table name of this object
	*
	* @var_int_id string
	* @access protected
	**/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_var_int_id = 'id';

	/**
	* holds the possible pos field table name of this object
	*
	* @var_int_id_pos string
	* @access protected
	**/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_var_int_id_pos = false;

	/**
	* holds all keys for variables of an object
	*
	* @var array
	* @access protected
	**/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_keys = array ();

	/**
	* holds the blobfields for calling UpdateBlobs;
	*
	* @var array
	* @access protected
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_blofields = array ();

	/**
	* additional filters registered dynamically by a child class object
	*
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_filters = array ();

	/**
	* errors
	*
	* @var array
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_errors = array ();

	/**
	* features of the singel var
	*
	* @var array
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_default_features = array (_OOBJ_DTYPE_HTML => true,
								_OOBJ_DTYPE_BBCODE => true,
								_OOBJ_DTYPE_CBR => true,
								_OOBJ_DTYPE_SMILE => true,
								_OOBJ_DTYPE_UIMAGES => true,
								_OOBJ_DTYPE_SIG => true);

	/**
	* constructor
	*
	* normally, this is called from child classes only
	* @access public
	*/

	function opn_Object () {

	}

	/**
	* used for new/clone objects
	*
	* @access public
	*/

	function setNew () {

		$this->_isNew = true;

	}

	function unsetNew () {

		$this->_isNew = false;

	}

	function isNew () {
		return $this->_isNew;

	}

	/**
	* used for modified objects only
	* @access public
	*/

	function setDirty () {

		$this->_isDirty = true;

	}

	function unsetDirty () {

		$this->_isDirty = false;

	}

	function isDirty () {
		return $this->_isDirty;

	}

	/**
	* used for keys objects
	*
	* @access public
	*/

	function setKeys ($keys) {

		$this->_keys = $keys;

	}

	function getKeys () {
		return $this->_keys;

	}

	function setBlobFields ($fields) {

		$this->_blofields = $fields;

	}

	function getBlobFields () {
		return $this->_blofields;

	}

	function setPrefix ($var) {

		$this->_var_prefix = $var;

	}

	function getPrefix () {
		return $this->_var_prefix;

	}

	function setIdVar ($var) {

		$this->_var_int_id = $var;

	}

	function getIdVar () {
		return $this->_var_int_id;

	}

	function setIdPosVar ($var) {

		$this->_var_int_id_pos = $var;

	}

	function getIdPosVar () {
		return $this->_var_int_id_pos;

	}

	function setFeatures ($var) {

		$this->_default_features = $var;

	}

	function setVarFeatures ($key, $var) {

		$this->vars[$key]['features'] = $var;

	}

	function getFeatures () {
		return $this->_default_features;

	}

	function getVarFeatures ($key) {
		if (isset ($this->vars[$key]['features']) ) {
			return $this->vars[$key]['features'];
		}
		return false;

	}

	/**
	* initialize variables for the object
	*
	* @access public
	* @param string $key
	* @param int $data_type set to one of _OOBJ_DTYPE_XXX constants	(set to	_OOBJ_DTYPE_OTHER if	no data	type ckecking nor text sanitizing is required)
	* @param mixed
	* @param bool $required require html form input?
	* @param int $maxlength for _OOBJ_DTYPE_TXTBOX type	only
	* @param string $option does this data have any select options?
	*/

	function initVar ($key, $data_type, $value = null, $required = false, $maxlength = null, $options = '') {

		$this->vars[$key] = array ('value' => $value,
					'required' => $required,
					'data_type' => $data_type,
					'maxlength' => $maxlength,
					'changed' => false,
					'options' => $options,
					'features' => $this->_default_features);

	}

	/**
	* assign a value to a variable
	*
	* @access public
	* @param string	$key name of the variable to assign
	* @param mixed $value value	to assign
	*/

	function assignVar ($key, $value, $getvar = true) {
		if (isset ($value) && isset ($this->vars[$key]) ) {
			$this->vars[$key]['value'] = &$value;
			$this->vars[$key]['show_dat'] = false;
			$this->vars[$key]['getvar'] = $getvar;
		}

	}

	/**
	* assign values to multiple	variables in a batch
	*
	* @access private
	* @param array $var_array associative array of values to assign
	*/

	function assignVars ($var_arr) {

		foreach ($var_arr as $key => $value) {
			$this->assignVar ($key, $value);
		}

	}

	/**
	* assign a value to a variable
	*
	* @access public
	* @param string $key name of the variable to assign
	* @param mixed $value value	to assign
	* @param bool $not_gpc
	*/

	function setVar ($key, $value, $not_gpc = false) {
		if (!empty ($key) && isset ($value) && isset ($this->vars[$key]) ) {
			$this->vars[$key]['value'] = &$value;
			$this->vars[$key]['not_gpc'] = $not_gpc;
			$this->vars[$key]['changed'] = true;
			$this->vars[$key]['show_dat'] = false;
			$this->setDirty ();
		}

	}

	/**
	* assign values to multiple	variables in a batch
	*
	* @access private
	* @param array $var_arr	associative	array of values to assign
	* @param bool $not_gpc
	*/

	function setVars ($var_arr, $not_gpc = false) {

		foreach ($var_arr as $key => $value) {
			$this->setVar ($key, $value, $not_gpc);
		}

	}

	/**
	* Assign values to multiple	variables in a batch
	*
	* Meant	for	a CGI contenxt:
	* -	prefixed CGI args are considered save
	* -	avoids polluting of	namespace with CGI args
	*
	* @access private
	* @param array $var_arr	associative	array of values to assign
	* @param string	$pref prefix (only keys	starting with the prefix will be set)
	*/

	function setFormVars ($var_arr = null, $pref = 'opn_', $not_gpc = false) {

		$len = strlen ($pref);
		foreach ($var_arr as $key => $value) {
			if ($pref == substr ($key, 0, $len) ) {
				$this->setVar (substr ($key, $len), $value, $not_gpc);
			}
		}

	}

	/**
	* returns all variables	for	the	object
	*
	* @access public
	* @return array associative array of key->value pairs
	*/

	function &getVars () {
		return $this->vars;

	}

	/**
	* returns specifics variables for the object from input
	*
	* @access public
	* @param array $keys keys of the object's variable to be returned
	* @return mixed formatted value of the variable
	*/

	function objectGetVar ($keys) {

		global $opnConfig;
		if (!is_array ($keys) ) {
			$value = '';
			if ( (!isset ($this->vars[$keys]['getvar']) ) OR ($this->vars[$keys]['getvar'] == true) ) {
				switch ($this->vars[$keys]['data_type']) {
					case _OOBJ_DTYPE_CLEAN:
					case _OOBJ_DTYPE_CHECK:
						$value = '';
						_get_var ($this->getPrefix () . $keys, $value, 'both', $this->vars[$keys]['data_type'], false);
						break;
					case _OOBJ_DTYPE_INT:
						$value = '';
						_get_var ($this->getPrefix () . $keys, $value, 'both', _OOBJ_DTYPE_INT, false);
						break;
					case _OOBJ_DTYPE_ODATE:
						$dummy = '';
						_get_var ($this->getPrefix () . $keys, $dummy, 'both', 'CHECK', false);
						if ($dummy == '') {
							$day = 0;
							_get_var ($this->getPrefix () . $keys . 'day', $day, 'both', _OOBJ_DTYPE_INT, false);
							$month = 0;
							_get_var ($this->getPrefix () . $keys . 'month', $month, 'both', _OOBJ_DTYPE_INT, false);
							$year = 0;
							_get_var ($this->getPrefix () . $keys . 'year', $year, 'both', _OOBJ_DTYPE_INT, false);
							$hour = 0;
							_get_var ($this->getPrefix () . $keys . 'hour', $hour, 'both', _OOBJ_DTYPE_INT, false);
							$min = 0;
							_get_var ($this->getPrefix () . $keys . 'min', $min, 'both', _OOBJ_DTYPE_INT, false);
							if ($day<10) {
								$day = '0' . $day;
							}
							$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':00');
							$dummy = '';
							$opnConfig['opndate']->opnDataTosql ($dummy);
						}
						break;
					default:
						$dummy = '';
						_get_var ($this->getPrefix () . $keys, $value, 'both', $this->vars[$keys]['data_type'], false);
						break;
				}
			} else {
				$value = $this->vars[$keys]['value'];
			}
		} else {
			$value = array ();
			foreach ($keys as $key) {
				if ( (!isset ($this->vars[$key]['getvar']) ) OR ($this->vars[$key]['getvar'] == true) ) {
					switch ($this->vars[$key]['data_type']) {
						case _OOBJ_DTYPE_CLEAN:
						case _OOBJ_DTYPE_CHECK:
							$dummy = '';
							_get_var ($this->getPrefix () . $key, $dummy, 'both', $this->vars[$key]['data_type'], false);
							break;
						case _OOBJ_DTYPE_INT:
							$dummy = '';
							_get_var ($this->getPrefix () . $key, $dummy, 'both', _OOBJ_DTYPE_INT, false);
							break;
						case _OOBJ_DTYPE_ODATE:
							$dummy = '';
							_get_var ($this->getPrefix () . $key, $dummy, 'both', 'CHECK', false);
							if ($dummy == '') {
								$day = 0;
								_get_var ($this->getPrefix () . $key . 'day', $day, 'both', _OOBJ_DTYPE_INT, false);
								$month = 0;
								_get_var ($this->getPrefix () . $key . 'month', $month, 'both', _OOBJ_DTYPE_INT, false);
								$year = 0;
								_get_var ($this->getPrefix () . $key . 'year', $year, 'both', _OOBJ_DTYPE_INT, false);
								$hour = 0;
								_get_var ($this->getPrefix () . $key . 'hour', $hour, 'both', _OOBJ_DTYPE_INT, false);
								$min = 0;
								_get_var ($this->getPrefix () . $key . 'min', $min, 'both', _OOBJ_DTYPE_INT, false);
								if ($day<10) {
									$day = '0' . $day;
								}
								$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':00');
								$dummy = '';
								$opnConfig['opndate']->opnDataTosql ($dummy);
							}
							break;
						default:
							$dummy = '';
							_get_var ($this->getPrefix () . $key, $dummy, 'both', $this->vars[$key]['data_type'], false);
							break;
					}
					$value[$key] = $dummy;
				} else {
					$value[$key] = $this->vars[$key]['value'];
				}
			}
		}
		$this->metamorphosis ($value, $this->getKeys () );
		return $value;

	}

	/**
	* returns a specific variable for the object in a proper format
	*
	* @access public
	* @param string $key key of the object's variable to be returned
	* @param string $format	format to use for the output
	* @return mixed formatted value of the variable
	*/

	function &getVar ($key, $format = 'none') {

		$ret = $this->vars[$key]['value'];
		switch ($this->vars[$key]['data_type']) {
			case _OOBJ_DTYPE_CLEAN:
			case _OOBJ_DTYPE_CHECK:
				switch (strtolower ($format) ) {
				case 'parse':
					$this->TextToReadyText ($ret, $key);
					break 1;
				case 'unparse':
					$this->ReadyTextToText ($ret, $key);
					break 1;
				case 'none':
				default:
					break 1;
			}
			break;
			default:
				break;
		}
		return $ret;

	}

	/**
	* clean values of all variables of the object for storage.
	* also add slashes whereever needed
	*
	* @return bool true if successful
	* @access public
	*/

	function cleanVars () {

		foreach ($this->vars as $k => $v) {
			$cleanv = $v['value'];
			if (!$v['changed']) {
			} else {
				$cleanv = is_string ($cleanv)?trim ($cleanv) : $cleanv;
				switch ($v['data_type']) {
					case _OOBJ_DTYPE_CLEAN:
					case _OOBJ_DTYPE_CHECK:
						// TODO : Stefan Diese Zuweisung bringt nichts ;).
						// $cleanv = $cleanv;
						break;
					default:
						break;
				}
			}
			$this->cleanVars[$k] = &$cleanv;
			unset ($cleanv);
		}
		if (count ($this->_errors)>0) {
			return false;
		}
		$this->unsetDirty ();
		return true;

	}

	function metamorphosis (&$message, $keys, $setto = 'parse') {
		if (!is_array ($keys) ) {
			switch ($this->vars[$keys]['data_type']) {
				case _OOBJ_DTYPE_CLEAN:
				case _OOBJ_DTYPE_CHECK:
					if ($setto == 'parse') {
						$this->TextToReadyText ($message, $keys);
					} else {
						$this->ReadyTextToText ($message, $keys);
					}
					break;
				default:
					break;
			}
		} else {
			foreach ($keys as $ourvar) {
				switch ($this->vars[$ourvar]['data_type']) {
					case _OOBJ_DTYPE_CLEAN:
					case _OOBJ_DTYPE_CHECK:
						if ($setto == 'parse') {
							$this->TextToReadyText ($message[$ourvar], $ourvar);
						} else {
							$this->ReadyTextToText ($message[$ourvar], $ourvar);
						}
						break;
					default:
						break;
				}
			}
		}

	}

	function TextToReadyText (&$message, $key) {

		global $opnConfig;
		if (!isset ($this->vars[$key]['show_dat']) ) {
			$options = false;
		} else {
			$options = $this->vars[$key]['show_dat'];
		}
		if ($options === false) {
			$options = array ();
			$options[_OOBJ_DTYPE_HTML] = true;
			$options[_OOBJ_DTYPE_BBCODE] = true;
			$options[_OOBJ_DTYPE_CBR] = true;
			$options[_OOBJ_DTYPE_SMILE] = true;
			$options[_OOBJ_DTYPE_UIMAGES] = true;
			$options[_OOBJ_DTYPE_SIG] = true;
		}
		$temp = '';
		get_var ($this->getPrefix () . $key . '_use_', $temp, 'form', _OOBJ_DTYPE_CHECK);
		if ($temp == 'opn') {
			$tp = 0;
			get_var ($this->getPrefix () . $key . '_use_html', $tp, 'form', _OOBJ_DTYPE_CHECK);
			if ($tp == 0) {
				$options[_OOBJ_DTYPE_HTML] = false;
			}
			$tp = 0;
			get_var ($this->getPrefix () . $key . '_use_bbcode', $tp, 'form', _OOBJ_DTYPE_CHECK);
			if ($tp == 0) {
				$options[_OOBJ_DTYPE_BBCODE] = false;
			}
			$tp = 0;
			get_var ($this->getPrefix () . $key . '_use_smile', $tp, 'form', _OOBJ_DTYPE_CHECK);
			if ($tp == 0) {
				$options[_OOBJ_DTYPE_SMILE] = false;
			}
		}
		$message = $opnConfig['cleantext']->FixQuotes ($message);
		if (!$options[_OOBJ_DTYPE_HTML]) {
			$message = htmlspecialchars ($message);
		}
		if ($options[_OOBJ_DTYPE_BBCODE]) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
			$ubb =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ UBBCode;
			$ubb->ubbencode ($message);
		}
		if ($options[_OOBJ_DTYPE_CBR]) {
			opn_nl2br ($message);
		}
		if ($options[_OOBJ_DTYPE_SMILE]) {
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
				include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
				$message = smilies_smile ($message);
			}
		}
		if ($options[_OOBJ_DTYPE_UIMAGES]) {
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
				include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
				$message = make_user_images ($message);
			}
		}
		if ($options[_OOBJ_DTYPE_SIG]) {
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
				$ui = $opnConfig['permission']->GetUserinfo ();
				// ? ['user_sig']
			}
		}

	}

	function ReadyTextToText (&$message, $key) {

		global $opnConfig;
		if ( (!isset ($this->vars[$key]) ) OR (!isset ($this->vars[$key]['show_dat']) ) ) {
			$options = false;
		} else {
			$options = $this->vars[$key]['show_dat'];
		}
		if ($options === false) {
			$options = array ();
			$options[_OOBJ_DTYPE_HTML] = true;
			$options[_OOBJ_DTYPE_BBCODE] = true;
			$options[_OOBJ_DTYPE_CBR] = true;
			$options[_OOBJ_DTYPE_SMILE] = true;
			$options[_OOBJ_DTYPE_UIMAGES] = true;
			$options[_OOBJ_DTYPE_SIG] = true;
		}
		if ($options[_OOBJ_DTYPE_CBR]) {
			$message = str_replace ('<br>', _OPN_HTML_NL, $message);
			$message = str_replace ('<br />', _OPN_HTML_NL, $message);
		}
		if ($options[_OOBJ_DTYPE_UIMAGES]) {
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
				include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
				$oldmessage = $message;
				$message = de_make_user_images ($message);
				if ($oldmessage == $message) {
					$disableuserimages = TRUE;
				} else {
					$disableuserimages = FALSE;
				}
			}
		}
		if ($options[_OOBJ_DTYPE_SMILE]) {
			$oldmessage = $message;
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
				include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
				$message = smilies_desmile ($message);
			}
			if ($oldmessage == $message) {
				$disablesmilies = true;
			} else {
				$disablesmilies = false;
			}
		}
		if ($options[_OOBJ_DTYPE_BBCODE]) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
			$ubb =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ UBBCode;
			$ubb->ubbdecode ($message);
		}
		if ($options[_OOBJ_DTYPE_SIG]) {
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
				$message = preg_replace ('/\[addsig]/i', '', $message);
				$message = preg_replace ('/\[\'addsig\']/i', '', $message);
			}
		}

	}

	/**
	* dynamically register additional filter for the object
	*
	* @param string $filtername name of the filter
	* @access public
	*/

	function registerFilter ($filtername) {

		$this->_filters[] = $filtername;

	}

	/**
	* create a	clone(copy)	of the current object
	*
	* @access public
	* @return object clone
	*/

	function &opn_Clone () {

		$class = get_class ($this);
		$clone =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $class ();
		foreach ($this->vars as $k => $v) {
			$clone->assignVar ($k, $v['value']);
		}
		// need	this to	notify the handler class that this is a	newly created object
		$clone->setNew ();
		return $clone;

	}

	/**
	* add an error
	*
	* @param string $value	error to add
	* @access public
	*/

	function setErrors ($err_str) {

		$this->_errors[] = trim ($err_str);

	}

	/**
	* return the errors for this object as	an array
	*
	* @return array an	array of errors
	* @access public
	*/

	function getErrors () {
		return $this->_errors;

	}

	/**
	* return the errors for this object as	html
	*
	* @return string html listing the errors
	* @access public
	*/

	function getHtmlErrors () {

		$ret = 'ERROR:';
		if (!empty ($this->_errors) ) {
			foreach ($this->_errors as $error) {
				$ret .= $error . '<br />';
			}
		} else {
			$ret .= _NONE . '<br />';
		}
		return $ret;

	}

	/**
	* Returns an array representation of the object
	*
	* @return array
	*/

	function toArray () {

		$ret = array ();
		$vars = $this->getVars ();
		foreach (array_keys ($vars) as $i) {
			$ret[$i] = $this->getVar ($i);
		}
		return $ret;

	}

}

/**
* opn_object handler class.
* This class is an abstract	class of handler classes that are responsible for providing
* data access mechanisms to	the	data source	of its corresponsing data objects
*
* @author  Stefan Kaletta
*
*/

class opn_ObjectHandler {

	/**
	* called from child classes only
	*
	* @access protected
	*/

	function opn_ObjectHandler () {

	}

	/**
	* creates a new object
	*
	* @abstract
	*/

	function &create () {

	}

	/**
	* gets	a value	object
	*
	* @param	int	$id
	* @abstract
	*/

	function &get ($id = false) {

		$x = $id;

	}

	/**
	* insert/update object
	*
	* @param	object $object
	* @abstract
	*/

	function insert (&$object) {

		$x = $object;

	}

	/**
	* delete obejct from database
	*
	* @param object $object
	* @abstract
	*/

	function &delete ($id = false) {

		$x = $id;

	}

}

/**
* instant opn_object handler class.
* This class is an abstract	class of handler classes that are responsible for providing
* data access mechanisms to	the	data source	of its corresponsing data objects
*
* usefull for basic application
*
* @author  Stefan Kaletta
*
*/

class opn_InstantObjectHandler extends opn_ObjectHandler {

	/** Information about the class, the handler is managing
	*
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $table;

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $className = '';

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $moduleName;

	/**
	* Constructor - called from child classes
	* @param string	 $tablename  Name of database table
	* @param string	 $classname  Name of Class, this handler is managing
	* @param string	 $modulename	Name of the module, this handler is managing
	*
	* @return void
	*/

	function opn_InstantObjectHandler ($tablename, $classname, $modulename) {

		$this->opn_ObjectHandler ();
		$this->table = $tablename;
		$this->className = $classname;
		$this->moduleName = $modulename;

	}

	/**
	* create a new class instand
	*
	* @param bool $isNew Flag the new objects as 'new'?
	*
	* @return object
	*/

	function &create ($isNew = true) {

		$class = $this->className;
		$obj =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $class ();
		if ($isNew === true) {
			$obj->setNew ();
		}
		return $obj;

	}

	/**
	* Get an object of class this handler is managing
	*
	* @param mixed $id ID of the object - or array of ids
	* @return array Array of associative arrays of class this handler is managing information
	*/

	function &get ($id = false) {

		global $opnTables, $opnConfig;
		if ($id === false) {
			$where = ' WHERE (id>0)';
		} elseif (is_subclass_of ($id, 'sql_statement_element') ) {
			$id1 = $id;
			$where = ' ' . $id1->renderWhere ();
			if ($id1->getSort () != '') {
				$where .= ' ORDER BY ' . $id1->getSort () . ' ' . $id1->getOrder ();
			}
			$limit = $id1->getLimit ();
			$start = $id1->getStart ();
			unset ($id1);
		} else {
			if (is_array ($id) ) {
				$idsize = sizeof ($id);
				for ($x = 0; $x<$idsize; $x++) {
					if ($x == 0) {
						$where = ' WHERE ';
					} else {
						$where .= ' AND ';
					}
					$where .= '(' . key ($id) . '=' . current ($id) . ')';
				}
			} else {
				$where = ' WHERE (id=' . $id . ')';
			}
		}
		$class = $this->className;
		$obj =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $class ();
		$result = &$opnConfig['database']->SelectLimit ('SELECT ' . implode (',', $obj->getKeys () ) . ' FROM ' . $opnTables[$this->table] . $where, 1);
		if ($result !== false) {
			if (!$result->EOF) {
				$ret = array ();
				$opnConfig['opnSQL']->get_result_array ($ret, $result, $obj->getKeys () );
				$obj->assignVars ($ret);
			}
			$result->Close ();
			return $obj;
		}
		return false;

	}

	/**
	* insert a new object in the database
	*
	* @param object $obj reference to the object
	* @return bool FALSE if failed, TRUE if already present and unchanged or successful
	*
	*/

	function insert (&$obj) {

		global $opnTables, $opnConfig;
		if (strtolower (get_class ($obj) ) != $this->className) {
			return false;
		}
		$id = -1;
		get_var ($obj->getIdVar (), $id, 'both', _OOBJ_DTYPE_INT);
		$temp = $obj->objectGetVar ($obj->getKeys () );
		if (count ($obj->getBlobFields () ) ) {
			$opnConfig['opnSQL']->qstr_array ($temp, $obj->getBlobFields () );
			$isblobs = true;
		} else {
			$opnConfig['opnSQL']->qstr_array ($temp);
			$isblobs = false;
		}
		if ( ($obj->isNew () ) && ($id == -1) ) {
			$posfield = $obj->getIdPosVar ();
			if ( ($posfield != '') && ($posfield !== false) ) {
				$posy = $posfield . ', ';
			} else {
				$posy = '';
			}
			$id = $opnConfig['opnSQL']->get_new_number ($this->table, $obj->getIdVar () );
			$insert = '';
			$opnConfig['opnSQL']->opn_make_insert ($obj->getKeys (), $temp, $insert);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables[$this->table] . ' values (' . $id . ', ' . $posy . ' ' . $insert . ')');
		} else {
			$insert = '';
			$opnConfig['opnSQL']->opn_make_update ($obj->getKeys (), $temp, $insert);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables[$this->table] . ' SET ' . $insert . ' WHERE id=' . $id);
		}
		if ($isblobs) {
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables[$this->table], $obj->getIdVar () . '=' . $id);
		}
		return true;

	}

	/**
	* Delete an object of class this handler is managing
	*
	* @param mixed $id ID of the object
	*/

	function &delete ($id = false) {

		global $opnTables, $opnConfig;

		$class = $this->className;
		$obj =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $class ();
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables[$this->table] . ' WHERE ' . $obj->getIdVar () . '=' . $id);
		unset ($obj);

	}

	function listing (&$obj, $config_dat) {

		include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
		global $opnConfig, $opnTables;

		$keys = $obj->getKeys ();
		$offset = 0;
		get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
		$posfield = $obj->getIdPosVar ();
		if ( ($posfield != '') && ($posfield !== false) ) {
			$sortby = 'asc_' . $keys[0];
			get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
		} else {
			$sortby = 'asc_' . $posfield;
			get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
		}
		$_op = '';
		get_var ('op', $_op, 'url', _OOBJ_DTYPE_CLEAN);
		$new_pos = '';
		get_var ('new_pos', $new_pos, 'url', _OOBJ_DTYPE_CLEAN);
		if ( ($_op == 'move') && ($new_pos != '') ) {
			$id = 0;
			get_var ($obj->getIdVar (), $id, 'url', _OOBJ_DTYPE_INT);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables[$this->table] . ' SET ' . $obj->getIdPosVar () . '=' . $new_pos . ' WHERE ' . $obj->getIdVar () . '=' . $id);
			$result = &$opnConfig['database']->Execute ('SELECT ' . $obj->getIdVar () . ' FROM ' . $opnTables[$this->table] . ' ORDER BY ' . $obj->getIdPosVar () );
			$c = 0;
			while (! $result->EOF) {
				$row = $result->GetRowAssoc ('0');
				$c++;
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables[$this->table] . ' SET ' . $obj->getIdPosVar () . '=' . $c . ' WHERE ' . $obj->getIdVar () . '=' . $row[$obj->getIdVar ()]);
				$result->MoveNext ();
			}
		} elseif ($_op == 'delete') {
			$id = 0;
			get_var ($obj->getIdVar (), $id, 'url', _OOBJ_DTYPE_INT);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables[$this->table] . ' WHERE ' . $obj->getIdVar () . '=' . $id);
		} elseif ($_op == 'onoff') {
			$id = 0;
			get_var ($obj->getIdVar (), $id, 'url', _OOBJ_DTYPE_INT);
			if ( (isset ($config_dat['onoff_field'])) && ($config_dat['onoff_field'] !== false) ) {
				$onoff = 0;
				$result = &$opnConfig['database']->Execute ('SELECT ' . $config_dat['onoff_field'] . ' FROM ' . $opnTables[$this->table] . ' WHERE ' . $obj->getIdVar () . '=' . $id);
				while (! $result->EOF) {
					$row = $result->GetRowAssoc ('0');
					$onoff = $row[$config_dat['onoff_field']];
					$result->MoveNext ();
				}
				if ($onoff==0) {
					$onoff = 1;
				} else {
					$onoff = 0;
				}
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables[$this->table] . ' SET ' . $config_dat['onoff_field'] . '=' . $onoff . ' WHERE ' . $obj->getIdVar () . '=' . $id);
			}
		}
		$text = '';
		$sql = 'SELECT COUNT(' . $obj->getIdVar () . ') AS counter FROM ' . $opnTables[$this->table];
		$justforcounting = &$opnConfig['database']->Execute ($sql);
		if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
			$reccount = $justforcounting->fields['counter'];
		} else {
			$reccount = 0;
		}
		unset ($justforcounting);
		$order = '';
		$oldsortby = $sortby;
		if ($reccount >= 1) {
			$form =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_FormularClass ('alternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN__10_', $config_dat['module']);
			$form->Init ($config_dat['prog_url'][0]);
			$form->AddTable ();
			$form->get_sort_order ($order, $keys, $sortby);
			$form->AddOpenHeadRow ();
			$form->SetIsHeader (true);
			foreach ($keys as $mykey) {
				if (isset ($config_dat['dyn_lang'][$mykey]) ) {
					$form->AddText ($form->get_sort_feld ($mykey, $config_dat['dyn_lang'][$mykey], $config_dat['prog_url']) );
				}
			}
			$form->AddText ('');
			$form->SetIsHeader (false);
			$form->AddCloseRow ();
			if ( ($posfield != '') && ($posfield !== false) ) {
				$posy = ', ' . $posfield;
			} else {
				$posy = '';
			}
			$info = &$opnConfig['database']->SelectLimit ('SELECT ' . implode (',', $obj->getKeys () ) . ',' . $obj->getIdVar () . $posy . ' FROM ' . $opnTables[$this->table] . ' ' . $order, $opnConfig['opn_gfx_defaultlistrows'], $offset);
			while (! $info->EOF) {
				$ret = array ();
				$opnConfig['opnSQL']->get_result_array ($ret, $info, $obj->getKeys () );
				$obj->assignVars ($ret);
				$form->AddOpenRow ();
				foreach ($keys as $mykey) {
					if (isset ($config_dat['dyn_lang'][$mykey]) ) {
						$form->AddText ($obj->getVar ($mykey, 'show') );
					}
				}
				$id = $info->fields[$obj->getIdVar ()];
				$dym_url = $config_dat['prog_url'];
				$dym_url['op'] = 'edit';
				$dym_url[$obj->getIdVar ()] = $id;
				if ( (isset ($config_dat['id_edit']) ) && ($config_dat['id_edit'] == false) ) {
					$hlp = '';
				} else {
					$hlp = $opnConfig['defimages']->get_edit_link ($dym_url);
					$hlp .= '&nbsp;';
				}
				$dym_url['op'] = 'delete';
				$hlp .= $opnConfig['defimages']->get_delete_link ($dym_url) . '&nbsp;';
				if ( (isset ($config_dat['id_url']))  && ($config_dat['id_edit'] != false) ) {
					$dym_url = $config_dat['id_url'];
					$dym_url[$obj->getIdVar ()] = $id;
					$hlp .= '<a class="%alternate%" href="' . encodeurl ($dym_url) . '">' . $config_dat['dyn_lang']['opt'] . '</a> ';
				}
				if ( (isset ($config_dat['onoff_field']))&& ($config_dat['onoff_field'] !== false) ) {
					$onoff = 0;
					$result = &$opnConfig['database']->Execute ('SELECT ' . $config_dat['onoff_field'] . ' FROM ' . $opnTables[$this->table] . ' WHERE ' . $obj->getIdVar () . '=' . $id);
					while (! $result->EOF) {
						$row = $result->GetRowAssoc ('0');
						$onoff = $row[$config_dat['onoff_field']];
						$result->MoveNext ();
					}
					$dym_url['op'] = 'onoff';
					$hlp .= $opnConfig['defimages']->get_activate_deactivate_link ($dym_url, $onoff , '', _OFF, _ON);
					$hlp .= '&nbsp;';
				}
				if ( ($posfield != '') && ($posfield !== false) ) {
					$dym_url['op'] = 'move';
					$dym_url['new_pos'] = ($info->fields[$posfield]-1.5);
					$move_ = $opnConfig['defimages']->get_up_link ($dym_url);
					$move_ .= '&nbsp;';
					$dym_url['new_pos'] = ($info->fields[$posfield]+1.5);
					$move_ .= $opnConfig['defimages']->get_down_link ($dym_url);
					$hlp = $hlp . $move_;
				}
				$form->AddText ($hlp);
				$form->AddCloseRow ();
				$info->MoveNext ();
			}
			// while
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($text);
			$text .= '<br /><br />';
			$dym_url = $config_dat['prog_url'];
			$dym_url['sortby'] = $oldsortby;
			$text .= build_pagebar ($dym_url, $reccount, $opnConfig['opn_gfx_defaultlistrows'], $offset);
		}
		return $text;

	}

}

?>