<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_MODULE_AUTOINSTALLER_PHP') ) {
	define ('_OPN_INCLUDE_MODULE_AUTOINSTALLER_PHP', 1);

	function sortadminarray ($a, $b) {

		$a1 = explode ('::', $a);
		$b1 = explode ('::', $b);
		if ($a1[0] == $b1[0]) {
			if ( (isset ($a1[2]) ) && ($a1[2] != '') && (isset ($b1[2]) ) && ($b1[2] != '') ) {
				return strcollcase ($a1[2], $b1[2]);
			}
			return 1;
		}
		if ($a1[0]<$b1[0]) {
			return -1;
		}
		return 1;

	}

	function filteradminarray ($a) {

		$rc = 0;
		if (isset ($a) == true) {
			if (substr_count ($a, ':')>0) {
				$rc = 1;
			}
		}
		return $rc;

	}

	function AutoInstallModules (&$pos, $automate = 'install') {
		if ($pos == 0) {
			$pos = 1;
		}
		$apos = $pos;
		$boxtxt = AInstall (_OPN_ROOT_PATH, 'modules', $pos, $automate);
		$boxtxt .= AInstall (_OPN_ROOT_PATH, 'system', $pos, $automate);
		$boxtxt .= AInstall (_OPN_ROOT_PATH, 'pro', $pos, $automate);
		$boxtxt .= AInstall (_OPN_ROOT_PATH, 'developer', $pos, $automate);
		$boxtxt .= AInstall (_OPN_ROOT_PATH, 'themes', $pos, $automate);
		if ($pos == $apos) {
			$pos = 0;
		}
		return $boxtxt;

	}

	function AInstall ($wichPath, $wichFolder, &$pos, $automate) {

		global $opnConfig;

		$apos = $pos;
		$boxtxt = '';
		$admindata = get_dir_list ($wichPath . $wichFolder);
		$i = 0;
		if (!$opnConfig['opn_host_use_safemode']) {
			@set_time_limit (0);
		}
		foreach ($admindata as $file) {
			$admin_data[$i] = AGetPlugins ($wichPath . $wichFolder . '/' . $file, $file, _OPN_ROOT_PATH . $wichFolder . '/' . $file . '/plugin/index.php', $wichFolder . '/' . $file, $wichFolder, $automate);
			$i++;
		}
		if (is_array ($admin_data) ) {
			arrayfilter ($admin_data, $admin_data, 'filteradminarray');
			usort ($admin_data, 'sortadminarray');
			foreach ($admin_data as $key1 => $val1) {
				$admin_item = explode ('::', $val1);
				$next = $key1+1;
				if (isset ($admin_data[$next]) ) {
					$next_item = explode ('::', $admin_data[$next]);
					if ($automate == 'install') {
						$next_itemtext = sprintf (_PLU_INSTALLNEXT, $next_item[1]);
					} else {
						$next_itemtext = sprintf (_PLU_DEINSTALLNEXT, $next_item[1]);
					}
				} else {
					$next_itemtext = '';
				}
				if ( (isset ($admin_item[0]) ) && (trim ($admin_item[0]) != '') && ($apos == $pos) ) {
					include_once ($admin_item[2]);
					if ($automate == 'install') {
						$boxtxt .= sprintf (_PLU_INSTALLED, $admin_item[1]) . $next_itemtext . '<br />';
						$myfunc = $admin_item[0] . '_DoInstall';
					} else {
						$boxtxt .= sprintf (_PLU_DEINSTALLED, $admin_item[1]) . $next_itemtext . '<br />';
						$myfunc = $admin_item[0] . '_DoRemove';
					}
					set_var ('module', $admin_item[1], 'both');
					set_var ('auto', 1, 'both');
					set_var ('plugback', '', 'both');
					$myfunc ();
					unset_var ('module', 'both');
					unset_var ('auto', 'both');
					unset_var ('plugback', 'both');
					$pos++;
				}
			}
		}
		return $boxtxt;

	}

	function AGetPlugins ($folder, $module, $ufolder, $wfolder, $wichFolder, $automate) {

		global $opnConfig;

		$item_path = $folder . '/plugin/index.php';
		if (file_exists ($item_path) ) {
			$setinfo = FALSE;
			$c = $opnConfig['installedPlugins']->isplugininstalled ($wichFolder . '/' . $module);
			if ( (!$c) && ($automate == 'install') ) {
				$setinfo = TRUE;
			}
			if ( ($c) && ($automate == 'deinstall') ) {
				$setinfo = TRUE;
			}
			if ($setinfo) {
				$dat = $module;
				$image = $wfolder;
				$adminpath = $ufolder;
			} else {
				$dat = '';
				$image = '';
				$adminpath = '';
			}
			$tlink = $adminpath;
			$glink = $image;
			$data = '';
			if (!isset ($dat) ) {
				$dat = '';
			}
			if (!isset ($glink) ) {
				$glink = '';
			}
			if (!isset ($tlink) ) {
				$tlink = '';
			}
			$data .= trim ($dat) . '::';
			$data .= trim ($glink) . '::';
			$data .= trim ($tlink);
		} else {
			$data = '';
		}
		return $data;

	}
}

?>