<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_INCLUDE_OPN_ADMIN_FUNCTIONS_PHP') ) {
	define ('_OPN_INCLUDE_OPN_ADMIN_FUNKTIONS_PHP', 1);
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.update.php');

	/*****************************************************/
	/* Core Menu Functions								*/
	/***************************************************/

	function admin_menu_item ($admin_array) {

		global $opnConfig;
		if ($opnConfig['admingraphic'] == 1) {
			if ($admin_array['glink'] != '') {
				return $admin_array['glink'];
			}
			return $admin_array['tlink'];
		}
		return $admin_array['tlink'];

	}

	function adminheader () {

		global $opnConfig;

		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array ('<a href="' . $opnConfig['opn_url'] . '/admin.php" class="alternatorhead">' . _AF_ADMINMENU . '</a>') );
		$help = '';
		$table->GetTable ($help);
		return $help;

	}

	/*********************************************************/

	/* System Menu Functions				 */

	/*********************************************************/

	function system_admin_menu ($view = '', $fullview = false) {

		$txt = '';
		if ( ($view == '') OR ($view == 'admin') ) {
			$txt .= make_admin_menu ('admin', $fullview) . '<br />';
		}
		if ( ($view == '') OR ($view == 'system') ) {
			$txt .= make_admin_menu ('system', $fullview) . '<br />';
		}
		if ( ($view == '') OR ($view == 'modules') ) {
			$txt .= make_admin_menu ('modules', $fullview) . '<br />';
		}
		if ( ($view == '') OR ($view == 'themes') ) {
			$txt .= make_admin_menu ('themes', $fullview) . '<br />';
		}
		if ( ($view == '') OR ($view == 'pro') ) {
			$txt .= make_admin_menu ('pro', $fullview) . '<br />';
		}
		if ( ($view == '') OR ($view == 'developer') ) {
			$txt .= make_admin_menu ('developer', $fullview) . '<br />';
		}
		return $txt;

	}

	function sortitems ($a, $b) {
		return strcollcase ($a['description'], $b['description']);

	}

	function make_admin_menu ($wichFolder, $fullview = false) {

		global $opnConfig;

		$ui = $opnConfig['permission']->GetUserinfo ();
		$uid = $ui['uid'];
		$i = 0;
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug,
									'admin',
									$wichFolder);
		foreach ($plug as $var) {
			$module = $var['plugin'];
			$rights = array (_PERM_EDIT,
					_PERM_NEW,
					_PERM_DELETE,
					_PERM_SETTING,
					_PERM_ADMIN);
			if (file_exists (_OPN_ROOT_PATH . $module . '/plugin/userrights/rights.php') ) {
				include_once (_OPN_ROOT_PATH . $module . '/plugin/userrights/rights.php');
				$myfunc = $var['module'] . '_admin_rights';
				if (function_exists ($myfunc) ) {
					$myfunc ($rights);
				}
			}
			if ($opnConfig['permission']->HasRights ($var['plugin'], $rights, true) ) {
				$rank = 1;
				if ($opnConfig['installedPlugins']->isplugininstalled ('admin/customizer_admin') ) {
					global $opnTables;

					$name = $opnConfig['opnSQL']->qstr ($module);
					$auto_found = $opnConfig['opnSQL']->qstr ('ADMIN');
					$module = $opnConfig['opnSQL']->qstr ($module);
					$query = &$opnConfig['database']->SelectLimit ('SELECT id, rank FROM ' . $opnTables['customizer_admin_set'] . ' WHERE (uid=' . $uid . ' OR uid=0) AND auto_found=' . $auto_found . ' AND name=' . $name . ' AND module=' . $module, 1);
					if ($query->RecordCount () != 1) {
						$id = $opnConfig['opnSQL']->get_new_number ('customizer_admin_set', 'id');
						$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['customizer_admin_set'] . " values ($id, 0, $name, $auto_found, $module, $rank)");
					} else {
						if ($query !== false) {
							while (! $query->EOF) {
								$rank = $query->fields['rank'];
								$query->MoveNext ();
							}
						}
						$query->Close ();
					}
				}
				if ( ($opnConfig['installedPlugins']->isplugininstalled ($var['plugin']) ) OR ($wichFolder == 'admin') ) {
					if ($rank != 0) {
						$admin_data[$i] = '';
						get_menu ($admin_data[$i], _OPN_ROOT_PATH . $var['plugin'], $var['module'], $opnConfig['opn_url'] . '/' . $var['plugin']);
						$i++;
					}
				}
			}
		}
		$i = 0;
		$domenu = false;
		if (isset ($admin_data) ) {
			if (is_array ($admin_data) ) {
				usort ($admin_data, 'sortitems');
				reset ($admin_data);
				foreach ($admin_data as $val1) {
					if ($val1 != '') {
						$domenu = true;
					}
				}
				if ($domenu) {
					$table = & new opn_TableClass ('alternator');
					if ( ($opnConfig['opn_showadminmodernart'] == 1) && (!$fullview) ) {
						$table->AddCols (array ('100%') );
						$moderne = 1;
					} else {
						$table->AddCols (array ('20%', '20%', '20%', '20%', '20%') );
						$moderne = 5;
					}
					$table->AddOpenHeadRow ();
					$table->AddHeaderCol ('<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
												'aop' => $wichFolder) ) . '" class="alternatorhead">' . ucfirst ($wichFolder) . '&nbsp;' . _AF_ADMINMENU . '</a>',
												'center',
												'5');
					$table->AddChangeRow ();
					reset ($admin_data);
					foreach ($admin_data as $val1) {
						if ($val1 != '') {
							$admin_item = $val1;
							if ($admin_item['description'] != '') {
								if ($i == $moderne) {
									$i = 0;
									$table->AddChangeRow ();
								}
								$table->AddDataCol (admin_menu_item ($admin_item), 'center');
								$i++;
							}
						}
					}
					if ($i<$moderne) {
						$table->AddDataCol ('&nbsp;', '', $moderne- $i);
					}
					$table->AddCloseRow ();
				}
			}
		}
		if ($domenu) {
			$txt = '';
			$table->GetTable ($txt);
			return $txt;
		}
		return '';

	}

	function get_menu (&$data, $folder, $module, $ufolder, $pfix = 'opn_') {

		global $opnConfig;

		$data = '';
		$item_path = $folder . '/' . $pfix . 'item.php';
		if (file_exists ($item_path) ) {
			include_once ($item_path);
			$myfunc = $module . '_get_admin_config';
			if (function_exists ($myfunc) ) {
				$data = array ();
				$myfunc ($data);
			} else {
				$data['adminpath'] = '';
				$data['image'] = '';
				$data['description'] = '';
			}
			if ($data['adminpath'] != '') {
				$a = '<a href="' . encodeurl ($ufolder . '/' . $data['adminpath']) . '" class="%alternate%">';
			} else {
				$a = '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
								'fct' => $module) ) . '" class="%alternate%">';
			}
			if ($data['image'] != '') {
				$data['glink'] = $a . '<img src="' . $opnConfig['opn_url'] . '/' . $data['image'] . '" class="imgtag" alt="' . $data['description'] . '" title="' . $data['description'] . '" /><br />' . $data['description'] . '</a>' . _OPN_HTML_NL;
			} else {
				$data['glink'] = '';
			}
			$data['tlink'] = $a . $data['description'] . '</a>' . _OPN_HTML_NL;
		}

	}

	function get_plugins ($folder, $module, $installed, $wfolder, $update = false) {

		global $opnConfig;

		$data = '';
		$item_path = $folder . '/plugin/index.php';
		if (file_exists ($item_path) ) {
			$setinfo = FALSE;
			$c = $opnConfig['installedPlugins']->isplugininstalled ($wfolder . '/' . $module);
			if ($installed) {
				if ($c) {
					$setinfo = TRUE;
				}
			} elseif (! $c) {
				$setinfo = TRUE;
			}
			if ($setinfo) {
				$item_path = $folder . '/' . 'opn_item.php';
				$haveitem = FALSE;
				if (file_exists ($item_path) ) {
					include_once ($item_path);
					$myfunc = $module . '_get_admin_config';
					if (function_exists ($myfunc) ) {
						$data = array ();
						$myfunc ($data);
						if (!isset ($data['description']) ) {
							opnErrorHandler (E_WARNING, 'This module ist not ok', $myfunc, $item_path);
							$data['description'] = $module;
							$data['image'] = '';
							$data['adminpath'] = '';
						}
						$haveitem = TRUE;
					}
				}
				if (!$haveitem) {
					$data['description'] = $module;
					$data['image'] = '';
					$data['adminpath'] = '';
				}
				if ($update) {
					$updatepath = encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'plugins',
									'op' => 'update',
									'module' => $wfolder . '/' . $module,
									'plugback' => $wfolder) );
				}
				$temp = array ($opnConfig['opn_url'] . '/admin.php',
						'fct' => 'plugins',
						'module' => $wfolder . '/' . $module,
						'plugback' => $wfolder);
				if ($installed) {
					$temp['op'] = 'remove';
				} else {
					$temp['op'] = 'install';
				}
				$data['adminpath'] = encodeurl ($temp);
			} else {
				return '';
			}
			$a = '<a href="' . $data['adminpath'] . '" class="%alternate%">';
			if ($data['image'] != '') {
				$data['glink'] = $a . '<img src="' . $opnConfig['opn_url'] . '/' . $data['image'] . '" class="imgtag" alt="' . $data['description'] . '" title="' . $data['description'] . '" /><br />' . $data['description'] . '</a>' . _OPN_HTML_NL;
			} else {
				$data['glink'] = '';
			}
			$data['tlink'] = $a . $data['description'] . '</a>' . _OPN_HTML_NL;
			if ($update) {
				$a = '<a href="' . $updatepath . '" class="%alternate%">';
				if ($data['image'] != '') {
					$data['glink'] = $a . '<img src="' . $opnConfig['opn_url'] . '/' . $data['image'] . '" class="imgtag" alt="' . $data['description'] . '" title="' . $data['description'] . '" /><br />' . $data['description'] . '</a>' . _OPN_HTML_NL;
				}
				$data['tlink'] = $a . $data['description'] . '</a>' . _OPN_HTML_NL;
			}
		}
		return $data;

	}

	function make_plugins_menu ($wichPath, $wichFolder, $installed, $update = false) {

		global $opnConfig;

		$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
		if ($update) {
			$name = 'fix';
			$box = 'allfixbox';
		} else {
			if ($installed) {
				$name = 'deinstall';
				$box = 'alldeinstallbox';
			} else {
				$name = 'install';
				$box = 'allinstallbox';
			}
		}
		$func1 = 'CheckAll(\'' . $name . '\',\'' . $box . '\');';
		$func2 = 'CheckCheckAll(\'' . $name . '\',\'' . $box . '\');';
		$form = & new opn_FormularClass ('alternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('opn_zzz_yyy', 'opn_plugins');
		$form->Init ($opnConfig['opn_url'] . '/admin.php', 'post', $name);
		$form->AddTable ();
		$form->AddCols (array ('20%', '20%', '20%', '20%', '20%') );
		$form->AddOpenHeadRow ();
		$form->SetIsHeader (true);
		if ($update) {
			$help = _AF_MIRRORFIX;
		} else {
			if ($installed) {
				$help = _AF_REMOVEPLGIN;
			} else {
				$help = _AF_INSTALLPLUGIN;
			}
		}
		$form->SetColspan ('5');
		$form->SetSameCol ();
		$form->AddCheckbox ($box, 'Check All', 0, $func1);
		$form->AddText ('&nbsp;' . $help);
		$form->SetEndCol ();
		$form->SetColspan ('');
		$form->SetIsHeader (false);
		$form->AddCloseRow ();
		$i = 0;
		$da = '';
		$admin_data = '';
		$admindata = get_dir_list ($wichPath . $wichFolder);
		foreach ($admindata as $file) {
			$da = get_plugins ($wichPath . $wichFolder . '/' . $file, $file, $installed, $wichFolder, $update);
			if (is_array ($da) ) {
				$da['SAFE_MH'] = $wichFolder . '/' . $file;
				$da['module'] = $file;
				$admin_data[] = $da;
			}
		}
		$i = 0;
		$uid = $opnConfig['permission']->UserInfo ('uid');
		$opnConfig['webinclude'] = & new update_module ();
		if (is_array ($admin_data) ) {
			usort ($admin_data, 'sortitems');
			reset ($admin_data);
			$form->AddOpenRow ();
			$help2 = false;
			foreach ($admin_data as $val1) {
				$admin_item = $val1;
				if ( (isset ($admin_item['description']) ) && (trim ($val1['description']) != '') ) {
					if ($uid == 2) {
						$ok = 1;
					} else {
						if ($opnConfig['opn_multihome'] == 0) {
							$ok = 1;
						} else {
							if ($opnConfig['webinclude']->mhfix_check_module (trim ($val1['SAFE_MH']) ) == 1) {
								$ok = 1;
							} else {
								$ok = 0;
							}
						}
					}
					if ($ok == 1) {
						$help2 = true;
						if ($i == 5) {
							$i = 0;
							$form->AddChangeRow ();
						}
						$form->SetSameCol ();
						$form->AddHidden ('modulenames[' . $val1['SAFE_MH'] . ']', urlencode ($val1['description']) );
						$form->AddHidden ('modulename[' . $val1['SAFE_MH'] . ']', $val1['module']);
						$form->AddCheckbox ('modules[]', $val1['SAFE_MH'], 0, $func2);
						$form->AddText ('&nbsp;');
						$form->AddText (admin_menu_item ($val1) );
						$form->SetEndCol ();
						$i++;
					}
				}
			}
			if (!$help2) {
				$form->SetColspan ('5');
				$form->AddText (_AF_NOMODULESFOUND);
				$form->SetColspan ('');
			} else {
				if ($i<5) {
					$form->SetColspan (5- $i);
					$form->AddText ('&nbsp;');
					$form->SetColspan ('');
				}
				$form->AddChangeRow ();
				$form->SetColspan ('5');
				$form->SetAlign ('center');
				$form->SetSameCol ();
				$form->AddHidden ('fct', 'plugins');
				$form->AddHidden ('op', 'moduleselected');
				$form->AddHidden ('plugback', $wichFolder);
				$form->AddHidden ('action', urlencode ($help) );
				$form->AddSubmit ('submit', $help);
				$form->SetEndCol ();
				$form->SetColspan ('');
				$form->SetAlign ('');
			}
			$form->AddCloseRow ();
		}
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$help = '';
		$form->GetFormular ($help);
		return $help;

	}

	function plugin_admin_menu ($wFolder) {

		global $opnConfig;

		$txt = make_plugins_menu (_OPN_ROOT_PATH, $wFolder, false) . '<br />';
		$txt .= make_plugins_menu (_OPN_ROOT_PATH, $wFolder, true);
		if (isset ($opnConfig['UseMirrorFixSystem']) ) {
			$txt .= make_plugins_menu (_OPN_ROOT_PATH, $wFolder, true, true);
		}
		return $txt;

	}

	/* for admin sidebox, centerbox, opnbox */

	function admin_build_day () {

		$xday = 1;
		$options = array ();
		while ($xday<=31) {
			$day = sprintf ('%02d', $xday);
			$options[$day] = $day;
			$xday++;
		}
		return $options;

	}

	function admin_build_month () {

		$xmonth = 1;
		$options = array ();
		while ($xmonth<=12) {
			$month = sprintf ('%02d', $xmonth);
			$options[$month] = $month;
			$xmonth++;
		}
		return $options;

	}

	function admin_build_hour () {

		$xhour = 0;
		$options = array ();
		while ($xhour<=23) {
			$hour = sprintf ('%02d', $xhour);
			$options[$hour] = $hour;
			$xhour++;
		}
		return $options;

	}

	function admin_build_minute () {

		$xmin = 0;
		$options = array ();
		while ($xmin<=59) {
			$min = sprintf ('%02d', $xmin);
			$options[$min] = $min;
			$xmin = $xmin+5;
		}
		return $options;

	}

	function filterfiles ($var, $parm, $parm2) {

		$rc = 0;
		if (substr ($var, 0, $parm2) == $parm) {
			$rc = 1;
		}
		return $rc;

	}

	function GetFileChooseOption (&$options, $tpath, $search) {

		$m = strlen ($search);
		$options = array ();
		$filelist = get_file_list ($tpath);
		arrayfilter ($filelist, $filelist, 'filterfiles', $search);
		natcasesort ($filelist);
		reset ($filelist);
		$options[''] = _NO_SUBMIT;
		if (is_array ($filelist) ) {
			foreach ($filelist as $file) {
				$g = substr ($file, $m);
				$g = explode ('.', $g);
				if (is_array ($g) ) {
					$options[$file] = $g[0];
				}
			}
		}

	}

	function get_all_box_types_from_modul ($modul) {

		global $opnConfig;

		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug, 'middlebox');
		$mytypearr = array ();
		foreach ($plug as $var1) {
			foreach ($var1['middleboxes'] as $var2) {
				if ( ($modul == '') OR ($modul == $var1['plugin']) ) {
					$retval = include_once (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/middlebox/' . $var2 . '/typedata.php');
					if (!isset ($retval['preview']) ) {
						if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/middlebox/' . $var2 . '/preview/preview.png') ) {
							$retval['preview'] = $var1['plugin'] . '/plugin/middlebox/' . $var2 . '/preview/preview.png';
						} else {
							$retval['preview'] = 'admin/sidebox/images/no_preview.jpg';
						}
					} else {
						$retval['preview'] = $var1['plugin'] . '/' . $retval['preview'];
					}
					if (isset ($retval['name']) ) {
						$boxname = $retval['name'];
					} else {
						$boxname = $var1['plugin'];
					}
					if (isset ($retval['type']) ) {
						$boxtype = '[' . $retval['type'] . ']';
					} else {
						$boxtype = '[C]';
					}
					if (isset ($mytypearr[$boxname]) ) {
						$boxname .= 'centerbox DD';
					}
					if ($boxtype != '') {
						$boxname .= '' . $boxtype;
					} else {
						$boxname .= '[C]';
					}
					$mytypearr[$boxname] = array ('preview' => $retval['preview'],
									'name' => $boxname,
									'path' => $var1['plugin'] . '/plugin/middlebox/' . $var2);
				}
			}
		}
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug, 'sidebox');
		foreach ($plug as $var1) {
			foreach ($var1['sideboxes'] as $var2) {
				if ( ($modul == '') OR ($modul == $var1['plugin']) ) {
					$retval = include_once (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/sidebox/' . $var2 . '/typedata.php');
					if (!isset ($retval['preview']) ) {
						if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/sidebox/' . $var2 . '/preview/preview.png') ) {
							$retval['preview'] = $var1['plugin'] . '/plugin/sidebox/' . $var2 . '/preview/preview.png';
						} else {
							$retval['preview'] = 'admin/sidebox/images/no_preview.jpg';
						}
					} else {
						$retval['preview'] = $var1['plugin'] . '/' . $retval['preview'];
					}
					if (isset ($retval['name']) ) {
						$boxname = $retval['name'];
					} else {
						$boxname = $var1['plugin'];
					}
					if (isset ($retval['type']) ) {
						$boxtype = '[' . $retval['type'] . ']';
					} else {
						$boxtype = '[S]';
					}
					if (isset ($mytypearr[$boxname]) ) {
						$boxname .= 'sidebox DD';
					}
					if ($boxtype != '') {
						$boxname .= '' . $boxtype;
					} else {
						$boxname .= '[S]';
					}
					$mytypearr[$boxname] = array ('preview' => $retval['preview'],
									'name' => $boxname,
									'path' => $var1['plugin'] . '/plugin/sidebox/' . $var2);
				}
			}
		}
		return $mytypearr;

	}
}

?>