<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_INCLUDE_OPNDB_ERRORHANDLER_PHP') ) {
	define ('_OPN_INCLUDE_OPNDB_ERRORHANDLER_PHP', 1);
	define ('SQLLAYER_ERROR_HANDLER', 'SQLLAYER_Error_Handler');
	if (!defined ('SQLLAYER_ERROR_HANDLER_TYPE') ) {
		define ('SQLLAYER_ERROR_HANDLER_TYPE', E_USER_ERROR);
	}

	function opnErrorHandler ($errno, $errstr, $errfile, $errline) {

		global $opnConfig;
		if (error_reporting () == 0) {
			return '';
		}
		if (substr(phpversion(), 0,1) == '5') {
			if ( (!isset ($opnConfig['opn_php5_migration']) ) OR ($opnConfig['opn_php5_migration'] == 0) ) {
				if (!defined ('_OPN_XP_ERRORPHP51X')) {
					if ( (substr_count ($errstr, 'Deprecated')>0) OR (substr_count ($errstr, 'deprecated')>0) OR (substr_count ($errstr, 'Only variable references should be returned by reference')>0) OR (substr_count ($errstr, 'Implicit cloning object') ) OR (substr_count ($errstr, 'Redefining already defined constructor')>0) ) {
						return '';
					}
				} else {
					if ( (substr_count ($errstr, 'Deprecated')>0) OR (substr_count ($errstr, 'deprecated')>0) OR (substr_count ($errstr, 'Implicit cloning object') ) OR (substr_count ($errstr, 'Redefining already defined constructor')>0) ) {
						return '';
					}
				}
			}
		}
		if ( (!defined ('_OPN_XML_DOCTYPE') ) && (!defined ('_OPN_SHELL_RUN') ) ) {
			define ('_OPN_XML_DOCTYPE', 1);
			if (!isset ($opnConfig['opn_charset_encoding']) ) {
				$opnConfig['opn_charset_encoding'] = '';
			}
			if ($opnConfig['opn_charset_encoding'] != '') {
				echo '<?xml version="1.0" encoding="' . $opnConfig['opn_charset_encoding'] . '"?>' . _OPN_HTML_NL;
			}
			echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . _OPN_HTML_NL;
			echo '<html xmlns="http://www.w3.org/1999/xhtml">' . _OPN_HTML_NL;
			echo '<head>' . _OPN_HTML_NL;
		}
		if (defined ('_OPN_ROOT_PATH') ) {
			$file = str_replace (_OPN_ROOT_PATH, '', $errfile);
		} else {
			$file = $errfile;
		}
		$_error_log = '<hr />' . _OPN_HTML_NL;
		$_error_log .= '<span class="normaltextbold">%s</span> [%s] %s<br />' . _OPN_HTML_NL;
		$_error_log .= '<span class="normaltextbold">FOUND IN</span> [' . $file . '] <br />' . _OPN_HTML_NL;
		$_error_log .= '<span class="normaltextbold">FOUND AT</span> ' . $errline . '   <br />' . _OPN_HTML_NL;
		switch ($errno) {
			case E_ERROR:
			case E_PARSE:
				$_error_log = sprintf ($_error_log, 'FATAL', $errno, $errstr) . _OPN_HTML_NL;
				$_error_log .= ', PHP ' . PHP_VERSION . ' (' . PHP_OS . ')' . '<br />' . _OPN_HTML_NL;
				$_error_log .= 'Aborting...<br />' . _OPN_HTML_NL;
				break;
			case E_USER_WARNING:
			case E_WARNING:
				$_error_log = sprintf ($_error_log, 'ERROR', $errno, $errstr) . _OPN_HTML_NL;
				break;
			case SQLLAYER_ERROR_HANDLER_TYPE:
				$_error_log = sprintf ($_error_log, 'SQL-ERROR', $errno, $errstr) . _OPN_HTML_NL;
				break;
			case E_USER_NOTICE:
			case E_NOTICE:
				$_error_log = sprintf ($_error_log, 'WARNING', $errno, $errstr) . _OPN_HTML_NL;
				break;
			case E_STRICT:
				$_error_log = sprintf ($_error_log, 'STRICT', $errno, $errstr) . _OPN_HTML_NL;
				break;
			default:
				$_error_log = sprintf ($_error_log, 'Unkown error type:', $errno, $errstr) . _OPN_HTML_NL;
				break;
		}
		$_error_log .= '<hr />' . _OPN_HTML_NL;
		$_log = str_replace ('<span class="normaltextbold">', '', $_error_log);
		$_log = str_replace ('</span>', '', $_log);
		$_log = str_replace ('<br />', '', $_log);
		$_log = str_replace ('<hr />', '', $_log);
		if (class_exists ('opn_errorhandler') ) {
			$eh = & new opn_errorhandler ();
			$eh->write_error_log ($_log);
		}
		if ( (isset ($opnConfig['errorlog_useunixlog']) ) && ($opnConfig['errorlog_useunixlog'] == 1) ) {
			if (!class_exists ('opn_handler_logging') ) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.handler_logging.php');
			}
			$_logger = & new opn_handler_logging ('errors.log');
			$_logger->write ($_log);
			$_logger->close ();
		}
		if (defined ('_OPN_SHELL_RUN') ) {
			echo $_log;
		} else {
			echo $_error_log;
		}
		return '';

	}
	if (!defined ('_OPN_XP_ERRORTYPE') ) {
		$old_error_handler = set_error_handler ('opnErrorHandler');
		if (defined ('_OPN_XP_ERRORPHP51X')) {
			ini_set ('display_errors', false);
			if (defined ('_OPN_XP_LOGERRORS')) {
				ini_set ('log_errors', true);
				ini_set ('error_log', _OPN_ROOT_PATH . 'cache/error.log');
			}
			ini_set ('warn_plus_overloading', true);
		}
	}

	function outpintopn ($msg, $newline = true) {

		global $HTTP_SERVER_VARS, $opnConfig;
		if ( (!defined ('_OPN_XML_DOCTYPE') ) && (!defined ('_OPN_SHELL_RUN') ) ) {
			define ('_OPN_XML_DOCTYPE', 1);
			if ($opnConfig['opn_charset_encoding'] != '') {
				echo '<?xml version="1.0" encoding="' . $opnConfig['opn_charset_encoding'] . '"?>' . _OPN_HTML_NL;
			}
			echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . _OPN_HTML_NL;
			echo '<html xmlns="http://www.w3.org/1999/xhtml">' . _OPN_HTML_NL;
			echo '<head>' . _OPN_HTML_NL;
		}
		if ($newline) {
			$msg .= '<br />' . _OPN_HTML_NL;
		}
		if (isset ($HTTP_SERVER_VARS['HTTP_USER_AGENT']) ) {
			echo $msg;
		} else {
			echo strip_tags ($msg);
		}

	}

	/**
	* Error Handler. This will be called with the following params
	*
	* @param $dbms		the RDBMS you are connecting to
	* @param $fn		the name of the calling function (in uppercase)
	* @param $errno		the native error number from the database
	* @param $errmsg	the native error msg from the database
	* @param $p1		$fn specific parameter - see below
	* @param $P2		$fn specific parameter - see below
	*/

	function SQLLAYER_Error_Handler ($dbms, $fn, $errno, $errmsg, $p1 = false, $p2 = false) {
		if (error_reporting () == 0) {
			return;
		}
		// obey @ protocol
		switch ($fn) {
			case 'EXECUTE':
				$sql = $p1;
				$s = $dbms . ' error: [' . $errno . ': ' . $errmsg . '] in ' . $fn . "(\"$sql\")\n";
				break;
			case 'PCONNECT':
			case 'CONNECT':
				$host = $p1;
				$database = $p2;
				$s = "$dbms error: [$errno: $errmsg] in $fn($host, '****', '****', $database)\n";
				break;
			default:
				$s = "$dbms error: [$errno: $errmsg] in $fn($p1, $p2)\n";
				break;
		}

		/*
		* Log connection error somewhere
		*	0 message is sent to PHP's system logger, using the Operating System's system
		*		logging mechanism or a file, depending on what the error_log configuration
		*		directive is set to.
		*	1 message is sent by email to the address in the destination parameter.
		*		This is the only message type WHERE the fourth parameter, extra_headers is used.
		*		This message type uses the same internal function as mail() does.
		*	2 message is sent through the PHP debugging connection.
		*		This option is only available if remote debugging has been enabled.
		*		In this case, the destination parameter specifies the host name or IP address
		*		and optionally, port number, of the socket receiving the debug information.
		*	3 message is appended to the file destination
		*/
		if (defined ('SQLLAYER_ERROR_LOG_TYPE') ) {
			$t = date ('Y-m-d H:i:s');
			if (defined ('SQLLAYER_ERROR_LOG_DEST') ) {
				error_log ("($t) $s", SQLLAYER_ERROR_LOG_TYPE, SQLLAYER_ERROR_LOG_DEST);
			} else {
				error_log ("($t) $s", SQLLAYER_ERROR_LOG_TYPE);
			}
		}
		if (!defined ('_SQLLAYER_ERROR_HANDLER_NO') ) {
			trigger_error ($s, SQLLAYER_ERROR_HANDLER_TYPE);
			if (defined ('_OPN_XP_ERRORTYPE') ) {
				echo $s;
			}
		}

	}
}

?>