<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig, ${$opnConfig['opn_server_vars']};

$vars = ${$opnConfig['opn_server_vars']};
if (isset ($vars['PATH_INFO']) ) {
	$script = $vars['PATH_INFO'];
} else {
	$script = $vars['SCRIPT_NAME'];
}
$img_expand = $opnConfig['opn_default_images'] . 'tree/tree_expand.gif';
$img_collapse = $opnConfig['opn_default_images'] . 'tree/tree_collapse.gif';
$img_line = $opnConfig['opn_default_images'] . 'tree/tree_vertline.gif';
$img_split = $opnConfig['opn_default_images'] . 'tree/tree_split.gif';
$img_end = $opnConfig['opn_default_images'] . 'tree/tree_end.gif';
$img_leaf = $opnConfig['opn_default_images'] . 'tree/tree_leaf.gif';
$img_spc = $opnConfig['opn_default_images'] . 'tree/tree_space.gif';

/*********************************************/

/*  Read text file with tree structure	   */

/*********************************************/

/**********************************************/

/* read file to $tree array			*/

/* tree['x'][0] -> tree level			*/

/* tree['x'][1] -> item text			*/

/* tree['x'][2] -> item link			*/

/* tree['x'][3] -> link target		*/

/* tree['x'][4] -> last item in subtree	*/

/*********************************************/

global $treefile;

$maxlevel = 0;
$cnt = 0;
if (file_exists ($treefile) ) {
	$fd = fopen ($treefile, 'r');
	if ($fd == 0) {
		die ('treemenu.php : Unable to open file ' . $treefile);
	}
	while ($buffer = fgets ($fd, 4096) ) {
		$tree[$cnt][0] = strspn ($buffer, '.');
		$tmp = rtrim (substr ($buffer, $tree[$cnt][0]) );
		$node = explode ('|', $tmp);
		if (!isset ($node[2]) ) {
			$node[2] = '';
		}
		$tree[$cnt][1] = $node[0];
		$tree[$cnt][2] = $node[1];
		$tree[$cnt][3] = $node[2];
		$tree[$cnt][4] = 0;
		if ($tree[$cnt][0]>$maxlevel) {
			$maxlevel = $tree[$cnt][0];
		}
		$cnt++;
	}
	fclose ($fd);
	$max = count ($tree);
	for ($i = 0; $i< $max; $i++) {
		$expand[$i] = 0;
		$visible[$i] = 0;
		$levels[$i] = 0;
	}

	/*********************************************/

	/*  Get Node numbers to expand			   */

	/*********************************************/
	if (!isset ($p) ) {
		$p = '';
	}
	if ($p != '') {
		$explevels = explode ('|', $p);
	}
	$i = 0;
	if (!isset ($explevels) ) {
		$explevels = array ();
	}
	while ($i<count ($explevels) ) {
		$expand[$explevels[$i]] = 1;
		$i++;
	}

	/*********************************************/

	/*  Find last nodes of subtrees			  */

	/*********************************************/

	$lastlevel = $maxlevel;
	for ($i = count ($tree)-1; $i >= 0; $i--) {
		if ($tree[$i][0]<$lastlevel) {
			for ($j = $tree[$i][0]+1; $j<= $maxlevel; $j++) {
				$levels[$j] = 0;
			}
		}
		if (!isset ($levels[$tree[$i][0]]) ) {
			$levels[$tree[$i][0]] = 0;
		}
		if ($levels[$tree[$i][0]] == 0) {
			$levels[$tree[$i][0]] = 1;
			$tree[$i][4] = 1;
		} else {
			$tree[$i][4] = 0;
			$lastlevel = $tree[$i][0];
		}
	}

	/*********************************************/

	/*  Determine visible nodes				  */

	/*********************************************/
	// all root nodes are always visible
	$counted = count ($tree);
	for ($i = 0; $i<$counted; $i++) {
		if ($tree[$i][0] == 1) {
			$visible[$i] = 1;
		}
	}
	if (!isset ($explevels) ) {
		$explevels = array ();
	}
	$counted = count ($explevels);
	for ($i = 0; $i<$counted; $i++) {
		$n = $explevels[$i];
		if ( ($visible[$n] == 1) && ($expand[$n] == 1) ) {
			$j = $n+1;
			while ($tree[$j][0]> $tree[$n][0]) {
				if ($tree[$j][0] == $tree[$n][0]+1) {
					$visible[$j] = 1;
				}
				$j++;
			}
		}
	}

	/****************************************/

	/*  Output nicely formatted tree	*/

	/****************************************/

	for ($i = 0; $i< $maxlevel; $i++) $levels[$i] = 1; $maxlevel++; $mycols = $maxlevel+3; $boxstuff .= '<table cellspacing="0" cellpadding="0" width="100%"><tr>' . _OPN_HTML_NL; for ($i = 0; $i< $maxlevel; $i++) {
		$boxstuff .= '<td width="16"></td>' . _OPN_HTML_NL;
	}
	$boxstuff .= '<td width="100%">&nbsp;</td></tr>' . _OPN_HTML_NL;
	$cnt = 0;
	while ($cnt<count ($tree) ) {
		if (!isset ($visible[$cnt]) ) {
			$visible[$cnt] = false;
		}
		if ($visible[$cnt]) {

			/****************************************/

			/* start new row			*/

			/****************************************/

			$boxstuff .= '<tr>';

			/****************************************/

			/* vertical lines from higher levels	*/

			/****************************************/

			$i = 0;
			while ($i< $tree[$cnt][0]-1) {
				if ($levels[$i] == 1) {
					$boxstuff .= '<td><a name="' . $cnt . '"></td>' . _OPN_HTML_NL;
				} else {
					$boxstuff .= '<td><a name="' . $cnt . '"></td>' . _OPN_HTML_NL;
				}
				$i++;
			}

			/****************************************/

			/* corner at end of subtree or t-split  */

			/****************************************/
			if ($tree[$cnt][4] == 1) {
				$levels[$tree[$cnt][0]-1] = 0;
			} else {
				$levels[$tree[$cnt][0]-1] = 1;
			}

			/********************************************/

			/* Node (with subtree) or Leaf (no subtree) */

			/********************************************/

			$params = '';
			if (!isset ($tree[$cnt+1][0]) ) {
				$tree[$cnt+1][0] = 0;
			}
			if ($tree[$cnt+1][0]>$tree[$cnt][0]) {

				/****************************************/

				/* Create expand/collapse parameters	*/

				/****************************************/

				$i = 0;
				$params = '?p=';
				while ($i<count ($expand) ) {
					if ( ($expand[$i] == 1) && ($cnt != $i) || ($expand[$i] == 0 && $cnt == $i) ) {
						$params = $params . $i;
						$params = $params . '&amp;';
					}
					$i++;
				}
				if ($expand[$cnt] == 0) {
					$boxstuff .= '<td><a href="' . $script . $params . '"><img src="' . $img_expand . '" class="imgtag" alt="" /></a></td>' . _OPN_HTML_NL;
				} else {
					$boxstuff .= '<td><a href="' . $script . $params . '"><img src="' . $img_collapse . '" class="imgtag" alt="" /></a></td>' . _OPN_HTML_NL;
				}
			} else {

				/*************************/

				/* Tree Leaf			 */

				/*************************/
				// $boxstuff .= "<img src=\"".$img_leaf."\">";
			}

			/****************************************/

			/* output item text					 */

			/****************************************/

			$twdummy = $maxlevel- ($tree[$cnt][0]);
			$boxstuff .= '<td colspan="' . $twdummy . '" nowrap="nowrap">';
			if ($tree[$cnt][2] == '') {
				$boxstuff .= $tree[$cnt][1];
			} else {
				if ( (isset ($tree[$cnt][3]) ) && ($tree[$cnt][3] != '') ) {
					$target = ' target="' . $tree[$cnt][3] . '"';
				} else {
					$target = '';
				}
				$boxstuff .= '<span class="smalltext"><a href="' . $tree[$cnt][2] . '&amp;p=' . $params . '"' . $target . '>' . $tree[$cnt][1] . '</a></span>';
			}
			$boxstuff .= '</td></tr>' . _OPN_HTML_NL;

			/****************************************/

			/* end row							  */

			/****************************************/
		}
		$cnt++;
	}
	$boxstuff .= '</table>' . _OPN_HTML_NL;
}

?>