<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/acronyms/admin/language/');

function AcronymsConfigHeader () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_ACRODMIN_TITLE);
	$menu->InsertEntry (_ACROADMIN_MAIN, $opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
	$result = $opnConfig['database']->Execute ('SELECT COUNT(id) AS counter FROM ' . $opnTables['acronyms_new']);
	if (isset ($result->fields['counter']) ) {
		$num = $result->fields['counter'];
	} else {
		$num = 0;
	}
	$result->Close ();
	unset ($result);
	if ($num>0) {
		$menu->InsertEntry (sprintf (_ACROADMIN_NEWACROS, $num), array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'newacronyms') );
	}
	$menu->InsertEntry (_ACROADMIN_ADMINSETTINGS, $opnConfig['opn_url'] . '/modules/acronyms/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function listAcronyms () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_acronym';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$text = '';
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['acronyms'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	AcronymsConfigHeader ();
	$order = '';
	$oldsortby = $sortby;
	$progurl = array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
	if ($reccount >= 1) {
		$form = & new opn_FormularClass ('alternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_10_', 'modules/acronyms');
		$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
		$form->AddTable ();
		$form->get_sort_order ($order, array ('id',
							'acronym',
							'meaning'),
							$sortby);
		$form->AddOpenHeadRow ();
		$form->SetIsHeader (true);
		$form->AddText ('&nbsp;');
		$form->AddText ($form->get_sort_feld ('id', _ACROADMIN_ID, $progurl) );
		$form->AddText ($form->get_sort_feld ('acronym', _ACROADMIN_TERM, $progurl) );
		$form->AddText ($form->get_sort_feld ('meaning', _ACROADMIN_MEANING, $progurl) );
		$form->AddText (_ACROADMIN_DECLARATION);
		$form->AddText (_ACROADMIN_FUNCTIONS);
		$form->SetIsHeader (false);
		$form->AddCloseRow ();
		$info = &$opnConfig['database']->SelectLimit ('SELECT id, acronym, meaning, declaration FROM ' . $opnTables['acronyms'] . ' ' . $order, $maxperpage, $offset);
		while (! $info->EOF) {
			$id = $info->fields['id'];
			$term = $info->fields['acronym'];
			$meaning = $info->fields['meaning'];
			$declaration = $info->fields['declaration'];
			opn_nl2br ($declaration);
			$hlp = $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'editacro',
										'id' => $id) ) . ' ';
			$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'deleteacro',
										'id' => $id,
										'ok' => '0') );
			$form->AddOpenRow ();
			$form->AddCheckbox ('del_id[]', $id);
			$form->AddText ($id);
			$form->AddText ($term);
			$form->AddText ($meaning);
			$form->AddText ($declaration);
			$form->AddText ($hlp);
			$form->AddCloseRow ();
			$info->MoveNext ();
		}
		// while
		$form->AddOpenRow ();
		$form->SetColspan ('6');
		$form->SetSameCol ();
		$form->AddHidden ('op', 'deleteselected');
		$form->AddSubmit ('submit', _ACROADMIN_DELETE);
		$form->SetEndCol ();
		$form->SetColspan ('');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($text);
		$text .= '<br /><br />';
		$text .= build_pagebar (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
						'sortby' => $oldsortby),
						$reccount,
						$maxperpage,
						$offset);
	}
	$text .= '<br /><br />';
	$text .= '<span class="normaltextbold">' . _ACROADMIN_ADDACRO . '</span><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_20_', 'modules/acronyms');
	$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('acronym', _ACROADMIN_TERM . ':');
	$form->AddTextfield ('acronym', 20, 100);
	$form->AddChangeRow ();
	$form->AddLabel ('meaning', _ACROADMIN_MEANING . ':');
	$form->AddTextfield ('meaning', 60, 250);
	$form->AddChangeRow ();
	$form->AddLabel ('declaration', _ACROADMIN_DECLARATION);
	$form->AddTextarea ('declaration');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'addacro');
	$form->AddSubmit ('submit', _ACROADMIN_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_30_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_TITLE, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function listNewAcronyms () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['acronyms_new'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, acronym, meaning, declaration FROM ' . $opnTables['acronyms_new'] . ' ORDER BY id', $maxperpage, $offset);
	if (!isset ($offset) ) {
		$offset = 0;
	}
	AcronymsConfigHeader ();
	$menu = & new OPN_Adminmenu (_ACRODMIN_NEWTITLE);
	$menu->InsertEntry (_ACROADMIN_ADDALLNEW, array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
							'op' => 'addallnew') );
	$menu->InsertEntry (_ACROADMIN_IGNOREALLNEW, array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
							'op' => 'ignoreallnew') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_ACROADMIN_TERM, _ACROADMIN_MEANING, _ACROADMIN_DECLARATION, _ACROADMIN_FUNCTIONS) );
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$term = $info->fields['acronym'];
		$meaning = $info->fields['meaning'];
		$declaration = $info->fields['declaration'];
		opn_nl2br ($declaration);
		$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
									'op' => 'addsinglenew',
									'id' => $id) ) . '">' . _ACROADMIN_ADDNEW . '</a> | ';
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
									'op' => 'ignoresinglenew',
									'id' => $id,
									'ok' => '0') ) . '">' . _ACROADMIN_IGNORENEW . '</a>';
		$table->AddDataRow (array ($term, $meaning, $declaration, $hlp) );
		$info->MoveNext ();
	}
	// while
	$text = '';
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
					'op' => 'newacronyms'),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_40_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_NEWTITLE, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function addallnew () {

	global $opnConfig, $opnTables;

	$opnConfig['opndate']->now ();
	$mydate = '';
	$opnConfig['opndate']->opnDataTosql ($mydate);
	$result = $opnConfig['database']->Execute ('SELECT acronym, meaning, declaration FROM ' . $opnTables['acronyms_new']);
	while (! $result->EOF) {
		$acronym = $result->fields['acronym'];
		$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($acronym{0}) );
		$acronym = $opnConfig['opnSQL']->qstr ($acronym);
		$meaning = $opnConfig['opnSQL']->qstr ($result->fields['meaning']);
		$declaration = $opnConfig['opnSQL']->qstr ($result->fields['declaration'], 'declaration');
		$id = $opnConfig['opnSQL']->get_new_number ('acronyms', 'id');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['acronyms'] . " values ($id, $acronym, $meaning, $declaration, $mydate,$orderchar)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['acronyms'], 'id=' . $id);
		$result->MoveNext ();
	}
	// while
	$result->Close ();
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms_new']);
	$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');

}

function addsinglenew () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['opndate']->now ();
	$mydate = '';
	$opnConfig['opndate']->opnDataTosql ($mydate);
	$result = $opnConfig['database']->Execute ('SELECT acronym, meaning, declaration FROM ' . $opnTables['acronyms_new'] . ' WHERE id=' . $id);
	$acronym = $result->fields['acronym'];
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($acronym{0}) );
	$acronym = $opnConfig['opnSQL']->qstr ($acronym);
	$meaning = $opnConfig['opnSQL']->qstr ($result->fields['meaning']);
	$declaration = $opnConfig['opnSQL']->qstr ($result->fields['declaration'], 'declaration');
	$id1 = $opnConfig['opnSQL']->get_new_number ('acronyms', 'id');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['acronyms'] . " values ($id1, $acronym, $meaning, $declaration, $mydate,$orderchar)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['acronyms'], 'id=' . $id1);
	$result->Close ();
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms_new'] . ' WHERE id=' . $id);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php?op=newacronyms', false) );

}

function ignoreallnew () {

	global $opnConfig, $opnTables;

	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms_new']);
		$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');
	} else {
		AcronymsConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _ACROADMIN_IGNOREALL . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'ignoreallnew',
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php?op=newacronyms') . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_50_';
		$_display_dat['module'] = 'modules/acronyms';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function ignoresinglenew () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms_new'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php?op=newacronyms', false) );
	} else {
		AcronymsConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _ACROADMIN_IGNORESINGLE . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'ignoresinglenew',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php?op=newacronyms') . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_60_';
		$_display_dat['module'] = 'modules/acronyms';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function deleteacro () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');
	} else {
		AcronymsConfigHeader ();
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _ACROADMIN_DELETEACRO . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
										'op' => 'deleteacro',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/acronyms/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_70_';
		$_display_dat['module'] = 'modules/acronyms';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function editacro () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$result = $opnConfig['database']->Execute ('SELECT acronym, meaning, declaration FROM ' . $opnTables['acronyms'] . ' WHERE id=' . $id);
	$acronym = $result->fields['acronym'];
	$meaning = $result->fields['meaning'];
	$declaration = $result->fields['declaration'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_80_', 'modules/acronyms');
	$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('acronym', _ACROADMIN_TERM . ':');
	$form->AddTextfield ('acronym', 20, 100, $acronym);
	$form->AddChangeRow ();
	$form->AddLabel ('meaning', _ACROADMIN_MEANING . ':');
	$form->AddTextfield ('meaning', 60, 250, $meaning);
	$form->AddChangeRow ();
	$form->AddLabel ('declaration', _ACROADMIN_DECLARATION);
	$form->AddTextarea ('declaration', 0, 0, '', $declaration);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	$form->AddHidden ('op', 'saveacro');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _ACROADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$text = '';
	$form->GetFormular ($text);
	AcronymsConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_90_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ACROADMIN_EDITACRO, $text);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function saveacro () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$acronym = '';
	get_var ('acronym', $acronym, 'form', _OOBJ_DTYPE_CHECK);
	$meaning = '';
	get_var ('meaning', $meaning, 'form', _OOBJ_DTYPE_CHECK);
	$declaration = '';
	get_var ('declaration', $declaration, 'form', _OOBJ_DTYPE_CHECK);
	$opnConfig['opndate']->now ();
	$mydate = '';
	$opnConfig['opndate']->opnDataTosql ($mydate);
	$acronym = $opnConfig['cleantext']->filter_text ($acronym, true, true, 'nothml');
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($acronym{0}) );
	$acronym = $opnConfig['opnSQL']->qstr ($acronym);
	$meaning = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($meaning, true, true, 'nothml') );
	$declaration = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($declaration, true, true, 'nothml'), 'declaration');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['acronyms'] . " SET acronym=$acronym, meaning=$meaning, declaration=$declaration, lastmod=$mydate, orderchar=$orderchar WHERE id=$id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['acronyms'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');

}

function addacro () {

	global $opnConfig, $opnTables;

	$acronym = '';
	get_var ('acronym', $acronym, 'form', _OOBJ_DTYPE_CHECK);
	$meaning = '';
	get_var ('meaning', $meaning, 'form', _OOBJ_DTYPE_CHECK);
	$declaration = '';
	get_var ('declaration', $declaration, 'form', _OOBJ_DTYPE_CHECK);
	$opnConfig['opndate']->now ();
	$mydate = '';
	$opnConfig['opndate']->opnDataTosql ($mydate);
	$acronym = $opnConfig['cleantext']->filter_text ($acronym, true, true, 'nothml');
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($acronym{0}) );
	$acronym = $opnConfig['opnSQL']->qstr ($acronym);
	$meaning = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($meaning, true, true, 'nothml') );
	$declaration = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($declaration, true, true, 'nothml'), 'declaration');
	$id = $opnConfig['opnSQL']->get_new_number ('acronyms', 'id');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['acronyms'] . " values ($id, $acronym, $meaning, $declaration, $mydate, $orderchar)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['acronyms'], 'id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');

}

function deleteselectedacro () {

	global $opnConfig, $opnTables;

	$del_id = array ();
	get_var ('del_id', $del_id, 'form', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'form', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		foreach ($del_id as $id) {
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['acronyms'] . ' WHERE id=' . $id);
		}
		$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');
	} else {
		AcronymsConfigHeader ();
		$text = '';
		$form = & new opn_FormularClass ('alternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_100_', 'modules/acronyms');
		$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php');
		$form->AddText ('<div class="bigtextbold" align="center">');
		$form->AddText ('<span class="alerttextcolor">' . _ACROADMIN_DELETESELECTEDACRO . '</span><br />');
		$form->AddHidden ('ok', 1);
		foreach ($del_id as $id) {
			$form->AddHidden ('del_id[]', $id);
		}
		$form->AddHidden ('op', 'deleteselected');
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText ('&nbsp;');
		$form->AddButton ('index', _NO_SUBMIT, '', '', 'location=\'' . encodeurl ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php') . '\'');
		$form->AddText ('<br /><br /></div>');
		$form->AddFormEnd ();
		$form->GetFormular ($text);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_110_';
		$_display_dat['module'] = 'modules/acronyms';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ACRODMIN_TITLE, $text);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'deleteselected':
		deleteselectedacro ();
		break;
	case 'addacro':
		addacro ();
		break;
	case 'editacro':
		editacro ();
		break;
	case 'saveacro':
		saveacro ();
		break;
	case 'deleteacro':
		deleteacro ();
		break;
	case 'newacronyms':
		listNewAcronyms ();
		break;
	case 'addallnew':
		addallnew ();
		break;
	case 'addsinglenew':
		addsinglenew ();
		break;
	case 'ignoreallnew':
		ignoreallnew ();
		break;
	case 'ignoresinglenew':
		ignoresinglenew ();
		break;
	default:
		listAcronyms ();
		break;
}

?>