<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/acronyms', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/acronyms/admin/language/');

function acronyms_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_ACROADMIN_SAVE] = _ACROADMIN_SAVE;
	$nav[_ACROADMIN_ADMIN] = _ACROADMIN_ADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function acronymssettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('modules/acronyms');
	$set->SetHelpID ('_OPNDOCID_MODULES_ACRONYMS_ACRONMYSSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _ACROADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ACROADMIN_SUBMISSIONNOTIFY,
			'name' => 'acro_notify',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['acro_notify'] == 1?true : false),
			 ($privsettings['acro_notify'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ACROADMIN_EMAIL,
			'name' => 'acro_notify_email',
			'value' => $privsettings['acro_notify_email'],
			'size' => 30,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ACROADMIN_EMAILSUBJECT,
			'name' => 'acro_notify_subject',
			'value' => $privsettings['acro_notify_subject'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _ACROADMIN_MESSAGE,
			'name' => 'acro_notify_message',
			'value' => $privsettings['acro_notify_message'],
			'wrap' => '',
			'cols' => 40,
			'rows' => 8);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ACROADMIN_MAILACCOUNT,
			'name' => 'acro_notify_from',
			'value' => $privsettings['acro_notify_from'],
			'size' => 30,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ACROADMIN_SHOWONLYPOSSIBLELETTERS,
			'name' => 'acro_showonlypossibleletters',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['acro_showonlypossibleletters'] == 1?true : false),
			 ($privsettings['acro_showonlypossibleletters'] == 0?true : false) ) );
	$values = array_merge ($values, acronyms_allhiddens (_ACROADMIN_NAVGENERAL) );
	$set->GetTheForm (_ACROADMIN_CONFIG, $opnConfig['opn_url'] . '/modules/acronyms/admin/settings.php', $values);

}

function acronyms_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function acronyms_dosaveacronyms ($vars) {

	global $privsettings;

	$privsettings['acro_notify'] = $vars['acro_notify'];
	$privsettings['acro_notify_email'] = $vars['acro_notify_email'];
	$privsettings['acro_notify_subject'] = $vars['acro_notify_subject'];
	$privsettings['acro_notify_message'] = $vars['acro_notify_message'];
	$privsettings['acro_notify_from'] = $vars['acro_notify_from'];
	$privsettings['acro_showonlypossibleletters'] = $vars['acro_showonlypossibleletters'];
	acronyms_dosavesettings ();

}

function acronyms_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _ACROADMIN_NAVGENERAL:
			acronyms_dosaveacronyms ($returns);
			break;
	}

}
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		acronyms_dosave ($result);
	} else {
		$result = '';
	}
}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$op = urldecode ($op);
switch ($op) {
	case _ACROADMIN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _ACROADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/acronyms/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		acronymssettings ();
		break;
}

?>