<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function build_acronymarr ($id) {

	global $opnConfig, $opnTables;

	$sql = 'SELECT id,acronym FROM ' . $opnTables['acronyms'] . ' WHERE id<>' . $id;
	$keyphrases = &$opnConfig['database']->Execute ($sql);
	if (is_object ($keyphrases) ) {
		$defcount = $keyphrases->RecordCount ();
	} else {
		$defcount = 0;
	}
	$myretarray = array ();
	if ($defcount>0) {
		while (! $keyphrases->EOF) {
			$keyphrase = $keyphrases->fields['acronym'];
			$reid = $keyphrases->fields['id'];
			$furl = array ($opnConfig['opn_url'] . '/modules/acronyms/index.php',
					'op' => 'listacronym',
					'id' => $reid);
			$onclick = "onclick=\"NewWindow('" . encodeurl ($furl) . "','test','400,200);return false\"";
			$replacestring = '<a class="%alternate%" href="' . encodeurl ($furl) . '" ' . $onclick . '>&raquo;' . $keyphrase . '</a>';
			$myretarray['keywords'][$keyphrase] = $replacestring;
			$keyphrases->MoveNext ();
		}
	} else {
		$myretarray['keywords'] = array ();
	}
	return $myretarray;

}

function do_acro (&$text, $id) {

	static $_keyarr = array ();
	if (!isset ($_keyarr[$id]) ) {
		$_keyarr[$id] = build_acronymarr ($id);
	}
	$keywords = array_keys ($_keyarr[$id]['keywords']);
	$guessedkeywords = array ();
	foreach ($keywords as $keyword) {
		if (strpos ($text, $keyword) ) {
			$guessedkeywords['keywords'][] = ' ' . $keyword . ' ';
			$guessedkeywords['keyreplace'][] = ' ' . $_keyarr[$id]['keywords'][$keyword] . ' ';
			$guessedkeywords['keywords'][] = ' ' . $keyword . ')';
			$guessedkeywords['keyreplace'][] = ' ' . $_keyarr[$id]['keywords'][$keyword] . ')';
			$guessedkeywords['keywords'][] = ' ' . $keyword . ',';
			$guessedkeywords['keyreplace'][] = ' ' . $_keyarr[$id]['keywords'][$keyword] . ',';
			$guessedkeywords['keywords'][] = ' ' . $keyword . '.';
			$guessedkeywords['keyreplace'][] = ' ' . $_keyarr[$id]['keywords'][$keyword] . '.';
			$guessedkeywords['keywords'][] = ' ' . $keyword . ';';
			$guessedkeywords['keyreplace'][] = ' ' . $_keyarr[$id]['keywords'][$keyword] . ';';
			$guessedkeywords['keywords'][] = ',' . $keyword . ' ';
			$guessedkeywords['keyreplace'][] = ',' . $_keyarr[$id]['keywords'][$keyword] . ' ';
			$guessedkeywords['keywords'][] = '.' . $keyword . ' ';
			$guessedkeywords['keyreplace'][] = '.' . $_keyarr[$id]['keywords'][$keyword] . ' ';
		}
	}
	if (count ($guessedkeywords)>0) {
		$text = str_replace ($guessedkeywords['keywords'], $guessedkeywords['keyreplace'], $text);
	}

}

function headacronyms (&$text, $query, $letter) {

	global $opnConfig, $opnTables;

	$text = '<div class="centertag">';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_130_', 'modules/acronyms');
	$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/index.php');
	$form->AddTextfield ('query', 0, 0, $query);
	$form->AddText ('&nbsp;&nbsp;');
	$form->AddSubmit ('submit', _ACRO_SEARCH);
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	if ($opnConfig['permission']->HasRight ('modules/acronyms', _PERM_WRITE, true) ) {
		$text .= '<br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/index.php',
										'op' => 'addacronym') ) . '">' . _ACRO_ADDACRONYM . '</a>';
	}
	$text .= '<br /><br />';
	$text .= '</div>';
	if (isset ($opnConfig['acro_showonlypossibleletters']) && $opnConfig['acro_showonlypossibleletters'] == 1) {
		$sql = 'SELECT orderchar FROM ' . $opnTables['acronyms'] . ' GROUP BY orderchar';
	} else {
		$sql = '';
	}
	$text .= build_letterpagebar (array ($opnConfig['opn_url'] . '/modules/acronyms/index.php'),
					'letter',
					$letter,
					$sql);
	$text .= '<br />';
	$text .= '<br />';

}

function displayacronyms () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$query = '';
	get_var ('query', $query, 'both');
	$letter = '';
	get_var ('letter', $letter, 'url', _OOBJ_DTYPE_CLEAN);
	$showadmin = $opnConfig['permission']->HasRights ('modules/acronyms', array (_PERM_ADMIN), true);
	$query = $opnConfig['cleantext']->filter_searchtext ($query);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$where = '';
	if ($query != '') {
		$like_search = $opnConfig['opnSQL']->AddLike ($query);
		$where = " WHERE (acronym LIKE $like_search OR meaning LIKE $like_search)";
	}
	if ( ($letter != '') && ($letter != 'ALL') ) {
		if ($where == '') {
			$where = ' WHERE ';
		} else {
			$where .= ' AND ';
		}
		if ($letter == '123') {
			$where .= $opnConfig['opnSQL']->CreateOpnRegexp ('acronym', '0-9');
		} else {
			$like_search = $opnConfig['opnSQL']->AddLike ($letter, '', '%');
			$where .= "(acronym LIKE $like_search)";
		}
	}
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['acronyms'] . $where;
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$text = '';
	headacronyms ($text, $query, $letter);
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, acronym, meaning, declaration, lastmod FROM ' . $opnTables['acronyms'] . $where . ' ORDER BY acronym', $maxperpage, $offset);
	if (!isset ($offset) ) {
		$offset = 0;
	}
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/acronyms/index.php',
					'query' => $query,
					'letter' => $letter),
					$reccount,
					$maxperpage,
					$offset);
	$text .= $pagebar;
	$text .= '<br />';
	$table = & new opn_TableClass ('alternator');
	if ($showadmin) {
		$table->AddCols (array ('30%', '68%', '2%') );
	} else {
		$table->AddCols (array ('30%', '70%') );
	}
	if ($showadmin) {
		$table->AddHeaderRow (array (_ACRO_TERM, _ACRO_MEANING, '&nbsp;') );
	} else {
		$table->AddHeaderRow (array (_ACRO_TERM, _ACRO_MEANING) );
	}
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$term = htmlentities ($info->fields['acronym']);
		$meaning = htmlentities ($info->fields['meaning']);
		$declaration = htmlentities ($info->fields['declaration']);
		$table->AddOpenRow ();
		if ($declaration == '') {
			$hlp = $term;
		} else {
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/acronyms/index.php',
										'op' => 'showacronym',
										'id' => $id) ) . '">' . $term . '</a>';
		}
		$newtag = buildnewtag ($info->fields['lastmod']);
		if ($newtag) {
			$newtag = '&nbsp;' . $newtag;
		}
		$table->AddDataCol ($hlp . $newtag);
		$table->AddDataCol ($meaning);
		if ($showadmin) {
			$table->AddDataCol ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php',
												'op' => 'editacro',
												'id' => $id)));
		}
		$table->AddCloseRow ();
		$info->MoveNext ();
	}
	// while
	$table->GetTable ($text);
	$text .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_140_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ACRO_LIST, $text);

}

function addacronym () {

	global $opnConfig;

	$text = '';
	headacronyms ($text, '', '');
	$text .= '<br />';
	$title = _ACRO_ADDACRONYM;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_ACRONYMS_150_', 'modules/acronyms');
	$form->Init ($opnConfig['opn_url'] . '/modules/acronyms/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('acronym', _ACRO_TERM);
	$form->AddTextfield ('acronym', 20, 100);
	$form->AddChangeRow ();
	$form->AddLabel ('meaning', _ACRO_MEANING);
	$form->AddTextfield ('meaning', 60, 250);
	$form->AddChangeRow ();
	$form->AddLabel ('declaration', _ACRO_DECLARATION);
	$form->AddTextarea ('declaration');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'addtodb');
	$form->AddSubmit ('submit', _ACRO_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($text);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_160_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($title, $text);

}

function showacronym () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, acronym, meaning, declaration FROM ' . $opnTables['acronyms'] . ' WHERE id=' . $id, 1);
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$term = $info->fields['acronym'];
		$meaning = $info->fields['meaning'];
		$declaration = $info->fields['declaration'];
		do_acro (&$declaration, $id);
		opn_nl2br ($declaration);
		$info->MoveNext ();
	}
	// while
	$text = '';
	headacronyms ($text, '', '');
	if (isset ($term) ) {
		$text .= '<br />';
		$text .= '<br />';
		$text .= '<br />';
		$table = & new opn_TableClass ('listalternator');
		$table->AddCols (array ('30%', '70%') );
		$table->AddDataRow (array (_ACRO_TERM, $term) );
		$table->AddDataRow (array (_ACRO_MEANING, $meaning) );
		$table->AddDataRow (array (_ACRO_DECLARATION, $declaration) );
		$showadmin = $opnConfig['permission']->HasRights ('modules/acronyms', array (_PERM_ADMIN), true);
		if ($showadmin) {
			$table->AddDataRow (array ('&nbsp;', $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php', 'op' => 'editacro', 'id' => $id) )) );
		}
		$table->GetTable ($text);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_170_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ACRO_LIST, $text);

}

function addtodb () {

	global $opnConfig, $opnTables;

	$acronym = '';
	get_var ('acronym', $acronym, 'form', _OOBJ_DTYPE_CLEAN);
	$meaning = '';
	get_var ('meaning', $meaning, 'form', _OOBJ_DTYPE_CHECK);
	$declaration = '';
	get_var ('declaration', $declaration, 'form', _OOBJ_DTYPE_CHECK);
	$id = $opnConfig['opnSQL']->get_new_number ('acronyms_new', 'id');
	$acronym = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($acronym, true, true, 'nothml') );
	$meaning = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($meaning, true, true, 'nothml') );
	$declaration = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($declaration, true, true, 'nothml'), 'declaration');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['acronyms_new'] . " values ($id,$acronym,$meaning,$declaration)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['acronyms_new'], 'id=' . $id);
	if ($opnConfig['acro_notify']) {
		if ($opnConfig['permission']->IsUser () ) {
			$ui = $opnConfig['permission']->GetUserinfo ();
			$name = $ui['uname'];
			unset ($ui);
		} else {
			$name = $opnConfig['opn_anonymous_name'];
		}
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		if ($opnConfig['opnOption']['client']) {
			$os = $opnConfig['opnOption']['client']->property ('platform') . ' ' . $opnConfig['opnOption']['client']->property ('os');
			$browser = $opnConfig['opnOption']['client']->property ('long_name') . ' ' . $opnConfig['opnOption']['client']->property ('version');
			$browser_language = $opnConfig['opnOption']['client']->property ('language');
		} else {
			$os = '';
			$browser = '';
			$browser_language = '';
		}
		$ip = get_real_IP ();
		$vars['{SUBJECT}'] = StripSlashes ($acronym);
		$vars['{MEANING}'] = StripSlashes ($meaning);
		$vars['{BY}'] = $name;
		$vars['{IP}'] = $ip;
		$vars['{NOTIFY_MESSAGE}'] = $opnConfig['acro_notify_message'];
		$vars['{BROWSER}'] = $os . ' ' . $browser . ' ' . $browser_language;
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($opnConfig['acro_notify_email'], $opnConfig['acro_notify_subject'], 'modules/acronyms', 'newacronyms', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['acro_notify_email']);
		$mail->send ();
		$mail->init ();
	}
	$boxtxt = '';
	headacronyms ($boxtxt, '', '');
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$boxtxt .= _ACRO_THANKYOU;
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_180_';
	$_display_dat['module'] = 'modules/acronyms';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ACRO_ADDACRONYM, $boxtxt);

}

function list_acronym () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT id, acronym, meaning, declaration, lastmod FROM ' . $opnTables['acronyms'] . " WHERE id=" . $id;
	$rdefinition = &$opnConfig['database']->Execute ($sql);
	$showadmin = $opnConfig['permission']->HasRight ('modules/acronyms', _PERM_ADMIN, true);
	if (is_object ($rdefinition) ) {
		$defcount = $rdefinition->RecordCount ();
	} else {
		$defcount = 0;
	}
	$table = & new opn_TableClass ('listalternator');
	$table->AddCols (array ('30%', '70%') );
	if ($defcount != 0) {
		$id = $rdefinition->fields['id'];
		$term = $rdefinition->fields['acronym'];
		$meaning = $rdefinition->fields['meaning'];
		$declaration = $rdefinition->fields['declaration'];
		do_acro (&$declaration, $id);
		$table->AddDataRow (array (_ACRO_TERM, $term) );
		$table->AddDataRow (array (_ACRO_MEANING, $meaning) );
		$table->AddDataRow (array (_ACRO_DECLARATION, $declaration) );
		$showadmin = $opnConfig['permission']->HasRights ('modules/acronyms', array (_PERM_ADMIN), true);
		if ($showadmin) {
			$table->AddDataRow (array ('&nbsp;', $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/acronyms/admin/index.php', 'op' => 'editacro', 'id' => $id) )) );
		}
	}
	$table->AddDataRow (array ('&nbsp;', '<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/modules/acronyms/index.php" onclick="window.close()">' . _ACRO_CLOSEWINDOW . '</a>'), array ('left', 'right') );
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	define ('_OPN_DISPLAYCONTENT_DONE', 1);
	$opnConfig['opn_generateautomatictitle'] = 1;
	define ('_OPN_ADDTOTITLE', _ACRO_TERM . ': ' . $term);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_ACRONYMS_190_';
	$_display_dat['module'] = 'modules/acronyms';
	$_display_dat['emergency'] = true;
	$_display_dat['nothemehead'] = true;
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

?>