<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/banners/admin/language/');
$opnConfig['module']->InitModule ('modules/banners', true);

function BannersConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_BAN_ADMIN_BANADMIN);
	$menu->InsertEntry (_BAN_ADMIN_MAIN, $opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$menu->InsertEntry (_BAN_ADMIN_ACCOUNT, array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
							'op' => 'BannerAccount') );
	$menu->InsertEntry (_BAN_ADMIN_GROUPS, array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
							'op' => 'BannerGroup') );
	$menu->InsertEntry (_BAN_ADMIN_CURACTIVE, array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
							'op' => 'BannerActive') );
	$menu->InsertEntry (_BAN_ADMIN_FINBAN, array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
							'op' => 'BannerFinish') );
	$menu->InsertEntry (_BAN_ADMIN_BANCONFIG, $opnConfig['opn_url'] . '/modules/banners/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function BannersFinish () {

	global $opnConfig, $opnTables;

	$boxtxt = '<div align="center" class="normaltextbold"><span class="normaltextbold">' . _BAN_ADMIN_FINBAN . '</span></div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_BAN_ADMIN_ID, _BAN_ADMIN_IMP, _BAN_ADMIN_CLICKS, _BAN_ADMIN_CLICKSP, _BAN_ADMIN_DATES, _BAN_ADMIN_DATEE, _BAN_ADMIN_CLIENTNAM, _BAN_ADMIN_GROUP, _BAN_ADMIN_CATEGORY, _BAN_ADMIN_FUNCTION) );
	$result = &$opnConfig['database']->Execute ('SELECT bid, cid, impressions, clicks, datestart, dateend,gid, theme_group FROM ' . $opnTables['bannerfinish'] . ' WHERE bid>0 ORDER BY bid');
	if ($result !== false) {
		$datestart = '';
		$dateend = '';
		while (! $result->EOF) {
			$bid = $result->fields['bid'];
			$cid = $result->fields['cid'];
			$impressions = $result->fields['impressions'];
			$clicks = $result->fields['clicks'];
			$themegroup = $result->fields['theme_group'];
			$gid = $result->fields['gid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['datestart']);
			$opnConfig['opndate']->formatTimestamp ($datestart, _DATE_DATESTRING5);
			$opnConfig['opndate']->sqlToopnData ($result->fields['dateend']);
			$opnConfig['opndate']->formatTimestamp ($dateend, _DATE_DATESTRING5);
			$result2 = &$opnConfig['database']->Execute ('SELECT cid, name FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
			$cid = $result2->fields['cid'];
			$name = $result2->fields['name'];
			$percent = substr (100* $clicks/ $impressions, 0, 5);
			if ($gid) {
				$result2 = $opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bannergroup'] . ' WHERE gid=' . $gid);
				$group = $result2->fields['name'];
			} else {
				$group = _BAN_ADMIN_NONE;
			}
			$cat = $opnConfig['theme_groups'][$themegroup]['theme_group_text'];
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerFinishReactivate',
										'bid' => $bid) ) . '">' . _BAN_ADMIN_REACITIVATE . '</a> | ';
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerFinishDelete',
										'bid' => $bid) ) . '">' . _BAN_ADMIN_DEL . '</a>';
			$table->AddDataRow (array ($bid, $impressions, $clicks, $percent . '%', $datestart, $dateend, $name, $group, $cat, $hlp), array ('center', 'center', 'center', 'center', 'center', 'center', 'center', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function BannersActive () {

	global $opnConfig, $opnTables;

	$boxtxt = '<div align="center" class="normaltextbold"><span class="normaltextbold">' . _BAN_ADMIN_CURACTIVE . '</span></div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_BAN_ADMIN_ID, _BAN_ADMIN_IMP, _BAN_ADMIN_IMPLEFT, _BAN_ADMIN_CLICKS, _BAN_ADMIN_CLICKSP, _BAN_ADMIN_CLIENTNAM, _BAN_ADMIN_GROUP, _BAN_ADMIN_CATEGORY, _BAN_ADMIN_FUNCTION) );
	$result = &$opnConfig['database']->Execute ('SELECT bid, cid, imptotal, impmade, clicks, bannerdate, theme_group, gid FROM ' . $opnTables['banner'] . ' WHERE bid>0 ORDER BY bid');
	if ($result !== false) {
		while (! $result->EOF) {
			$bid = $result->fields['bid'];
			$cid = $result->fields['cid'];
			$imptotal = $result->fields['imptotal'];
			$impmade = $result->fields['impmade'];
			$clicks = $result->fields['clicks'];
			$themegroup = $result->fields['theme_group'];
			$gid = $result->fields['gid'];
			// $date=$result->fields['bannerdate'];
			$result2 = &$opnConfig['database']->Execute ('SELECT cid, name FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
			$cid = $result2->fields['cid'];
			$name = $result2->fields['name'];
			if ($impmade == 0) {
				$percent = 0;
			} else {
				$percent = substr (100* $clicks/ $impmade, 0, 5);
			}
			if ($imptotal == 0) {
				$left = _BAN_ADMIN_UNLIMIT;
			} else {
				$left = $imptotal- $impmade;
			}
			if ($gid) {
				$result2 = $opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bannergroup'] . ' WHERE gid=' . $gid);
				$group = $result2->fields['name'];
			} else {
				$group = _BAN_ADMIN_NONE;
			}
			$cat = $opnConfig['theme_groups'][$themegroup]['theme_group_text'];
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerEdit',
										'bid' => $bid) ) . '">' . _BAN_ADMIN_EDIT . '</a> | ';
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerDelete',
										'bid' => $bid,
										'ok' => '0') ) . '">' . _BAN_ADMIN_DEL . '</a>';
			$table->AddDataRow (array ($bid, $impmade, $left, $clicks, $percent . '%', $name, $group, $cat, $hlp), array ('center', 'center', 'center', 'center', 'center', 'center', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />' . _OPN_HTML_NL . _OPN_HTML_NL;
	// Add Banner
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(cid) AS counter FROM ' . $opnTables['bannerclient']);
	if ($result !== false) {
		if (isset ($result->fields['counter']) ) {
			$numrows = $result->fields['counter'];
		} else {
			$numrows = 0;
		}
		if ($numrows>0) {
			$boxtxt .= '<span class="normaltextbold">' . _BAN_ADMIN_ADDNEWBAN . '</span><br /><br />';
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_10_', 'banners');
			$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
			$form->AddTable ();
			$form->AddCols (array ('15%', '85%') );
			$form->AddOpenRow ();
			$form->AddLabel ('cid', _BAN_ADMIN_CLIENTNAM . ':');
			$result_select = &$opnConfig['database']->Execute ('SELECT cid,name FROM ' . $opnTables['bannerclient'] . ' WHERE cid>0');
			$form->AddSelectDB ('cid', $result_select);
			$form->AddChangeRow ();
			$form->AddLabel ('gid', _BAN_ADMIN_GROUP);
			$result_select = &$opnConfig['database']->Execute ('SELECT gid,name FROM ' . $opnTables['bannergroup'] . ' WHERE gid>0');
			$options = array ();
			$options[0] = _BAN_ADMIN_NONE;
			while (! $result_select->EOF) {
				$options[$result_select->fields['gid']] = $result_select->fields['name'];
				$result_select->MoveNext ();
			}
			$form->AddSelect ('gid', $options, 0);
			$options = array ();
			$groups = $opnConfig['theme_groups'];
			foreach ($groups as $group) {
				$options[$group['theme_group_id']] = $group['theme_group_text'];
			}
			$form->AddChangeRow ();
			$form->AddLabel ('theme_group', _BAN_ADMIN_CATEGORY);
			$form->AddSelect ('theme_group', $options, 0);
			$form->AddChangeRow ();
			$form->AddLabel ('imptotal', _BAN_ADMIN_IMPPURCH);
			$form->SetSameCol ();
			$form->AddTextfield ('imptotal', 12, 11);
			$form->AddText (_BAN_ADMIN_UNLIMIT);
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->AddLabel ('imageurl', _BAN_ADMIN_IMGURL);
			$form->AddTextfield ('imageurl', 50, 200);
			$form->AddChangeRow ();
			$form->AddLabel ('clickurl', _BAN_ADMIN_CLICKURL);
			$form->AddTextfield ('clickurl', 50, 200);
			$form->AddChangeRow ();
			$form->AddLabel ('htmlcocde', _BAN_ADMIN_HTMLCODE);
			$form->AddTextarea ('htmlcode', 0, 0);
			$form->AddChangeRow ();
			$form->AddHidden ('op', 'BannersAdd');
			$form->AddSubmit ('submit', _BAN_ADMIN_ADDBAN);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
			$boxtxt .= '<br />' . _OPN_HTML_NL . _OPN_HTML_NL;
		}
	}
	return $boxtxt;

}

function BannersGroup () {

	global $opnConfig, $opnTables;
	// Grouplist
	$boxtxt = '<div align="center" class="normaltextbold"><span class="normaltextbold">' . _BAN_ADMIN_ADVGROUPS . '</span></div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_BAN_ADMIN_ID, _BAN_ADMIN_GROUPNAM, _BAN_ADMIN_FUNCTION) );
	$result = &$opnConfig['database']->Execute ('SELECT gid, name FROM ' . $opnTables['bannergroup'] . ' WHERE gid>0 ORDER BY gid');
	if ($result !== false) {
		while (! $result->EOF) {
			$gid = $result->fields['gid'];
			$name = $result->fields['name'];
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerGroupEdit',
										'gid' => $gid) ) . '">' . _BAN_ADMIN_EDIT . '</a> | ';
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerGroupDelete',
										'gid' => $gid) ) . '">' . _BAN_ADMIN_DEL . '</a>';
			$table->AddDataRow (array ($gid, $name, $hlp), array ('center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />' . _OPN_HTML_NL . _OPN_HTML_NL;
	// Add Group
	$boxtxt .= '<span class="normaltextbold">' . _BAN_ADMIN_ADDGROUP . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_20_', 'banners');
	$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _BAN_ADMIN_GROUP . ':');
	$form->AddTextfield ('name', 40, 40);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'BannerAddGroup');
	$form->AddSubmit ('submit', _BAN_ADMIN_ADDGROUP);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function BannersAdd () {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$imptotal = 0;
	get_var ('imptotal', $imptotal, 'form', _OOBJ_DTYPE_INT);
	$imageurl = '';
	get_var ('imageurl', $imageurl, 'form', _OOBJ_DTYPE_URL);
	$clickurl = '';
	get_var ('clickurl', $clickurl, 'form', _OOBJ_DTYPE_URL);
	$gid = 0;
	get_var ('gid', $gid, 'form', _OOBJ_DTYPE_INT);
	$theme_group = 0;
	get_var ('theme_group', $theme_group, 'form', _OOBJ_DTYPE_INT);
	$htmlcode = '';
	get_var ('htmlcode', $htmlcode, 'form', _OOBJ_DTYPE_CHECK);
	if ( ( ($clickurl != '') && ($imageurl != '') ) || ($htmlcode != '') ) {
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		$result_select = &$opnConfig['database']->Execute ('SELECT name, contact, email, login, passwd FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
		while (! $result_select->EOF) {
			$name = $result_select->fields['name'];
			$contact = $result_select->fields['contact'];
			$email = $result_select->fields['email'];
			$passwd = $result_select->fields['passwd'];
			$login = $result_select->fields['login'];
			$result_select->MoveNext ();
		}
		$mail = & new opn_mailer ();
		$subject = _BAN_ADMIN_CURACTIVE . ' ' . $opnConfig['sitename'];
		$vars['{NAME}'] = $contact;
		$vars['{EMAIL}'] = $email;
		$vars['{ACCNAME}'] = $name;
		$vars['{LOGIN}'] = $login;
		$vars['{PASSWD}'] = $passwd;
		if ($imptotal === 0) {
			$numberimpressions = _BAN_ADMIN_UNLIMITED;
		} else {
			$numberimpressions = $imptotal;
		}
		$vars['{IMPTOTAL}'] = $numberimpressions;
		$vars['{IMAGEURL}'] = $imageurl;
		if ($htmlcode != '') {
			$vars['{CLICKURL}'] = $htmlcode;
		} else {
			$vars['{CLICKURL}'] = $clickurl;
		}
		$vars['{URL}'] = encodeurl ($opnConfig['opn_url'] . '/modules/banners/login.php', false);
		$mail->opn_mail_fill ($email, $subject, 'modules/banners/admin', 'newbanner', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
		$mail->send ();
		$mail->init ();
		$bid = $opnConfig['opnSQL']->get_new_number ('banner', 'bid');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$_imageurl = $opnConfig['opnSQL']->qstr ($imageurl);
		$_clickurl = $opnConfig['opnSQL']->qstr ($clickurl);
		$_htmlcode = $opnConfig['opnSQL']->qstr ($htmlcode, 'htmlcode');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['banner'] . " values ($bid, $cid, $imptotal, 1, 0, $_imageurl, $_clickurl, $now, $theme_group, $gid,$_htmlcode)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['banner'], 'bid=' . $bid);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerActive', false) );

}

function BannersAddGroup () {

	global $opnConfig, $opnTables;

	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$gid = $opnConfig['opnSQL']->get_new_number ('bannergroup', 'gid');
	$name = $opnConfig['opnSQL']->qstr ($name);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bannergroup'] . " values ($gid, $name)");
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerGroup', false) );

}

function BannerAccounts () {

	global $opnConfig, $opnTables;
	// Clients List
	$boxtxt = '<div align="center" class="normaltextbold"><span class="normaltextbold">' . _BAN_ADMIN_ADVCLIENTS . '</span></div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_BAN_ADMIN_ID, _BAN_ADMIN_CLIENTNAM, _BAN_ADMIN_ACTIVEBAN, _BAN_ADMIN_CONNAM, _BAN_ADMIN_CONEMAIL, _BAN_ADMIN_FUNCTION) );
	$result = &$opnConfig['database']->Execute ('SELECT cid, name, contact, email FROM ' . $opnTables['bannerclient'] . ' WHERE cid>0 ORDER BY cid');
	if ($result !== false) {
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$name = $result->fields['name'];
			$contact = $result->fields['contact'];
			$email = $result->fields['email'];
			$result2 = &$opnConfig['database']->Execute ('SELECT COUNT(cid) AS counter FROM ' . $opnTables['banner'] . ' WHERE cid=' . $cid);
			if (isset ($result2->fields['counter']) ) {
				$numrows = $result2->fields['counter'];
			} else {
				$numrows = 0;
			}
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerClientEdit',
										'cid' => $cid) ) . '">' . _BAN_ADMIN_EDIT . '</a> | ';
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
										'op' => 'BannerClientDelete',
										'cid' => $cid) ) . '">' . _BAN_ADMIN_DEL . '</a>';
			$table->AddDataRow (array ($cid, $name, $numrows, $contact, $email, $hlp), array ('center', 'center', 'center', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />' . _OPN_HTML_NL . _OPN_HTML_NL;
	// Add Client
	$boxtxt .= '<span class="normaltextbold">' . _BAN_ADMIN_ADDCLIENT . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_30_', 'banners');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _BAN_ADMIN_CLIENTNAM . ':');
	$form->AddTextfield ('name', 30, 60);
	$form->AddChangeRow ();
	$form->AddLabel ('contact', _BAN_ADMIN_CONNAM . ':');
	$form->AddTextfield ('contact', 30, 60);
	$form->AddChangeRow ();
	$form->AddLabel ('email', _BAN_ADMIN_CONEMAIL . ':');
	$form->AddTextfield ('email', 30, 60);
	$form->AddChangeRow ();
	$form->AddLabel ('login', _BAN_ADMIN_CLIENTLOGIN . ':');
	$form->AddTextfield ('login', 12, 10);
	$form->AddChangeRow ();
	$form->AddLabel ('passwd', _BAN_ADMIN_CLIENTPASS . ':');
	$form->AddTextfield ('passwd', 12, 10);
	$form->AddChangeRow ();
	$form->AddLabel ('extrainfo', _BAN_ADMIN_EXTRAINFO);
	$form->AddTextarea ('extrainfo', 0, 0);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'BannerAddClient');
	$form->AddSubmit ('submit', _BAN_ADMIN_ADDCLIENT);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function BannerAddClient () {

	global $opnTables, $opnConfig;

	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$contact = '';
	get_var ('contact', $contact, 'form', _OOBJ_DTYPE_CHECK);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$login = '';
	get_var ('login', $login, 'form', _OOBJ_DTYPE_CLEAN);
	$passwd = '';
	get_var ('passwd', $passwd, 'form', _OOBJ_DTYPE_CLEAN);
	$extrainfo = '';
	get_var ('extrainfo', $extrainfo, 'form', _OOBJ_DTYPE_CHECK);
	$boxtxt = '';
	$stop = FALSE;
	if ($name == '') {
		$boxtxt .= '<li>' . _BAN_ADMIN_CLIENTNAM . '</li>';
		$stop = TRUE;
	}
	if ($email == '') {
		$boxtxt .= '<li>' . _BAN_ADMIN_CONEMAIL . '</li>';
		$stop = TRUE;
	}
	if ($login == '') {
		$boxtxt .= '<li>' . _BAN_ADMIN_CLIENTLOGIN . '</li>';
		$stop = TRUE;
	}
	if ($passwd == '') {
		$boxtxt .= '<li>' . _BAN_ADMIN_CLIENTPASS . '</li>';
		$stop = TRUE;
	}
	$boxtxt = '';
	if ($stop) {
		$boxtxt = _BAN_ADMIN_MISSINGVALUES . '<ul>' . $boxtxt . '</ul>' . _BAN_ADMIN_GOBACK;
	} else {
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		$mail = & new opn_mailer ();
		$subject = _BAN_ADMIN_ADVCLIENTS . ' ' . $opnConfig['sitename'];
		$vars['{NAME}'] = $contact;
		$vars['{EMAIL}'] = $email;
		$vars['{ACCNAME}'] = $name;
		$vars['{LOGIN}'] = $login;
		$vars['{PASSWD}'] = $passwd;
		$vars['{URL}'] = encodeurl ($opnConfig['opn_url'] . '/modules/banners/login.php', false);
		$mail->opn_mail_fill ($email, $subject, 'modules/banners/admin', 'newlogin', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
		$mail->send ();
		$mail->init ();
		$cid = $opnConfig['opnSQL']->get_new_number ('bannerclient', 'cid');
		$name = $opnConfig['opnSQL']->qstr ($name);
		$contact = $opnConfig['opnSQL']->qstr ($contact);
		$extrainfo = $opnConfig['opnSQL']->qstr ($extrainfo, 'extrainfo');
		$email = $opnConfig['opnSQL']->qstr ($email);
		$_login = $opnConfig['opnSQL']->qstr ($login);
		$_passwd = $opnConfig['opnSQL']->qstr ($passwd);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bannerclient'] . " VALUES ($cid, $name, $contact, $email, $_login, $_passwd, $extrainfo)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bannerclient'], 'cid=' . $cid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerAccount', false) );
	}
	return $boxtxt;

}

function BannerFinishDelete () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bannerfinish'] . ' WHERE bid=' . $bid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerFinish', false) );

}

function BannerDelete () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['banner'] . ' WHERE bid=' . $bid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerActive', false) );
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT cid, imptotal, impmade, clicks, imageurl, clickurl FROM ' . $opnTables['banner'] . ' WHERE bid=' . $bid);
		$cid = $result->fields['cid'];
		$imptotal = $result->fields['imptotal'];
		$impmade = $result->fields['impmade'];
		$clicks = $result->fields['clicks'];
		$imageurl = $result->fields['imageurl'];
		$clickurl = $result->fields['clickurl'];
		$boxtxt = '<div class="centertag"><span class="normaltextbold">' . _BAN_ADMIN_DELBAN . '</span><br /><br />';
		if ( ($imageurl != '') && ($clickurl != '') ) {
			$boxtxt .= '<a class="opncenterbox" href="' . $clickurl . '" target="_blank">';
			if (strtolower (substr ($imageurl, strrpos ($imageurl, '.') ) ) == '.swf') {
				$boxtxt .= '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/ swflash.cab#version=6,0,40,0"; width="468" height="60">';
				$boxtxt .= '<param name=movie value="' . $imageurl . '">';
				$boxtxt .= '<param name=quality value=high>';
				$boxtxt .= '<embed src="' . $imageurl . '" quality=high pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"; type="application/x-shockwave-flash" width="468" height="60">';
				$boxtxt .= '</embed>';
				$boxtxt .= '</object>';
			} else {
				$boxtxt .= '<img src="' . $imageurl . '" class="imgtag" alt="Anzeige" />';
			}
			$boxtxt .= '</a>';
			$boxtxt .= '<a class="opncenterbox" href="' . $clickurl . '">' . htmlentities ($clickurl) . '</a><br /><br />';
		}
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_BAN_ADMIN_ID, _BAN_ADMIN_IMP, _BAN_ADMIN_IMPLEFT, _BAN_ADMIN_CLICKS, _BAN_ADMIN_CLICKSP, _BAN_ADMIN_CLIENTNAM) );
		$result2 = &$opnConfig['database']->Execute ('SELECT cid, name FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
		$cid = $result2->fields['cid'];
		$name = $result2->fields['name'];
		$percent = substr (100* $clicks/ $impmade, 0, 5);
		if ($imptotal == 0) {
			$left = _BAN_ADMIN_UNLIMIT;
		} else {
			$left = $imptotal- $impmade;
		}
		$table->AddDataRow (array ($bid, $impmade, $left, $clicks, $percent . '%', $name), array ('center', 'center', 'center', 'center', 'center', 'center') );
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><div class="bigtextbold"><span class="alerttextcolor">' . _BAN_ADMIN_SUREDELBAN . '</span></div><br /><br />' . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerActive') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
																																													'op' => 'BannerDelete',
																																													'bid' => $bid,
																																													'ok' => '1') ) . '">' . _YES . '</a>' . '</div><br /><br />';
	}
	return $boxtxt;

}

function BannerEdit () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT cid, imptotal, impmade, clicks, imageurl, clickurl, theme_group, gid, htmlcode FROM ' . $opnTables['banner'] . ' WHERE bid=' . $bid);
	$cid = $result->fields['cid'];
	$imptotal = $result->fields['imptotal'];
	$impmade = $result->fields['impmade'];
	// $clicks=$result->fields['clicks'];
	$imageurl = $result->fields['imageurl'];
	$clickurl = $result->fields['clickurl'];
	$gid = $result->fields['gid'];
	$theme_group = $result->fields['theme_group'];
	$htmlcode = $result->fields['htmlcode'];
	$boxtxt = '<div class="centertag"><span class="normaltextbold">' . _BAN_ADMIN_EDITBAN . '</span>';
	if ($imageurl != '') {
		if (strtolower (substr ($imageurl, strrpos ($imageurl, '.') ) ) == '.swf') {
			$boxtxt .= '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/ swflash.cab#version=6,0,40,0"; width="468" height="60">';
			$boxtxt .= '<param name=movie value="' . $imageurl . '">';
			$boxtxt .= '<param name=quality value=high>';
			$boxtxt .= '<embed src="' . $imageurl . '" quality=high pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"; type="application/x-shockwave-flash" width="468" height="60">';
			$boxtxt .= '</embed>';
			$boxtxt .= '</object>';
		} else {
			$boxtxt .= '<img src="' . $imageurl . '" class="imgtag" alt="Anzeige" />';
		}
	}
	$boxtxt .= '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_40_', 'banners');
	$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('cid', _BAN_ADMIN_CLIENTNAM . ':');
	$result = &$opnConfig['database']->Execute ('SELECT cid,name FROM ' . $opnTables['bannerclient'] . ' WHERE cid>0');
	$form->AddSelectDB ('cid', $result, $cid);
	$form->AddChangeRow ();
	$form->AddLabel ('gid', _BAN_ADMIN_GROUP);
	$result = &$opnConfig['database']->Execute ('SELECT gid,name FROM ' . $opnTables['bannergroup'] . ' WHERE gid>0');
	$options[0] = _BAN_ADMIN_NONE;
	while (! $result->EOF) {
		$options[$result->fields['gid']] = $result->fields['name'];
		$result->MoveNext ();
	}
	$form->AddSelect ('gid', $options, $gid);
	$options = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('theme_group', _BAN_ADMIN_CATEGORY);
	$form->AddSelect ('theme_group', $options, intval ($theme_group) );
	if ($imptotal == 0) {
		$impressions = _BAN_ADMIN_UNLIMIT;
	} else {
		$impressions = $imptotal;
	}
	$form->AddChangeRow ();
	$form->AddLabel ('impadded', _BAN_ADMIN_ADDMOREIMP);
	$form->SetSameCol ();
	$form->AddTextfield ('impadded', 12, 11);
	$form->AddText (_BAN_ADMIN_PURCHASED . '<span class="normaltextbold">' . $impressions . '</span> ' . _BAN_ADMIN_MADE . '<span class="normaltextbold">' . $impmade . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('imageurl', _BAN_ADMIN_IMGURL);
	$form->AddTextfield ('imageurl', 50, 200, $imageurl);
	$form->AddChangeRow ();
	$form->AddLabel ('clickurl', _BAN_ADMIN_CLICKURL);
	$form->AddTextfield ('clickurl', 50, 200, $clickurl);
	$form->AddChangeRow ();
	$form->AddLabel ('htmlcocde', _BAN_ADMIN_HTMLCODE);
	$form->AddTextarea ('htmlcode', 0, 0, '', $htmlcode);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('bid', $bid);
	$form->AddHidden ('imptotal', $imptotal);
	$form->AddHidden ('op', 'BannerChange');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BAN_ADMIN_CHANGEBAN);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function BannerChange () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$imptotal = 0;
	get_var ('imptotal', $imptotal, 'form', _OOBJ_DTYPE_INT);
	$impadded = 0;
	get_var ('impadded', $impadded, 'form', _OOBJ_DTYPE_INT);
	$imageurl = '';
	get_var ('imageurl', $imageurl, 'form', _OOBJ_DTYPE_URL);
	$clickurl = '';
	get_var ('clickurl', $clickurl, 'form', _OOBJ_DTYPE_URL);
	$theme_group = 0;
	get_var ('theme_group', $theme_group, 'form', _OOBJ_DTYPE_INT);
	$gid = 0;
	get_var ('gid', $gid, 'form', _OOBJ_DTYPE_INT);
	$htmlcode = '';
	get_var ('htmlcode', $htmlcode, 'form', _OOBJ_DTYPE_CHECK);
	$imp = $imptotal+ $impadded;
	$imageurl = $opnConfig['opnSQL']->qstr ($imageurl);
	$clickurl = $opnConfig['opnSQL']->qstr ($clickurl);
	$theme_group = $opnConfig['opnSQL']->qstr ($theme_group);
	$htmlcode = $opnConfig['opnSQL']->qstr ($htmlcode, 'htmlcode');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['banner'] . " SET cid=$cid, imptotal=$imp, imageurl=$imageurl, clickurl=$clickurl, theme_group=$theme_group, gid=$gid, htmlcode=$htmlcode WHERE bid=$bid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['banner'], 'bid=' . $bid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerActive', false) );

}

function BannerGroupDelete () {

	global $opnConfig, $opnTables;

	$gid = 0;
	get_var ('gid', $gid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['banner'] . ' SET gid=0 WHERE gid=' . $gid);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bannergroup'] . ' WHERE gid=' . $gid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerGroup', false) );
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bannergroup'] . ' WHERE gid=' . $gid);
		$name = $result->fields['name'];
		$result->Close ();
		$boxtxt = '<br /><div class="bigtextbold"><span class="alerttextcolor">' . _BAN_ADMIN_SUREDELGROUP . ' : ' . $name . '</span></div><br /><br />' . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerGroup') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
																																															'op' => 'BannerGroupDelete',
																																															'gid' => $gid,
																																															'ok' => '1') ) . '">' . _YES . '</a>' . '</div><br /><br />';
		return $boxtxt;
	}
	return '';

}

function BannerGroupEdit () {

	global $opnConfig, $opnTables;

	$gid = 0;
	get_var ('gid', $gid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['bannergroup'] . ' WHERE gid=' . $gid);
	$name = $result->fields['name'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_50_', 'banners');
	$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _BAN_ADMIN_GROUP);
	$form->AddTextfield ('name', 40, 40, $name);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('gid', $gid);
	$form->AddHidden ('op', 'BannerGroupChange');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BAN_ADMIN_CHANGEGROUP);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function BannerGroupChange () {

	global $opnConfig, $opnTables;

	$gid = 0;
	get_var ('gid', $gid, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$name = $opnConfig['opnSQL']->qstr ($name);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bannergroup'] . " SET name=$name WHERE gid=$gid");
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerGroup', false) );

}

function BannerClientDelete () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['banner'] . ' WHERE cid=' . $cid);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bannerfinish'] . ' WHERE cid=' . $cid);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerAccount', false) );
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT cid, name FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
		if ($result !== false) {
			if ($result->fields !== false) {
				$cid = $result->fields['cid'];
				$name = $result->fields['name'];
			}
		}
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _BAN_ADMIN_DELADVCLIENT . '</span><br /><br />' . '<span class="normaltext">' . _BAN_ADMIN_ABOUT . ' <span class="normaltextbold">' . $name . '</span> ' . _BAN_ADMIN_ANDALLBAN . '</span><br /><br />';
		$result2 = &$opnConfig['database']->Execute ('SELECT imageurl, clickurl FROM ' . $opnTables['banner'] . ' WHERE cid=' . $cid);
		$numrows = 0;
		if ($result2 !== false) {
			if ($result2->fields !== false) {
				$numrows = $result2->RecordCount ();
			}
		}
		if ($numrows == 0) {
			$boxtxt .= _BAN_ADMIN_NOBAN4CLIENT . '<br /><br />';
		} else {
			$boxtxt .= '<span class="alerttext">' . _BAN_ADMIN_WARN . '</span><br /><span class="normaltext">' . _BAN_ADMIN_BANRUNNING . ' ' . $opnConfig['sitename'] . ':</span><br /><br />';
		}
		while (! $result2->EOF) {
			$imageurl = $result2->fields['imageurl'];
			$clickurl = $result2->fields['clickurl'];
			$boxtxt .= '<div class="centertag">';
			$boxtxt .= '<a class="opncenterbox" href="' . $clickurl . '" target="_blank">';
			if (strtolower (substr ($imageurl, strrpos ($imageurl, '.') ) ) == '.swf') {
				$boxtxt .= '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/ swflash.cab#version=6,0,40,0"; width="468" height="60">';
				$boxtxt .= '<param name=movie value="' . $imageurl . '">';
				$boxtxt .= '<param name=quality value=high>';
				$boxtxt .= '<embed src="' . $imageurl . '" quality=high pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"; type="application/x-shockwave-flash" width="468" height="60">';
				$boxtxt .= '</embed>';
				$boxtxt .= '</object>';
			} else {
				$boxtxt .= '<img src="' . $imageurl . '" class="imgtag" alt="Anzeige" />';
			}
			$boxtxt .= '</a>';
			$boxtxt .= '</div>';
			$boxtxt .= '<br /><a class="opncenterbox" href="' . $clickurl . '">' . $clickurl . '</a><br /><br />';
			$result2->MoveNext ();
		}
		$boxtxt .= '<div class="bigtextbold"><span class="alerttextcolor">' . _BAN_ADMIN_SUREDELCLIENT . '</span></div><br /><br />' . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerAccount') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
																																												'op' => 'BannerClientDelete',
																																												'cid' => $cid,
																																												'ok' => '1') ) . '">' . _YES . '</a></div><br /><br />';
	}
	return $boxtxt;

}

function BannerClientEdit () {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT name, contact, email, login, passwd, extrainfo FROM ' . $opnTables['bannerclient'] . ' WHERE cid=' . $cid);
	$name = $result->fields['name'];
	$contact = $result->fields['contact'];
	$email = $result->fields['email'];
	$login = $result->fields['login'];
	$passwd = $result->fields['passwd'];
	$extrainfo = $result->fields['extrainfo'];
	$boxtxt = '<div align="center" class="normaltextbold"><span class="normaltextbold">' . _BAN_ADMIN_EDITADVCLIENT . '</span><br /><br /></div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BANNERS_60_', 'banners');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/banners/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _BAN_ADMIN_CLIENTNAM . ':');
	$form->AddTextfield ('name', 30, 60, $name);
	$form->AddChangeRow ();
	$form->AddLabel ('contact', _BAN_ADMIN_CONNAM . ':');
	$form->AddTextfield ('contact', 30, 60, $contact);
	$form->AddChangeRow ();
	$form->AddLabel ('email', _BAN_ADMIN_CONEMAIL . ':');
	$form->AddTextfield ('email', 30, 60, $email);
	$form->AddChangeRow ();
	$form->AddLabel ('login', _BAN_ADMIN_CLIENTLOGIN . ':');
	$form->AddTextfield ('login', 12, 10, $login);
	$form->AddChangeRow ();
	$form->AddLabel ('passwd', _BAN_ADMIN_CLIENTPASS . ':');
	$form->AddTextfield ('passwd', 12, 10, $passwd);
	$form->AddChangeRow ();
	$form->AddLabel ('extrainfo', _BAN_ADMIN_EXTRAINFO);
	$form->AddTextarea ('extrainfo', 0, 0, '', $extrainfo);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('cid', $cid);
	$form->AddHidden ('op', 'BannerClientChange');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BAN_ADMIN_CHANGECLIENT);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function BannerClientChange () {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$contact = '';
	get_var ('contact', $contact, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$extrainfo = '';
	get_var ('extrainfo', $extrainfo, 'form', _OOBJ_DTYPE_CHECK);
	$login = '';
	get_var ('login', $login, 'form', _OOBJ_DTYPE_CLEAN);
	$passwd = '';
	get_var ('passwd', $passwd, 'form', _OOBJ_DTYPE_CLEAN);
	$name = $opnConfig['opnSQL']->qstr ($name);
	$contact = $opnConfig['opnSQL']->qstr ($contact);
	$extrainfo = $opnConfig['opnSQL']->qstr ($extrainfo, 'extrainfo');
	$email = $opnConfig['opnSQL']->qstr ($email);
	$login = $opnConfig['opnSQL']->qstr ($login);
	$passwd = $opnConfig['opnSQL']->qstr ($passwd);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bannerclient'] . " SET name=$name, contact=$contact, email=$email, login=$login, passwd=$passwd, extrainfo=$extrainfo WHERE cid=$cid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bannerclient'], 'cid=' . $cid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerAccount', false) );

}

function BannerFinishReactivate () {

	global $opnTables, $opnConfig;

	$bid = 0;
	get_var ('bid', $bid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$result = $opnConfig['database']->Execute ('SELECT cid, impressions, clicks, datestart,theme_group,imptotal,imageurl,clickurl,gid, htmlcode FROM ' . $opnTables['bannerfinish'] . ' WHERE bid=' . $bid);
		$bid1 = $opnConfig['opnSQL']->get_new_number ('banner', 'bid');
		$cid = $result->fields['cid'];
		$impmade = $result->fields['impressions'];
		$clicks = $result->fields['clicks'];
		$bannerdate = $result->fields['datestart'];
		$theme_group = $result->fields['theme_group'];
		$imptotal = $result->fields['imptotal'];
		$imageurl = $result->fields['imageurl'];
		$clickurl = $result->fields['clickurl'];
		$htmlcode = $result->fields['htmlcode'];
		$gid = $result->fields['gid'];
		$_imageurl = $opnConfig['opnSQL']->qstr ($imageurl);
		$_clickurl = $opnConfig['opnSQL']->qstr ($clickurl);
		$_htmlcode = $opnConfig['opnSQL']->qstr ($htmlcode, 'htmlcode');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['banner'] . " VALUES ($bid1,$cid,$imptotal,$impmade,$clicks,$_imageurl,$_clickurl,$bannerdate,$theme_group,$gid, $_htmlcode)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['banner'], 'bid=' . $bid1);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bannerfinish'] . ' WHERE bid=' . $bid);
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannerFinish', false) );
	} else {
		$boxtxt = '<br /><div class="bigtextbold"><span class="alerttextcolor">' . _BAN_ADMIN_SUREREACTBAN . '</span></div><br /><br />' . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/banners/admin/index.php?op=BannersFinish') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/banners/admin/index.php',
																																													'op' => 'BannerFinishReactivate',
																																													'bid' => $bid,
																																													'ok' => '1') ) . '">' . _YES . '</a>' . '</div><br /><br />';
		return $boxtxt;
	}
	return '';

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$boxtxt = '';
switch ($op) {
	default:
		$boxtxt = '&nbsp;';
		break;
	case 'BannerAddGroup':
		BannersAddGroup ();
		break;
	case 'BannersAdd':
		BannersAdd ();
		break;
	case 'BannerFinish':
		$boxtxt = BannersFinish ();
		break;
	case 'BannerFinishReactivate':
		$boxtxt = BannerFinishReactivate ();
		break;
	case 'BannerActive':
		$boxtxt = BannersActive ();
		break;
	case 'BannerGroup':
		$boxtxt = BannersGroup ();
		break;
	case 'BannerAccount':
		$boxtxt = BannerAccounts ();
		break;
	case 'BannerAddClient':
		$boxtxt = BannerAddClient ();
		break;
	case 'BannerFinishDelete':
		BannerFinishDelete ();
		break;
	case 'BannerDelete':
		$boxtxt = BannerDelete ();
		break;
	case 'BannerGroupDelete':
		$boxtxt = BannerGroupDelete ();
		break;
	case 'BannerEdit':
		$boxtxt = BannerEdit ();
		break;
	case 'BannerGroupEdit':
		$boxtxt = BannerGroupEdit ();
		break;
	case 'BannerChange':
		BannerChange ();
		break;
	case 'BannerGroupChange':
		BannerGroupChange ();
		break;
	case 'BannerClientDelete':
		$boxtxt = BannerClientDelete ();
		break;
	case 'BannerClientEdit':
		$boxtxt = BannerClientEdit ();
		break;
	case 'BannerClientChange':
		BannerClientChange ();
		break;
}
if ($boxtxt != '') {
	BannersConfigHeader ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BANNERS_70_';
	$_display_dat['module'] = 'modules/banners';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_BAN_ADMIN_BANCONFIG, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();
}

?>