<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}

function checkvars ($birthdate, $diag, $back, $fore, $grid, $cros, $phys, $emot, $inte, $width, $heigth, $bio_days) {
	if (!defined ('IMG_PNG') ) {
		return 15;
	}
	if (!isset ($birthdate) ) {
		return 2;
	}

	/*	if(strlen($birthdate)<>10) {
	return 0;
	}*/
	if (!preg_match ('/([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})/', $birthdate) ) {
		return 3;
	}
	if (!isset ($diag) ) {
		return 4;
	}
	if (!isset ($back) ) {
		return 5;
	}
	if (!isset ($fore) ) {
		return 6;
	}
	if (!isset ($grid) ) {
		return 7;
	}
	if (!isset ($cros) ) {
		return 8;
	}
	if (!isset ($phys) ) {
		return 9;
	}
	if (!isset ($emot) ) {
		return 10;
	}
	if (!isset ($inte) ) {
		return 11;
	}
	if (!isset ($width) ) {
		return 12;
	}
	if (!isset ($heigth) ) {
		return 13;
	}
	if (!isset ($bio_days) ) {
		return 14;
	}
	return 1;

}

function get_birthday () {

	global $opnConfig;
	if ($opnConfig['opnOption']['user_login']) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		if ( (isset ($userinfo['yearbirth']) ) && ($userinfo['yearbirth'] != '0') && $userinfo['yearbirth'] != '') {
			$year = $userinfo['yearbirth'];
		}
		if ( (isset ($userinfo['monthbirth']) ) && ($userinfo['monthbirth'] != '0') && ($userinfo['monthbirth'] != '') ) {
			$month = $userinfo['monthbirth'];
		}
		if ( (isset ($userinfo['daybirth']) ) && ($userinfo['daybirth'] != '0') && ($userinfo['daybirth'] != '') ) {
			$day = $userinfo['daybirth'];
		}
	}
	if ( (isset ($day) ) AND (isset ($month) AND (isset ($year) ) ) ) {
		return $year . '-' . $month . '-' . $day;
	}
	return 'no birthday';

}

function build_colorurl (&$url) {

	global $opnTheme, $opnConfig;

	$url['diag'] = check_color ($opnTheme['bgcolor1']);
	$url['back'] = check_color ($opnTheme['bgcolor3']);
	$url['fore'] = check_color ($opnTheme['bgcolor2']);
	$url['grid'] = check_color ($opnTheme['textcolor1']);
	$url['cros'] = check_color ($opnTheme['textcolor1']);
	$url['phys'] = check_color ($opnConfig['bio_colPhys']);
	$url['emot'] = check_color ($opnConfig['bio_colEmot']);
	$url['inte'] = check_color ($opnConfig['bio_colInte']);

}

function build_sizeurl ($width, $heigth, $bio_days, &$url) {

	$url['width'] = $width;
	$url['heigth'] = $heigth;
	$url['bio_days'] = $bio_days;

}

function get_biocolors ($diag, $back, $fore, $grid, $cros, $phys, $emot, $inte) {

	$mycol['diag'] = $diag;
	$mycol['back'] = $back;
	$mycol['fore'] = $fore;
	$mycol['grid'] = $grid;
	$mycol['cros'] = $cros;
	$mycol['phys'] = $phys;
	$mycol['emot'] = $emot;
	$mycol['inte'] = $inte;
	return $mycol;

}

function check_color ($hexcolor) {
	if (substr ($hexcolor, 0, 1) == '#') {
		$hexcolor = substr ($hexcolor, 1, 7);
	} else {
		// we do not have a proper color here, so it will be the default one
		$hexcolor = 'FF00FF';
	}
	return $hexcolor;

}

function split_color ($hexcolor) {

	$ret['r'] = hexdec (substr ($hexcolor, 0, 2) );
	$ret['g'] = hexdec (substr ($hexcolor, 2, 2) );
	$ret['b'] = hexdec (substr ($hexcolor, 4, 2) );
	return $ret;

}

function gregorianToJD_func ($month, $day, $year) {
	// Note: The following algorithm is based
	// on a paper by Peter Baum, pbaum@capecod.net
	if ($month<3) {
		$month = $month+12;
		$year = $year-1;
	}
	$jd = $day+floor ( (153* $month-457)/5)+365* $year+floor ($year/4)-floor ($year/100)+floor ($year/400)+1721118.5;
	return ($jd);

}
// Function to draw a curve of the biorythm
// Parameters are the day number for which to draw,
// period of the specific curve and its color

function drawRhythm (&$image, $daysAlive, $period, $color) {

	global $daysToShow, $diagramWidth, $diagramHeight;
	// get day on which to center
	$centerDay = $daysAlive- ($daysToShow/2);
	// calculate diagram parameters
	$plotScale = ($diagramHeight-35)/2;
	$plotCenter = ($diagramHeight-35)/2;
	$oldX = 0;
	$oldY = 0;
	// draw the curve
	for ($x = 0; $x<= $daysToShow; $x++) {
		// calculate phase of curve at this day, then Y value
		// within diagram
		$phase = ( ($centerDay+ $x)% $period)/ $period*2*pi ();
		$y = 1-sin ($phase)*(float) $plotScale+(float) $plotCenter;
		// draw line from last point to current point
		if ($x>0) {
			imageLine ($image, $oldX, $oldY, $x* $diagramWidth/ $daysToShow, $y, $color);
		}
		// save current X/Y coordinates as start point for next line
		$oldX = $x* $diagramWidth/ $daysToShow;
		$oldY = $y;
	}

}

?>