<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* Codesnipped by Till Gerken http://www.phpwizard.net/
* Completed Code by Wolfram Borowski www.woboweb.de 2001
* CMS-Integration by Kurt Fleischmann, TypoType www.typotype.de 2000-2002
* opnPHPnuke Version by Alexander Weber, xweber@kamelfreunde.de
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../mainfile.php');
}
global $opnConfig;

$opnConfig['module']->InitModule ('modules/biorythm');
getLanguageDef (_OPN_ROOT_PATH . 'modules/biorythm/show/language/');
include_once (_OPN_ROOT_PATH . '/modules/biorythm/function.php');
$birthdate = '';
get_var ('birthdate', $birthdate, 'both', _OOBJ_DTYPE_CLEAN);
$diag = '';
get_var ('diag', $diag, 'both', _OOBJ_DTYPE_CLEAN);
$back = '';
get_var ('back', $back, 'both', _OOBJ_DTYPE_CLEAN);
$fore = '';
get_var ('fore', $fore, 'both', _OOBJ_DTYPE_CLEAN);
$grid = '';
get_var ('grid', $grid, 'both', _OOBJ_DTYPE_CLEAN);
$cros = '';
get_var ('cros', $cros, 'both', _OOBJ_DTYPE_CLEAN);
$phys = '';
get_var ('phys', $phys, 'both', _OOBJ_DTYPE_CLEAN);
$emot = '';
get_var ('emot', $emot, 'both', _OOBJ_DTYPE_CLEAN);
$inte = '';
get_var ('inte', $inte, 'both', _OOBJ_DTYPE_CLEAN);
$width = '';
get_var ('width', $width, 'both', _OOBJ_DTYPE_CLEAN);
$heigth = '';
get_var ('heigth', $heigth, 'both', _OOBJ_DTYPE_CLEAN);
$bio_days = '';
get_var ('bio_days', $bio_days, 'both', _OOBJ_DTYPE_CLEAN);
$check = checkvars ($birthdate, $diag, $back, $fore, $grid, $cros, $phys, $emot, $inte, $width, $heigth, $bio_days);
if ($check == 1) {
	$diagramWidth = $width;
	$diagramHeight = $heigth;
	$daysToShow = $bio_days;
	$birtharr = explode ('-', $birthdate);
	$birthYear = $birtharr[0];
	$birthMonth = $birtharr[1];
	$birthDay = $birtharr[2];
	// calculate the number of days this person is alive
	// this works because Julian dates specify an absolute number
	// of days -> the difference between Julian birthday and
	// 'Julian today' gives the number of days alive
	$daysGone = abs (gregorianToJD_func ($birthMonth, $birthDay, $birthYear)-gregorianToJD_func (date ('m'), date ('d'), date ('Y') ) );
	// create image
	$func = $opnConfig['opn_gfx_imagecreate'];
	$image = $func ($diagramWidth, $diagramHeight);
	// define the colors
	$mycolors = get_biocolors ($diag, $back, $fore, $grid, $cros, $phys, $emot, $inte);
	$colDiagramm = split_color ($mycolors['diag']);
	$colBackgr = split_color ($mycolors['back']);
	$colForegr = split_color ($mycolors['fore']);
	$colGrid = split_color ($mycolors['grid']);
	$colCross = split_color ($mycolors['cros']);
	$colPhys = split_color ($mycolors['phys']);
	$colEmot = split_color ($mycolors['emot']);
	$colInter = split_color ($mycolors['inte']);
	$colorDiagramm = imageColorAllocate ($image, $colDiagramm['r'], $colDiagramm['g'], $colDiagramm['b']);
	$colorBackgr = imageColorAllocate ($image, $colBackgr['r'], $colBackgr['g'], $colBackgr['b']);
	$colorForegr = imageColorAllocate ($image, $colForegr['r'], $colForegr['g'], $colForegr['b']);
	$colorGrid = imageColorAllocate ($image, $colGrid['r'], $colGrid['g'], $colGrid['b']);
	$colorCross = imageColorAllocate ($image, $colCross['r'], $colCross['g'], $colCross['b']);
	$colorPhysical = imageColorAllocate ($image, $colPhys['r'], $colPhys['g'], $colPhys['b']);
	$colorEmotional = imageColorAllocate ($image, $colEmot['r'], $colEmot['g'], $colEmot['b']);
	$colorIntellectual = imageColorAllocate ($image, $colInter['r'], $colInter['g'], $colInter['b']);
	ImageFilledRectangle ($image, 0, 0, $diagramWidth, $diagramHeight, $colorBackgr);
	// fill image with colors
	ImageFilledRectangle ($image, 0, 0, $diagramWidth-1, $diagramHeight-30, $colorDiagramm);
	// calculate start date for diagram and start drawing
	$nrSecondsPerDay = 86400;
	$diagramDate = time ()- ($daysToShow/2* $nrSecondsPerDay)+ $nrSecondsPerDay;
	for ($i = 1; $i< $daysToShow; $i++) {
		$thisDate = getDate ($diagramDate);
		$xCoord = ($diagramWidth/ $daysToShow)* $i;
		// draw day mark and day number
		imageLine ($image, $xCoord, $diagramHeight-35, $xCoord, $diagramHeight-30, $colorGrid);
		// show the dates
		imageString ($image, 1, $xCoord-2, $diagramHeight-28, $thisDate['mday'], $colorGrid);
		$diagramDate += $nrSecondsPerDay;
	}
	// draw critical zone
	$grey = ImageColorAllocate ($image, 192, 192, 192);
	ImageFilledRectangle ($image, 0, ($diagramHeight-20)*45/100, $diagramWidth, ($diagramHeight-20)*55/100, $grey);
	// draw rectangle around diagram (marks its boundaries)
	imageRectangle ($image, 0, 0, $diagramWidth-1, $diagramHeight-30, $colorGrid);
	// lines below
	imageRectangle ($image, 0, $diagramHeight-1, $diagramWidth-1, $diagramHeight-30, $colorGrid);
	// draw middle cross
	imageLine ($image, 0, ($diagramHeight-20)/2, $diagramWidth, ($diagramHeight-20)/2, $colorCross);
	imageLine ($image, $diagramWidth/2, 0, $diagramWidth/2, $diagramHeight-30, $colorCross);
	// show up some text
	$opnConfig['opndate']->now ();
	$formatToday = '';
	$opnConfig['opndate']->formatTimestamp ($formatToday, _DATE_DATESTRING4);
	$theday = $birthYear . '-' . sprintf ('%02d-%02d', $birthMonth, $birthDay);
	$temp2 = $theday . ' 00:00:00';
	$opnConfig['opndate']->setTimestamp ($temp2);
	$formatBirthday = '';
	$opnConfig['opndate']->formatTimestamp ($formatBirthday, _DATE_DATESTRING4);
	imageString ($image, 1, 3, $diagramHeight-19, _BIO_IMG_TODAY . ': ' . $formatToday, $colorCross);
	imageString ($image, 1, 3, $diagramHeight-10, _BIO_IMG_BIRTHDAY . ':' . $formatBirthday, $colorCross);
	imageString ($image, 2, 3, 4, _BIO_IMG_PHYS, $colorPhysical);
	imageString ($image, 2, 3, 16, _BIO_IMG_EMOT, $colorEmotional);
	imageString ($image, 2, 3, 28, _BIO_IMG_INTE, $colorIntellectual);
	imageString ($image, 1, 3, ($diagramHeight-20)/2-8, _BIO_IMG_CRITICAL, $colorCross);
	imageString ($image, 1, 3, ($diagramHeight-20)/2, _BIO_IMG_AREA, $colorCross);
	// now draw each curve with its appropriate parameters
	drawRhythm ($image, $daysGone, 23, $colorPhysical);
	drawRhythm ($image, $daysGone, 28, $colorEmotional);
	drawRhythm ($image, $daysGone, 33, $colorIntellectual);
	header ('Content-type:  image/png');
	imageInterlace ($image, 1);
	imagePNG ($image);
} else {
	echo 'Impossible Parameters  -  check failed ' . $check;
}

?>