<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/bookcorner', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/bookcorner/admin/language/');

function bookcorner_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_BOOKCORNERADM_BOOSAVE] = _BOOKCORNERADM_BOOSAVE;
	$nav[_BOOKCORNERADM_BOOADMIN] = _BOOKCORNERADM_BOOADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function bookcornersettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BOOKCORNERADM_BOOGENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BOOKCORNERADM_BOOBOOKSPERPAGECORNER,
			'name' => 'bookcorner_books_per_page_corner',
			'value' => $privsettings['bookcorner_books_per_page_corner'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BOOKCORNERADM_BOOBOOKSPERPAGEADMIN,
			'name' => 'bookcorner_books_per_page_admin',
			'value' => $privsettings['bookcorner_books_per_page_admin'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BOOKCORNERADM_BOOBOOKSPERSUBCAT,
			'name' => 'bookcorner_cats_per_row',
			'value' => $privsettings['bookcorner_cats_per_row'],
			'size' => 1,
			'maxlength' => 1);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BOOKCORNERADM_INDEXPICWIDTH,
			'name' => 'bookcorner_books_image_width',
			'value' => $privsettings['bookcorner_books_image_width'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BOOKCORNERADM_DISPLAY_SEARCH,
			'name' => 'bookcorner_display_search',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bookcorner_display_search'] == 1?true : false),
			 ($privsettings['bookcorner_display_search'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BOOKCORNERADM_DISPLAY_AMAZON_SEARCH,
			'name' => 'bookcorner_display_amazon_search',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bookcorner_display_amazon_search'] == 1?true : false),
			 ($privsettings['bookcorner_display_amazon_search'] == 0?true : false) ) );
	$values = array_merge ($values, bookcorner_allhiddens (_BOOKCORNERADM_BOOGENERAL) );
	$set->GetTheForm (_BOOKCORNERADM_BOOSETTINGS, $opnConfig['opn_url'] . '/modules/bookcorner/admin/settings.php', $values);

}

function bookcorner_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function bookcorner_dosavebookcorner ($vars) {

	global $privsettings;

	$privsettings['bookcorner_books_per_page_corner'] = $vars['bookcorner_books_per_page_corner'];
	$privsettings['bookcorner_books_per_page_admin'] = $vars['bookcorner_books_per_page_admin'];
	$privsettings['bookcorner_cats_per_row'] = $vars['bookcorner_cats_per_row'];
	$privsettings['bookcorner_books_image_width'] = $vars['bookcorner_books_image_width'];
	$privsettings['bookcorner_display_search'] = $vars['bookcorner_display_search'];
	$privsettings['bookcorner_display_amazon_search'] = $vars['bookcorner_display_amazon_search'];
	bookcorner_dosavesettings ();

}

function bookcorner_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _BOOKCORNERADM_BOOGENERAL:
			bookcorner_dosavebookcorner ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		bookcorner_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _BOOKCORNERADM_BOOSAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bookcorner/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _BOOKCORNERADM_BOOADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/bookcorner/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		bookcornersettings ();
		break;
}

?>