<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('GOOGLE_MAGIC', 0xE6359A60);

function zeroFill ($a, $b) {

	$z = hexdec (80000000);
	if ($z&$a) {
		$a = ($a >> 1);
		$a &= (~ $z);
		$a |= 0x40000000;
		$a = ($a >> ($b-1) );
	} else {
		$a = ($a >> $b);
	}
	return $a;

}

function mix ($a, $b, $c) {

	$a -= $b;
	$a -= $c;
	$a ^= (zeroFill ($c, 13) );
	$b -= $c;
	$b -= $a;
	$b ^= ($a << 8);
	$c -= $a;
	$c -= $b;
	$c ^= (zeroFill ($b, 13) );
	$a -= $b;
	$a -= $c;
	$a ^= (zeroFill ($c, 12) );
	$b -= $c;
	$b -= $a;
	$b ^= ($a << 16);
	$c -= $a;
	$c -= $b;
	$c ^= (zeroFill ($b, 5) );
	$a -= $b;
	$a -= $c;
	$a ^= (zeroFill ($c, 3) );
	$b -= $c;
	$b -= $a;
	$b ^= ($a << 10);
	$c -= $a;
	$c -= $b;
	$c ^= (zeroFill ($b, 15) );
	return array ($a,
			$b,
			$c);

}

function GoogleCH ($url, $length = null, $init = GOOGLE_MAGIC) {
	if (is_null ($length) ) {
		$length = sizeof ($url);
	}
	$a = $b = 0x9E3779B9;
	$c = $init;
	$k = 0;
	$len = $length;
	while ($len >= 12) {
		$a += ($url[$k+0]+ ($url[$k+1] << 8)+ ($url[$k+2] << 16)+ ($url[$k+3] << 24) );
		$b += ($url[$k+4]+ ($url[$k+5] << 8)+ ($url[$k+6] << 16)+ ($url[$k+7] << 24) );
		$c += ($url[$k+8]+ ($url[$k+9] << 8)+ ($url[$k+10] << 16)+ ($url[$k+11] << 24) );
		$mix = mix ($a, $b, $c);
		$a = $mix[0];
		$b = $mix[1];
		$c = $mix[2];
		$k += 12;
		$len -= 12;
	}
	$c += $length;
	switch ($len) {
		case 11:
			$c += ($url[$k+10] << 24);
			break;
		case 10:
			$c += ($url[$k+9] << 16);
			break;
		case 9:
			$c += ($url[$k+8] << 8);
			break;
		case 8:
			$b += ($url[$k+7] << 24);
			break;
		case 7:
			$b += ($url[$k+6] << 16);
			break;
		case 6:
			$b += ($url[$k+5] << 8);
			break;
		case 5:
			$b += ($url[$k+4]);
			break;
		case 4:
			$a += ($url[$k+3] << 24);
			break;
		case 3:
			$a += ($url[$k+2] << 16);
			break;
		case 2:
			$a += ($url[$k+1] << 8);
			break;
		case 1:
			$a += ($url[$k+0]);
			break;
	}
	$mix = mix ($a, $b, $c);
	return $mix[2];

}

function strord ($string) {

	$result = array ();
	$max = strlen ($string);
	for ($i = 0; $i<$max; $i++) {
		$result[$i] = ord ($string{$i});
	}
	return $result;

}

?>