<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_convert_charset.php');

function box_last_fm_parse_xml ($file, $listelements, &$data, &$encoding) {

		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_xml.php');
		$xml = & new opn_xml ();
		$xml->GetAttributes (true);
		foreach ($listelements as $element) {
			$xml->Set_Listelement ($element);
		}
		$xml->Set_URL ($file);
		$data = $xml->items;
		$encoding = $xml->encoding;
		unset ($xml);

}

function box_last_fm_parse_tags ($data, $displaystats, $linesize, $limit, $encoding, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="opnsidebox">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		$index1 = 'toptags';
		$index2 = 'tag';
		$convert = & new ConvertCharset;
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$name = '';
				$count = '';
				$url = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'name') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$name = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$name = $child1;
						}
					}
					if ($key == 'count') {
						$count = $child1;
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$name = str_replace ('"', '\'', $name);
				$title1 = strip_tags ($name);
				$opnConfig['cleantext']->opn_shortentext ($name, $linesize);
				$get .= '<div class="sideboxsmalltext">' . '<a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' .$name . '</a>';
				if ($displaystats) {
					$get .= ' ' . $count;
				}
				$get .= '<br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}

function box_last_fm_parse_rtrack ($data, $displaystats, $linesize, $limit, $encoding, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="opnsidebox">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		$index1 = 'recenttracks';
		$index2 = 'track';
		$convert = & new ConvertCharset;
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$artist = '';
				$date = '';
				$url = '';
				$name = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'artist') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$artist = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$artist = $child1;
						}
					}
					if ($key == 'name') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$name = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$name = $child1;
						}
					}
					if ($key == 'date_attribute_uts') {
						$date = strftime (_DATE_DATESTRING5, $child1);
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$artist = $artist . ' - ' . $name;
				$artist = str_replace ('"', '\'', $artist);
				$title1 = strip_tags ($artist);
				$opnConfig['cleantext']->opn_shortentext ($artist, $linesize);
				$get .= '<div class="sideboxsmalltext">' . '<a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' .$artist . '</a>';
				if ($displaystats) {
					$get .= sprintf (_BOX_LASTFM_PLAYED_AT, $date);
				}
				$get .= '<br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}

function box_last_fm_parse_album ($data, $displaystats, $linesize, $limit, $encoding, $top, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="opnsidebox">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		if ($top) {
			$index1 = 'topalbums';
		} else {
			$index1 = 'weeklyalbumchart';
		}
		$index2 = 'album';
		$convert = & new ConvertCharset;
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$artist = '';
				$position = '';
				$playcount = '';
				$url = '';
				$name = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'artist') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$artist = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$artist = $child1;
						}
					}
					if ($key == 'name') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$name = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$name = $child1;
						}
					}
					if ($key == 'chartposition') {
						$position = $child1;
					}
					if ($key == 'rank') {
						$position = $child1;
					}
					if ($key == 'playcount') {
						$playcount = $child1;
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$artist = $artist . ' - ' . $name;
				$artist = str_replace ('"', '\'', $artist);
				$title1 = strip_tags ($artist);
				$opnConfig['cleantext']->opn_shortentext ($artist, $linesize);
				$get .= '<div class="sideboxsmalltext">' . $position . '.) <a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' .$artist . '</a>';
				if ($displaystats) {
					$get .= sprintf (_BOX_LASTFM_PLAYED, $playcount);
				}
				$get .= '<br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}

function box_last_fm_parse_track ($data, $displaystats, $linesize, $limit, $encoding, $top, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="opnsidebox">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		$convert = & new ConvertCharset;
		if ($top) {
			$index1 = 'toptracks';
		} else {
			$index1 = 'weeklytrackchart';
		}
		$index2 = 'track';
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$artist = '';
				$track = '';
				$position = '';
				$playcount = '';
				$url = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'artist') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$artist = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$artist = $child1;
						}
					}
					if ($key == 'name') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$track = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$track = $child1;
						}
					}
					if ($key == 'chartposition') {
						$position = $child1;
					}
					if ($key == 'rank') {
						$position = $child1;
					}
					if ($key == 'playcount') {
						$playcount = $child1;
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$track = $artist . ' - ' . $track;
				$track = str_replace ('"', '\'', $track);
				$title1 = strip_tags ($track);
				$opnConfig['cleantext']->opn_shortentext ($track, $linesize);
				$get .= '<div class="sideboxsmalltext">' . $position . '.) <a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' .$track . '</a>';
				if ($displaystats) {
					$get .= sprintf (_BOX_LASTFM_PLAYED, $playcount);
				}
				$get .= '<br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}


function box_last_fm_parse_artist ($data, $displaystats, $linesize, $limit, $encoding, $top, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="opnsidebox">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		if ($top) {
			$index1 = 'topartists';
		} else {
			$index1 = 'weeklyartistchart';
		}
		$index2 = 'artist';
		$convert = & new ConvertCharset;
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$artist = '';
				$position = '';
				$playcount = '';
				$url = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'name') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$artist = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$artist = $child1;
						}
					}
					if ($key == 'chartposition') {
						$position = $child1;
					}
					if ($key == 'rank') {
						$position = $child1;
					}
					if ($key == 'playcount') {
						$playcount = $child1;
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$artist = str_replace ('"', '\'', $artist);
				$title1 = strip_tags ($artist);
				$opnConfig['cleantext']->opn_shortentext ($artist, $linesize);
				$get .= '<div class="sideboxsmalltext">' . $position . '.) <a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' .$artist . '</a>';
				if ($displaystats) {
					$get .= sprintf (_BOX_LASTFM_PLAYED, $playcount);
				}
				$get .= '<br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}

function box_last_fm_parse_users ($data, $linesize, $limit, $encoding, &$get, $friends = true) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="sideboxsmalltext">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$counter = 0;
		$index2 = 'user';
		$convert = & new ConvertCharset;
		if ($friends) {
			$title = _BOX_LASTFM_FRIEND;
			$index1 = 'friends';
		} else {
			$title = _BOX_LASTFM_NEIGHBOUR;
			$index1 = 'neighbours';
		}
		foreach ($data[$index1][0][$index2] as $child) {
			if (($limit ==0) || ($counter < $limit)) {
				$username = '';
				$url = '';
				foreach ($child as $key=>$child1) {
					if ($key == 'username') {
						if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
							$username = $convert->Convert ($child1, $encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$username = $child1;
						}
					}
					if ($key == 'url') {
						$url = $child1;
					}
				}
				$username = str_replace ('"', '\'', $username);
				$title1 = strip_tags ($username);
				$opnConfig['cleantext']->opn_shortentext ($username, $linesize);
				$get .= '<div class="sideboxsmalltext">' . $title . '<a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' . $username . '</a><br /></div>' . _OPN_HTML_NL;
				++$counter;
			}
		}
		unset ($convert);
	}
}

function box_last_fm_parse_profile ($data, $displaystats, $linesize, $encoding, &$get) {

	global $opnConfig;

	if (is_null ($data)) {
		$get = '<div class="sideboxsmalltext">' . _BOX_LASTFM_NODATA .'<br /></div>';
	} else {
		$username = '';
		$userurl = '';
		$realname = '';
		$registered = '';
		$age = '';
		$gender = '';
		$country = '';
		$playcount = '';
		$convert = & new ConvertCharset;
		foreach ($data['profile'][0] as $key=>$child) {
			if ($key == 'username') {
				if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
					$username = $convert->Convert ($child, $encoding, $opnConfig['opn_charset_encoding'], true);
				} else {
					$username = $child;
				}
			}
			if ($key == 'url') {
				$url = $child;
			}
			if ($key == 'realname') {
				if ( ($encoding != $opnConfig['opn_charset_encoding']) ) {
					$realname = $convert->Convert ($child, $encoding, $opnConfig['opn_charset_encoding'], true);
				} else {
					$realname = $child;
				}
			}
			if ($key == 'registered_attribute_unixtime') {
				$registered = $child;
			}
			if ($key == 'age') {
				$age = $child;
			}
			if ($key == 'gender') {
				$gender = $child;
				switch ($gender) {
					case 'Male':
						$gender = _BOX_LASTFM_GENDER_MALE;
						break;
					case 'Female':
						$gender = _BOX_LASTFM_GENDER_FEMALE;
						break;
					case 'Unknown':
						$gender = _BOX_LASTFM_GENDER_UNKNOWN;
						break;
				}
			}
			if ($key == 'country') {
				$country = $child;
			}
			if ($key == 'playcount') {
				$playcount = $child;
			}
		}
		unset ($convert);
		$username = str_replace ('"', '\'', $username);
		$title1 = strip_tags ($username);
		$opnConfig['cleantext']->opn_shortentext ($username, $linesize);
		$get = '<div class="sideboxsmalltext">' . _BOX_LASTFM_USER . '<a class="sideboxsmalltext" href="' . $url . '" target="_blank" title="' . $title1 . '">' . $username . '</a><br /></div>' . _OPN_HTML_NL;
		if ($realname != '') {
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_REALNAME . $realname . '<br /></div>' . _OPN_HTML_NL;
		}
		if ($registered != '') {
			$registered = strftime (_DATE_DATESTRING4, $registered);
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_REGISTERED . $registered . '<br /></div>' . _OPN_HTML_NL;
		}
		if ($age != '') {
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_AGE . $age . _BOX_LASTFM_YEARS . '<br /></div>' . _OPN_HTML_NL;
		}
		if ($gender != '') {
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_GENDER . $gender . '<br /></div>' . _OPN_HTML_NL;
		}
		if ($country != '') {
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_COUNTRY . $country .'<br /></div>' . _OPN_HTML_NL;
		}
		if (($playcount != '') && ($displaystats == 1)) {
			$get .= '<div class="sideboxsmalltext">' . _BOX_LASTFM_PLAYCOUNT . $playcount . '<br /></div>' . _OPN_HTML_NL;
		}
	}
}

function box_last_fm_get_sidebox_result (&$box_array_dat) {

	global $opnConfig;

	if (!isset ($box_array_dat['box_options']['title']) ) {
		$box_array_dat['box_options']['title'] = _BOX_LASTFM_TITLE;
		// default title
	}
	if (!isset ($box_array_dat['box_options']['box_user_name']) ) {
		$box_array_dat['box_options']['box_user_name'] = '';
	}
	if (!isset ($box_array_dat['box_options']['box_what_display']) ) {
		$box_array_dat['box_options']['box_what_display'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['cache_time']) ) {
		$box_array_dat['box_options']['cache_time'] = 60;
	}
	if (!isset ($box_array_dat['box_options']['limit']) ) {
		$box_array_dat['box_options']['limit'] = 0;
	}
	if ($box_array_dat['box_options']['limit'] == '') {
		$box_array_dat['box_options']['limit'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['display_stats']) ) {
		$box_array_dat['box_options']['display_stats'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	$boxstuff = $box_array_dat['box_options']['textbefore'];
	$cache_time = $box_array_dat['box_options']['cache_time']*60;
	$displaystats = $box_array_dat['box_options']['display_stats'];
	$linesize = $box_array_dat['box_options']['strlength'];
	$limit = $box_array_dat['box_options']['limit'];
	$whatdisplay = $box_array_dat['box_options']['box_what_display'];
	getLanguageDef (_OPN_ROOT_PATH . 'modules/box_collection/plugin/sidebox/box_last_fm/language/');
	$url = 'http://ws.audioscrobbler.com/1.0/user/' . $box_array_dat['box_options']['box_user_name'] . '/%s.xml';
	$cache_dir = $opnConfig['datasave']['box_last_fm']['path'] . '%s' . $box_array_dat['box_options']['box_user_name'] . '.xml';
	$top = false;
	switch ($whatdisplay) {
		case 0:
			$url = sprintf ($url, 'profile');
			$cache_dir = sprintf ($cache_dir, 'profile');
			$listelements = array ('profile');
			break;
		case 1:
			$url = sprintf ($url, 'friends');
			$cache_dir = sprintf ($cache_dir, 'friends');
			$listelements = array ('friends', 'user');
			break;
		case 2:
			$url = sprintf ($url, 'neighbours');
			$cache_dir = sprintf ($cache_dir, 'neighbours');
			$listelements = array ('neighbours', 'user');
			break;
		case 3:
			$url = sprintf ($url, 'recenttracks');
			$cache_dir = sprintf ($cache_dir, 'recenttracks');
			$listelements = array ('recenttracks', 'track');
			break;
		case 4:
			$url = sprintf ($url, 'weeklyartistchart');
			$cache_dir = sprintf ($cache_dir, 'weeklyartistchart');
			$listelements = array ('weeklyartistchart', 'artist');
			break;
		case 5:
			$url = sprintf ($url, 'weeklytrackchart');
			$cache_dir = sprintf ($cache_dir, 'weeklytrackchart');
			$listelements = array ('weeklytrackchart', 'track');
			break;
		case 6:
			$url = sprintf ($url, 'topartists');
			$cache_dir = sprintf ($cache_dir, 'topartists');
			$listelements = array ('topartists', 'artist');
			$top = true;
			break;
		case 7:
			$url = sprintf ($url, 'toptracks');
			$cache_dir = sprintf ($cache_dir, 'toptracks');
			$listelements = array ('toptracks', 'track');
			$top = true;
			break;
		case 8:
			$url = sprintf ($url, 'topalbums');
			$cache_dir = sprintf ($cache_dir, 'topalbums');
			$listelements = array ('topalbums', 'album');
			$top = true;
			break;
		case 9:
			$url = sprintf ($url, 'tags');
			$cache_dir = sprintf ($cache_dir, 'tags');
			$listelements = array ('toptags', 'tag');
			$top = true;
			break;
	}
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_cache.php');
	$cache = & new opn_cache ($cache_dir, $cache_time);
	if ($cache->IsTimeouted () ) {
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
		$http = & new http ();
		$status = $http->get ($url);
		if ($status == HTTP_STATUS_OK) {
			$get = $http->get_response_body ();
		} else {
			$get = 'received status ' . $status;
		}
		$http->disconnect ();
		if (($whatdisplay == 1) || ($whatdisplay == 2)) {
			$search = array ('<neighbours user=', '<friends user=');
			$replace = array ('<neighbours user1=', '<friends user1=');
			$get = str_replace($search, $replace, $get);
			unset ($search);
			unset ($replace);
		}
		$cache->WriteData ($get);
	}
	unset ($cache);
	$data = array ();
	$encoding = '';
	box_last_fm_parse_xml ($cache_dir, $listelements, $data, $encoding);
	$get = '';
	switch ($whatdisplay) {
		case 0:
			box_last_fm_parse_profile ($data, $displaystats, $linesize, $encoding, $get);
			break;
		case 1:
			box_last_fm_parse_users ($data, $linesize, $limit, $encoding, $get);
			break;
		case 2:
			box_last_fm_parse_users ($data, $linesize, $limit, $encoding, $get, false);
			break;
		case 3:
			box_last_fm_parse_rtrack ($data, $displaystats, $linesize, $limit, $encoding, $get);
			break;
		case 4:
		case 6:
			box_last_fm_parse_artist ($data, $displaystats, $linesize, $limit, $encoding, $top, $get);
			break;
		case 5:
		case 7:
			box_last_fm_parse_track ($data, $displaystats, $linesize, $limit, $encoding, $top, $get);
			break;
		case 8:
			box_last_fm_parse_album ($data, $displaystats, $linesize, $limit, $encoding, $top, $get);
			break;
		case 9:
			box_last_fm_parse_tags ($data, $displaystats, $linesize, $limit, $encoding, $get);
			break;
	}
	$boxstuff .= '<div>' . $get . '</div>';
	$box_array_dat['box_result']['skip'] = false;
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

?>