<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function BugTracking_CSV_Export () {

	global $opnConfig;

	global $bugs;

	global $project, $category, $version;

	global $bugvalues;

	$sel_project = -1;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$sortby = 'desc_date_updated';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$sel_reporter = 0;
	get_var ('sel_reporter', $sel_reporter, 'both', _OOBJ_DTYPE_INT);
	$sel_handler = 0;
	get_var ('sel_handler', $sel_handler, 'both', _OOBJ_DTYPE_INT);
	$sel_category = 0;
	get_var ('sel_category', $sel_category, 'both', _OOBJ_DTYPE_INT);
	$sel_severity = 0;
	get_var ('sel_severity', $sel_severity, 'both', _OOBJ_DTYPE_INT);
	$sel_status = 0;
	get_var ('sel_status', $sel_status, 'both', _OOBJ_DTYPE_INT);
	$block_resolved = 0;
	get_var ('block_resolved', $block_resolved, 'both', _OOBJ_DTYPE_INT);
	$block_closed = 0;
	get_var ('block_closed', $block_closed, 'both', _OOBJ_DTYPE_INT);
	$block_feature = 0;
	get_var ('block_feature', $block_feature, 'both', _OOBJ_DTYPE_INT);
	$sel_query = '';
	get_var ('sel_query', $sel_query, 'both');
	$sel_query = urldecode ($sel_query);
	$bugs->SetProject ($sel_project);
	$bugs->SetCategory ($sel_category);
	$bugs->SetSeverity ($sel_severity);
	$bugs->SetQuery ($sel_query);
	if ($sel_status) {
		$bugs->SetStatus ($sel_status);
		$bugs->ClearBlockStatus ();
	}
	$bugs->SetReporter ($sel_reporter);
	$bugs->SetHandler ($sel_handler);
	if (!$sel_status) {
		if ($block_resolved) {
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_RESOLVED);
		}
		if ($block_closed) {
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_CLOSED);
		}
	}
	if (!$sel_severity) {
		if ($block_feature) {
			$bugs->SetBlockSeverity (_OPN_BUG_SEVERITY_FEATURE);
		}
	}
	$order = ' ORDER BY ';
	switch ($sortby) {
		case 'asc_bug_id':
			$order .= 'bug_id';
			break;
		case 'desc_bug_id':
			$order .= 'bug_id DESC';
			break;
		case 'asc_category':
			$order .= 'category';
			break;
		case 'desc_category':
			$order .= 'category DESC';
			break;
		case 'asc_severity':
			$order .= 'severity';
			break;
		case 'desc_severity':
			$order .= 'severity DESC';
			break;
		case 'asc_status':
			$order .= 'status';
			break;
		case 'desc_status':
			$order .= 'status DESC';
			break;
		case 'asc_date_updated':
			$order .= 'date_updated';
			break;
		case 'desc_date_updated':
			$order .= 'date_updated DESC';
			break;
		case 'asc_summary':
			$order .= 'summary';
			break;
		case 'desc_summary':
			$order .= 'summary DESC';
			break;
		case 'asc_project_id':
			$order .= 'project_id';
			break;
		case 'desc_project_id':
			$order .= 'project_id DESC';
			break;
	}
	$bugs->SetOrderby ($order);
	$reccounter = $bugs->GetCount ();
	if ($reccounter) {
		$export = $bugs->GetArray ();
		$exporter = array ();
		$exporter[] = array (_BUG_ID,
				_BUG_PROJECT,
				_BUG_REPORTER,
				_BUG_HANDLER,
				_BUG_PRIORITY,
				_BUG_SEVERITY,
				_BUG_REPRO,
				_BUG_VERSION,
				_BUG_PROJECTION,
				_BUG_CATEGORY,
				_BUG_DATE_SUBMITTED,
				_BUG_ETA,
				_BUG_DATE_UPDATED1,
				_BUG_SUMMARY,
				_BUG_STATUS,
				_BUG_RESOLUTION,
				_BUG_DUPLICATE_ID);
		foreach ($export as $value) {
			$hlp = array ();
			$hlp[] = $value['bug_id'];
			$pro = $project->RetrieveSingle ($value['project_id']);
			$hlp[] = $pro['project_name'];
			$ui = $opnConfig['permission']->GetUser ($value['reporter_id'], 'useruid', '');
			$hlp[] = $ui['uname'];
			if ($value['handler_id']) {
				$ui = $opnConfig['permission']->GetUser ($value['handler_id'], 'useruid', '');
			} else {
				$ui['uname'] = '';
			}
			$hlp[] = $ui['uname'];
			$hlp[] = $bugvalues['priority'][$value['priority']];
			$hlp[] = $bugvalues['severity'][$value['severity']];
			$hlp[] = $bugvalues['reproducibility'][$value['reproducibility']];
			if ($value['category']) {
				$cat = $category->RetrieveSingle ($value['category']);
			} else {
				$cat['category'] = '';
			}
			if ($value['version']) {
				$ver = $version->RetrieveSingle ($value['version']);
			} else {
				$ver['version'] = '';
			}
			$hlp[] = $ver['version'];
			$hlp[] = $bugvalues['projection'][$value['projection']];
			$hlp[] = $cat['category'];
			$opnConfig['opndate']->sqlToopnData ($value['date_submitted']);
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$hlp[] = $time;
			$hlp[] = $bugvalues['eta'][$value['eta']];
			$opnConfig['opndate']->sqlToopnData ($value['date_updated']);
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$hlp[] = $time;
			$hlp[] = $value['summary'];
			$hlp[] = $bugvalues['status'][$value['status']];
			$hlp[] = $bugvalues['resolution'][$value['resolution']];
			$hlp[] = $value['duplicate_id'];
			$exporter[] = $hlp;
			unset ($hlp);
		}
		unset ($export);
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_csv.php');
		$csv = & new opn_csv ();
		$csv->arrayToCSV ($exporter);
		$csv->dump ('bug_tracking');
	}

}

?>