<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function summary_print_rows (&$table, $name, $open, $resolved, $closed, $total) {

	$table->AddDataRow (array ($name, $open, $resolved, $closed, $total), array ('left', 'right', 'right', 'right', 'right') );

}

function summary_by_project (&$table) {

	global $opnConfig, $opnTables, $project;

	$query = 'SELECT project_id, status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . ' GROUP BY project_id, status';
	$t_last_project = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields['project_id'] != $t_last_project) && ($t_last_project != -1) ) {
			$pro = $project->RetrieveSingle ($t_last_project);
			summary_print_rows ($table, $pro['project_name'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['status']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_project = $result->fields['project_id'];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		$pro = $project->RetrieveSingle ($t_last_project);
		summary_print_rows ($table, $pro['project_name'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}

function summary_by ($project_id, $p_enum, &$table) {

	global $opnConfig, $opnTables, $bugvalues;

	$where = '';
	if ($project_id) {
		$where = ' WHERE project_id=' . $project_id;
	}
	$query = 'SELECT ' . $p_enum . ',status as stat, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY ' . $p_enum . ', status';
	$t_last_value = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields[$p_enum] != $t_last_value) && ($t_last_value != -1) ) {
			summary_print_rows ($table, $bugvalues[$p_enum][$t_last_value], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['stat']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_value = $result->fields[$p_enum];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		summary_print_rows ($table, $bugvalues[$p_enum][$t_last_value], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}

function summary_developer ($project_id, &$table) {

	global $opnConfig, $opnTables;

	$where = ' WHERE handler_id>0';
	if ($project_id) {
		$where .= ' AND project_id=' . $project_id;
	}
	$query = 'SELECT handler_id,status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY handler_id, status';
	$t_last_handler = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields['handler_id'] != $t_last_handler) && ($t_last_handler != -1) ) {
			$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
			summary_print_rows ($table, $ui['uname'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['status']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_handler = $result->fields['handler_id'];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
		summary_print_rows ($table, $ui['uname'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}

function summary_reporter ($project_id, &$table) {

	global $opnConfig, $opnTables;

	$where = '';
	if ($project_id) {
		$where = ' WHERE project_id=' . $project_id;
	}
	$query = 'SELECT reporter_id,status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY reporter_id, status';
	$t_last_handler = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields['reporter_id'] != $t_last_handler) && ($t_last_handler != -1) ) {
			$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
			summary_print_rows ($table, $ui['uname'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['status']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_handler = $result->fields['reporter_id'];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		$ui = $opnConfig['permission']->GetUser ($t_last_handler, 'useruid', '');
		summary_print_rows ($table, $ui['uname'], $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}

function summary_category ($project_id, &$table) {

	global $opnConfig, $opnTables, $category, $project;

	$where = '';
	if ($project_id) {
		$where = ' WHERE project_id=' . $project_id;
	}
	$query = 'SELECT category,project_id, status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY category, project_id, status';
	$t_last_category = -1;
	$t_last_project = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields['category'] != $t_last_category) && ($t_last_category != -1) ) {
			if ($t_last_category) {
				$cat = $category->RetrieveSingle ($t_last_category);
			} else {
				$cat['category'] = '&nbsp;';
			}
			if ($project_id) {
				$name = $cat['category'];
			} else {
				$pro = $project->RetrieveSingle ($t_last_project);
				$name = '[' . $pro['project_name'] . '] ' . $cat['category'];
			}
			summary_print_rows ($table, $name, $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['status']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_category = $result->fields['category'];
		$t_last_project = $result->fields['project_id'];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		if ($t_last_category) {
			$cat = $category->RetrieveSingle ($t_last_category);
		} else {
			$cat['category'] = '&nbsp;';
		}
		if ($project_id) {
			$name = $cat['category'];
		} else {
			$pro = $project->RetrieveSingle ($t_last_project);
			$name = '[' . $pro['project_name'] . '] ' . $cat['category'];
		}
		summary_print_rows ($table, $name, $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}

function summary_version ($project_id, &$table) {

	global $opnConfig, $opnTables, $version, $project;

	$where = '';
	if ($project_id) {
		$where = ' WHERE project_id=' . $project_id;
	}
	$query = 'SELECT version,project_id, status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY version, project_id, status';
	$t_last_version = -1;
	$t_last_project = -1;
	$t_bugs_open = 0;
	$t_bugs_resolved = 0;
	$t_bugs_closed = 0;
	$t_bugs_total = 0;
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		if ( ($result->fields['version'] != $t_last_version) && ($t_last_version != -1) ) {
			if ($t_last_version) {
				$ver = $version->RetrieveSingle ($t_last_version);
			} else {
				$ver['version'] = '&nbsp;';
			}
			if ($project_id) {
				$name = $ver['version'];
			} else {
				$pro = $project->RetrieveSingle ($t_last_project);
				$name = '[' . $pro['project_name'] . '] ' . $ver['version'];
			}
			summary_print_rows ($table, $name, $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
			$t_bugs_open = 0;
			$t_bugs_resolved = 0;
			$t_bugs_closed = 0;
			$t_bugs_total = 0;
		}
		$t_bugs_total += $counter;
		switch ($result->fields['status']) {
			case _OPN_BUG_STATUS_RESOLVED:
				$t_bugs_resolved += $counter;
				break;
			case _OPN_BUG_STATUS_CLOSED:
				$t_bugs_closed += $counter;
				break;
			default:
				$t_bugs_open += $counter;
				break;
		}
		$t_last_version = $result->fields['version'];
		$t_last_project = $result->fields['project_id'];
		$result->MoveNext ();
	}
	if (0<$t_bugs_total) {
		if ($t_last_version) {
			$ver = $version->RetrieveSingle ($t_last_version);
		} else {
			$ver['version'] = '&nbsp;';
		}
		if ($project_id) {
			$name = $ver['version'];
		} else {
			$pro = $project->RetrieveSingle ($t_last_project);
			$name = '[' . $pro['project_name'] . '] ' . $ver['version'];
		}
		summary_print_rows ($table, $name, $t_bugs_open, $t_bugs_resolved, $t_bugs_closed, $t_bugs_total);
	}

}
// --------------------
// Print reporter / resolution report

function summary_reporter_resolution ($project_id, &$table) {

	global $opnConfig, $opnTables, $bugvalues;
	// Organise an array of resolution values to be used later
	$c_res_s = array ();
	$help = array_keys ($bugvalues['resolution']);
	foreach ($help as $value) {
		$c_res_s[] = $value;
	}
	$enum_res_count = count ($c_res_s);
	unset ($help);
	// Get all of the bugs and split them up into an array
	$where = '';
	if ($project_id) {
		$where = ' WHERE project_id=' . $project_id;
	}
	$query = 'SELECT reporter_id,resolution, count(bug_id) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY reporter_id, resolution';
	$align = array ('left',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right');
	$t_reporter_res_arr = array ();
	$t_reporter_bugcount_arr = array ();
	$result = $opnConfig['database']->Execute ($query);
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		$reporter = $result->fields['reporter_id'];
		$resolution = $result->fields['resolution'];
		if (!isset ($t_reporter_res_arr[$reporter]) ) {
			$t_reporter_res_arr[$reporter] = array ();
			$t_reporter_bugcount_arr[$reporter] = 0;
		}
		if (!isset ($t_reporter_res_arr[$reporter][$resolution]) ) {
			$t_reporter_res_arr[$reporter][$resolution] = 0;
		}
		$t_reporter_res_arr[$reporter][$resolution] += $counter;
		$t_reporter_bugcount_arr[$reporter] += $counter;
		$result->MoveNext ();
	}
	// Sort our total bug count array so that the reporters with the highest number of bugs are listed first,
	arsort ($t_reporter_bugcount_arr);
	$t_row_count = 0;
	// We now have a multi dimensional array of users and resolutions, with the value of each resolution for each user
	foreach ($t_reporter_bugcount_arr as $t_reporter_id => $t_total_user_bugs) {

		# Limit the number of reporters listed
		if ($t_row_count>$opnConfig['admart']) {
			break;
		}
		$help = array ();
		// Only print reporters who have reported at least one bug. This helps
		// prevent divide by zeroes, showing reporters not on this project, and showing
		// users that aren't actually reporters...
		if ($t_total_user_bugs>0) {
			$t_arr2 = $t_reporter_res_arr[$t_reporter_id];
			$ui = $opnConfig['permission']->GetUser ($t_reporter_id, 'useruid', '');
			$help[] = $ui['uname'];
			// We need to track the percentage of bugs that are considered fix, as well as
			// those that aren't considered bugs to begin with (when looking at %age)
			$t_bugs_fixed = 0;
			$t_bugs_notbugs = 0;
			for ($j = 0; $j< $enum_res_count; $j++) {
				$res_bug_count = 0;
				if (isset ($t_arr2[$c_res_s[$j]]) ) {
					$res_bug_count = $t_arr2[$c_res_s[$j]];
				}
				$help[] = $res_bug_count;
				// These resolutions are considered fixed
				if (_OPN_BUG_RESOLUTION_FIXED == $c_res_s[$j]) {
					$t_bugs_fixed += $res_bug_count;
				} elseif ( (_OPN_BUG_RESOLUTION_UNABLEDUPLICATE == $c_res_s[$j]) || (_OPN_BUG_RESOLUTION_DUPLICATE == $c_res_s[$j]) || (_OPN_BUG_RESOLUTION_NOTBUG == $c_res_s[$j]) ) {
					// These are not counted as bugs
					$t_bugs_notbugs += $res_bug_count;
				}
			}
			$t_percent_errors = 0;
			if ($t_total_user_bugs>0) {
				$t_percent_errors = ($t_bugs_notbugs/ $t_total_user_bugs);
			}
			$help[] = sprintf ('% 1.0f%%', ($t_percent_errors*100) );
			$table->AddDataRow ($help, $align);
		}
	}

}
// --------------------
// Print developer / resolution report

function summary_developer_resolution ($project_id, &$table) {

	global $opnConfig, $opnTables, $bugvalues;
	// Organise an array of resolution values to be used later
	$c_res_s = array ();
	$help = array_keys ($bugvalues['resolution']);
	foreach ($help as $value) {
		$c_res_s[] = $value;
	}
	$enum_res_count = count ($c_res_s);
	unset ($help);
	// Get all of the bugs and split them up into an array
	$where = ' WHERE handler_id>0';
	if ($project_id) {
		$where .= ' AND project_id=' . $project_id;
	}
	$query = 'SELECT handler_id,resolution, count(bug_id) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY handler_id, resolution';
	$align = array ('left',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right',
			'right');
	$result = $opnConfig['database']->Execute ($query);
	$t_handler_res_arr = array ();
	while (! $result->EOF) {
		if (isset ($result->fields['counter']) ) {
			$counter = $result->fields['counter'];
		} else {
			$counter = 0;
		}
		$handler = $result->fields['handler_id'];
		$resolution = $result->fields['resolution'];
		if (!isset ($t_handler_res_arr[$handler]) ) {
			$t_handler_res_arr[$handler] = array ();
			$t_handler_res_arr[$handler]['total'] = 0;
		}
		if (!isset ($t_handler_res_arr[$handler][$resolution]) ) {
			$t_handler_res_arr[$handler][$resolution] = 0;
		}
		$t_handler_res_arr[$handler][$resolution] += $counter;
		$t_handler_res_arr[$handler]['total'] += $counter;
		$result->MoveNext ();
	}

	# We now have a multi dimensional array of users and resolutions, with the value of each resolution for each user

	foreach ($t_handler_res_arr as $t_handler_id => $t_arr2) {
		// Only print developers who have had at least one bug assigned to them. This helps
		// prevent divide by zeroes, showing developers not on this project, and showing
		// users that aren't actually developers...
		$help = array ();
		if ($t_arr2['total']>0) {
			$ui = $opnConfig['permission']->GetUser ($t_handler_id, 'useruid', '');
			$help[] = $ui['uname'];
			// We need to track the percentage of bugs that are considered fix, as well as
			// those that aren't considered bugs to begin with (when looking at %age)
			$t_bugs_fixed = 0;
			$t_bugs_notbugs = 0;
			for ($j = 0; $j< $enum_res_count; $j++) {
				$res_bug_count = 0;
				if (isset ($t_arr2[$c_res_s[$j]]) ) {
					$res_bug_count = $t_arr2[$c_res_s[$j]];
				}
				$help[] = $res_bug_count;

				# These resolutions are considered fixed
				if (_OPN_BUG_RESOLUTION_FIXED == $c_res_s[$j]) {
					$t_bugs_fixed += $res_bug_count;
				} elseif ( (_OPN_BUG_RESOLUTION_WONTFIX == $c_res_s[$j]) || (_OPN_BUG_RESOLUTION_SUSPENDED == $c_res_s[$j]) || (_OPN_BUG_RESOLUTION_DUPLICATE == $c_res_s[$j]) || (_OPN_BUG_RESOLUTION_NOTBUG == $c_res_s[$j]) ) {

					# These are not counted as bugs

					$t_bugs_notbugs += $res_bug_count;
				}
			}
			$t_percent_fixed = 0;
			if ( ($t_arr2['total']-$t_bugs_notbugs)>0) {
				$t_percent_fixed = ($t_bugs_fixed/ ($t_arr2['total']- $t_bugs_notbugs) );
			}
			$help[] = sprintf ('% 1.0f%%', ($t_percent_fixed*100) );
			$table->AddDataRow ($help, $align);
		}
	}

}

function BugTracking_do_reminder () {

	global $opnConfig, $bugs, $bugsmonitoring;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$body = '';
	get_var ('body', $body, 'form', _OOBJ_DTYPE_CHECK);
	$send_to = array ();
	get_var ('send_to', $send_to,'form',_OOBJ_DTYPE_CLEAN);
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$bug = $bugs->RetrieveSingle ($bug_id);
		foreach ($send_to as $value) {
			if ( ($bug['reporter_id'] != $value) && ($bug['handler_id'] != $value) ) {
				set_var ('user_id', $value, 'form');
				$bugsmonitoring->AddRecord ($bug_id);
			}
		}
		BugTracking_email_reminder ($send_to, $body, $bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_Summary_AddHeader (&$table, $what) {

	$table->AddCols (array ('60%', '10%', '10%', '10%', '10%') );
	$table->AddHeaderRow (array ($what, _BUG_RESOLUTION_OPEN, _BUG_STATUS_RESOLVED, _BUG_STATUS_CLOSED, _BUG_TOTAL) );

}

function BugTracking_Summary () {

	global $opnConfig, $bugvalues;

	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = mainheaderbug_tracking (1, 'summary', $sel_project);
	if (!$sel_project) {
		$table = & new opn_TableClass ('alternator');
		BugTracking_Summary_AddHeader ($table, _BUG_BY_PROJECT);
		summary_by_project ($table);
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br />';
	}
	$tablex = & new opn_TableClass ('default');
	$tablex->AddCols (array ('49%', '2%', '49%') );
	$tablex->SetValignTab ('top');
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_CATEGORY);
	summary_category ($sel_project, $table);
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_VERSION);
	summary_version ($sel_project, $table);
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$tablex->AddDataRow (array ($hlp1, '&nbsp;', $hlp2) );
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_STATUS);
	summary_by ($sel_project, 'status', $table);
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_SEVERITY);
	summary_by ($sel_project, 'severity', $table);
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$tablex->AddDataRow (array ('&nbsp;', '&nbsp;', '&nbsp;') );
	$tablex->AddDataRow (array ($hlp1, '&nbsp;', $hlp2) );
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_RESOLUTION);
	summary_by ($sel_project, 'resolution', $table);
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_PRIORITY);
	summary_by ($sel_project, 'priority', $table);
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$tablex->AddDataRow (array ('&nbsp;', '&nbsp;', '&nbsp;') );
	$tablex->AddDataRow (array ($hlp1, '&nbsp;', $hlp2) );
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_REPRODUCIBILITY);
	summary_by ($sel_project, 'reproducibility', $table);
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_PROJECTION);
	summary_by ($sel_project, 'projection', $table);
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$tablex->AddDataRow (array ('&nbsp;', '&nbsp;', '&nbsp;') );
	$tablex->AddDataRow (array ($hlp1, '&nbsp;', $hlp2) );
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_ETA);
	summary_by ($sel_project, 'eta', $table);
	$hlp1 = '';
	$table->GetTable ($hlp1);
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_DEVELOPER);
	summary_developer ($sel_project, $table);
	$hlp2 = '';
	$table->GetTable ($hlp2);
	$tablex->AddDataRow (array ('&nbsp;', '&nbsp;', '&nbsp;') );
	$tablex->AddDataRow (array ($hlp1, '&nbsp;', $hlp2) );
	$tablex->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	BugTracking_Summary_AddHeader ($table, _BUG_BY_REPORTER);
	summary_reporter ($sel_project, $table);
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	$help = array ();
	$help[] = _BUG_BY_REPORTER_RESOLUTION;
	foreach ($bugvalues['resolution'] as $value) {
		$help[] = $value;
	}
	$help[] = _BUG_PERCENT_WRONG;
	$table->AddHeaderRow ($help);
	summary_reporter_resolution ($sel_project, $table);
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	$help = array ();
	$help[] = _BUG_BY_DEVELOPER_RESOLUTION;
	foreach ($bugvalues['resolution'] as $value) {
		$help[] = $value;
	}
	$help[] = _BUG_PERCENT_FIXED;
	$table->AddHeaderRow ($help);
	summary_developer_resolution ($sel_project, $table);
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_60_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_BUG_SUMMARY, $boxtxt);

}

?>