<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_ATTACHMENTS_INCLUDED') ) {
	define ('_OPN_BUGS_ATTACHMENTS_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/include/language/');

	class BugsAttachments extends AbstractBugs {
		var $_bug = 0;
		var $_orderby = '';

		function BugsAttachments () {

			$this->_fieldname = 'attachment_id';
			$this->_tablename = 'bugs_attachments';
			$this->_orderby = ' ORDER BY date_added DESC';

		}

		function SetBug ($bug) {

			$this->_bug = $bug;

		}

		function SetOrderby ($orderby) {

			$this->_orderby = $orderby;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT attachment_id, bug_id, filename, filesize, description, date_added FROM ' . $opnTables['bugs_attachments'] . $where . ' ORDER BY attachment_id');
			while (! $result->EOF) {
				$id = $result->fields['attachment_id'];
				$this->_cache[$id]['attachment_id'] = $result->fields['atatchment_id'];
				$this->_cache[$id]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$id]['filename'] = $result->fields['filename'];
				$this->_cache[$id]['filesize'] = $result->fields['filesize'];
				$this->_cache[$id]['description'] = $result->fields['description'];
				$this->_cache[$id]['date_added'] = $result->fields['date_added'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE attachment_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT attachment_id, bug_id, filename, filesize, description, date_added FROM ' . $opnTables['bugs_attachments'] . $where);
				$this->_cache[$id]['attachment_id'] = $result->fields['attachment_id'];
				$this->_cache[$id]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$id]['filename'] = $result->fields['filename'];
				$this->_cache[$id]['filesize'] = $result->fields['filesize'];
				$this->_cache[$id]['description'] = $result->fields['description'];
				$this->_cache[$id]['date_added'] = $result->fields['date_added'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$bug_id = func_get_arg (0);
			$description = '';
			get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
			$attach = array ();
			$this->check_upload ($attach);
			if ($attach['name'] != '') {
				$attachment_id = $opnConfig['opnSQL']->get_new_number ('bugs_attachments', 'attachment_id');
				$filename = $attach['name'];
				$filesize = $attach['size'];
				if ($this->do_upload ($attach, $attachment_id) ) {
					$opnConfig['opndate']->now ();
					$time = '';
					$opnConfig['opndate']->opnDataTosql ($time);
					$this->_cache[$attachment_id]['attachment_id'] = $attachment_id;
					$this->_cache[$attachment_id]['bug_id'] = $bug_id;
					$this->_cache[$attachment_id]['filename'] = $filename;
					$this->_cache[$attachment_id]['filesize'] = $filesize;
					$this->_cache[$attachment_id]['description'] = $description;
					$this->_cache[$attachment_id]['date_added'] = $time;
					$description = $opnConfig['opnSQL']->qstr ($description);
					$filename = $opnConfig['opnSQL']->qstr ($filename);
					$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs_attachments'] . "(attachment_id, bug_id,filename,filesize,description,date_added) VALUES ($attachment_id,$bug_id,$filename,$filesize,$description,$time)");
					return $attachment_id;
				}
				return 0;
			}
			return 0;

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$attachment_id = func_get_arg (0);
			unset ($this->_cache[$attachment_id]);
			$result = $opnConfig['database']->Execute ('SELECT filename FROM ' . $opnTables['bugs_attachments'] . ' WHERE attachment_id=' . $attachment_id);
			$filename = $result->fields['filename'];
			$result->Close ();
			$this->DeleteFile ($attachment_id, $filename);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_attachments'] . ' WHERE attachment_id=' . $attachment_id);

		}

		function getAttachmentFilename ($filename, $attachment_id, $new = false, $url = false) {

			global $opnConfig;
			// Remove special accented characters - ie. s.
			$clean_name = strtr ($filename, '', 'SZszYAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy');
			$clean_name = strtr ($clean_name, array ('' => 'TH',
								'' => 'th',
								'' => 'DH',
								'' => 'dh',
								'' => 'ss',
								'' => 'OE',
								'' => 'oe',
								'' => 'AE',
								'' => 'ae',
								'' => 'u') );
			// Sorry, no spaces, dots, or anything else but letters allowed.
			$clean_name = preg_replace (array ('/\s/',
							'/[^\w_\.\-]/'),
							array ('_',
				''),
				$clean_name);
			$clean_name = str_replace ('%20', '_', $clean_name);
			$enc_name = $attachment_id . '_' . str_replace ('.', '_', $clean_name) . md5 ($clean_name);
			if ($attachment_id == false) {
				return $clean_name;
			}
			if ($new) {
				return $enc_name;
			}
			if (!$url) {
				$dir = $opnConfig['datasave']['bug_attachment']['path'];
			} else {
				$dir = $opnConfig['datasave']['bug_attachment']['url'] . '/';
			}
			$filename = $dir . $enc_name;
			return $filename;

		}

		function DeleteFile ($attachment_id, $filename) {

			$filename = $this->getAttachmentFilename ($filename, $attachment_id);
			$file = & new opnFile ();
			$file->delete_File ($filename);
			if ($file->ERROR != '') {
				echo $file->ERROR . '<br />';
			}

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$this->SetBug ($bug_id);
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT attachment_id, filename FROM ' . $opnTables['bugs_attachments'] . $where);
			while (! $result->EOF) {
				$attachment_id = $result->fields['attachment_id'];
				$filename = $result->fields['filename'];
				$this->DeleteFile ($attachment_id, $filename);
				$result->MoveNext ();
			}
			$result->Close ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_attachments'] . $where);
			$this->SetBug (0);

		}

		function AddHistory ($bug_id, $filename) {

			global $opnConfig;

			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugshistory.php');
			$bugs = & new Bugs ();
			$bugshistory = & new BugsHistory ();
			set_var ('user_id', $opnConfig['permission']->Userinfo ('uid'), 'form');
			set_var ('field_name', '', 'form');
			set_var ('old_value', $filename, 'form');
			set_var ('new_value', '', 'form');
			set_var ('wtype', _OPN_HISTORY_FILE_DELETED, 'form');
			$bugshistory->AddRecord ($bug_id);
			$bugs->ModifyDate ($bug_id);
			set_var ('user_id', 0, 'form');
			set_var ('field_name', '', 'form');
			set_var ('old_value', '', 'form');
			set_var ('new_value', '', 'form');
			set_var ('wtype', '', 'form');

		}

		function DeleteBySize ($size) {

			global $opnConfig, $opnTables;

			$size1 = $size*1024;
			$result = $opnConfig['database']->Execute ('SELECT attachment_id, bug_id, filename FROM ' . $opnTables['bugs_attachments'] . ' WHERE filesize>' . $size1);
			while (! $result->EOF) {
				$attachment_id = $result->fields['attachment_id'];
				$filename = $result->fields['filename'];
				$bug_id = $result->fields['bug_id'];
				$this->AddHistory ($bug_id, $filename);
				$this->DeleteFile ($attachment_id, $filename);
				$result->MoveNext ();
			}
			$result->Close ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_attachments'] . ' WHERE filesize>' . $size1);

		}

		function DeleteByDate ($days) {

			global $opnConfig, $opnTables;
			if ($days>0) {
				$opnConfig['opndate']->now ();
				$opnConfig['opndate']->subInterval ($days . ' DAYS');
				$time = '';
				$opnConfig['opndate']->opnDataTosql ($time);
				$result = $opnConfig['database']->Execute ('SELECT attachment_id, bug_id, filename FROM ' . $opnTables['bugs_attachments'] . ' WHERE date_added<' . $time);
				while (! $result->EOF) {
					$attachment_id = $result->fields['attachment_id'];
					$filename = $result->fields['filename'];
					$filename = $result->fields['filename'];
					$bug_id = $result->fields['bug_id'];
					$this->AddHistory ($bug_id, $filename);
					$this->DeleteFile ($attachment_id, $filename);
					$result->MoveNext ();
				}
				$result->Close ();
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_attachments'] . ' WHERE date_added<' . $time);
			}

		}

		function DeleteByIds ($idarray) {

			global $opnConfig, $opnTables;
			if (count ($idarray) ) {
				$result = $opnConfig['database']->Execute ('SELECT attachment_id, bug_id, filename FROM ' . $opnTables['bugs_attachments'] . ' WHERE attachment_id IN (' . implode (',', $idarray) . ')');
				while (! $result->EOF) {
					$attachment_id = $result->fields['attachment_id'];
					$filename = $result->fields['filename'];
					$filename = $result->fields['filename'];
					$bug_id = $result->fields['bug_id'];
					$this->AddHistory ($bug_id, $filename);
					$this->DeleteFile ($attachment_id, $filename);
					$result->MoveNext ();
				}
				$result->Close ();
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_attachments'] . ' WHERE attachment_id IN (' . implode (',', $idarray) . ')');
			}

		}

		/**
		* @return object
		*/

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT attachment_id, bug_id, filename, filesize, description, date_added FROM ' . $opnTables['bugs_attachments'] . $where . $this->_orderby, $limit, $offset);
			return $result;

		}

		function loadAttachmentContext () {

			global $opnConfig, $opnTables;

			$attachmentData = array ();
			$where = $this->BuildWhere ();
			$sql = 'SELECT attachment_id, filename, filesize, description, date_added FROM ' . $opnTables['bugs_attachments'] . $where;
			$attachments = $opnConfig['database']->GetAll ($sql);
			$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/viewattachment.php';
			$url['action'] = 'dlattach';
			if (count ($attachments) ) {
				foreach ($attachments as $i => $attachment) {
					$url['id'] = $attachment['attachment_id'];
					$opnConfig['opndate']->sqlToopnData ($attachment['date_added']);
					$time = '';
					$opnConfig['opndate']->formatTimestamp ($time, _DATE_FORUMDATESTRING2);
					$ext = (strstr ($attachment['filename'], '.')?strtolower (substr (strrchr ($attachment['filename'], '.'), 1) ) : '');
					if (isset ($opnConfig['bug_tracking_file_types'][$ext]) ) {
						$icon = $opnConfig['bug_tracking_file_types'][$ext];
					} else {
						$icon = $opnConfig['bug_tracking_file_types']['?'];
					}
					$icon = '<a class="opncenterbox" href="' . encodeurl ($url) . '"><img src="' . $opnConfig['opn_default_images'] . 'files/' . $icon . '" align="middle" alt="" /></a>';
					$attachmentData[$i] = array ('id' => $attachment['attachment_id'],
								'name' => $attachment['filename'],
								'description' => $attachment['description'],
								'icon' => $icon,
								'date' => $time,
								'size' => round ($attachment['filesize']/1024,
								2) . ' ' . _BUG_INC_ATTACHMENT_KB,
								'byte_size' => $attachment['filesize'],
								'href' => encodeurl ($url),
								'link' => '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . $attachment['filename'] . '</a>',
								'is_image' => false);
					if (empty ($opnConfig['attachmentshowimages']) ) {
						continue;
					}
					// Set up the image attachment info.
					$filename = $this->getAttachmentFilename ($attachment['filename'], $attachment['attachment_id']);
					$imageTypes = array ('gif' => 1,
							'jpeg' => 2,
							'png' => 3,
							'bmp' => 6);
					if (file_exists ($filename) && filesize ($filename)>0) {
						list ($width, $height, $imageType) = @getimagesize ($filename);
					} else {
						$imageType = 0;
						$attachmentData[$i]['size'] = '0 ' . _BUG_INC_ATTACHMENT_KB;
					}
					// If this isn't an image, we're done.
					if (!in_array ($imageType, $imageTypes) ) {
						continue;
					}
					$attachmentData[$i]['width'] = $width;
					$attachmentData[$i]['height'] = $height;
					$imagefilename = $this->getAttachmentFilename ($attachment['filename'], $attachment['attachment_id'], false, true);
					if ( ( ($opnConfig['maxwidth']) && ($opnConfig['maxheight']) ) && ($width>$opnConfig['maxwidth'] || $height>$opnConfig['maxheight']) ) {
						if ($width>$opnConfig['maxwidth'] && ($opnConfig['maxwidth']) ) {
							$height = floor ($opnConfig['maxwidth']/ $width* $height);
							$width = $opnConfig['maxwidth'];
							if ($height>$opnConfig['maxheight'] && ($opnConfig['maxheight']) ) {
								$width = floor ($opnConfig['maxheight']/ $height* $width);
								$height = $opnConfig['maxheight'];
							}
						} elseif ($height> $opnConfig['maxheight'] && ($opnConfig['maxheight']) ) {
							$width = floor ($opnConfig['maxheight']/ $height* $width);
							$height = $opnConfig['maxheight'];
						}
						$attachmentData[$i]['image'] = '<img src="' . $imagefilename . '" alt="" width="' . $width . '" height="' . $height . '" />';
					} else {
						$attachmentData[$i]['image'] = '<img src="' . $imagefilename . '" alt="" />';
					}
					$attachmentData[$i]['is_image'] = true;
				}
			}
			return $attachmentData;

		}

		function setErrorCodes (&$eh) {

			$eh->SetErrorMsg ('_BUG_INC_ERROR_BUG_ATTACHMENT_0001', _BUG_INC_ERROR_BUG_ATTACHMENT_0001);
			$eh->SetErrorMsg ('_BUG_INC_ERROR_BUG_ATTACHMENT_0003', _BUG_INC_ERROR_BUG_ATTACHMENT_0003);

		}

		function check_upload (&$attach) {

			global $opnConfig, $opnTables;

			$eh = & new opn_errorhandler;
			// opn_errorhandler object
			$this->setErrorCodes ($eh);
			$attachment = array ();
			get_var ('file', $attachment,'file');
			if ($attachment['name'] != '') {
				$result = $opnConfig['database']->Execute ('SELECT sum(filesize) AS summe FROM ' . $opnTables['bugs_attachments']);
				if ( ($result !== false) && (isset ($result->fields['summe']) ) ) {
					$size = $result->fields['summe'];
				} else {
					$size = 0;
				}
				if (!is_uploaded_file ($attachment['tmp_name']) ) {
					$eh->show ('_BUG_INC_ERROR_BUG_ATTACHMENT_0003');
				}
				$attachment['name'] = $this->getAttachmentFilename ($attachment['name'], false, true);
				// Is the file too big?
				if ($attachment['size']>$opnConfig['attachmentsizelimit']*1024) {
					$eh->show (sprintf (_BUG_INC_ERROR_BUG_ATTACHMENT_0004, $opnConfig['attachmentsizelimit']) );
				}
				$ext = (strstr ($attachment['name'], '.')?strtolower (substr (strrchr ($attachment['name'], '.'), 1) ) : '');
				if (!in_array ($ext, explode (',', strtolower ($opnConfig['attachmentextensions']) ) ) ) {
					$eh->show (sprintf (_BUG_INC_ERROR_BUG_ATTACHMENT_0002, $opnConfig['attachmentextensions']) );
				}
				// Too big!  Maybe you could zip it or something...
				if ($attachment['size']+$size>$opnConfig['attachemntdirsizelim']*1024) {
					$eh->show ('_BUG_INC_ERROR_BUG_ATTACHMENT_0001');
				}
				$destName = basename ($attachment['name']);
				$disabledFiles = array ('con',
							'com1',
							'com2',
							'com3',
							'com4',
							'prn',
							'aux',
							'lpt1',
							'.htaccess',
							'index.php',
							'index.html');
				if (in_array (strtolower ($destName), $disabledFiles) ) {
					$eh->show (sprintf (_BUG_INC_ERROR_BUG_ATTACHMENT_0005, $destName) );
				}
			}
			$attach = $attachment;

		}

		function do_upload ($attach, $attach_id) {

			global $opnConfig, $opnTables;

			require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
			$attach['name'] = $this->getAttachmentFilename ($attach['name'], $attach_id, true);
			set_var ('userupload', $attach, 'file');
			$upload = & new file_upload_class;
			if ($upload->upload ('userupload', '', '') ) {
				if ($upload->save_file ($opnConfig['datasave']['bug_attachment']['path'], 3, false, true) ) {
					$upload->new_file;
					$filename = $upload->file['name'];
				}
			}
			$uploaded = true;
			if (count ($upload->errors) ) {
				$hlp = '';
				$uploaded = false;
				foreach ($upload->errors as $var) {
					$hlp .= '<br /><br />' . $var . '<br />';
				}
				$eh = & new opn_errorhandler;
				$eh->show ($hlp);
			}
			unset ($upload);
			return $uploaded;

		}

		function BuildWhere () {

			global $opnConfig;

			$help = '';
			if ($this->_bug) {
				$this->_isAnd ($help);
				$help .= ' bug_id=' . $this->_bug;
			}
			if ($help != '') {
				return ' WHERE ' . $help;
			}
			return '';

		}

	}
}

?>