<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_NOTES_INCLUDED') ) {
	define ('_OPN_BUGS_NOTES_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/include/language/');

	class BugsNotes extends AbstractBugs {
		var $_bug = 0;
		var $_project = 0;

		function BugsNotes () {

			$this->_fieldname = 'note_id';
			$this->_tablename = 'bugs_notes';

		}

		function SetBug ($bug) {

			$this->_bug = $bug;

		}

		function SetProject ($project) {

			$this->_project = $project;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT note_id, bug_id, reporter_id, view_state, date_submitted, date_updated,note FROM ' . $opnTables['bugs_notes'] . $where . ' ORDER BY note_id');
			while (! $result->EOF) {
				$id = $result->fields['note_id'];
				$this->_cache[$id]['note_id'] = $result->fields['note_id'];
				$this->_cache[$id]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$id]['reporter_id'] = $result->fields['reporter_id'];
				$this->_cache[$id]['view_state'] = $result->fields['view_state'];
				$this->_cache[$id]['date_submitted'] = $result->fields['date_submitted'];
				$this->_cache[$id]['date_updated'] = $result->fields['date_updated'];
				$this->_cache[$id]['note'] = $result->fields['note'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE note_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT note_id, bug_id, reporter_id, view_state, date_submitted, date_updated,note FROM ' . $opnTables['bugs_notes'] . $where);
				$this->_cache[$id]['note_id'] = $result->fields['note_id'];
				$this->_cache[$id]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$id]['reporter_id'] = $result->fields['reporter_id'];
				$this->_cache[$id]['view_state'] = $result->fields['view_state'];
				$this->_cache[$id]['date_submitted'] = $result->fields['date_submitted'];
				$this->_cache[$id]['date_updated'] = $result->fields['date_updated'];
				$this->_cache[$id]['note'] = $result->fields['note'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$bug_id = func_get_arg (0);
			$reporter_id = 0;
			get_var ('reporter_id', $reporter_id, 'form', _OOBJ_DTYPE_INT);
			$view_state = _OPN_BUG_STATE_PUBLIC;
			get_var ('view_state', $view_state, 'form', _OOBJ_DTYPE_INT);
			$note = '';
			get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
			$note_id = $opnConfig['opnSQL']->get_new_number ('bugs_notes', 'note_id');
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$this->_cache[$note_id]['note_id'] = $note_id;
			$this->_cache[$note_id]['bug_id'] = $bug_id;
			$this->_cache[$note_id]['reporter_id'] = $reporter_id;
			$this->_cache[$note_id]['view_state'] = $view_state;
			$this->_cache[$note_id]['date_submitted'] = $time;
			$this->_cache[$note_id]['date_updated'] = $time;
			$this->_cache[$note_id]['note'] = $note;
			$note = $opnConfig['opnSQL']->qstr ($note, 'note');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs_notes'] . "(note_id, bug_id,reporter_id,view_state,date_submitted,date_updated,note) VALUES ($note_id,$bug_id,$reporter_id,$view_state,$time,$time,$note)");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bugs_notes'], 'note_id=' . $note_id);
			return $note_id;

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$note_id = 0;
			get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
			$view_state = 0;
			get_var ('view_state', $view_state, 'both', _OOBJ_DTYPE_INT);
			$note = '';
			get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$this->_cache[$note_id]['note_id'] = $note_id;
			$this->_cache[$note_id]['view_state'] = $view_state;
			$this->_cache[$note_id]['date_updated'] = $time;
			$time2 = '';
			$opnConfig['opndate']->formatTimestamp ($time2, _DATE_DATESTRING5);
			$note .= _OPN_HTML_NL . _OPN_HTML_NL . sprintf (_BUG_INC_EDITED_AT, $time2);
			$this->_cache[$note_id]['note'] = $note;
			$where = ' WHERE note_id=' . $note_id;
			$note = $opnConfig['opnSQL']->qstr ($note, 'note');
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs_notes'] . " SET note=$note,view_state=$view_state, date_updated=$time" . $where);
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bugs_notes'], 'note_id=' . $note_id);

		}

		function ModifyState () {

			global $opnConfig, $opnTables;

			$note_id = 0;
			get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
			$view_state = 0;
			get_var ('view_state', $view_state, 'both', _OOBJ_DTYPE_INT);
			$this->_cache[$note_id]['note_id'] = $note_id;
			$this->_cache[$note_id]['view_state'] = $view_state;
			$where = ' WHERE note_id=' . $note_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs_notes'] . " SET view_state=$view_state" . $where);

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$note_id = 0;
			get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$note_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_notes'] . ' WHERE note_id=' . $note_id);

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$this->SetBug ($bug_id);
			$where = $this->BuildWhere ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_notes'] . $where);
			$this->SetBug (0);

		}

		function CheckAdmin () {

			global $opnConfig;

			include_once (_OPN_ROOT_PATH . 'modules/project/include/class.user.php');
			$admins = & new ProjectUser ();
			if ($this->_project) {
				$admins->SetProject ($this->_project);
			}
			if ($admins->GetCount ($opnConfig['permission']->UserInfo ('uid') ) ) {
				return true;
			}
			return false;

		}

		function BuildWhere () {

			global $opnConfig;

			$help = '';
			if ( (!$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN), true) ) && (!$this->CheckAdmin () ) ) {
				$help .= ' ( (view_state=' . _OPN_BUG_STATE_PUBLIC . ')';
				if ($opnConfig['permission']->IsUser () ) {
					$help .= ' OR ((view_state=' . _OPN_BUG_STATE_PRIVATE . ') AND (reporter_id=' . $opnConfig['permission']->UserInfo ('uid') . '))';
				}
				$help .= ' )';
			}
			if ($this->_bug) {
				$this->_isAnd ($help);
				$help .= ' bug_id=' . $this->_bug;
			}
			if ($help != '') {
				return ' WHERE ' . $help;
			}
			return '';

		}

	}
}

?>