<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_RELATION_INCLUDED') ) {
	define ('_OPN_BUGS_RELATION_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');

	class BugsRelation extends AbstractBugs {
		var $_source_bug = 0;
		var $_destination_bug = 0;

		function BugsRelation () {

			$this->_fieldname = 'relation_id';
			$this->_tablename = 'bugs_relation';

		}

		function SetBug ($bug) {

			$this->_source_bug = $bug;
			$this->_destination_bug = $bug;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT relation_id, source_bug_id, destination_bug_id, relation_type FROM ' . $opnTables['bugs_relation'] . $where . ' ORDER BY relation_id');
			while (! $result->EOF) {
				$id = $result->fields['relation_id'];
				$this->_cache[$id]['relation_id'] = $result->fields['relation_id'];
				$this->_cache[$id]['source_bug_id'] = $result->fields['source_bug_id'];
				$this->_cache[$id]['destination_bug_id'] = $result->fields['destination_bug_id'];
				if ($result->fields['relation_type']) {
					$this->_cache[$id]['relation_type'] = $result->fields['relation_type'];
				} else {
					$this->_cache[$id]['relation_type'] = 0;
				}
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE relation_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT relation_id, source_bug_id, destination_bug_id, relation_type FROM ' . $opnTables['bugs_relation'] . $where);
				$this->_cache[$id]['relation_id'] = $result->fields['relation_id'];
				$this->_cache[$id]['source_bug_id'] = $result->fields['source_bug_id'];
				$this->_cache[$id]['destination_bug_id'] = $result->fields['destination_bug_id'];
				$this->_cache[$id]['relation_type'] = $result->fields['relation_type'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$source_id = 0;
			get_var ('source_id', $source_id, 'form', _OOBJ_DTYPE_INT);
			$destination_id = 0;
			get_var ('destination_id', $destination_id, 'form', _OOBJ_DTYPE_INT);
			$relation = 0;
			get_var ('relation', $relation, 'form', _OOBJ_DTYPE_INT);
			$source = $source_id;
			$destination = $destination_id;
			switch ($relation) {
				case _OPN_BUG_RELATION_DEPENDANT_OF:
					$source = $destination_id;
					$destination = $source_id;
					break;
				case _OPN_BUG_RELATION_HAS_DUPLICATE:
					$source = $destination_id;
					$destination = $source_id;
					break;
			}
			// switch
			$relation_id = $opnConfig['opnSQL']->get_new_number ('bugs_relation', 'relation_id');
			$this->_cache[$relation_id]['relation_id'] = $relation_id;
			$this->_cache[$relation_id]['source_bug_id'] = $source;
			$this->_cache[$relation_id]['destination_bug_id'] = $destination;
			$this->_cache[$relation_id]['relation_type'] = $relation;
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs_relation'] . "(relation_id, source_bug_id,destination_bug_id,relation_type) VALUES ($relation_id,$source,$destination,$relation)");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$relation_id = func_get_arg (0);
			unset ($this->_cache[$relation_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_relation'] . ' WHERE relation_id=' . $relation_id);

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$this->SetBug ($bug_id);
			$where = $this->BuildWhere ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_relation'] . $where);
			$this->SetBug (0);

		}

		function BuildWhere () {

			$help = '';
			if ($this->_source_bug) {
				$this->_isOr ($help);
				$help .= ' source_bug_id=' . $this->_source_bug;
			}
			if ($this->_destination_bug) {
				$this->_isOr ($help);
				$help .= ' destination_bug_id=' . $this->_destination_bug;
			}
			if ($help != '') {
				return ' WHERE ' . $help;
			}
			return '';

		}

	}
}

?>