<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../../mainfile.php');
}
global $opnConfig, $opnTables;

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/include/graphics/language/');
$opnConfig['module']->InitModule ('modules/bug_tracking');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/bugs.constants.php');
if (!isset ($opnConfig['ttffont']) ) {
	$opnConfig['ttffont'] = 'NONE';
}
if (!isset ($opnConfig['xres']) ) {
	$opnConfig['xres'] = 800;
}
if (!isset ($opnConfig['yres']) ) {
	$opnConfig['yres'] = 600;
}
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.category.php');
$project = & new Project ();
$category = & new ProjectCategory ();
$project_id = 0;
get_var ('project_id', $project_id, 'url', _OOBJ_DTYPE_INT);
$where = '';
if ($project_id) {
	$where = ' WHERE project_id=' . $project_id;
}
$query = 'SELECT category,project_id, status, count(bug_ID) as counter FROM ' . $opnTables['bugs'] . $where . ' GROUP BY category, project_id, status';
$t_last_value = -1;
$t_last_project = -1;
$t_bugs_open = 0;
$t_bugs_resolved = 0;
$t_bugs_closed = 0;
$t_bugs_total = 0;
$result = $opnConfig['database']->Execute ($query);
$data = array ();
while (! $result->EOF) {
	if (isset ($result->fields['counter']) ) {
		$counter = $result->fields['counter'];
	} else {
		$counter = 0;
	}
	if ( ($result->fields['category'] != $t_last_value) && ($t_last_value != -1) ) {
		if ($t_last_value) {
			$cat = $category->RetrieveSingle ($t_last_value);
		} else {
			$cat['category'] = '';
		}
		if ($project_id) {
			$name = $cat['category'];
		} else {
			$pro = $project->RetrieveSingle ($t_last_project);
			$name = '[' . $pro['project_name'] . '] ' . $cat['category'];
		}
		$data[] = array ($name,
				$t_bugs_open,
				$t_bugs_resolved,
				$t_bugs_closed);
		$t_bugs_open = 0;
		$t_bugs_resolved = 0;
		$t_bugs_closed = 0;
		$t_bugs_total = 0;
	}
	$t_bugs_total += $counter;
	switch ($result->fields['status']) {
		case _OPN_BUG_STATUS_RESOLVED:
			$t_bugs_resolved += $counter;
			break;
		case _OPN_BUG_STATUS_CLOSED:
			$t_bugs_closed += $counter;
			break;
		default:
			$t_bugs_open += $counter;
			break;
	}
	$t_last_value = $result->fields['category'];
	$t_last_project = $result->fields['project_id'];
	$result->MoveNext ();
}
if (0<$t_bugs_total) {
	if ($t_last_value) {
		$cat = $category->RetrieveSingle ($t_last_value);
	} else {
		$cat['category'] = '';
	}
	if ($project_id) {
		$name = $cat['category'];
	} else {
		$pro = $project->RetrieveSingle ($t_last_project);
		$name = '[' . $pro['project_name'] . '] ' . $cat['category'];
	}
	$data[] = array ($name,
			$t_bugs_open,
			$t_bugs_resolved,
			$t_bugs_closed);
}
$keys = array_keys ($data);
foreach ($keys as $value) {
	$max = count ($data[$value]);
	for ($i = 1; $i< $max; $i++) {
		if ($data[$value][$i] == 0) {
			$data[$value][$i] = '';
		}
	}
}
if (count ($data) ) {
	$legend = array ();
	$legend[] = _BUG_GRAPH_RESOLUTION_OPEN;
	$legend[] = _BUG_GRAPH_STATUS_RESOLVED;
	$legend[] = _BUG_GRAPH_STATUS_CLOSED;
	include_once (_OPN_ROOT_PATH . 'modules/phplot/class/phplot.php');
	$graph = & new PHPlot ($opnConfig['xres'], $opnConfig['yres']);
	$graph->SetDataType ('text-data');
	$graph->SetDataValues ($data);
	$graph->SetFileFormat ('jpg');
	$graph->SetYLabelType ('data');
	$graph->SetDrawXGrid (TRUE);
	$graph->SetDrawYGrid (TRUE);
	$graph->SetXTickIncrement (1);
	$graph->SetXTickLength (5);
	$graph->SetXTickCrossing (3);
	$graph->SetXTickPos ('plotdown');
	$graph->SetXTickLabelPos ('plotdown');
	$graph->SetXDataLabelPos ('plotdown');
	$graph->SetDrawDashedGrid (1);
	$graph->SetPrecisionY (0);
	$graph->SetTitle (_BUG_GRAPH_BY_CATEGORY_STATUS);
	$graph->SetRGBArray ('small');
	$graph->SetDataColors (array ('yellow',
					'blue',
					'red',
					'green'),
					array ('black') );
	$graph->SetLegend ($legend);
	$graph->SetXTitle ('');
	$graph->SetYTitle ('');
	$graph->SetPlotType ('stackedbars');
	$graph->SetBrowserCache (true);
	$graph->SetMarginsPixels (50, 50, 50, 150);
	$graph->SetPlotAreaWorld ();
	$graph->SetPlotAreaPixels ();
	$graph->SetXLabelAngle (90);
	if ($opnConfig['ttffont'] != 'NONE') {
		$graph->SetUseTTF (true);
		$graph->SetDefaultTTFont ($opnConfig['ttffont']);
	}
	$graph->SetLineWidth (1);
	$graph->DrawGraph ();
	$graph->PrintImage ();
}

?>