<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/calendar', true);
define ('_CALENDARADM_CALVERSION', '1.1.1 (16)');
getLanguageDef (_OPN_ROOT_PATH . 'modules/calendar/admin/language/');

function themepreview ($title, $hometext, $bodytext = '', $notes = '') {
	return '<p><span class="normaltextbold">' . $title . '</span><br />' . $hometext . ' ' . $bodytext . ' ' . $notes . '</p>' . _OPN_HTML_NL;

}

function buildMonthSelectCAL () {

	$options = array ();
	for ($i = 1; $i<=12; $i++) {
		$month = sprintf ('%02d', $i);
		$options[$month] = $month;
	}
	return $options;

}

function buildDaySelectCAL () {

	$options = array ();
	for ($i = 1; $i<=31; $i++) {
		$day = sprintf ('%02d', $i);
		$options[$day] = $day;
	}
	return $options;

}

function buildYearSelectCAL () {

	$options = array ();
	for ($i = 2001; $i<=2030; $i++) {
		$options[$i] = $i;
	}
	return $options;

}

function buildHourSelectCAL () {

	$options = array ();
	for ($i = 0; $i<=23; $i++) {
		if ($i<10) {
			$i1 = '0' . $i;
		} else {
			$i1 = $i;
		}
		$options[$i] = $i1;
	}
	return $options;

}

function buildMinSelectCAL () {

	$options = array ();
	for ($i = 0; $i<=45; ) {
		if ($i == 0) {
			$i1 = ':00';
		} else {
			$i1 = ':' . $i;
		}
		$options[$i] = $i1;
		$i = $i+15;
	}
	return $options;

}

function CalendarDeleteStory () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['calendar_events_queue'] . ' WHERE qid=' . $qid);
		if ($opnConfig['database']->ErrorNo ()>0) {
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_10_';
			$_display_dat['module'] = 'modules/calendar';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent ('', $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />');
			return;
		}
		CalendarSubmissions ();
	} else {
		$txt = '<div class="centertag"><span class="normaltextbold">';
		$txt .= _CALENDARADM_CALREMOVETEST . $qid;
		$txt .= '</span><br /><br /><a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php') . '">' . _NO . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php',
																														'op' => 'CalendarDeleteStory',
																														'qid' => $qid,
																														'ok' => '1') ) . '">' . _YES . '</a></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_20_';
		$_display_dat['module'] = 'modules/calendar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_CALENDARADM_CALDELETESTORY, $txt);
	}

}

function printJavaScript () {

	$catemp = "<script type='text/javascript'>
		function verify() {
			var msg = '" . _CALENDARADM_CALVALIDERRORMSG . "\\n__________________________________________________\\n\\n';
			var errors = 'FALSE';
			var starthour;
			var endhour;
			var startampm;
			var endampm;
			eventDate = new Date(document.calendar.month.options[document.calendar.month.selectedIndex].value +'/'+ document.calendar.day.options[document.calendar.day.selectedIndex].value+'/'+document.calendar.year.options[document.calendar.year.selectedIndex].value);
			endDate = new Date(document.calendar.endmonth.options[document.calendar.endmonth.selectedIndex].value + '/' + document.calendar.endday.options[document.calendar.endday.selectedIndex].value + '/' + document.calendar.endyear.options[document.calendar.endyear.selectedIndex].value);

			if (document.calendar.subject.value == '') {
				errors = 'TRUE';
				msg += '" . _CALENDARADM_CALVALIDSUBJECT . "\\n';
			}
			if (eventDate.getMonth()+1 != document.calendar.month.options[document.calendar.month.selectedIndex].value) {
				errors = 'TRUE';
				msg += '** " . _CALENDARADM_CALVALIDEVENTDATE . "\\n';
			}
			if (endDate.getMonth()+1 != document.calendar.endmonth.options[document.calendar.endmonth.selectedIndex].value) {
				errors = 'TRUE';
				msg += '** " . _CALENDARADM_CALVALIDENDDATE . "\\n';
			}
			if (endDate.getTime() < eventDate.getTime()) {
				errors = 'TRUE';
				msg += '** " . _CALENDARADM_CALVALIDDATES . "\\n';
			}
			if (errors == 'TRUE') {
				msg += '__________________________________________________\\n\\n" . _CALENDARADM_CALVALIDFIXMSG . "\\n';
				alert(msg);
				return false;
			}
		}
		</script>";
	return $catemp;

}

function CalendarDisplayStory () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = printJavaScript ();
	$boxtxt .= '<div align="center" class="bigtextbold">' . _CALENDARADM_CALSUBMISSIONSADMIN . '</div>';
	$boxtxt .= '<br />';
	$opnConfig['opndate']->now ();
	$result = &$opnConfig['database']->Execute ("SELECT qid, uid, uname, title, story, topic, eventdate, enddate, starttime, endtime, alldayevent, barcolor FROM " . $opnTables['calendar_events_queue'] . " WHERE qid=$qid");
	$qid = $result->fields['qid'];
	$uid = $result->fields['uid'];
	$uname = $result->fields['uname'];
	$subject = $result->fields['title'];
	$story = $result->fields['story'];
	$topic = $result->fields['topic'];
	$eventDate = $result->fields['eventdate'];
	$endDate = $result->fields['enddate'];
	$startTime = $result->fields['starttime'];
	$endTime = $result->fields['endtime'];
	$alldayevent = $result->fields['alldayevent'];
	$barcolor = $result->fields['barcolor'];
	$result->Close ();
	$boxtxt .= '<br /><br />';
	$opnConfig['opndate']->sqlToopnData ($eventDate);
	$d2 = '';
	$opnConfig['opndate']->formatTimestamp ($d2, _DATE_DATESTRING4);
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$s1 = '';
	$opnConfig['opndate']->formatTimestamp ($s1, '%H:%M');
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenRow ();
	$topicimage = '';
	$warning = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		if ($topic == '') {
			$topicimage = 'AllTopics.gif';
			$warning = '<div align="center" class="alerttext">' . _CALENDARADM_CALTOPICERROR . '</div>';
		} else {
			$warning = '';
			$_topic = $opnConfig['opnSQL']->qstr ($topic);
			$result = &$opnConfig['database']->Execute ('SELECT topicimage FROM ' . $opnTables['article_topics'] . " WHERE topicid=$_topic");
			$topicimage = $result->fields['topicimage'];
		}
		if ($topicimage == '') {
			$topicimage = 'AllTopics.gif';
		}
	}
	$hlp = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$hlp .= '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgtag" align="right" alt="" />';
	}
	$hlp .= '<span class="normaltextbold">' . _CALENDARADM_CALEVENTDATEPREVIEW . '</span><span class="normaltext"> ' . $d2 . ' ' . $s1 . '</span> ' . '<br /><br />';
	$table->AddDataCol ($hlp);
	$table->AddChangeRow ();
	$hlp = themepreview ($subject, nl2br ($story) );
	$hlp .= $warning;
	$table->AddDataCol ($hlp);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CALENDARADM_30_', 'calendar');
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php', 'post', 'calendar', '', 'return verify();');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('author', _CALENDARADM_CALNAMEFIELD);
	if ($uname != $opnConfig['opn_anonymous_name']) {
		$form->SetSameCol ();
	}
	$form->AddTextfield ('author', 25, 0, $uname);
	if ($uname != $opnConfig['opn_anonymous_name']) {
		$_uname = $opnConfig['opnSQL']->qstr ($uname);
		$res = &$opnConfig['database']->Execute ('SELECT email, uid FROM ' . $opnTables['users'] . " WHERE uname=$_uname");
		$email = $res->fields['email'];
		$uid = $res->fields['uid'];
		$form->AddText ('&nbsp;&nbsp;[ <a class="%alternate%" href="mailto:' . $email . '">' . _CALENDARADM_CALEMAILUSER . '</a> ');
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) {
			$form->AddText ('| <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php',
												'send2' => '1',
												'to_userid' => $uid) ) . '" target="_blank">' . _CALENDARADM_CALSENDPM . '</a> ');
		}
		$form->AddText (']');
		$form->SetEndCol ();
	}
	$form->AddChangeRow ();
	$form->AddLabel ('subject', _CALENDARADM_CALSUBTITLE);
	$form->AddTextfield ('subject', 50, 0, $subject);
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddLabel ('topic', _CALENDARADM_CALTOPIC);
		$toplist = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . " ORDER BY topictext");
		$options[0] = _CALENDARADM_CALSELECTTOPIC;
		while (! $toplist->EOF) {
			$topicid = $toplist->fields['topicid'];
			$topics = $toplist->fields['topictext'];
			$options[$topicid] = $topics;
			$toplist->MoveNext ();
		}
		$form->AddSelect ('topic', $options, $topic);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topic', _CALENDARADM_CALSELECTTOPIC);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('user_group', _CALENDARADM_USERGROUP);
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('user_group', $options);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALEVENTDATETEXT . ':');
	$form->SetSameCol ();
	$opnConfig['opndate']->sqlToopnData ($eventDate);
	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('year', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$opnConfig['opndate']->sqlToopnData ($endDate);
	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endyear', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALSTARTTIME . ':');
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	$min = '';
	$opnConfig['opndate']->getMinute ($min);
	$form->SetSameCol ();
	$form->AddSelect ('startHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('startMin', buildMinSelectCAL (), $min);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDTIME . ':');
	$form->SetSameCol ();
	$opnConfig['opndate']->sqlToopnData ($endTime);
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	$min = '';
	$opnConfig['opndate']->getMinute ($min);
	$form->AddSelect ('endHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endMin', buildMinSelectCAL (), $min);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('alldayevent', _CALENDARADM_CALALLDAYEVENT);
	$form->SetSameCol ();
	$form->AddCheckbox ('alldayevent', 1, $alldayevent);
	$form->AddText ('<br />(' . _CALENDARADM_CALTIMEIGNORED . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALBARCOLORTEXT . ':');
	$form->SetSameCol ();
	$form->AddRadio ('barcolor', 'r', ($barcolor == 'r'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'g', ($barcolor == 'g'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'b', ($barcolor == 'b'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'w', ($barcolor == 'w'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'y', ($barcolor == 'y'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow']);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('hometext', _CALENDARADM_CALARTICLETEXT);
	$form->AddTextarea ('hometext', 0, 0, '', $story);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('uid', $uid);
	$form->SetEndCol ();
	$options = array ();
	$options['CalendarDeleteStory'] = _CALENDARADM_CALDELETESTORY;
	$options['CalendarPreviewAgain'] = _CALENDARADM_CALPREVIEWSTORY;
	$options['CalendarPostStory'] = _CALENDARADM_CALPOSTSTORY;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'CalendarPreviewAgain');
	$form->AddSubmit ('submit', _CALENDARADM_CALOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_40_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDARADM_CALADMIN, $boxtxt);

}

function CalendarPreviewStory () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$topic = 0;
	get_var ('topic', $topic, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$endday = 0;
	get_var ('endday', $endday, 'form', _OOBJ_DTYPE_INT);
	$endmonth = 0;
	get_var ('endmonth', $endmonth, 'form', _OOBJ_DTYPE_INT);
	$endyear = 0;
	get_var ('endyear', $endyear, 'form', _OOBJ_DTYPE_INT);
	$startHour = 0;
	get_var ('startHour', $startHour, 'form', _OOBJ_DTYPE_INT);
	$startMin = 0;
	get_var ('startMin', $startMin, 'form', _OOBJ_DTYPE_INT);
	$endHour = 0;
	get_var ('endHour', $endHour, 'form', _OOBJ_DTYPE_INT);
	$endMin = 0;
	get_var ('endMin', $endMin, 'form', _OOBJ_DTYPE_INT);
	$alldayevent = 0;
	get_var ('alldayevent', $alldayevent, 'form', _OOBJ_DTYPE_INT);
	$barcolor = '';
	get_var ('barcolor', $barcolor, 'form', _OOBJ_DTYPE_CLEAN);
	$user_group = 0;
	get_var ('user_group', $user_group, 'form', _OOBJ_DTYPE_INT);
	$subject = stripslashes ($subject);
	$hometext = stripslashes ($hometext);
	$boxtxt = printJavaScript ();
	$boxtxt .= '<div align="center" class="bigtextbold">' . _CALENDARADM_CALSUBMISSIONSADMIN . '</div>' . _OPN_HTML_NL;
	$boxtxt .= '<br />';
	if ($topic == '') {
		$topicimage = 'AllTopics.gif';
	} else {
		$_topic = $opnConfig['opnSQL']->qstr ($topic);
		$result = &$opnConfig['database']->Execute ('SELECT topicimage FROM ' . $opnTables['article_topics'] . " WHERE topicid=$_topic");
		$topicimage = $result->fields['topicimage'];
	}
	$boxtxt .= '<br /><br />';
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $startHour . ':' . $startMin . ':00');
	$mydate = '';
	$opnConfig['opndate']->formatTimestamp ($mydate, _DATE_DATESTRING5);
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenRow ();
	$warning = '';
	$hlp = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		if ($topic == '') {
			$topicimage = 'AllTopics.gif';
			$warning = '<div align="center" class="alerttext">' . _CALENDARADM_CALTOPICERROR . '</div>' . _OPN_HTML_NL;
		} else {
			$_topic = $opnConfig['opnSQL']->qstr ($topic);
			$result = &$opnConfig['database']->Execute ("select topicimage from " . $opnTables['article_topics'] . " WHERE topicid=$_topic");
			$topicimage = $result->fields['topicimage'];
		}
		if ($topicimage == '') {
			$topicimage = 'AllTopics.gif';
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
			$hlp .= '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgtag" align="right" alt="" />';
		}
	}
	$hlp .= '<span class="normaltextbold">' . _CALENDARADM_CALEVENTDATEPREVIEW . '</span><span class="normaltext"> ' . $mydate . '</span> ' . '<br /><br />';
	$table->AddDataCol ($hlp);
	$table->AddChangeRow ();
	$story = $hometext;
	opn_nl2br ($story);
	$hlp = themepreview ($subject, $story);
	$hlp .= $warning;
	$table->AddDataCol ($hlp);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />' . _OPN_HTML_NL;
	$boxtxt .= '<br />' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CALENDARADM_50_', 'calendar');
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php', 'post', 'calendar', '', 'return verify();');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('author', _CALENDARADM_CALNAME);
	if ($author != $opnConfig['opn_anonymous_name']) {
		$form->SetSameCol ();
	}
	$form->AddTextfield ('author', 25, 0, $author);
	if ($author != $opnConfig['opn_anonymous_name']) {
		$_author = $opnConfig['opnSQL']->qstr ($author);
		$res = &$opnConfig['database']->Execute ("SELECT email from " . $opnTables['users'] . " WHERE uname=$_author");
		$email = $res->fields['email'];
		$form->AddText ('&nbsp;&nbsp;[ <a class="%alternate%" href="mailto:' . $email . '">' . _CALENDARADM_CALEMAILUSER . '</a> ');
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) {
			$form->AddText ('| <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php',
												'send2' => '1',
												'to_userid' => $uid) ) . '" target="_blank">' . _CALENDARADM_CALSENDPM . '</a> ');
		}
		$form->AddText (']');
		$form->SetEndCol ();
	}
	$form->AddChangeRow ();
	$form->AddLabel ('subject', _CALENDARADM_CALSUBTITLE);
	$form->AddTextfield ('subject', 50, 0, $subject);
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddLabel ('topic', _CALENDARADM_CALTOPIC);
		$toplist = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . " ORDER BY topictext");
		$options[0] = _CALENDARADM_CALSELECTTOPIC;
		while (! $toplist->EOF) {
			$topicid = $toplist->fields['topicid'];
			$topics = $toplist->fields['topictext'];
			$options[$topicid] = $topics;
			$toplist->MoveNext ();
		}
		$form->AddSelect ('topic', $options, $topic);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topic', _CALENDARADM_CALSELECTTOPIC);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('user_group', _CALENDARADM_USERGROUP);
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('user_group', $options, $user_group);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALEVENTDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('year', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDDATETEXT . ':');
	$form->SetSameCol ();
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('endday', buildDaySelectCAL (), $endday);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $endmonth);
	} else {
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $endmonth);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endday', buildDaySelectCAL (), $endday);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endyear', buildYearSelectCAL (), $endyear);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALSTARTTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('startHour', buildHourSelectCAL (), $startHour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('startMin', buildMinSelectCAL (), $startMin);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('endHour', buildHourSelectCAL (), $endHour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endMin', buildMinSelectCAL (), $endMin);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('alldayevent', _CALENDARADM_CALALLDAYEVENT);
	$form->SetSameCol ();
	$form->AddCheckbox ('alldayevent', 1, $alldayevent);
	$form->AddText ('<br />(' . _CALENDARADM_CALTIMEIGNORED . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALBARCOLORTEXT);
	$form->SetSameCol ();
	$form->AddRadio ('barcolor', 'r', ($barcolor == 'r'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'g', ($barcolor == 'g'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'b', ($barcolor == 'b'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'w', ($barcolor == 'w'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'y', ($barcolor == 'y'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow']);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('hometext', _CALENDARADM_CALARTICLETEXT);
	$form->AddTextarea ('hometext', 0, 0, '', $hometext);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('uid', $uid);
	$form->SetEndCol ();
	$options = array ();
	$options['CalendarDeleteStory'] = _CALENDARADM_CALDELETESTORY;
	$options['CalendarPreviewAgain'] = _CALENDARADM_CALPREVIEWSTORY;
	$options['CalendarPostStory'] = _CALENDARADM_CALPOSTSTORY;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'CalendarPreviewAgain');
	$form->AddSubmit ('submit', _CALENDARADM_CALOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_60_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDARADM_CALADMIN, $boxtxt);

}

function CalendarPostStory () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$topic = 0;
	get_var ('topic', $topic, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$endday = 0;
	get_var ('endday', $endday, 'form', _OOBJ_DTYPE_INT);
	$endmonth = 0;
	get_var ('endmonth', $endmonth, 'form', _OOBJ_DTYPE_INT);
	$endyear = 0;
	get_var ('endyear', $endyear, 'form', _OOBJ_DTYPE_INT);
	$startHour = 0;
	get_var ('startHour', $startHour, 'form', _OOBJ_DTYPE_INT);
	$startMin = 0;
	get_var ('startMin', $startMin, 'form', _OOBJ_DTYPE_INT);
	$endHour = 0;
	get_var ('endHour', $endHour, 'form', _OOBJ_DTYPE_INT);
	$endMin = 0;
	get_var ('endMin', $endMin, 'form', _OOBJ_DTYPE_INT);
	$alldayevent = 0;
	get_var ('alldayevent', $alldayevent, 'form', _OOBJ_DTYPE_INT);
	$barcolor = '';
	get_var ('barcolor', $barcolor, 'form', _OOBJ_DTYPE_CLEAN);
	$user_group = 0;
	get_var ('user_group', $user_group, 'form', _OOBJ_DTYPE_INT);
	$subject = $opnConfig['opnSQL']->qstr ($subject);
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
	} else {
		$ui['uid'] = 1;
		$ui['uname'] = $opnConfig['opn_anonymous_name'];
	}
	$eid = $opnConfig['opnSQL']->get_new_number ('calendar_events', 'eid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$opnConfig['opndate']->setTimestamp ($year . "-" . $month . "-" . $day);
	$newDate = '';
	$opnConfig['opndate']->opnDataTosql ($newDate);
	$opnConfig['opndate']->setTimestamp ($endyear . '-' . $endmonth . '-' . $endday);
	$endDate = '';
	$opnConfig['opndate']->opnDataTosql ($endDate);
	$opnConfig['opndate']->setTimestamp ($startHour . ':' . $startMin . ':00');
	$startTime = '';
	$opnConfig['opndate']->opnDataTosql ($startTime);
	$opnConfig['opndate']->setTimestamp ($endHour . ':' . $endMin . ':00');
	$endTime = '';
	$opnConfig['opndate']->opnDataTosql ($endTime);
	$_barcolor = $opnConfig['opnSQL']->qstr ($barcolor);
	$hometext = $opnConfig['opnSQL']->qstr ($hometext, 'hometext');
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$casql = 'INSERT INTO ' . $opnTables['calendar_events'] . " values ($eid, " . $ui['uid'] . ", $subject, $now, $hometext, 0, 0, $topic,$_author,$newDate,$endDate,$startTime,$endTime, $alldayevent, $_barcolor,$user_group)";
	$opnConfig['database']->Execute ($casql);
	if ($opnConfig['database']->ErrorNo ()>0) {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_70_';
		$_display_dat['module'] = 'modules/calendar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ('', $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />' . $casql . '<br />');
		return;
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['calendar_events'], 'eid=' . $eid);
	set_var ('qid', $qid, 'url');
	set_var ('ok', 1, 'url');
	CalendarDeleteStory ();

}

function CalendarEditStory () {

	global $opnConfig, $opnTables;

	$eid = 0;
	get_var ('eid', $eid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = printJavaScript ();
	$boxtxt .= '<div align="center" class="bigtextbold">' . _CALENDARADM_CALSUBMISSIONSADMIN . '</div>';
	$boxtxt .= '<br />';
	$result = &$opnConfig['database']->Execute ("SELECT title, hometext, topic, informant, eventdate, enddate, starttime, endtime, alldayevent, barcolor, user_group FROM " . $opnTables['calendar_events'] . " WHERE eid=$eid");
	$subject = $result->fields['title'];
	$story = $result->fields['hometext'];
	$topic = $result->fields['topic'];
	$author = $result->fields['informant'];
	$eventDate = $result->fields['eventdate'];
	$endDate = $result->fields['enddate'];
	$startTime = $result->fields['starttime'];
	$endTime = $result->fields['endtime'];
	$alldayevent = $result->fields['alldayevent'];
	$barcolor = $result->fields['barcolor'];
	$user_group = $result->fields['user_group'];
	$result->Close ();
	if ($author == '') {
		$author = $opnConfig['opn_anonymous_name'];
	}
	if ($topic == '') {
		$topic = 1;
	}
	$result = &$opnConfig['database']->Execute ("SELECT topicimage FROM " . $opnTables['article_topics'] . " WHERE topicid=$topic");
	$boxtxt .= '<br /><br />';
	$opnConfig['opndate']->sqlToopnData ($eventDate);
	$d2 = '';
	$opnConfig['opndate']->formatTimestamp ($d2, _DATE_DATESTRING4);
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$s1 = '';
	$opnConfig['opndate']->formatTimestamp ($s1, '%H:%M');
	$table = & new opn_TableClass ('alternator');
	$table->AddOpenRow ();
	$warning = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		if ($topic == '') {
			$topicimage = 'AllTopics.gif';
			$warning = '<div align="center" class="alerttext">' . _CALENDARADM_CALTOPICERROR . '</div>' . _OPN_HTML_NL;
		} else {
			$_topic = $opnConfig['opnSQL']->qstr ($topic);
			$result = &$opnConfig['database']->Execute ("select topicimage from " . $opnTables['article_topics'] . " WHERE topicid=$_topic");
			$topicimage = $result->fields['topicimage'];
		}
		if ($topicimage == '') {
			$topicimage = 'AllTopics.gif';
		}
	}
	$hlp = '';
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$hlp .= '<img src="' . $opnConfig['datasave']['art_topic_path']['url'] . '/' . $topicimage . '" class="imgtag" align="right" alt="" />';
	}
	$hlp .= '<span class="normaltextbold">' . _CALENDARADM_CALEVENTDATEPREVIEW . '</span><span class="normaltext"> ' . $d2 . ' ' . $s1 . '</span> ' . '<br /><br />';
	$table->AddDataCol ($hlp);
	$storypreview = $story;
	opn_nl2br ($storypreview);
	$hlp = themepreview ($subject, $storypreview);
	$hlp .= $warning;
	$table->AddChangeRow ();
	$table->AddDataCol ($hlp);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CALENDARADM_80_', 'calendar');
	$form->Init ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php', 'post', 'calendar', '', 'return verify();');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('author', _CALENDARADM_CALNAMEFIELD);
	$form->SetSameCol ();
	$form->AddTextfield ('author', 25, 0, $author);
	if ($opnConfig['permission']->IsUser () ) {
		$ui = $opnConfig['permission']->GetUserinfo ();
		$form->AddText ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $ui['uname'] . '</a> [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _CALENDARADM_CALLOGOUT . '</a> ]');
	} else {
		$form->AddText ($opnConfig['opn_anonymous_name']);
	}
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('subject', _CALENDARADM_CALSUBTITLE);
	$form->AddTextfield ('subject', 50, 0, $subject);
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddLabel ('topic', _CALENDARADM_CALTOPIC);
		$toplist = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . " ORDER BY topictext");
		$options[''] = _CALENDARADM_CALSELECTTOPIC;
		while (! $toplist->EOF) {
			$topicid = $toplist->fields['topicid'];
			$topics = $toplist->fields['topictext'];
			$options[$topicid] = $topics;
			$toplist->MoveNext ();
		}
		$form->AddSelect ('topic', $options, $topic);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topic', _CALENDARADM_CALSELECTTOPIC);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('user_group', _CALENDARADM_USERGROUP);
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('user_group', $options, $user_group);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALEVENTDATETEXT . ':');
	$form->SetSameCol ();
	$opnConfig['opndate']->sqlToopnData ($eventDate);
	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('month', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('day', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('year', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDDATETEXT . ':');
	$form->SetSameCol ();
	$opnConfig['opndate']->sqlToopnData ($endDate);
	$day = '';
	$opnConfig['opndate']->getDay ($day);
	$month = '';
	$opnConfig['opndate']->getMonth ($month);
	$year = '';
	$opnConfig['opndate']->getYear ($year);
	if ($opnConfig['calendar_useInternationalDates']) {
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
	} else {
		$form->AddSelect ('endmonth', buildMonthSelectCAL (), $month);
		$form->AddText ('&nbsp;');
		$form->AddSelect ('endday', buildDaySelectCAL (), $day);
	}
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endyear', buildYearSelectCAL (), $year);
	$form->SetEndCol ();
	$opnConfig['opndate']->sqlToopnData ($startTime);
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	$min = '';
	$opnConfig['opndate']->getMinute ($min);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALSTARTTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('startHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('startMin', buildMinSelectCAL (), $min);
	$form->SetEndCol ();
	$opnConfig['opndate']->sqlToopnData ($endTime);
	$hour = '';
	$opnConfig['opndate']->getHour ($hour);
	$min = '';
	$opnConfig['opndate']->getMinute ($min);
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALENDTIME . ':');
	$form->SetSameCol ();
	$form->AddSelect ('endHour', buildHourSelectCAL (), $hour);
	$form->AddText ('&nbsp;');
	$form->AddSelect ('endMin', buildMinSelectCAL (), $min);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('alldayevent', _CALENDARADM_CALALLDAYEVENT);
	$form->SetSameCol ();
	$form->AddCheckbox ('alldayevent', 1, $alldayevent);
	$form->AddText ('<br />(' . _CALENDARADM_CALTIMEIGNORED . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText (_CALENDARADM_CALBARCOLORTEXT);
	$form->SetSameCol ();
	$form->AddRadio ('barcolor', 'r', ($barcolor == 'r'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballr.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorred'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'g', ($barcolor == 'g'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballg.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorgreen'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'b', ($barcolor == 'b'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballb.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorblue'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'w', ($barcolor == 'w'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/ballw.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcolorwhite'] . '&nbsp;&nbsp;');
	$form->AddRadio ('barcolor', 'y', ($barcolor == 'y'?1 : 0) );
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/calendar/images/bally.gif" alt="" />&nbsp;' . $opnConfig['calendar_caldotcoloryellow']);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('hometext', _CALENDARADM_CALARTICLETEXT);
	$form->AddTextarea ('hometext', 0, 0, '', $story);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('eid', $eid);
	$form->AddHidden ('op', 'CalendarChangeStory');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _CALENDARADM_CALPOSTSTORY);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_90_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_CALENDARADM_CALADMIN, $boxtxt);

}

function CalendarRemoveStory () {

	global $opnTables, $opnConfig;

	$eid = 0;
	get_var ('eid', $eid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['calendar_events'] . " WHERE eid=$eid");
		CalendarSubmissions ();
	} else {
		$boxtxt = '<div align="center" class="bigtextbold">' . _CALENDARADM_CALSUBMISSIONSADMIN . '</div>';
		$boxtxt .= '<br />';
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _CALENDARADM_CALREMOVETEST . ': ' . $eid . '<br /></span>';
		$boxtxt .= '<br /><a href="' . $opnConfig['opn_url'] . '/modules/calendar/admin/index.php">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php',
																					'op' => 'CalendarRemoveStory',
																					'eid' => $eid,
																					'ok' => '1') ) . '">' . _YES . '</a></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_100_';
		$_display_dat['module'] = 'modules/calendar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_CALENDARADM_CALADMIN, $boxtxt);
	}

}

function CalendarChangeStory () {

	global $opnConfig, $opnTables;

	$eid = 0;
	get_var ('eid', $eid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$topic = 0;
	get_var ('topic', $topic, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$endday = 0;
	get_var ('endday', $endday, 'form', _OOBJ_DTYPE_INT);
	$endmonth = 0;
	get_var ('endmonth', $endmonth, 'form', _OOBJ_DTYPE_INT);
	$endyear = 0;
	get_var ('endyear', $endyear, 'form', _OOBJ_DTYPE_INT);
	$startHour = 0;
	get_var ('startHour', $startHour, 'form', _OOBJ_DTYPE_INT);
	$startMin = 0;
	get_var ('startMin', $startMin, 'form', _OOBJ_DTYPE_INT);
	$endHour = 0;
	get_var ('endHour', $endHour, 'form', _OOBJ_DTYPE_INT);
	$endMin = 0;
	get_var ('endMin', $endMin, 'form', _OOBJ_DTYPE_INT);
	$alldayevent = 0;
	get_var ('alldayevent', $alldayevent, 'form', _OOBJ_DTYPE_INT);
	$barcolor = '';
	get_var ('barcolor', $barcolor, 'form', _OOBJ_DTYPE_CLEAN);
	$user_group = 0;
	get_var ('user_group', $user_group, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day);
	$newDate = '';
	$opnConfig['opndate']->opnDataTosql ($newDate);
	$opnConfig['opndate']->setTimestamp ($endyear . '-' . $endmonth . '-' . $endday);
	$endDate = '';
	$opnConfig['opndate']->opnDataTosql ($endDate);
	$subject = $opnConfig['opnSQL']->qstr ($subject);
	$opnConfig['opndate']->setTimestamp ($startHour . ':' . $startMin . ':00');
	$startTime = '';
	$opnConfig['opndate']->opnDataTosql ($startTime);
	$opnConfig['opndate']->setTimestamp ($endHour . ':' . $endMin . ':00');
	$endTime = '';
	$opnConfig['opndate']->opnDataTosql ($endTime);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_topic = $opnConfig['opnSQL']->qstr ($topic);
	$_endDate = $opnConfig['opnSQL']->qstr ($endDate);
	$_startTime = $opnConfig['opnSQL']->qstr ($startTime);
	$_barcolor = $opnConfig['opnSQL']->qstr ($barcolor);
	$_alldayevent = $opnConfig['opnSQL']->qstr ($alldayevent);
	$_endTime = $opnConfig['opnSQL']->qstr ($endTime);
	$hometext = $opnConfig['opnSQL']->qstr ($hometext, 'hometext');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['calendar_events'] . " SET title=" . $subject . ", hometext=" . $hometext . ", topic=$_topic, informant=$_author, eventdate='" . $newDate . "', enddate=$_endDate, starttime=$_startTime, endtime=$_endTime, alldayevent=$_alldayevent, barcolor=$_barcolor, user_group=$user_group WHERE eid=$eid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['calendar_events'], 'eid=' . $eid);
	CalendarSubmissions ();

}

function CalendarSubmissions () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_CALENDARADM_CALSUBMISSIONSADMIN);
	$menu->InsertEntry (_CALENDARADM_CALSETTINGS, $opnConfig['opn_url'] . '/modules/calendar/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT qid, title, wtimestamp FROM ' . $opnTables['calendar_events_queue'] . ' WHERE qid>0 ORDER BY wtimestamp');
	$cladummy = 0;
	if ($result !== false) {
		$cladummy = $result->RecordCount ();
	}
	if ($cladummy == 0) {
		$table = & new opn_TableClass ('alternator');
		$table->AddDataRow (array (_CALENDARADM_CALNOSUBMISSIONS), array ('center') );
		$table->GetTable ($boxtxt);
	} else {
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _CALENDARADM_CALNEWSUBMISSIONS . '</span>' . _OPN_HTML_NL;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('10%', '75%', '15%') );
		while (! $result->EOF) {
			$qid = $result->fields['qid'];
			$subject = $result->fields['title'];
			$timestamp = $result->fields['wtimestamp'];
			$opnConfig['opndate']->sqlToopnData ($timestamp);
			if ($subject == '') {
				$subject = _CALENDARADM_CALNOSUBJECT;
			}
			$opnConfig['opndate']->formatTimestamp ($timestamp, _DATE_DATESTRING5);
			$table->AddDataRow (array ($opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php', 'op' => 'CalendarDeleteStory', 'qid' => $qid) ), '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/calendar/admin/index.php', 'op' => 'CalendarDisplayStory', 'qid' => $qid) ) . '">' . $subject . '</a>', $timestamp), array ('center', 'left', 'center') );
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '</div>' . _OPN_HTML_NL;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_CALENDARADM_110_';
	$_display_dat['module'] = 'modules/calendar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_CALENDARADM_CALADMIN, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'CalendarDisplayStory':
		CalendarDisplayStory ();
		break;
	case 'CalendarPreviewAgain':
	case _CALENDARADM_CALPREVIEWSTORY:
		CalendarPreviewStory ();
		break;
	case 'CalendarPostStory':
	case _CALENDARADM_CALPOSTSTORY:
		CalendarPostStory ();
		break;
	case 'CalendarEditStory':
		CalendarEditStory ();
		break;
	case 'CalendarRemoveStory':
		CalendarRemoveStory ();
		break;
	case 'CalendarChangeStory':
		CalendarChangeStory ();
		break;
	case 'CalendarDeleteStory':
	case _CALENDARADM_CALDELETESTORY:
		CalendarDeleteStory ();
		break;
	case 'CalendarAdmin':
		CalendarSubmissions ();
		break;
	default:
		CalendarSubmissions ();
		break;
}

?>