<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/changelog', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/changelog/admin/language/');

function changelog_allhiddens ($wichSave) {

	global $opnConfig;

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	if ( !$opnConfig['installedPlugins']->isplugininstalled ('pro/svnchangelog')) {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'changelog_cache_time',
				'value' => 60 );
	}
	$nav[_CHANGELOG_SAVE] = _CHANGELOG_SAVE;
	$nav[_CHANGELOG_ADMIN] = _CHANGELOG_ADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function changelogsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _CHANGELOG_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _CHANGELOG_PAGESIZE,
			'name' => 'pagesize_changelog',
			'value' => $privsettings['pagesize_changelog'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _CHANGELOG_BUILDNRREQUIRED,
			'name' => 'changelog_buildnrrequired',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['changelog_buildnrrequired'] == 1?true : false),
			 ($privsettings['changelog_buildnrrequired'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _CHANGELOG_CATSPERROW,
			'name' => 'changelog_cats_per_row',
			'value' => $privsettings['changelog_cats_per_row'],
			'size' => 1,
			'maxlength' => 1);
	if ( $opnConfig['installedPlugins']->isplugininstalled ('pro/svnchangelog')) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _CHANGELOG_CACHETIME,
				'name' => 'changelog_cache_time',
				'value' => $privsettings['changelog_cache_time'],
				'size' => 3,
				'maxlength' => 3);
	}
	$values = array_merge ($values, changelog_allhiddens (_CHANGELOG_NAVGENERAL) );
	$set->GetTheForm (_CHANGELOG_SETTINGS, $opnConfig['opn_url'] . '/modules/changelog/admin/settings.php', $values);

}

function changelog_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function changelog_dosavechangelog ($vars) {

	global $privsettings;

	$privsettings['pagesize_changelog'] = $vars['pagesize_changelog'];
	$privsettings['changelog_buildnrrequired'] = $vars['changelog_buildnrrequired'];
	$privsettings['changelog_cats_per_row'] = $vars['changelog_cats_per_row'];
	$privsettings['changelog_cache_time'] = $vars['changelog_cache_time'];
	changelog_dosavesettings ();

}

function changelog_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _CHANGELOG_NAVGENERAL:
			changelog_dosavechangelog ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		changelog_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _CHANGELOG_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/changelog/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _CHANGELOG_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/changelog/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		changelogsettings ();
		break;
}

?>