<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/download/plugin/search/language/');

function download_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'download';
	$button['sel'] = 0;
	$button['label'] = _DOWNLOAD_SEARCH_DOWNLOAD;
	$buttons[] = $button;
	unset ($button);

}

function download_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'download':
			download_retrieve_all ($query, $data, $sap);
		}
	}

	function download_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = download_get_query ($query);
		$q .= download_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if ($result !== false) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _DOWNLOAD_SEARCH_DOWNLOAD;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$lid = $result->fields['lid'];
					$title = $result->fields['title'];
					$hlp1['data'] = download_build_link ($lid, $title);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function download_get_query ($query) {

		global $opnTables, $opnConfig;

		$checkerlist = $opnConfig['permission']->GetUserGroups ();
		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('l.lid',
								'l.title') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['downloads_links'] . ' l, ' . $opnTables['download_cats'] . ' c');
		$opnConfig['opn_searching_class']->SetWhere (' l.cid=c.cat_id AND l.user_group IN (' . $checkerlist . ') AND c.cat_usergroup IN (' . $checkerlist . ') AND');
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('l.title',
									'l.description') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function download_get_orderby () {
	return ' ORDER BY l.title ASC';

}

function download_build_link ($lid, $title) {

	global $opnConfig;

	$ttitle = str_replace (' ', '_', $title);
	$hlp = '<a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
								'op' => 'viewlinkdetails',
								'lid' => $lid,
								'ttitle' => $ttitle) ) . '">' . $title . '</a>&nbsp;';
	$hlp .= '<a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
								'op' => 'visit',
								'lid' => $lid) ) . '" target="_blank">';
	$hlp .= '<img src="' . $opnConfig['opn_url'] . '/modules/download/images/download.gif" class="imgtag" alt="" /></a>';
	return $hlp;

}

?>