<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/download/plugin/tracking/language/');

function download_get_tracking ($url) {

	global $opnTables, $opnConfig;
	if ( ($url == '/modules/download/index.php') or ($url == '/modules/download/') ) {
		return _DOW_TRACKING_DIRCAT;
	}
	if (substr_count (strtolower ($url), 'modules/download/index.php?op=addlink')>0) {
		return _DOW_TRACKING_ADDDOWNLOAD;
	}
	if (substr_count (strtolower ($url), 'modules/download/index.php?op=newlinks')>0) {
		return _DOW_TRACKING_NEWDOWNLOAD;
	}
	if (substr_count (strtolower ($url), 'modules/download/index.php?op=mostpopular')>0) {
		return _DOW_TRACKING_MOSTPOP;
	}
	if (substr_count (strtolower ($url), 'modules/download/index.php?op=toprated')>0) {
		return _DOW_TRACKING_TOPDOWN;
	}
	if (substr_count ($url, 'modules/download/index.php?op=search&query=')>0) {
		$title = str_replace ('/modules/download/index.php?op=search&query=', '', $url);
		return _DOW_TRACKING_SEARCHDOWN . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=search')>0) {
		return _DOW_TRACKING_SEARCHDOWN;
	}
	if (substr_count ($url, 'modules/download/index.php?op=viewlink&cid=')>0) {
		if (substr_count ($url, '&') == 2) {
			$cid = str_replace ('/modules/download/index.php?op=viewlink', '', $url);
			$c = explode ('&', $cid);
			$cid = str_replace ('cid=', '', $c[1]);
		} else {
			$cid = str_replace ('/modules/download/index.php?op=viewlink&cid=', '', $url);
		}
		$result = &$opnConfig['database']->Execute ('SELECT cat_name FROM ' . $opnTables['download_cats'] . ' WHERE cat_id=' . $cid);
		if ($result !== false) {
			$title = ($result->RecordCount () == 1? $result->fields['cat_name'] : $cid);
			$result->Close ();
		} else {
			$title = $cid;
		}
		return _DOW_TRACKING_DOWNCAT . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=viewlinkdetails&lid=')>0) {
		$title = str_replace ('/modules/download/index.php?op=viewlinkdetails', '', $url);
		$t = explode ('&', $title);
		$title = str_replace ('ttitle=', '', $t[2]);
		return _DOW_TRACKING_DOWNDETAIL . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=viewlinkeditorial&lid=')>0) {
		$title = str_replace ('/modules/download/index.php?op=viewlinkeditorial', '', $url);
		$t = explode ('&', $title);
		$title = str_replace ('ttitle=', '', $t[2]);
		return _DOW_TRACKING_DOWNEDIT . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=brokenlink&lid=')>0) {
		$lid = str_replace ('/modules/download/index.php?op=brokenlink&lid=', '', $url);
		$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid);
		if ($result !== false) {
			$title = ($result->RecordCount () == 1? $result->fields['title'] : $lid);
			$result->Close ();
		} else {
			$title = $lid;
		}
		return _DOW_TRACKING_BROKENDOWN . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=modifylinkrequest&lid=')>0) {
		$lid = str_replace ('/modules/download/index.php?op=modifylinkrequest&lid=', '', $url);
		$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid);
		if ($result !== false) {
			$title = ($result->RecordCount () == 1? $result->fields['title'] : $lid);
			$result->Close ();
		} else {
			$title = $lid;
		}
		return _DOW_TRACKING_MODIFYDOWN . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=viewlinkcomments&lid=')>0) {
		$lid = str_replace ('/modules/download/index.php?op=viewlinkcomments=', '', $url);
		$title = str_replace ('/modules/download/index.php?op=viewlinkeditorial', '', $url);
		$t = explode ('&', $title);
		$title = str_replace ('ttitle=', '', $t[2]);
		return _DOW_TRACKING_COMMENTS . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=ratelink&lid=')>0) {
		$title = str_replace ('/modules/download/index.php?op=ratelink', '', $url);
		$t = explode ('&', $title);
		if (count ($t)>2) {
			$title = str_replace ('ttitle=', '', $t[2]);
		} else {
			$title = 'N/A';
		}
		return _DOW_TRACKING_RATEDOWN . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/index.php?op=visit&lid=')>0) {
		$lid = str_replace ('/modules/download/index.php?op=visit&lid=', '', $url);
		$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid);
		if ($result !== false) {
			$title = ($result->RecordCount () == 1? $result->fields['title'] : $lid);
			$result->Close ();
		} else {
			$title = $lid;
		}
		return _DOW_TRACKING_EXTLINKDWON . ' "' . urldecode ($title) . '"';
	}
	if (substr_count ($url, 'modules/download/admin/')>0) {
		return _DOW_TRACKING_ADMINDONLOAD;
	}
	return '';

}

?>