<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/ephemerids/admin/language/');
include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function ephemeridsConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_EPHEM_EPHEMERIDADMIN);
	$menu->InsertEntry (_EPHEM_MAIN, $opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php');
	$menu->InsertEntry (_EPHEM_OVERVIEW, array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
						'op' => 'Ephemeridsshow') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function Ephemerids () {

	global $opnConfig;

	ephemeridsConfigHeader ();
	$boxtitle = _EPHEM_TITLE;
	if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt = '<span class="extratextbold">' . _EPHEM_ADD . '</span><br /><br />' . _OPN_HTML_NL;
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_EPHEMERIDS_10_', 'ephemerids');
		$form->Init ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('15%', '85%') );
		$form->AddOpenRow ();
		$nday = '1';
		$form->AddLabel ('did', _EPHEM_DAY . ' ');
		while ($nday<=31) {
			$options[$nday] = $nday;
			$nday++;
		}
		$form->AddSelect ('did', $options);
		$nmonth = '1';
		$form->AddChangeRow ();
		$form->AddLabel ('mid', _EPHEM_MONTH . ' ');
		$options = array ();
		while ($nmonth<=12) {
			$options[$nmonth] = $nmonth;
			$nmonth++;
		}
		$form->AddSelect ('mid', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('yid', _EPHEM_YEAR . ' ');
		$form->AddTextfield ('yid', 5, 4);
		$form->AddChangeRow ();
		$form->AddLabel ('content', _EPHEM_DESC);
		$form->AddTextarea ('content');
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'Ephemeridsadd');
		$form->AddSubmit ('submit', _EPHEM_SEND);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$boxtxt .= '<br /><br />' . _OPN_HTML_NL;
	} else {
		$boxtxt = '';
	}
	if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$boxtxt .= '<span class="extratextbold">' . _EPHEM_MAINTENANCE . '</span><br /><br />' . _OPN_HTML_NL;
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_EPHEMERIDS_20_', 'ephemerids');
		$form->Init ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$nday = '1';
		$form->AddLabel ('did1', _EPHEM_DAY . ' ');
		$options = array ();
		while ($nday<=31) {
			$options[$nday] = $nday;
			$nday++;
		}
		$form->AddSelect ('did1', $options);
		$nmonth = '1';
		$form->AddChangeRow ();
		$form->AddLabel ('mid1', _EPHEM_MONTH . ' ');
		$options = array ();
		while ($nmonth<=12) {
			$options[$nmonth] = $nmonth;
			$nmonth++;
		}
		$form->AddSelect ('mid1', $options);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'Ephemeridsmaintenance');
		$form->AddSubmit ('submit', _EPHEM_EDIT);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EPHEMERIDS_30_';
	$_display_dat['module'] = 'modules/ephemerids';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function Ephemeridsadd () {

	global $opnTables, $opnConfig;

	$did = 0;
	get_var ('did', $did, 'form', _OOBJ_DTYPE_INT);
	$mid = 0;
	get_var ('mid', $mid, 'form', _OOBJ_DTYPE_INT);
	$yid = 0;
	get_var ('yid', $yid, 'form', _OOBJ_DTYPE_INT);
	$content = '';
	get_var ('content', $content, 'form', _OOBJ_DTYPE_CHECK);
	$content = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($content, true, true, ''), 'content');
	$eid = $opnConfig['opnSQL']->get_new_number ('ephem', 'eid');
	$opnConfig['database']->Execute ('insert into ' . $opnTables['ephem'] . " values ($eid, $did, $mid, $yid, $content)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['ephem'], 'eid=' . $eid);

}

function Ephemeridsmaintenance () {

	global $opnTables, $opnConfig;

	ephemeridsConfigHeader ();
	$did = 0;
	get_var ('did1', $did, 'both', _OOBJ_DTYPE_INT);
	$mid = 0;
	get_var ('mid1', $mid, 'both', _OOBJ_DTYPE_INT);
	$boxtitle = _EPHEM_MAINTTITLE;
	$result = &$opnConfig['database']->Execute ('SELECT eid, did, mid, yid, content FROM ' . $opnTables['ephem'] . " WHERE did=$did AND mid=$mid ORDER BY yid,mid");
	$boxtxt = '';
	if ($result !== false) {
		while (! $result->EOF) {
			$eid = $result->fields['eid'];
			$did = $result->fields['did'];
			$mid = $result->fields['mid'];
			$yid = $result->fields['yid'];
			$content = $result->fields['content'];
			$boxtxt .= '<span class="normaltextbold">' . $yid . ' </span> ';
			if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$boxtxt .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
												'op' => 'Ephemeridsedit',
												'eid' => $eid,
												'did' => $did,
												'mid' => $mid), 'opncenterbox' ) . ' ';
			}
			if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$boxtxt .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
												'op' => 'Ephemeridsdel',
												'eid' => $eid,
												'did' => $did,
												'mid' => $mid) );
			}
			$boxtxt .= '<br />' . _OPN_HTML_NL;
			$boxtxt .= $content . '<br /><br /><br />' . _OPN_HTML_NL;
			$result->MoveNext ();
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EPHEMERIDS_40_';
	$_display_dat['module'] = 'modules/ephemerids';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function Ephemeridsshow () {

	global $opnTables, $opnConfig;

	ephemeridsConfigHeader ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtitle = _EPHEM_MAINTTITLE;
	$url = array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
			'op' => 'Ephemeridsshow');
	$sql = 'SELECT COUNT(eid) AS counter FROM ' . $opnTables['ephem'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$newsortby = $sortby;
	$order = '';
	$boxtxt = '';
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('10%', '10%', '10%', '50%', '10%') );
	$table->get_sort_order ($order, array ('did',
						'content',
						'yid',
						'mid'),
						$newsortby);
	$result = &$opnConfig['database']->SelectLimit ('SELECT eid, did, mid, yid, content FROM ' . $opnTables['ephem'] . $order, $opnConfig['opn_gfx_defaultlistrows'], $offset);
	$table->AddHeaderRow (array ($table->get_sort_feld ('did', _EPHEM_DAY, $url), $table->get_sort_feld ('mid', _EPHEM_MONTH, $url), $table->get_sort_feld ('yid', _EPHEM_YEAR, $url), $table->get_sort_feld ('content', _EPHEM_TITLE, $url), '&nbsp;') );
	if ($result !== false) {
		while (! $result->EOF) {
			$eid = $result->fields['eid'];
			$did = $result->fields['did'];
			$mid = $result->fields['mid'];
			$yid = $result->fields['yid'];
			$content = $result->fields['content'];
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
											'op' => 'Ephemeridsedit',
											'eid' => $eid,
											'did' => $did,
											'mid' => $mid) ) . ' ';
			}
			if ($opnConfig['permission']->HasRights ('modules/ephemerids', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
											'op' => 'Ephemeridsdel',
											'eid' => $eid,
											'did' => $did,
											'mid' => $mid) );
			}
			$table->AddDataRow (array ($did, $mid, $yid, $content, $hlp) );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
					'op' => 'Ephemeridsshow',
					'sortby' => $sortby),
					$reccount,
					$opnConfig['opn_gfx_defaultlistrows'],
					$offset,
					_EPHEM_ENTRIES_ALLUSERSINOURDATABASEARE);
	$boxtxt .= '<br /><br />' . $pagebar . '<br /><br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EPHEMERIDS_50_';
	$_display_dat['module'] = 'modules/ephemerids';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function Ephemeridsdel () {

	global $opnTables, $opnConfig;

	$eid = 0;
	get_var ('eid', $eid, 'url', _OOBJ_DTYPE_INT);
	$did = 0;
	get_var ('did', $did, 'url', _OOBJ_DTYPE_INT);
	$mid = 0;
	get_var ('mid', $mid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['ephem'] . ' WHERE eid=' . $eid);
		Ephemerids ();
	} else {
		ephemeridsConfigHeader ();
		$boxtxt .= '<div class="centertag"><br />';
		$boxtxt .= '<span class="alerttext">';
		$boxtxt .= _DELDATA_WARNING . '</span><br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
										'op' => 'Ephemeridsdel',
										'eid' => $eid,
										'did' => $did,
										'mid' => $mid,
										'ok' => '1') ) . '">' . _YES . '</a>';
		$boxtxt .= '&nbsp;&nbsp;&nbsp;';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
										'op' => 'Ephemeridsmaintenance',
										'did1' => $did,
										'mid1' => $mid) ) . '">' . _NO . '</a>';
		$boxtxt .= '<br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EPHEMERIDS_60_';
		$_display_dat['module'] = 'modules/ephemerids';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function Ephemeridsedit () {

	global $opnTables, $opnConfig;

	ephemeridsConfigHeader ();
	$eid = 0;
	get_var ('eid', $eid, 'url', _OOBJ_DTYPE_INT);
	$did = 0;
	get_var ('did', $did, 'url', _OOBJ_DTYPE_INT);
	$mid = 0;
	get_var ('mid', $mid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT yid, content FROM ' . $opnTables['ephem'] . " WHERE eid=$eid");
	$yid = $result->fields['yid'];
	$content = $result->fields['content'];
	$boxtitle = _EPHEM_MAINTTITLE;
	$boxtxt = '<span class="extratextbold">' . _EPHEM_EDITEPHEM . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_EPHEMERIDS_70_', 'ephemerids');
	$form->Init ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '85%') );
	$form->AddOpenRow ();
	$form->AddLabel ('yid', _EPHEM_YEAR . ' ');
	$form->AddTextfield ('yid', 5, 4, $yid);
	$form->AddChangeRow ();
	$form->AddLabel ('content', _EPHEM_DESC);
	$form->AddTextarea ('content', 0, 0, '', $content);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('did', $did);
	$form->AddHidden ('mid', $mid);
	$form->AddHidden ('eid', $eid);
	$form->AddHidden ('op', 'Ephemeridschange');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _EPHEM_SEND);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EPHEMERIDS_80_';
	$_display_dat['module'] = 'modules/ephemerids';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function Ephemeridschange () {

	global $opnTables, $opnConfig;

	$eid = 0;
	get_var ('eid', $eid, 'form', _OOBJ_DTYPE_INT);
	$did = 0;
	get_var ('did', $did, 'form', _OOBJ_DTYPE_INT);
	$mid = 0;
	get_var ('mid', $mid, 'form', _OOBJ_DTYPE_INT);
	$yid = 0;
	get_var ('yid', $yid, 'form', _OOBJ_DTYPE_INT);
	$content = '';
	get_var ('content', $content, 'form', _OOBJ_DTYPE_CHECK);
	$content = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($content, true, true, ''), 'content');
	$opnConfig['database']->Execute ('update ' . $opnTables['ephem'] . " set content=$content,yid=$yid,did=$did,mid=$mid WHERE eid=$eid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['ephem'], 'eid=' . $eid);
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/ephemerids/admin/index.php',
							'op' => 'Ephemeridsmaintenance',
							'did1' => $did,
							'mid1' => $mid),
							false) );

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'Ephemeridsshow':
		Ephemeridsshow ();
		break;
	case 'Ephemeridsedit':
		Ephemeridsedit ();
		break;
	case 'Ephemeridschange':
		Ephemeridschange ();
		break;
	case 'Ephemeridsdel':
		Ephemeridsdel ();
		break;
	case 'Ephemeridsmaintenance':
		Ephemeridsmaintenance ();
		break;
	case 'Ephemeridsadd':
		Ephemeridsadd ();
		Ephemerids ();
		break;
	default:
		Ephemerids ();
		break;
}

?>