<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/ephemerids/plugin/middlebox/ephem/language/');

function mid_ephemapplet_scrollcontent ($myheight, $width, $id, $scroll) {

	global $opnConfig;

	$cache_file = $opnConfig['root_path_datasave'] . '/ephemapplet' . $id . '.txt';
	if (filesize ($cache_file)>0) {
		$content = file_get_contents ($cache_file);
		$content = str_replace ("'", " \'", $content);
		$content = str_replace ('"', '\"', $content);
		$boxstuff = '<script type="text/javascript"><!--' . _OPN_HTML_NL . _OPN_HTML_NL;
		if ($scroll) {
			$boxstuff .= 'var my' . $id . ' = new HoriScroller("' . $content . '",' . $width . ',' . $myheight . ',"' . $id . '");' . _OPN_HTML_NL;
		} else {
			$boxstuff .= 'var my' . $id . ' = new VertScroller("' . $content . '",' . $width . ',' . $myheight . ',"' . $id . '");' . _OPN_HTML_NL;
		}
		$boxstuff .= '  my' . $id . '.create("' . $id . '");' . _OPN_HTML_NL;
		$boxstuff .= '//--></script>' . _OPN_HTML_NL;
	}
	return ($boxstuff);

}

function ephem_get_middlebox_result (&$box_array_dat) {

	global $opnConfig, $opnTables;
	if (!isset ($box_array_dat['box_options']['scroll_hori_ephems']) ) {
		$box_array_dat['box_options']['scroll_hori_ephems'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['ephems_scrollboxwidth']) ) {
		$box_array_dat['box_options']['ephems_scrollboxwidth'] = 125;
		// default value
	}
	$opnConfig['opndate']->now ();
	$eday = 0;
	(int) $opnConfig['opndate']->getDay ($eday);
	$emonth = 0;
	(int) $opnConfig['opndate']->getMonth ($emonth);
	$result = &$opnConfig['database']->Execute ('SELECT yid, content FROM ' . $opnTables['ephem'] . " WHERE did=$eday AND mid=$emonth");
	if ($box_array_dat['box_options']['scroll_hori_ephems']) {
		$newline = '&nbsp;&nbsp;&nbsp;';
	} else {
		$newline = '<br /><br />';
	}
	if ($box_array_dat['box_options']['opnbox_class'] == 'side') {
		$css = 'sideboxsmalltextbold';
	} else {
		$css = 'normaltextbold';
	}
	if ($result !== false) {
		$boxstuff = $box_array_dat['box_options']['textbefore'] . _OPN_HTML_NL;
		$numrows = $result->RecordCount ();
		if ($numrows>0) {
			$ephemboxstuff = '';
			while (! $result->EOF) {
				$yid = $result->fields['yid'];
				$contenttxt = $result->fields['content'];
				if ($box_array_dat['box_options']['use_ephems_applet']) {
					if ($yid) {
						if ($box_array_dat['box_options']['scroll_hori_ephems']) {
							$ephemboxstuff .= '<span class="' . $css . '">' . $yid . '</span>&nbsp;&nbsp;';
						} else {
							$ephemboxstuff .= '<span class="' . $css . '">' . $yid . '</span><br />';
						}
					}
					$ephemboxstuff .= $contenttxt;
				} else {
					if ($yid) {
						$ephemboxstuff .= '<span class="' . $css . '">' . $yid . '</span><br />';
					}
					$ephemboxstuff .= $contenttxt . _OPN_HTML_NL;
				}
				$ephemboxstuff .= $newline;
				$result->MoveNext ();
			}
			$ephemboxstuff .= $newline;
			if ($box_array_dat['box_options']['use_ephems_applet']) {
				$filename = $opnConfig['root_path_datasave'] . 'ephemapplet' . $box_array_dat['box_options']['boxid'] . '.txt';
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
				$File = & new opnFile;
				$File->overwrite_file ($filename, $ephemboxstuff);
				include_once (_OPN_ROOT_PATH . 'include/js.scroller.php');
				$boxstuff = '';
				GetScroller ($boxstuff);
				$boxstuff .= _OPN_HTML_NL;
				$boxstuff .= mid_ephemapplet_scrollcontent ($box_array_dat['box_options']['ephems_scrollboxheight'], $box_array_dat['box_options']['ephems_scrollboxwidth'], $box_array_dat['box_options']['boxid'], $box_array_dat['box_options']['scroll_hori_ephems']);
			} else {
				$boxstuff .= $ephemboxstuff;
			}
		} else {
			$boxstuff .= _MID_EPHEMERIDS_NOEPHEMERIDS;
		}
		$boxstuff .= $box_array_dat['box_options']['textafter'];
		$box_array_dat['box_result']['skip'] = false;
		$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
		$box_array_dat['box_result']['content'] = $boxstuff;
		unset ($boxstuff);
	} else {
		$box_array_dat['box_result']['skip'] = true;
	}

}

?>