<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/faq', true);
$pubsettings = $opnConfig['module']->GetPublicSettings ();
$privsettings = $opnConfig['module']->GetPrivateSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/faq/admin/language/');

function faq_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_FAQADMIN_SAVE_CHANGES] = _FAQADMIN_SAVE_CHANGES;
	$nav[_FAQADMIN_ADMIN] = _FAQADMIN_ADMIN;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function faqsettings () {

	global $opnConfig, $pubsettings, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _FAQADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _FAQADMIN_NAVI,
			'name' => 'faq_navibox',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['faq_navibox'] == 1?true : false),
			 ($pubsettings['faq_navibox'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _FAQADMIN_CATSPERROW,
			'name' => 'faq_cats_per_row',
			'value' => $privsettings['faq_cats_per_row'],
			'size' => 1,
			'maxlength' => 1);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _FAQADMIN_DISPLAYASLIST,
			'name' => 'faq_displayaslist',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['faq_displayaslist'] == 1?true : false),
			 ($privsettings['faq_displayaslist'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _FAQADMIN_DISPLAYSEARCHONTOP,
			'name' => 'faq_displaysearchontop',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['faq_displaysearchontop'] == 1?true : false),
			 ($privsettings['faq_displaysearchontop'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _FAQADMIN_DEFAULTSEARCHFIELD,
			'name' => 'faq_defaultsearchfield',
			'values' => array (0,1,2),
			'titles' => array (_FAQADMIN_QUESTION.' '._FAQADMIN_AND.' '._FAQADMIN_ANSWER, _FAQADMIN_QUESTION, _FAQADMIN_ANSWER),
			'checked' => array ( ($privsettings['faq_defaultsearchfield'] == 0?true : false),
			  ($privsettings['faq_defaultsearchfield'] == 1?true : false),
			   ($privsettings['faq_defaultsearchfield'] == 2?true : false)));
			 
	$values = array_merge ($values, faq_allhiddens (_FAQADMIN_NAVGENERAL) );
	$set->GetTheForm (_FAQADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/faq/admin/settings.php', $values);

}

function faq_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePublicSettings ();

}

function faq_dosavefaq ($vars) {

	global $pubsettings, $privsettings;

	$pubsettings['faq_navibox'] = $vars['faq_navibox'];
	$privsettings['faq_cats_per_row'] = $vars['faq_cats_per_row'];
	$privsettings['faq_displayaslist'] = $vars['faq_displayaslist'];
	$privsettings['faq_displaysearchontop'] = $vars['faq_displaysearchontop'];
	$privsettings['faq_defaultsearchfield'] = $vars['faq_defaultsearchfield'];	
	faq_dosavesettings ();

}

function faq_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _FAQADMIN_NAVGENERAL:
			faq_dosavefaq ($returns);
			break;
	}

}

$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		faq_dosave ($result);
	} else {
		$result = '';
	}
}

$op = urldecode ($op);
switch ($op) {
	case _FAQADMIN_SAVE_CHANGES:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/faq/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _FAQADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/faq/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		faqsettings ();
		break;
}

?>