<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->InitPermissions ('modules/geodb');
$opnConfig['module']->InitModule ('modules/geodb');
$opnConfig['opnOutput']->setMetaPageName ('modules/geodb');
if ($opnConfig['permission']->HasRights ('modules/geodb', array (_PERM_READ, _PERM_BOT) ) ) {
	getLanguageDef (_OPN_ROOT_PATH . 'modules/geodb/language/');
	include_once (_OPN_ROOT_PATH . 'modules/geodb/class/class.geo.php');

	function geodb_searchform () {

		global $opnConfig;

		$userinput = '';
		get_var ('userinput', $userinput, 'both', _OOBJ_DTYPE_CLEAN);
		$boxtxt = '<span class="normaltextbold">' . _GEODB_SEARCHTITLE . '</span>';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_GEODB_30_', 'geodb');
		$form->Init ($opnConfig['opn_url'] . '/modules/geodb/index.php');
		$form->AddTextfield ('userinput', 30, 200, $userinput);
		$form->AddSubmit ('submit', _GEODB_SEARCH);
		$form->AddNewline (2);
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		if ($userinput !== '') {
			$mygeodb = & new geodb;
			$reccount = $mygeodb->counthits ($userinput);
			$boxtxt .= sprintf (_GEODB_SEARCHRESULTTEXT, $userinput, $reccount) . '<br />';
			if ($reccount>0) {
				$countriesarr = '';
				$mygeodb->get_countryarray ($countriesarr);
				$statesarr = '';
				$mygeodb->get_statearray ($statesarr);
				$hits = '';
				$mygeodb->gethitsarray ($hits, $userinput);
				$boxtxt .= '<ol>';
				foreach ($hits AS $ort) {
					$boxtxt .= '<li>';
					if ($ort['typ']>6) {
						$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/geodb/index.php',
														'op' => 'show',
														'lookupid' => $ort['locationsid'],
														'userinput' => $userinput) ) . '">' . $ort['locationsname'] . '</a><br />';
					} else {
						$boxtxt .= '<span class="normaltextbold"><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/geodb/index.php',
																	'op' => 'show',
																	'lookupid' => $ort['locationsid'],
																	'userinput' => $userinput) ) . '">' . $ort['locationsname'] . '</a></span><br />';
					}
					$boxtxt .= '<span class="smalltext">';
					$mycountry = $ort['adm0'];
					$mystate = $ort['adm1'];
					$boxtxt .= $countriesarr[$mycountry];
					$boxtxt .= ' &gt; ' . $statesarr[$mycountry][$mystate];
					$boxtxt .= ' &gt; ' . $ort['adm3'];
					if ($ort['adm4']) {
						$boxtxt .= ' &gt; ' . $ort['adm4'];
					}
					if ($ort['typ']>6) {
						$boxtxt .= ' &gt; ' . $ort['ort'];
					}
					$boxtxt .= '</span>';
					$boxtxt .= '</li>';
				}
				$boxtxt .= '</ol>';
			}
		} else {
			$boxtxt .= _GEODB_SEARCHHINT;
		}
		return $boxtxt;

	}

	function geodb_showid () {

		global $opnConfig;

		$lookupid = '';
		get_var ('lookupid', $lookupid, 'url', _OOBJ_DTYPE_INT);
		$userinput = '';
		get_var ('userinput', $userinput, 'both', _OOBJ_DTYPE_CLEAN);
		$boxtxt = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/geodb/index.php',
										'userinput' => $userinput) ) . '">' . _GEODB_BACKTOSEARCH . '</a><br /><br />';
		$mygeodb = & new geodb;
		$location = $mygeodb->getlocationarray ($lookupid);
		$boxtxt .= '<span class="bigtextbold">' . $location->dbValues['locationsname'] . '</span><br /><br />';
		$newMap = '';
		get_var ('newMap', $newMap, 'url', _OOBJ_DTYPE_INT);
		$mymap = $mygeodb->getImage ($mygeodb, $location);
		$boxtxt .= '<div style="float:right">';
		$boxtxt .= $mymap['tag'];
		$boxtxt .= '</div>';
		$countriesarr = '';
		$mygeodb->get_countryarray ($countriesarr);
		$statesarr = '';
		$mygeodb->get_statearray ($statesarr);
		$table = & new opn_TableClass ('listalternator');
		$table->AddCols (array ('25%', '75%') );
		$table->AddOpenRow ();
		$table->AddHeaderCol (_GEODB_ADMINISTRATIVEDATA, 'left', '2');
		$table->AddCloseRow ();
		$table->AddDataRow (array (_GEODB_COUNTRY, $countriesarr[$location->dbValues['adm0']]) );
		if ($location->dbValues['adm1']) {
			$table->AddDataRow (array (_GEODB_STATE, $statesarr[$location->dbValues['adm0']][$location->dbValues['adm1']]) );
		}
		if ($location->dbValues['adm2']) {
			$table->AddDataRow (array (_GEODB_ADMINISTRATIVEDISTRICT, $location->dbValues['adm2']) );
		}
		if ($location->dbValues['adm3']) {
			$table->AddDataRow (array (_GEODB_COUNTY, $location->dbValues['adm3']) );
		}
		if ($location->dbValues['adm4']) {
			$table->AddDataRow (array (_GEODB_ASSOCOFADMIN, $location->dbValues['adm4']) );
		}
		if ($location->dbValues["typ"]>6) {
			$table->AddDataRow (array (_GEODB_CITYCOMMUNE, $location->dbValues['ort']) );
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />';
		$table = & new opn_TableClass ('listalternator');
		$table->AddCols (array ('25%', '75%') );
		$table->AddOpenRow ();
		$table->AddHeaderCol (_GEODB_COORDINATES, 'left', '2');
		$table->AddCloseRow ();
		$table->AddDataRow (array (_GEODB_LONGITUDE, $location->dbValues["laenge"] . ' &nbsp;/&nbsp; ' . $location->longitudeDMS) );
		$table->AddDataRow (array (_GEODB_LATITUDE, $location->dbValues["breite"] . ' &nbsp;/&nbsp; ' . $location->latitudeDMS) );
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />';
		$table = & new opn_TableClass ('listalternator');
		$table->AddCols (array ('25%', '75%') );
		$table->AddOpenRow ();
		$table->AddHeaderCol (_GEODB_ADDINFOS, 'left', '2');
		$table->AddCloseRow ();
		if ($location->dbValues['gs']) {
			$table->AddDataRow (array (_GEODB_COMMUNEID, $location->dbValues['gs']) );
		}
		if ($location->dbValues['kfz']) {
			$table->AddDataRow (array (_GEODB_LICENSEPLATE, $location->dbValues['kfz']) );
		}
		if ($location->dbValues['plz']) {
			$plz = explode (',', $location->dbValues['plz']);
			if (count ($plz)>3) {
				$table->AddDataRow (array (_GEODB_ZIPCODES, $plz[0] . ', ' . $plz[1] . ', ' . $plz[2] . ' <a href="#" title="' . join (', ', $plz) . '">...</a>') );
			} else {
				$table->AddDataRow (array (_GEODB_ZIPCODES, join (', ', $plz) ) );
			}
		}
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />';
		$range = 25;
		$lochits = $mygeodb->findCloseByGeoObjects ($location, $range, false);
		if (is_array ($lochits) && count ($lochits)>1) {
			$boxtxt .= '<span class="normaltextbold">' . sprintf (_GEODB_LOCATIONSWITHIN, $range) . '</span><br />';
			$boxtxt .= '<ol>';
			foreach ($lochits as $ort) {
				if ($location->dbValues['locationsid'] != $ort->dbValues['locationsid']) {
					$boxtxt .= '<li>';
					if ($ort->dbValues['typ']>6) {
						$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/geodb/index.php',
														'op' => 'show',
														'lookupid' => $ort->dbValues['locationsid'],
														'userinput' => $userinput) ) . '">' . $ort->dbValues['locationsname'] . '</a>';
					} else {
						$boxtxt .= '<strong><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/geodb/index.php',
															'op' => 'show',
															'lookupid' => $ort->dbValues['locationsid'],
															'userinput' => $userinput) ) . '">' . $ort->dbValues['locationsname'] . '</a></strong>';
					}
					$boxtxt .= '<br />';
					$boxtxt .= '<span class="smalltext">';
					$boxtxt .= $countriesarr[$ort->dbValues['adm0']];
					$boxtxt .= ' &gt; ' . $statesarr[$ort->dbValues['adm0']][$ort->dbValues['adm1']];
					$boxtxt .= ' &gt; ' . $ort->dbValues['adm3'];
					if ($ort->dbValues['adm4']) {
						$boxtxt .= ' &gt; ' . $ort->dbValues['adm4'];
					}
					if ($ort->dbValues['typ']>6) {
						$boxtxt .= ' &gt; ' . $ort->dbValues['ort'];
					}
					$boxtxt .= '<br />' . _GEODB_DISTANCE . ': ' . $location->getDistanceString ($ort);
					$boxtxt .= '</span>';
					$boxtxt .= '</li>';
				}
			}
			$boxtxt .= '</ol>';
		}
		return $boxtxt;

	}
	$boxtxt = '';
	$op = '';
	get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
	switch ($op) {
		default:
			$boxtxt .= geodb_searchform ();
			break;
		case 'show':
			$boxtxt .= geodb_showid ();
			break;
	}
	if ($boxtxt != '') {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GEODB_40_';
		$_display_dat['module'] = 'modules/geodb';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_GEODB_HEAD, $boxtxt, _GEODB_FOOTER);
	}
}

?>