<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/*
* Makros:
*
* class OPN_MACRO_XL_[makroname]
*
* 	function parse (&$text) {
*    			...
* 	}
*
* }
*
*/

class OPN_MACRO_XL_modul_glossar {
	var $search = array ();
	var $replace = array ();

	function OPN_MACRO_XL_modul_glossar () {

		global $opnConfig, $opnTables;

		$i = 0;
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
		$mf = & new CatFunctions ('glossary');
		$mf->itemtable = $opnTables['glossary'];
		$mf->itemid = 'gloid';
		$mf->itemlink = 'catid';
		$mf->itemwhere = "status = ''";
		$css = 'opn' . $opnConfig['opnOutput']->GetDisplaySide () . 'box';
		$result = $mf->GetItemResult (array ('gloid',
						'keyphrase',
						'catid'),
						array (),
			'');
		if ( ($result !== false) && ($result->fields !== false) ) {
			while (! $result->EOF) {
				$id = $result->fields['gloid'];
				$term = $result->fields['keyphrase'];
				$catid = $result->fields['catid'];
				$link = '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
											'op' => 'listword',
											'word' => htmlentities ($term),
											'catid' => $catid) ) . '" target="_blank" ' . 'onclick="NewWindow(\'' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
															'op' => 'listword',
															'word' => htmlentities ($term),
															'catid' => $catid) ) . '\',\'glossar\',400,200);return false">' . $term . '</a>';
				$this->search[$i] = '#(?!<.*?)(\b' . preg_quote ($term) . '\b)(?![^<>]*?>)#i';
				$this->replace[$i] = $link;
				$i++;
				$result->MoveNext ();
			}
		}

	}

	function parse (&$text) {

		$haslinks = false;
		$hasselect = false;
		$hasscript = false;
		$hastitle = false;
		$hasimg = false;
		if ( (substr_count (strtolower ($text), '<a ')>0) ) {
			$haslinks = true;
			replace_tag ($text, 'a', $links = array () );
		}
		if ( (substr_count (strtolower ($text), '<select ')>0) ) {
			$hasselect = true;
			replace_tag ($text, 'select', $selects = array () );
		}
		if ( (substr_count (strtolower ($text), '<script')>0) ) {
			$hasscript = true;
			$scripts = array ();
			replace_tag ($text, 'script', $scripts);
		}
		if ( (substr_count (strtolower ($text), '<img')>0) ) {
			$hasimg = true;
			$images = array ();
			replace_tag ($text, 'img', $images);
		}
		if ( (substr_count (strtolower ($text), 'title="')>0) ) {
			$hastitle = true;
			$titles = array ();
			replace_attribute ($text, 'title', $titles);
		}
		$text = preg_replace ($this->search, $this->replace, $text);
		if ($haslinks) {
			restore_tag ($text, 'a', $links);
			unset ($links);
		}
		if ($hasselect) {
			restore_tag ($text, 'select', $selects);
			unset ($selects);
		}
		if ($hasscript) {
			restore_tag ($text, 'script', $scripts);
			unset ($scripts);
		}
		if ($hasimg) {
			restore_tag ($text, 'img', $images);
			unset ($images);
		}
		if ($hastitle) {
			restore_attribute ($text, 'title', $titles);
			unset ($titles);
		}

	}

}

?>