<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/glossar/plugin/search/language/');

function glossar_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'glossar';
	$button['sel'] = 0;
	$button['label'] = _GLOSSAR_SEARCH_GLOSSAR;
	$buttons[] = $button;
	unset ($button);

}

function glossar_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'glossar':
			glossar_retrieve_all ($query, $data, $sap);
		}
	}

	function glossar_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = glossar_get_query ($query);
		$q .= glossar_get_order ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if (is_object ($result) ) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _GLOSSAR_SEARCH_GLOSSAR;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$keyphrase = $result->fields['keyphrase'];
					$definition = $result->fields['definition'];
					$catid = $result->fields['catid'];
					$hlp1['data'] = glossar_build_link ($keyphrase, $catid);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function glossar_build_link ($keyphrase, $catid) {

		global $opnConfig;

		$furl = encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/index.php',
					'op' => 'listword',
					'word' => $keyphrase,
					'catid' => $catid) );
		$onclick = "onclick=\"NewWindow('" . $furl . "','test',400,200);return false\"";
		$hlp = '<a class="%linkclass%" href="' . $furl . '" target="_blank" ' . $onclick . '>' . $keyphrase . '</a>&nbsp;';
		return $hlp;

}

function glossar_get_query ($query) {

	global $opnTables, $opnConfig;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('l.keyphrase',
							'l.definition',
							'l.catid') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['glossary']);
	$opnConfig['opn_searching_class']->SetTable ($opnTables['glossary'] . ' l, ' . $opnTables['glossary_cats'] . ' c');
	$opnConfig['opn_searching_class']->SetWhere (" status='' AND c.cat_usergroup IN (" . $checkerlist . ') AND');
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('l.keyphrase',
								'l.definition') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function glossar_get_order () {
	return ' ORDER BY keyphrase ASC';

}

?>