<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_xml.php');

class RSS_feed extends opn_xml {
	// The object of the parser is to determine the "State" of the RSS/XML
	// and set up the class to respond accordingly. The critical information
	// is in the _handle_character_data function as that is WHERE the
	// feed information can be found.

	/*<{php4}>
	var $output;    // Where the results will be stored
	var $limit;     // The maximum number of links we want
	var $cssclass;
	var $_prefix;
	var $_suffix;
	var $_isnewwindow = false;
	var $_linesize = 0;
	var $_isscroller = false;
	<{php4/}>*/

	/*<{php5}>
	private $output;    // Where the results will be stored
	private $limit;     // The maximum number of links we want
	private $cssclass;
	private $_prefix;
	private $_suffix;
	private $_isnewwindow = false;
	private $_linesize = 0;
	private $_isscroller = false;
	<{php5/}>*/

	/*<{delete}>*/
	var $output;    // Where the results will be stored
	var $limit;     // The maximum number of links we want
	var $cssclass;
	var $_prefix;
	var $_suffix;
	var $_isnewwindow = false;
	var $_linesize = 0;
	var $_isscroller = false;
	/*<{delete/}>*/
	// Define the functions required for handling the different pieces.

	function RSS_feed () {
		// Constructor
		$this->output = '';
		$this->limit = 0;
		// use 0 as default == all
		$this->cssclass = '';
		$this->_prefix = '';
		$this->_suffix = '';
		$this->opn_xml ();
		$this->_isnewwindow = false;
		$this->GetAttributes (true);

	}
	// METHODS AND PROPERTIES *****************************************

	function SetCSSClass ($css) {

		$this->cssclass = $css;

	}

	function SetPrefix ($prefix) {

		$this->_prefix = $prefix;

	}

	function SetSuffix ($suffix) {

		$this->_suffix = $suffix;

	}

	function SetLinesize ($size) {

		$this->_linesize = $size;

	}

	function Set_Limit ($cnt) {
		// This property sets the limit of links to return
		// if $cnt is not numeric, 0 is returned! You get the entire list!
		$i = intval ($cnt);
		if ($i>0) {
			$this->limit = $i;
		}

	}

	function Set_NewWindow ($newwindow = true) {

		$this->_isnewwindow = $newwindow;

	}

	function Set_Scroller ($scroller = true) {

		$this->_isscroller = $scroller;

	}

	function Get_Results () {

		global $opnConfig;
		if ($this->contents != '') {
			if (isset ($this->index['feed']) ) {
				$link = 'link_attribute_href';
			} else {
				$link = 'link';
			}
			$items = array ();
			$isopen = false;
			$i = 0;
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_convert_charset.php');
			$convert = & new ConvertCharset;
			$feed = $this->contents;
			if (isset ($this->items['rss']) ) {
				$items = $this->items['rss']['channel']['item'];
			} elseif (isset ($this->items['rdf:RDF']) ) {
				$items = $this->items['rdf:RDF']['item'];
			} elseif (isset ($this->items['feed']) ) {
				$items = $this->items['feed']['entry'];
			}
			$counter = count ($items);
			if ($counter) {
				if ($this->limit) {
					if ($this->limit<$counter) {
						$counter = $this->limit;
					}
				}
				$target = '';
				if ($this->_isnewwindow) {
					$target = ' target="_blank"';
				}
				if ($this->_isscroller) {
					$endlink = '<\/a>';
				} else {
					$endlink = '</a>';
				}
				for ($i = 0; $i< $counter; $i++) {
					if (isset ($items[$i][$link]) ) {
						if ( ($this->encoding != $opnConfig['opn_charset_encoding']) ) {
							$title = $convert->Convert ($items[$i]['title'], $this->encoding, $opnConfig['opn_charset_encoding'], true);
						} else {
							$title = $items[$i]['title'];
						}
						$title = str_replace ('"', '\'', $title);
						$title1 = strip_tags ($title);
						$opnConfig['cleantext']->opn_shortentext ($title, $this->_linesize);
						$this->output .= $this->_prefix . '<a class="' . $this->cssclass . '" href="' . htmlspecialchars ($items[$i][$link]) . '"' . $target . ' title="' . $title1 . '">' . $title . $endlink . $this->_suffix;
					}
				}
			}
			unset ($items);
		}
		return $this->output;

	}

}
// end of class

?>