<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

class Guestbook {
	var $admin = false;

	function Guestbook () {

		global $opnConfig;
		if ($opnConfig['permission']->HasRight ('modules/myguestbook', _PERM_ADMIN, true) ) {
			$this->admin = true;
		} else {
			$this->admin = false;
		}

	}

	function getTotal ($id, $type) {

		global $opnTables, $opnConfig;
		switch ($type) {
			case 'users':
				$sql = 'SELECT COUNT(guest_id) AS counter FROM ' . $opnTables['myguestbook'] . ' WHERE (wstatus=0) AND (guest_poster = ' . $id . ')';
				break;
			case 'all':
				$sql = 'SELECT COUNT(guest_id) AS counter FROM ' . $opnTables['myguestbook'] . ' WHERE (wstatus=0) AND (guest_id>0)';
				break;
		}
		$result = &$opnConfig['database']->Execute ($sql);
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			$num = $result->fields['counter'];
		} else {
			$num = 0;
		}
		$result->Close ();
		return $num;

	}

	function show () {

		global $opnTables, $opnConfig;

		$start = 0;
		get_var ('start', $start, 'both', _OOBJ_DTYPE_INT);
		$total_guests = $this->getTotal ('0', 'all');
		if ($total_guests>$opnConfig['mygb_guests_per_page']) {
			$times = 0;
			for ($x = 0; $x< $total_guests; $x += $opnConfig['mygb_guests_per_page']) {
				$times++;
			}
			$pages = $times;
		} else {
			$pages = 1;
		}
		$table = & new opn_TableClass ('default');
		$table->AddOpenRow ();
		$hlp = '';
		if ($opnConfig['permission']->HasRight ('modules/myguestbook', _PERM_WRITE, true) ) {
			$hlp .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/myguestbook/index.php?op=addguest') . '"><img src="' . $opnConfig['opn_url'] . '/modules/myguestbook/images/guestbook.gif" class="imgtag" alt="" /></a><br />';
		}
		$hlp .= '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/index.php">' . $opnConfig['sitename'] . '</a> <span class="alerttext">&raquo;&raquo;</span> <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_GUESTBOOK . '</a>';
		$table->AddDataCol ($hlp, 'left');
		if ($opnConfig['permission']->HasRight ('modules/myguestbook', _PERM_WRITE, true) ) {
			$hlp = '<a class="txtbutton" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/myguestbook/index.php?op=addguest') . '">' . _MYGB_SIGN_THE_GUESTBOOK . '</a>';
		} else {
			$hlp = '&nbsp;';
		}
		$table->AddDataCol ($hlp, 'right');
		$table->AddCloseRow ();
		$boxtxt = '';
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />';
		if ($total_guests>$opnConfig['mygb_guests_per_page']) {
			$table = & new opn_TableClass ('default');
			$times = 1;
			$hlp = '<span class="normaltextbold">' . $pages . '</span> ' . _MYGB_PAGES . ' ( ';
			for ($x = 0; $x< $total_guests; $x += $opnConfig['mygb_guests_per_page']) {
				if ($times != 1) {
					$hlp .= ' | ';
				}
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/index.php',
											'start' => $x) ) . '">' . $times . '</a>';
				$times++;
			}
			$hlp .= ' )';
			$table->AddDataRow (array ($hlp), array ('right') );
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br />';
		}
		if ($opnConfig['permission']->IsUser () ) {
			$userdata = $opnConfig['permission']->GetUserinfo ();
		} else {
			$userdata = $opnConfig['permission']->GetUser ('1', '', '');
		}
		if (!$start) {
			$start = 0;
		}
		$sql = 'SELECT guest_id, guest_title, guest_body, guest_poster, guest_time, guest_views, guest_image, guest_ip, guest_name, guest_email, guest_datum, guest_modus FROM ' . $opnTables['myguestbook'] . ' WHERE (wstatus=0) ORDER BY guest_id DESC';
		$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['mygb_guests_per_page'], $start);
		if ( ($result === FALSE) OR ($result->RecordCount () == 0) ) {
			$boxtxt .= _MYGB_THERE_ARE_NO_MESSAGES . _OPN_HTML_NL;
			$boxtxt .= '<br />';
		} else {
			$myrow = $result->GetArray ();
			$maxi = count ($myrow);
			for ($mycount = 0; $mycount< $maxi; $mycount++) {
				$table = & new opn_TableClass ('alternator');
				if ( ($this->admin) || ( ($myrow[$mycount]['guest_poster'] == $userdata['uid']) ) && ($myrow[$mycount]['guest_poster'] != $opnConfig['opn_anonymous_id']) ) {
					$table->AddCols (array ('20', '450', '20', '100') );
				} else {
					$table->AddCols (array ('20', '450', '20') );
				}
				$table->AddOpenHeadRow ();
				$table->AddHeaderCol (_MYGB_ICON);
				$table->AddHeaderCol (_MYGB_TITLE);
				$table->AddHeaderCol (_MYGB_DATE);
				if ( ($this->admin) || ( ($myrow[$mycount]['guest_poster'] == $userdata['uid']) ) && ($myrow[$mycount]['guest_poster'] != $opnConfig['opn_anonymous_id']) ) {
					$table->AddHeaderCol (_MYGB_ACTION);
				}
				$table->AddCloseRow ();
				$table->AddOpenRow ();
				if ($myrow[$mycount]['guest_image'] != '') {
					$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/myguestbook/images/subject/' . $myrow[$mycount]['guest_image'] . '" alt="" />', 'center', '', 'middle');
				} else {
					$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/modules/myguestbook/images/icons/posticon.gif" alt="" />', 'center', '', 'middle');
				}
				if ($myrow[$mycount]['guest_modus'] == 0) {
					opn_nl2br ($myrow[$mycount]['guest_title']);
					$hlp = $myrow[$mycount]['guest_title'];
				} else {
					$hlp = $myrow[$mycount]['guest_body'];
				}
				$table->AddDataCol ($hlp, 'left', '', 'top');
				$opnConfig['opndate']->sqlToopnData ($myrow[$mycount]['guest_time']);
				$temp = '';
				$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
				$table->AddDataCol ($temp, 'left', '', 'top');
				// if admin or poster show action
				if ( ($this->admin) || ( ($myrow[$mycount]['guest_poster'] == $userdata['uid']) ) && ($myrow[$mycount]['guest_poster'] != $opnConfig['opn_anonymous_id']) ) {
					$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/index.php',
												'op' => 'editguest',
												'id' => $myrow[$mycount]['guest_id']) ) . '">' . _MYGB_EDIT . '</a>';
					$hlp .= '&nbsp;|&nbsp;';
					$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/index.php',
												'op' => 'delguest',
												'id' => $myrow[$mycount]['guest_id']) ) . '">' . _MYGB_DELETE . '</a>';
					$table->AddDataCol ($hlp, 'left', '', 'top');
					$table_colspan = 5;
				} else {
					$table_colspan = 4;
				}
				$table->AddChangeRow ();
				$table->SetAutoAlternator ('1');
				if ($myrow[$mycount]['guest_modus'] == 0) {
					$guestmess = $myrow[$mycount]['guest_body'];
					if ($opnConfig['mygb_guest_allow_smilies']) {
						$guestmess = smilies_smile ($guestmess);
					}
					if ($opnConfig['mygb_guest_allow_bbcode']) {
						include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
						$ubb = & new UBBCode;
						$ubb->ubbencode ($guestmess);
					}
					opn_nl2br ($guestmess);
					$table->AddDataCol ($guestmess, 'left', $table_colspan, 'top');
				}
				$table->AddChangeRow ();
				$hlp = '';
				if ($myrow[$mycount]['guest_modus'] == 0) {
					$hlp .= '->&nbsp;';
					if ($myrow[$mycount]['guest_poster'] != $opnConfig['opn_anonymous_id']) {
						$posterdata = $opnConfig['permission']->GetUser ($myrow[$mycount]['guest_poster'], 'useruid', '');
						$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
													'op' => 'userinfo',
													'uname' => $posterdata['uname']) ) . '" target="_blank">';
						$hlp .= $posterdata['uname'];
						$hlp .= '</a>';
						if ($this->admin) {
							if (isset ($myrow[$mycount]['guest_ip']) || $myrow[$mycount]['guest_ip'] != '') {
								$hlp .= '&nbsp;&nbsp;(IP: ' . $myrow[$mycount]['guest_ip'] . ')';
							}
						}
					} else {
						$hlp .= '' . $opnConfig['anonymous'];
						if ($this->admin) {
							if (isset ($myrow[$mycount]['guest_ip']) || $myrow[$mycount]['guest_ip'] != '') {
								$hlp .= '&nbsp;&nbsp;(IP: ' . $myrow[$mycount]['guest_ip'] . ')';
							}
						}
					}
				} else {
					if (isset ($myrow['guest_name']) ) {
						$hlp .= ($myrow['guest_name']);
					} else {
						$hlp .= '';
					}
					$hlp .= (' --- ');
					$hlp .= ('<a class="%alternate%" href="mailto:' . $myrow[$mycount]['guest_email'] . '">' . $myrow[$mycount]['guest_email'] . '</a>');
				}
				$table->AddDataCol ($hlp, 'right', $table_colspan, 'top');
				$table->SetAutoAlternator ();
				$table->AddCloseRow ();
				$table->GetTable ($boxtxt);
				$boxtxt .= '<br />';
			}
		}
		return $boxtxt;

	}

	function showInterface () {

		global $opnTables, $opnConfig;

		$id = 0;
		get_var ('id', $id, 'both', _OOBJ_DTYPE_INT);
		$userdata = $opnConfig['permission']->GetUserinfo ();
		$poster_id = $userdata['uid'];
		$poster_nickname = $userdata['uname'];
		if ($poster_id == $opnConfig['opn_anonymous_id']) {
			$poster_nickname .= ' (<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/register.php">' . _MYGB_REGISTER . '</a> / <a href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _MYGB_LOGIN . '</a> ' . _MYGB_TO_SIGN . ')';
		}
		if ($id != 0) {
			$sql = 'SELECT guest_id, guest_title, guest_body, guest_poster, guest_time, guest_views, guest_image, guest_ip, guest_name, guest_email, guest_datum, guest_modus FROM ' . $opnTables['myguestbook'] . ' WHERE (wstatus=0) AND (guest_id = ' . $id . ')';
			$result = &$opnConfig['database']->Execute ($sql);
			if (!is_object ($result) ) {
				$stop = 1;
			}
			$myrow = $result->GetArray ();
			if (is_array ($myrow) ) {
				if (!$this->admin) {
					if ($myrow[0][3] != $userdata['uid']) {
						$stop = 1;
					}
					if ($myrow[0][3] == $opnConfig['opn_anonymous_id']) {
						$stop = 1;
					}
				}
				if (!isset ($stop) ) {
					$stop = '';
				}
				if (!$stop) {
					$guest_id = $id;
					$guest_title = $myrow[0]['guest_title'];
					$guest_body = $myrow[0]['guest_body'];
					$guest_poster = $myrow[0]['guest_poster'];
					// $opnConfig['opndate']->sqlToopnData($myrow[0]['guest_time']);
					$guest_time='';
					// $opnConfig['opndate']->formatTimestamp($guest_time,_DATE_DATESTRING2);
					// $guest_views = $myrow[0]['guest_views'];
					$guest_image = $myrow[0]['guest_image'];
					// $guest_ip = $myrow[0]['guest_ip'];
					$posterdata = $opnConfig['permission']->GetUser ($guest_poster, 'useruid', '');
					$poster_id = $posterdata['uid'];
					$poster_nickname = $posterdata['uname'];
				}
			} else {
				$stop = 1;
			}
		}
		$boxtxt = '';
		if ( (!isset ($stop) ) OR (!$stop) ) {
			$table = & new opn_TableClass ('default');
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/index.php">' . $opnConfig['sitename'] . '</a>  <span class="alerttext">&raquo;&raquo;</span>  <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_GUESTBOOK . '</a>', 'left');
			$table->AddCloseRow ();
			$boxtxt = '';
			$table->GetTable ($boxtxt);
			if (!isset ($guest_title) ) {
				$guest_title = '';
			}
			if (!isset ($guest_image) ) {
				$guest_image = '';
			}
			if (!isset ($guest_body) ) {
				$guest_body = '';
			}
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MYGUESTBOOK_30_', 'myguestbook');
			$form->Init ($opnConfig['opn_url'] . '/modules/myguestbook/index.php');
			$form->AddTable ();
			$form->AddCols (array ('10%', '90%') );
			$form->AddOpenRow ();
			$form->AddText (_MYGB_NICKNAME);
			$form->AddText ($poster_nickname);
			$form->AddChangeRow ();
			$form->AddLabel ('guest_title', _MYGB_TITLEP);
			$form->AddTextfield ('guest_title', 50, 100, $guest_title);
			$form->AddChangeRow ();
			$form->AddText (_MYGB_MESSAGE_ICON);
			$form->SetSameCol ();
			$form->AddHidden ('guest_poster', $poster_id);
			$filelist = get_file_list (_OPN_ROOT_PATH . 'modules/myguestbook/images/subject');
			asort ($filelist);
			$count = 1;
			foreach ($filelist as $file) {
				if ( ($file != '.') && ($file != '..') && ($file != 'index.html') ) {
					$form->AddRadio ('guest_image', $file, ($file == $guest_image?1 : 0) );
					$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/myguestbook/images/subject/' . $file . '" class="imgtag" alt="" />&nbsp;');
				}
				if ($count == 8) {
					$form->AddText ('<br />');
					$count = 1;
				} else {
					$count++;
				}
			}
			$form->AddText ('&nbsp;');
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddText (_MYGB_MESSAGE . '<br />');
			$form->AddText ('HTML : ');
			if ($opnConfig['mygb_guest_allow_html'] == 1) {
				$form->AddText ('On');
			} else {
				$form->AddText ('Off');
				$form->UseEditor (false);
				$form->UseWysiwyg (false);
			}
			if ($opnConfig['mygb_guest_allow_bbcode'] == 1) {
				$form->UseBBCode (true);
			}
			$form->AddNewline (2);
			$form->AddText ('<a class="listalternator" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/bbcode_ref.php" target="blank">BBCode</a> : ');
			if ($opnConfig['mygb_guest_allow_bbcode'] == 1) {
				$form->AddText ('On');
			} else {
				$form->AddText ('Off');
			}
			$form->AddNewline (2);
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
				$form->AddText ('<a class="listalternator" href="' . $opnConfig['opn_url'] . '/system/smilies/" target="blank">Smilies</a> : ');
				if ($opnConfig['mygb_guest_allow_smilies'] == 1) {
					$form->AddText ('On');
					$form->UseSmilies (true);
				} else {
					$form->AddText ('Off');
				}
			}
			$form->AddText ('&nbsp;');
			$form->SetEndCol ();
			$form->AddTextarea ('guest_body', 0, 0, '', $guest_body);
			if ( ($opnConfig['mygb_guest_allow_html']>0) || ($opnConfig['mygb_guest_allow_bbcode']>0) || ($opnConfig['mygb_guest_allow_smilies']>0) ) {
				$form->AddChangeRow ();
				$form->AddText (_MYGB_OPTIONS);
				$form->SetSameCol ();
				if ($opnConfig['mygb_guest_allow_html'] == 1) {
					$form->AddCheckbox ('html', 1);
					$form->AddLabel ('html', _MYGB_DISABLE_HTML_ON_THIS_ENTRY, 1);
					$form->AddNewline (1);
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
					if ($opnConfig['mygb_guest_allow_smilies'] == 1) {
						$form->AddCheckbox ('smilies', 1);
						$form->AddLabel ('smilies', _MYGB_DISABLE . ' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/smilies/" target="_blank">' . _MYGB_SMILIES . '</a> ' . _MYGB_ON_THIS_ENTRY, 1);
						$form->AddNewline (1);
					} else {
						$form->AddHidden ('smilies', 0);
					}
				}
				if ($opnConfig['mygb_guest_allow_bbcode'] == 1) {
					$form->AddCheckbox ('bbcode', 1);
					$form->AddLabel ('bbcode', _MYGB_DISABLE . ' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/bbcode_ref.php" target="_blank">' . _MYGB_BBCODE . '</a> ' . _MYGB_ON_THIS_ENTRY, 1);
				}
				$form->AddText ('&nbsp;');
				$form->SetEndCol ();
			}
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('op', 'saveguest');
			if (!isset ($guest_id) ) {
				$guest_id = '';
			}
			$form->AddHidden ('id', $guest_id);
			$form->SetEndCol ();
			$form->SetSameCol ();
			$form->AddSubmit ('submit', _MYGB_SUBMIT);
			$form->AddText ('&nbsp;');
			$form->AddReset ('reset', _MYGB_RESET);
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('cancel', _MYGB_CANCEL_POST);
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
		} else {
			$boxtxt .= '<div align="center" class="normaltextbold">' . _MYGB_SORRY_NOT_ALLOWED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_RETURN . '</div></a>';
		}
		return $boxtxt;

	}

	function save () {

		global $opnConfig, $opnTables;

		$stop = '';
		$guest_poster = '';
		get_var ('guest_poster', $guest_poster, 'form', _OOBJ_DTYPE_CLEAN);
		$guest_title = '';
		get_var ('guest_title', $guest_title, 'form', _OOBJ_DTYPE_CLEAN);
		$guest_body = '';
		get_var ('guest_body', $guest_body, 'form', _OOBJ_DTYPE_CHECK);
		$guest_image = '';
		get_var ('guest_image', $guest_image, 'form', _OOBJ_DTYPE_CHECK);
		$id = 0;
		get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
		if ( ($guest_title == '') OR ($guest_body == '') ) {
			$stop = 1;
		}
		if ( (isset ($id) ) || ($id != 0) || ($id != '') ) {
			$guest_id = $id;
		}
		if ($stop != 1) {
			$guest_title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($guest_title, true, true, 'nohtml') );
			$strip = '';
			if (!$opnConfig['mygb_guest_allow_html']) {
				$strip = 'nohtml';
			}
			$guest_body = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($guest_body, true, true, $strip), 'guest_body');
			$guest_ip = get_real_IP ();
			$guest_views = 0;
			if (!isset ($guest_id) ) {
				$guest_id = 0;
			}
			$boxtxt = '';
			$opnConfig['opndate']->now ();
			$now = '';
			$opnConfig['opndate']->opnDataTosql ($now);
			$_guest_image = $opnConfig['opnSQL']->qstr ($guest_image);
			$_guest_ip = $opnConfig['opnSQL']->qstr ($guest_ip);
			if ($guest_id>0) {
				$sql = 'UPDATE ' . $opnTables['myguestbook'] . " SET guest_title=$guest_title, guest_body=$guest_body, guest_poster=$guest_poster, guest_time=$now, guest_views=$guest_views, guest_image=$_guest_image, guest_ip=$_guest_ip WHERE (guest_id = $guest_id)";
				$opnConfig['database']->Execute ($sql);
				if ($opnConfig['database']->ErrorNo ()>0) {
					$boxtxt .= 'Error#: ' . $opnConfig['database']->ErrorNo () . '<br />';
					$boxtxt .= 'Error: ' . $opnConfig['database']->ErrorMsg () . '<br />';
					die ('<span class="normaltextbold">Error: </span><span class="alerttext">Could not enter data into the database. Please go back and try again.</span>');
				}
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['myguestbook'], 'guest_id=' . $guest_id);
				$boxtxt .= '<div class="centertag">' . _MYGB_YOUR_GUESTBOOK_ENTRY_UPDATED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_VIEW_POST . '</div></a>';
			} else {
				$modmodus = 0;
				if (isset ($opnConfig['mygb_myguestbook_mod_modus']) ) {
					$modmodus = $opnConfig['mygb_myguestbook_mod_modus'];
				}
				$sql = 'SELECT guest_id, guest_title, guest_body FROM ' . $opnTables['myguestbook'] . ' WHERE (guest_body='.$guest_body.')';
				$result = &$opnConfig['database']->Execute ($sql);
				if ( ($result === FALSE) OR ($result->RecordCount () == 0) ) {
					$guest_id = $opnConfig['opnSQL']->get_new_number ('myguestbook', 'guest_id');
					$sql = 'INSERT INTO ' . $opnTables['myguestbook'] . " (guest_id, guest_title, guest_body, guest_poster, guest_time, guest_views, guest_image, guest_ip, wstatus) VALUES ($guest_id, $guest_title, $guest_body, $guest_poster, $now, $guest_views, $_guest_image, $_guest_ip, $modmodus)";
					$opnConfig['database']->Execute ($sql);
					if ($opnConfig['database']->ErrorNo ()>0) {
						$boxtxt .= 'Error: ' . $opnConfig['database']->ErrorMsg () . '<br />';
						die ('<span class="normaltextbold">Error: </span><span class="alerttext">Could not enter data into the database. Please go back and try again.</span>');
					}
					$opnConfig['opnSQL']->UpdateBlobs ($opnTables['myguestbook'], 'guest_id=' . $guest_id);

					if ($opnConfig['mygb_new_guestbook_notify'] == 1) {
						if (!defined ('_OPN_MAILER_INCLUDED') ) {
							include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
						}
						$vars['{TITLE}'] = $guest_title;
						$vars['{CONTENT}'] = $guest_body;
						$vars['{URL}'] = $opnConfig['opn_url'] . '/modules/myguestbook/index.php';
						$vars['{IP}'] = $guest_ip;
						$subject = _MYGB_NEW_MESSAGE_IN_GB . $opnConfig['sitename'];
						$mail = & new opn_mailer ();
						$mail->opn_mail_fill ($opnConfig['adminmail'], $subject, 'modules/myguestbook', 'newentry', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
						$mail->send ();
						$mail->init ();
					}
				}
				if ($modmodus == 0) {
					$boxtxt .= '<div class="centertag">' . _MYGB_YOUR_MESSAGE_HAS_BEEN_POSTED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_VIEW_YOUR_ENTRY . '</a></div>';
				} else {
					$boxtxt .= '<div class="centertag">' . _MYGB_THANKYOUWAIT . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_RETURN . '</a></div>';
				}
			}
		} else {
			$boxtxt = _MYGB_YOU_MUST_PROVIDE_SUBJECT_AND_MESSAGE;
		}
		return $boxtxt;

	}

	function delete () {

		global $opnTables, $opnConfig;
		if ($opnConfig['permission']->IsUser () ) {
			$userdata = $opnConfig['permission']->GetUserinfo ();
		} else {
			$userdata = $opnConfig['permission']->GetUser ('1', '', '');
		}
		$boxtxt = '';
		$confirm = '';
		get_var ('confirm', $confirm, 'both', _OOBJ_DTYPE_CLEAN);
		$id = 0;
		get_var ('id', $id, 'both', _OOBJ_DTYPE_INT);
		$stop = 0;
		if (isset ($id) ) {
			$sql = 'SELECT guest_id, guest_title, guest_body, guest_poster, guest_time, guest_views, guest_image, guest_ip, guest_name, guest_email, guest_datum, guest_modus FROM ' . $opnTables['myguestbook'] . ' WHERE guest_id = ' . $id;
			$result = &$opnConfig['database']->Execute ($sql);
			if (!is_object ($result) ) {
				$stop = 1;
			}
			$myrow = $result->GetArray ();
			if (is_array ($myrow) ) {
				if (!$this->admin) {
					if ( ($myrow[0]['guest_poster'] != $userdata['uid']) || ($myrow[0]['guest_poster'] == $opnConfig['opn_anonymous_id']) ) {
						$stop = 1;
					}
				}
			}
		}
		if (!$stop) {
			if ($confirm == 'yes') {
				$sql = 'DELETE FROM ' . $opnTables['myguestbook'] . ' WHERE guest_id = ' . $id;
				$opnConfig['database']->Execute ($sql);
				if ($opnConfig['database']->ErrorNo ()>0) {
					$stop = 1;
				}
				if (!$stop) {
					$boxtxt .= '<div class="centertag">' . _MYGB_YOU_MUST_PROVIDE_SUBJECT . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_RETURN . '</div></a>';
				} else {
					$boxtxt .= '<div class="centertag">' . _MYGB_ERROR_DEL . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_RETURN . '</div></a>';
				}
			} else {
				$boxtxt .= '<div class="centertag">';
				$boxtxt .= _MYGB_REALLY_WANT_TO_DELETE;
				$boxtxt .= '<br />';
				$boxtxt .= '<br />';
				$boxtxt .= '&nbsp;';
				$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/index.php',
												'op' => 'delguest',
												'id' => $id,
												'confirm' => 'yes') ) . '">' . _YES . '</a>';
				$boxtxt .= '&nbsp;&nbsp;&nbsp;';
				$boxtxt .= '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _NO . '</a>';
				$boxtxt .= '</div>';
			}
		} else {
			$boxtxt .= '<div align="center" class="normaltextbold">' . _MYGB_SORRY_NOT_ALLOWED_DELETE . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/myguestbook/index.php">' . _MYGB_CLICK_HERE_TO_RETURN . '</div></a>';
		}
		return $boxtxt;

	}

}

?>