<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->HasRight ('modules/mylinks', _PERM_WRITE);
$opnConfig['module']->InitModule ('modules/mylinks');
$opnConfig['opnOutput']->setMetaPageName ('modules/mylinks');
if (!defined ('_OPN_MAILER_INCLUDED') ) {
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
}
include_once (_OPN_ROOT_PATH . 'modules/mylinks/functions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/mylinks/language/');
$eh = & new opn_errorhandler;
// opn_errorhandler object
mylinksSetError ($eh);
$checkerlist = $opnConfig['permission']->GetUserGroups ();
$mf = & new CatFunctions ('mylinks');
// MyFunctions object
$mf->itemtable = $opnTables['mylinks_links'];
$mf->itemid = 'lid';
$mf->itemlink = 'cid';
$mf->ratingtable = $opnTables['mylinks_votedata'];
$cid = 0;
get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);

function fetchURLInfo ($rel_url) {

	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
	$http = & new http ();
	$list = array ();
	if ($rel_url != 'http://') {
		$status = $http->get ($rel_url);
		if ($status == 200) {
			$contents = $http->get_response_body ();
			$title = '';
			preg_match ("|<title[^>]*>(.*)</title>|siU", $contents, $title);
			$metas = '';
			preg_match_all ("|<meta name=\"(.*)\" content=\"(.*)\"[^>]*>|siU", $contents, $metas);
			foreach ($metas[1] as $key => $val) {
				$metatags[strtolower ($val)] = $metas[2][$key];
			}
			$title = $title['1'];
			$description = '';
			if (isset ($metatags['abstract']) ) {
				$description = $metatags['abstract'];
				$list['abstract'] = $metatags['abstract'];
			} else {
				$metatags['abstract'] = '';
				$list['abstract'] = '';
			}
			if (isset ($metatags['description']) ) {
				$description = $metatags['description'];
			}
			$list['title'] = $title;
			$list['description'] = $description;
			return $list;
		}
		$http->disconnect ();
	}
	return false;

}

function get_spider (&$title, $url, &$description) {
	if ($url) {
		$url = stripslashes ($url);
		if (!preg_match ('%^([a-z]+://)%', $url) ) {
			$rel_url = 'http://' . $url;
		} else {
			$rel_url = $url;
		}
		if ($rel_url != 'http://') {
			if (!preg_match ("/\\\$/", $rel_url) ) {
				$rel_url = $rel_url . "/";
			}
		}
		$metaList = fetchURLInfo ($rel_url);
		if ($metaList == false) {
			$title = 'The site does not exists';
		} elseif (count ($metaList) == 0) {
			$title = 'No Metadata found';
		}
		if ( (isset ($metaList['description']) ) && ($metaList['description'] != '') ) {
			$description = $metaList['description'];
		} else {
			$description = '';
		}
		if ($metaList['title']) {
			$title = $metaList['title'];
		} elseif ($metaList['abstract']) {
			$title = $metaList['abstract'];
		}
	}
	// $opnConfig['opnOutput']->Redirect('/modules/mylinks/submit.php?title='.$title.'&url='.rawurldecode($url).'&cid='.$cid.'&description='.$description.'&name='.$submitter.'&email='.$email);

}
$submit = '';
get_var ('submit', $submit, 'form', _OOBJ_DTYPE_CLEAN);
$spider = '';
get_var ('spider', $spider, 'form', _OOBJ_DTYPE_CLEAN);
$title = '';
get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
$url = '';
get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
$description = '';
get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
$logourl = '';
get_var ('logourl', $logourl, 'form', _OOBJ_DTYPE_URL);
$cid = 0;
get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
$email = '';
get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
$submitter = '';
get_var ('submitter', $submitter, 'form', _OOBJ_DTYPE_CLEAN);
if ($submit != '') {
	$ui = $opnConfig['permission']->GetUserinfo ();
	if ($submitter == '') {
		$submitter = $ui['uname'];
		if ($ui['uid'] == 1) {
			$submitter = '';
		}
	}
	// Check if Title exist
	if ($title == '') {
		$eh->show ('MYLINKS_0001');
	}
	// Check if URL exist
	if ( ($url) || ($url != '') ) {
		$opnConfig['cleantext']->formatURL ($url);
	}
	if ($url == 'http://') {
		$url = '';
	}
	if ($url == '') {
		$eh->show ('MYLINKS_0008');
	}
	// Check if Description exist
	if ( ($description == '') && ($spider == '') ) {
		$eh->show ('MYLINKS_0002');
	}
	$surl = $url;
	$url = urlencode ($url);
	$url = $opnConfig['opnSQL']->qstr ($url);
	$title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($title, true, true, 'nohtml') );
	$email = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($email, false, true, 'nohtml') );
	$opnConfig['cleantext']->formatURL ($logourl);
	if ($logourl == 'http://') {
		$logourl = '';
	}
	$logourl = $opnConfig['opnSQL']->qstr ($logourl);
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS counter FROM ' . $opnTables['mylinks_links'] . " WHERE url=$url");
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$counter = $result->fields['counter'];
	} else {
		$counter = 0;
	}
	$result->Close ();
	if ($counter>0) {
		$eh->show ('MYLINKS_0010');
	}
	$description = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($description, true, true), 'description');
	$lid = $opnConfig['opnSQL']->get_new_number ('mylinks_links', 'lid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$_submitter = $opnConfig['opnSQL']->qstr ($submitter);
	$q = 'insert into ' . $opnTables['mylinks_links'] . " values ($lid, $cid, $title, $url, $email, $logourl, $_submitter, 0, $now, 0, 0, 0, 0)";
	$opnConfig['database']->Execute ($q) or $eh->show ('OPN_0001');
	$txtid = $opnConfig['opnSQL']->get_new_number ('mylinks_text', 'txtid');
	$opnConfig['database']->Execute ('insert into ' . $opnTables['mylinks_text'] . " values ($txtid, $lid, $description)") or $eh->show ("OPN_0001");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['mylinks_text'], 'txtid=' . $txtid);
	$boxtxt = mainheader ();
	$boxtxt .= '<br /><div align="center" class="normaltextbold">' . _MYL_WERESIVEDYOURSITEINFOTHX . '<br />';
	$boxtxt .= _MYL_YOURECIVEAMAILWENNAPPROVED . '</div>';
	if ($opnConfig['myl_notify']) {
		$vars['{ADMIN}'] = $opnConfig['myl_notify_email'];
		$vars['{NAME}'] = $submitter;
		$vars['{URL}'] = $surl;
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($opnConfig['myl_notify_email'], $opnConfig['myl_notify_subject'], 'modules/mylinks', 'adminmsgnewlink', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['myl_notify_email']);
		$mail->send ();
		$mail->init ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MYLINKS_290_';
	$_display_dat['module'] = 'modules/mylinks';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
} else {
	$ui = $opnConfig['permission']->GetUserinfo ();
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	if ($spider != '') {
		get_spider ($title, $url, $description);
	}
	$title = urldecode ($title);
	$description = urldecode ($description);
	$boxtxt = mainheader ();
	$boxtxt .= '<br />' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_MYLINKS_300_', 'mylinks');
	$form->Init ($opnConfig['opn_url'] . '/modules/mylinks/submit.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('title', _MYL_SITENAME);
	$form->AddTextfield ('title', 50, 100, $title);
	$form->AddChangeRow ();
	$form->AddLabel ('url', _MYL_WESITEURL . '<br />' . '<br />' . _MYL_MORELINKSHINFO);
	$form->AddTextfield ('url', 50, 200, $url);
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _MYL_CATEGORY);
	$mf->makeMySelBox (0, $form, 0, 'cid');
	$form->AddChangeRow ();
	$form->AddLabel ('email', _MYL_CONTACTEMAIL);
	$form->AddTextfield ('email', 50, 60, $email);
	if ($opnConfig['mylinks_useshots']) {
		$form->AddChangeRow ();
		$form->AddLabel ('logourl', _MYL_SCREENIMG);
		$form->AddTextfield ('logourl', 50, 150, $logourl);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('description', _MYL_DESCRIPTION);
	$form->AddTextarea ('description', 0, 0, '', $description);
	$form->AddChangeRow ();
	$form->AddHidden ('submitter', $ui['uname']);
	$form->SetSameCol ();
	$form->AddSubmit ('spider', _MYL_GET_META_INFO);
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('submit', _MYL_SUBMIT);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br />' . _OPN_HTML_NL;
	$boxtxt .= '<ul>';
	$boxtxt .= '<li>' . _MYL_SUBMITYOURLINKONLYONCE . '</li>' . _OPN_HTML_NL;
	$boxtxt .= '<li>' . _MYL_ALLLINKAREPOSTETVERIFY . '</li>' . _OPN_HTML_NL;
	$boxtxt .= '<li>' . _MYL_USERNAMEANDIPARERECORDET . '</li>' . _OPN_HTML_NL;
	$boxtxt .= '<li>' . _MYL_WETAKESCREENSHOTOFYOURSITE . '</li>';
	$boxtxt .= '</ul>' . _OPN_HTML_NL;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MYLINKS_310_';
	$_display_dat['module'] = 'modules/mylinks';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_MYL_DESC, $boxtxt);
}

?>