<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
// displays a paragraph

function nl_Para ($text, $align = 'left', $class = '') {
	if ($class != '') {
		$cls = ' class="' . $class . '"';
	}
	echo '<p align="' . $align . '"' . $class . '>' . $text . '</p>';

}

function nl_UserActive ($lid) {

	global $opnConfig;
	if (!$opnConfig['permission']->IsUser () ) {
		return false;
	}
	$ui = $opnConfig['permission']->GetUserinfo ();
	$mytablename = $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_user';
	$r = &$opnConfig['database']->Execute ('SELECT COUNT(email) AS counter FROM ' . $mytablename . " WHERE email='" . $ui['email'] . "'");
	if ( (isset ($r->fields['counter']) ) && ($r->fields['counter'] != 0) ) {
		$r->Close ();
		return true;
	}
	return false;

}
// displays the "Go back"
// - $to can set to an url not equals sqlf
if (!function_exists ('nl_GoBack') ) {

	function nl_GoBack ($to = '') {

		$PHPSELF = '';
		get_var ('PHP_SELF', $PHPSELF, 'server');
		$myreturn = '<div class="centertag">';
		if ($to == '') {
			$myreturn .= '<a class="opncenterbox" href="' . encodeurl ($PHPSELF) . '">' . _ONL_GOBACK . '</a>';
		} else {
			$myreturn .= '<a class="opncenterbox" href="' . $to . '">' . _ONL_GOBACK . '</a>';
		}
		$myreturn .= '</div>';
		return $myreturn;

	}
}
// Just displays an Error and dies
// - $text: the message
// - $refer: Where to go by nl_GoBack

function nl_Error ($text, $refer = '') {

	global $opnConfig;

	$boxtxt = $text . '<br /><br />' . nl_GoBack ($refer);
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_220_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_ERROR, $boxtxt);
	exit;

}
// Fetch the record
// - $lid: List ID

function nl_GetListInfo ($lid) {

	global $opnTables, $opnConfig;
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	$r = &$opnConfig['database']->Execute ('SELECT lid, name, access, enabled, description FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	if ($r !== false) {
		if ($r->RecordCount () != 0) {
			$result = $r->GetRowAssoc ('0');
			$r->Close ();
		} else {
			nl_Error (_ONL_ERRORCANNOTFINDNL);
		}
	} else {
		nl_Error (_ONL_ERRORCANNOTFINDNL);
	}
	return $result;

}
// Show all news letters

function nl_ShowCats () {

	global $opnConfig, $opnTables;

	$access = $opnConfig['permission']->GetUserGroups ();
	$r = &$opnConfig['database']->Execute ('SELECT lid, name, access, enabled, description FROM ' . $opnTables['newsletter_list'] . " WHERE access in ($access) ORDER BY name;");
	if ($r !== false) {
		$entries = $r->RecordCount ();
	} else {
		$entries = 0;
	}
	$boxtxt = '<span class="normaltext">';
	$boxtxt .= _ONL_NEWSLETTERLIST . '<br /><br />';
	if (!$opnConfig['permission']->IsUser () ) {
		$boxtxt .= _ONL_IFREGUSER;
	} else {
		$boxtxt .= _ONL_THISAREYOURENL;
	}
	$boxtxt .= '</span>';
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	if ($entries>0) {
		$table = & new opn_TableClass ('alternator');
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol (_ONL_NLNAME, '', '2');
		$table->AddCloseRow ();
		while (! $r->EOF) {
			// test if user is in list
			$active = nl_UserActive ($r->fields['lid'])&$r->fields['enabled'];
			$access = $r->fields['access'];
			$table->AddOpenRow ();
			$table->SetAutoAlternator ('1');
			$dcol = ($active?'%alternateextra%' : '%alternate%');
			$table->AddDataCol ('<a class="' . $dcol . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
												'op' => 'archive',
												'lid' => $r->fields['lid']) ) . '">' . $r->fields['name'] . '</a>',
												'',
												'2',
												'top');
			$table->AddChangeRow ();
			$table->AddDataCol ($r->fields['description'], '', '', 'top');
			if ($r->fields['enabled'] == 0) {
				$table->AddDataCol (_ONL_THISNLISCLOSED, '', '', 'top');
			} else {
				if ($opnConfig['permission']->IsUser () ) {
					if ($active) {
						$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
													'op' => 'remove',
													'lid' => $r->fields['lid']) ) . '">' . _ONL_UNSUBSCRIBE . '</a> ';
					} else {
						$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
													'op' => 'add',
													'lid' => $r->fields['lid']) ) . '">' . _ONL_SUBSCRIBE . '</a> ';
					}
				} else {
					$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
												'op' => 'addremove',
												'lid' => $r->fields['lid']) ) . '">' . _ONL_SUBORUNSUBSCRIBE . '</a> ';
				}
				$table->AddDataCol ($hlp, '', '', 'top');
			}
			$table->SetAutoAlternator ();
			$table->AddCloseRow ();
			$r->MoveNext ();
		}
		$table->GetTable ($boxtxt);
	} else {
		$boxtxt .= '<div class="centertag">' . _ONL_SORRYNONLHERE . '</div>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_230_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_DESC, $boxtxt, '');

}
// same as above, but for removing

function nl_ConfirmDelete ($lid, $email, $code) {

	global $opnConfig;
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	// fetch name
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnConfig['tableprefix'] . 'newsletter_list WHERE lid=' . $lid);
	$name = $r->fields['name'];
	// test if user is listed
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$r = &$opnConfig['database']->Execute ('SELECT enabled, code FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email");
	if ($r !== false) {
		$num = $r->RecordCount ();
	} else {
		$num = 0;
	}
	if ($num == 0) {
		nl_Para (_ONL_NOEMAILINDB);
	} else {
		$db_code = $r->fields['code'];
		if ($db_code == $code) {
			$_email = $opnConfig['opnSQL']->qstr ($email);
			$opnConfig['database']->Execute ('DELETE from ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email");
			nl_Para (_ONL_UNSUBSCRIBE2, 'center');
		} else {
			nl_Para (_ONL_NO_UNSUBTXT_A);
			nl_Para ('<ul><li>' . _ONL_NO_UNSUBTXT_B . '<li>' . _ONL_NO_UNSUBTXT_C . '</ul>');
			nl_Para (_ONL_NO_UNSUBTXT_D);
			nl_Para (sprintf (_ONL_NO_UNSUBTXT_E, $opnConfig['opn_url']) );
		}
	}
	nl_GoBack ();

}
// remove reg. user
// $lid: list id

function nl_DelIntern () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if (!$opnConfig['permission']->IsUser () ) {
		$opnConfig['opnOutput']->Redirect ('/system/user/index.php');
		CloseTheOpnDB ($opnConfig);
		exit;
	}
	$boxtxt = '';
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	$ui = $opnConfig['permission']->GetUserinfo ();
	if (!isset ($ui['name']) ) {
		$ui['name'] = '';
	}
	// fetch name and access
	$r = &$opnConfig['database']->Execute ('SELECT nluid FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email='" . $ui['email'] . "'");
	if ($r !== false) {
		$num = $r->RecordCount ();
	} else {
		$num = 0;
	}
	if ($num == 0) {
		$boxtxt .= _ONL_NOTSUBSCRIBED;
	} else {
		$nluid = $r->fields['nluid'];
		$opnConfig['database']->Execute ('DELETE from ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE nluid=$nluid;");
		$boxtxt .= _ONL_HELLO . " " . ( ($ui['name'] == '')? $ui['uname'] : $ui['name']) . ' !<br /><br />';
		$boxtxt .= _ONL_SUCCESSUNSUBSCRIBE;
	}
	$boxtxt .= nl_GoBack () . '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_240_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_UNSUBSCRIBE, $boxtxt, '');

}
// add reg. user
// $lid: list id

function nl_AddIntern () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	// shouldn't be happend but if a user use saved url and cookie expired
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	$ui = $opnConfig['permission']->GetUserinfo ();
	if (!isset ($ui['name']) ) {
		$ui['name'] = '';
	}
	$boxtxt = '';
	// fetch name and access
	$r = &$opnConfig['database']->Execute ('SELECT name, access, enabled FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$db_access = $r->fields['access'];
	$enabled = $r->fields['enabled'];
	if ( (!$opnConfig['permission']->CheckUserGroup ($db_access) ) || !$enabled) {
		// this should only displayed on manual url-entries :/
		$boxtxt .= _ONL_CANNOTSUBSCRIBE;
	} else {
		$r = &$opnConfig['database']->Execute ('SELECT email FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email='" . $ui['email'] . "'");
		if ($r !== false) {
			$num = $r->RecordCount ();
		} else {
			$num = 0;
		}
		if ($num != 0) {
			$boxtxt .= _ONL_ALREADYSUBSCRIBED;
		} else {
			// could be happend that he will remove without logged in as user
			$code = md5 (uniqid (rand () ) );
			$nluid = $opnConfig['opnSQL']->get_new_number ('newsletter_' . $lid . '_user', 'nluid');
			$opnConfig['opndate']->now ();
			$now = '';
			$opnConfig['opndate']->opnDataTosql ($now);
			$_code = $opnConfig['opnSQL']->qstr ($code);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user (nluid, email, enabled, wdate, code) " . " VALUES  ($nluid, '" . $ui['email'] . "', 1, $now, $_code);");
			$boxtxt .= _ONL_HELLO . ' ' . ( ($ui['name'] == '')? $ui['uname'] : $ui['name']) . ' !<br /><br />';
			$boxtxt .= sprintf (_ONL_SUBSCRIBESUCCESS, '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
															'op' => 'archive',
															'lid' => $lid) ) . '">') . '<br /><br />';
		}
	}
	$boxtxt .= nl_GoBack () . '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_250_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_SUBSCRIBE, $boxtxt, '');

}
// nl_Archive($lid, $offset, $limit)
// Display the headlines of an archive
// $lid: list id
// $offset: db-offset [0..num_rows-1]
// $limit: headlines per page

function nl_Archive () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$limit = 0;
	get_var ('limit', $limit, 'url', _OOBJ_DTYPE_INT);
	// adjust vars
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	$limit = (int) $limit;
	if ($limit == 0) {
		$limit = 25;
	}
	$offset = (int) $offset;
	// get list info
	$li = nl_GetListInfo ($lid);
	// get access
	if (!$opnConfig['permission']->CheckUserGroup ($li['access']) ) {
		nl_Error (_ONL_ERRORNOACCESS . ' &quot;' . $li['name'] . '&quot;');
	}
	$mytablename = $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data';
	$r = &$opnConfig['database']->Execute ('SELECT COUNT(nlid) AS counter FROM ' . $mytablename);
	if ( ($r !== false) && (isset ($r->fields['counter']) ) ) {
		$num = $r->fields['counter'];
	} else {
		$num = 0;
	}
	if ($num != 0) {
		$boxtxt = '';
		$boxtxt .= sprintf (_ONL_STOREDLETTERS, $num);
		$boxtxt .= '<br /><br />';
		if ($offset>$num-1) {
			$offset = 0;
		}
		$r = &$opnConfig['database']->SelectLimit ('SELECT nlid, aid, subject, wdate, text FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data ORDER BY wdate DESC', $limit, $offset);
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_ONL_SUBJECT, _ONL_FROM, _ONL_DATE) );
		$even = true;
		if ($r !== false) {
			$temp = '';
			while (! $r->EOF) {
				$data = $r->GetRowAssoc ('0');
				$ai = $opnConfig['permission']->GetUser ($data['aid'], 'useruid', '');
				$opnConfig['opndate']->sqlToopnData ($data['wdate']);
				$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
				$table->AddOpenRow ();
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
													'op' => 'read',
													'lid' => $lid,
													'nlid' => $data['nlid'],
													'offset' => $offset,
													'limit' => $limit) ) . '">' . $data['subject'] . '</a>',
													'',
													'',
													'top');
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
													'op' => 'userinfo',
													'uname' => $ai['uname']) ) . '">' . $ai['uname'] . '</a>',
													'',
													'',
													'top');
				$table->AddDataCol ($temp, '', '', 'top');
				$table->AddCloseRow ();
				$even = ! $even;
				$r->MoveNext ();
			}
		}
		// make navigation
		if ($num>$limit) {
			$table->AddOpenRow ();
			// Create page navigation
			$actpage = (int) ($offset/ $limit)+1;
			$hlp = '';
			for ($i = 0; $i< $num; $i += $limit) {
				$page = (int) ($i/ $limit)+1;
				if ($page == $actpage) {
					$hlp .= '<span class="normaltextbold">' . $page . '</span> ';
				} else {
					$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
												'op' => 'archive',
												'lid' => $lid,
												'offset' => $i,
												'limit' => $limit) ) . '">' . $page . '</a> ';
				}
			}
			$table->AddDataCol ($hlp, 'center', '3');
		}
		$table->GetTable ($boxtxt);
	} else {
		$boxtxt = '<br />';
		$boxtxt .= '<div class="centertag">' . _ONL_THEREARENONLDATA . '</div>';
	}
	$boxtxt .= '<br />';
	$boxtxt .= nl_GoBack ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_260_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_ARCHIVE, $boxtxt, '');

}
// read a single letter
// $lid: list id
// nlid: news letter id
// $offset, $limit: page description (see above)

function nl_Read () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$nlid = 0;
	get_var ('nlid', $nlid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$limit = 0;
	get_var ('limit', $limit, 'url', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	// get list info
	$li = nl_GetListInfo ($lid);
	// get access
	if (!$opnConfig['permission']->CheckUserGroup ($li['access']) ) {
		nl_Error (_ONL_ERRORNOACCESS . ' &quot;' . $li['name'] . '&quot;');
	}
	if ((int) $nlid == 0) {
		nl_Error (_ONL_ERRORDOESNOTEXIST);
	}
	$r = &$opnConfig['database']->Execute ('SELECT nlid, aid, subject, wdate, text FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data WHERE nlid=' . $nlid);
	if ($r !== false) {
		$num = $r->RecordCount ();
	} else {
		$num = 0;
	}
	$boxtxt = '';
	if ($num != 0) {
		$data = $r->GetRowAssoc ('0');
		$ai = $opnConfig['permission']->GetUser ($data['aid'], 'useruid', '');
		$opnConfig['opndate']->sqlToopnData ($data['wdate']);
		$temp = '';
		$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
		$boxtxt .= '<span class="normaltext">' . _ONL_FROM . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
															'op' => 'userinfo',
															'uname' => $ai['uname']) ) . '">' . $ai['uname'] . '</a> ' . _ONL_ON . ' ' . $temp . '<hr />';
		$boxtxt .= '<span class="normaltextbold">' . $data['subject'] . '</span><br /><br />';
		$boxtxt .= nl2br ($data['text']) . '</span>';
	} else {
		$boxtxt .= _ONL_THEREARENONLDATA;
	}
	$boxtxt .= nl_GoBack (encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
						'op' => 'archive',
						'lid' => $lid,
						'offset' => $offset,
						'limit' => $limit) ) ) . '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_270_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_ARCHIVE, $boxtxt, '');

}

function nl_addremove () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	if ((int) $lid == 0) {
		nl_Error (_ONL_ERRORINVALIDLID);
	}
	$ui = $opnConfig['permission']->GetUserinfo ();
	if (!isset ($ui['name']) ) {
		$ui['name'] = '';
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_280_', 'opn_newsletter');
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('email', _ONL_EMAIL);
	$form->AddTextfield ('email', 40, 128);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('lid', $lid);
	$form->AddHidden ('op', 'doaddremove');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _ONL_SUBORUNSUBSCRIBE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt . '<br /><br />' . _ONL_NO_UNSUBTXT_E;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_290_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_SUBORUNSUBSCRIBE, $boxtxt, '');

}

function nl_doaddremove () {

	global $opnConfig, $opnTables;

	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . " WHERE lid=$lid");
	$name = $r->fields['name'];
	$vars['{SITENAME}'] = $opnConfig['sitename'];
	$vars['{EMAIL}'] = $email;
	$vars['{LISTNAME}'] = $name;
	$opnConfig['activation']->InitActivation ();
	$opnConfig['activation']->BuildActivationKey ();
	$opnConfig['activation']->SetActdata ($email);
	$opnConfig['activation']->SetExtraData ($lid);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$r = &$opnConfig['database']->Execute ('SELECT nluid FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email");
	$key = $opnConfig['activation']->GetActivationKey ();
	if ($r->RecordCount () == 0) {
		$subject = sprintf (_ONL_ADDSUBJECT, $name);
		$mail1 = 'addnl';
		$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
					'op' => 'confirmedadd',
					'actkey' => $key,
					'email' => $email),
					false);
	} else {
		$subject = sprintf (_ONL_REMOVESUBJECT, $name);
		$mail1 = 'removenl';
		$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
					'op' => 'confirmedremove',
					'actkey' => $key,
					'email' => $email),
					false);
	}
	$vars['{URL}'] = $url;
	$vars['{KEY}'] = $key;
	$opnConfig['activation']->SaveActivation ();
	$from = $opnConfig['adminmail'];
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($email, $subject, 'modules/opn_newsletter', $mail1, $vars, $opnConfig['opn_webmaster_name'], $from);
	$mail->send ();
	$mail->init ();
	$boxtxt = _ONL_WHAT_TO_DO;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_300_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONL_SUBORUNSUBSCRIBE, $boxtxt, '');

}

function nl_confirmedadd () {

	global $opnConfig;

	$actkey = '';
	get_var ('actkey', $actkey, 'url', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'url', _OOBJ_DTYPE_EMAIL);
	$opnConfig['activation']->InitActivation ();
	$opnConfig['activation']->SetActivationKey ($actkey);
	$opnConfig['activation']->LoadActivation ();
	$boxtxt = '';
	if ($opnConfig['activation']->CheckActivation ($actkey, $email) ) {
		$boxtitle = _ONL_SUBSCRIBE;
		$lid = $opnConfig['activation']->GetExtraData ();
		$boxtxt .= sprintf (_ONL_SUBSCRIBESUCCESS, '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
														'op' => 'archive',
														'lid' => $lid) ) . '">') . '<br /><br />';
		$code = md5 (uniqid (rand () ) );
		$nluid = $opnConfig['opnSQL']->get_new_number ('newsletter_' . $lid . '_user', 'nluid');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$_code = $opnConfig['opnSQL']->qstr ($code);
		$_email = $opnConfig['opnSQL']->qstr ($email);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user (nluid, email, enabled, wdate, code) VALUES ($nluid, $_email, 1, $now, $_code);");
		$opnConfig['activation']->DeleteActivation ();
	} else {
		$boxtitle = _ONL_WRONG_ACTIVATION;
		$boxtxt .= _ONL_WRONG_ACTIVATION1;
		$boxtxt .= '<br /><a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php?op=confirmadd') . '">' . _ONL_BACK_CONFIRM . '</a>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_310_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt, '');

}

function nl_confirmedremove () {

	global $opnConfig;

	$actkey = '';
	get_var ('actkey', $actkey, 'url', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'url', _OOBJ_DTYPE_EMAIL);
	$opnConfig['activation']->InitActivation ();
	$opnConfig['activation']->SetActivationKey ($actkey);
	$opnConfig['activation']->LoadActivation ();
	$boxtxt = '';
	if ($opnConfig['activation']->CheckActivation ($actkey, $email) ) {
		$boxtitle = _ONL_UNSUBSCRIBE;
		$boxtxt .= _ONL_SUCCESSUNSUBSCRIBE . '<br /><br />';
		$boxtxt .= '<a href="' . $opnConfig['opn_url'] . '/modules/opn_newsletter/index.php">' . _ONL_GOBACK . '</a>';
		$lid = $opnConfig['activation']->GetExtraData ();
		$_email = $opnConfig['opnSQL']->qstr ($email);
		$opnConfig['database']->Execute ('DELETE from ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email");
		$opnConfig['activation']->DeleteActivation ();
	} else {
		$boxtitle = _ONL_WRONG_ACTIVATION;
		$boxtxt .= _ONL_WRONG_ACTIVATION1;
		$boxtxt .= '<br /><a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php?op=confirmremove') . '">' . _ONL_BACK_CONFIRM . '</a>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_320_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt, '');

}

?>