<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/project', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/project/admin/language/');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.status.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.category.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.version.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.user.php');
include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
$status = & new ProjectStatus ();
$project = & new Project ();
$version = & new ProjectVersion ();
$category = & new ProjectCategory ();
$users = & new ProjectUser ();

function ProjectConfigHeader () {

	global $opnConfig, $status, $project;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_PROJECT_INDEXPROJECTCONFIGURATION);
	$menu->InsertEntry (_PROJECT_INDEXMAIN, $opnConfig['opn_url'] . '/modules/project/admin/index.php');
	if ($status->GetCount () ) {
		$menu->InsertEntry (_PROJECT_PROJECTS, array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
								'op' => 'ProjectAdmin') );
		if ($project->GetCount () ) {
			$menu->InsertEntry (_PROJECT_CATEGORIES, array ($opnConfig['opn_url'] . '/modules/project/admin/index.php', 'op' => 'CatAdmin') );
			$menu->InsertEntry (_PROJECT_VERSIONS, array ($opnConfig['opn_url'] . '/modules/project/admin/index.php', 'op' => 'VersionAdmin') );
		}
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function StatusAdmin () {

	global $opnConfig, $status;

	ProjectConfigHeader ();
	$boxtxt = '';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$recordcount = $status->GetCount ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if ($recordcount) {
		$result = $status->GetLimit ($maxperpage, $offset);
		if ($result !== false) {
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('85%', '15%') );
			$table->AddHeaderRow (array (_PROJECT_STATUS, _PROJECT_FUNCTIONS) );
			while (! $result->EOF) {
				$status_id = $result->fields['status_id'];
				$status_name = $result->fields['status_name'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php', 'op' => 'EditStatus', 'status_id' => $status_id) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php', 'op' => 'DeleteStatus', 'status_id' => $status_id, 'ok' => '0') );
					$hlp .= '&nbsp;';
				}
				$table->AddDataRow (array ($status_name, $hlp), array ('center', 'center') );
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
			$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php'),
							$recordcount,
							$maxperpage,
							$offset);
			$boxtxt .= '<br /><br />' . $pagebar;
		}
	}
	if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<br /><br /><div align="center" class="normaltextbold">' . _PROJECT_ADMINNEWSTATUS . '</div>';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_10_', 'project');
		$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('status_name', _PROJECT_ADMINSTATUSNAME);
		$form->AddTextfield ('status_name', 50, 128);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'AddStatus');
		$form->AddSubmit ('submit', _PROJECT_ADMINADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_20_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function AddStatus () {

	global $opnConfig, $status;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
	$status->AddRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php', false) );
	CloseTheOpnDB ($opnConfig);

}

function EditStatus () {

	global $opnConfig, $status;

	ProjectConfigHeader ();
	$boxtxt = '';
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$status_id = 0;
	get_var ('status_id', $status_id, 'url', _OOBJ_DTYPE_INT);
	$stat = $status->RetrieveSingle ($status_id);
	$boxtxt .= '<div align="center" class="bigtextbold">' . _PROJECT_EDITSTATUS . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_30_', 'project');
	$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
	$form->AddLabel ('status_name', _PROJECT_ADMINSTATUSNAME);
	$form->AddTextfield ('status_name', 50, 128, $stat['status_name']);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('status_id', $status_id);
	$form->AddHidden ('op', 'SaveStatus');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _PROJECT_ADMINSAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_40_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function SaveStatus () {

	global $opnConfig, $status;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$status->ModifyRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php', false) );

}

function DeleteStatus () {

	global $opnConfig, $status;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$status_id = 0;
	get_var ('status_id', $status_id, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$status->DeleteRecord ();
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php', false) );
	} else {
		ProjectConfigHeader ();
		$result = $status->RetrieveSingle ($status_id);
		$title = $result['status_name'];
		$boxtxt = '<div class="bigtext" align="center"><br />';
		$boxtxt .= '<span class="alerttextcolor">';
		$boxtxt .= sprintf (_PROJECT_STATUS_DELETE, $title) . '<br /><br /></span>';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
										'op' => 'DeleteStatus',
										'status_id' => $status_id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/project/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_50_';
		$_display_dat['module'] = 'modules/project';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function ProjectAdmin () {

	global $opnConfig, $project, $status;

	ProjectConfigHeader ();
	$boxtxt = '';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$recordcount = $project->GetCount ();
	$stat = $status->GetArray ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if ($recordcount) {
		$result = $project->GetLimit ($maxperpage, $offset);
		if ($result !== false) {
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('40%', '35%', '5%', '10%', '10%') );
			$table->AddHeaderRow (array (_PROJECT_PROJECT, _PROJECT_STATUS, _PROJECT_ENABLED, _PROJECT_DISPLAY, _PROJECT_FUNCTIONS) );
			while (! $result->EOF) {
				$project_id = $result->fields['project_id'];
				$project_name = $result->fields['project_name'];
				$project_status = $result->fields['project_status'];
				$project_enabled = $result->fields['project_enabled'];
				$project_state = $result->fields['project_state'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'CatAdmin',
												'projectid' => $project_id) );
					$hlp .= '<img src="' . $opnConfig['opn_url'] . '/modules/project/admin/images/cat.gif" class="imgtag" alt="' . _PROJECT_CATEGORIES . '" title="' . _PROJECT_CATEGORIES . '" />';
					$hlp .= '</a>';
					$hlp .= '&nbsp;';
					$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'VersionAdmin',
												'projectid' => $project_id) );
					$hlp .= '<img src="' . $opnConfig['opn_url'] . '/modules/project/admin/images/version.gif" class="imgtag" alt="' . _PROJECT_VERSIONS . '" title="' . _PROJECT_VERSIONS . '" />';
					$hlp .= '</a>';
					$hlp .= '&nbsp;';
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'EditProject',
												'project_id' => $project_id) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'DeleteProject',
												'project_id' => $project_id,
												'ok' => '0') );
					$hlp .= '&nbsp;';
				}
				$status_name = $stat[$project_status]['status_name'];
				if ($project_enabled) {
					$project_enabled = _YES_SUBMIT;
				} else {
					$project_enabled = _NO_SUBMIT;
				}
				if ($project_state == 1) {
					$project_state = _PROJECT_PUBLIC;
				} else {
					$project_state = _PROJECT_PRIVATE;
				}
				$table->AddDataRow (array ($project_name, $status_name, $project_enabled, $project_state, $hlp), array ('center', 'center', 'center', 'center', 'center') );
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
			$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op=ProjectAdmin'),
							$recordcount,
							$maxperpage,
							$offset);
			$boxtxt .= '<br /><br />' . $pagebar;
		}
	}
	if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<br /><br /><div align="center" class="normaltextbold">' . _PROJECT_ADMINNEWPROJECT . '</div>';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_60_', 'project');
		$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('project_name', _PROJECT_ADMINPROJECTNAME);
		$form->AddTextfield ('project_name', 50, 128);
		$options = array ();
		foreach ($stat as $value) {
			$options[$value['status_id']] = $value['status_name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('project_status', _PROJECT_ADMINPROJECTSTATUS);
		$form->AddSelect ('project_status', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('project_enabled', _PROJECT_ADMINPROJECTENABLED);
		$form->AddCheckbox ('project_enabled', 1, true);
		$options = array ();
		$options[1] = _PROJECT_PUBLIC;
		$options[2] = _PROJECT_PRIVATE;
		$form->AddChangeRow ();
		$form->AddLabel ('project_state', _PROJECT_ADMINPROJECTDISPLAY);
		$form->AddSelect ('project_state', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('project_desc', _PROJECT_ADMINPROJECTDESC);
		$form->AddTextarea ('project_desc');
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'AddProject');
		$form->AddSubmit ('submit', _PROJECT_ADMINADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_70_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function AddProject () {

	global $opnConfig, $project;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
	$project->AddRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php?op=ProjectAdmin', false) );
	CloseTheOpnDB ($opnConfig);

}

function EditProject () {

	global $opnConfig, $project, $status;

	ProjectConfigHeader ();
	$boxtxt = '';
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$project_id = 0;
	get_var ('project_id', $project_id, 'url', _OOBJ_DTYPE_INT);
	$pro = $project->RetrieveSingle ($project_id);
	$stat = $status->GetArray ();
	$boxtxt .= '<div align="center" class="bigtextbold">' . _PROJECT_EDITPROJECT . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_80_', 'project');
	$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
	$form->AddOpenRow ();
	$form->AddLabel ('project_name', _PROJECT_ADMINPROJECTNAME);
	$form->AddTextfield ('project_name', 50, 128, $pro['project_name']);
	$options = array ();
	foreach ($stat as $value) {
		$options[$value['status_id']] = $value['status_name'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('project_status', _PROJECT_ADMINPROJECTSTATUS);
	$form->AddSelect ('project_status', $options, $pro['project_status']);
	$form->AddChangeRow ();
	$form->AddLabel ('project_enabled', _PROJECT_ADMINPROJECTENABLED);
	$form->AddCheckbox ('project_enabled', 1, ($pro['project_enabled']?1 : 0) );
	$options = array ();
	$options[1] = _PROJECT_PUBLIC;
	$options[2] = _PROJECT_PRIVATE;
	$form->AddChangeRow ();
	$form->AddLabel ('project_state', _PROJECT_ADMINPROJECTDISPLAY);
	$form->AddSelect ('project_state', $options, $pro['project_state']);
	$form->AddChangeRow ();
	$form->AddLabel ('project_desc', _PROJECT_ADMINPROJECTDESC);
	$form->AddTextarea ('project_desc', 0, 0, '', $pro['project_desc']);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('project_id', $project_id);
	$form->AddHidden ('op', 'SaveProject');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _PROJECT_ADMINSAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_90_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function SaveProject () {

	global $opnConfig, $project;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$project->ModifyRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php?op=ProjectAdmin', false) );

}

function DeleteProject () {

	global $opnConfig, $project, $category, $version, $users;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$project_id = 0;
	get_var ('project_id', $project_id, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$category->DeleteByProject ($project_id);
		$version->DeleteByProject ($project_id);
		$users->DeletebyProject ($project_id);
		$project->DeleteRecord ();
		if ($opnConfig['installedPlugins']->isplugininstalled ('modules/bug_tracking') ) {
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
			$bugs = & new Bugs ();
			$bugs->DeleteByProject ($project_id);
			unset ($bugs);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php?op=ProjectAdmin', false) );
	} else {
		ProjectConfigHeader ();
		$result = $project->RetrieveSingle ($project_id);
		$title = $result['project_name'];
		$boxtxt = '<div class="bigtext" align="center"><br />';
		$boxtxt .= '<span class="alerttextcolor">';
		$boxtxt .= sprintf (_PROJECT_PROJECT_DELETE, $title) . '<br /><br /></span>';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
										'op' => 'DeleteProject',
										'project_id' => $project_id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/project/admin/index.php?op=ProjectAdmin') . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_100_';
		$_display_dat['module'] = 'modules/project';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function CatAdmin () {

	global $opnConfig, $category, $project;

	ProjectConfigHeader ();
	$boxtxt = '';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$projectid = 0;
	get_var ('projectid', $projectid, 'both', _OOBJ_DTYPE_INT);
	if ($projectid) {
		$category->SetProject ($projectid);
	}
	$recordcount = $category->GetCount ();
	$pro = $project->GetArray ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if ($recordcount) {
		$result = $category->GetLimit ($maxperpage, $offset);
		if ($result !== false) {
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('45%', '45%', '10%') );
			$table->AddHeaderRow (array (_PROJECT_CATEGORY, _PROJECT_PROJECT, _PROJECT_FUNCTIONS) );
			while (! $result->EOF) {
				$category_id = $result->fields['category_id'];
				$category = $result->fields['category'];
				$project_id = $result->fields['project_id'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'EditCat',
												'category_id' => $category_id,
												'projectid' => $projectid) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'DeleteCat',
												'category_id' => $category_id,
												'projectid' => $projectid,
												'ok' => '0') );
					$hlp .= '&nbsp;';
				}
				$project_name = $pro[$project_id]['project_name'];
				$table->AddDataRow (array ($category, $project_name, $hlp), array ('center', 'center', 'center') );
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
			$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'CatAdmin',
							'projectid' => $project),
							$recordcount,
							$maxperpage,
							$offset);
			$boxtxt .= '<br /><br />' . $pagebar;
		}
	}
	if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<br /><br /><div align="center" class="normaltextbold">' . _PROJECT_ADMINNEWCATEGORY . '</div>';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_110_', 'project');
		$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('category', _PROJECT_ADMINCATEGORYNAME);
		$form->AddTextfield ('category', 50, 64);
		if (!$projectid) {
			$options = array ();
			foreach ($pro as $value) {
				$options[$value['project_id']] = $value['project_name'];
			}
			$form->AddChangeRow ();
			$form->AddLabel ('project_id', _PROJECT_ADMINPROJECT);
			$form->AddSelect ('project_id', $options);
		}
		$form->AddChangeRow ();
		if ($projectid) {
			$form->SetSameCol ();
			$form->AddHidden ('project_id', $projectid);
			$form->AddHidden ('projectid', $projectid);
		}
		$form->AddHidden ('op', 'AddCat');
		if ($projectid) {
			$form->SetEndCol ();
		}
		$form->AddSubmit ('submit', _PROJECT_ADMINADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	if ( ($recordcount) && ($projectid) ) {
		if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			$boxtxt .= '<br /><br />';
			$form = & new opn_FormularClass ();
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_120_', 'project');
			$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
			$options = array ();
			foreach ($pro as $value) {
				$options[$value['project_id']] = $value['project_name'];
			}
			$form->AddSelect ('project_id', $options);
			$form->AddHidden ('projectid', $projectid);
			$form->AddHidden ('op', 'CopyCat');
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('from', _PROJECT_COPY_CAT_FROM);
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('to', _PROJECT_COPY_CAT_TO);
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_130_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function AddCatProject () {

	global $opnConfig, $category;

	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
	$category->AddRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'CatAdmin',
							'projectid' => $projectid),
							false) );
	CloseTheOpnDB ($opnConfig);

}

function EditCat () {

	global $opnConfig, $project, $category;

	ProjectConfigHeader ();
	$boxtxt = '';
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$category_id = 0;
	get_var ('category_id', $category_id, 'url', _OOBJ_DTYPE_INT);
	$projectid = 0;
	get_var ('projectid', $projectid, 'url', _OOBJ_DTYPE_INT);
	$pro = $project->GetArray ();
	$cat = $category->RetrieveSingle ($category_id);
	$boxtxt .= '<div align="center" class="bigtextbold">' . _PROJECT_EDITCATEGORY . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_140_', 'project');
	$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('category', _PROJECT_ADMINCATEGORYNAME);
	$form->AddTextfield ('category', 50, 64, $cat['category']);
	if (!$projectid) {
		$options = array ();
		foreach ($pro as $value) {
			$options[$value['project_id']] = $value['project_name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('project_id', _PROJECT_ADMINPROJECT);
		$form->AddSelect ('project_id', $options, $cat['project_id']);
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	if ($projectid) {
		$form->AddHidden ('project_id', $projectid);
		$form->AddHidden ('projectid', $projectid);
	}
	$form->AddHidden ('category_id', $category_id);
	$form->AddHidden ('op', 'SaveCat');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _PROJECT_ADMINSAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_150_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function SaveCat () {

	global $opnConfig, $category;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$category->ModifyRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'CatAdmin',
							'projectid' => $projectid),
							false) );

}

function DeleteCat () {

	global $opnConfig, $category;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$category_id = 0;
	get_var ('category_id', $category_id, 'both', _OOBJ_DTYPE_INT);
	$projectid = 0;
	get_var ('projectid', $projectid, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$category->DeleteRecord ();
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
								'op' => 'CatAdmin',
								'projectid' => $projectid),
								false) );
	} else {
		ProjectConfigHeader ();
		$result = $category->RetrieveSingle ($category_id);
		$title = $result['category'];
		$boxtxt = '<div class="bigtext" align="center"><br />';
		$boxtxt .= '<span class="alerttextcolor">';
		$boxtxt .= sprintf (_PROJECT_CATEGORY_DELETE, $title) . '<br /><br /></span>';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
										'op' => 'DeleteCat',
										'category_id' => $category_id,
										'projectid' => $projectid,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
															'op' => 'CatAdmin',
															'projectid' => $projectid) ) . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_160_';
		$_display_dat['module'] = 'modules/project';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function CopyCat () {

	global $opnConfig, $category;

	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$project_id = 0;
	get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
	$from = '';
	get_var ('from', $from, 'form', _OOBJ_DTYPE_CLEAN);
	$to = '';
	get_var ('to', $to, 'form', _OOBJ_DTYPE_CLEAN);
	if ($projectid != $project_id) {
		if ($from != '') {
			$category->SetProject ($project_id);
		} elseif ($to != '') {
			$category->SetProject ($projectid);
		}
		$cat = $category->GetArray ();
		foreach ($cat as $value) {
			set_var ('category', $value['category'], 'form');
			if ($from != '') {
				set_var ('project_id', $projectid, 'form');
			} elseif ($to != '') {
				set_var ('project_id', $project_id, 'form');
			}
			$category->AddRecord ();
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'CatAdmin',
							'projectid' => $projectid),
							false) );

}

function VersionAdmin () {

	global $opnConfig, $version, $project;

	ProjectConfigHeader ();
	$boxtxt = '';
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$projectid = 0;
	get_var ('projectid', $projectid, 'both', _OOBJ_DTYPE_INT);
	if ($projectid) {
		$version->SetProject ($projectid);
	}
	$recordcount = $version->GetCount ();
	$pro = $project->GetArray ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if ($recordcount) {
		$result = $version->GetLimit ($maxperpage, $offset);
		if ($result !== false) {
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('45%', '45%', '10%') );
			$table->AddHeaderRow (array (_PROJECT_VERSION, _PROJECT_PROJECT, _PROJECT_FUNCTIONS) );
			while (! $result->EOF) {
				$version_id = $result->fields['version_id'];
				$version = $result->fields['version'];
				$project_id = $result->fields['project_id'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'EditVersion',
												'version_id' => $version_id,
												'projectid' => $projectid) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
												'op' => 'DeleteVersion',
												'version_id' => $version_id,
												'projectid' => $projectid,
												'ok' => '0') );
					$hlp .= '&nbsp;';
				}
				$project_name = $pro[$project_id]['project_name'];
				$table->AddDataRow (array ($version, $project_name, $hlp), array ('center', 'center', 'center') );
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
			$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'VersionAdmin',
							'projectid' => $project),
							$recordcount,
							$maxperpage,
							$offset);
			$boxtxt .= '<br /><br />' . $pagebar;
		}
	}
	if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<br /><br /><div align="center" class="normaltextbold">' . _PROJECT_ADMINNEWVERSION . '</div>';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_170_', 'project');
		$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('version', _PROJECT_ADMINVERSIONNAME);
		$form->AddTextfield ('version', 50, 64);
		if (!$projectid) {
			$options = array ();
			foreach ($pro as $value) {
				$options[$value['project_id']] = $value['project_name'];
			}
			$form->AddChangeRow ();
			$form->AddLabel ('project_id', _PROJECT_ADMINPROJECT);
			$form->AddSelect ('project_id', $options);
		}
		$form->AddChangeRow ();
		if ($projectid) {
			$form->SetSameCol ();
			$form->AddHidden ('project_id', $projectid);
			$form->AddHidden ('projectid', $projectid);
		}
		$form->AddHidden ('op', 'AddVersion');
		if ($projectid) {
			$form->SetEndCol ();
		}
		$form->AddSubmit ('submit', _PROJECT_ADMINADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	if ( ($recordcount) && ($projectid) ) {
		if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			$boxtxt .= '<br /><br />';
			$form = & new opn_FormularClass ();
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_180_', 'project');
			$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
			$options = array ();
			foreach ($pro as $value) {
				$options[$value['project_id']] = $value['project_name'];
			}
			$form->AddSelect ('project_id', $options);
			$form->AddHidden ('projectid', $projectid);
			$form->AddHidden ('op', 'CopyVersion');
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('from', _PROJECT_COPY_VERSION_FROM);
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('to', _PROJECT_COPY_VERSION_TO);
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_190_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function AddVersion () {

	global $opnConfig, $version;

	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
	$version->AddRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'VersionAdmin',
							'projectid' => $projectid),
							false) );
	CloseTheOpnDB ($opnConfig);

}

function EditVersion () {

	global $opnConfig, $project, $version;

	ProjectConfigHeader ();
	$boxtxt = '';
	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$version_id = 0;
	get_var ('version_id', $version_id, 'url', _OOBJ_DTYPE_INT);
	$projectid = 0;
	get_var ('projectid', $projectid, 'url', _OOBJ_DTYPE_INT);
	$pro = $project->GetArray ();
	$ver = $version->RetrieveSingle ($version_id);
	$boxtxt .= '<div align="center" class="bigtextbold">' . _PROJECT_EDITVERSION . '</div>';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_PROJECT_200_', 'project');
	$form->Init ($opnConfig['opn_url'] . '/modules/project/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('version', _PROJECT_ADMINVERSIONNAME);
	$form->AddTextfield ('version', 50, 64, $ver['version']);
	if (!$projectid) {
		$options = array ();
		foreach ($pro as $value) {
			$options[$value['project_id']] = $value['project_name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('project_id', _PROJECT_ADMINPROJECT);
		$form->AddSelect ('project_id', $options, $ver['project_id']);
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	if ($projectid) {
		$form->AddHidden ('project_id', $projectid);
		$form->AddHidden ('projectid', $projectid);
	}
	$form->AddHidden ('version_id', $version_id);
	$form->AddHidden ('op', 'SaveVersion');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _PROJECT_ADMINSAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_210_';
	$_display_dat['module'] = 'modules/project';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function SaveVersion () {

	global $opnConfig, $version;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$version->ModifyRecord ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'VersionAdmin',
							'projectid' => $projectid),
							false) );

}

function DeleteVersion () {

	global $opnConfig, $version;

	$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$version_id = 0;
	get_var ('version_id', $version_id, 'both', _OOBJ_DTYPE_INT);
	$projectid = 0;
	get_var ('projectid', $projectid, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$version->DeleteRecord ();
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
								'op' => 'VersionAdmin',
								'projectid' => $projectid),
								false) );
	} else {
		ProjectConfigHeader ();
		$result = $version->RetrieveSingle ($version_id);
		$title = $result['version'];
		$boxtxt = '<div class="bigtext" align="center"><br />';
		$boxtxt .= '<span class="alerttextcolor">';
		$boxtxt .= sprintf (_PROJECT_VERSION_DELETE, $title) . '<br /><br /></span>';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
										'op' => 'DeleteVersion',
										'version_id' => $version_id,
										'projectid' => $projectid,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
															'op' => 'VersionAdmin',
															'projectid' => $projectid) ) . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_PROJECT_220_';
		$_display_dat['module'] = 'modules/project';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_PROJECT_INDEXPROJECTCONFIGURATION, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}

function CopyVersion () {

	global $opnConfig, $version;

	$projectid = 0;
	get_var ('projectid', $projectid, 'form', _OOBJ_DTYPE_INT);
	$project_id = 0;
	get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
	$from = '';
	get_var ('from', $from, 'form', _OOBJ_DTYPE_CLEAN);
	$to = '';
	get_var ('to', $to, 'form', _OOBJ_DTYPE_CLEAN);
	if ($projectid != $project_id) {
		if ($from != '') {
			$version->SetProject ($project_id);
		} elseif ($to != '') {
			$version->SetProject ($projectid);
		}
		$ver = $version->GetArray ();
		foreach ($ver as $value) {
			set_var ('version', $value['version'], 'form');
			if ($from != '') {
				set_var ('project_id', $projectid, 'form');
			} elseif ($to != '') {
				set_var ('project_id', $project_id, 'form');
			}
			$version->AddRecord ();
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/project/admin/index.php',
							'op' => 'VersionAdmin',
							'projectid' => $projectid),
							false) );

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'AddStatus':
		AddStatus ();
		break;
	case 'EditStatus':
		EditStatus ();
		break;
	case 'SaveStatus':
		SaveStatus ();
		break;
	case 'DeleteStatus':
		DeleteStatus ();
		break;
	case 'ProjectAdmin':
		ProjectAdmin ();
		break;
	case 'AddProject':
		AddProject ();
		break;
	case 'EditProject':
		EditProject ();
		break;
	case 'SaveProject':
		SaveProject ();
		break;
	case 'DeleteProject':
		DeleteProject ();
		break;
	case 'CatAdmin':
		CatAdmin ();
		break;
	case 'AddCat':
		AddCatProject ();
		break;
	case 'EditCat':
		EditCat ();
		break;
	case 'SaveCat':
		SaveCat ();
		break;
	case 'DeleteCat':
		DeleteCat ();
		break;
	case 'CopyCat':
		CopyCat ();
		break;
	case 'VersionAdmin':
		VersionAdmin ();
		break;
	case 'AddVersion':
		AddVersion ();
		break;
	case 'EditVersion':
		EditVersion ();
		break;
	case 'SaveVersion':
		SaveVersion ();
		break;
	case 'DeleteVersion':
		DeleteVersion ();
		break;
	case 'CopyVersion':
		CopyVersion ();
		break;
	case 'UserAdmin':
		UserAdmin ();
		break;
	default:
		StatusAdmin ();
		break;
}

?>