<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_PROJECT_PROJECT_INCLUDED') ) {
	define ('_OPN_PROJECT_PROJECT_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.abstracts.php');

	class Project extends AbstractProjects {

		function Project () {

			$this->_fieldname = 'project_id';
			$this->_tablename = 'projects';

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT project_id, project_name, project_status, project_enabled, project_state, project_desc FROM ' . $opnTables['projects'] . $where . ' ORDER BY project_id');
			while (! $result->EOF) {
				$this->_cache[$result->fields['project_id']]['project_id'] = $result->fields['project_id'];
				$this->_cache[$result->fields['project_id']]['project_name'] = $result->fields['project_name'];
				$this->_cache[$result->fields['project_id']]['project_status'] = $result->fields['project_status'];
				$this->_cache[$result->fields['project_id']]['project_enabled'] = $result->fields['project_enabled'];
				$this->_cache[$result->fields['project_id']]['project_state'] = $result->fields['project_state'];
				$this->_cache[$result->fields['project_id']]['project_desc'] = $result->fields['project_desc'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = $this->BuildWhere ();
				if ($where == '') {
					$where .= ' WHERE ';
				} else {
					$where .= ' AND ';
				}
				$where .= 'project_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT project_id, project_name, project_status, project_enabled, project_state, project_desc FROM ' . $opnTables['projects'] . $where);
				if (!$result->EOF) {
					$this->_cache[$id]['project_id'] = $result->fields['project_id'];
					$this->_cache[$id]['project_name'] = $result->fields['project_name'];
					$this->_cache[$id]['project_status'] = $result->fields['project_status'];
					$this->_cache[$id]['project_enabled'] = $result->fields['project_enabled'];
					$this->_cache[$id]['project_state'] = $result->fields['project_state'];
					$this->_cache[$id]['project_desc'] = $result->fields['project_desc'];
				}
				$result->Close ();
			}
			if (isset ($this->_cache[$id]) ) {
				return $this->_cache[$id];
			}
			return false;

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
			$project_name = '';
			get_var ('project_name', $project_name, 'form', _OOBJ_DTYPE_CLEAN);
			$project_status = 0;
			get_var ('project_status', $project_status, 'form', _OOBJ_DTYPE_INT);
			$project_enabled = 0;
			get_var ('project_enabled', $project_enabled, 'form', _OOBJ_DTYPE_INT);
			$project_state = 0;
			get_var ('project_state', $project_state, 'form', _OOBJ_DTYPE_INT);
			$project_desc = '';
			get_var ('project_desc', $project_desc, 'form', _OOBJ_DTYPE_CHECK);
			$project_id = $opnConfig['opnSQL']->get_new_number ('projects', 'project_id');
			$this->_cache[$project_id]['project_id'] = $project_id;
			$this->_cache[$project_id]['project_name'] = $project_name;
			$this->_cache[$project_id]['project_status'] = $project_status;
			$this->_cache[$project_id]['project_enabled'] = $project_enabled;
			$this->_cache[$project_id]['project_state'] = $project_state;
			$this->_cache[$project_id]['project_desc'] = $project_desc;
			$project_name = $opnConfig['opnSQL']->qstr ($project_name);
			$project_desc = $opnConfig['opnSQL']->qstr ($project_desc, 'project_desc');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['projects'] . "(project_id,project_name, project_status, project_enabled, project_state,project_desc) VALUES ($project_id,$project_name,$project_status,$project_enabled,$project_state,$project_desc)");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['projects'], 'project_id=' . $project_id);
			return $project_id;

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$project_name = '';
			get_var ('project_name', $project_name, 'form', _OOBJ_DTYPE_CLEAN);
			$project_status = 0;
			get_var ('project_status', $project_status, 'form', _OOBJ_DTYPE_INT);
			$project_enabled = 0;
			get_var ('project_enabled', $project_enabled, 'form', _OOBJ_DTYPE_INT);
			$project_state = 0;
			get_var ('project_state', $project_state, 'form', _OOBJ_DTYPE_INT);
			$project_desc = '';
			get_var ('project_desc', $project_desc, 'form', _OOBJ_DTYPE_CHECK);
			$this->_cache[$project_id]['project_name'] = $project_name;
			$this->_cache[$project_id]['project_status'] = $project_status;
			$this->_cache[$project_id]['project_enabled'] = $project_enabled;
			$this->_cache[$project_id]['project_state'] = $project_state;
			$this->_cache[$project_id]['project_desc'] = $project_desc;
			$project_name = $opnConfig['opnSQL']->qstr ($project_name);
			$project_desc = $opnConfig['opnSQL']->qstr ($project_desc, 'project_desc');
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['projects'] . " SET project_name=$project_name," . "project_status=$project_status," . "project_enabled=$project_enabled," . "project_state=$project_state," . "project_desc=$project_desc" . " WHERE project_id=$project_id");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['projects'], 'project_id=' . $project_id);

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$project_id = 0;
			get_var ('project_id', $project_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$project_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects'] . ' WHERE project_id=' . $project_id);

		}

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT project_id, project_name, project_status, project_enabled, project_state, project_desc FROM ' . $opnTables['projects'] . $where . ' ORDER BY project_id', $limit, $offset);
			return $result;

		}

		function BuildWhere () {

			global $opnConfig;
			if ($opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_DELETE, _PERM_NEW, _PERM_ADMIN), true) ) {
				return '';
			}
			return ' WHERE project_enabled=1 AND project_state=1';

		}

	}
}

?>