<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_PROJECT_VERSION_INCLUDED') ) {
	define ('_OPN_PROJECT_VERSION_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.abstracts.php');

	class ProjectVersion extends AbstractProjects {
		var $_project = 0;
		var $_desc = '';

		function ProjectVersion () {

			$this->_fieldname = 'version_id';
			$this->_tablename = 'projects_version';

		}

		function SetProject ($project) {

			$this->_project = $project;

		}

		function SetDescend () {

			$this->_desc = ' DESC';

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT version_id, version, project_id FROM ' . $opnTables['projects_version'] . $where . ' ORDER BY version_id' . $this->_desc);
			while (! $result->EOF) {
				$this->_cache[$result->fields['version_id']]['version_id'] = $result->fields['version_id'];
				$this->_cache[$result->fields['version_id']]['version'] = $result->fields['version'];
				$this->_cache[$result->fields['version_id']]['project_id'] = $result->fields['project_id'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = $this->BuildWhere ();
				if ($where == '') {
					$where = ' WHERE ';
				} else {
					$where .= ' AND ';
				}
				$where .= ' version_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT version_id, version, project_id FROM ' . $opnTables['projects_version'] . $where);
				$this->_cache[$id]['version_id'] = $result->fields['version_id'];
				$this->_cache[$id]['version'] = $result->fields['version'];
				$this->_cache[$id]['project_id'] = $result->fields['project_id'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
			$version = '';
			get_var ('version', $version, 'form', _OOBJ_DTYPE_CLEAN);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$version_id = $opnConfig['opnSQL']->get_new_number ('projects_version', 'version_id');
			$this->_cache[$version_id]['version_id'] = $version_id;
			$this->_cache[$version_id]['version'] = $version;
			$this->_cache[$version_id]['project_id_id'] = $project_id;
			$version = $opnConfig['opnSQL']->qstr ($version);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['projects_version'] . "(version_id,version,project_id) VALUES ($version_id,$version,$project_id)");
			return $version_id;

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
			$version_id = 0;
			get_var ('version_id', $version_id, 'form', _OOBJ_DTYPE_INT);
			$version = '';
			get_var ('version', $version, 'form', _OOBJ_DTYPE_CLEAN);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$this->_cache[$version_id]['version'] = $version;
			$this->_cache[$version_id]['project_id'] = $project_id;
			$version = $opnConfig['opnSQL']->qstr ($version);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['projects_version'] . " SET version=$version, project_id=$project_id WHERE version_id=$version_id");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$version_id = 0;
			get_var ('version_id', $version_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$version_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_version'] . ' WHERE version_id=' . $version_id);

		}

		function DeleteByProject ($project_id) {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_version'] . ' WHERE project_id=' . $project_id);

		}

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT version_id, version, project_id FROM ' . $opnTables['projects_version'] . $where . ' ORDER BY version_id', $limit, $offset);
			return $result;

		}

		function BuildWhere () {
			if ($this->_project) {
				return ' WHERE project_id=' . $this->_project;
			}
			return '';

		}

	}
}

?>