<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function reviews_nav ($letter) {

	global $opnConfig, $opnTables;

	$boxtxt = '<div class="centertag">';
	$boxtxt .= '<br />';
	if (isset ($opnConfig['review_lettersasnormallink']) && $opnConfig['review_lettersasnormallink'] == 1) {
		$classname = 'opncenterbox';
	} else {
		$classname = 'txtbutton';
	}
	if (isset ($opnConfig['review_showonlypossibleletters']) && $opnConfig['review_showonlypossibleletters'] == 1) {
		$sql = 'SELECT orderchar FROM ' . $opnTables['reviews'] . ' GROUP BY orderchar';
	} else {
		$sql = '';
	}
	$boxtxt .= build_letterpagebar (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
						'op' => 'reviews'),
						'letter',
						$letter,
						$sql);
	$boxtxt .= '<br />';
	if ($opnConfig['permission']->HasRights ('modules/reviews', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$boxtxt .= '<a href="' . encodeurl ($opnConfig['opn_url'] . '/modules/reviews/index.php?op=write_review') . '" class="opncenterbox"><span class="normaltextbold">' . _REVIEW_WRITE_REVIEW . '</span></a>';
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/search') ) {
		$boxtxt .= '<br />';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_90_', 'reviews');
		$form->Init ($opnConfig['opn_url'] . '/system/search/index.php', 'post');
		$form->AddTextfield ('query', 17);
		$form->AddText ('&nbsp;');
		$form->AddHidden ('types[]', 'reviews');
		$form->AddSubmit ('submit', _REVIEW_SEARCH);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$boxtxt .= '</div><br />';
	return $boxtxt;

}

function reviews_display_score ($score) {

	global $opnConfig;

	$image = '<img src="' . $opnConfig['opn_default_images'] . 'blue.gif" alt="" />';
	$halfimage = '<img src="' . $opnConfig['opn_default_images'] . 'bluehalf.gif" alt="" />';
	$full = '<img src="' . $opnConfig['opn_default_images'] . 'star.gif" alt="" />';
	$boxtxt = '';
	if ($score == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score%2) {
		$score -= 1;
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image;
	}
	return $boxtxt;

}

function write_review ($mf) {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/reviews', array (_PERM_WRITE, _PERM_ADMIN) );
	$boxtxt = '<br />';
	$boxtxt .= '<span class="normaltextbold">' . _REVIEW_WRITE_REVIEW_FOR . " " . $opnConfig['sitename'] . "</span><br /><br /><span class='normaltextitalic'>" . _REVIEW_SPECS_TEXT . "</span><br /><br /><div class='normaltext'>";
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_100_', 'reviews');
	$form->Init ($opnConfig['opn_url'] . '/modules/reviews/index.php', 'post', 'coolsus');
	$form->AddCheckField ('title', 'e', _REVIEW_ERR_TITLE);
	$form->AddCheckField ('text', 'e', _REVIEW_ERR_TITLE_TEXT);
	$form->AddCheckField ('score', '<', _REVIEW_ERR_SCORE,'',0);
	$form->AddCheckField ('score', '>', _REVIEW_ERR_SCORE,'',11);
	$form->AddCheckField ('reviewer', 'e', _REVIEW_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'e', _REVIEW_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'm', _REVIEW_ERR_EMAIL);
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('title', _REVIEW_PRODUCT_TITLE);
	$form->AddTextfield ('title', 50, 150);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('text', _REV_DES);
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_WRITE_TEXT . '</span><br />');
	$form->SetEndCol ();
	$form->UseImages (true);
	$form->AddTextarea ('text');
	if ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$name = $userinfo['uname'];
		$email = '';
		if (isset ($userinfo['femail']) ) {
			$email = $userinfo['femail'];
		}
	}
	if (!isset ($name) ) {
		$name = '';
	}
	if (!isset ($email) ) {
		$email = '';
	}
	$form->AddChangeRow ();
	$form->AddLabel ('reviewer', _REVIEW_YOUR_NAME);
	$form->SetSameCol ();
	$form->AddTextfield ('reviewer', 40, 20, $name);
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_YOUR_NAME_REQUIRED . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('email', _REVIEW_YOUR_EMAIL);
	$form->SetSameCol ();
	$form->AddTextfield ('email', 40, 30, $email);
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_YOUR_EMAIL_REQUIRED . '</span>');
	$form->SetEndCol ();
	$options = array ();
	for ($i = 10; $i>0; $i--) {
		$options[$i] = $i;
	}
	$form->AddChangeRow ();
	$form->AddLabel ('score', _REVIEW_SCORE);
	$form->SetSameCol ();
	$form->AddSelect ('score', $options);
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_SCORE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url', _REVIEW_RELAT_LINK);
	$form->SetSameCol ();
	$form->AddTextfield ('url', 40, 100, 'http://');
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_RELAT_LINK_TEXT . ' "http://"</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url_title', _REVIEW_LINK_TITLE);
	$form->SetSameCol ();
	$form->AddTextfield ('url_title', 40, 50);
	$form->AddText ('<br /><span class="normaltextitalic">' . _REVIEW_LINK_TITLE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _REVIEW_CATE);
	$mf->makeMySelBox (0, $form, 0, 'cid');
	if ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) {
		$form->AddChangeRow ();
		$form->AddLabel ('cover', _REVIEW_IMAGE_NAME);
		$form->SetSameCol ();
		$form->AddTextfield ('cover', 40, 100);
		$form->AddText ('<br /><span class="normaltextitalic">' . sprintf (_REVIEW_IMAGE_NAME_TEXT, $opnConfig['datasave']['reviews_images']['url']) . '</span>');
		$form->SetEndCol ();
	}
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText ('<span class="normaltextitalic">' . _REVIEW_WRITE_REVIEW_TEXT . '</span>');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'preview_review');
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _REVIEW_WRITE_PREVIEW);
	$form->AddText (' ');
	$form->AddButton ('Cancel', _REVIEW_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_110_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function preview_review () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/reviews', array (_PERM_WRITE, _PERM_ADMIN) );
	$date = '';
	get_var ('date', $date, 'form', _OOBJ_DTYPE_CLEAN);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$reviewer = '';
	get_var ('reviewer', $reviewer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$title = stripslashes ($opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml') );
	$text = stripslashes ($opnConfig['cleantext']->filter_text ($text, true, true) );
	$reviewer = stripslashes ($opnConfig['cleantext']->filter_text ($reviewer, false, true, 'nohtml') );
	$url_title = stripslashes ($opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml') );
	if ($url == 'http://') {
		$url = '';
	}
	$errormsg = '';
	$boxtxt = '<br />';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_120_', 'reviews');
	$form->Init ($opnConfig['opn_url'] . '/modules/reviews/index.php', 'post', 'coolsus');
	if ( ($hits<0) && ($id != 0) ) {
		$errormsg .= _REVIEW_ERR_HITS . '<br />';
	}
	if ( ($url_title != '' && $url == '') || ($url_title == '' && $url != '') ) {
		$errormsg .= _REVIEW_ERR_LINK . '<br />';
	} elseif ( ($url != '') && (! (preg_match ('/(^http[s]*:[\/]+)(.*)/i', $url) ) ) ) {
		$url = 'http://' . $url;
	}
	if ($errormsg != '') {
		$form->AddText ($errormsg . '<br />');
		$form->AddButton ('Cancel', _REVIEW_GOBACK, '', '', 'history.go(-1)');
	} else {
		if ($date != '') {
			$opnConfig['opndate']->sqlToopnData ($date);
		}
		$fdate = '';
		$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
		if ($hits == '') {
			$hits = 1;
		}
		$form->AddText ('<div class="extratextbold" align="center">' . $title . '</div>');
		if ($cover != '') {
			$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/reviews/images/reviews/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />');
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$showtext = make_user_images ($text);
		} else {
			$showtext = $text;
		}
		opn_nl2br ($showtext);
		$form->AddText ('<div >' . $showtext . '</div>');
		$form->AddText ('<br />');
		$form->AddText (reviews_extrainfo ($id, $fdate, $title, $reviewer, $email, $score, $url_title, $url, $hits, 1) );
		$text = urlencode ($text);
		$form->AddText ('<div class="centertag">');
		$form->AddText ('<span class="normaltextitalic">' . _REVIEW_LOOK_RIGHT . ' </span>');
		$form->AddText ('</div>');
		$form->AddHidden ('id', $id);
		$form->AddHidden ('hits', $hits);
		$form->AddHidden ('op', 'send_review');
		$form->AddHidden ('date', $date);
		$form->AddHidden ('title', $title);
		$form->AddHidden ('text', $text);
		$form->AddHidden ('reviewer', $reviewer);
		$form->AddHidden ('email', $email);
		$form->AddHidden ('score', $score);
		$form->AddHidden ('url', $url);
		$form->AddHidden ('url_title', $url_title);
		$form->AddHidden ('cover', $cover);
		$form->AddHidden ('cid', $cid);
		$form->AddText ('<div class="centertag">');
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText (' ');
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</div>');
		if ($id != 0) {
			$word = _REVIEW_MOD;
		} else {
			$word = _REVIEW_ADD;
		}
		if ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) {
			$form->AddText ('<br /><br /><span class="normaltextbold">' . _REVIEW_NOTE . '</span> ' . _REVIEW_LOG_ADMIN_TEXT . ' ' . $word . '&nbsp;' . _REVIEW_IMMED . '.');
		}
	}
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_130_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function send_review () {

	global $opnTables, $opnConfig;

	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$reviewer = '';
	get_var ('reviewer', $reviewer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/reviews', array (_PERM_WRITE, _PERM_ADMIN) );
	$title = $opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml');
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($title{0}) );
	$title = $opnConfig['opnSQL']->qstr ($title);
	$text = urldecode ($opnConfig['cleantext']->filter_text ($text, false, true) );
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$text = make_user_images ($text);
	}
	$url_title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml') );
	$opnConfig['cleantext']->filter_text ($reviewer, false, true, 'nohtml');
	$boxtxt = '<br />';
	$boxtxt .= '<br /><div class="centertag">' . _REVIEW_THANKS;
	if ($id != 0) {
		$boxtxt .= ' ' . _REVIEW_MODI;
	} else {
		$boxtxt .= ', ' . $reviewer;
	}
	$boxtxt .= '!<br />';
	$opnConfig['opndate']->now ();
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_reviewer = $opnConfig['opnSQL']->qstr ($reviewer);
	$_cover = $opnConfig['opnSQL']->qstr ($cover);
	$_url = $opnConfig['opnSQL']->qstr ($url);
	$text = $opnConfig['opnSQL']->qstr ($text, 'text');
	if ( ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) && ($id == 0) ) {
		$id = $opnConfig['opnSQL']->get_new_number ('reviews', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['reviews'] . " VALUES ($id, $date, $title, $text, $_reviewer, $_email, $score, $_cover, $_url, $url_title, 1, $cid,$orderchar)");
		if ($result === false) {
			die ('Unable to insert recordset');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['reviews'], 'id=' . $id);
		$boxtxt .= _REVIEW_AVAI_TEXT;
	} elseif ( ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) && ($id != 0) ) {
		$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['reviews'] . " SET text=$text,wdate=$date, title=$title, reviewer=$_reviewer, email=$_email, score=$score, cover=$_cover, url=$_url, url_title=$url_title, hits=$hits, cid=$cid, orderchar=$orderchar WHERE id = $id");
		if ($result === false) {
			die ('Unable to update record');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['reviews'], 'id=' . $id);
		$boxtxt .= _REVIEW_AVAI_TEXT;
	} else {
		$id = $opnConfig['opnSQL']->get_new_number ('reviews_add', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['reviews_add'] . " VALUES ($id, $date, $title, $text, $_reviewer, $_email, $score, $_url, $url_title,$cid)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['reviews_add'], 'id=' . $id);
		if ($result === false) {
			die ('Unable to insert record');
		}
		$result->Close ();
		$boxtxt .= _REVIEW_LOOK_SUBMISSION;
		if ($opnConfig['send_new_review']) {
			$vars = array ();
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($opnConfig['adminmail'], _REVIEW_REV_SEND, 'modules/reviews', 'newreview', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
			$mail->send ();
			$mail->init ();
		}
	}
	$boxtxt .= '<br /><br />[ <a href="' . $opnConfig['opn_url'] . '/modules/reviews/index.php" class="opncenterbox">' . _REVIEW_BACK_INDEX . '</a> ]<br /></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_140_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function reviews_index ($reviewscat, $mf) {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$cid = 0;
		get_var ('cat_id', $cid, 'url', _OOBJ_DTYPE_INT);
	}
	$hlptxt = '';
	if ($cid == 0) {
		$hlptxt = $reviewscat->MainNavigation ();
	}
	$boxtxt = $hlptxt;
	if ($cid != 0) {
		$boxtxt .= $reviewscat->SubNavigation ($cid);
	}
	$boxtxt .= reviews_nav ('');
	$result = &$opnConfig['database']->Execute ('SELECT title, description FROM ' . $opnTables['reviews_main']);
	if ($result !== false) {
		$title = $result->fields['title'];
		$description = $result->fields['description'];
		opn_nl2br ($description);
		$result->Close ();
	}
	if ($title != '') {
		OpenTable2 ($boxtxt);
		$boxtxt .= '<div align="center" class="normaltextbold">' . $title . '</div>';
		$boxtxt .= '<br />';
		$boxtxt .= '<div class="centertag">' . $description . '</div>';
		CloseTable2 ($boxtxt);
		$boxtxt .= '<br />';
	}
	$where = '';
	if ($cid != 0) {
		$where = 'i.cid=' . $cid . ' ';
	}
	$result_pop = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.hits DESC'),
		10,
		$where);
	$result_rec = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.wdate DESC'),
		10, $where);
	$y = 1;
	$boxtxt .= '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('50%', '50%') );
	$table->AddHeaderRow (array (_REVIEW_10_POP, _REVIEW_10_REC) );
	if ( ($result_pop !== false) && ($result_rec !== false) ) {
		for ($x = 0; $x<10; $x++) {
			$row = $result_pop->GetRowAssoc ('0');
			if ($row['id'] != '') {
				$hlp = $y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
												'op' => 'showcontent',
												'id' => $row['id']) ) . '">' . $row['title'] . '</a>';
			} else {
				$hlp = '&nbsp;';
			}
			$row = $result_rec->GetRowAssoc ('0');
			if ($row['id'] != '') {
				$hlp1 = $y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
												'op' => 'showcontent',
												'id' => $row['id']) ) . '">' . $row['title'] . '</a>';
			} else {
				$hlp1 = '&nbsp;';
			}
			$table->AddDataRow (array ($hlp, $hlp1) );
			$y++;
			$result_pop->MoveNext ();
			$result_rec->MoveNext ();
		}
		$result_pop->Close ();
		$result_rec->Close ();
	}
	$table->GetTable ($boxtxt);
	$numresults = $mf->GetItemCount ($where);
	$boxtxt .= '<br />';
	$boxtxt .= _REVIEW_THERE_ARE . '&nbsp;' . $numresults . '&nbsp;' . _REVIEW_IN_DB;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_150_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function reviews () {

	global $opnConfig, $mf;

	$field = 'title';
	get_var ('field', $field, 'url', _OOBJ_DTYPE_CLEAN);
	$letter = '';
	get_var ('letter', $letter, 'url', _OOBJ_DTYPE_CLEAN);
	$order = 'ASC';
	get_var ('order', $order, 'url', _OOBJ_DTYPE_CLEAN);
	$letter = $opnConfig['cleantext']->filter_searchtext ($letter);
	if ( ($letter != '123') && ($letter != 'ALL') ) {
		$like_search = $opnConfig['opnSQL']->AddLike ($letter, '', '%');
		$where = "title LIKE $like_search ";
	} elseif ( ($letter == '123') && ($letter != 'ALL') ) {
		$where = $opnConfig['opnSQL']->CreateOpnRegexp ('title', '0-9');
	} else {
		$where = '';
	}
	$numresults = 0;
	$err = $opnConfig['cleantext']->var_possible_check ($field, array ('title','reviewer','email','score','id','hits'));
	$result = $mf->GetItemResult (array ('id',
					'title',
					'hits',
					'reviewer',
					'email',
					'score'),
					array ($field . ' ' . $order),
		$where);
	$boxtxt = reviews_nav ($letter);
	if ($result !== false) {
		$numresults = $result->RecordCount ();
	}
	$boxtxt .= '<br /><br />';
	if ($numresults == 0) {
		$boxtxt .= '<span class="normaltextitalic"><span class="normaltextbold">' . sprintf (_REVIEW_NO_REV_FOR_LETTER, $letter) . '</span></span><br /><br />';
	} elseif ($numresults>0) {
		$i = 1;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('40%', '21%', '21%', '18%') );
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
											'op' => 'reviews',
											'letter' => $letter,
											'field' => 'title',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_ASC . '"></a> ' . _REVIEW_PRODUCT_TITLE . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																													'op' => 'reviews',
																													'letter',
																													$letter,
																													'field' => 'title',
																													'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_DESC . '"></a>',
																													'left');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
											'op' => 'reviews',
											'letter' => $letter,
											'field' => 'reviewer',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_ASC . '"></a> ' . _REV_ER . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																												'op' => 'reviews',
																												'letter',
																												$letter,
																												'field' => 'reviewer',
																												'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_DESC . '"></a>',
																												'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
											'op' => 'reviews',
											'letter' => $letter,
											'field' => 'score',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_ASC . '"></a> ' . _REVIEW_SCORE . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																												'op' => 'reviews',
																												'letter',
																												$letter,
																												'field' => 'score',
																												'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_DESC . '"></a>',
																												'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
											'op' => 'reviews',
											'letter' => $letter,
											'field' => 'hits',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_ASC . '"></a> ' . _REVIEW_HITS . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																												'op' => 'reviews',
																												'letter',
																												$letter,
																												'field=' => 'hits',
																												'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_arrow.gif" class="imgtag" title="' . _REVIEW_SORT_DESC . '"></a>',
																												'center');
		$table->AddCloseRow ();
		while (! $result->EOF) {
			$i++;
			$id = $result->fields['id'];
			$title = $result->fields['title'];
			$id = $result->fields['id'];
			$reviewer = $result->fields['reviewer'];

			#			$email = $result->fields['email'];

			$score = $result->fields['score'];
			$hits = $result->fields['hits'];
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
										'op' => 'showcontent',
										'id' => $id) ) . '">' . $title . '</a>';
			$hlp1 = reviews_display_score ($score);
			$table->AddDataRow (array ($hlp, $reviewer, $hlp1, $hits), array ('left', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
		$result->Close ();
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><div class="normaltext" align="center">' . $numresults . '&nbsp;' . _REVIEW_TOTAL . '</div><br /><br />';
	}
	$boxtxt .= '<div class="centertag">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/reviews/index.php">' . _REVIEW_RET_MAIN . '</a> ]</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_160_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function reviews_postcomment () {

	global $anonpost, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/reviews', _PERM_WRITE);
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$title = '';
	get_var ('title', $title, 'url', _OOBJ_DTYPE_CLEAN);
	$title = urldecode ($title);
	$boxtxt = '<br />';
	$boxtxt .= '<div class="bigtextbold" align="center">' . _REVIEW_COM_REV . ' ' . $title . '</div>';
	$boxtxt .= '<br />';
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_170_', 'reviews');
	$form->Init ($opnConfig['opn_url'] . '/modules/reviews/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	if ( ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 1) ) or ($opnConfig['permission']->IsUser () ) ) {
		$form->AddText (_REVIEW_YOUR_NICKNAME);
		if (!$opnConfig['permission']->IsUser () ) {
			$form->AddText ('Anonymous [ <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _REVIEW_CREATE_ACCOUNT . ' ]');
			$cookie['uname'] = $opnConfig['opn_anonymous_name'];
		} else {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$form->SetSameCol ();
			$form->AddText ($cookie['uname']);
			if ($anonpost == 1) {
				$form->AddCheckbox ('xanon', 1);
				$form->AddText (_REVIEW_POST_ANONYM);
			}
			$form->AddText ('&nbsp;');
			$form->SetEndCol ();
		}
		$form->AddChangeRow ();
		$form->AddLabel ('score', _REVIEW_PRODUCT_SCORE);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->AddSelect ('score', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('comments', _REVIEW_YOU_COMM);
		$form->AddTextarea ('comments');
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddText (_REVIEW_HTML . '<br />');
		if (is_array ($opnConfig['AllowableHTML']) ) {
			$temp = array_keys ($opnConfig['AllowableHTML']);
			foreach ($temp as $key) {
				$boxtxt .= $form->AddText (htmlentities ($key) . ' ');
			}
		}
		$form->AddText ('&nbsp;');
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('uname', $cookie['uname']);
		$form->AddHidden ('id', $id);
		$form->AddHidden ('op', 'savecomment');
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _REVIEW_SUBMIT);
	} else {
		$form->AddText (sprintf (_REVIEW_PLEASE_REG, $opnConfig['opn_url']) );
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_180_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function reviews_printComments ($id) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT userid, wdate, comments, score FROM ' . $opnTables['reviews_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			if ($uname == $opnConfig['opn_anonymous_name']) {
				$boxtxt .= _REVIEW_POST_BY . ' ' . $uname . '&nbsp;' . _REVIEW_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= _REVIEW_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $uname) ) . '">' . $uname . '</a> ' . _REVIEW_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= _REVIEW_MY_SCORE . ' ';
			$boxtxt .= reviews_display_score ($score);
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function reviews_savecomment () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/reviews', _PERM_WRITE);
	$xanon = 0;
	get_var ('xanon', $xanon, 'form', _OOBJ_DTYPE_INT);
	$uname = '';
	get_var ('uname', $uname, 'form', _OOBJ_DTYPE_CLEAN);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$comments = '';
	get_var ('comments', $comments, 'form', _OOBJ_DTYPE_CHECK);
	if ($xanon) {
		$uname = $opnConfig['opn_anonymous_name'];
	}
	$comments = $opnConfig['opnSQL']->qstr (urldecode ($opnConfig['cleantext']->filter_text ($comments, true, true) ), 'comments');
	$opnConfig['cleantext']->filter_text ($uname, false, true, 'nohtml');
	$cid = $opnConfig['opnSQL']->get_new_number ('reviews_comments', 'cid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$_uname = $opnConfig['opnSQL']->qstr ($uname);
	$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['reviews_comments'] . " VALUES ($cid, $id, $_uname, $now, $comments, $score)");
	$result->Close ();
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['reviews_comments'], 'cid=' . $cid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/reviews/index.php?', false, true, array ('op' => 'showcontent',
																'id' => $id) ) );

}

function reviews_r_comments ($id, $title) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT cid, userid, wdate, comments, score FROM ' . $opnTables['reviews_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			$title = urldecode ($title);
			$boxtxt .= '<span class="normaltextbold">' . $title . '</span><br />';
			if ($uname == $opnConfig['opn_anonymous_name']) {
				$boxtxt .= _REVIEW_POST_BY . ' ' . $uname . '&nbsp;' . _REVIEW_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= _REVIEW_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $uname) ) . '">' . $uname . '</a> ' . _REVIEW_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= _REVIEW_MY_SCORE . ' ';
			$boxtxt .= reviews_display_score ($score);
			if ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) {
				$boxtxt .= '<br /><span class="normaltextbold">' . _REVIEW_ADMIN . '</span> [ <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																				'op' => 'del_comment',
																				'cid' => $cid,
																				'id' => $id) ) . '">' . _REVIEW_DEL . '</a> ]<hr noshade="noshade" size="1" /><br /><br />';
			} else {
				$boxtxt .= '<hr noshade="noshade" size="1" /><br /><br />';
			}
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function reviews_showcontent () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['reviews'] . ' SET hits=hits+1 WHERE id=' . $id);
	$result->Close ();
	$myrow = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, reviewer, email, hits, url, url_title, score FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id);
	if ( ($myrow !== false) && (!$myrow->EOF) ) {
		$id = $myrow->fields['id'];
		$opnConfig['opndate']->sqlToopnData ($myrow->fields['wdate']);
		$fdate = '';
		$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
		$title = $myrow->fields['title'];
		$text = $myrow->fields['text'];
		$cover = $myrow->fields['cover'];
		$reviewer = $myrow->fields['reviewer'];
		$email = $myrow->fields['email'];
		$hits = $myrow->fields['hits'];
		$url = $myrow->fields['url'];
		$url_title = $myrow->fields['url_title'];
		$score = $myrow->fields['score'];
		$boxtxt .= '<div class="extratextbold" align="center">' . $title . '</div><br /><br />';
		$boxtxt .= '<div class="normaltext">';
		if ($cover != '') {
			$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/reviews/images/reviews/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />';
		}
		opn_nl2br ($text);
		$boxtxt .= '' . $text . '</div>';
		$boxtxt .= reviews_extrainfo ($id, $fdate, $title, $reviewer, $email, $score, $url_title, $url, $hits, 0);
		$title = urlencode ($title);
		$boxtxt .= '<br /><br /><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/reviews/index.php">' . _REVIEW_BACK_INDEX . '</a> ]</span>';
		$boxtxt .= '<br />';
		$boxtxt .= reviews_r_comments ($id, $title);
	}
	$myrow->Close ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_190_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function mod_review ($mf) {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN);
	$id = 0;
	get_var ('id', $id, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = '<br />';
	if ( ($id == 0) ) {
		$boxtxt .= 'This function must be passed argument id, or you are not admin.';
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, reviewer, email, hits, url, url_title, score, cid FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id);
		if ($result !== false) {
			$date = '';
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
				$opnConfig['opndate']->formatTimestamp ($date);
				$title = $result->fields['title'];
				$text = $result->fields['text'];
				$cover = $result->fields['cover'];
				$reviewer = $result->fields['reviewer'];
				$email = $result->fields['email'];
				$hits = $result->fields['hits'];
				$url = $result->fields['url'];
				$url_title = $result->fields['url_title'];
				$score = $result->fields['score'];
				$cid = $result->fields['cid'];
				$result->MoveNext ();
			}
			$result->Close ();
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = de_make_user_images ($text);
		}
		$text = opn_br2nl ($text);
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_200_', 'reviews');
		$form->Init ($opnConfig['opn_url'] . '/modules/reviews/index.php');
		$form->UseImages (true);
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('date', _REVIEW_DAT);
		$form->AddTextfield ('date', 18, 18, $date);
		$form->AddChangeRow ();
		$form->AddLabel ('title', _REVIEW_TITEL);
		$form->AddTextfield ('title', 50, 150, $title);
		$form->AddChangeRow ();
		$form->AddLabel ('text', _REVIEW_TEXT);
		$text = str_replace ('&amp;', '&amp;amp;', $text);
		$text = str_replace ('&lt;', '&amp;lt;', $text);
		$text = str_replace ('&gt;', '&amp;gt;', $text);
		$form->AddTextarea ('text', 0, 0, '', $text);
		$form->AddChangeRow ();
		$form->AddLabel ('reviewer', _REV_ER);
		$form->AddTextfield ('reviewer', 30, 20, $reviewer);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _REVIEW_EMAIL);
		$form->AddTextfield ('email', 30, 60, $email);
		$form->AddChangeRow ();
		$form->AddLabel ('score', _REVIEW_SCORE);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->AddSelect ('score', $options, $score);
		$form->AddChangeRow ();
		$form->AddLabel ('url', _REVIEW_LINK);
		$form->AddTextfield ('url', 30, 100, $url);
		$form->AddChangeRow ();
		$form->AddLabel ('url_title', _REVIEW_LINK_TITLE);
		$form->AddTextfield ('url_title', 30, 50, $url_title);
		$form->AddChangeRow ();
		$form->AddLabel ('cid', _REVIEW_CATE);
		$mf->makeMySelBox ($cid, $form, 0, 'cid');
		$form->AddChangeRow ();
		$form->AddLabel ('cover', _REVIEW_COVER_IMG);
		$form->AddTextfield ('cover', 30, 100, $cover);
		$form->AddChangeRow ();
		$form->AddLabel ('hits', _REVIEW_HITS);
		$form->AddTextfield ('hits', 5, 5, $hits);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('op', 'preview_review');
		$form->AddHidden ('id', $id);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddSubmit ('submit', _REVIEW_WRITE_PREVIEW);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddButton ('Cancel', _REVIEW_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_210_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_REVIEW_MODIFIC, $boxtxt);

}

function del_review () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN);
	$id_del = 0;
	get_var ('id_del', $id_del, 'url', _OOBJ_DTYPE_INT);
	$yes = 0;
	get_var ('yes', $yes, 'url', _OOBJ_DTYPE_INT);
	if ( ($yes) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['reviews_comments'] . ' WHERE rid=' . $id_del);
		$result->Close ();
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id_del);
		$result->Close ();
		$opnConfig['opnOutput']->Redirect ('/modules/reviews/index.php');
	} else {
		$boxtxt = '<h3>' . sprintf (_REVIEW_DEL_REV, $id_del) . '</h3>';
		$boxtxt .= '' . sprintf (_REVIEW_DEL_REV_TXT, $id_del) . ' ';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
										'op' => 'del_review',
										'id_del' => $id_del,
										'yes' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
															'op' => 'showcontent',
															'id' => $id_del) ) . '">' . _NO . '</a><br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_220_';
		$_display_dat['module'] = 'modules/reviews';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	}

}

function reviews_del_comment () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN);
	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['reviews_comments'] . ' WHERE cid=' . $cid);
	$result->Close ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
							'op' => 'showcontent',
							'id' => $id),
							false) );

}

function PrintReview () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$printcomment = 0;
	get_var ('printcomment', $printcomment, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		$opnConfig['opnOutput']->Redirect ('/modules/reviews/index.php');
	}
	$themecss = $opnConfig['opnOutput']->css;
	$result = &$opnConfig['database']->Execute ('SELECT wdate, title, text, reviewer, email, score, cover, url, url_title FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id);
	if ($result !== false) {
		$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date, _DATE_FORUMDATESTRING2);
		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$reviewer = $result->fields['reviewer'];
		$email = $result->fields['email'];
		$score = $result->fields['score'];
		$cover = $result->fields['cover'];
		$url = $result->fields['url'];
		$url_title = $result->fields['url_title'];
		$result->Close ();
	}
	echo '<html><head><title>' . $opnConfig['sitename'] . ' - ' . $title . '</title>';
	if ($themecss != '') {
		echo '<link href="' . $themecss . '" rel="stylesheet">' . _OPN_HTML_NL;
	}
	echo '</head><body bgcolor="#FFFFFF" text="#000000"><table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr class="opncenterbox"><td class="opncenterbox"><table border="0" width="640" cellpadding="0" cellspacing="1" class="bgcolor2"><tr class="opncenterbox"><td class="opncenterbox"><table border="0" width="640" cellpadding="20" cellspacing="1" class="bgcolor3"><tr class="opncenterbox"><td class="opncenterbox"><div class="bigtextbold" align="center">' . $title . '</span><br /><br /></div>';
	if ($cover != '') {
		echo '<img src="' . $opnConfig['opn_url'] . '/modules/reviews/images/reviews/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />' . _OPN_HTML_NL;
	}
	echo $text . '<br /><br />' . _OPN_HTML_NL . '<span class="normaltextbold">' . _REV_ER . '</span> ' . $reviewer . ' (' . $opnConfig['crypttext']->CodeEmail ($email) . ')<br />' . '<span class="normaltextbold">' . _REVIEW_ADD . '</span> ' . $date . '<br />' . '<span class="normaltextbold">' . _REVIEW_SCORE . '</span> ';
	echo reviews_display_score ($score);
	echo '<br /><span class="normaltextbold">' . _REVIEW_RELAT_LINK . ' </span> ' . $url_title . '<br />' . '<span class="normaltextbold">' . _REVIEW_RELAT_URL . '</span> ' . $url . '<br /><br />';
	if ($printcomment == 1) {
		echo '<br />';
		echo '<br />' . _REVIEW_COMMENT . '<br />';
		echo '<br />';
		echo reviews_printcomments ($id);
	}
	echo '</td></tr></table></td></tr></table><br /><br /><div class="centertag">' . _REVIEW_THIS_REV . ' ' . $opnConfig['sitename'] . '<br />' . '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '">' . $opnConfig['opn_url'] . '</a><br /><br />' . _REVIEW_URL_REV . '<br />' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																																											'op' => 'showcontent',
																																											'id' => $id) ) . '">' . encodeurl ($opnConfig['opn_url'] . '/index.php?op=showcontent&id=' . $id) . '</a>' . '</td></tr></table></body></html>';

}

function reviews_extrainfo ($id, $fdate, $title, $reviewer, $email, $score, $url_title, $url, $hits, $preview) {

	global $anonpost, $opnTables, $opnConfig;

	$_reviewer = $opnConfig['opnSQL']->qstr ($reviewer);
	$result = &$opnConfig['database']->Execute ('SELECT uname FROM ' . $opnTables['users'] . " WHERE uname=$_reviewer");
	if ($result !== false) {
		$name = $result->fields['uname'];
		$result->Close ();
	} else {
		$name = '';
	}
	if ($name != '') {
		$name = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $name) ) . '" target="_blank">' . $reviewer . '</a>';
	} else {
		$name = $reviewer;
	}
	$boxtxt = '<br /><br />';
	$table = & new opn_TableClass ('listalternator');
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol ($opnConfig['defimages']->get_info_image (_REVIEW_EX_INFO), 'left', '2');
	$table->AddCloseRow ();
	$table->AddDataRow (array (_REVIEW_DATE_ADD, $fdate) );
	$table->AddOpenRow ();
	$table->AddDataCol (_REV_ER);
	$name .= ' (' . $opnConfig['crypttext']->CodeEmail ($email, '', $table->currentclass) . ')';
	$table->AddDataCol ($name);
	$table->AddCloseRow ();
	if ($score != '') {
		$hlp = reviews_display_score ($score) . _OPN_HTML_NL;
		$hlp .= '  (' . sprintf (_REVIEW_READ_TIMES, $hits) . ')';
		$table->AddDataRow (array (_REVIEW_SCORE, $hlp) );
	}
	if ($url != '') {
		$table->AddDataRow (array (_REVIEW_RELAT_LINK, '<a class="%alternate%" href="' . $url . '" target="_blank">' . $url_title . '</a>') );
	}
	if (!$preview) {
		$hlp = '';
		if ( ($opnConfig['permission']->IsUser () ) or ($anonpost == 1) ) {
			$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
										'op' => 'postcomment',
										'id' => $id,
										'title' => urlencode ($title) ),  _REVIEW_COMMENT, _REVIEW_COMMENT) . ' |&nbsp;' . _OPN_HTML_NL;
		}
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
									'op' => 'PrintReview',
									'id' => $id) ) . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _REVIEW_PRINT . '</a> |&nbsp;' . _OPN_HTML_NL;
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
									'op' => 'PrintReview',
									'id' => $id,
									'printcomment' => '1') ) . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _REVIEW_PRINTCOMMENT . '</a> |&nbsp;' . _OPN_HTML_NL;
		if ($opnConfig['permission']->HasRights ('modules/reviews', array (_REVIEWS_PERM_FRIENDSEND, _PERM_ADMIN), true) ) {
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
										'op' => 'SendReview',
										'id' => $id) ) . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="" /> ' . _REVIEW_SEND . '</a>';
		}
		$table->AddDataRow (array (_REVIEW_OPTION, $hlp) );
		if ($opnConfig['permission']->HasRight ('modules/reviews', _PERM_ADMIN, true) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol ('Admin (ID ' . $id . '): [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																'op' => 'mod_review',
																'id' => $id) ) . '">' . _REVIEW_MODIFY . '</a> ] - [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
																	'op' => 'del_review',
																	'id_del' => $id,
																	'yes' => '0') ) . '">' . _REVIEW_DEL . '</a> ]',
																	'',
																	'2');
			$table->AddCloseRow ();
		}
		if ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 0) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol (sprintf (_REVIEW_PLEASE_REG, $opnConfig['opn_url']), '', '2');
			$table->AddCloseRow ();
		}
	}
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function SendReview () {

	global $cookie, $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/reviews', array (_REVIEWS_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		exit ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_230_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$boxtxt = '<script type="text/javascript">' . _OPN_HTML_NL;
	$boxtxt . '<!--' . _OPN_HTML_NL;
	// Function for Validating Forms
	$boxtxt .= 'function CheckForm(form)' . _OPN_HTML_NL . '{' . _OPN_HTML_NL . 'if ( form.yname.value == "" ) {' . _OPN_HTML_NL . 'alert( "' . _REVIEW_PLEASE_NAME . '" )' . _OPN_HTML_NL . 'form.yname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if (form.ymail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _REVIEW_PLEASE_EMAIL . '" )' . _OPN_HTML_NL . 'form.ymail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fname.value == "") {' . _OPN_HTML_NL . 'alert( "' . _REVIEW_PLEASE_FRIEND_NAME . '" )' . _OPN_HTML_NL . 'form.fname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fmail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _REVIEW_PLEASE_FRIEND_EMAIL . '" )' . _OPN_HTML_NL . 'form.fmail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else {' . _OPN_HTML_NL . 'document.friend.submit()' . _OPN_HTML_NL . 'return true' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '//--->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['reviews'] . " WHERE id=$id");
	if ($result !== false) {
		$title = $result->fields['title'];
		$result->Close ();
	}
	$boxtxt .= '<br />';
	$boxtxt .= '<span class="extratextbold">' . _REVIEW_SEND_FRIEND . '</span><br /><br />' . sprintf (_REVIEW_SEND_SPEC_FRIEND, $title) . '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_REVIEWS_240_', 'reviews');
	$form->Init ($opnConfig['opn_url'] . '/modules/reviews/index.php', 'post', 'friend');
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$result = &$opnConfig['database']->Execute ('SELECT uname, email FROM ' . $opnTables['users'] . " WHERE uname='" . $cookie['uname'] . "'");
		if ($result !== false) {
			$yn = $result->fields['uname'];
			$ye = $result->fields['email'];
			$result->Close ();
		}
	}
	if (!isset ($yn) ) {
		$yn = '';
	}
	if (!isset ($ye) ) {
		$ye = '';
	}
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('yname', _REVIEW_YOUR_NAME);
	$form->AddTextfield ('yname', 30, 50, $yn);
	$form->AddChangeRow ();
	$form->AddLabel ('ymail', _REVIEW_YOUR_EMAIL);
	$form->AddTextfield ('ymail', 30, 60, $ye);
	$form->AddChangeRow ();
	$form->AddLabel ('fname', _REVIEW_FRIEND_NAME);
	$form->AddTextfield ('fname', 30, 50);
	$form->AddChangeRow ();
	$form->AddLabel ('fmail', _REVIEW_FRIEND_EMAIL);
	$form->AddTextfield ('fmail', 30, 60);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('id', $id);
	$form->AddHidden ('op', 'EmailReview');
	$form->SetEndCol ();
	$form->AddButton ('Send', _REVIEW_SEND, '', '', 'CheckForm(this.form)');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_250_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function EmailReview () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/reviews', array (_REVIEWS_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$yname = '';
	get_var ('yname', $yname, 'form', _OOBJ_DTYPE_CLEAN);
	$ymail = '';
	get_var ('ymail', $ymail, 'form', _OOBJ_DTYPE_EMAIL);
	$fname = '';
	get_var ('fname', $fname, 'form', _OOBJ_DTYPE_CLEAN);
	$fmail = '';
	get_var ('fmail', $fmail, 'form', _OOBJ_DTYPE_EMAIL);
	$result = &$opnConfig['database']->SelectLimit ('SELECT wdate, title, text, reviewer, email, score, cover, url, url_title FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id, 1);
	if ($result !== false) {

		#		$date = $result->fields['wdate'];

		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$reviewer = $result->fields['reviewer'];

		#		$email = $result->fields['email'];

		$score = $result->fields['score'];

		#		$cover = $result->fields['cover'];

		#		$url = $result->fields['url'];

		#		$url_title = $result->fields['url_title'];

		$result->Close ();
	}
	$subject = sprintf (_REVIEW_MAIL_SUBJECT, $opnConfig['sitename']);
	$text = $opnConfig['cleantext']->filter_text ($text, true, true, 'nohtml');
	$vars['{FNAME}'] = $fname;
	$vars['{YNAME}'] = $yname;
	$vars['{TITLE}'] = $title;
	$vars['{TEXT}'] = $text;
	$vars['{REVIEWER}'] = $reviewer;
	$vars['{SCORE}'] = $score;
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($fmail, $subject, 'modules/reviews', 'review', $vars, $yname, $ymail);
	$mail->send ();
	$mail->init ();
	$boxtxt = '<br />';
	$boxtxt .= '<h3>' . _REVIEW_REV_SEND . '</h3><blockquote>' . sprintf (_REVIEW_THX_SUPP, $opnConfig['sitename'], $yname) . '' . '<br />' . sprintf (_REVIEW_SEND_TO, $fname, $fmail) . '</blockquote>';
	$boxtxt .= '<p align="center"><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/reviews/index.php">' . _REVIEW_RET_MAIN . '</a> ]</span></p>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_REVIEWS_260_';
	$_display_dat['module'] = 'modules/reviews';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	unset ($boxtxt);

}

?>