<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/reviews/plugin/search/language/');

function reviews_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'reviews';
	$button['sel'] = 0;
	$button['label'] = _REVIEWS_SEARCH_REVIEWS;
	$buttons[] = $button;
	unset ($button);

}

function reviews_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'reviews':
			reviews_retrieve_all ($query, $data, $sap);
		}
	}

	function reviews_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = reviews_get_query ($query);
		$q .= reviews_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if ($result !== false) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _REVIEWS_SEARCH_REVIEWS;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$id = $result->fields['id'];
					$title = $result->fields['title'];
					$text = $result->fields['text'];
					$reviewer = $result->fields['reviewer'];
					$hlp1['data'] = reviews_build_link ($id, $title, $text, $reviewer);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function reviews_get_query ($query) {

		global $opnTables, $opnConfig;

		$checkerlist = $opnConfig['permission']->GetUserGroups ();
		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('l.id as id',
								'l.title as title',
								'l.text as text',
								'l.reviewer as reviewer') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['reviews'] . ' l, ' . $opnTables['reviews_cats'] . ' c');
		$opnConfig['opn_searching_class']->SetWhere (' (l.cid=c.cat_id) AND c.cat_usergroup IN (' . $checkerlist . ') AND');
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('l.title',
									'l.text',
									'l.reviewer') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function reviews_get_orderby () {
	return ' ORDER BY wdate DESC';

}

function reviews_build_link ($id, $title, $text, $reviewer) {

	global $opnConfig;

	$t = $text;
	$furl = encodeurl (array ($opnConfig['opn_url'] . '/modules/reviews/index.php',
				'op' => 'showcontent',
				'id' => $id) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $title . '</a> ';
	$hlp .= _REVIEWS_SEARCH_BY . ' ' . $reviewer . ' ';
	return $hlp;

}

?>