<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;
if ($opnConfig['permission']->HasRights ('modules/talking_free', array (_PERM_ADMIN, _PERM_READ, _PERM_BOT, _PERM_WRITE) ) ) {
	$opnConfig['module']->InitModule ('modules/talking_free');
	$opnConfig['opnOutput']->setMetaPageName ('modules/talking_free');
	include_once (_OPN_ROOT_PATH . 'modules/talking_free/functions.php');
	$chapter = '';
	get_var ('chapter', $chapter, 'both', _OOBJ_DTYPE_CLEAN);
	$_chapter = $opnConfig['opnSQL']->qstr ($chapter);
	$lang = '';
	get_var ('lang', $lang, 'both', _OOBJ_DTYPE_CLEAN);
	$_lang = $opnConfig['opnSQL']->qstr ($lang);
	$op = '';
	get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
	switch ($op) {
		case 'delete':
			$number = 0;
			get_var ('number', $number, 'url', _OOBJ_DTYPE_CLEAN);
			$number = $number+0;
			// this one should convert this into a double value
			if ($opnConfig['permission']->HasRight ('modules/talking_free', _PERM_ADMIN, true) ) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['talking_free'] . ' WHERE wtime=' . $number . ' AND chapter=' . $_chapter . ' AND lang=' . $_lang);
			}
			break;
		case 'delete_all':
			if ($opnConfig['permission']->HasRight ('modules/talking_free', _PERM_ADMIN, true) ) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang);
			}
			break;
		case 'delete_last':
			if ($opnConfig['permission']->HasRight ('modules/talking_free', _PERM_ADMIN, true) ) {
				$result = &$opnConfig['database']->Execute ('SELECT wtime, text FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang . ' ORDER BY wtime DESC');
				if ($result !== false) {
					$my_talking_free_to_del = $result->GetRowAssoc ('0');
					$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang . ' AND wtime=' . $my_talking_free_to_del['wtime'] . ' AND text=' . $opnConfig['opnSQL']->qstr ($my_talking_free_to_del['text']) );
				}
			}
			break;
		case 'add':
			if ($opnConfig['permission']->HasRights ('modules/talking_free', array (_PERM_ADMIN, _PERM_WRITE) ) ) {
				$send_text = '';
				get_var ('send_text', $send_text, 'form', _OOBJ_DTYPE_CHECK);
				if ($send_text != '') {
					$result = &$opnConfig['database']->Execute ('SELECT wtime, text, ip, uname FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang . ' ORDER BY wtime DESC');
					if ($result !== false) {
						$nmy_talking_free = $result->RecordCount ();
					} else {
						$nmy_talking_free = 0;
					}
					if ($nmy_talking_free >= $opnConfig['talking_free_max_maxmsg']) {
						$last_my_talking_free = $result->GetRowAssoc ('0');
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang . ' AND wtime=' . $last_my_talking_free['wtime'] . ' AND text=' . $opnConfig['opnSQL']->qstr ($last_my_talking_free['text']) );
					}
					$opnConfig['opndate']->now ();
					$mytime = '';
					$opnConfig['opndate']->opnDataTosql ($mytime);
					if ($opnConfig['permission']->IsUser () ) {
						$ui = $opnConfig['permission']->GetUserinfo ();
					} else {
						$ui = $opnConfig['permission']->GetUser ('1', '', '');
					}
					$user_ip = get_real_IP ();
					$_text = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($send_text, false, true, 'nohtml') );
					$_uname = $opnConfig['opnSQL']->qstr ($ui['uname']);
					$_chapter = $opnConfig['opnSQL']->qstr ($chapter);
					$_lang = $opnConfig['opnSQL']->qstr ($lang);
					$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['talking_free'] . ' (wtime,text,ip,uname, chapter, lang) values (' . $mytime . ',' . $_text . ",'" . $user_ip . "'," . $_uname . ',' . $_chapter . ',' . $_lang . ')');
				}
			}
			break;
		default:
			break;
	}
	$content = overview_talking_free ($chapter, $lang);
	$content .= add_form ($chapter, $lang);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TALKING_FREE_30_';
	$_display_dat['module'] = 'modules/talking_free';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_TAFREE_TITLE, $content);
}

?>