<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/top_sites/plugin/search/language/');

function top_sites_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'top_sites';
	$button['sel'] = 0;
	$button['label'] = _TOPSITES_SEARCH_TOPSITES;
	$buttons[] = $button;
	unset ($button);

}

function top_sites_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'top_sites':
			top_sites_retrieve_all ($query, $data, $sap);
		}
	}

	function top_sites_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = top_sites_get_query ($query);
		$q .= top_sites_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if ($result !== false) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _TOPSITES_SEARCH_TOPSITES;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$id = $result->fields['id'];
					$name = $result->fields['name'];
					$description = $result->fields['description'];
					$hlp1['data'] = top_sites_build_link ($id, $name, $description);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function top_sites_get_query ($query) {

		global $opnTables, $opnConfig;

		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('id',
								'name',
								'description') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['topsites']);
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('name',
									'description') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function top_sites_get_orderby () {
	return ' ORDER BY hitsin DESC';

}

function top_sites_build_link ($id, $name, $description) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/modules/top_sites/top100-out.php?',
				'id' => $id) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $name . '</a>&nbsp;&nbsp;';
	$hlp .= $description;
	return $hlp;

}

?>