<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/trouble_tickets/plugin/search/language/');

function trouble_tickets_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'trouble_tickets';
	$button['sel'] = 0;
	$button['label'] = _TT_SEARCH_TT;
	$buttons[] = $button;
	unset ($button);

}

function trouble_tickets_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'trouble_tickets':
			trouble_tickets_retrieve_all ($query, $data, $sap);
		}
	}

	function trouble_tickets_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = trouble_tickets_get_query ($query);
		$q .= trouble_tickets_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if ($result !== false) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _TT_SEARCH_TT;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$id = $result->fields['ticket'];
					$subject = $result->fields['subject'];
					$hlp1['data'] = trouble_tickets_build_link ($id, $subject);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function trouble_tickets_get_query ($query) {

		global $opnTables, $opnConfig;

		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('ticket',
								'subject') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['troubleticket']);
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('subject',
									'problem',
									'solution') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function trouble_tickets_get_orderby () {
	return ' ORDER BY subject';

}

function trouble_tickets_build_link ($id, $subject) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/modules/trouble_tickets/index.php',
				'op' => 'showticket',
				'ticket' => $id) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $subject . '</a> ';
	return $hlp;

}

?>