<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN) );
$opnConfig['module']->InitModule ('modules/tutorial', true);
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
include_once (_OPN_ROOT_PATH . 'modules/tutorial/admin/indexadmin.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/admin/language/');

function topicadminrow ($id, $title, $pos, $usergroup, &$table) {

	global $opnConfig;

	$table->AddOpenRow ();
	$table->AddDataCol ($title, 'center');
	$table->AddDataCol ($opnConfig['permission']->UserGroups[$usergroup]['name'], 'center');
	$hlp = '';
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
		$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'modTopic',
									'topicid' => $id) );
		$hlp .= '&nbsp;' . _OPN_HTML_NL;
	}
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
		$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'delTopic',
									'topicid' => $id,
									'ok' => '0') ) . _OPN_HTML_NL;
	}
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
		$hlp .= '&nbsp;/&nbsp;' . _OPN_HTML_NL;
		$hlp .= $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'movingtopic',
									'topicid' => $id,
									'newpos' => ($pos-1.5) ) );
		$hlp .= '&nbsp;' . _OPN_HTML_NL;
		$hlp .= $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'movingtopic',
									'topicid' => $id,
									'newpos' => ($pos+1.5) ) );
	}
	$table->AddDataCol ($hlp, 'center');
	$table->AddCloseRow ();
	unset ($hlp);

}

function topicsmanager () {

	global $opnTables, $opnConfig;

	$txt = '';
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mflinks = & new CatFunctions ('mylinks', false);
	$mfdl = & new CatFunctions ('download', false);
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		// Modify Topic
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(topicid) AS counter FROM ' . $opnTables['tutorial_topics'] . ' WHERE pid=0');
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			$numrows = $result->fields['counter'];
		} else {
			$numrows = 0;
		}
		if ($numrows>0) {
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array (_TUTADMIN_ADMINTOPIC, _TUT_USEUSERGROUP1, '&nbsp;') );
			$result = &$opnConfig['database']->Execute ('SELECT topicid, topictext, topicpos,user_group FROM ' . $opnTables['tutorial_topics'] . ' WHERE pid=0 ORDER BY topicpos');
			while (! $result->EOF) {
				$id = $result->fields['topicid'];
				$title = $result->fields['topictext'];
				$pos = $result->fields['topicpos'];
				$usergroup = $result->fields['user_group'];
				topicadminrow ($id, $title, $pos, $usergroup, $table);
				$mf->pos = 'topicpos';
				$arr = $mf->getChildTreeArray ($id);
				$mf->pos = '';
				$max = count ($arr);
				for ($i = 0; $i< $max; $i++) {
					$catpath = $mf->getPathFromId ($arr[$i][2]);
					$catpath = substr ($catpath, 1);
					$result1 = &$opnConfig['database']->Execute ('SELECT topicpos,user_group FROM ' . $opnTables['tutorial_topics'] . ' WHERE topicid=' . $arr[$i][2]);
					$pos = $result1->fields['topicpos'];
					$usergroup = $result1->fields['user_group'];
					topicadminrow ($arr[$i][2], $catpath, $pos, $usergroup, $table);
				}
				unset ($arr);
				$result->MoveNext ();
			}
			$table->GetTable ($txt);
			$txt .= '<br /><br />';
		}
	}
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		// Add a New Main Category
		$assoctopics = $mf->getChildTreeArray (0);
		$keys = array_keys ($assoctopics);
		foreach ($keys as $value) {
			$assoctopics[$value][1] = substr ($mf->getPathFromId ($assoctopics[$value][2]), 1);
		}
		$txt .= _TUTADMIN_ADMINADDAMAINTOPIC;
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_240_', 'tutorialtopic');
		$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->SetSameCol ();
		$form->AddLabel ('topictext', _TUTADMIN_ADMINTOPICNAME);
		$form->AddText ('<br />');
		$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINJUSTANAMEWITHOUTSPACES . '</span>');
		$form->AddNewline ();
		$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINFOREXAMPLE . '</span>');
		$form->SetEndCol ();
		$form->AddTextfield ('topictext', 40, 40);
		$form->AddChangeRow ();
		$form->AddLabel ('pid', _TUTADMININ);
		$mf->makeMySelBox (0, $form, 1, 'pid');
		$tgfx = get_file_list ($opnConfig['datasave']['tut_topic_path']['path']);
		$options = array ();
		$options[''] = '&nbsp;';
		if (count ($tgfx) ) {
			usort ($tgfx, 'strcollcase');
			$max = count ($tgfx);
			for ($i = 0; $i< $max; $i++) {
				$options[$tgfx[$i]] = $tgfx[$i];
			}
		}
		$form->AddChangeRow ();
		$form->AddText (_TUTADMIN_ASSOCTOPICS);
		$form->SetSameCol ();
		foreach ($assoctopics as $value) {
			$form->AddCheckBox ('assoctopics[]', $value[2]);
			$form->AddText ('&nbsp;');
			$form->AddLabel ('assoctopics[]', $value[1], 1);
			$form->AddText ('&nbsp;&nbsp;&nbsp;');
		}
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddLabel ('topicimage', _TUTADMIN_ADMINTOPICIMAGE);
		$form->AddText ('<br />');
		$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINIMAGENAMEANDEXTENSIONLOCATETIN);
		$form->AddText (' ' . wordwrap ($opnConfig['datasave']['tut_topic_path']['url'], 30, '<br />', 1) . ')</span>');
		$form->SetEndCol ();
		$form->AddSelect ('topicimage', $options, '');
		$form->AddChangeRow ();
		$form->AddLabel ('description', _TUTADMIN_DESCRIPTION);
		$form->AddTextarea ('description');
		$form->AddChangeRow ();
		$form->AddLabel ('user_group', _TUT_USEUSERGROUP);
		$options = array ();
		$groups = $opnConfig['permission']->UserGroups;
		foreach ($groups as $group) {
			$options[$group['id']] = $group['name'];
		}
		$form->AddSelect ('user_group', $options);
		if ($mflinks->table <> '') {
			$form->AddChangeRow ();
			$form->AddLabel ('linkid', _TUTADMIN_ADMINRELATETLINKSCATEGORY);
			$mflinks->makeMySelBox (0, $form, 1, 'linkid');
		}
		if ($mfdl->table <> '') {
			$form->AddChangeRow ();
			$form->AddLabel ('dlid', _TUTADMIN_ADMINRELETETDOWNLOADCATEGORY);
			$mfdl->makeMySelBox (0, $form, 1, 'dlid');
		}
		$form->AddChangeRow ();
		$form->AddLabel ('sitename', _TUTADMIN_SITENAME);
		$form->AddTextfield ('sitename', 25, 25);
		$form->AddChangeRow ();
		$form->AddLabel ('siteurl', _TUTADMIN_SITEURL);
		$form->AddTextfield ('siteurl', 50, 200, 'http://');
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'addTopic');
		$form->AddSubmit ('submit', _TUTADMIN_ADMINADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($txt);
		$txt .= '<br />';
	}
	return $txt;

}

function modTopic () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN) );
	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mflinks = & new CatFunctions ('mylinks', false);
	$mfdl = & new CatFunctions ('download', false);
	$assoctopics = $mf->getChildTreeArray (0);
	$keys = array_keys ($assoctopics);
	foreach ($keys as $value) {
		$assoctopics[$value][1] = substr ($mf->getPathFromId ($assoctopics[$value][2]), 1);
	}
	$txt = '';
	$txt .= _TUTADMIN_ADMINMODIFYTOPIC . '<br />';
	$result = &$opnConfig['database']->SelectLimit ('SELECT pid, topicimage, topictext, linkid, dlid, topicpos, description, assoctopics, user_group FROM ' . $opnTables['tutorial_topics'] . " WHERE topicid=$topicid", 1);
	$pid = $result->fields['pid'];
	$topicimage = $result->fields['topicimage'];
	$topictext = $result->fields['topictext'];
	$linkid = $result->fields['linkid'];
	$dlid = $result->fields['dlid'];
	$position = $result->fields['topicpos'];
	$description = $result->fields['description'];
	$assoc = $result->fields['assoctopics'];
	$user_group = $result->fields['user_group'];
	$topicimage = urldecode ($topicimage);
	if ($topicimage != '') {
		$txt .= '<div align="right"><img src="' . $opnConfig['datasave']['tut_topic_path']['url'] . '/' . $topicimage . '" alt="" /></div>';
	}
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_250_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->SetSameCol ();
	$form->AddLabel ('topictext', _TUTADMIN_ADMINTOPICNAME);
	$form->AddText ('<br />');
	$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINJUSTANAMEWITHOUTSPACES . '</span>');
	$form->AddNewline ();
	$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINFOREXAMPLE . '</span>');
	$form->SetEndCol ();
	$form->AddTextfield ('topictext', 40, 40, $topictext);
	$form->AddChangeRow ();
	$form->AddLabel ('pid', _TUTADMIN_ADMINPARENTTOPIC);
	$mf->makeMySelBox ($pid, $form, 1, 'pid');
	$form->AddChangeRow ();
	$form->AddText (_TUTADMIN_ASSOCTOPICS);
	$form->SetSameCol ();
	if ($assoc == '') {
		$assoc = array ();
	} else {
		$assoc = explode ('-', $assoc);
	}
	foreach ($assoctopics as $value) {
		if ($value[2] != $topicid) {
			if (in_array ($value[2], $assoc) ) {
				$sel = 1;
			} else {
				$sel = 0;
			}
			$form->AddCheckBox ('assoctopics[]', $value[2], $sel);
			$form->AddText ('&nbsp;');
			$form->AddLabel ('assoctopics[]', $value[1], 1);
			$form->AddText ('&nbsp;&nbsp;&nbsp;');
		}
	}
	$form->SetEndCol ();
	$tgfx = get_file_list ($opnConfig['datasave']['tut_topic_path']['path']);
	$options = array ();
	$options[''] = '&nbsp;';
	if (is_array ($tgfx) ) {
		usort ($tgfx, 'strcollcase');
		$max = count ($tgfx);
		for ($i = 0; $i< $max; $i++) {
			$options[$tgfx[$i]] = $tgfx[$i];
		}
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('topicimage', _TUTADMIN_ADMINTOPICIMAGE);
	$form->AddText ('<br />');
	$form->AddText ('<span class="smalltext">' . _TUTADMIN_ADMINIMAGENAMEANDEXTENSIONLOCATETIN);
	$form->AddText (' ' . wordwrap ($opnConfig['datasave']['tut_topic_path']['url'], 30, '<br />', 1) . ')</span>');
	$form->SetEndCol ();
	$form->AddSelect ('topicimage', $options, $topicimage);
	$form->AddChangeRow ();
	$form->AddLabel ('description', _TUTADMIN_DESCRIPTION);
	$form->AddTextarea ('description', 0, 0, '', $description);
	$form->AddChangeRow ();
	$form->AddLabel ('user_group', _TUT_USEUSERGROUP);
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('user_group', $options, $user_group);
	$form->AddChangeRow ();
	$form->AddLabel ('position', _TUTADMIN_POSITION);
	$form->AddTextfield ('position', 0, 0, $position);
	if ($mflinks->table <> '') {
		$form->AddChangeRow ();
		$form->AddLabel ('linkid', _TUTADMIN_ADMINRELATETLINKSCATEGORY);
		$mflinks->makeMySelBox ($linkid, $form, 1, 'linkid');
	}
	if ($mfdl->table <> '') {
		$form->AddChangeRow ();
		$form->AddLabel ('dlid', _TUTADMIN_ADMINRELETETDOWNLOADCATEGORY);
		$mfdl->makeMySelBox ($dlid, $form, 1, 'dlid');
	}
	$form->AddChangeRow ();
	$form->AddLabel ('sitename', _TUTADMIN_SITENAME);
	$form->AddTextfield ('sitename', 25, 25);
	$form->AddChangeRow ();
	$form->AddLabel ('siteurl', _TUTADMIN_SITEURL);
	$form->AddTextfield ('siteurl', 50, 200, 'http://');
	$result1 = $opnConfig['database']->Execute ('SELECT rid, name, url FROM ' . $opnTables['tutorial_related'] . ' WHERE tid=' . $topicid);
	if (!$result1->EOF) {
		$form->AddChangeRow ();
		$form->AddTable ('alternator', '2');
		$form->AddHeaderRow (array (_TUTADMIN_SITENAME1, _TUTADMIN_SITEURL1, '&nbsp;') );
		while (! $result1->EOF) {
			$rid = $result1->fields['rid'];
			$name = $result1->fields['name'];
			$url = $result1->fields['url'];
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
											'op' => 'modRelated',
											'topicid' => $topicid,
											'rid' => $rid) );
				$hlp .= '&nbsp;' . _OPN_HTML_NL;
			}
			if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
											'op' => 'delRelated',
											'topicid' => $topicid,
											'rid' => $rid,
											'ok' => '0') ) . _OPN_HTML_NL;
			}
			$form->AddDataRow (array ($name, $url, $hlp) );
			$result1->MoveNext ();
		}
		$form->AddTableClose (true);
	}
	$result1->Close ();
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('topicid', $topicid);
	$form->AddHidden ('op', 'modTopicS');
	$form->SetEndCol ();
	$form->SetSameCol ();
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
		$form->AddSubmit ('submit',
										_TUTADMIN_ADMINTOPICMODIFY);
		$form->AddText ('&nbsp;');
	}
	$form->AddButton ('cancel', _TUTADMIN_ADMINCANCEL, '', '', 'javascript:hitutorial.go(-1)');
	$form->AddText ('&nbsp;');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	$txt .= '<br />';
	return $txt;

}

function modTopicS () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN) );
	$eh = & new opn_errorhandler;
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$linkid = 0;
	get_var ('linkid', $linkid, 'form', _OOBJ_DTYPE_INT);
	$dlid = 0;
	get_var ('dlid', $dlid, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	$topictext = '';
	get_var ('topictext', $topictext, 'form', _OOBJ_DTYPE_CHECK);
	$topicimage = '';
	get_var ('topicimage', $topicimage, 'form', _OOBJ_DTYPE_CHECK);
	$sitename = '';
	get_var ('sitename', $sitename, 'form', _OOBJ_DTYPE_CLEAN);
	$siteurl = '';
	get_var ('siteurl', $siteurl, 'form', _OOBJ_DTYPE_URL);
	$assoctopics = array ();
	get_var ('assoctopics', $assoctopics,'form',_OOBJ_DTYPE_CLEAN);
	$user_group = 0;
	get_var ('user_group', $user_group, 'form', _OOBJ_DTYPE_INT);
	$position = 0;
	get_var ('position', $position, 'form', _OOBJ_DTYPE_CLEAN);
	if (count ($assoctopics) ) {
		$assoctopics = implode ('-', $assoctopics);
	} else {
		$assoctopics = '';
	}
	$topictext = $opnConfig['opnSQL']->qstr ($topictext);
	$assoctopics = $opnConfig['opnSQL']->qstr ($assoctopics, 'assoctopics');
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	if ($topicimage != '') {
		$topicimage = urlencode ($topicimage);
	}
	$topicimage = $opnConfig['opnSQL']->qstr ($topicimage);
	if ($topicid != $pid) {
		$result = $opnConfig['database']->Execute ('SELECT topicpos FROM ' . $opnTables['tutorial_topics'] . ' WHERE topicid=' . $topicid);
		$pos = $result->fields['topicpos'];
		$result->Close ();
		$query = 'UPDATE ' . $opnTables['tutorial_topics'] . " SET description=$description, assoctopics=$assoctopics,pid=$pid, topictext=$topictext, topicimage=$topicimage, linkid=$linkid, dlid=$dlid, user_group=$user_group WHERE topicid=$topicid";
		$opnConfig['database']->Execute ($query);
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_topics'], 'topicid=' . $topicid);
		$content = getTopicTree ();
		writeTopicTree ($content);
		if ($sitename != '') {
			$rid = $opnConfig['opnSQL']->get_new_number ('tutorial_related', 'rid');
			$sitename = $opnConfig['opnSQL']->qstr ($sitename);
			$siteurl = $opnConfig['cleantext']->FixQuotes ($siteurl);
			$opnConfig['cleantext']->formatURL ($siteurl);
			$siteurl = $opnConfig['opnSQL']->qstr ($siteurl);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_related'] . " VALUES ($rid, $topicid, $sitename, $siteurl)");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$eh->show ('OPN_0001');
			}
		}
		if ($pos != $position) {
			set_var ('newpos', $position, 'url');
			set_var ('topicid', $topicid, 'url');
			OrderTutTopic ();
			unset_var ('newpos', 'url');
			unset_var ('topicid', 'url');
		}
		$txt = '';
		$txt .= _TUTADMIN_ADMINTOPISMODIFIESSUCCSESSFULLY;
	} else {
		$txt = '';
		$txt .= _TUTADMIN_ADMINTOPISMODIFIESNOSUCCSESSFULLY;
	}
	return $txt;

}

function delTopic () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN) );
	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$eh = & new opn_errorhandler;
	if ($ok == 1) {
		// get all subtopics under the specified topic
		$arr = $mf->getAllChildId ($topicid);
		$mysize = sizeof ($arr);
		for ($i = 0; $i<$mysize; $i++) {
			// get all stories in each topic
			$result = &$opnConfig['database']->Execute ('SELECT sid FROM ' . $opnTables['tutorial_stories'] . " WHERE topic=" . $arr[$i] . "");
			if ($result === false) {
				$eh->show ("OPN_0001");
			}
			// now for each tutorial, delete the comment data and vote ata associated with the link
			while (! $result->EOF) {
				$sid = $result->fields['sid'];
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_comments'] . " WHERE sid=" . $sid . "");
				if ($opnConfig['database']->ErrorNo ()>0) {
					$eh->show ('OPN_0001');
				}
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_stories'] . " WHERE sid=" . $sid . "");
				if ($opnConfig['database']->ErrorNo ()>0) {
					$eh->show ('OPN_0001');
				}
				$result->MoveNext ();
			}
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_related'] . " WHERE tid=" . $arr[$i] . "");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$eh->show ('OPN_0001');
			}
			// all stories for each subtopic is deleted, now delete the subtopic data
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_topics'] . " WHERE topicid=" . $arr[$i] . "");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$eh->show ('OPN_0001');
			}
		}
		// all subtopic and associated data are deleted, now delete topic data and its associated data
		$result = &$opnConfig['database']->Execute ('SELECT sid FROM ' . $opnTables['tutorial_stories'] . " WHERE topic=" . $topicid . "");
		if ($result === false) {
			$eh->show ('OPN_0001');
		}
		while (! $result->EOF) {
			$sid = $result->fields['sid'];
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_stories'] . " WHERE sid=" . $sid . "");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$eh->show ('OPN_0001');
			}
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_comments'] . " WHERE sid=" . $sid . "");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$eh->show ('OPN_0001');
			}
		}
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_related'] . " WHERE tid=" . $topicid . "");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
		// now delete the topic itself
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_topics'] . " WHERE topicid=" . $topicid . "");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
		$content = getTopicTree ();
		writeTopicTree ($content);
		$txt = '';
		$txt .= _TUTADMIN_ADMINTOPICDETELTEDSUCCESSFULLY;
	} else {
		$txt = '';
		$txt .= '<div class="bigtextbold" align="center">';
		$txt .= '<span class="alerttext">';
		$txt .= _TUTADMIN_ADMINWARNINGAREYOUSUREYOUWANTTODELETETHISTOPICANDALLTUTORIALSCOMMENTS;
		$txt .= '</span>';
		$txt .= '<br />';
		$txt .= '<br />';
		$txt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'delTopic',
									'topicid' => $topicid,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php?op=topicsmanager') . '">' . _NO . '</a>';
		$txt .= '<br />';
		$txt .= '<br />';
		$txt .= '</div>';
		$txt .= '<br />';
	}
	return $txt;

}

function addTopic () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_NEW, _PERM_ADMIN) );
	$eh = & new opn_errorhandler;
	$linkid = 0;
	get_var ('linkid', $linkid, 'form', _OOBJ_DTYPE_INT);
	$dlid = 0;
	get_var ('dlid', $dlid, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$pid = 0;
	get_var ('pid', $pid, 'form', _OOBJ_DTYPE_INT);
	$topictext = '';
	get_var ('topictext', $topictext, 'form', _OOBJ_DTYPE_CHECK);
	$topicimage = '';
	get_var ('topicimage', $topicimage, 'form', _OOBJ_DTYPE_CHECK);
	$sitename = '';
	get_var ('sitename', $sitename, 'form', _OOBJ_DTYPE_CLEAN);
	$siteurl = '';
	get_var ('siteurl', $siteurl, 'form', _OOBJ_DTYPE_URL);
	$assoctopics = array ();
	get_var ('assoctopics', $assoctopics,'form',_OOBJ_DTYPE_CLEAN);
	$user_group = 0;
	get_var ('user_group', $user_group, 'form', _OOBJ_DTYPE_INT);
	if (count ($assoctopics) ) {
		$assoctopics = implode ('-', $assoctopics);
	} else {
		$assoctopics = '';
	}
	$assoctopics = $opnConfig['opnSQL']->qstr ($assoctopics, 'assoctopics');
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	if ($topicimage != '') {
		$topicimage = urlencode ($topicimage);
	}
	$topicimage = $opnConfig['opnSQL']->qstr ($topicimage);
	$topictext = $opnConfig['opnSQL']->qstr ($topictext);
	$topicid = $opnConfig['opnSQL']->get_new_number ('tutorial_topics', 'topicid');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_topics'] . " VALUES ($topicid, $pid, $topicimage, $topictext, $linkid, $dlid, $topicid, $description,$assoctopics, $user_group)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$eh->show ('OPN_0001');
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_topics'], 'topicid=' . $topicid);
	$content = getTopicTree ();
	writeTopicTree ($content);
	if ($sitename != '') {
		$rid = $opnConfig['opnSQL']->get_new_number ('topic_related', 'rid');
		$sitename = $opnConfig['opnSQL']->qstr ($sitename);
		$siteurl = $opnConfig['cleantext']->FixQuotes ($siteurl);
		$opnConfig['cleantext']->formatURL ($siteurl);
		$siteurl = $opnConfig['opnSQL']->qstr ($siteurl);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['topic_related'] . " VALUES ($rid, $topicid, $sitename, $siteurl)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
	}
	$txt = '';
	$txt .= _TUTADMIN_ADMINNEWTOPICADDEDSUCCESSFULLY;
	return $txt;

}

function getTopicTree () {

	global $opnTables, $opnConfig;

	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$content = '';
	$result = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['tutorial_topics'] . " WHERE pid=0 ORDER BY topictext");
	while (! $result->EOF) {
		$dbtopicid = $result->fields['topicid'];
		$topictext = $result->fields['topictext'];
		$arr = $mf->getChildTreeArray ($dbtopicid);
		if (count ($arr) ) {
			$content = '.' . $topictext . '|' . $opnConfig['opn_url'] . '?tutorialtopic=' . $dbtopicid . _OPN_HTML_NL;
			$max = count ($arr);
			for ($i = 0; $i< $max; $i++) {
				$content .= '.' . $arr[$i][0] . $arr[$i][1] . '|' . $opnConfig['opn_url'] . '?tutorialtopic=' . $arr[$i][2] . _OPN_HTML_NL;
			}
		} else {
			$content .= '.' . $topictext . '|' . $opnConfig['opn_url'] . '?tutorialtopic=' . $dbtopicid . _OPN_HTML_NL;
		}
		$result->MoveNext ();
	}
	return $content;

}

function writeTopicTree ($content) {

	global $opnConfig;

	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	$filename = $opnConfig['root_path_datasave'] . 'topictree.txt';
	$File = & new opnFile;
	$File->overwrite_file ($filename, $content);

}

function modRelated () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN) );
	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$rid = 0;
	get_var ('rid', $rid, 'url', _OOBJ_DTYPE_INT);
	$txt = '';
	$txt .= _TUTADMIN_ADMINMODIFYRELATED . '<br />';
	$txt .= _TUTADMIN_ADMINTOPIC;
	$result = &$opnConfig['database']->SelectLimit ('SELECT topictext FROM ' . $opnTables['tutorial_topics'] . " WHERE topicid=$topicid", 1);
	$txt .= $result->fields['topictext'];
	$result = &$opnConfig['database']->SelectLimit ('SELECT name,url FROM ' . $opnTables['tutorial_related'] . " WHERE rid=$rid", 1);
	$name = $result->fields['name'];
	$url = $result->fields['url'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_260_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('sitename', _TUTADMIN_SITENAME);
	$form->AddTextfield ('sitename', 25, 25, $name);
	$form->AddChangeRow ();
	$form->AddLabel ('siteurl', _TUTADMIN_SITEURL);
	$form->AddTextfield ('siteurl', 50, 200, $url);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('topicid', $topicid);
	$form->AddHidden ('rid', $rid);
	$form->AddHidden ('op', 'modRelatedS');
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _TUTADMIN_ADMINTOPICMODIFY);
	$form->AddText ('&nbsp;');
	$form->AddButton ('cancel', _TUTADMIN_ADMINCANCEL, '', '', 'javascript:history.go(-1)');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	$txt .= '<br />';
	return $txt;

}

function modRelatedS () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN) );
	$eh = & new opn_errorhandler;
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$rid = 0;
	get_var ('rid', $rid, 'form', _OOBJ_DTYPE_INT);
	$sitename = '';
	get_var ('sitename', $sitename, 'form', _OOBJ_DTYPE_CLEAN);
	$siteurl = '';
	get_var ('siteurl', $siteurl, 'form', _OOBJ_DTYPE_URL);
	if ($sitename != '') {
		$sitename = $opnConfig['opnSQL']->qstr ($sitename);
		$siteurl = $opnConfig['cleantext']->FixQuotes ($siteurl);
		$opnConfig['cleantext']->formatURL ($siteurl);
		$siteurl = $opnConfig['opnSQL']->qstr ($siteurl);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_related'] . " set name=$sitename, url=$siteurl WHERE rid=$rid");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
							'op' => 'modTopic',
							'topicid' => $topicid),
							false) );
	CloseTheOpnDB ($opnConfig);

}

function delRelated () {

	global $opnConfig, $opnTables;

	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$rid = 0;
	get_var ('rid', $rid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN) );
	$eh = & new opn_errorhandler;
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_related'] . " WHERE rid=" . $rid . "");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$eh->show ('OPN_0001');
		}
		$txt = '';
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
								'op' => 'modTopic',
								'topicid' => $topicid),
								false) );
		CloseTheOpnDB ($opnConfig);
	} else {
		$txt = '';
		$txt .= '<div class="bigtextbold" align="center"><span class="alerttext">';
		$txt .= _TUTADMIN_ADMINWARNINGAREYOUSUREYOUWANTTODELETETHISRELATED;
		$txt .= '</span><br /><br />';
		$txt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
									'op' => 'delRelated',
									'topicid' => $topicid,
									'rid' => $rid,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/topicadmin.php',
															'op' => 'modTopic',
															'topicid' => $topicid) ) . '">' . _NO . '</a>';
		$txt .= '<br /><br />';
		$txt .= '</div>';
		$txt .= '<br />';
	}
	return $txt;

}

function OrderTutTopic () {

	global $opnConfig, $opnTables;

	$newpos = 0;
	get_var ('newpos', $newpos, 'url', _OOBJ_DTYPE_CLEAN);
	$topicid = 0;
	get_var ('topicid', $topicid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_topics'] . ' SET topicpos=' . $newpos . ' WHERE topicid=' . $topicid);
	$result = &$opnConfig['database']->Execute ('SELECT topicid FROM ' . $opnTables['tutorial_topics'] . ' ORDER BY topicpos');
	$mypos = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$mypos++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_topics'] . ' SET topicpos=' . $mypos . ' WHERE topicid=' . $row['topicid']);
		$result->MoveNext ();
	}

}
$txt = '';
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'delRelated':
		$boxtxt = delRelated ();
		break;
	case 'modRelatedS':
		modRelatedS ();
		break;
	case 'modRelated':
		$boxtxt = modRelated ();
		break;
	case 'topicsmanager':
		$boxtxt = topicsmanager ();
		break;
	case 'addTopic':
		$txt = addTopic ();
		$boxtxt = topicsmanager ();
		break;
	case 'delTopic':
		$boxtxt = delTopic ();
		break;
	case 'modTopic':
		$boxtxt = modTopic ();
		break;
	case 'modTopicS':
		$txt = modTopicS ();
		$boxtxt = topicsmanager ();
		break;
	case 'movingtopic':
		OrderTutTopic ();
		$boxtxt = topicsmanager ();
		break;
	default:
		$boxtxt = topicsmanager ();
		break;
}
if ( (isset ($boxtxt) ) && ($boxtxt != '') ) {
	$opnConfig['opnOutput']->DisplayHead ();
	$tutHeader = tutorialConfigHeader ();
	if ($txt != '') {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_270_';
		$_display_dat['module'] = 'modules/tutorial';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_TUTADMIN_ADMINTUTORIALCONFIGURATION, $txt, '');
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_280_';
	$_display_dat['module'] = 'modules/tutorial';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_TUTADMIN_ADMINTUTORIALCONFIGURATION, $tutHeader . $boxtxt, '');
	$opnConfig['opnOutput']->DisplayFoot ();
}

?>