<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig;

$opnConfig['module']->InitModule ('modules/tutorial');
$opnConfig['permission']->InitPermissions ('modules/tutorial');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/language/');

function _tutorial_set_options () {

	global $opnConfig;

	$tutorialcat = 0;
	get_var ('tutorialcat', $tutorialcat, 'url', _OOBJ_DTYPE_INT);
	$tutorialtopic = 0;
	get_var ('tutorialtopic', $tutorialtopic, 'url', _OOBJ_DTYPE_INT);
	if ( ($tutorialcat) && (preg_match ('/^[0-9]{1,}$/', $tutorialcat) ) ) {
		$opnConfig['opnOption']['tutorialcat'] = $tutorialcat;
	} else {
		$opnConfig['opnOption']['tutorialcat'] = '';
	}
	if ( ($tutorialtopic) && (preg_match ('/^[0-9]{1,}$/', $tutorialtopic) ) ) {
		$opnConfig['opnOption']['tutorialtopic'] = $tutorialtopic;
	} else {
		$opnConfig['opnOption']['tutorialtopic'] = '';
	}

}

function _tutorial_get_cats (&$cats) {

	global $opnConfig, $opnTables;

	$cats = array ();
	$resultm = &$opnConfig['database']->Execute ('SELECT catid,title FROM ' . $opnTables['tutorial_stories_cat'] . ' WHERE catid>0');
	while (! $resultm->EOF) {
		$cats[$resultm->fields['catid']] = $resultm->fields['title'];
		$resultm->MoveNext ();
	}
	$resultm->Close ();

}

function _tutorial_get_topics (&$topics, &$topicchecker) {

	global $opnConfig, $opnTables;

	$topics = array ();
	$checker = array ();
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$t_result = &$opnConfig['database']->Execute ('SELECT topicid, topicimage, topictext, pid FROM ' . $opnTables['tutorial_topics'] . ' WHERE user_group IN (' . $checkerlist . ')');
	while (! $t_result->EOF) {
		$checker[] = $t_result->fields['topicid'];
		$topics[$t_result->fields['topicid']][0] = $t_result->fields['topicimage'];
		$topics[$t_result->fields['topicid']][1] = $t_result->fields['topictext'];
		$topics[$t_result->fields['topicid']][2] = $t_result->fields['pid'];
		$t_result->MoveNext ();
	}
	$topicchecker = implode (',', $checker);
	$t_result->Close ();

}

function _tutorial_get_path ($topics, $topic, $path = '') {
	if (!isset ($topics[$topic][1]) ) {
		return $path;
	}
	$parentid = $topics[$topic][2];
	$name = $topics[$topic][1];
	opn_nl2br ($name);
	$path = '/' . $name . $path;
	if ($parentid == 0) {
		return $path;
	}
	$path = _tutorial_get_path ($topics, $parentid, $path);
	return $path;

}

function _build_tutorial ($tutorialnumber, &$result, &$myreturntext, $tut_options = false, $backto = '', $isindex = false) {

	global $opnTheme, $opnConfig, $opnTables, $tutorialnum, $aftersid;
	if ( ($tut_options === false) OR (!is_array ($tut_options) ) ) {
		$tut_options = array ();
		$tut_options['docenterbox'] = 0;
		$tut_options['dothetitle'] = 1;
		$tut_options['dothetitle_max'] = 0;
		$tut_options['dothebody'] = 0;
		$tut_options['dothebody_max'] = 0;
		$tut_options['dothefooter'] = 1;
		$tut_options['dothefooter_max'] = 0;
		$tut_options['showtopic'] = 1;
		$tut_options['showfulllink'] = 0;
	} else {
		if (!isset ($tut_options['docenterbox']) ) {
			$tut_options['docenterbox'] = 0;
		}
		if (!isset ($tut_options['dothetitle']) ) {
			$tut_options['dothetitle'] = 1;
		}
		if (!isset ($tut_options['dothetitle_max']) ) {
			$tut_options['dothetitle_max'] = 0;
		}
		if (!isset ($tut_options['dothebody']) ) {
			$tut_options['dothebody'] = 0;
		}
		if (!isset ($tut_options['dothebody_max']) ) {
			$tut_options['dothebody_max'] = 0;
		}
		if (!isset ($tut_options['dothefooter']) ) {
			$tut_options['dothefooter'] = 1;
		}
		if (!isset ($tut_options['dothefooter_max']) ) {
			$tut_options['dothefooter_max'] = 0;
		}
		if (!isset ($tut_options['showtopic']) ) {
			$tut_options['showtopic'] = 1;
		}
		if (!isset ($tut_options['showfulllink']) ) {
			$tut_options['showfulllink'] = 0;
		}
	}
	$sidcount = 0;
	$topsid = 0;
	$firstsid = 0;
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$cats = '';
	_tutorial_get_cats ($cats);
	_tutorial_set_options ();
	if (preg_match ('/^[0-3][0-5]$/', $tutorialnum) ) {
		$opnConfig['opnOption']['tutorialnum'] = $tutorialnum;
	} elseif ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$opnConfig['opnOption']['tutorialnum'] = $userinfo['storynum'];
	} else {
		$opnConfig['opnOption']['tutorialnum'] = $opnConfig['tutorialhome'];
	}
	$query = 'SELECT sid, catid, aid, title, wtime, hometext, bodytext, comments, counter, topic, informant, notes, userfile, options, acomm FROM ' . $opnTables['tutorial_stories'];
	$query1 = 'SELECT COUNT(sid) AS counter FROM ' . $opnTables['tutorial_stories'];
	$query .= "  WHERE (tut_lang='0' OR tut_lang='" . $opnConfig['language'] . "')";
	$query1 .= "  WHERE (tut_lang='0' OR tut_lang='" . $opnConfig['language'] . "')";
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$topics = '';
	$checker = '';
	_tutorial_get_topics ($topics, $checker);
	if ($checker != '') {
		$topics1 = ' AND (topic IN (' . $checker . ')) ';
	} else {
		$topics1 = ' ';
	}
	$query .= ' AND (tut_user_group IN (' . $checkerlist . '))';
	$query1 .= ' AND (tut_user_group IN (' . $checkerlist . '))';
	$query .= $topics1;
	$query1 .= $topics1;
	if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
		$query .= " AND ((tut_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (tut_theme_group=0))";
		$query1 .= " AND ((tut_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (tut_theme_group=0))";
	}
	if ($opnConfig['opnOption']['tutorialtopic'] != '') {
		$query .= ' AND topic=' . $opnConfig['opnOption']['tutorialtopic'];
		$query1 .= ' AND topic=' . $opnConfig['opnOption']['tutorialtopic'];
	} elseif ($opnConfig['opnOption']['tutorialcat'] != '') {
		$query .= ' AND catid=' . $opnConfig['opnOption']['tutorialcat'];
		$query1 .= ' AND catid=' . $opnConfig['opnOption']['tutorialcat'];
	} else {
		if ($backto == '') {
			$query .= ' AND ihome=0';
			$query1 .= ' AND ihome=0';
		}
	}
	if ($aftersid != 0) {
		$query .= ' AND (sid<' . $aftersid . ')';
	}
	if (! ($opnConfig['opnOption']['tutorialnum']) ) {
		$opnConfig['opnOption']['tutorialnum'] = $opnConfig['tutorialhome'];
	}
	if ($tutorialnumber != 0) {
		$query .= ' AND (sid=' . $tutorialnumber . ')';
	}
	$query .= ' ORDER BY wtime DESC';
	if ($result == '') {
		$result = &$opnConfig['database']->SelectLimit ($query, $opnConfig['opnOption']['tutorialnum'], $offset);
		$tut_options['docenterbox'] = 1;
	}
	if ($opnConfig['database']->ErrorNo ()>0) {
		echo $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />SQL : ' . $query;
		exit ();
	}
	$foundsometutorials = false;
	$datetime = '';
	$temp = '';
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
	$ubb = & new UBBCode;
	while (! $result->EOF) {
		$s_sid = $result->fields['sid'];
		$s_catid = $result->fields['catid'];

		#		$aid=$result->fields['aid'];

		$title = $result->fields['title'];
		$opnConfig['opndate']->sqlToopnData ($result->fields['wtime']);
		$time = $result->fields['wtime'];
		$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
		$hometext = $result->fields['hometext'];
		$bodytext = $result->fields['bodytext'];
		$comments = $result->fields['comments'];
		$counter = $result->fields['counter'];
		$topic = $result->fields['topic'];
		$informant = $result->fields['informant'];
		$notes = $result->fields['notes'];
		$userfile = $result->fields['userfile'];
		$myoptions = unserialize ($result->fields['options']);
		$acomm = $result->fields['acomm'];
		$ubb->ubbencode ($hometext);
		$ubb->ubbencode ($bodytext);
		if ($isindex) {
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_stories'] . " SET counter=counter+1 WHERE sid=$s_sid");
		}
		$sql1 = 'SELECT wdate FROM ' . $opnTables['tutorial_comments'] . ' WHERE sid=' . $s_sid . ' ORDER BY wdate DESC';
		$result1 = &$opnConfig['database']->SelectLimit ($sql1, 1);
		if (isset ($result1->fields['wdate']) ) {
			$newest_comment = $result1->fields['wdate'];
		} else {
			$newest_comment = 0;
		}
		if (isset ($myoptions['_tut_op_use_theme_id']) ) {
			$opnConfig['current_mb_themeid'] = $myoptions['_tut_op_use_theme_id'];
		} else {
			$opnConfig['current_mb_themeid'] = '';
		}
		if ($informant == '') {
			$informant = $opnConfig['opn_anonymous_name'];
		}
		if ($firstsid == 0) {
			$firstsid = $s_sid;
		}
		if ( (!isset ($myoptions['_tut_op_use_foot']) ) OR ($myoptions['_tut_op_use_foot'] == '') ) {
			$myoptions['_tut_op_use_foot'] = '';
			$tplzu = '&nbsp;|&nbsp;';
		} else {
			$tplzu = '';
		}
		$sidcount++;
		$myicons = '';
		if ($isindex) {
			if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$myicons .= '&nbsp;&nbsp; [ <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
														'op' => 'EditTutorial',
														'sid' => $s_sid) ) . '">' . _THEME_EDIT . '</a>';
			}
			if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$myicons .= ' | <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
													'op' => 'RemoveTutorial',
													'sid' => $s_sid) ) . '">' . _THEME_DELETE . '</a> ]&nbsp;&nbsp;';
			}
			if ($backto != '') {
				$myicons .= '&nbsp;&nbsp' . $backto;
			}
		}
		if (!$opnConfig['tut_hideicons']) {
			if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_PRINT, true) ) {
				$myicons .= ' | <a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/printtutorial.php',
													'sid' => $s_sid) ) . '" title="' . _TUTAUTO_ALLTOPICSPRINTERFRIENDLYPAGE . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] .'print.gif" class="imgtag" alt="' . _TUTAUTO_ALLTOPICSPRINTERFRIENDLYPAGE . '" /></a>&nbsp;';
			}
			if (!$acomm) {
				if ( ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_PRINT, true) ) && ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_COMMENTREAD, true) ) ) {
					$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/printtutorial.php',
													'sid' => $s_sid,
													'printcomment' => '1') ) . '" title="' . _TUTAUTO_ALLTOPICSPRINTERFRIENDLYPAGEWITHCOMMENTS . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print_comments.gif" class="imgtag" alt="' . _TUTAUTO_ALLTOPICSPRINTERFRIENDLYPAGEWITHCOMMENTS . '" /></a>&nbsp;';
				}
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('modules/fpdf') ) {
				if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_PRINTASPDF, true) ) {
					$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/printpdf.php',
													'sid' => $s_sid) ) . '" title="' . _TUT_ALLTOPICSPRINTERPDF . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'files/pdf.gif" class="imgtag" title="' . _TUT_ALLTOPICSPRINTERPDF . '" alt="' . _TUT_ALLTOPICSPRINTERPDF . '" /></a>&nbsp;';
				}
			}
			if ($opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_SENDTUTORIAL, true) ) {
				$myicons .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/friend/index.php',
												'op' => 'FriendSendTutoral',
												'sid' => $s_sid) ) . '" title="' . _TUTAUTO_ALLTOPICSSENDTOAFRIEND . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="' . _TUTAUTO_ALLTOPICSSENDTOAFRIEND . '" /></a>';
			}
		}
		if ($isindex) {
			if ( (!isset ($opnConfig['tut_useshortheaderindetailedview']) ) || ($opnConfig['tut_useshortheaderindetailedview'] == 0) ) {
				$title = $title . '&nbsp;' . $myicons . '<br />' . _OPN_HTML_NL;
			}
		}
		if (isset ($topics[$topic][0]) ) {
			$topicimage = $topics[$topic][0];
		} else {
			$topicimage = '';
		}
		if (isset ($topics[$topic][1]) ) {
			$topictext = _tutorial_get_path ($topics, $topic);
			$topictext = substr ($topictext, 1);
		} else {
			$topictext = '';
		}
		$hometext = $opnConfig['cleantext']->makeClickable ($hometext);
		opn_nl2br ($hometext);
		$notes = $opnConfig['cleantext']->makeClickable ($notes);
		opn_nl2br ($notes);
		$introcount = strlen ($hometext);
		$fullcount = strlen ($bodytext);
		opn_nl2br ($bodytext);
		$totalcount = $introcount+ $fullcount;
		$morelink = '';
		$morebytes = '';
		$mycomments = '';
		$com_date = '';
		if (!$isindex) {
			if ( ($fullcount >= 1) OR ( ($userfile != '') && ($userfile != 'none') ) ) {
				$morelink .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
													'sid' => $s_sid) ) . '">';
				$morelink .= '<span class="normaltextbold">' . _TUT_AUTOSTARTREADMORE . '</span></a>';
				$morebytes .= $tplzu . $totalcount . '&nbsp;' . _TUT_ALLTOPICSBYTESMORE . $tplzu;
			}
			if ($comments == 0) {
				$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
													'sid' => $s_sid) ) . '">' . _TUT_ALLTOPICSCOMMENTS . '</a>';
			} else {
				if ( ( (isset ($opnConfig['tut_showcommentdate']) ) && ($opnConfig['tut_showcommentdate']) ) && ($newest_comment) ) {
					$opnConfig['opndate']->sqlToopnData ($newest_comment);
					$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
					$com_date = $tplzu . _TUT_LASTCOMMENT . ': ' . $temp;
				}
				if ($comments == 1) {
					$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
														'sid' => $s_sid) ) . '">' . $comments . '&nbsp;' . _TUT_ALLTOPICSCOMMENT . '</a>';
				} else {
					$mycomments = '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
														'sid' => $s_sid) ) . '">' . $comments . '&nbsp;' . _TUT_ALLTOPICSCOMMENTA . '</a>';
				}
				$mycomments .= '&nbsp;' . buildnewtag ($newest_comment);
			}
			if (!$opnConfig['permission']->HasRight ('modules/tutorial', _TUT_PERM_COMMENTREAD, true) ) {
				$mycomments = '';
				$com_date = '';
				if ($morelink == '') {
					$morelink .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
														'sid' => $s_sid) ) . '">';
					$morelink .= '<span class="normaltextbold">' . _TUT_AUTOSTARTREADMORE . '</span></a>';
				}
			}
		}
		$thetext = '';
		$imagetext = '';
		if ( ($userfile != '') && ($userfile != 'none') && (!is_array ($userfile) ) ) {
			if ( (isset ($opnConfig['tut_showarticleimagebeforetext']) ) && ($opnConfig['tut_showarticleimagebeforetext'] == 1) ) {
				$thetext .= '<img src="' . $userfile . '" class="articleimg" alt="" /><br style="clear:left" />';
			} else {
				$imagetext = '<br /><img src="' . $userfile . '" class="imgtag" alt="" />';
			}
		}
		// add notes
		$thetext .= $hometext;
		if ( ($tut_options['dothebody'] == 1) && ($bodytext != '') ) {
			$thetext = $thetext . '<br /><br />' . $bodytext;
		}
		if ($notes != '') {
			$thetext .= '<br /><span class="normaltextbold">' . _TUT_ADMINNOTE . '</span> <span class="normaltextitalic">' . $notes . '</span>';
		}
		if ( ($topicimage != '') && ($tut_options['showtopic'] == 1) ) {
			$thetext = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/topicindex.php',
											'tutorialtopic' => $topic) ) . '" title="' . $topictext . '">' . '<img src="' . $opnConfig['datasave']['tut_topic_path']['url'] . '/' . $topicimage . '" border="0" class="imgtutorialcenter" alt="" title="" />' . '</a>' . $thetext;
		}
		$thetext .= $imagetext;
		if (!isset ($myoptions['_tut_op_use_head']) ) {
			$myoptions['_tut_op_use_head'] = '';
		}
		if (!isset ($myoptions['_tut_op_use_foot']) ) {
			$myoptions['_tut_op_use_foot'] = '';
		}
		if ( ($myoptions['_tut_op_use_head'] == '') && ($opnConfig['_op_tut_use_head_org'] != '') ) {
			$myoptions['_tut_op_use_head'] = $opnConfig['_op_tut_use_head_org'];
		}
		if ( ($myoptions['_tut_op_use_foot'] == '') && ($opnConfig['_op_tut_use_foot_org'] != '') ) {
			$myoptions['_tut_op_use_foot'] = $opnConfig['_op_tut_use_foot_org'];
		}
		if ( ($myoptions['_tut_op_use_head'] != '') || ($myoptions['_tut_op_use_foot'] != '') ) {
			if ($s_catid != '0') {
				$mycat = $cats[$s_catid];
				$mycaturl = encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/topicindex.php',
								'tutorialcat' => $s_catid) );
			} else {
				$mycat = '';
				$mycaturl = '';
			}
			$_tut_dat_ = array ('[MORELINK]' => $morelink,
					'[MOREBYTES]' => $morebytes,
					'[COMMENTS]' => $mycomments,
					'[COMMENTS_LAST]' => $com_date,
					'[ICONS]' => $myicons,
					'[POSTER]' => api_user_name ($informant),
					'[HREFPOSTER]' => encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
							'op' => 'userinfo',
							'uname' => $informant) ),
							'[TITLE]' => $title,
							'[POSTEDON]' => $datetime . '&nbsp;' . buildnewtag ($time),
							'[READS]' => $counter,
							'[_THEME_POSTEDBY]' => _THEME_POSTEDBY,
							'[_THEME_ON]' => _THEME_ON,
							'[_THEME_READS]' => _THEME_READS,
							'[CAT]' => $mycat,
							'[HREFCAT]' => $mycaturl,
							'[URL]' => $opnConfig['opn_url'] . '/');
			$headtypedetected = substr ($myoptions['_tut_op_use_head'], strrpos ($myoptions['_tut_op_use_head'], '.')+1);
			$foottypedetected = substr ($myoptions['_tut_op_use_foot'], strrpos ($myoptions['_tut_op_use_foot'], '.')+1);
			if ( ($headtypedetected != 'php') || ($foottypedetected != 'php') ) {
				if (!defined ('_OPN_TEMPLATE_CLASS_INCLUDED') ) {
					include (_OPN_ROOT_PATH . "class/class.opn_theme_template.php");
				}
				$tpl = & new opn_template (_OPN_ROOT_PATH);
				$tpl->set ('[MORELINK]', $morelink);
				$tpl->set ('[MOREBYTES]', $morebytes);
				$tpl->set ('[COMMENTS]', $mycomments);
				$tpl->set ('[COMMENTS_LAST]', $com_date);
				$tpl->set ('[ICONS]', $myicons);
				$tpl->set ('[POSTER]', api_user_name ($informant) );
				$tpl->set ('[HREFPOSTER]', encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $informant) ) );
				$tpl->set ('[TITLE]', $title);
				$tpl->set ('[POSTEDON]', $datetime . '&nbsp;' . buildnewtag ($time) );
				$tpl->set ('[READS]', $counter);
				$tpl->set ('[_THEME_POSTEDBY]', _THEME_POSTEDBY);
				$tpl->set ('[_THEME_ON]', _THEME_ON);
				$tpl->set ('[_THEME_READS]', _THEME_READS);
				$tpl->set ('[CAT]', $mycat);
				$tpl->set ('[HREFCAT]', $mycaturl);
				$tpl->set ('[URL]', $opnConfig['opn_url'] . '/');
			}
		}
		$myoptions['_tut_op_use_foot'] = trim ($myoptions['_tut_op_use_foot']);
		if ($myoptions['_tut_op_use_foot'] != '') {
			if ($foottypedetected != 'php') {
				$foot = $tpl->fetch ('themes/' . $opnTheme['thename'] . '/tpl/tutorial/' . $myoptions['_tut_op_use_foot']);
			} else {
				include (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/tutorial/' . $myoptions['_tut_op_use_foot']);
			}
		} else {
			$foot = '';
			if (!$isindex) {
				$foot .= '<a href="javascript:self.scrollTo(0,0)" target="_self">';
				$foot .= '<img src="' . $opnConfig['opn_url'] . '/modules/tutorial/plugin/autostart/images/point_nach_oben.gif" class="imgtag" alt="" />';
				$foot .= '</a>';
				$foot .= '<img src="' . $opnConfig['opn_url'] . '/modules/tutorial/plugin/autostart/images/point.gif" width="8" height="8" border="0" alt="" /> ';
			} else {
				$foot .= '<br />';
			}
			$foot .= $morelink . $morebytes . $mycomments . $com_date . $myicons;
		}
		$myoptions['_tut_op_use_head'] = trim ($myoptions['_tut_op_use_head']);
		if ($myoptions['_tut_op_use_head'] != '') {
			if ($headtypedetected != 'php') {
				$title = $tpl->fetch ('themes/' . $opnTheme['thename'] . '/tpl/tutorial/' . $myoptions['_tut_op_use_head']);
			} else {
				include (_OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/tutorial/' . $myoptions['_tut_op_use_head']);
			}
		} else {
			if ($tut_options['showfulllink'] == 1) {
				$title = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
												'sid' => $s_sid) ) . '">' . $title . '</a>';
			} else {
				if ($s_catid != '0') {
					$title = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/topicindex.php',
													'tutorialcat' => $s_catid) ) . '">' . $cats[$s_catid] . '</a>: ' . $title;
				}
				$poster = '<a class="opncenterboxhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
												'op' => 'userinfo',
												'uname' => $informant) ) . '">' . api_user_name ($informant) . '</a>';
				$title = $title . '<br />';
				$title .= _THEME_POSTEDBY . ' ' . $poster . '&nbsp;' . _THEME_ON . ' ' . $datetime . '&nbsp;' . buildnewtag ($time) . ' (' . $counter . ' * ' . _THEME_READS . ")";
			}
		}
		if ($tut_options['dothetitle'] == 0) {
			$title = '';
		}
		if ($tut_options['dothefooter'] == 0) {
			$foot = '';
		}
		if ($tut_options['dothetitle_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($title, $tut_options['dothetitle_max']);
		}
		if ($tut_options['dothebody_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($thetext, $tut_options['dothebody_max']);
		}
		if ($tut_options['dothefooter_max'] != 0) {
			$opnConfig['cleantext']->opn_shortentext ($foot, $tut_options['dothefooter_max']);
		}
		if ($tut_options['docenterbox'] == 1) {
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_510_';
			$_display_dat['module'] = 'modules/tutorial';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox ($title, $thetext, $foot);
		} else {
			themebox_centerincenter ($myreturntext, $title, $thetext, $foot);
		}
		$foundsometutorials = true;
		$result->MoveNext ();
	}
	$result->Close ();
	if ($foundsometutorials == true) {
		if ($tutorialnumber == 0) {
			$txt = '';
			$offsetafter = $offset+ $opnConfig['opnOption']['tutorialnum'];
			$offsetbefore = $offset- $opnConfig['opnOption']['tutorialnum'];
			$result = $opnConfig['database']->Execute ($query1);
			if ( (is_object ($result) ) && (isset ($result->fields['counter']) ) ) {
				$reccount = $result->fields['counter'];
				$result->Close ();
			} else {
				$reccount = 0;
			}
			unset ($result);
			$url = array ($opnConfig['opn_url'] . '/modules/tutorial/topicindex.php');
			if ($opnConfig['opnOption']['tutorialtopic'] != '') {
				$url['tutorialtopic'] = $opnConfig['opnOption']['tutorialtopic'];
			}
			if ($opnConfig['opnOption']['tutorialcat'] != '') {
				$url['tutorialcat'] = $opnConfig['opnOption']['tutorialcat'];
			}
			if ($offsetbefore >= 0) {
				$txt .= '<td align="left">';
				$url['offset'] = $offsetbefore;
				$txt .= '<a href="' . encodeurl ($url) . '"><span class="normaltextbold">' . _TUT_PREVIOUS_PAGE . '</span></a>';
				$txt .= '</td>';
			}
			if ($offsetafter<=$reccount) {
				$txt .= '<td align="right">';
				$url['offset'] = $offsetafter;
				$txt .= '<a href="' . encodeurl ($url) . '"><span class="normaltextbold">' . _TUT_NEXT_PAGE . '</span></a>';
				$txt .= '</td>';
			}
			if ($txt != '') {
				$txt = '<table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr>' . $txt . '</tr></table>';
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_520_';
				$_display_dat['module'] = 'modules/tutorial';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayCenterbox (_TUT_BROWSEINTUTORIAL, $txt, '');
			}
		}
	}
	unset ($ubb);
	return $foundsometutorials;

}

?>