<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function update_nav ($function) {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('33%', '34%', '33%') );
		$table->AddOpenRow ();
		if ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_NEW, _PERM_ADMIN), true) ) {
			if ($function != 1) {

				$table->AddDataCol ('<a class="txtbutton" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/updatelog/index.php?op=add_update') . '">' . _UPDL_ADDUPDATE . '</a>');
			} else {
				$table->AddDataCol ('<span class="txtbutton">' . _UPDL_ADDUPDATE . '</span>');
			}
		}
		if ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			if ($function != 2) {

				$table->AddDataCol ('<a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
													'op' => 'mod_update',
													'id' => '0',
													'page' => '1') ) . '">' . _UPDL_MODUPDATE . '</a>');
			} else {
				$table->AddDataCol ('<span class="txtbutton">' . _UPDL_MODUPDATE . '</span>');
			}
		}
		if ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
			if ($function != 3) {

				$table->AddDataCol ('<a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
													'op' => 'del_update',
													'id' => 0,
													'page' => '1') ) . '">' . _UPDL_DELUPDATE . '</a>');
			} else {
				$table->AddDataCol ('<span class="txtbutton">' . _UPDL_DELUPDATE . '</span>');
			}
		}
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br />';
	}
	return $boxtxt;

}

function display_update_box ($name, $email, $date, $files, $updates, $bugs, $mod, $del, $id) {

	global $opnConfig;

	$t = $email;
	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_READ, _PERM_DELETE, _PERM_EDIT, _PERM_ADMIN) );
	opn_nl2br ($files);
	opn_nl2br ($updates);
	opn_nl2br ($bugs);
	$table = & new opn_TableClass ('listalternator');
	$table->AddCols (array ('30%', '500') );
	$opnConfig['opndate']->sqlToopnData ($date);
	$hdate = '';
	$opnConfig['opndate']->formatTimestamp ($hdate, _DATE_DATESTRING5);
	$table->AddOpenRow ();
	$table->AddDataCol ($hdate . '&nbsp;' . _UPDL_BY . ' ' . $name, '', '2');
	$table->AddCloseRow ();
	$table->AddDataRow (array (_UPDL_MODFILES, $files) );
	$table->AddDataRow (array (_UPDL_UPDDETAILS, $updates) );
	if ($bugs != '') {
		$table->AddDataRow (array (_UPDL_POSBUGS, $bugs) );
	}
	if ( ($mod == 1) && ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_EDIT, _PERM_ADMIN), true) ) ) {
		$table->AddOpenFootRow ('center');
		$table->AddFooterCol ('[ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'mod_update',
												'id' => $id,
												'page' => '1') ) . '">' . _UPDL_MODTHIS . '</a> ]',
												'',
												'2');
		$table->AddCloseRow ();
	}
	if ( ($del == 1) && ($opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_DELETE, _PERM_ADMIN), true) ) ) {
		$table->AddOpenFootRow ('center');
		$table->AddDataCol ('[ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'del_update',
												'id' => $id,
												'page' => '1') ) . '">' . _UPDL_DELTHIS . '</a> ]',
												'',
												'2');
		$table->AddCloseRow ();
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function add_update () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_NEW, _PERM_ADMIN) );
	$cookie = $opnConfig['permission']->GetUserinfo ();
	$uname = $cookie['uname'];
	$email = $cookie['email'];
	$boxtxt = update_nav (1);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_UPDATELOG_10_', 'updatelog_add');
	$form->Init ($opnConfig['opn_url'] . '/modules/updatelog/index.php');
	$form->AddTable ();
	$form->AddCols (array ('15%', '45%', '40%') );
	$form->AddOpenRow ();
	$form->AddDataCol (_UPDL_ACCSPECS, '', '3');
	$form->AddChangeRow ();
	$form->AddLabel ('name', _UPDL_FULLNAME);
	$form->AddTextfield ('name', 25, 40, $uname);
	$form->AddText (_UPDL_FULLNAMEEG);
	$form->AddChangeRow ();
	$form->AddLabel ('email', _UPDL_EMAILADDR);
	$form->AddTextfield ('email', 25, 40, $email);
	$form->AddText (_UPDL_EMAILADDREG);
	$form->AddTableChangeRow ();
	$form->AddLabel ('files', _UPDL_FILES);
	$form->AddTextfield ('files', 25, 40);
	$form->AddText (_UPDL_FILESEG);
	$form->AddChangeRow ();
	$form->AddLabel ('updates', _UPDL_DETAILS);
	$form->AddTextarea ('updates', 0, 0, 'virtual');
	$form->AddText (_UPDL_DETAILSEG);
	$form->AddChangeRow ();
	$form->AddLabel ('bugs', _UPDL_BUGS);
	$form->AddTextarea ('bugs', 0, 0, 'virtual');
	$form->AddText (_UPDL_BUGSEG);
	$form->AddCloseRow ();
	$form->AddOpenRow ();
	$form->AddDataCol (_UPDL_VALID, '', '3');
	$form->AddTableChangeRow ();
	$form->SetColspan ('3');
	$form->SetAlign ('center');
	$form->SetSameCol ();
	$form->AddHidden ('op', 'add');
	$form->AddSubmit ('submit');
	$form->AddText ('&nbsp;');
	$form->AddButton ('Cancel', _UPDL_CANCEL, '', '', 'history.go(-1)');
	$form->SetEndCol ();
	$form->SetColspan ('');
	$form->SetAlign ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_20_';
	$_display_dat['module'] = 'modules/updatelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);

}

function addUPD () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_NEW, _PERM_ADMIN) );
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$files = '';
	get_var ('files', $files, 'form', _OOBJ_DTYPE_CLEAN);
	$updates = '';
	get_var ('updates', $updates, 'form', _OOBJ_DTYPE_CLEAN);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CLEAN);
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_UPDATELOG_30_', 'updatelog');
	$form->Init ($opnConfig['opn_url'] . '/modules/updatelog/index.php');
	$form->AddHidden ('op', 'add_update_send');
	$error = 0;
	if ($name == '') {
		$error = 1;
		$form->AddText (_UPDL_INVNAME . '<br />');
	}
	if ($files == '') {
		$error = 1;
		$form->AddText (_UPDL_INVFILE . '<br />');
	}
	if ($updates == '') {
		$error = 1;
		$form->AddText (_UPDL_INVUPDATES . '<br />');
	}
	if (! (preg_match ('/^([a-zA-Z0-9_\-])+(\.([a-zA-Z0-9_\-])+)*@((\[(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5]))\]))|((([a-zA-Z0-9])+(([\-])+([a-zA-Z0-9])+)*\.)+([a-zA-Z])+(([\-])+([a-zA-Z0-9])+)*))$/i', $email) ) ) {
		$error = 1;
		$form->AddText (_UPDL_INVEMAIL . '<br />');
	}
	if ($error == 1) {
		$form->AddText ('<br />');
		$form->AddButton ('Back', _UPDL_GOBACK, '', '', 'history.go(-1)');
	} else {
		$opnConfig['opndate']->now ();
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$mod = 0;
		$del = 0;
		$id = 0;
		$form->AddText (display_update_box ($name, $email, $date, $files, $updates, $bugs, $mod, $del, $id) );
		$name = urlencode ($name);
		$files = urlencode ($files);
		$updates = urlencode ($updates);
		$bugs = urlencode ($bugs);
		$form->AddText ('<p><span class="normaltextitalic">' . _UPDL_LOOKRIGHT . ' </span>');
		$form->AddHidden ('name', $name);
		$form->AddHidden ('email', $email);
		$form->AddHidden ('files', $files);
		$form->AddHidden ('updates', $updates);
		$form->AddHidden ('bugs', $bugs);
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</p>');
	}
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_40_';
	$_display_dat['module'] = 'modules/updatelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);

}

function add_update_send () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_NEW, _PERM_ADMIN) );
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$files = '';
	get_var ('files', $files, 'form', _OOBJ_DTYPE_CLEAN);
	$updates = '';
	get_var ('updates', $updates, 'form', _OOBJ_DTYPE_CLEAN);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CHECK);
	$email = $opnConfig['cleantext']->FixQuotes ($email);
	$email = stripslashes ($email);
	$name = urldecode ($name);
	$files = $opnConfig['opnSQL']->qstr (urldecode ($files) );
	$updates = $opnConfig['opnSQL']->qstr (urldecode ($updates), 'updates');
	$bugs = $opnConfig['opnSQL']->qstr (urldecode ($bugs), 'bugs');
	$id = $opnConfig['opnSQL']->get_new_number ('updatelog', 'id');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_name = $opnConfig['opnSQL']->qstr ($name);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['updatelog'] . " VALUES ($id, $_name, $_email, $now, $files, $updates, $bugs)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['updatelog'], 'id=' . $id);
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorMsg () . '<br />';
		$boxtxt .= "$id, $name, $email, $files, $updates, $bugs";
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_50_';
		$_display_dat['module'] = 'modules/updatelog';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);
	} else {
		$opnConfig['opnOutput']->Redirect ('/modules/updatelog/index.php');
	}

}

function del_update () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_DELETE, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$page = 1;
	get_var ('page', $page, 'both', _OOBJ_DTYPE_CLEAN);
	$boxtxt = update_nav (3);
	if ($id == 0) {
		$boxtxt .= list_updates (0, 1, $page);
	} else
	if ($id != 0) {
		$result = &$opnConfig['database']->Execute ('SELECT id, name, email, wdate, files, updates, bugs FROM ' . $opnTables['updatelog'] . ' WHERE id=' . $id);
		$id = $result->fields['id'];
		$name = $result->fields['name'];
		$email = $result->fields['email'];
		$date = $result->fields['wdate'];
		$files = $result->fields['files'];
		$updates = $result->fields['updates'];
		$bugs = $result->fields['bugs'];
		$mod = 0;
		$del = 1;
		$boxtxt .= display_update_box ($name, $email, $date, $files, $updates, $bugs, $mod, $del, $id);
		$result->Close ();
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_UPDATELOG_60_', 'updatelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/updatelog/index.php');
		$form->AddHidden ('op', 'del_update_send');
		$form->AddText ('<span class="normaltextitalic">' . _UPDL_SUREDELETE . '</span><p>');
		$form->AddHidden ('id', $id);
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</p>');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_70_';
	$_display_dat['module'] = 'modules/updatelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);

}

function del_update_send () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_DELETE, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['updatelog'] . ' WHERE id=' . $id);
	$opnConfig['opnOutput']->Redirect ('/modules/updatelog/index.php');

}

function index_update () {

	global $opnConfig;

	$page = 1;
	get_var ('page', $page, 'both', _OOBJ_DTYPE_CLEAN);
	$boxtxt = update_nav (0);
	$boxtxt .= list_updates (0, 0, $page);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_80_';
	$_display_dat['module'] = 'modules/updatelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);

}

function list_updates ($mod, $del, $page) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$min = $opnConfig['pagesize_updatelog']* ($page-1);
	$max = $opnConfig['pagesize_updatelog'];
	$count_result = &$opnConfig['database']->Execute ('SELECT COUNT(id) AS total FROM ' . $opnTables['updatelog']);
	if ( ($count_result !== false) && (isset ($count_result->fields['total']) ) ) {
		$num_rows_per_order = $count_result->fields['total'];
	} else {
		$num_rows_per_order = 0;
	}
	$result = &$opnConfig['database']->SelectLimit ('SELECT id, name, email, wdate, files, updates, bugs FROM ' . $opnTables['updatelog'] . ' ORDER by id desc', $max, $min);
	if ($result !== false) {
		$num_updates = $result->RecordCount ();
	} else {
		$num_updates = 0;
	}
	if ($num_rows_per_order>0) {
		while (! $result->EOF) {
			$myrow = $result->GetRowAssoc ('0');
			$boxtxt .= '<br /><br />';
			$boxtxt .= display_update_box ($myrow['name'], $myrow['email'], $myrow['wdate'], $myrow['files'], $myrow['updates'], $myrow['bugs'], $mod, $del, $myrow['id']);
			$result->MoveNext ();
		}
	}
	// $boxtxt .=  _OPN_HTML_NL.'<tr class="opncenterbox"><td class="opncenterbox" align="right">'._OPN_HTML_NL.'<br /><br />';
	$boxtxt .= _OPN_HTML_NL . '<br /><br />';
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('15%', '70%', '15%') );
	$table->AddOpenRow ();
	if ($num_rows_per_order>$opnConfig['pagesize_updatelog']) {
		$total_pages = ceil ($num_rows_per_order/ $opnConfig['pagesize_updatelog']);
		$prev_page = $page-1;
		if ($prev_page>0) {
			if ($mod) {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'op' => 'mod_update',
											'id' => '0',
											'page' => $prev_page) ) . '">';
			} elseif ($del) {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'op' => 'del_update',
											'id' => '0',
											'page' => $prev_page) ) . '">';
			} else {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'page' => $prev_page) ) . '">';
			}
			$hlp .= '<img src="' . $opnConfig['opn_default_images'] .'arrow/left_arrow.gif" class="imgtag" alt="' . _UPDL_PREVPAGE . ' (' . $prev_page . ')" title="' . _UPDL_PREVPAGE . ' (' . $prev_page . ')" /></a>';
			$table->AddDataCol ($hlp);
		} else {
			$table->AddDataCol ('&nbsp;');
		}
		$hlp = sprintf (_UPDL_TOTALUPDATES, $num_rows_per_order, $total_pages, $num_updates);
		$table->AddDataCol ('<span class="smalltext">' . $hlp . '</span>');
		$next_page = $page+1;
		if ($next_page<=$total_pages) {
			if ($mod) {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'op' => 'mod_update',
											'id' => '0',
											'page' => $next_page) ) . '">';
			} elseif ($del) {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'op' => 'del_update',
											'id' => '0',
											'page' => $next_page) ) . '">';
			} else {
				$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
											'page' => $next_page) ) . '">';
			}
			$hlp .= '<img src="' . $opnConfig['opn_default_images'] .'arrow/right_arrow.gif" class="imgtag" alt="' . _UPDL_NEXTPAGE . ' (' . $next_page . ')" title="' . _UPDL_NEXTPAGE . ' (' . $next_page . ')" /></a>';
			$table->AddDataCol ($hlp);
		} else {
			$table->AddDataCol ('&nbsp;');
		}
		$table->AddChangeRow ();
		$hlp = ' <span class="smalltext">[ </span>';
		for ($n = 1; $n< $total_pages; $n++) {
			if ($n == $page) {
				$hlp .= '<span class="normaltextbold">' . $n . '</span>';
			} else {
				if ($mod) {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'mod_update',
												'id' => '0',
												'page' => $n) ) . '">' . $n . '</a>';
				} elseif ($del) {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'del_update',
												'id' => '0',
												'page' => $n) ) . '">' . $n . '</a>';
				} else {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'page' => $n) ) . '">' . $n . '</a>';
				}
			}
			if ($n >= 50) {
				$break = true;
				break;
			}
			$hlp .= ' | ';
		}
		if (!isset ($break) ) {
			if ($n == $page) {
				$hlp .= '<span class="normaltextbold">' . $n . '</span>';
			} else {
				if ($mod) {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'mod_update',
												'id' => '0',
												'page' => $total_pages) ) . '">' . $n . '</a>';
				} elseif ($del) {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'op' => 'del_update',
												'id' => '0',
												'page' => $total_pages) ) . '">' . $n . '</a>';
				} else {
					$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/updatelog/index.php',
												'page' => $total_pages) ) . '">' . $n . '</a>';
				}
			}
		}
		$hlp .= '<span class="smalltext"> ] [ </span><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/updatelog/index.php">' . _UPDL_MAINLOG . '</a><span class="smalltext"> ]</span>';
		$table->AddDataCol ($hlp, 'center', '3');
	} else {
		$table->AddDataCol ('<span class="smalltext">' . $num_rows_per_order . '&nbsp;' . _UPDL_UPDATESFOUND . '</span>', '', '3');
	}
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$result->Close ();
	return $boxtxt;

}

function mod_update () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_EDIT, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$page = 1;
	get_var ('page', $page, 'both', _OOBJ_DTYPE_CLEAN);
	$boxtxt = update_nav (2);
	if ($id == 0) {
		$boxtxt .= list_updates (1, 0, $page);
	} else
	if ($id != 0) {
		$result = &$opnConfig['database']->Execute ('SELECT id, name, email, wdate, files, updates, bugs FROM ' . $opnTables['updatelog'] . ' WHERE id=' . $id);
		$id = $result->fields['id'];
		$name = $result->fields['name'];
		$email = $result->fields['email'];
		$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date);
		$files = $result->fields['files'];
		$updates = $result->fields['updates'];
		$bugs = $result->fields['bugs'];
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_UPDATELOG_90_', 'updatelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/updatelog/index.php');
		$form->AddTable ();
		$form->AddCols (array ('12%', '38%', '12%', '38%') );
		$form->AddOpenRow ();
		$form->AddDataCol (_UPDL_ORGINFO, '', '2');
		$form->AddDataCol (_UPDL_MODINFO, '', '2', '', '', 'listalternator');
		$form->AddChangeRow ();
		$form->AddText (_UPDL_NAME);
		$form->AddText ($name);
		$form->SetClass ('listalternator');
		$form->AddLabel ('name', _UPDL_NAME);
		$form->SetClass ('');
		$form->AddTextfield ('name', 25, 40, $name);
		$form->AddChangeRow ();
		$form->AddText (_UPDL_EMAIL);
		$form->AddText ($email);
		$form->SetClass ('listalternator');
		$form->AddLabel ('email', _UPDL_EMAIL);
		$form->SetClass ('');
		$form->AddTextfield ('email', 25, 40, $email);
		$form->AddChangeRow ();
		$form->AddText (_UPDL_FILES2);
		$form->AddText ($files);
		$form->SetClass ('listalternator');
		$form->AddLabel ('files', _UPDL_FILES2);
		$form->SetClass ('');
		$form->AddTextfield ('files', 25, 40, $files);
		$form->AddChangeRow ();
		$form->AddText (_UPDL_UPDATES);
		$form->AddText ($updates);
		$form->SetClass ('listalternator');
		$form->AddLabel ('updates', _UPDL_UPDATES);
		$form->SetClass ('');
		$form->AddTextarea ('updates', 0, 0, '', $updates);
		$form->AddChangeRow ();
		$form->AddText (_UPDL_BUGS2);
		$form->AddText ($bugs);
		$form->SetClass ('listalternator');
		$form->AddLabel ('bugs', _UPDL_BUGS2);
		$form->SetClass ('');
		$form->AddTextarea ('bugs', 0, 0, '', $bugs);
		$form->AddChangeRow ();
		$form->AddText (_UPDL_DATE);
		$form->AddText ($date);
		$form->SetClass ('listalternator');
		$form->AddLabel ('date', _UPDL_DATE);
		$form->SetClass ('');
		$form->AddTextfield ('date', 25, 19, $date);
		$form->AddChangeRow ();
		$form->SetColspan ('4');
		$form->SetAlign ('center');
		$form->SetSameCol ();
		$form->AddHidden ('op', 'mod_update_send');
		$form->AddHidden ('id', $id);
		$form->AddSubmit ('submit', _UPDL_APPLYMOD);
		$form->AddText (' ');
		$form->AddButton ('Cancel', _UPDL_CANCEL, '', '', 'history.go(-1)');
		$form->SetEndCol ();
		$form->SetColspan ('');
		$form->SetAlign ('');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		// memory flush
		$result->Close ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_100_';
	$_display_dat['module'] = 'modules/updatelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);

}

function mod_update_send () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/updatelog', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$errormsg = '';
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$date = '';
	get_var ('date', $date, 'form', _OOBJ_DTYPE_CLEAN);
	$files = '';
	get_var ('files', $files, 'form', _OOBJ_DTYPE_CLEAN);
	$updates = '';
	get_var ('updates', $updates, 'form', _OOBJ_DTYPE_CHECK);
	$bugs = '';
	get_var ('bugs', $bugs, 'form', _OOBJ_DTYPE_CHECK);
	$updates = stripslashes (check_html ($updates, '') );
	$bugs = stripslashes (check_html ($bugs, '') );
	if ($name == '') {
		$errormsg .= _UPDL_INVNAME . '<br />';
	}
	if ($files == '') {
		$errormsg .= _UPDL_INVFILE . '<br />';
	}
	if ($updates == '') {
		$errormsg .= _UPDL_INVUPDATES . '<br />';
	}
	if (! (preg_match ('/^([a-zA-Z0-9_\-])+(\.([a-zA-Z0-9_\-])+)*@((\[(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5])))\.(((([0-1])?([0-9])?[0-9])|(2[0-4][0-9])|(2[0-5][0-5]))\]))|((([a-zA-Z0-9])+(([\-])+([a-zA-Z0-9])+)*\.)+([a-zA-Z])+(([\-])+([a-zA-Z0-9])+)*))$/i', $email) ) ) {
		$errormsg .= _UPDL_INVEMAIL . '<br />';
	}
	if ($errormsg != '') {
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_UPDATELOG_110_', 'updatelog');
		$form->Init ($opnConfig['opn_url'] . '/modules/updatelog/index.php');
		$form->AddHidden ('op', 'add_update_send');
		$form->AddText ($errormsg . '<br />');
		$form->AddButton ('Back', _UPDL_GOBACK, '', '', 'history.go(-1)');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_UPDATELOG_120_';
		$_display_dat['module'] = 'modules/updatelog';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_UPDL_DESC, $boxtxt);
	} else {
		$updates = $opnConfig['opnSQL']->qstr (urldecode ($updates), 'updates');
		$bugs = $opnConfig['opnSQL']->qstr (urldecode ($bugs), 'bugs');
		$opnConfig['opndate']->setTimestamp ($date);
		$opnConfig['opndate']->opnDataTosql ($date);
		$_email = $opnConfig['opnSQL']->qstr ($email);
		$_files = $opnConfig['opnSQL']->qstr ($files);
		$_name = $opnConfig['opnSQL']->qstr ($name);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['updatelog'] . " SET name=$_name, email=$_email, files=$_files, updates=$updates, bugs=$bugs, wdate=$date WHERE id = $id");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['updatelog'], 'id=' . $id);
		$opnConfig['opnOutput']->Redirect ('/modules/updatelog/index.php');
	}

}

?>