<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/weblogs', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/weblogs/admin/language/');

function weblogs_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_WEB_NAVGENERAL] = _WEB_NAVGENERAL;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_WEB_SAVE] = _WEB_SAVE;
	$nav[_WEB_ADMIN] = _WEB_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function weblogssettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _WEB_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _WEB_NAV,
			'name' => 'weblogs_nav',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['weblogs_nav'] == 1?true : false),
			 ($privsettings['weblogs_nav'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _WEB_SORT,
			'name' => 'weblogs_sort',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['weblogs_sort'] == 1?true : false),
			 ($privsettings['weblogs_sort'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _WEB_DISPLAYSEARCH,
			'name' => 'weblogs_search',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['weblogs_search'] == 1?true : false),
			 ($privsettings['weblogs_search'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _WEB_LOGLOADPAGE,
			'name' => 'weblogs_perpage',
			'value' => $privsettings['weblogs_perpage'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _WEB_LOGNEW,
			'name' => 'weblogs_toplinks',
			'value' => $privsettings['weblogs_toplinks'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _WEB_CATSPERROW,
			'name' => 'weblogs_cats_per_row',
			'value' => $privsettings['weblogs_cats_per_row'],
			'size' => 1,
			'maxlength' => 1);
	$values = array_merge ($values, weblogs_allhiddens (_WEB_NAVGENERAL) );
	$set->GetTheForm (_WEB_SETTINGS, $opnConfig['opn_url'] . '/modules/weblogs/admin/settings.php', $values);

}

function weblogs_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function weblogs_dosaveweblogs ($vars) {

	global $privsettings;

	$privsettings['weblogs_toplinks'] = $vars['weblogs_toplinks'];
	$privsettings['weblogs_perpage'] = $vars['weblogs_perpage'];
	$privsettings['weblogs_nav'] = $vars['weblogs_nav'];
	$privsettings['weblogs_sort'] = $vars['weblogs_sort'];
	$privsettings['weblogs_search'] = $vars['weblogs_search'];
	$privsettings['weblogs_cats_per_row'] = $vars['weblogs_cats_per_row'];
	weblogs_dosavesettings ();

}

function weblogs_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _WEB_NAVGENERAL:
			weblogs_dosaveweblogs ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		weblogs_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _WEB_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/weblogs/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _WEB_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/weblogs/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		weblogssettings ();
		break;
}

?>