<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
$opnConfig['module']->InitModule ('modules/whois', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/whois/admin/language/');

function WhoisConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_WHOIS_ADMIN);
	$menu->InsertEntry (_WHOIS_WHOISMAIN, $opnConfig['opn_url'] . '/modules/whois/admin/index.php');
	$menu->InsertEntry (_WHOIS_SETTINGS, $opnConfig['opn_url'] . '/modules/whois/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function WhoisAdmin () {

	global $opnTables, $opnConfig;

	WhoisConfigHeader ();
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = 'asc_domain_name';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(domain_id) AS counter FROM ' . $opnTables['whois_domain'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$boxtitle = _WHOIS_TITLE;
	$progurl = array ($opnConfig['opn_url'] . '/modules/whois/admin/index.php');
	$order = '';
	$oldsortby = $sortby;
	$table = & new opn_TableClass ('alternator');
	$table->get_sort_order ($order, array ('domain_id',
						'domain_name',
						'domain_server',
						'domain_visible'),
						$sortby);
	$table->AddHeaderRow (array ($table->get_sort_feld ('domain_id', _WHOIS_ID, $progurl), $table->get_sort_feld ('domain_name', _WHOIS_NAME, $progurl), $table->get_sort_feld ('domain_server', _WHOIS_SERVER, $progurl), _WHOIS_NOTFOUND, $table->get_sort_feld ('domain_visible', _WHOIS_VISIBLE, $progurl), _WHOIS_FUNCTIONS) );
	$result = &$opnConfig['database']->SelectLimit ('SELECT domain_id, domain_name, domain_server, domain_notfound, domain_visible FROM ' . $opnTables['whois_domain'] . " " . $order, $maxperpage, $offset);
	if ($result !== false) {
		while (! $result->EOF) {
			$id = $result->fields['domain_id'];
			$domainname = $result->fields['domain_name'];
			$domainserver = $result->fields['domain_server'];
			$domainnotfound = $result->fields['domain_notfound'];
			$domainvisible = $result->fields['domain_visible'];
			if ($domainvisible == 1) {
				$domainvisible = _YES_SUBMIT;
			} else {
				$domainvisible = _NO_SUBMIT;
			}
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('modules/whois', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/whois/admin/index.php',
											'op' => 'WhoisEdit',
											'id' => $id) ) . ' ';
			}
			if ($opnConfig['permission']->HasRights ('modules/whois', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/whois/admin/index.php',
											'op' => 'WhoisDel',
											'id' => $id,
											'ok' => '0') );
			}
			$table->AddDataRow (array ($id, $domainname, $domainserver, $domainnotfound, $domainvisible, $hlp), array ('center', 'center', 'center', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/whois/admin/index.php',
					_OPN_VAR_TABLE_SORT_VAR => $oldsortby),
					$reccount,
					$maxperpage,
					$offset,
					_WHOIS_ALLWHOISINOURDATABASEARE);
	$boxtxt .= $pagebar . '<br /><br />';
	if ($opnConfig['permission']->HasRights ('modules/whois', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<span class="extratextbold">' . _WHOIS_ADDTLD . '</span><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WHOIS_10_', 'whois');
		$form->Init ($opnConfig['opn_url'] . '/modules/whois/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('25%', '75%') );
		$form->AddOpenRow ();
		$form->AddLabel ('domainname', _WHOIS_NAME . ' ');
		$form->AddTextfield ('domainname', 20, 20);
		$form->AddChangeRow ();
		$form->AddLabel ('domainserver', _WHOIS_SERVER . ' ');
		$form->AddTextfield ('domainserver', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('domainnotfound', _WHOIS_NOTFOUND . ' ');
		$form->AddTextfield ('domainnotfound', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('domainvisible', _WHOIS_VISIBLE . ' ');
		$options[0] = _NO_SUBMIT;
		$options[1] = _YES_SUBMIT;
		$form->AddSelect ('domainvisible', $options, 0);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'WhoisAdd');
		$form->AddSubmit ('submit', _WHOIS_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WHOIS_20_';
	$_display_dat['module'] = 'modules/whois';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function WhoisEdit () {

	global $opnTables, $opnConfig;

	WhoisConfigHeader ();
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/whois', array (_PERM_EDIT, _PERM_ADMIN) );
	$result = &$opnConfig['database']->Execute ('SELECT domain_name, domain_server, domain_notfound, domain_visible FROM ' . $opnTables['whois_domain'] . ' WHERE domain_id=' . $id);
	$domainname = $result->fields['domain_name'];
	$domainserver = $result->fields['domain_server'];
	$domainnotfound = $result->fields['domain_notfound'];
	$domainvisible = $result->fields['domain_visible'];
	$boxtitle = _WHOIS_EDITWHOIS;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WHOIS_30_', 'whois');
	$form->Init ($opnConfig['opn_url'] . '/modules/whois/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('25%', '75%') );
	$form->AddOpenRow ();
	$form->AddLabel ('domainname', _WHOIS_NAME . ' ');
	$form->AddTextfield ('domainname', 20, 20, $domainname);
	$form->AddChangeRow ();
	$form->AddLabel ('domainserver', _WHOIS_SERVER . ' ');
	$form->AddTextfield ('domainserver', 50, 200, $domainserver);
	$form->AddChangeRow ();
	$form->AddLabel ('domainnotfound', _WHOIS_NOTFOUND . ' ');
	$form->AddTextfield ('domainnotfound', 50, 200, $domainnotfound);
	$form->AddChangeRow ();
	$form->AddLabel ('domainvisible', _WHOIS_VISIBLE . ' ');
	$options[0] = _NO_SUBMIT;
	$options[1] = _YES_SUBMIT;
	$form->AddSelect ('domainvisible', $options, $domainvisible);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'WhoisSave');
	$form->AddHidden ('id', $id);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _WHOIS_SAVECHANGE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WHOIS_40_';
	$_display_dat['module'] = 'modules/whois';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function WhoisSave () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$domainname = '';
	get_var ('domainname', $domainname, 'form', _OOBJ_DTYPE_CLEAN);
	$domainserver = '';
	get_var ('domainserver', $domainserver, 'form', _OOBJ_DTYPE_CLEAN);
	$domainnotfound = '';
	get_var ('domainnotfound', $domainnotfound, 'form', _OOBJ_DTYPE_CLEAN);
	$domainvisible = 0;
	get_var ('domainvisible', $domainvisible, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/whois', array (_PERM_EDIT, _PERM_ADMIN) );
	$domainserver = $opnConfig['opnSQL']->qstr ($domainserver);
	$domainnotfound = $opnConfig['opnSQL']->qstr ($domainnotfound, 'domain_notfound');
	$_domainname = $opnConfig['opnSQL']->qstr ($domainname);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['whois_domain'] . " SET domain_name=$_domainname, domain_server=$domainserver, domain_notfound=$domainnotfound, domain_visible=$domainvisible WHERE domain_id=$id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['whois_domain'], 'domain_id=' . $id);

}

function WhoisAdd () {

	global $opnTables, $opnConfig;

	$domainname = '';
	get_var ('domainname', $domainname, 'form', _OOBJ_DTYPE_CLEAN);
	$domainserver = '';
	get_var ('domainserver', $domainserver, 'form', _OOBJ_DTYPE_CLEAN);
	$domainnotfound = '';
	get_var ('domainnotfound', $domainnotfound, 'form', _OOBJ_DTYPE_CLEAN);
	$domainvisible = 0;
	get_var ('domainvisible', $domainvisible, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/whois', array (_PERM_NEW, _PERM_ADMIN) );
	$domainserver = $opnConfig['opnSQL']->qstr ($domainserver);
	$domainnotfound = $opnConfig['opnSQL']->qstr ($domainnotfound, 'domain_notfound');
	$id = $opnConfig['opnSQL']->get_new_number ('whois_domain', 'domain_id');
	$_domainname = $opnConfig['opnSQL']->qstr ($domainname);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['whois_domain'] . " VALUES ($id, $_domainname, $domainserver, $domainnotfound, $domainvisible)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['whois_domain'], 'domain_id=' . $id);

}

function WhoisDel () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/whois', array (_PERM_DELETE, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['whois_domain'] . ' WHERE domain_id=' . $id);
		WhoisAdmin ();
	} else {
		WhoisConfigHeader ();
		$boxtitle = _WHOIS_WHOIS_DELETE;
		$boxtxt = '<div class="centertag"><br />';
		$boxtxt .= '<span class="alerttext">';
		$boxtxt .= '' . _WHOIS_DELETEQUESTION . '</span><br /><br />';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/whois/admin/index.php',
										'op' => 'WhoisDel',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/whois/admin/index.php">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WHOIS_50_';
		$_display_dat['module'] = 'modules/whois';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
		$opnConfig['opnOutput']->DisplayFoot ();
	}

}
$foot = '';
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'WhoisEdit':
		WhoisEdit ();
		break;
	case 'WhoisSave':
		WhoisSave ();
		WhoisAdmin ();
		break;
	case 'WhoisAdd':
		WhoisAdd ();
		WhoisAdmin ();
		break;
	case 'WhoisDel':
		WhoisDel ();
		break;
	default:
		WhoisAdmin ();
		break;
}

?>