<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/admin/plugin/user/language/');

function admin_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	if ($usernr == '') {
		$usernr = 0;
	}
	$sql = 'SELECT user_opn_home FROM ' . $opnTables['opn_user_regist_dat'] . ' WHERE user_uid=' . intval($usernr);
	$result = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($result) ) && (isset ($result->fields['user_opn_home']) ) ) {
		$user_opn_home = $result->fields['user_opn_home'];
		$result->Close ();
	} else {
		$user_opn_home = '';
	}
	unset ($result);
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_group FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr, 1);
	if (is_object ($query) ) {
		$user_group_addon = $query->fields['user_group'];
		$query->Close ();
	}
	unset ($query);
	$opnConfig['opnOption']['form']->AddOpenHeadRow ();
	$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->ResetAlternate ();
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddLabel ('user_group_addon', _ADMIN_ADUSERINFOUSERGROUP . ' <span class="alerttextcolor">(' . _ADMIN_ADUSERINFOOPTIONAL . ')</span>');
	$options = array ();
	foreach ($opnConfig['permission']->UserGroups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$opnConfig['opnOption']['form']->AddSelect ('user_group_addon', $options, $user_group_addon);
	$opnConfig['opnOption']['form']->AddChangeRow ();
	$opnConfig['opnOption']['form']->AddLabel ('user_opn_home', _ADMIN_ADUSERINFO_USER_OPN_HOME);
	$opnConfig['opnOption']['form']->AddTextfield ('user_opn_home', 60, 100, $user_opn_home);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function admin_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_group_addon = 0;
	get_var ('user_group_addon', $user_group_addon, 'form', _OOBJ_DTYPE_INT);
	$user_opn_home = '';
	get_var ('user_opn_home', $user_opn_home, 'form', _OOBJ_DTYPE_CLEAN);
	$_user_opn_home = $opnConfig['opnSQL']->qstr ($user_opn_home);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . ' SET user_group=' . $user_group_addon . ' WHERE uid=' . $usernr);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_user_regist_dat'] . " SET user_opn_home = $_user_opn_home WHERE user_uid=" . $usernr);

}

function admin_show_the_user_addon_info ($usernr, &$func) {

	global $opnConfig, $opnTables;

	$t = $func;
	$help = '<br />';
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_group FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr, 1);
	if (is_object ($query) ) {
		$user_group_addon = $query->fields['user_group'];
		$query->Close ();
	}
	unset ($query);
	$user_group_addon = $opnConfig['permission']->UserGroups[$user_group_addon]['name'];
	if (!$user_group_addon == '') {
		$help1 = '<span class="normaltextbold">' . _ADMIN_ADUSERINFOUSERGROUP . '</span><br />' . $user_group_addon . '<br /><br />' . _OPN_HTML_NL;
		$help .= $help1 . _OPN_HTML_NL;
		unset ($help1);
	}
	if ($usernr == '') {
		$usernr = 0;
	}
	$sql = 'SELECT user_opn_home FROM ' . $opnTables['opn_user_regist_dat'] . ' WHERE user_uid=' . intval($usernr);
	$result = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($result) ) && (isset ($result->fields['user_opn_home']) ) ) {
		$user_opn_home = $result->fields['user_opn_home'];
		$result->Close ();
	} else {
		$user_opn_home = '';
	}
	unset ($result);
	if ($user_opn_home != '') {
		$help1 = '<span class="normaltextbold">' . _ADMIN_ADUSERINFO_USER_OPN_HOME . '</span><br />' . $user_opn_home . '<br /><br />' . _OPN_HTML_NL;
		$help .= $help1 . _OPN_HTML_NL;
		unset ($help1);
	}
	return $help;

}

function admin_confirm_the_user_addon_info ($usernr) {

	global $opnConfig;

	$t = $usernr;
	$user_opn_home = '';
	get_var ('user_opn_home', $user_opn_home, 'form', _OOBJ_DTYPE_CLEAN);
	$user_group_addon = 0;
	get_var ('user_group_addon', $user_group_addon, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->SetSameCol ();
	$opnConfig['opnOption']['form']->AddHidden ('user_group_addon', $user_group_addon);
	$opnConfig['opnOption']['form']->AddHidden ('user_opn_home', $user_opn_home);
	$opnConfig['opnOption']['form']->SetEndCol ();
	$opnConfig['opnOption']['form']->AddCloseRow ();
	return '';

}

function admin_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			admin_get_the_user_addon_info ($uid);
			break;
		case 'save':
			admin_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			admin_confirm_the_user_addon_info ($uid);
			break;
		case 'show_page':
			$option['content'] = admin_show_the_user_addon_info ($uid, $option['data']);
			break;
		default:
			break;
	}

}

?>