<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/anypage', true);
getLanguageDef (_OPN_ROOT_PATH . 'system/anypage/admin/language/');
include (_OPN_ROOT_PATH . 'system/anypage/admin/indexmenu.php');
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.html_destroy.php');

function anypage_page_importdiradmin () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('system/anypage', array (_ANYPAGE_PERM_IMPORTDIR, _PERM_ADMIN) );
	$themelist = get_dir_list ($opnConfig['datasave']['anypage_data_url']['path']);
	usort ($themelist, 'strcollcase');
	$max = sizeof ($themelist);
	for ($i = 0; $i< $max; $i++) {
		if ($themelist[$i] != '') {
			$options[$themelist[$i]] = $themelist[$i];
		}
	}
	if ( (isset ($options) ) && ($options != '') ) {
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_ANYPAGE_50_', 'getimportdir_anypage');
		$form->Init ($opnConfig['opn_url'] . '/system/anypage/admin/importdiradmin.php');
		$form->AddText ('<span class="normaltextbold">' . _ANYPADMIN_SELECTDIR . '</span><br />');
		$form->AddSelect ('verzeichnis', $options);
		$form->AddHidden ('op', 'importdir');
		$form->AddSubmit ('fnc', _ANYPADMIN_SAVECHANGES);
		$form->AddFormEnd ();
		$help = '';
		$form->GetFormular ($help);
	} else {
		$help = '<br />' . _ANYPADMIN_NOPAGESFOUND . '<br />';
	}
	return $help;

}

function getdateiany ($datei, $verzeichnis) {

	$file = fopen ($verzeichnis . '/' . $datei, 'r');
	$str = fread ($file, filesize ($verzeichnis . '/' . $datei) );
	fclose ($file);
	return $str;

}

function importdir () {

	global $opnConfig, $opnTables;

	$verzeichnis = '';
	get_var ('verzeichnis', $verzeichnis, 'form', _OOBJ_DTYPE_CLEAN);
	$catname = '';
	get_var ('catname', $catname, 'form', _OOBJ_DTYPE_CLEAN);
	$verzeichnis = $opnConfig['datasave']['anypage_data_url']['path'] . $verzeichnis;
	$opnConfig['permission']->HasRights ('system/anypage', array (_ANYPAGE_PERM_IMPORTDIR, _PERM_ADMIN) );
	$anypage_page_cat_id = $opnConfig['opnSQL']->get_new_number ('anypage_page_cat', 'id');
	$anypage_page_cat_name = $opnConfig['opnSQL']->qstr ($catname);
	$anypage_page_cat_text = $opnConfig['opnSQL']->qstr ($catname);
	$anypage_page_cat_img = $opnConfig['opnSQL']->qstr ('');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['anypage_page_cat'] . " VALUES ($anypage_page_cat_id, $anypage_page_cat_name, $anypage_page_cat_text, $anypage_page_cat_img, 0)");
	$anypage_cat = $anypage_page_cat_id;
	$pagestatus = 'V';
	$date = Date ('m/d/Y/H/i');
	$date_array = explode ('/', $date);
	$myyear = $date_array[2];
	$mymonth = $date_array[0];
	$myday = $date_array[1];
	$myhour = $date_array[3];
	$mymin = $date_array[4];
	$opnConfig['opndate']->setTimestamp ($myyear . '-' . $mymonth . '-' . $myday . ' ' . $myhour . ':' . $mymin . ':00');
	$sqldate = '';
	$opnConfig['opndate']->opnDataTosql ($sqldate);
	$dateiliste = get_file_list ($verzeichnis);
	if (count ($dateiliste) ) {
		usort ($dateiliste, 'strcollcase');
		$max = sizeof ($dateiliste);
		for ($ii = 0; $ii< $max; $ii++) {
			if ($dateiliste[$ii] != 'image') {
				$str = getdateiany ($dateiliste[$ii], $verzeichnis);
				$info = & new html_destroy ($str);
				$pagename = $dateiliste[$ii];
				$title = $info->get_title ();
				$body = $info->get_body ();
				$info->clean_content ($body);
				$body = str_replace ("href=\"", "href=\"" . $opnConfig['opn_url'] . '/system/anypage/index.php?page=', $body);
				$body = str_replace ("href=\"" . $opnConfig['opn_url'] . '/system/anypage/index.php?page=#', "href=\"" . $opnConfig['opn_url'] . '/system/anypage/index.php?page=' . $pagename . '#', $body);
				$body = str_replace ("src=\"", "src=\"" . $opnConfig['datasave']['anypage_data_url']['url'] . '/' . $catname . '/', $body);
				$footline = '';
				$shortdesc = '';
				$anypid = $opnConfig['opnSQL']->get_new_number ('anypage_page', 'id');
				$anypage_pos = $anypid;
				$name = trim ($pagename);
				$title = $opnConfig['opnSQL']->qstr ($title);
				$footline = $opnConfig['opnSQL']->qstr ($footline);
				$shortdesc = $opnConfig['opnSQL']->qstr ($shortdesc, 'shortdesc');
				$body = $opnConfig['opnSQL']->qstr ($body, 'wpage');
				$_name = $opnConfig['opnSQL']->qstr ($name);
				$_sqldate = $opnConfig['opnSQL']->qstr ($sqldate);
				$_pagestatus = $opnConfig['opnSQL']->qstr ($pagestatus);
				$sql = 'INSERT INTO ' . $opnTables['anypage_page'] . " VALUES ($anypid, $_name, $title, $footline, $shortdesc, $body, $_pagestatus, $_sqldate, $anypage_pos, $anypage_cat, 0, 0, 0)";
				$opnConfig['database']->Execute ($sql);
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['anypage_page'], 'id=' . $anypid);
			}
		}
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'importdir':
		importdir ();
		$boxtxt = anypage_page_importdiradmin ();
		break;
	default:
		$boxtxt = anypage_page_importdiradmin ();
		break;
}
anypage_ConfigHeader ();
if (isset ($boxtxt) ) {
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ANYPAGE_60_';
	$_display_dat['module'] = 'system/anypage';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ANYPADMIN_CONFIG, $boxtxt);
}
$opnConfig['opnOutput']->DisplayFoot ();

?>