<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['permission']->HasRights ('system/article', array (_PERM_SETTING, _PERM_ADMIN) );
$opnConfig['module']->InitModule ('system/article', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'system/article/admin/language/');

function article_makenavbar ($wichSave) {

	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$nav[_ARTADMIN_NAVGENERAL] = _ARTADMIN_NAVGENERAL;
	$nav[_ARTADMIN_NAVMAIL] = _ARTADMIN_NAVMAIL;
	$nav[_ARTADMIN_NAVCOMMENTS] = _ARTADMIN_NAVCOMMENTS;
	$nav[_ARTADMIN_NAVMDERATION] = _ARTADMIN_NAVMDERATION;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_ARTADMIN_SAVE] = _ARTADMIN_SAVE;
	$nav[_ARTADMIN_ADMIN] = _ARTADMIN_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function articlesettings () {

	global $opnConfig, $privsettings, $pubsettings;
	if (!isset ($pubsettings['art_showtopicnamewhenimage']) ) {
		$pubsettings['art_showtopicnamewhenimage'] = TRUE;
	}
	if (!isset ($pubsettings['art_showtopicdescription']) ) {
		$pubsettings['art_showtopicdescription'] = TRUE;
	}
	$set = & new MySettings;
	$set->SetModule ('system/article');
	$set->SetHelpID ('_OPNDOCID_SYSTEM_ARTICLE_ARTICLESETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _ARTADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_TOPICPATH,
			'name' => 'topicpath',
			'value' => $opnConfig['datasave']['art_topic_path']['url'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_NUMADMIN,
			'name' => 'admart',
			'value' => $pubsettings['admart'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_NUMHOME,
			'name' => 'storyhome',
			'value' => $pubsettings['storyhome'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_NUMOLD,
			'name' => 'oldnum',
			'value' => $pubsettings['oldnum'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_HIDEICONS,
			'name' => 'art_hideicons',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['art_hideicons'] == 1?true : false),
			 ($pubsettings['art_hideicons'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_SHOWCOMMENTDATE,
			'name' => 'art_showcommentdate',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['art_showcommentdate'] == 1?true : false),
			 ($pubsettings['art_showcommentdate'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_SHOWTOPICNAMEWHENIMAGE,
			'name' => 'art_showtopicnamewhenimage',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['art_showtopicnamewhenimage'] == 1?true : false),
			 ($pubsettings['art_showtopicnamewhenimage'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_SHOWTOPICDESCRIPTION,
			'name' => 'art_showtopicdescription',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['art_showtopicdescription'] == 1?true : false),
			 ($pubsettings['art_showtopicdescription'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_USESHORTHEADERINDETAILEDVIEW,
			'name' => 'art_useshortheaderindetailedview',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['art_useshortheaderindetailedview'] == 1?true : false),
			 ($privsettings['art_useshortheaderindetailedview'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_SHOWARTICLEIMAGEBEFORETEXT,
			'name' => 'art_showarticleimagebeforetext',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['art_showarticleimagebeforetext'] == 1?true : false),
			 ($pubsettings['art_showarticleimagebeforetext'] == 0?true : false) ) );
	$options_file = array ();
	$themelist = get_file_list (_OPN_ROOT_PATH . 'themes' . '/' . $opnConfig['Default_Theme'] . '/tpl/article/', array ('opnliste-') );
	$options_file['&nbsp;'] = '*empty*';
	if (count ($themelist) ) {
		usort ($themelist, 'strnatcasecmp');
		$max = sizeof ($themelist);
		for ($i = 0; $i< $max; $i++) {
			$options_file[$themelist[$i]] = $themelist[$i];
		}
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _ARTADMIN_OP_USE_HEAD_ORG,
			'name' => '_op_use_head_org',
			'options' => $options_file,
			'selected' => $privsettings['_op_use_head_org']);
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _ARTADMIN_OP_USE_FOOT_ORG,
			'name' => '_op_use_foot_org',
			'options' => $options_file,
			'selected' => $privsettings['_op_use_foot_org']);
	$values = array_merge ($values, article_makenavbar (_ARTADMIN_NAVGENERAL) );
	$set->GetTheForm (_ARTADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/article/admin/settings.php', $values);

}

function mailsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('system/article');
	$set->SetHelpID ('_OPNDOCID_SYSTEM_ARTICLE_MAILSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _ARTADMIN_MAIL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _ARTADMIN_SUBMISSIONNOTIFY,
			'name' => 'notify',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['notify'] == 1?true : false),
			 ($privsettings['notify'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_EMAIL,
			'name' => 'notify_email',
			'value' => $privsettings['notify_email'],
			'size' => 30,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_EMAILSUBJECT,
			'name' => 'notify_subject',
			'value' => $privsettings['notify_subject'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _ARTADMIN_MESSAGE,
			'name' => 'notify_message',
			'value' => $privsettings['notify_message'],
			'wrap' => '',
			'cols' => 40,
			'rows' => 8);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_MAILACCOUNT,
			'name' => 'art_notify_from',
			'value' => $privsettings['art_notify_from'],
			'size' => 15,
			'maxlength' => 25);
	$values = array_merge ($values, article_makenavbar (_ARTADMIN_NAVMAIL) );
	$set->GetTheForm (_ARTADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/article/admin/settings.php', $values);

}

function commentsettings () {

	global $opnConfig, $pubsettings, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('system/article');
	$set->SetHelpID ('_OPNDOCID_SYSTEM_ARTICLE_COMMENTSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _ARTADMIN_COMMENTS);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_COMMENTLIMIT,
			'name' => 'commentlimit',
			'value' => $pubsettings['commentlimit'],
			'size' => 11,
			'maxlength' => 10);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_ANONNAME,
			'name' => 'anonymous',
			'value' => $pubsettings['anonymous'],
			'size' => 15,
			'maxlength' => 25);
	if ($opnConfig['opn_activate_email'] == 1) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _ARTADMIN_COMMENTMAIL,
				'name' => 'opn_new_comment_notify',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['opn_new_comment_notify'] == 1?true : false),
				 ($privsettings['opn_new_comment_notify'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_new_comment_notify',
				'value' => 0);
	}
	$values = array_merge ($values, article_makenavbar (_ARTADMIN_NAVCOMMENTS) );
	$set->GetTheForm (_ARTADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/article/admin/settings.php', $values);

}

function moderatesettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$set->SetModule ('system/article');
	$set->SetHelpID ('_OPNDOCID_SYSTEM_ARTICLE_MODERATESETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _ARTADMIN_MODERATION);
	$options[_ARTADMIN_NOMODERATION] = 0;
	$options[_ARTADMIN_ADMINMODERATION] = 1;
	$options[_ARTADMIN_USERMODERATION] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _ARTADMIN_MODERATIONTYPE,
			'name' => 'moderate',
			'options' => $options,
			'selected' => $pubsettings['moderate']);
	if (isset ($pubsettings['reasons']) ) {
		for ($i = 0; $i<count ($pubsettings['reasons']); $i++) {
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _ARTADMIN_REASON,
					'name' => 'reason' . $i,
					'value' => $pubsettings['reasons'][$i],
					'size' => 15,
					'maxlength' => 25);
		}
	}
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _ARTADMIN_BADREASON,
			'name' => 'badreasons',
			'value' => $pubsettings['badreasons'],
			'size' => 4,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _ARTADMIN_ADDREASON);
	$values = array_merge ($values, article_makenavbar (_ARTADMIN_NAVMDERATION) );
	$set->GetTheForm (_ARTADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/article/admin/settings.php', $values);

}

function article_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SavePublicsettings ();

}

function article_dosavearticle ($vars) {

	global $privsettings, $pubsettings;

	$pubsettings['topicpath'] = $vars['topicpath'];
	$pubsettings['admart'] = $vars['admart'];
	$pubsettings['oldnum'] = $vars['oldnum'];
	$pubsettings['storyhome'] = $vars['storyhome'];
	$pubsettings['art_hideicons'] = $vars['art_hideicons'];
	$pubsettings['art_showcommentdate'] = $vars['art_showcommentdate'];
	$pubsettings['art_showtopicnamewhenimage'] = $vars['art_showtopicnamewhenimage'];
	$pubsettings['art_showtopicdescription'] = $vars['art_showtopicdescription'];
	$pubsettings['art_showarticleimagebeforetext'] = $vars['art_showarticleimagebeforetext'];
	$privsettings['art_useshortheaderindetailedview'] = $vars['art_useshortheaderindetailedview'];
	if ($vars['_op_use_head_org'] == '*empty*') {
		$vars['_op_use_head_org'] = '';
	}
	if ($vars['_op_use_foot_org'] == '*empty*') {
		$vars['_op_use_foot_org'] = '';
	}
	$privsettings['_op_use_head_org'] = $vars['_op_use_head_org'];
	$privsettings['_op_use_foot_org'] = $vars['_op_use_foot_org'];
	article_dosavesettings ();

}

function article_dosavemail ($vars) {

	global $privsettings;

	$privsettings['notify'] = $vars['notify'];
	$privsettings['notify_email'] = $vars['notify_email'];
	$privsettings['notify_subject'] = $vars['notify_subject'];
	$privsettings['notify_message'] = $vars['notify_message'];
	$privsettings['art_notify_from'] = $vars['art_notify_from'];
	article_dosavesettings ();

}

function article_dosavecomment ($vars) {

	global $privsettings, $pubsettings;

	$pubsettings['commentlimit'] = $vars['commentlimit'];
	$pubsettings['anonymous'] = $vars['anonymous'];
	$privsettings['opn_new_comment_notify'] = $vars['opn_new_comment_notify'];
	article_dosavesettings ();

}

function article_dosavemoderate ($vars) {

	global $pubsettings;

	$pubsettings['moderate'] = $vars['moderate'];
	if (isset ($pubsettings['reasons']) ) {
		for ($i = 0; $i<count ($pubsettings['reasons']); $i++) {
			$pubsettings['reasons'][$i] = $vars['reason' . $i];
		}
	}
	$pubsettings['badreasons'] = $vars['badreasons'];
	article_dosavesettings ();

}

function article_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _ARTADMIN_NAVGENERAL:
			article_dosavearticle ($returns);
			break;
		case _ARTADMIN_NAVMAIL:
			article_dosavemail ($returns);
			break;
		case _ARTADMIN_NAVCOMMENTS:
			article_dosavecomment ($returns);
			break;
		case _ARTADMIN_NAVMDERATION:
			article_dosavemoderate ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		article_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _ARTADMIN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/article/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _ARTADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/system/article/admin/index.php') );
		CloseTheOpnDB ($opnConfig);
		break;
	case _ARTADMIN_ADDREASON:
		$pubsettings['reasons'][count ($pubsettings['reasons'])] = 'New';
		article_dosavesettings ();
		moderatesettings ();
		break;
	case _ARTADMIN_NAVMAIL:
		mailsettings ();
		break;
	case _ARTADMIN_NAVCOMMENTS:
		commentsettings ();
		break;
	case _ARTADMIN_NAVMDERATION:
		moderatesettings ();
		break;
	default:
		articlesettings ();
		break;
}

?>