<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/article/plugin/search/language/');

function article_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'article';
	$button['sel'] = 0;
	$button['label'] = _ARTICLE_SEARCH_ARTICLE;
	$buttons[] = $button;
	unset ($button);
	$button['name'] = 'comments';
	$button['sel'] = 0;
	$button['label'] = _ARTICLE_SEARCH_COMMENTS;
	$buttons[] = $button;
	unset ($button);

}

function article_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'article':
			article_retrieve_article ($query, $data, $sap);
			break;
		case 'comments':
			article_retrieve_comments ($query, $data, $sap);
			break;
	}

}

function article_retrieve_all ($query, &$data, &$sap) {

	article_retrieve_article ($query, $data, $sap);
	article_retrieve_comments ($query, $data, $sap);

}

function article_retrieve_article ($query, &$data, &$sap) {

	global $opnConfig;

	$q = article_get_query ($query);
	$q .= article_get_orderby ();
	$result = &$opnConfig['database']->Execute ($q);
	$hlp1 = array ();
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		if ($nrows>0) {
			$hlp1['data'] = _ARTICLE_SEARCH_ARTICLE;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$sid = $result->fields['sid'];
				$title = $result->fields['title'];
				$time = $result->fields['wtime'];
				$comments = $result->fields['comments'];
				$informant = $result->fields['informant'];
				$hlp1['data'] = article_build_link ($sid, $title, $time, $comments, $informant);
				$hlp1['ishead'] = false;
				$data[] = $hlp1;
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
		}
		$result->Close ();
	}

}

function article_retrieve_comments ($query, &$data, &$sap) {

	global $opnConfig;

	$hlp1 = array ();
	$q = comments_get_query ($query);
	$q .= comments_get_orderby ();
	$result = &$opnConfig['database']->Execute ($q);
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		if ($nrows>0) {
			$hlp1['data'] = _ARTICLE_SEARCH_COMMENTS;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$tid = $result->fields['tid'];
				$sid = $result->fields['sid'];
				$subject = $result->fields['subject'];
				$date = $result->fields['wdate'];
				$name = $result->fields['name'];
				$hlp1['data'] = comments_build_link ($tid, $sid, $subject, $date, $name);
				$hlp1['ishead'] = false;
				$data[] = $hlp1;
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
		}
		$result->Close ();
	}

}

function article_get_query ($query) {

	global $opnTables, $opnConfig;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$t_result = &$opnConfig['database']->Execute ('SELECT topicid FROM ' . $opnTables['article_topics'] . ' WHERE user_group IN (' . $checkerlist . ')');
	$checker = array ();
	while (! $t_result->EOF) {
		$checker[] = $t_result->fields['topicid'];
		$t_result->MoveNext ();
	}
	$topicchecker = implode (',', $checker);
	if ($topicchecker != '') {
		$topics = ' AND (topic IN (' . $topicchecker . ')) ';
	} else {
		$topics = ' ';
	}
	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('sid',
							'title',
							'wtime',
							'comments',
							'topic',
							'informant') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['article_stories']);
	$opnConfig['opn_searching_class']->SetWhere ('sid>0 AND (art_user_group IN (' . $checkerlist . ')) ' . $topics . ' AND');
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('title',
								'hometext',
								'bodytext',
								'notes',
								'informant') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function article_get_orderby () {
	return ' ORDER BY wtime DESC';

}

function article_build_link ($sid, $title, $time, $comments, $informant) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
				'sid' => $sid) );
	$opnConfig['opndate']->sqlToopnData ($time);
	$datetime = '';
	$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
	if ($title == '') {
		$title = '-';
	}
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $title . '</a> ';
	$hlp .= _ARTICLE_SEARCH_BY;
	$hlp .= ' <a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
								'op' => 'userinfo',
								'uname' => $informant) ) . '">' . api_user_name ($informant) . '</a> ';
	$hlp .= _ARTICLE_SEARCH_ON . ' ' . $datetime . ' (' . $comments . ')';
	return $hlp;

}

function comments_get_query ($query) {

	global $opnTables, $opnConfig;

	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('tid',
							'sid',
							'subject',
							'wdate',
							'name') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['article_comments']);
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('subject',
								'comment',
								'name',
								'email',
								'url') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function comments_get_orderby () {
	return ' ORDER BY wdate DESC';

}

function comments_build_link ($tid, $sid, $subject, $date, $name) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/article/index.php',
				'thold' => '-1',
				'mode' => 'flat',
				'order' => '1',
				'sid' => $sid),
				true,
				true,
				false,
				'#' . $tid);
	if (!$name) {
		$name = $opnConfig['opn_anonymous_name'];
	}
	$opnConfig['opndate']->sqlToopnData ($date);
	$datetime = '';
	$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $subject . '</a> ';
	$hlp .= _ARTICLE_SEARCH_BY . ' <a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
											'op' => 'userinfo',
											'uname' => $name) ) . '">' . api_user_name ($name) . '</a> ';
	$hlp .= ' ' . _ARTICLE_SEARCH_ON . ' ' . $datetime;
	return $hlp;

}

?>