<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->InitPermissions ('system/article');
$opnConfig['permission']->HasRight ('system/article', _PERM_WRITE);
$opnConfig['module']->InitModule ('system/article');
$opnConfig['opnOutput']->setMetaPageName ('system/article');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . 'system/article/include/articlefunctions.php');
include_once (_OPN_ROOT_PATH . 'system/article/include/submiter.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/article/language/');
require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
$opnConfig['opnOption']['article_uploadfilename'] = 'userfile';

function denyAnonymous () {

	global $opnConfig;

	$boxtitle = _ART_SUBMITNEWS;
	$boxtext = sprintf (_OPNMESSAGE_NO_USER, '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/register.php">', '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=login') . '">');
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ARTICLE_450_';
	$_display_dat['module'] = 'system/article';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}

function defaultDisplay () {

	global $opnConfig, $opnTables;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new MyFunctions;
	$form = & new opn_FormularClass ('listalternator');
	$mf->table = $opnTables['article_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mf->where = '(user_group IN (' . $checkerlist . '))';
	$boxtitle = _ART_SUBMITNEWS;
	$boxtext = '';
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_ARTICLE_460_', 'article');
	if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_USERIMAGES, true) ) {
		$form->UseImages (true);
	}
	if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_UPLOAD, true) ) {
		$form->Init ($opnConfig['opn_url'] . '/system/article/submit.php', 'post', 'coolsus', 'multipart/form-data');
	} else {
		$form->Init ($opnConfig['opn_url'] . '/system/article/submit.php', 'post', 'coolsus');
	}
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_ART_YOURNAME);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$form->SetSameCol ();
		$form->AddText (' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $cookie['uname'] . '</a>');
		$form->AddText (' [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _ART_LOGOUT . '</a> ]');
		$form->SetEndCol ();
	} else {
		$form->AddText (' ' . $opnConfig['opn_anonymous_name'] . ' [ <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _ART_NEWUSER . '</a> ]');
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('subject', _ART_TITLE);
	$form->AddText ('<br />(' . _ART_TITLEHINT . ')');
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddTextfield ('subject', 70, 80);
	$form->AddText ('<br />(' . htmlentities (_ART_BADTITLE) . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('topicid', _ART_TOPIC);
	$mf->makeMySelBox (0, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('story', _ART_SCOOP);
	$form->AddText ('<br />(' . _ART_SCOOPHINT . ')');
	$form->SetEndCol ();
	$form->AddTextarea ('story');
	$form->AddChangeRow ();
	if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_UPLOAD, true) ) {
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddHidden ('MAX_FILE_SIZE', $opnConfig['opn_upload_size_limit']);
		$form->AddFile ('userfile');
		$form->SetEndCol ();
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('userfile', 'none');
	}
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$options = array ();
	$options['exttrans'] = _ART_SCOOPTYPE1;
	$options['html'] = _ART_SCOOPTYPE2;
	$options['plaintext'] = _ART_SCOOPTYPE3;
	$form->SetSameCol ();
	$form->AddSelect ('posttype', $options, 'html');
	$form->AddText ('<br />(' . _ART_HINT . ')');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('op', _ART_PREVIEW);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText ('(' . _ART_PREVIEW2SUBMIT . ')');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtext);
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ARTICLE_470_';
	$_display_dat['module'] = 'system/article';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}

function PreviewStory () {

	global $opnConfig, $opnTables, $NEW_NAME;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new MyFunctions;
	$mf->table = $opnTables['article_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mf->where = '(user_group IN (' . $checkerlist . '))';
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
	$story = '';
	get_var ('story', $story, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$posttype = '';
	get_var ('posttype', $posttype, 'form', _OOBJ_DTYPE_CLEAN);
	$userfile = '';
	get_var ('userfile', $userfile, 'file');
	$year = 9999;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_CLEAN);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);

	$boxtitle = _ART_SUBMITNEWS;
	if (($subject != '') && ($story != '')) {
		if ($userfile == '') {
			$userfile = 'none';
		}
		$userfile = check_upload ($userfile);
		if ($userfile <> 'none') {
			$upload = & new file_upload_class;
			$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
			if ($upload->upload ('userfile', 'image', '') ) {
				if ($upload->save_file ($opnConfig['datasave']['art_bild_upload']['path'], 3) ) {
					$file = $upload->new_file;
				}
			}
			if ( (isset ($upload->errors) ) && ($upload->errors) ) {
				$file = '';
			}
		}
		$story = $opnConfig['cleantext']->FixQuotes ($story);
		$subject = $opnConfig['cleantext']->FixQuotes ($subject);
		$boxtext = '';
		if (isset ($NEW_NAME) ) {
			$boxtext .= '<br /><br />' . _ART_IMAGENAME . ': <span class="normaltextbold">' . $NEW_NAME . '</span>';
		}
		$p_subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
		if ($posttype == 'exttrans') {
			$p_story = $opnConfig['cleantext']->filter_text (htmlspecialchars ($story), true);
		} elseif ($posttype == 'plaintext') {
			$p_story = $opnConfig['cleantext']->filter_text ($story, true, true, 'nohtml');
		} else {
			$p_story = $opnConfig['cleantext']->filter_text ($story, true, true);
		}
		$f_subject = $p_subject;
		$f_story = $p_story;
		opn_nl2br ($p_story);
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_ARTICLE_480_', 'article');
		if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_USERIMAGES, true) ) {
			$form->UseImages (true);
		}
		$form->Init ($opnConfig['opn_url'] . '/system/article/submit.php', 'post', 'coolsus');
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddText (_ART_YOURNAME);
		if ($opnConfig['permission']->IsUser () ) {
			$form->SetSameCol ();
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$form->AddText ('<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . $cookie['uname'] . '</a>');
			$form->AddText (' [ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user/index.php?op=logout') . '">' . _ART_LOGOUT . '</a> ]');
			$form->SetEndCol ();
		} else {
			$form->AddText (' ' . $opnConfig['opn_anonymous_name'] . ' [ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _ART_NEWUSER . '</a> ]');
		}
		$form->AddChangeRow ();
		$form->AddText (_ART_PREVIEWWINDOW);
		if ($topicid == '') {
			$warning = '<div align="center" class="normaltextbold"><br />' . _ART_SELTOPIC . '</div>';
		} else {
			$warning = '';
		}
		if ($file != 'none') {
			$file = str_ireplace (_OPN_ROOT_PATH, $opnConfig['opn_url'] . '/', $file);
			// $form->AddText('<img src="'.$file.'" class="imgtag" alt="" />');
		}
		ArtikelPreviewPart ($form, $topicid, $file, $p_subject, $p_story);
		if ($warning != '') {
			$form->AddChangeRow ();
			$form->AddText ('&nbsp;');
			$form->AddText ($warning);
		}
		$form->AddChangeRow ();
		$form->AddLabel ('subject', _ART_TITLE);
		$form->AddTextfield ('subject', 70, 80, $f_subject);
		$form->AddChangeRow ();
		$form->AddLabel ('topicid', _ART_TOPIC);
		$mf->makeMySelBox ($topicid, $form);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddLabel ('story', _ART_SCOOP);
		$form->AddText ('<br />(' . _ART_SCOOPHINT . ')');
		$form->SetEndCol ();
		$form->AddTextarea ('story', 0, 0, '', $f_story);
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$options['exttrans'] = _ART_SCOOPTYPE1;
		$options['html'] = _ART_SCOOPTYPE2;
		$options['plaintext'] = _ART_SCOOPTYPE3;
		$form->SetSameCol ();
		$form->AddSelect ('posttype', $options, $posttype);
		$form->AddText ('<br />(' . _ART_HINT . ')');
		$form->SetEndCol ();
		if ($opnConfig['permission']->HasRight ('system/article', _ART_PERM_DELTIME, true) ) {
			// hier start the AutoDel Part
			$opnConfig['opndate']->now ();
			$ttmon = '';
			$opnConfig['opndate']->getMonth ($ttmon);
			$ttday = '';
			$opnConfig['opndate']->getDay ($ttday);
			$tthour = '';
			$opnConfig['opndate']->getHour ($tthour);
			$ttmin = '';
			$opnConfig['opndate']->getMinute ($ttmin);
			if ($month == 0) {
				$month = $ttmon;
			}
			if ($day == 0) {
				$day = $ttday;
			}
			if ($hour == 0) {
				$hour = $tthour;
			}
			if ($min == 0) {
				$min = $ttmin;
			}
			$form->AddChangeRow ();
			$form->AddText (_ART_SUBMITWHENDOYOUDELSTORY);
			$temp = '';
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
			$form->SetSameCol ();
			$form->AddText (_ART_SUBMITNOWIS . ' ' . $temp);
			$form->AddNewline (2);
			$options = array ();
			$xday = 1;
			while ($xday<=31) {
				$options[$xday] = $xday;
				$xday++;
			}
			$form->AddLabel ('day', _ART_SUBMITDAY . ' ');
			$form->AddSelect ('day', $options, $day);
			$xmonth = 1;
			$options = array ();
			while ($xmonth<=12) {
				$month1 = sprintf ('%02d', $xmonth);
				$options[$month1] = $month1;
				$xmonth++;
			}
			$form->AddLabel ('month', ' ' . _ART_SUBMITMONTH . ' ');
			$form->AddSelect ('month', $options, sprintf ('%02d', $month) );
			$form->AddLabel ('year', ' ' . _ART_SUBMITYEAR . ' ');
			$form->AddTextfield ('year', 5, 4, $year);
			$xhour = 0;
			$options = array ();
			while ($xhour<=23) {
				$hour1 = sprintf ('%02d', $xhour);
				$options[$hour1] = $hour1;
				$xhour++;
			}
			$form->AddLabel ('hour', _ART_SUBMITHOUR . ' ');
			$form->AddSelect ('hour', $options, sprintf ('%02d', $hour) );
			$xmin = 0;
			$options = array ();
			while ($xmin<=59) {
				$min1 = sprintf ('%02d', $xmin);
				$options[$min1] = $min1;
				$xmin = $xmin+5;
			}
			$min = floor ($min/5)*5;
			$form->AddLabel ('min', ' : ');
			$form->AddSelect ('min', $options, sprintf ('%02d', $min) );
			$form->AddText (' : 00');
			$form->SetEndCol ();
		}
		// hier stop the AutoDel Part
		$form->AddChangeRow ();
		$form->AddHidden ('file', $file);
		$form->SetSameCol ();
		$form->AddSubmit ('op', _ART_PREVIEW);
		$form->AddSubmit ('op', _ART_SUBMIT);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtext);
		$opnConfig['opnOutput']->EnableJavaScript ();
	} else {
		$boxtext = '<div class="centertag">' . _ART_SUBJECTSTORY . '<br />';
		$boxtext .= '[ <a class="opncenterbox" href="javascript:history.go(-1)">' . _ART_GOBACK . '</a> ]</div>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_ARTICLE_490_';
	$_display_dat['module'] = 'system/article';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case _ART_PREVIEW:
		PreviewStory ();
		break;
	case _ART_SUBMIT:
		SubmitStory ();
		break;
	default:
		defaultDisplay ();
		break;
}

?>