<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('_OPN_NO_URL_DECODE', 1);
$opnConfig['isBackend'] = true;
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
autostart_module_interface ('every_header');
if ($opnConfig['permission']->HasRight ('system/backend', _PERM_READ) ) {
	$opnConfig['module']->InitModule ('system/backend');
	getLanguageDef (_OPN_ROOT_PATH . 'system/backend/language/');
	$opnConfig['option']['days'] = array ('Sunday',
						'Monday',
						'Tuesday',
						'Wednesday',
						'Thursday',
						'Friday',
						'Saturday');
	$opnConfig['option']['daysabbr'] = array ('Sun',
						'Mon',
						'Tue',
						'Wed',
						'Thu',
						'Fri',
						'Sat');
	$opnConfig['option']['months'] = array ('January',
						'February',
						'March',
						'April',
						'May',
						'June',
						'July',
						'August',
						'September',
						'October',
						'November',
						'December');
	$opnConfig['opndate']->_days = $opnConfig['option']['days'];
	$opnConfig['opndate']->_months = $opnConfig['option']['months'];
	$opnConfig['opndate']->_daysabbr = $opnConfig['option']['daysabbr'];
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.rssbuilder.inc.php');
	$limit = 0;
	get_var ('limit', $limit, 'url', _OOBJ_DTYPE_INT);
	if (!$limit) {
		$limit = $opnConfig['backend_limit'];
	}
	if ($limit>$opnConfig['backend_max_limit']) {
		$limit = $opnConfig['backend_max_limit'];
	}
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_convert_charset.php');
	$convert = & new ConvertCharset;
	$about = $opnConfig['opn_url'];
	$title = $opnConfig['sitename'];
	$description = $convert->Convert ($opnConfig['backend_title'], $opnConfig['opn_charset_encoding'], 'utf-8', true);
	$imglink = $opnConfig['backend_image'];
	$lang = $opnConfig['backend_language'];
	$categeory = $convert->Convert ($opnConfig['slogan'], $opnConfig['opn_charset_encoding'], 'utf-8', true);
	$module = '';
	get_var ('module', $module, 'url', _OOBJ_DTYPE_CLEAN);
	if ($module != '') {
		if ($opnConfig['installedPlugins']->isplugininstalled ($module) ) {
			if ($opnConfig['installedPlugins']->hasfeature ($module, 'backend') ) {
				$stop = 2;
				$pass = '';
				get_var ('pass', $pass, 'url', _OOBJ_DTYPE_CLEAN);
				if ($pass != '') {
					if ($pass == $opnConfig['backend_pass']) {
						$stop = 0;
					}
				} elseif ( (isset ($opnConfig['backend_allow'][$module]) ) && ($opnConfig['backend_allow'][$module]) ) {
					$stop = 0;
				}
				if (!$stop) {
					$modulename = $opnConfig['installedPlugins']->plugintomodulename ($module);
					include_once (_OPN_ROOT_PATH . $module . '/plugin/backend/index.php');
					$myfunc = $modulename . '_get_backend_header';
					$myfunc ($title);
				}
			} else {
				$stop = 1;
			}
		} else {
			$stop = 1;
		}
	} else {
		$stop = 1;
	}
	$rssfile = & new RSSBuilder ('', $about, $convert->Convert ($title, $opnConfig['opn_charset_encoding'], 'utf-8', true), $description, $imglink, $categeory, 60);
	$rssfile->setFromCharset ($opnConfig['opn_charset_encoding']);
	$rssfile->setCreator ('openPHPNuke ' . versionnr () . ' - http://www.openphpnuke.com');
	if (!$stop) {
		$myfunc = $modulename . '_get_backend_content';
		$myfunc ($rssfile, $limit, $date);
		$rssfile->setDate ($date);
	} else {
		$link = $opnConfig['opn_url'];
		if ($stop == 2) {
			$title1 = _BACKEND_FORBIDDEN;
		} else {
			$title1 = _BACKEND_ERROR;
		}
		$opnConfig['opndate']->now ();
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$rssfile->setDate ($date);
		$rssfile->addItem ($link, $rssfile->ConvertToUTF ($title1), $link, '', '', $date, 'openPHPNuke ' . versionnr () . ' - http://www.openphpnuke.com', $link);
	}
	$version = '';
	get_var ('version', $version, 'url', _OOBJ_DTYPE_CLEAN);
	if ($version == '') {
		$version = $opnConfig['backend_version'];
	}
	// if ($version !='html') {header('Content-Type: text/plain'); }
	$rssfile->setLanguage ($lang);
	$rssfile->use_dc_data = true;
	// ob_start();
	$ver = '0.91';
	switch ($version) {
		case 'html':
			$ver = 'html';
			break;
		case 'atom':
			$ver = 'atom';
			break;
		case '200':
		default:
			$ver = '2.0';
			break;
	}
	$rssfile->outputRSS ($ver);
	// ob_end_flush();
}

?>