<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
global $opnConfig;
if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
	include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
}
global $opnConfig, $opnTables;

class ForumHandler {
	var $_forum_data = array ('forum' => '',
				'topic' => '',
				'offset' => '',
				'topic_subject' => '',
				'topic_post_total' => '',
				'userdata' => '',
				'bypass' => '',
				'sorting' => '',
				'start' => '',
				'forumconfig' => '',
				'error' => '',
				'highlight' => '');

	function _insert ($k, $v) {

		$this->_forum_data[strtolower ($k)] = $v;

	}

	function property ($p = null) {
		if ($p == null) {
			return $this->_forum_data;
		}
		return $this->_forum_data[strtolower ($p)];

	}

	function _setforum ($v) {

		$this->_forum_data['forum'] = $v;

	}

	function help_show_navi () {

		global $opnConfig;

		$forum = $this->property ('forum');
		$topic = $this->property ('topic');
		$userdata = $this->property ('userdata');
		$bypass = $this->property ('bypass');
		$sorting = $this->property ('sorting');
		$start = $this->property ('start');
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_FORUM_200_', 'forum');
		$form->Init ($opnConfig['opn_url'] . '/system/forum/viewtopic.php');
		$form->AddText ('<span class="opncenterbox">' . _FORUM_SORTING);
		$options[1] = _FORUM_SORT_ASC;
		$options[2] = _FORUM_SORT_DESC;
		$form->AddSelect ('sorting', $options, $sorting);
		$form->AddHidden ('forum', $forum);
		$form->AddHidden ('topic', $topic);
		$form->AddHidden ('bypass', $bypass);
		$form->AddHidden ('userdata', $userdata);
		if (isset ($start) ) {
			$form->AddHidden ('start', $start);
		}
		$form->AddSubmit ('submit', _FORUM_GO);
		$form->AddText ('</span>');
		$form->AddFormEnd ();
		$boxtxt = '';
		$form->GetFormular ($boxtxt);
		return $boxtxt;

	}

	function help_show_mods ($forum) {

		global $opnConfig;

		$moderators = get_moderators ($forum);
		$helptxt = '<span class="normaltext">' . _FORUM_MODBY . '</span>';
		$count = 0;
		reset ($moderators);
		foreach ($moderators as $mods) {
			foreach ($mods as $mod_id => $mod_name) {
				if ($count>0) {
					$helptxt .= ', ';
				}
				$helptxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
												'op' => 'userinfo',
												'uname' => $mod_name) ) . '">' . api_user_name ($mod_name,
												$mod_id) . '</a>';
				$count++;
			}
		}
		return $helptxt;

	}

	function help_head_index () {

		global $opnConfig;

		$opnConfig['opndate']->now ();
		$temp = '';
		$opnConfig['opndate']->formatTimestamp ($temp, '%A');
		$table = & new opn_TableClass ('default');
		$table->AddCols (array ('50%', '50%') );
		$hlp = _FORUM_TODAY . '<em>' . $temp . ', ';
		$opnConfig['opndate']->formatTimestamp ($temp, _DATE_FORUMDATESTRING2);
		$hlp .= $temp . '</em>';
		$hlp1 = '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/searchbb.php?searchmode=lastposts') . '">' . _FORUM_SEARCH_LAST . '</a><br />';
		$hlp1 .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/searchbb.php?searchmode=unanswered') . '">' . _FORUM_SEARCH_UNANSWERED . '</a><br />';
		if ($opnConfig['permission']->IsUser () ) {
			$hlp1 .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/searchbb.php?searchmode=egosearch') . '">' . _FORUM_OWNPOSTS . '</a><br />';
			$hlp1 .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/searchbb.php?searchmode=newposts') . '">' . _FORUM_SEARCH_NEW . '</a>';
		}
		$table->AddDataRow (array ($hlp, $hlp1), array ('left', 'right') );
		$boxtxt = '';
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><br />';
		return $boxtxt;

	}

	function get_next_prev_thread () {

		global $opnConfig, $opnTables;

		$forum = $this->property ('forum');
		$topic = $this->property ('topic');
		$table = & new opn_TableClass ('default');
		$result = $opnConfig['database']->SelectLimit ('SELECT topic_time FROM ' . $opnTables['forum_topics'] . ' WHERE topic_id=' . $topic . ' AND forum_id=' . $forum . ' ORDER BY topic_id', 1);
		$topictime = $result->fields['topic_time'];
		$result = $opnConfig['database']->SelectLimit ('SELECT topic_id, topic_title FROM ' . $opnTables['forum_topics'] . ' WHERE topic_time<' . $topictime . ' AND forum_id=' . $forum . ' ORDER BY topic_id DESC', 1);
		$atleastoneadded = false;
		if (!$result->EOF) {
			$id = $result->fields['topic_id'];
			$title = $result->fields['topic_title'];
			$table->AddDataRow (array (_FORUM_PREVTHREAD . '&nbsp;', ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php', 'topic' => $id, 'forum' => $forum) ) . '">' . $title . '</a>'), array ('right', 'left') );
			$atleastoneadded = true;
		}
		$result = $opnConfig['database']->SelectLimit ('SELECT topic_id, topic_title FROM ' . $opnTables['forum_topics'] . ' WHERE topic_time>' . $topictime . ' AND forum_id=' . $forum . ' ORDER BY topic_id', 1);
		if (!$result->EOF) {
			$id = $result->fields['topic_id'];
			$title = $result->fields['topic_title'];
			$table->AddDataRow (array (_FORUM_NEXTTHREAD . '&nbsp;', ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php', 'topic' => $id, 'forum' => $forum) ) . '">' . $title . '</a>'), array ('right', 'left') );
			$atleastoneadded = true;
		}
		if ($atleastoneadded == true) {
			$helptext = '';
			$table->GetTable ($helptext);
		} else {
			$helptext = '&nbsp;';
		}
		return $helptext;

	}

	function help_goto ($forum) {

		global $opnConfig, $opnTables;

		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_FORUM_210_', 'forum');
		$form->Init ($opnConfig['opn_url'] . '/system/forum/viewforum.php', 'post', 'forumselect');
		$form->AddText ('<span class="normaltext">' . _FORUM_JUMPTO . '</span>');
		if ($opnConfig['permission']->IsUser () ) {
			$ui = $opnConfig['permission']->GetUserinfo ();
			$user_id = $ui['uid'];
		} else {
			$user_id = 1;
		}
		$i = 0;
		$options[$i]['options'] = array (0 => _FORUM_SELECTFORUM);
		$i++;
		$forumlist = get_forumlist_user_can_see ();
		$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_title FROM ' . $opnTables['forum_cat'] . ' ORDER BY cat_id');
		if ($result !== false) {
			while (! $result->EOF) {
				$fcount = 0;
				$tempres = &$opnConfig['database']->Execute ('SELECT COUNT(forum_id) AS counter FROM ' . $opnTables['forum'] . ' WHERE cat_id = ' . $result->fields['cat_id'] . ' AND forum_id IN (' . $forumlist . ')');
				if ( ($tempres !== false) && (isset ($tempres->fields['counter']) ) ) {
					$fcount = $tempres->fields['counter'];
					$tempres->Close ();
				}
				if ($fcount>0) {
					$options[$i]['label'] = $result->fields['cat_title'];
					$forums = array ();
					$res = &$opnConfig['database']->Execute ('SELECT forum_id, forum_name FROM ' . $opnTables['forum'] . ' WHERE cat_id = ' . $result->fields['cat_id'] . ' AND forum_id IN (' . $forumlist . ')ORDER BY forum_id');
					if ($res !== false) {
						if (!$res->EOF) {
							while (! $res->EOF) {
								$name = stripslashes ($res->fields['forum_name']);
								$forums[$res->fields['forum_id']] = $name;
								$res->MoveNext ();
							}
							$res->Close ();
							$options[$i]['options'] = $forums;
							$i++;
							unset ($forums);
						} else {
							$options[$i]['options'] = array (0 => _FORUM_NOMORE);
							$i++;
						}
					} else {
						$options[$i]['options'] = array (0 => _FORUM_ERRCONNECTDB);
						$i++;
					}
				}
				$result->MoveNext ();
			}
			$result->Close ();
		} else {
			$options[$i]['options'] = array (0 => _FORUM_ERROR);
			$i++;
		}
		unset ($forumlist);
		$form->AddCheckField('forum', 's', _FORUMR_SELECT);
		$form->AddSelectGroup ('forum', $options, 0);
		$form->AddHidden ('forumiam', $forum);
		$form->AddSubmit ('submit', _FORUM_GO);
		$form->AddFormEnd ();
		$helptxt = '';
		$form->GetFormular ($helptxt);
		return $helptxt;

	}

	function body_helpinfo () {

		global $opnConfig;

		$table = & new opn_TableClass ('default');
		$table->AddOpenRow ();
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/new_kategorie.gif" title="' . _FORUM_NEWSUBCAT . '" alt="" /> ' . _FORUM_NEWSUBCAT);
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/alluser.gif" title="' . _FORUM_ALSOUNREGUSERS . '" alt="" /> ' . _FORUM_ALSOUNREGUSERS);
		$table->AddChangeRow ();
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/kategorie.gif" title="' . _FORUM_SUBCAT . '" alt="" /> ' . _FORUM_SUBCAT);
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/member.gif" title="' . _FORUM_ONLYREGUSERS . '" alt="" /> ' . _FORUM_ONLYREGUSERS);
		$table->AddChangeRow ();
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/newtopic.gif" title="' . _FORUM_NEWPOSTS . '" alt="" /> ' . _FORUM_NEWPOSTS);
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/modadm.gif" title="' . _FORUM_ONLYADMIN . '" alt="" /> ' . _FORUM_ONLYADMIN);
		$table->AddChangeRow ();
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/notnewtopic.gif" title="' . _FORUM_NONEWPOSTS . '" alt="" /> ' . _FORUM_NONEWPOSTS);
		$table->AddDataCol ('<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/privat.gif" title="' . _FORUM_PRIVATE . '" alt="" /> ' . _FORUM_PRIVATE);
		$table->AddCloseRow ();
		$helptxt = '';
		$table->GetTable ($helptxt);
		return $helptxt;

	}

	function body_normal ($forum = 0) {

		global $opnConfig, $opnTables;

		$table = & new opn_TableClass ('alternator');
		$table->AddOpenHeadRow ();
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) {
			if ($opnConfig['permission']->IsUser () ) {
				$table->AddHeaderCol (_FORUM_PM);
			}
		}
		$table->AddHeaderCol (_FORUM_SEARCH);
		$table->AddCloseRow ();
		$table->AddOpenRow ();
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) {
			if ($opnConfig['permission']->IsUser () ) {
				$hlp = '<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/inbox.gif" align="left" title="' . _FORUM_INBOX . '" alt="" />&nbsp;' . '<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _FORUM_INBOX . '</a><br />';
				$userdata = $opnConfig['permission']->GetUserinfo ();
				$result = &$opnConfig['database']->Execute ('SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'] . ' WHERE to_userid = ' . $userdata['uid']);
				if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
					$total_messages = $result->fields['counter'];
					$result->Close ();
				} else {
					$total_messages = 0;
				}
				$result = &$opnConfig['database']->Execute ('SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'] . ' WHERE to_userid = ' . $userdata['uid'] . ' AND read_msg=0');
				if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
					$new_messages = $result->fields['counter'];
					$result->Close ();
				} else {
					$new_messages = 0;
				}
				if ($total_messages>0) {
					if ($new_messages>0) {
						$hlp .= '&nbsp;' . $new_messages . '&nbsp;' . _FORUM_NEWMSG . ' | ';
					} else {
						$hlp .= _FORUM_NOMSG . ' | ';
					}
					$hlp .= $total_messages . '&nbsp;' . _FORUM_TOTALMSG;
				} else {
					$hlp .= _FORUM_YOUMSG;
				}
				$table->AddDataCol ($hlp);
			}
		}
		$form = & new opn_FormularClass ();
		$form->init ($opnConfig['opn_url'] . '/system/forum/searchbb.php');
		$form->AddHidden ('addterm', 'any');
		$form->AddHidden ('forum', 'all');
		$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, 'p.post_time desc');
		$form->AddText ('<div class="centertag">');
		$form->AddTextfield ('term', 25);
		$form->AddHidden ('submit', 'submit');
		$form->AddSubmit ('submity', _FORUM_SEARCH);
		$form->AddText ('<span class="normaltext">[<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/searchbb.php',
														'addterm' => 'any',
														'sortby' => 'p.post_time desc',
														'forum' => 'all',
														'adv' => '1') ) . '">' . _FORUM_ADVSEARCH . '</a>]</span></div>');
		$form->AddFormEnd ();
		$hlp = '';
		$form->GetFormular ($hlp);
		$table->AddDataCol ('<br />' . $hlp . '<br />');
		$table->AddChangeRow ();
		$colspan = '';
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) {
			if ($opnConfig['permission']->IsUser () ) {
				$colspan = '2';
			}
		}
		$hlp = '<a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/forum/stats.php">' . _FORUM_STATS . '</a>&nbsp;';
		if ($forum == 0) {
			$hlp .= '&nbsp;<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/index.php?MadeAllRead=1') . '">' . _FORUM_ALL_FORUM_READ . '</a>&nbsp;';
		} else {
			$hlp .= '&nbsp;<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/index.php',
											'MadeTopicsRead' => '1',
											'forum' => $forum) ) . '">' . _FORUM_ALL_TOPICS_READ . '</a>';
		}
		$table->AddDataCol ($hlp, 'center', $colspan);
		$table->AddCloseRow ();
		$boxtxt = '';
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br />';
		return $boxtxt;

	}

	function show_topics (&$thetopic, &$table, $readonly = 0) {

		global $opnConfig, $opnTables;

		$forum = $this->property ('forum');
		$topic = $this->property ('topic');
		if ($this->property ('offset') != '') {
			$offset = $this->property ('offset');
		} else {
			$offset = 0;
		}
		if ($this->property ('forumconfig') != '') {
			$forumconfig = $this->property ('forumconfig');
		} else {
			$forumconfig = '';
		}
		$userdata = $this->property ('userdata');
		$topic_subject = $this->property ('topic_subject');
		$lastpostinging = $this->property ('topic_post_total');
		$highlight = $this->property ('highlight');
		$ismoderator = is_moderator ($forum, $userdata['uid']);
		$count = 0;
		$eh = & new opn_errorhandler;
		forum_setErrorCodes ($eh);
		$temp = '';
		while (! $thetopic->EOF) {
			$table->Alternate ();
			$table->AddOpenRow ();
			if ( ($thetopic->fields['poster_id'] != $opnConfig['opn_anonymous_id']) OR ( ($thetopic->fields['poster_id'] == $opnConfig['opn_bot_user']) && ($opnConfig['installedPlugins']->isplugininstalled ('system/mailingclient') ) && ($thetopic->fields['poster_name'] == '') ) ) {
				// beginn tabelle userinfos reg
				$posterdata = $opnConfig['permission']->GetUser ($thetopic->fields['poster_id'], 'useruid', '');
				$hlp = '';
				$WarningDATA = get_image_user_warning ($posterdata['uid']);
				if ($WarningDATA != '') {
					$hlp .= '<span class="smalltext">' . $WarningDATA . '</span><br />';
				}
				$UserIsDelete = $opnConfig['permission']->CheckUserIsDelete ($posterdata);
				if ($UserIsDelete) {
					$hlp .= $posterdata['uname'] . '<br />';
				} else {
					$hlp .= '<a class="%alternateextra%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
													'op' => 'userinfo',
													'uname' => $posterdata['uname']) ) . '">' . api_user_name ($posterdata['uname']) . '</a><br />';
				}
				if ( ($opnConfig['forum_showmoderatorposts'] == '0') && (is_moderator ($forum, $posterdata['uid']) ) ) {
					$posterdata['posts'] = -1;
				}
				if ($posterdata['rank'] != 0) {
					$sql = 'SELECT rank_title FROM ' . $opnTables['forum_ranks'] . ' WHERE rank_id = ' . $posterdata['rank'];
				} elseif ($posterdata['posts']>0) {
					$sql = 'SELECT rank_title FROM ' . $opnTables['forum_ranks'] . ' WHERE rank_min <= ' . $posterdata['posts'] . ' AND rank_max >= ' . $posterdata['posts'] . ' AND rank_special = 0';
				} else {
					$sql = 'SELECT rank_title FROM ' . $opnTables['forum_ranks'] . ' WHERE rank_min <= ' . $posterdata['posts'] . ' AND rank_max >= ' . $posterdata['posts'] . '';
				}
				$result_rang = &$opnConfig['database']->Execute ($sql);
				if ($result_rang !== false) {
					$rank = $result_rang->fields['rank_title'];
					$result_rang->Close ();
					if ($rank != '') {
						$hlp .= '<span class="smalltext">' . stripslashes ($rank) . '</span><br />';
					} else {
						$hlp .= '<br />';
					}
				} else {
					$eh->show ('FORUM_0001');
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_avatar') ) {
					if ( (isset ($posterdata['user_avatar']) ) && ($posterdata['user_avatar'] != '') ) {
						include_once (_OPN_ROOT_PATH . 'system/user_avatar/plugin/user/userinfo.php');
						$hlp .= user_avatar_get_image ($posterdata['user_avatar']);
					}
				}
				if ($posterdata['user_regdate']>0) {
					$hlp .= '<span class="smalltext">' . _FORUM_JOINED;
					$opnConfig['opndate']->sqlToopnData ($posterdata['user_regdate']);
					$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING4);
					$hlp .= $temp;
					$hlp .= '</span><br />' . _OPN_HTML_NL;
				}
				if ($posterdata['posts']>0) {
					$hlp .= '<span class="smalltext">' . _FORUM_POSTSARE . _OPN_HTML_NL;
					$hlp .= $posterdata['posts'] . _OPN_HTML_NL;
					$hlp .= '</span><br />' . _OPN_HTML_NL;
				}
				$bar[0] = '';
				if ( (isset ($posterdata['user_from']) ) && ($posterdata['user_from'] != '') ) {
					$hlp .= '<span class="smalltext">' . _FORUM_FROM;
					$hlp .= $posterdata['user_from'] . '</span><br />' . _OPN_HTML_NL;
					$foo = $posterdata['user_from'];
					$bar = explode ('.', $foo);
					$bar[0] = ucwords ($bar[0]);
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_zusatz_flaggen') ) {
					if ( (isset ($posterdata['user_from_flag']) ) && ($posterdata['user_from_flag'] != '') ) {
						$hlp .= '<img src="' . $opnConfig['opn_url'] . '/system/user_zusatz_flaggen/images/' . $posterdata['user_from_flag'] . '" width="32" height="20" title="' . $bar[0] . '" alt="" /><br /><br />';
					}
				}
				if ( ($posterdata['uid'] != $opnConfig['opn_anonymous_id']) && ($opnConfig['installedPlugins']->isplugininstalled ('system/pm_msg') ) ) {
					$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php',
								'send2' => '1',
								'to_userid' => $posterdata['uid']),
								'',
								'' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/inbox.gif',
								_FORUM_SENDPM . ' ' . $posterdata['uname']);
				}
				if (isset ($posterdata['femail']) ) {
					if ($posterdata['femail'] != '') {
						$hlp .= theme_boxicrypt ($posterdata['femail'], $opnConfig['opn_url'] . '/system/forum/images/forum/icons/email.gif');
					}
				}
				if (isset ($posterdata['url']) ) {
					if ($posterdata['url'] != '') {
						if ($posterdata['url'] != 'http://') {
							if (strstr ('http://', $posterdata['url']) ) {
								$posterdata['url'] = 'http://' . $posterdata['url'];
							}
							$hlp .= theme_boxi ('' . $posterdata['url'], '', '' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/www_icon.gif', _FORUM_VISITHOME . ' ' . $posterdata['uname'], '', true);
						}
					}
				}
				$hlp .= '<br />';
				if (isset ($posterdata['user_icq']) ) {
					if ($posterdata['user_icq']) {
						$hlp .= theme_boxi ('http://wwp.icq.com/' . $posterdata['user_icq'], '', $opnConfig['opn_url'] . '/system/forum/images/forum/icons/icq_add.gif', _FORUM_ICQ, '', true);
					}
				}
				if (isset ($posterdata['user_aim']) ) {
					if ($posterdata['user_aim']) {
						$hlp .= theme_boxi ('aim:goim?screenname=' . $posterdata['user_aim'] . '&amp;message=Hi+' . $posterdata['user_aim'] . '.+Are+you+there?', '', '' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/aim.gif', _FORUM_AIM, '', true);
					}
				}
				if (isset ($posterdata['user_yim']) ) {
					if ($posterdata['user_yim']) {
						$hlp .= theme_boxi ('http://edit.yahoo.com/config/send_webmesg?.target=' . $posterdata['user_yim'] . '&amp;.src=pg', '', '' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/yim.gif', _FORUM_YIM, '', true);
					}
				}
				if (isset ($posterdata['user_msnm']) ) {
					if ($posterdata['user_msnm']) {
						$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $posterdata['uname']),
									'',
									'' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/msnm.gif',
									_FORUM_MSNM,
									'',
									true);
					}
				}
				// ende tabelle userinfos reg
			} else {
				// beginn tabelle userinfos ano
				if (!isset ($opnConfig['opn_anonymous_name']) ) {
					$opnConfig['opn_anonymous_name'] = 'Anonymous';
				}
				if ($thetopic->fields['poster_name'] != '') {
					if ($thetopic->fields['poster_email'] != '') {
						$uname = $opnConfig['crypttext']->CodeEmail ($thetopic->fields['poster_email'], $thetopic->fields['poster_name'], $table->currentclass1);
					} else {
						$uname = '<span class="normaltextbold">' . $thetopic->fields['poster_name'] . '</span>';
					}
				} else {
					$uname = '<span class="normaltextbold">' . $opnConfig['opn_anonymous_name'] . '</span>';
				}
				$posterdata = array ('uid' => $opnConfig['opn_anonymous_id'],
						'uname' => $uname,
						'posts' => '0',
						'rank' => 0);
				$hlp = $posterdata['uname'] . '<br />' . _OPN_HTML_NL;
				$hlp .= '<span class="smalltext">' . _FORUM_UNREGUSER . '</span>' . _OPN_HTML_NL;
				// ende tabelle userinfos ano
			}
			$table->AddDataCol ($hlp, '', '', 'top');
			// beginn tabelle content post
			$hlp = '';
			if ( (!$readonly) && (trim ($opnConfig['opnOption']['client']->_browser_info['browser']) != 'bot') ) {
				$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/reply.php',
											'fast_post' => 'fast_post',
											'topic' => $topic,
											'forum' => $forum,
											'post' => $thetopic->fields['post_id'],
											'quote' => '1') ) . '">';
			}
			if ( ($thetopic->fields['image'] != '') && ($thetopic->fields['image'] != 'blank.gif') ) {
				$hlp .= '<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/subject/' . $thetopic->fields['image'] . '" class="imgtag" border="0" alt="" />';
			} else {
				$hlp .= '<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/posticon.gif" class="imgtag" border="0" alt="" />';
			}
			if ( (!$readonly) && (trim ($opnConfig['opnOption']['client']->_browser_info['browser']) != 'bot') ) {
				$hlp .= '</a>';
			}
			$hlp .= '<a name="post_id' . $thetopic->fields['post_id'] . '"></a>';
			if ( ($thetopic->fields['post_subject'] != '') && ($thetopic->fields['post_subject'] != $topic_subject) ) {
				$hlp .= '<span class="smalltext">' . $thetopic->fields['post_subject'] . '</span><br /><br />';
			}
			$opnConfig['opndate']->sqlToopnData ($thetopic->fields['post_time']);
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_FORUMDATESTRING2);
			$hlp .= '<span class="smalltext">' . _FORUM_POSTED . $temp . '</span><br /><br />' . _OPN_HTML_NL;
			$ubb = & new UBBCode;
			$message = $thetopic->fields['post_text'];
			if (!isset ($forumconfig['attachmentenable']) ) {
				$forumconfig['attachmentenable'] = 0;
			}
			if ($forumconfig['attachmentenable']>0) {
				$attachments = loadAttachmentContext ($thetopic->fields['post_id'], $forumconfig);
				$hlp1 = '';
				foreach ($attachments as $attachment) {
					$extimg = $opnConfig['defimages']->get_attachment_image ('');
					if (isset ($attachment['image']) ) {
						$hlp1 .= $attachment['image'] . '<br />';
					}
					$hlp1 .= '<fieldset class="fieldset"><legend>'._FORUM_ATTACHED_FILES.'</legend>';
					$hlp1 .= '<a class="opncenterbox" href="' . $attachment['href'] . '">' . $extimg . '&nbsp;' . $attachment['name'] . '</a> (';
					$hlp1 .= $attachment['size'];
					$hlp1 .= ($attachment['is_image']?', ' . $attachment['width'] . 'x' . $attachment['height'] : '') . ' - ' . _FORUM_ATTACHMENT_DOWNLOADED . ' ' . $attachment['downloads'] . ' ' . _FORUM_ATTACHMENT_TIMES . '.)<br />';
					$hlp1 .= '</fieldset>';
				}
				if ($hlp1 != '') {
					if ( (substr_count ($message, '[addsig]') == 0) && (substr_count ($message, '[\'addsig\']') == 0) ) {
						$message .= '<br /><br />' . $hlp1;
					} else {
						if (substr_count ($message, '[addsig]')>0) {
							$message = str_replace ('[addsig]', '', $message);
						} elseif (substr_count ($message, '[\'addsig\']')>0) {
							$message = str_replace ('[\'addsig\']', '', $message);
						}
						$message .= '<br /><br />' . $hlp1 . '[addsig]';
					}
				}
			}
			if ( (substr_count ($message, '[addsig]') == 0) && (substr_count ($message, '[\'addsig\']') == 0) ) {
					$message = str_replace ('[addsig]', '', $message);
					$message = str_replace ('[\'addsig\']', '', $message);
					$message .= '</div>';
			} else {
					if (substr_count ($message, '[addsig]') > 0) { //mit sig
							$message = str_replace ('[addsig]', '</div>[addsig]', $message);
					} elseif (substr_count ($message, '[\'addsig\']') > 0) {
							$message = str_replace ('[\'addsig\']', '</div>[\'addsig\']', $message);
					}
			}
			if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
				if (isset ($posterdata['user_sig']) ) {
					if ($posterdata['user_sig'] != '') {
						opn_nl2br ($posterdata['user_sig']);
						$ubb->ubbencode ($posterdata['user_sig']);
						if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
							$message = preg_replace ('/\[addsig]/i', '<br /><br /><hr />' . smilies_smile ($posterdata['user_sig']), $message);
							$message = preg_replace ('/\[\'addsig\']/i', '<br /><br /><hr />' . smilies_smile ($posterdata['user_sig']), $message);
						} else {
							$message = preg_replace ('/\[addsig]/i', '<br /><br /><hr />' . $posterdata['user_sig'], $message);
							$message = preg_replace ('/\[\'addsig\']/i', '<br /><br /><hr />' . $posterdata['user_sig'], $message);
						}
					} else {
						$message = preg_replace ('/\[addsig]/i', '', $message);
					}
				}
			}
			if ($highlight != '') {
				$highlighter = explode (' ', $highlight);
				$opnConfig['cleantext']->hilight_text ($message, $highlighter);
				unset ($highlighter);
			}
			$hlp .= '<div style="width:auto; min-height:80px; height:auto !important; height:80px;">' . $message . '<br /><br />';
			$table->AddDataCol ($hlp, '', '', 'top');
			// ende tabelle content post
			$table->AddChangeRow ();
			$hlp = '';
			if ($posterdata['uid'] == $userdata['uid'] || ($ismoderator) ) {
				if ( ($posterdata['uid'] != $opnConfig['opn_anonymous_id']) OR ($ismoderator) ) {
					if (!$readonly) {
						$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/editpost.php',
									'post_id' => $thetopic->fields['post_id'],
									'topic' => $topic,
									'forum' => $forum,
									'offset' => $offset),
									'',
									'' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/edit.gif',
									_FORUM_EDIT);
					}
					if ($opnConfig['installedPlugins']->isplugininstalled ('system/trouble_tickets') ) {
						// $boxtxt .= theme_boxi ($opnConfig['opn_url'].'/modules/trouble_tickets/index.php?getDatenSubject='.$posterdata['uname'].':'.$topic_subject.'&getDatenProblem='.stripslashes($thetopic->fields['post_text']),_FORUM_MADE_TT,'');
					}
				}
			}
			if (!$readonly) {
				$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/reply.php',
							'topic' => $topic,
							'forum' => $forum,
							'post' => $thetopic->fields['post_id'],
							'quote' => '1'),
							'',
							'' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/quote.gif',
							_FORUM_QUOTE);
			}
			if ($ismoderator) {
				if ($opnConfig['permission']->HasRights ('system/forum', array (_FORUM_PERM_IP, _PERM_ADMIN), true) ) {
					$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/topicadmin.php',
								'mode' => 'viewip',
								'post' => $thetopic->fields['post_id'],
								'forum' => $forum),
								'',
								$opnConfig['opn_url'] . '/system/forum/images/forum/icons/ip_logged.gif',
								_FORUM_IP . $thetopic->fields['poster_ip']);
				}
				if ($lastpostinging >= 2) {
					if ($opnConfig['permission']->HasRights ('system/forum', array (_FORUM_PERM_CAN_DELETE, _PERM_ADMIN), true) ) {
						$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/topicadmin.php',
									'mode' => 'delposting',
									'topic' => $topic,
									'forum' => $forum,
									'post_id' => $thetopic->fields['post_id']),
									'',
									$opnConfig['opn_url'] . '/system/forum/images/forum/icons/del_topic.gif',
									_FORUM_DEL);
					}
				}
			}
			// link to print this
			$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/printtopic.php',
						'post_id' => $thetopic->fields['post_id'],
						'topic' => $topic,
						'forum' => $forum),
						'',
						$opnConfig['opn_url'] . '/system/forum/images/print.gif',
						_FORUM_PRINTER,
						'',
						true);
			if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_SENDTOPIC, true) ) {
				// link to eMail this
				$hlp .= theme_boxi (array ($opnConfig['opn_url'] . '/system/forum/emailtopic.php',
							'topic' => $topic,
							'forum' => $forum,
							'post_id' => $thetopic->fields['post_id'],
							'usernummer' => $userdata['uid']),
							'',
							'' . $opnConfig['opn_url'] . '/system/forum/images/friend.gif',
							_FORUM_EMAILPOST);
			}
			$hlp .= '<a class="themeboxi" href="javascript:self.scrollTo(0,0)"><img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/icons/top.gif" class="imgtag" alt="' . _FORUM_ATTOP . '" /></a>';
			$table->AddDataCol ($hlp, 'right', '2', 'top');
			$table->AddCloseRow ();
			$count++;
			$thetopic->MoveNext ();
		}

	}

	function auto_prune ($forum_id) {

		global $opnConfig, $opnTables;

		$config = loadForumConfig ($forum_id);
		if ($config['prune_freq'] && $config['prune_days']) {
			$opnConfig['opndate']->now ();
			$next_prune = 0;
			$opnConfig['opndate']->opnDataTosql ($next_prune);
			$opnConfig['opndate']->subInterval ($config['prune_days'] . ' DAYS');
			$prune_days = 0;
			$opnConfig['opndate']->opnDataTosql ($prune_days);
			$opnConfig['opndate']->sqlToopnData ($next_prune);
			$opnConfig['opndate']->addInterval ($config . ' DAYS');
			$opnConfig['opndate']->opnDataTosql ($next_prune);
			$this->prune ($forum_id, $prune_days);
			$sql = 'UPDATE ' . $opnTables['forum'] . " SET prune_next=$next_prune WHERE forum_id=$forum_id";
			$opnConfig['database']->Execute ($sql);
		}

	}

	function prune ($forum_id, $prune_date, $prune_all = false) {

		global $opnConfig, $opnTables;

		$prune_all = ($prune_all)?'' : 'and t.topic_type <> 3';
		$config = loadForumConfig ($forum_id);
		$prune_closed = ($config['prune_closed'])?'' : 'and t.topic_status <> 1';
		$prune_sticky = ($config['prune_sticky'])?'' : 'and t.topic_type <> 2';
		$sql = 'SELECT t.topic_id AS topic_id FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['forum_topics'] . ' t' . ' WHERE t.forum_id=' . $forum_id . ' ' . $prune_all . ' ' . $prune_sticky . ' ' . $prune_closed . ' and p.topic_id=t.topic_id';
		if ($prune_date != '') {
			$sql .= ' and p.post_time <' . $prune_date;
		}
		$result = &$opnConfig['database']->Execute ($sql);
		$sql_topics = '';
		while (! $result->EOF) {
			$row = $result->GetRowAssoc ('0');
			$sql_topics .= ( ($sql_topics != '')?', ' : '') . $row['topic_id'];
			$result->MoveNext ();
		}
		// while
		if ($sql_topics != '') {
			$sql = 'SELECT post_id FROM ' . $opnTables['forum_posts'] . ' WHERE forum_id=' . $forum_id . " and topic_id in ($sql_topics)";
			$result = &$opnConfig['database']->Execute ($sql);
			$sql_posts = '';
			while (! $result->EOF) {
				$row = $result->GetRowAssoc ('0');
				$sql_posts .= ( ($sql_posts != '')?', ' : '') . $row['post_id'];
				$result->MoveNext ();
			}
			// while
			if ($sql_posts != '') {
				$sql = 'delete FROM ' . $opnTables['forum_posts'] . " WHERE post_id in ($sql_posts)";
				$opnConfig['database']->Execute ($sql);
				$sql = 'delete FROM ' . $opnTables['forum_topics_watch'] . " WHERE topic_id in ($sql_topics)";
				$opnConfig['database']->Execute ($sql);
				$sql = 'delete FROM ' . $opnTables['forum_topics'] . " WHERE topic_id in ($sql_topics)";
				$opnConfig['database']->Execute ($sql);
			}
		}

	}

	function auto_bot ($forum_id) {

		global $opnConfig, $opnTables;
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/mailingclient') ) {
			$config = loadForumConfig ($forum_id);
			if ( ($config['botid'] != 0) && ($config['botid'] != '') ) {
				$botsql = &$opnConfig['database']->SelectLimit ('SELECT subject, body, maildate, id FROM ' . $opnTables['mailingclient'] . ' WHERE bot_id=' . $config['botid'] . ' ORDER BY id ', 20);
				if (is_object ($botsql) ) {
					while (! $botsql->EOF) {
						$subject = $botsql->fields['subject'];
						$body = $botsql->fields['body'];
						$maildate = $botsql->fields['maildate'];
						$id = $botsql->fields['id'];
						$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['mailingclient'] . ' WHERE id=' . $id);
						$botsearch = '';
						$sqlbot = &$opnConfig['database']->Execute ('SELECT botsearch FROM ' . $opnTables['mailingclient_bot'] . ' WHERE id=' . $config['botid']);
						if (is_object ($sqlbot) ) {
							while (! $sqlbot->EOF) {
								$botsearch = $sqlbot->fields['botsearch'];
								$sqlbot->MoveNext ();
							}
						}
						$subject = trim ($subject);
						$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
						$body = $opnConfig['opnSQL']->qstr ($body, 'post_text');
						$posttotopic = '';
						$sql = 'SELECT topic_id FROM ' . $opnTables['forum_topics'] . ' WHERE topic_title=' . $subject . ' AND forum_id=' . $forum_id . ' ORDER BY topic_id';
						$result = &$opnConfig['database']->SelectLimit ($sql, 1);
						if ($result !== false) {
							while (! $result->EOF) {
								$posttotopic = $result->fields['topic_id'];
								$result->MoveNext ();
							}
						}
						$opnConfig['opndate']->now ();
						$time = '';
						$opnConfig['opndate']->opnDataTosql ($time);
						if ($posttotopic == '') {
							$topic_id = $opnConfig['opnSQL']->get_new_number ('forum_topics', 'topic_id');
							$sql = 'INSERT INTO ' . $opnTables['forum_topics'];
							$sql .= ' (topic_id, topic_title, topic_poster, forum_id, topic_time, topic_notify, poll_id, topic_type) VALUES (';
							$sql .= "$topic_id,$subject, " . $opnConfig['opn_bot_user'] . ", $forum_id, $time";
							$sql .= ', 0';
							$sql .= ', 0, 1)';
							$opnConfig['database']->Execute ($sql);
							$posttotopic = $topic_id;
						}
						$post_id = $opnConfig['opnSQL']->get_new_number ('forum_posts', 'post_id');
						$sql = 'INSERT INTO ' . $opnTables['forum_posts'] . " (post_id, topic_id, image, forum_id, poster_id, post_text, post_time, poster_ip, poster_name, poster_email, post_subject) VALUES ($post_id,$posttotopic, '', $forum_id, " . $opnConfig['opn_bot_user'] . ", $body, $time, 'bot','', '', '')";
						$opnConfig['database']->Execute ($sql);
						$opnConfig['opnSQL']->UpdateBlobs ($opnTables['forum_posts'], 'post_id' . $post_id);
						$botsql->MoveNext ();
					}
					// while $botsql
				}
				// is_object
			}
		}

	}

	function display_nav_add_spaces ($counter, &$nav) {

		for ($j = 0; $j< $counter; $j++) {
			$nav .= '&nbsp;&nbsp;&nbsp;&nbsp;';
		}

	}

	function display_nav ($cat_id, $forum = 0, $forum_name = '', $topic = 0, $topic_subject = '') {

		global $opnConfig, $opnTables;

		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
		$mf = & new MyFunctions;
		$mf->table = $opnTables['forum_cat'];
		$mf->id = 'cat_id';
		$mf->pid = 'cat_pid';
		$mf->title = 'cat_title';
		if ($topic_subject == '') {
			$topic_subject = _FORUM_NO_TITLE;
		}
		$nav = '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/forum/index.php"><img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/tree/tree_collapse.gif" width="10" alt="" class="imgtag" /></a> <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/forum/index.php">' . $opnConfig['sitename'] . '&nbsp;' . _FORUM_INDEX . '</a><br />';
		$parents = $mf->getParents ($cat_id);
		$counter = 0;
		if (count ($parents) ) {
			if ( ($forum) || ($topic) ) {
				$pcounter = -1;
			} else {
				$pcounter = 0;
			}
			for ($i = count ($parents)-1; $i> $pcounter; $i--) {
				$this->display_nav_add_spaces ($counter, $nav);
				$nav .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/index.php',
											'cat' => $parents[$i]['id']) ) . '"><img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/tree/tree_endcolapse.gif" width="24" alt="" class="imgtag" /></a> <a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/forum/index.php?',
											true,
											true,
											array ('cat' => $parents[$i]['id']) ) . '">' . $parents[$i]['title'] . '</a><br />';
				$counter++;
			}
		}
		if ( ($forum) && (!$topic) ) {
			$this->display_nav_add_spaces ($counter, $nav);
			$nav .= '<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/tree/tree_end.gif" width="15" alt="" class="imgtag" /> ' . $forum_name;
		}
		if ( ($forum) && ($topic) ) {
			$this->display_nav_add_spaces ($counter, $nav);
			$nav .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php',
										'forum' => $forum) ) . '"><img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/tree/tree_endcolapse.gif" width="24" alt="" class="imgtag" /></a> ';
			$nav .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php',
										'forum' => $forum) ) . '">' . stripslashes ($forum_name) . '</a><br />';
			$this->display_nav_add_spaces ($counter, $nav);
			$nav .= '<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/tree/tree_ends.gif" width="31" alt="" class="imgtag" /> <span class="smalltext">' . $topic_subject . '</span>';
		}
		return $nav;

	}

}

?>