<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

class ForumHandler_input extends ForumHandler {

	function reply_form ($dat) {

		global $opnConfig, $opnTables;

		$message = '';
		get_var ('message', $message, 'form', _OOBJ_DTYPE_CHECK);
		$subject = '';
		get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
		$topic = 0;
		get_var ('topic', $topic, 'both', _OOBJ_DTYPE_INT);
		$post = 0;
		get_var ('post', $post, 'both', _OOBJ_DTYPE_INT);
		$preview = '0';
		get_var ('preview', $preview, 'form', _OOBJ_DTYPE_CLEAN);
		$image_subject = 'blank.gif';
		get_var ('image_subject', $image_subject, 'form', _OOBJ_DTYPE_CLEAN);
		$html = 0;
		get_var ('html', $html, 'form', _OOBJ_DTYPE_INT);
		$bbcode = 0;
		get_var ('bbcode', $bbcode, 'form', _OOBJ_DTYPE_INT);
		$smile = 0;
		get_var ('smile', $smile, 'form', _OOBJ_DTYPE_INT);
		$user_images = 0;
		get_var ('user_images', $user_images, 'form', _OOBJ_DTYPE_INT);
		$sig = '';
		get_var ('sig', $sig, 'form', _OOBJ_DTYPE_CLEAN);
		$attachmentpreview = '';
		get_var ('attachmentpreview', $attachmentpreview, 'form', _OOBJ_DTYPE_CLEAN);
		$forum_access = $dat['forum_access'];
		$forumconfig = $dat['forumconfig'];
		$topic_title = $dat['topic_title'];
		$forum_type = $dat['forum_type'];
		$notify2 = 0;
		get_var ('notify2', $notify2, 'form', _OOBJ_DTYPE_INT);
		$topictype = 1;
		get_var ('topictype', $topictype, 'form', _OOBJ_DTYPE_CLEAN);
		$userdata = $this->property ('userdata');
		$forum = $this->property ('forum');
		if ( ($sig == '') && (isset ($userdata['attachsig']) ) ) {
			$sig = $userdata['attachsig'];
		}
		$username = '(Anonymous)';
		get_var ('uname', $username, 'form', _OOBJ_DTYPE_CLEAN);
		$email = '';
		get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
		$password = '';
		get_var ('password', $password, 'form', _OOBJ_DTYPE_CLEAN);
		$polldata = false;
		if ($dat['mode'] == 'topic') {
			$poll_question = '';
			get_var ('poll_question', $poll_question, 'form', _OOBJ_DTYPE_CHECK);
			$poll_answer = array ();
			get_var ('poll_answer', $poll_answer,'form',_OOBJ_DTYPE_CHECK);
			$poll_answer_delete = array ();
			get_var ('poll_answer_delete', $poll_answer_delete,'form',_OOBJ_DTYPE_CLEAN);
			if (count ($poll_answer) ) {
				foreach ($poll_answer as $key => $value) {
					if ( (isset ($poll_answer_delete[$key]) ) || ($value == '') ) {
						unset ($poll_answer[$key]);
					} else {
						$poll_answer[$key] = $opnConfig['cleantext']->FixQuotes ($value);
					}
				}
			}
			$poll_length = 0;
			get_var ('poll_length', $poll_length, 'form', _OOBJ_DTYPE_INT);
			$poll_secret = 0;
			get_var ('poll_secret', $poll_secret, 'form', _OOBJ_DTYPE_INT);
			$poll_answer_add = '';
			get_var ('poll_answer_add', $poll_answer_add, 'form', _OOBJ_DTYPE_CHECK);
			if ($poll_answer_add != '') {
				$pollanswer = '';
				get_var ('add_poll_answer', $pollanswer, 'form', _OOBJ_DTYPE_CHECK);
				$poll_answer[] = $opnConfig['cleantext']->FixQuotes ($pollanswer);
			}
			$poll_question = $opnConfig['cleantext']->FixQuotes ($poll_question);
			if ($dat['forumconfig']['voteallowed']) {
				if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_VOTECREATE, true) ) {
					if ($poll_question != '') {
						$polldata['question'] = $poll_question;
						$polldata['answer'] = $poll_answer;
					}
				}
			}
		}
		$message = $opnConfig['cleantext']->FixQuotes ($message);
		$subject = $opnConfig['cleantext']->FixQuotes ($subject);
		$boxtxt = '';
		if ($preview != '0') {
			Build_Preview ($boxtxt, $forumconfig, $userdata, $message, $subject, $image_subject, $html, $bbcode, $sig, $smile, $user_images, $polldata);
		} else {
			if ($subject == '') {
				$subject = $topic_title;
			}
		}
		$help = '<script language="JavaScript" type="text/javascript"><!--' . _OPN_HTML_NL;
		$help .= 'function updateAttachmentCache() {' . _OPN_HTML_NL;
		$help .= '  if (typeof(document.coolsus.attachmentpreview) == "undefined") {' . _OPN_HTML_NL;
		$help .= '    return;' . _OPN_HTML_NL;
		$help .= '  }' . _OPN_HTML_NL;
		$help .= '  document.coolsus.attachmentpreview.value = "";' . _OPN_HTML_NL;
		$help .= '  if (typeof(document.forms["coolsus"].elements["attachment[]"].length) != "undefined") {' . _OPN_HTML_NL;
		$help .= '    var tempArray = [];' . _OPN_HTML_NL;
		$help .= '    for (var i = 0; i < document.forms["coolsus"].elements["attachment[]"].length; i++)' . _OPN_HTML_NL;
		$help .= '      tempArray[i] = document.forms["coolsus"].elements["attachment[]"][i].value;' . _OPN_HTML_NL;
		$help .= '    document.coolsus.attachmentpreview.value = tempArray.join(", ");' . _OPN_HTML_NL;
		$help .= '  } else {' . _OPN_HTML_NL;
		$help .= '    document.coolsus.attachmentpreview.value = document.forms["coolsus"].elements["attachment[]"].value;' . _OPN_HTML_NL;
		$help .= '  }' . _OPN_HTML_NL;
		$help .= '  return;' . _OPN_HTML_NL;
		$help .= '}' . _OPN_HTML_NL;
		$help .= '// --></script>' . _OPN_HTML_NL;
		$boxtxt .= $help;
		$myform = 'coolsus';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_FORUM_230_', 'forum');
		if (!isset ($forumconfig['attachmentenable']) ) {
			$forumconfig['attachmentenable'] = 0;
		}
		if ( ($forumconfig['attachmentenable'] == 1) && ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_UPLOADFILE, true) ) && ($dat['mode'] != 'fast_post') ) {
			$enc = 'multipart/form-data';
		} else {
			$enc = '';
		}
		if ($dat['mode'] != 'fast_post') {
			$form->UseWysiwyg (false);
			if ($forumconfig['allow_bbcode'] == 1) {
				$form->UseBBCode (true);
			} else {
				$form->UseEditor (false);
			}
			$form->UseSmilies (true);
			$form->UseImages (true);
			$form->Init ($opnConfig['opn_url'] . '/system/forum/' . $dat['donefile'], 'post', $myform, $enc);
		} else {
			$form->UseEditor (false);
			$form->Init ($opnConfig['opn_url'] . '/system/forum/' . $dat['donefile'], 'post', $myform);
		}
		$form->AddTable ();
		$form->AddCols (array ('15%', '85%') );
		if ($dat['mode'] != 'fast_post') {
			$form->AddOpenRow ();
			$form->AddText (_FORUM_ABOUT);
			if ($forum_access == 0) {
				$form->AddText (_FORUM_ANONYMPOST);
			} elseif ($forum_access == 1) {
				$form->AddText (_FORUM_REGUSERPOST);
			} elseif ($forum_access == 2) {
				$form->AddText (_FORUM_ONLYMODPOST);
			}
			$form->AddChangeRow ();
		} else {
			$form->AddOpenRow ();
		}
		$allow_to_reply = 0;
		$changerow = false;
		$forumlist = get_forumlist_user_can_see ();
		$forumlist = explode (',', $forumlist);
		if ( ( (!$opnConfig['permission']->IsUser () ) && ($forum_access != 0) ) OR ( (!in_array ($forum, $forumlist) ) && ($forum_type == 1) ) ) {
			if ( ($dat['mode'] == 'post') OR ( ($dat['mode'] == 'fast_post') ) ) {
				$form->AddText (_FORUM_NOTALLOWEDREPLY);
			} else {
				$form->AddText (_FORUM_NOTALLOWED);
			}
			$form->AddText ('<a class="%alternate%" href="javascript:history.go(-1)">' . _FORUM_BACK . '</a>');
			$changerow = true;
		} elseif (in_array ($forum, $forumlist) ) {
			$allow_to_reply = 1;
		} elseif ($opnConfig['permission']->IsUser () && $forum_access == 1) {
			$sql = 'SELECT u.pass AS pass, s.level1 AS level1 FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' s WHERE u.uid = ' . $userdata['uid'] . ' and s.uid = ' . $userdata['uid'];
			$result = &$opnConfig['database']->Execute ($sql);
			$user = $result->GetRowAssoc ('0');
			$password = $user['pass'];
			if ($password == $userdata['pass'] && $forum_access<=$user['level1']) {
				$allow_to_reply = 1;
			} else {
				if ( ($dat['mode'] == 'post') OR ( ($dat['mode'] == 'fast_post') ) ) {
					$form->AddText (_FORUM_NOTALLOWEDREPLY);
				} else {
					$form->AddText (_FORUM_NOTALLOWED);
				}
				$form->AddText ('<a class="%alternate%" href="javascript:history.go(-1)">' . _FORUM_BACK . '</a>');
				$changerow = true;
			}
		} elseif ($forum_access == 0) {
			$allow_to_reply = 1;
		}
		unset ($forumlist);
		if ($allow_to_reply) {
			if ($opnConfig['permission']->IsUser () ) {
				if ($dat['mode'] != 'fast_post') {
					$form->AddText (_FORUM_NICKNAME);
					$SpecialErweiterung = get_image_if_moderator ($userdata['uid']) . get_image_specialrang ($userdata['uid']);
					$form->AddText ($userdata['uname'] . $SpecialErweiterung);
					$changerow = true;
				}
			} else {
				$form->AddText (_FORUM_NICKNAME);
				$form->AddCheckField('uname', 'e', _FORUM_NAMEREQ);
				$form->AddTextfield ('uname', 30, 25, $username);
				$form->AddChangeRow ();
				$form->AddCheckField('email', 'm', _FORUM_EMAILREQ);
				$form->AddLabel ('email', _FORUM_EMAIL);
				$form->AddTextfield ('email', 30, 60, $email);
				$changerow = true;
			}
			if ($dat['mode'] != 'fast_post') {
				$form->AddChangeRow ();
				$form->AddCheckField('subject', 'e', _FORUM_SUBJECTREQ);
				$form->AddLabel ('subject', _FORUM_SUBJECT);
				$form->AddTextfield ('subject', 50, 100, $subject);
				$form->AddChangeRow ();
				$form->AddText (_FORUM_MSGICON);
				$form->SetSameCol ();
				$filelist = get_file_list (_OPN_ROOT_PATH . 'system/forum/images/forum/subject/');
				natcasesort ($filelist);
				$counter = 0;
				foreach ($filelist as $file) {
					if ($counter == 15) {
						$form->AddText ('<br />');
						$counter = 0;
					}
					$form->AddRadio ('image_subject', $file, ($file == $image_subject?1 : 0) );
					if ($file != 'blank.gif') {
						$form->AddLabel ('image_subject', '&nbsp;<img src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/subject/' . $file . '" alt="" />', 1);
					} else {
						$form->AddLabel ('image_subject', '&nbsp;' . _FORUM_NONE_TXT, 1);
					}
					$form->AddText ('&nbsp;&nbsp;');
					$counter++;
				}
				$form->SetEndCol ();
				$changerow = true;
				unset ($filelist);
			}
			if ( ($changerow) || ($dat['mode'] != 'fast_post') ) {
				$form->AddChangeRow ();
			}
			$form->SetSameCol ();
			$form->AddLabel ('message', _FORUM_MSG);
			if ($dat['mode'] != 'fast_post') {
				$form->AddText ('<br /><br />' . _FORUM_HTML);
				if ($forumconfig['allow_html'] == 1) {
					$form->AddText (_FORUM_ON . '<br />');
				} else {
					$form->AddText (_FORUM_OFF . '<br />');
				}
				$form->AddText ('<a class="listalternator" href="' . encodeurl (array ($opnConfig['opn_url'] . '/include/bbcode_ref.php',
													'module' => 'system/forum') ) . '" target="_blank">' . _FORUM_BBCODE . '</a> : ');
				if ($forumconfig['allow_bbcode'] == 1) {
					$form->AddText (_FORUM_ON . '<br />');
				} else {
					$form->AddText (_FORUM_OFF . '<br />');
				}
			}
			$quote = 0;
			get_var ('quote', $quote, 'url', _OOBJ_DTYPE_INT);
			if ( ($quote) && ($dat['mode'] != 'topic') ) {
				$sql = 'SELECT p.post_text AS post_text, p.post_time AS post_time, u.uname AS uname FROM ' . $opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u WHERE post_id = ' . $post . ' AND p.poster_id = u.uid';
				$r = &$opnConfig['database']->Execute ($sql);
				if ($r !== false) {
					$m = $r->GetRowAssoc ('0');
					$tempposttime = $m['post_time'];
					$opnConfig['opndate']->sqlToopnData ($tempposttime);
					$opnConfig['opndate']->formatTimestamp ($tempposttime, _DATE_DATESTRING7);
					$text = $m['post_text'];
					if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
						include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
						$text = de_make_user_images ($text);
					}
					if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
						$text = smilies_desmile ($text);
					}
					$text = str_replace ('<br />', _OPN_HTML_NL, $text);
					include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
					$ubb = & new UBBCode;
					$ubb->ubbdecode ($text);
					$text = str_replace ('[addsig]', '', $text);
					$text = str_replace ('[\'addsig\']', '', $text);
					$text = str_replace ('[quote]', '', $text);
					$text = str_replace ('[/quote]', '', $text);
					$textarr = explode (_OPN_HTML_NL, $text);
					$quoter = 0;
					$themax = count ($textarr);
					for ($i = 0; $i<$themax; $i++) {
						if (substr_count ($textarr[$i], '')>0) {
							$quoter++;
						} elseif (substr_count ($textarr[$i], '')>0) {
							$quoter--;
						} elseif ($quoter>0) {
							$textarr[$i] = str_repeat ('>', $quoter) . ' ' . $textarr[$i];
						}
					}
					$text = implode (_OPN_HTML_NL, $textarr);
					$text = str_replace ('', '[quote]', $text);
					$text = str_replace ('', '[/quote]', $text);
					$message = '[quote author=' . $m['uname'] . ' date=' . $tempposttime . ']' . _OPN_HTML_NL . $text . _OPN_HTML_NL . '[/quote]';
				} else {
					$message = _FORUM_ERRCONTACTDB;
				}
			}
			$form->AddText ('&nbsp;');
			$form->SetEndCol ();
			$form->AddCheckField('message', 'e', _FORUM_MSGREQ);
			if ( ($dat['mode'] == 'fast_post') && (!$quote) && ($preview == '0') ) {
				$form->AddTextarea ('message', 0, 5, '', $message);
			} else {
				$form->AddTextarea ('message', 0, 0, '', $message);
			}
			if ($dat['mode'] != 'fast_post') {
				if ( ($forumconfig['attachmentenable'] == 1) && ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_UPLOADFILE, true) ) ) {
					$form->AddChangeRow ();
					$form->AddLabel ('attachment[]', _FORUM_ADD_ATTACHMENT);
					$form->SetSameCol ();
					if ($attachmentpreview != '') {
						$form->AddText (sprintf (_FORUM_ATTACHMENT_PREVIEW, $attachmentpreview) );
						$form->AddNewline ();
					}
					$form->AddFile ('attachment[]', 'inputfile', 0, 0, '', 'updateAttachmentCache();');
					$help = '<script language="JavaScript" type="text/javascript"><!--' . _OPN_HTML_NL;
					$help .= 'var allowed_attachments = ' . $forumconfig['attachmentnumperpost'] . ' - 1;' . _OPN_HTML_NL;
					$help .= 'function setOuterHTML(element, toValue) {' . _OPN_HTML_NL;
					$help .= '	if (typeof(element.outerHTML) != \'undefined\')' . _OPN_HTML_NL;
					$help .= '		element.outerHTML = toValue;' . _OPN_HTML_NL;
					$help .= '	else' . _OPN_HTML_NL;
					$help .= '	{' . _OPN_HTML_NL;
					$help .= '		var range = document.createRange();' . _OPN_HTML_NL;
					$help .= '		range.setStartBefore(element);' . _OPN_HTML_NL;
					$help .= '		element.parentNode.replaceChild(range.createContextualFragment(toValue), element);' . _OPN_HTML_NL;
					$help .= '	}' . _OPN_HTML_NL;
					$help .= '}' . _OPN_HTML_NL;
					$help .= 'function addAttachment() {' . _OPN_HTML_NL;
					$help .= '  if (allowed_attachments <= 0)' . _OPN_HTML_NL;
					$help .= '    return alert("' . _FORUM_ATTACHMENT_NOMORE . '");' . _OPN_HTML_NL;
					$help .= '  setOuterHTML(document.getElementById("moreAttachments"), \'<br \/><input type="file" name="attachment[]" class="inputfile" onchange="updateAttachmentCache();" tabindex="' . $form->GetTabindex () . '" \/><span id="moreAttachments"><\/span>\');' . _OPN_HTML_NL;
					$help .= '  allowed_attachments = allowed_attachments - 1;' . _OPN_HTML_NL;
					$help .= '  return true;' . _OPN_HTML_NL;
					$help .= '}' . _OPN_HTML_NL;
					$help .= '// --></script>' . _OPN_HTML_NL;
					$help1 = '<noscript><br />' . _OPN_HTML_NL;
					for ($i = 1; $i< $forumconfig['attachmentnumperpost']; $i++) {
						$help1 .= '<input type="file" name="attachment[]" class="inputfile" onchange="updateAttachmentCache();" tabindex="' . $form->GetTabindex () . '" /><br />' . _OPN_HTML_NL;
						$form->SetTabindex ();
					}
					$help1 .= '</noscript>' . _OPN_HTML_NL;
					$form->AddText ($help . '<span id="moreAttachments"></span>&nbsp;<a class="%alternate%" href="javascript:addAttachment();%20void(0);">' . _FORUM_ATTACHMENT_MORE . '</a>' . $help1);
					$form->AddNewline ();
					$allow = explode (',', $forumconfig['attachmentextensions']);
					$allow = implode (', ', $allow);
					$form->AddHidden ('attachmentpreview', '');
					$form->AddText (sprintf (_FORUM_ATTACHMENT_ALLOWED, $allow) );
					$form->AddNewline ();
					$form->AddText (sprintf (_FORUM_ATTACHMENT_SIZE, $forumconfig['attachmentsizelimit'], $forumconfig['attachmentnumperpost']) );
					$form->SetEndCol ();
				}
				$form->AddChangeRow ();
				$form->AddText (_FORUM_OPTIONS);
				$form->SetSameCol ();
				if ($forumconfig['allow_html'] == 1) {
					$form->AddCheckbox ('html', 1, $html);
					$form->AddLabel ('html', _FORUM_DISABLEHTML, 1);
					$form->AddNewline (2);
				}
				if ($forumconfig['allow_bbcode'] == 1) {
					$form->AddCheckbox ('bbcode', 1, $bbcode);
					$form->AddLabel ('bbcode', _FORUM_DISABLE . ' <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/include/bbcode_ref.php',
																	'module' => 'system/forum') ) . '" target="_blank">' . _FORUM_BBCODE . '</a> ' . _FORUM_ONPOST,
																	1);
					$form->AddNewline (2);
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
					$form->AddCheckbox ('smile', 1, $smile);
					$form->AddLabel ('smile', _FORUM_DISABLE . ' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/smilies/index.php" target="_blank">' . _FORUM_SMILIES . '</a> ' . _FORUM_ONPOST, 1);
					$form->AddNewline (2);
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
					$form->AddCheckbox ('user_images', 1, $user_images);
					$form->AddLabel ('user_images', _FORUM_DISABLE . ' <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user_images/index.php" target="_blank">' . _FORUM_USERIMAGES . '</a> ' . _FORUM_ONPOST, 1);
					$form->AddNewline (2);
				}
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
					if ( ($forumconfig['allow_sig'] == 1) && (isset ($userdata['attachsig']) ) ) {
						$form->AddCheckbox ('sig', 1, $sig);
						$form->AddLabel ('sig', _FORUM_SHOWSIG . ' (' . _FORUM_ADDPROFILE . ')', 1);
						$form->AddNewline (2);
					}
				}
				if ($opnConfig['permission']->IsUser () && ($forumconfig['allow_watch']) ) {
					$form->AddCheckbox ('notify2', 1, $notify2);
					$form->AddLabel ('notify2', _FORUM_NOTIFYBYMAIL, 1);
					$form->AddNewline (2);
				}
				if ($dat['mode'] != 'post') {
					if ($opnConfig['permission']->HasRights ('system/forum', array (_FORUM_PERM_STICKY, _FORUM_PERM_ANOUNCEMENT), true) ) {
						$form->AddText ('&nbsp;&nbsp;' . _FORUM_POST_TOPIC_AS . '&nbsp;');
						$form->AddRadio ('topictype', 1, true, ($topictype == 1?true : false) );
						$form->AddLabel ('topictype', '&nbsp;' . _FORUM_POST_NORMAL, 1);
						if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_STICKY, true) ) {
							$form->AddText ('&nbsp;');
							$form->AddRadio ('topictype', 2, ($topictype == 2?true : false) );
							$form->AddLabel ('topictype', '&nbsp;' . _FORUM_POST_STICKY, 1);
						}
						if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_ANOUNCEMENT, true) ) {
							$form->AddText ('&nbsp;');
							$form->AddRadio ('topictype', 3, ($topictype == 3?true : false) );
							$form->AddLabel ('topictype', '&nbsp;' . _FORUM_POST_ANNOUNCE, 1);
						}
					} else {
						$form->AddHidden ('topictype', $topictype);
					}
				}
				$form->AddText ('&nbsp;');
				$form->SetEndCol ();
				$form->AddChangeRow ();
				if ($dat['mode'] == 'topic') {
					if ($dat['forumconfig']['voteallowed']) {
						if ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_VOTECREATE, true) ) {
							$form->AddText (_FORUM_ADDVOTE);
							$form->AddText (_FORUM_ADDVOTE_DESC);
							$form->AddChangeRow ();
							$form->AddLabel ('poll_question', _FORUM_POLL_QUESTION);
							$form->AddTextfield ('poll_question', 50, 100, $poll_question);
							$form->AddChangeRow ();
							if (count ($poll_answer) ) {
								foreach ($poll_answer as $xx => $value) {
									$form->AddLabel ('poll_answer[' . $xx . ']', _FORUM_POLL_ANSWER);
									$form->SetSameCol ();
									$form->AddTextfield ('poll_answer[' . $xx . ']', 50, 250, $value);
									$form->AddText ('&nbsp;');
									$form->AddSubmit ('poll_answer_refresh', _FORUM_ANSWER_REFRESH);
									$form->AddText ('&nbsp;');
									$form->AddSubmit ('poll_answer_delete[' . $xx . ']', _FORUM_ANSWER_DELETE);
									$form->SetEndCol ();
									$form->AddChangeRow ();
								}
							}
							$form->AddLabel ('add_poll_answer', _FORUM_POLL_ANSWER);
							$form->SetSameCol ();
							$form->AddTextfield ('add_poll_answer', 50, 250, '');
							$form->AddText ('&nbsp;');
							$form->AddSubmit ('poll_answer_add', _FORUM_ANSWER_ADD);
							$form->SetEndCol ();
							$form->AddChangeRow ();
							$form->AddLabel ('poll_length', _FORUM_POLL_LENGTH);
							$form->SetSameCol ();
							$form->AddTextfield ('poll_length', 3, 3, $poll_length);
							$form->AddText ('&nbsp;' . _FORUM_POLL_DAYS);
							$form->SetEndCol ();
							$form->AddChangeRow ();
							$form->AddText (_FORUM_POLL_SECRET);
							$form->SetSameCol ();
							$form->AddCheckbox ('poll_secret', 1, $poll_secret);
							$form->AddLabel ('poll_secret', '&nbsp;' . _FORUM_POLL_SECRET1, 1);
							$form->SetEndCol ();
							$form->AddChangeRow ();
						}
					}
				}
			} else {
				$form->AddChangeRow ();
			}
			$form->SetSameCol ();
			$form->AddHidden ('forum', $forum);
			$form->AddHidden ('topic', $topic);
			$form->AddHidden ('viewlastpost', 1);
			$form->SetEndCol ();
			$form->SetSameCol ();
			$help = '';
			if ( ($forumconfig['attachmentenable'] == 1) && ($opnConfig['permission']->HasRight ('system/forum', _FORUM_PERM_UPLOADFILE, true) ) ) {
				$help = 'return (typeof(document.coolsus.attachmentpreview) == \'undefined\' || !document.coolsus.attachmentpreview.value || confirm(\'' . _FORUM_ATTACHMENT_LOSE . '\'))';
			}
			$form->AddSubmit ('preview', FORUM_PREVIEW, $help);
			$form->AddSubmit ('submit', _FORUM_SUBMIT);
			$form->AddReset ('Reset', _FORUM_RESET);
			$form->AddButton ('Cancel', _FORUM_CANCELPOST, '', '', 'javascript:history.go(-1)');
			if ($dat['mode'] != 'topic') {
				$options = array ();
				$options['fast_post'] = _FORUM_SHOWSHORTFORM;
				$options['post'] = _FORUM_SHOWLONGFORM;
				$form->AddSelect ('fast_post', $options, $dat['mode']);
			} else {
				$form->AddHidden ('fast_post', $dat['mode']);
			}
			$form->SetEndCol ();
		}
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		return $boxtxt;

	}

}

?>