<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/forum/plugin/stats/language/');
getLanguageDef (_OPN_ROOT_PATH . 'system/forum/language/');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
include_once (_OPN_ROOT_PATH . 'system/forum/functions.php');

function forum_stats_SortPosterArray ($a, $b) {
	if ($a['counter'] == $b['counter']) {
		return 0;
	}
	return ($a['counter']> $b['counter'])?-1 : 1;

}

function forum_stats_add_br (&$boxtxt) {
	if ($boxtxt != '') {
		$boxtxt .= '<br />';
	}

}

function forum_stats () {

	global $opnConfig, $opnTables;

	$opnConfig['module']->InitModule ('system/forum');
	$user_number = $opnConfig['top'];
	$admin = '';
	$boxtxt = '';
	$sql = 'SELECT poster_id, count(poster_id) AS counter FROM ' . $opnTables['forum_posts'] . ' GROUP BY poster_id';
	$result = &$opnConfig['database']->Execute ($sql);
	if (!$result->EOF) {
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('70%', '30%') );
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol (sprintf (_FORUM_STAT_STATS, $opnConfig['top']), 'center', '2');
		$table->AddCloseRow ();
		$fields = array ();
		if ($result !== false) {
			while (! $result->EOF) {
				if (!isset ($result->fields['counter']) ) {
					$result->fields['counter'] = 0;
				}
				$fields[] = $result->GetRowAssoc ('0');
				$result->MoveNext ();
			}
			$result->Close ();
		}
		usort ($fields, 'forum_stats_SortPosterArray');
		$i = 0;
		foreach ($fields as $field) {
			$sql2 = 'SELECT uid, uname FROM ' . $opnTables['users'] . ' WHERE uid = ' . $field['poster_id'];
			$result2 = &$opnConfig['database']->Execute ($sql2);
			$myrow2 = $result2->GetRowAssoc ('0');
			$result2->Close ();
			if ( ($myrow2['uid'] != $opnConfig['opn_anonymous_id']) && ($myrow2['uname'] != $admin) && ($i<$user_number) ) {
				$sql3 = 'UPDATE ' . $opnTables['users_status'] . ' SET posts=' . $field['counter'] . ' WHERE (uid = ' . $myrow2['uid'] . ')';
				$opnConfig['database']->Execute ($sql3);
				$table->AddDataRow (array ( ($i+1) . ': <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php', 'op' => 'userinfo', 'uname' => $myrow2['uname']) ) . '">' . api_user_name ($myrow2['uname']) . '</a>', $field['counter'] . '&nbsp;' . _FORUM_STAT_POSTS) );
				$i++;
			}
		}
		$table->GetTable ($boxtxt);
	}
	$admin = '';
	$inlist = '';
	// first we have to narrow our search to forums that the user is able to see
	$forumlist = get_forumlist_user_can_see ();
	if ($forumlist != '') {
		$sqlforums = 'SELECT forum_id FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id IN (' . $forumlist . ') ORDER BY forum_id';
		$resultforums = &$opnConfig['database']->Execute ($sqlforums);
		$curr_user = $opnConfig['permission']->GetUserinfo ();
		while (! $resultforums->EOF) {
			if (!$inlist == '') {
				$inlist .= ',' . $resultforums->fields['forum_id'];
			} else {
				$inlist .= $resultforums->fields['forum_id'];
			}
			$resultforums->MoveNext ();
		}
		$resultforums->Close ();
	}
	// now we check if there is something to do ;-)
	if ($inlist != '') {
		$sql = 'SELECT topic_id, forum_id, topic_title, topic_views FROM ' . $opnTables['forum_topics'] . ' WHERE forum_id IN (' . $inlist . ') ORDER BY topic_views DESC';
		$result = &$opnConfig['database']->SelectLimit ($sql, $user_number, 0);
		if (!$result->EOF) {
			forum_stats_add_br ($boxtxt);
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('70%', '30%') );
			$table->AddOpenHeadRow ();
			$table->AddHeaderCol (sprintf (_FORUM_STAT_MOSTREADPOSTS, $opnConfig['top']), 'center', '2');
			$table->AddCloseRow ();
			// get the top posters
			$i = '0';
			while (! $result->EOF) {
				// get
				$myrow2 = $result->GetRowAssoc ('0');
				// $j is the positon in the top list
				$j = $i+1;
				// print following stuff for each user
				$topic_title = $myrow2['topic_title'];
				if ($topic_title == '') {
					$topic_title = '---';
				}
				$table->AddDataRow (array ($j . ': <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php', 'topic' => $myrow2['topic_id'], 'forum' => $myrow2['forum_id'], '0' => '') ) . '">' . $topic_title . '</a>', $myrow2['topic_views'] . '&nbsp;' . _FORUM_STAT_READ) );
				$i++;
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
		}
		$result->Close ();
	}
	return $boxtxt;

}

function forum_get_stat (&$data) {

	global $opnConfig, $opnTables;

	$result = &$opnConfig['database']->Execute ('SELECT COUNT(post_id) AS counter FROM ' . $opnTables['forum_posts']);
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$num = $result->fields['counter'];
	} else {
		$num = 0;
	}
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(topic_id) AS counter FROM ' . $opnTables['forum_topics']);
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$tnum = $result->fields['counter'];
	} else {
		$tnum = 0;
	}
	if ($tnum) {
		$hlp[] = '<a class="%linkclass%" href="' . $opnConfig['opn_url'] . '/system/forum/index.php"><img src="' . $opnConfig['opn_url'] . '/system/forum/plugin/stats/images/forum.png" class="imgtag" alt="" /></a>';
		$hlp[] = _FORUM_STAT_WEHAVETOPICS;
		$hlp[] = $tnum;
		$data[] = $hlp;
		unset ($hlp);
		if ($num) {
			$hlp[] = '<a class="%linkclass%" href="' . $opnConfig['opn_url'] . '/system/forum/index.php"><img src="' . $opnConfig['opn_url'] . '/system/forum/plugin/stats/images/forum.png" class="imgtag" alt="" /></a>';
			$hlp[] = _FORUM_STAT_WEHAVEPOSTS;
			$hlp[] = $num;
			$data[] = $hlp;
			unset ($hlp);
		}
	}

}

?>