<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->HasRights ('system/forum', array (_PERM_READ, _PERM_BOT) );
$opnConfig['module']->InitModule ('system/forum');
$opnConfig['opnOutput']->setMetaPageName ('system/forum');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');
include_once (_OPN_ROOT_PATH . '/system/forum/functions.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/forum/language/');
include_once (_OPN_ROOT_PATH . 'system/forum/searchbb_functions.php');
$eh = & new opn_errorhandler;
// opn_errorhandler object
forum_setErrorCodes ($eh);
$ui = $opnConfig['permission']->GetUserinfo ();
$searchmode = '';
get_var ('searchmode', $searchmode, 'both', _OOBJ_DTYPE_CLEAN);
$page = 0;
get_var ('offset', $page, 'both', _OOBJ_DTYPE_CLEAN);
$adv = 0;
get_var ('adv', $adv, 'both', _OOBJ_DTYPE_INT);
$sortbysel = '';
get_var ('sortbysel', $sortbysel, 'both', _OOBJ_DTYPE_CLEAN);
$sortorder = 'desc';
get_var ('sortorder', $sortorder, 'both', _OOBJ_DTYPE_CLEAN);
$term = '';
get_var ('term', $term, 'both');
$addterms = 'any';
get_var ('addterms', $addterms, 'both', _OOBJ_DTYPE_CLEAN);
$username = '';
get_var ('username', $username, 'both', _OOBJ_DTYPE_CLEAN);
$forum = -1;
get_var ('forum', $forum, 'both', _OOBJ_DTYPE_INT);
$term = $opnConfig['cleantext']->filter_searchtext ($term);
$sortby = '';
switch ($sortbysel) {
	case 'date':
	case '':
		$sortby = 'p.post_time';
		$sortbysel = 'date';
		break;
	case 'topic':
		$sortby = 't.topic_title';
		break;
	case 'post':
		$sortby = 'p.post_subject';
		break;
	case 'forum':
		$sortby = 'f.forum_name';
		break;
	case 'user':
		$sortby = 'u.uname';
		break;
}
switch ($sortorder) {
	case 'asc':
		$sortby .= ' asc';
		break;
	case 'desc':
		$sortby .= ' desc';
		break;
}
$pagesize = 20;
$offset = $page;
// This is WHERE we start our record set from
$nav = '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/forum/index.php">' . $opnConfig['sitename'] . '&nbsp;' . _FORUM_INDEX . '</a><br />';
$boxtxt = $nav;
$result = $opnConfig['database']->Execute ('SELECT forum_id FROM ' . $opnTables['forum']);
$maxrows = 0;
switch ($searchmode) {
	case 'egosearch':
		$username = $ui['uname'];
		$result = ego_search ($eh, $pagesize, $offset, $username, $maxrows);
		break;
	case 'newposts':
		$result = lastnewpostpost_search (_FORUM_SEARCH_TYPE_NEW, $ui, $eh, $pagesize, $offset, $maxrows);
		break;
	case 'lastposts':
		$result = lastnewpostpost_search (_FORUM_SEARCH_TYPE_LAST, $ui, $eh, $pagesize, $offset, $maxrows);
		break;
	case 'unanswered':
		$result = unansweredpost_search ($eh, $pagesize, $offset, $maxrows);
		break;
	default:
		$result = normal_search ($eh, $pagesize, $offset, $sortbysel, $sortorder, $sortby, $term, $addterms, $username, $forum, $boxtxt, $maxrows);
		break;
}

/* switch */

if (($searchmode == 'newposts') || ($searchmode == 'lastposts') || ($searchmode == 'unanswered')) {
	$boxtxt .= '<br />';
	display_thread ($result, $maxrows, $pagesize, $page, $sortbysel, $sortorder, $term, $addterms, $forum, $username, $searchmode, $boxtxt);
	$boxtxt .= '<br />';
	$boxtxt .= $nav;
} else {
	if ($result !== false) {
		$nrows = $result->RecordCount ();
		$row = $result->GetRowAssoc ('0');
	} else {
		$row['uid'] = '';
		$nrows = 0;
	}
	if ($row['uid'] == '') {
		if ($adv != 1) {
			$boxtxt .= '<div class="centertag">' . _FORUM_NOMATCH . '</div>';
		}
	}
	$boxtxt .= '<br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('25%', '40%', '20%', '15%') );
	$table->AddHeaderRow (array (_FORUM_FORUM, _FORUM_TOPIC, _FORUM_AUTHOR, _FORUM_POSTEDON) );
	$temp = '';
	if ($result !== false) {
		while (! $result->EOF) {
			$row = $result->GetRowAssoc ('0');
			$opnConfig['opndate']->sqlToopnData ($row['post_time']);
			$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
			$topic_title = $row['topic_title'];
			if ($topic_title == '') {
				$topic_title = _FORUM_NO_TITLE;
			}
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewforum.php',
												'forum' => $row['forum_id']) ) . '">' . stripslashes ($row['forum_name']) . '</a>',
												'center');
			if ($term != '') {
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
													'topic' => $row['topic_id'],
													'forum' => $row['forum_id'],
													'highlight' => $term) ) . '">' . stripslashes ($topic_title) . '</a>',
													'center');
			} else {
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
													'topic' => $row['topic_id'],
													'forum' => $row['forum_id']) ) . '">' . stripslashes ($topic_title) . '</a>',
													'center');
			}
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
												'op' => 'userinfo',
												'uname' => $row['uname']) ) . '">' . api_user_name ($row['uname']) . '</a>',
												'center');
			$table->AddDataCol ($temp, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$boxtxt .= $nav;
	if ($nrows>0) {
		include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
		$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/system/forum/searchbb.php',
						'sortbysel' => $sortbysel,
						'sortorder' => $sortorder,
						'term' => $term,
						'addterms' => $addterms,
						'forum' => $forum,
						'username' => $username,
						'searchmode' => $searchmode),
						$maxrows,
						$pagesize,
						$page);
	}
}
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_FORUM_660_';
$_display_dat['module'] = 'system/forum';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayContent (_FORUM_SEARCH, $boxtxt);

?>