<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/sections/plugin/sidebox/section/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');

function section_get_data ($result, &$data) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new CatFunctions ('sections');
	$mf->itemtable = $opnTables['seccont'];
	$mf->itemid = 'artid';
	$mf->itemlink = 'secid';
	$mf->itemwhere = '(seccont_usergroup IN (' . $checkerlist . '))';
	if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
		$mf->itemwhere .= " AND ((theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (theme_group=0))";
	}
	$i = 0;
	while (! $result->EOF) {
		$secid = $result->fields['cat_id'];
		$secname = $result->fields['cat_name'];
		$opnConfig['cleantext']->opn_shortentext ($secname, 19);
		$data[$i]['link'] = '<a class="opnsidebox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/sections/index.php',
											'secid' => $secid) ) . '">' . $secname . '</a>';
		$childs = $mf->getChildTreeArray ($secid);
		$arr = array ();
		$max = count ($childs);
		for ($j = 0; $j< $max; $j++) {
			$arr[] = '<a class="opnsidebox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/sections/index.php',
										'secid' => $childs[$j][2]) ) . '">' . $childs[$j][1] . '</a>';
		}
		$data[$i]['childs'] = $arr;
		unset ($arr);
		$i++;
		$result->MoveNext ();
	}
	unset ($mf);

}

function section_get_sidebox_result (&$box_array_dat) {

	global $opnConfig, $opnTables;

	$boxstuff = $box_array_dat['box_options']['textbefore'];
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$query = 'SELECT cat_id, cat_name FROM ' . $opnTables['sections_cats'];
	$query .= ' WHERE (cat_usergroup IN (' . $checkerlist . '))';
	if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
		$query .= " AND ((cat_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (cat_theme_group=0))";
	}
	$query .= ' AND (cat_pid=0) ORDER BY cat_pos';
	$result = &$opnConfig['database']->Execute ($query);
	if ($result !== false) {
		$data = array ();
		section_get_data ($result, $data);
		if ($box_array_dat['box_options']['use_tpl'] == '') {
			$boxstuff .= '<div class="sideboxsmalltext">';
			$boxstuff .= '<ul>';
			foreach ($data as $val) {
				$boxstuff .= '<li>' . $val['link'] . '</li>' . _OPN_HTML_NL;
				$childs = $val['childs'];
				$max = count ($childs);
				for ($i = 0; $i< $max; $i++) {
					$boxstuff .= '<li>' . $childs[$i] . '</li>' . _OPN_HTML_NL;
				}
			}
			unset ($childs);
			$boxstuff .= '</ul>';
			$boxstuff .= '</div>';
		} else {
			$pos = 0;
			$dcol1 = '2';
			$dcol2 = '1';
			$a = 0;
			$opnliste = array ();
			foreach ($data as $val) {
				$dcolor = ($a == 0? $dcol1 : $dcol2);
				$opnliste[$pos]['topic'] = $val['link'];
				$opnliste[$pos]['case'] = 'nosubtopic';
				$opnliste[$pos]['alternator'] = $dcolor;
				$opnliste[$pos]['image'] = '';
				$opnliste[$pos]['subtopic'][0] = '';
				$pos++;
				$a = ($dcolor == $dcol1?1 : 0);
				$childs = $val['childs'];
				$max = count ($childs);
				for ($i = 0; $i< $max; $i++) {
					$dcolor = ($a == 0? $dcol1 : $dcol2);
					$opnliste[$pos]['topic'] = $childs[$i];
					$opnliste[$pos]['case'] = 'nosubtopic';
					$opnliste[$pos]['alternator'] = $dcolor;
					$opnliste[$pos]['image'] = '';
					$opnliste[$pos]['subtopic'][0] = '';
					$pos++;
					$a = ($dcolor == $dcol1?1 : 0);
				}
				unset ($childs);
			}
			get_box_template ($box_array_dat, array ('subtopic',
								'nosubtopic'),
								$opnliste,
								0,
								0,
								$boxstuff);
		}
		unset ($data);
		$result->Close ();
	}
	$boxstuff .= '<br /><br /><div class="alternatorhead">&gt; ';
	$boxstuff .= '<a class="alternatorhead" href="' . $opnConfig['opn_url'] . '/system/sections/index.php">';
	$boxstuff .= _SEC_SID_INDEX . '</a> &lt;</div>' . _OPN_HTML_NL;
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['skip'] = false;
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

?>