<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function statistics_every_header () {

	global $opnConfig, $opnTables;

	/* Get the Browser data */
	if (!$opnConfig['stats_stop']) {
		$ip = get_real_IP ();
		// get remote IP
		if ($opnConfig['opnOption']['user_login']) {
			$userinfo = $opnConfig['permission']->GetUserinfo ();
			$uname = $userinfo['uname'];
		} else {
			$uname = '';
		}
		$hf_exclude = 0;
		$PATH_INFO = getenv ('PATH_INFO');
		if ($PATH_INFO != '') {
			$QUERY_STRING = '';
			get_var ('QUERY_STRING', $QUERY_STRING, 'server');
			if ($QUERY_STRING != '') {
				$requri = $PATH_INFO . "?" . $QUERY_STRING;
			} else {
				$requri = $PATH_INFO;
			}
		} else {
			$requri = '';
			get_var ('REQUEST_URI', $requri, 'server');
		}
		// check for excludes
		foreach ($opnConfig['stats_ip'] as $value) {
			if ($value != '') {
				if ($ip == $value) {
					$hf_exclude = 1;
				}
			}
		}
		foreach ($opnConfig['stats_user'] as $value) {
			if ($value != '') {
				if ($uname == $value) {
					$hf_exclude = 1;
				}
			}
		}
		foreach ($opnConfig['stats_url'] as $value) {
			if ($value != '') {
				if (stristr ($requri, $value) ) {
					$hf_exclude = 1;
				}
			}
		}
		if (!$hf_exclude) {
			if ($opnConfig['opnOption']['client']) {
				$platform = $opnConfig['opnOption']['client']->property ('platform');
				$os = $platform . ' ' . $opnConfig['opnOption']['client']->property ('os');
				$browser = $opnConfig['opnOption']['client']->property ('long_name');
				$browser_detail = $browser . ' ' . $opnConfig['opnOption']['client']->property ('version');
				$browser_language = $opnConfig['opnOption']['client']->property ('language');

				/* Save on the databases the obtained values */

				$_os = $opnConfig['opnSQL']->qstr ($os);
				$_platform = $opnConfig['opnSQL']->qstr ($platform);
				$_browser = $opnConfig['opnSQL']->qstr ($browser);
				$_browser_language = $opnConfig['opnSQL']->qstr ($browser_language);
				$_browser_detail = $opnConfig['opnSQL']->qstr ($browser_detail);
				$sqlSelect = 'SELECT wcount FROM ' . $opnTables['counter'] . " WHERE stat_platform=$_platform AND stat_os=$_os AND stat_browser=$_browser AND stat_browser_detail=$_browser_detail AND stat_browser_language=$_browser_language";
				$sqlUpdate = 'UPDATE ' . $opnTables['counter'] . " SET wcount=wcount+1 WHERE (stat_platform=$_platform AND stat_os=$_os AND stat_browser=$_browser AND stat_browser_detail=$_browser_detail AND stat_browser_language=$_browser_language)";
				$sqlInsert = 'INSERT INTO ' . $opnTables['counter'] . " VALUES ($_platform,$_os, $_browser, $_browser_detail, $_browser_language, 1)";
				$opnConfig['opnSQL']->ensure_dbwrite ($sqlSelect, $sqlUpdate, $sqlInsert);
				if ($opnConfig['stats_datestats']) {
					$datearr = explode ('-', date ('Y-m-d-w-G') );
					$stat_year = $datearr[0];
					$stat_month = $datearr[1];
					$stat_day = $datearr[2];
					$stat_dayofweek = $datearr[3];
					$stat_hour = $datearr[4];
					$stat_weekno = ISOWeek ($stat_year, $stat_month, $stat_day);
					$sqlSelect = 'SELECT stat_year FROM ' . $opnTables['counter_by_date'] . " WHERE stat_year=$stat_year and stat_month=$stat_month AND stat_day=$stat_day " . "AND stat_dayofweek=$stat_dayofweek AND stat_hour=$stat_hour AND stat_weekno=$stat_weekno";
					$sqlUpdate = 'UPDATE ' . $opnTables['counter_by_date'] . " SET wcount=wcount+1 WHERE (stat_year=$stat_year and stat_month=$stat_month AND stat_day=$stat_day " . "AND stat_dayofweek=$stat_dayofweek AND stat_hour=$stat_hour AND stat_weekno=$stat_weekno)";
					$sqlInsert = 'INSERT INTO ' . $opnTables['counter_by_date'] . " VALUES ($stat_year,$stat_month,$stat_day, " . "$stat_dayofweek, $stat_hour, $stat_weekno," . " 1)";
					$opnConfig['opnSQL']->ensure_dbwrite ($sqlSelect, $sqlUpdate, $sqlInsert);
				}
			}
		}
	}

}

function ISOWeek ($y, $m, $d) {

	$week = strftime ('%W', mktime (0, 0, 0, $m, $d, $y) );
	$dow0101 = getdate (mktime (0, 0, 0, 1, 1, $y) );
	$next0101 = getdate (mktime (0, 0, 0, 1, 1, $y+1) );
	if ($dow0101['wday']>1 && $dow0101['wday']<5) {
		$week++;
	}
	if ($next0101['wday']>1 && $next0101['wday']<5 && $week == 53) {
		$week = 1;
	}
	if ($week == 0) {
		$week = ISOWeek ($y-1, 12, 31);
	}
	return (substr ('00' . $week, -2) );

}

function statistics_every_header_box_pos () {
	return 0;

}

?>