<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* now some new features
*/

function getStatInfos (&$data) {

	global $opnConfig;

	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'stats');
	foreach ($plug as $var) {
		include_once (_OPN_ROOT_PATH . $var['plugin'] . '/plugin/stats/stats.php');
		$myfunc = $var['module'] . '_get_stat';
		if (function_exists ($myfunc) ) {
			$myfunc ($data);
		}
	}

}

function mk_percbar ($myperc, $mycolor, $tbheight = 10, $tbwidth = '100%') {

	$rmyperc = round ($myperc, 0);
	// $mycolor1=($mycolor=='alternator2'? 'alternator4' : 'alternator3');
	$boxtxt = '<table  width="' . $tbwidth . '" style="height:' . $tbheight . 'px" border="0" cellspacing="0" cellpadding="0">' . _OPN_HTML_NL;
	if ($myperc >= 100) {
		$boxtxt .= '<tr class="' . $mycolor . '"><td width="100%" class="' . $mycolor . 'bg">';
	} elseif ($myperc<=0) {
		$boxtxt .= '<tr><td width="100%"><span class="smalltext">&nbsp;</span>';
	} else {
		$boxtxt .= '<tr class="' . $mycolor . '">' . '<td width="' . $rmyperc . '%" class="' . $mycolor . 'bg">' . '</td><td width="' . (100- $rmyperc) . '%">';
	}
	$boxtxt .= '</td></tr></table>';
	return $boxtxt;

}

function create_dayofweeknamearr () {

	global $opnConfig;

	$myarr = array ();
	for ($i = 0; $i<7; $i++) {
		$opnConfig['opndate']->getWeekdayFullnameod ($myarr[$i], $i);
	}
	return $myarr;

}

function create_daynamearr () {

	$myarr = array ();
	for ($i = 1; $i<=31; $i++) {
		$myarr[$i] = $i . '.';
	}
	return $myarr;

}

function create_monthnamearr () {

	global $opnConfig;

	$myarr = array ();
	for ($i = 1; $i<13; $i++) {
		$opnConfig['opndate']->getMonthFullnameod ($myarr[$i], $i);
	}
	return $myarr;

}

function create_hournamearr () {

	for ($i = 0; $i<24; $i++) {
		$myarr[$i] = $i . ':00 - ' . $i . ':59 ' . _STATS_ACLOCK;
	}
	return $myarr;

}

function create_weeknonamearr () {

	for ($i = 1; $i<=54; $i++) {
		$myarr[$i] = _STATS_WEEKNONAME . ' ' . $i;
	}
	return $myarr;

}

function count_total () {

	global $opnConfig, $opnTables, $wheretec, $wherevalue;
	if ($wheretec) {
		$where = ' WHERE ' . $wheretec . "'" . $wherevalue . "' ";
	} else {
		$where = '';
	}
	if ( (!isset ($opnConfig['opnOption']['stats_total']) ) OR (!$opnConfig['opnOption']['stats_total']) ) {
		$result_total_count = &$opnConfig['database']->Execute ('SELECT SUM(wcount) as summe FROM ' . $opnTables['counter'] . $where);
		if ( ($result_total_count !== false) && (isset ($result_total_count->fields['summe']) ) ) {
			$opnConfig['opnOption']['stats_total'] = $result_total_count->fields['summe'];
		} else {
			$opnConfig['opnOption']['stats_total'] = 0;
		}
	}

}

function count_total_date ($wherepart) {

	global $opnConfig, $opnTables;
	if ($wherepart) {
		$where = ' WHERE ' . $wherepart;
	} else {
		$where = '';
	}
	$result_total_count = &$opnConfig['database']->Execute ('SELECT SUM(wcount) as summe FROM ' . $opnTables['counter_by_date'] . $where);
	if ( ($result_total_count !== false) && (isset ($result_total_count->fields['summe']) ) ) {
		$opnConfig['opnOption']['stats_total_date'] = $result_total_count->fields['summe'];
	} else {
		$opnConfig['opnOption']['stats_total_date'] = 0;
	}

}

function count_show_as_tablebar ($mytitle, $myarr, $center = false) {

	global $opnConfig;

	$boxtxt = '<table class="alternatortable" border="0" cellspacing="0" cellpadding="0">';
	if ($center) {
		$boxtxt .= '<tr class="alternatorhead">';
	} else {
		$boxtxt .= '<tr class="alternatorhead">';
	}
	$boxtxt .= '<th class="alternatorhead" colspan="4">' . $mytitle . '</th>' . _OPN_HTML_NL;
	$boxtxt .= '</tr>';
	$i = 0;
	if (is_array ($myarr) ) {
		foreach ($myarr as $obj) {
			if (isset ($obj['label']) ) {
				$what = $obj['label'];
			} else {
				$what = '';
			}
			if (isset ($obj['count']) ) {
				$count = $obj['count'];
			} else {
				$count = '';
			}
			if (isset ($obj['percent']) ) {
				$percent = $obj['percent'];
			} else {
				$percent = '';
			}

			# 			if (isset($obj['where'])) {

			# 				$where = $obj['where'];

			# 			}else {

			# 				$where = '';

			# 			}

			# 			if (isset($obj['value'])) {

			# 				$value = $obj['value'];

			# 			}else {

			# 				$value = '';

			# 			}

			# 			if (isset($obj['narrowresulttext'])) {

			# 				$narrowresulttext = $obj['narrowresulttext'];

			# 			}else {

			# 				$narrowresulttext = '';

			# 			}
			if (isset ($obj['url']) ) {
				$url = $obj['url'];
			} else {
				$url = '';
			}
			$mycolor = ($i == 0?'alternator2' : 'alternator1');
			if ($count) {
				if ($percent<0) {
					$width = '60%';
					$width1 = '40%';
					$align = '';
				} else {
					$width = '20%';
					$width1 = '10%';
					$align = 'align="right"';
				}
				$boxtxt .= '<tr class="' . $mycolor . '"><td width="' . $width . '" class="' . $mycolor . '">';
				if ($url != '') {
					$url[0] = $opnConfig['opn_url'] . '/system/statistics/index.php';
					$boxtxt .= '<a class="' . $mycolor . '" href="' . encodeurl ($url) . '">';
				}
				$boxtxt .= $what;
				if ($url != '') {
					$boxtxt .= '</a>';
				}
				$boxtxt .= '</td><td class="' . $mycolor . '" width="' . $width1 . '" ' . $align . '>';
				if ($count == '' . _STATS_HITS . '') {
					$boxtxt .= $count;
				} else {
					$boxtxt .= number_format ($count, 0, _STATS_DEC_POINT, _STATS_THOUSANDS_SEP);
				}
				$boxtxt .= '</td>';
				if ($percent >= 0) {
					$boxtxt .= '<td class="' . $mycolor . '" width="10%" align="right">';
					$boxtxt .= number_format ($percent, 2, _STATS_DEC_POINT, _STATS_THOUSANDS_SEP) . ' %';
					$boxtxt .= '</td><td class="' . $mycolor . '" width="60%">' . mk_percbar ($percent, $mycolor) . '</td>';
				}
				$boxtxt .= '</tr>';
				$i = ($mycolor == 'alternator2'?1 : 0);
			}
		}
	}
	$boxtxt .= '</table>' . _OPN_HTML_NL;
	return $boxtxt;

}

function count_show ($mytitle, $myarr, $center = false) {

	$boxtxt = count_show_as_tablebar ($mytitle, $myarr, $center);
	return $boxtxt;

}

function count_createarr ($myfield, $mytitle) {

	global $opnConfig, $opnTables, $wheretec, $wherevalue;

	$myarr = array ();
	if ($wheretec) {
		$where = ' WHERE ' . $wheretec . "'" . $wherevalue . "' ";
	} else {
		$where = '';
	}
	$sql = 'SELECT ' . $myfield . ', SUM(wcount) as summe FROM ' . $opnTables['counter'] . $where . ' GROUP BY ' . $myfield . ' ORDER BY ' . $myfield . ' asc';
	$result_count = &$opnConfig['database']->Execute ($sql);
	if ($result_count !== false) {
		$i = 1;
		while (! $result_count->EOF) {
			$myarr[$i]['label'] = $result_count->fields[$myfield];
			if (isset ($result_count->fields['summe']) ) {
				$myarr[$i]['count'] = $result_count->fields['summe'];
			} else {
				$myarr[$i]['count'] = 0;
			}
			$myarr[$i]['percent'] = ($opnConfig['opnOption']['stats_total'] <> 0?round ( ( (100* $myarr[$i]['count'])/ $opnConfig['opnOption']['stats_total']), 2) : 0);
			$myarr[$i]['where'] = 'tec=' . $myfield . '=';
			$myarr[$i]['value'] = $result_count->fields[$myfield];
			$myarr[$i]['narrowresulttext'] = 'tec=' . $mytitle . ' = ' . $myarr[$i]['label'];
			$i++;
			$result_count->MoveNext ();
		}
	}
	return $myarr;

}

function create_placeholder ($start, $end, &$i, $textarr) {

	for ($j = $start; $j<= $end; $j++) {
		$mytemparr[$j]['label'] = $textarr[$j];
		$mytemparr[$j]['count'] = 0;
		$mytemparr[$j]['percent'] = 0.00;
		$i++;
	}
	return $mytemparr;

}

function count_createarr_withfill ($myfield, $textarr, $firstrow, $maxrows, $mytitle, $wherepart = '', $urlpart = '', $urlfield = '') {

	global $opnConfig, $opnTables;

	$myarr = array ();
	if ($wherepart) {
		$where = ' WHERE ' . $wherepart;
	} else {
		$where = '';
	}
	if (!isset ($opnConfig['opn_start_day']) ) {
		$opnConfig['opn_start_day'] = 1;
	}
	$sql = 'SELECT ' . $myfield . ', SUM(wcount) as summe FROM ' . $opnTables['counter_by_date'] . $where . ' GROUP BY ' . $myfield . ' ORDER BY ' . $myfield . ' asc';
	$result_count = &$opnConfig['database']->Execute ($sql);
	$itshouldbe = $firstrow;
	if ($result_count !== false) {
		$i = $firstrow;
		while (! $result_count->EOF) {
			$what = intval ($result_count->fields[$myfield]);
			if ($what>$itshouldbe) {
				$mytemparr = create_placeholder ($itshouldbe, $what-1, $i, $textarr);
				$myarr = $myarr+ $mytemparr;
			}
			$itshouldbe = $what+1;
			$myarr[$i]['label'] = $textarr[$what];
			if (isset ($result_count->fields['summe']) ) {
				$myarr[$i]['count'] = $result_count->fields['summe'];
			} else {
				$myarr[$i]['count'] = 0;
			}
			if ($myfield != 'stat_year') {
				$myarr[$i]['percent'] = ($opnConfig['opnOption']['stats_total_date'] <> 0?round ( ( (100* $myarr[$i]['count'])/ $opnConfig['opnOption']['stats_total_date']), 2) : 0);
			} else {
				$myarr[$i]['percent'] = ($opnConfig['opnOption']['stats_total'] <> 0?round ( ( (100* $myarr[$i]['count'])/ $opnConfig['opnOption']['stats_total']), 2) : 0);
			}
			$myarr[$i]['where'] = 'dat=' . $myfield . '=';
			$myarr[$i]['value'] = $result_count->fields[$myfield];
			if (is_array ($urlpart) ) {
				$urlpart[$urlfield] = $result_count->fields[$myfield];
				$myarr[$i]['url'] = $urlpart;
			}
			$myarr[$i]['narrowresulttext'] = 'dat=' . $mytitle . ' = ' . $textarr[$what];
			$i++;
			$result_count->MoveNext ();
		}
	}
	if ($what<$maxrows) {
		$mytemparr = create_placeholder ($what, $maxrows, $i, $textarr);
		$myarr = $myarr+ $mytemparr;
	}
	if ($myfield == 'stat_dayofweek') {
		if ($opnConfig['opn_start_day']) {
			$help = array ();
			$j = 0;
			$max = count ($myarr);
			for ($i = 1; $i< $max; $i++) {
				$help[$j] = $myarr[$i];
				$j++;
			}
			$help[$j] = $myarr[0];
			$myarr = $help;
			unset ($help);
		}
	}
	return $myarr;

}

function stats_other () {

	global $opnConfig, $opnTables;
	if ($opnConfig['stats_view_user']) {
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(u.uid) AS counter FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE (us.uid=u.uid) and (us.level1<>' . _PERM_USER_STATUS_DELETE . ')');
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			$unum = $result->fields['counter'];
		} else {
			$unum = 0;
		}
	}
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('10%', '40%', '50%') );
	if (isset ($opnConfig['opn_version']) ) {
		$table->AddDataRow (array ('<img src="' . $opnConfig['opn_url'] . '/system/statistics/images/stats/version.png" class="imgtag" alt="" />', _STATS_OPNVERISON, '<span class="normaltextbold">' . $opnConfig['opn_version'] . '</span>') );
	}
	if ($opnConfig['stats_view_user']) {
		$table->AddDataRow (array ('<img src="' . $opnConfig['opn_url'] . '/system/statistics/images/stats/users.png" class="imgtag" alt="" />', _STATS_REGUSER, '<span class="normaltextbold">' . $unum . '</span>') );
	}
	$data = array ();
	getStatInfos ($data);
	$max = count ($data);
	for ($i = 0; $i< $max; $i++) {
		$table->AddDataRow (array (str_replace ('%linkclass%', 'opncenterbox', $data[$i][0]), $data[$i][1], '<span class="normaltextbold">' . $data[$i][2] . '</span>') );
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function stats () {

	global $opnConfig;

	$boxtitle = _STATS_MISC;
	count_total ();
	$boxtxt = stats_title ();
	$help = count_show ('<a class="alternatorhead" href="' . encodeurl ($opnConfig['opn_url'] . '/system/statistics/index.php?op=osview') . '">' . _STATS_BYPLATFORM . '</a>', count_createarr ('stat_platform', _STATS_BYPLATFORM) );
	$boxtxt .= $help;
	$help = count_show ('<a class="alternatorhead" href="' . encodeurl ($opnConfig['opn_url'] . '/system/statistics/index.php?op=browserview') . '">' . _STATS_BYBROWSER . '</a>', count_createarr ('stat_browser', _STATS_BYBROWSER) );
	$boxtxt .= '' . $help;
	$boxtxt .= '<br /><br />';
	$help = stats_other ();
	$boxtxt .= $help;
	if ( ($opnConfig['permission']->HasRight ('system/statistics', _PERM_ADMIN, true) ) && ($opnConfig['advancedstats'] == 1) ) {
		include_once (_OPN_ROOT_PATH . 'system/statistics/serverinfo.php');
		$boxtxt .= STATS_ServerInfo ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_100_';
	$_display_dat['module'] = 'system/statistics';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);

}

function statsosview () {

	global $opnConfig;

	count_total ();
	$boxtitle = _STATS_DESC . '&nbsp;' . _STATS_BYPLATFORM;
	$boxtxt = stats_title (false, true);
	$help = count_show (_STATS_BYOS, count_createarr ('stat_os', _STATS_BYOS) );
	$boxtxt .= '<br />' . $help;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_110_';
	$_display_dat['module'] = 'system/statistics';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);

}

function statsbrowserview () {

	global $opnConfig;

	count_total ();
	$boxtitle = _STATS_DESC . '&nbsp;' . _STATS_BYBROWSER;
	$boxtxt = stats_title (false, true);
	$help = count_show (_STATS_BYBROWSERDETAIL, count_createarr ('stat_browser_detail', _STATS_BYBROWSERDETAIL) );
	$boxtxt .= '<br />' . $help;
	$help = count_show (_STATS_BYBROWSERLANGUAGE, count_createarr ('stat_browser_language', _STATS_BYBROWSERLANGUAGE) );
	$boxtxt .= '<br />' . $help;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_120_';
	$_display_dat['module'] = 'system/statistics';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);

}

function showWeekdayMonth () {

	global $date;

	$where = 'stat_year = ' . $date['year'] . ' and stat_month=' . $date['month'] . ' and stat_dayofweek=' . $date['weekday'];
	count_total_date ($where);
	$title = sprintf (_STATS_DAILY, $date['monthname'] . ' ' . $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_day', create_daynamearr (), 1, 31, $title, $where, array ('op' => 'day',
																'year' => $date['year'],
																'month' => $date['month']),
																'day') );
	$boxtxt = $help;
	return $boxtxt;

}

function showWeek () {

	global $opnConfig, $opnTables, $date;

	$where = 'stat_year = ' . $date['year'] . ' and stat_weekno=' . $date['weekno'];
	$result = $opnConfig['database']->SelectLimit ('SELECT stat_month FROM ' . $opnTables['counter_by_date'] . ' WHERE ' . $where, 1, 0);
	$month = $result->fields['stat_month'];
	$result->Close ();
	count_total_date ($where);
	$title = sprintf (_STATS_WEEKLY, _STATS_WEEKNONAME . ' ' . $date['weekno'] . ' ' . $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_day', create_daynamearr (), 1, 31, $title, $where, array ('op' => 'day',
																'year' => $date['year'],
																'month' => $month),
																'day') );
	$boxtxt = $help;
	return $boxtxt;

}

function showDay () {

	global $date;

	$where = 'stat_year = ' . $date['year'] . ' and stat_month=' . $date['month'] . ' and stat_day=' . $date['day'];
	count_total_date ($where);
	$title = sprintf (_STATS_HOOURLY, $date['formdate']);
	$help = count_show ($title, count_createarr_withfill ('stat_hour', create_hournamearr (), 0, 23, $title, $where) );
	$boxtxt = '<br />' . $help;
	return $boxtxt;

}

function showMonth () {

	global $date;

	$where = 'stat_year = ' . $date['year'] . ' and stat_month=' . $date['month'];
	count_total_date ($where);
	$title = sprintf (_STATS_DAILY, $date['monthname'] . ' ' . $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_dayofweek', create_dayofweeknamearr (), 0, 6, $title, $where, array ('op' => 'weekdaymonth',
																	'year' => $date['year'],
																	'month' => $date['month']),
																	'weekday') );
	$boxtxt = $help;
	$help = count_show ($title, count_createarr_withfill ('stat_day', create_daynamearr (), 1, 31, $title, $where, array ('op' => 'day',
																'year' => $date['year'],
																'month' => $date['month']),
																'day') );
	$boxtxt .= '<br />' . $help;
	return $boxtxt;

}

function showYear () {

	global $date;

	$where = 'stat_year = ' . $date['year'];
	count_total_date ($where);
	$title = sprintf (_STATS_MONTHLY, $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_month', create_monthnamearr (), 1, 12, $title, $where, array ('op' => 'month',
																'year' => $date['year']),
																'month') );
	$boxtxt = $help;
	$title = sprintf (_STATS_WEEKLY, $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_weekno', create_weeknonamearr (), 1, 54, $title, $where, array ('op' => 'week',
																'year' => $date['year']),
																'weekno') );
	$boxtxt .= '<br />' . $help;
	$title = sprintf (_STATS_DAILY, $date['year']);
	$help = count_show ($title, count_createarr_withfill ('stat_dayofweek', create_dayofweeknamearr (), 0, 6, $title, $where) );
	$boxtxt .= '<br />' . $help;
	return $boxtxt;

}

function statsdetails () {

	global $opnConfig, $opnTables, $date;

	count_total ();
	$where = 'stat_year = ' . $date['year'];
	count_total_date ($where);
	$boxtitle = _STATS_DETAIL;
	$boxtxt = stats_title (false, true, true);
	$result = $opnConfig['database']->SelectLimit ('SELECT stat_year FROM ' . $opnTables['counter_by_date'] . ' ORDER BY stat_year asc', 1, 0);
	$first = $result->fields['stat_year'];
	$result = $opnConfig['database']->SelectLimit ('SELECT stat_year FROM ' . $opnTables['counter_by_date'] . ' ORDER BY stat_year desc', 1, 0);
	$last = $result->fields['stat_year'];
	for ($j = $first; $j< ($last+1); $j++) {
		$years[$j] = $j;
	}
	$help = count_show (_STATS_YEARLY, count_createarr_withfill ('stat_year', $years, $first, $last, _STATS_YEARLY, '', array ('op' => 'year'),
																'year') );
	$boxtxt .= '<br />' . $help;
	$boxtxt .= '<br />' . showYear ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_STATISTICS_130_';
	$_display_dat['module'] = 'system/statistics';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);

}

function buildDate ($day, $month, $year) {
	return sprintf ('%04d', $year) . '-' . sprintf ('%02d', $month) . '-' . sprintf ('%02d', $day) . ' 00:00:00';

}

function getDetailResult ($sql, $order = '') {

	global $opnConfig;
	if (strpos ($sql, ') AS counter') === false) {
		$result = $opnConfig['database']->SelectLimit ($sql, 1, 0);
		if ($result !== false) {
			$fields = $result->GetRowAssoc ('0');
		} else {
			$fields = array ();
		}
	} else {
		$result = $opnConfig['database']->Execute ($sql);
		if ($order == 'desc') {
			$fields['counter'] = 2000000000;
		} else {
			$fields['counter'] = 0;
		}
		if ($result !== false) {
			while (! $result->EOF) {
				$fields1 = $result->GetRowAssoc ('0');
				if (!isset ($fields1['counter']) ) {
					$fields1['counter'] = 0;
				}
				if ($order == 'desc') {
					if ($fields1['counter']<$fields['counter']) {
						$fields = $fields1;
					}
				}
				if ($order == 'asc') {
					if ($fields1['counter']>$fields['counter']) {
						$fields = $fields1;
					}
				}
				$result->MoveNext ();
			}
			$result->Close ();
		} else {
			$fields['counter'] = 0;
		}
	}
	return $fields;

}

function buildArray ($title, $counter, &$i, &$myarr) {

	$myarr[$i]['label'] = $title;
	$myarr[$i]['count'] = $counter;
	$myarr[$i]['percent'] = -1;
	$myarr[$i]['value'] = $title;
	$i++;

}

function getDayHits ($title, $day, $month, $year, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT sum(wcount) AS counter  FROM ' . $opnTables['counter_by_date'] . ' WHERE stat_year=' . $year . ' and stat_month=' . $month . ' and stat_day=' . $day;
	$fields = getDetailResult ($sql);
	buildArray ($title, $fields['counter'], $i, $myarr);

}

function getMonthHits ($title, $order, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT stat_year, stat_month, sum(wcount) AS counter  FROM ' . $opnTables['counter_by_date'] . ' group by stat_month,stat_year';
	$months = create_monthnamearr ();
	$fields = getDetailResult ($sql, $order);
	if (isset ($months[$fields['stat_month']]) ) {
		buildArray (sprintf ($title, $months[$fields['stat_month']] . ' ' . $fields['stat_year']), $fields['counter'], $i, $myarr);
	}

}

function getMonthHitsTotal ($title, $order, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT stat_month, sum(wcount) AS counter  FROM ' . $opnTables['counter_by_date'] . ' group by stat_month';
	$months = create_monthnamearr ();
	$fields = getDetailResult ($sql, $order);
	if (isset ($months[$fields['stat_month']]) ) {
		buildArray (sprintf ($title, $months[$fields['stat_month']]), $fields['counter'], $i, $myarr);
	}

}

function getWeekdayHits ($title, $order, &$i, &$myarr) {

	global $opnConfig, $opnTables;

	$sql = 'SELECT stat_year, stat_month,stat_day, stat_dayofweek, sum(wcount) AS counter FROM ' . $opnTables['counter_by_date'] . ' group by stat_dayofweek,stat_day,stat_month,stat_year';
	$fields = getDetailResult ($sql, $order);
	$days = create_dayofweeknamearr ();
	$opnConfig['opndate']->setTimestamp (buildDate ($fields['stat_day'], $fields['stat_month'], $fields['stat_year']) );
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING4);
	buildArray (sprintf ($title, $days[$fields['stat_dayofweek']], $temp), $fields['counter'], $i, $myarr);

}

function getWeekdayHitsTotal ($title, $order, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT stat_dayofweek, sum(wcount) AS counter FROM ' . $opnTables['counter_by_date'] . ' group by stat_dayofweek';
	$fields = getDetailResult ($sql, $order);
	$days = create_dayofweeknamearr ();
	buildArray (sprintf ($title, $days[$fields['stat_dayofweek']]), $fields['counter'], $i, $myarr);

}

function getHourHits ($title, $order, &$i, &$myarr) {

	global $opnConfig, $opnTables;

	$sql = 'SELECT stat_year, stat_month, stat_day, stat_hour, sum(wcount) AS counter  FROM ' . $opnTables['counter_by_date'] . ' group by stat_hour,stat_day,stat_month,stat_year';
	$hours = create_hournamearr ();
	$fields = getDetailResult ($sql, $order);
	$opnConfig['opndate']->setTimestamp (buildDate ($fields['stat_day'], $fields['stat_month'], $fields['stat_year']) );
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING4);
	buildArray (sprintf ($title, $hours[$fields['stat_hour']], $temp), $fields['counter'], $i, $myarr);

}

function getHourHitsTotal ($title, $order, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT stat_hour, sum(wcount) AS counter FROM ' . $opnTables['counter_by_date'] . ' group by stat_hour';
	$hours = create_hournamearr ();
	$fields = getDetailResult ($sql, $order);
	buildArray (sprintf ($title, $hours[$fields['stat_hour']]), $fields['counter'], $i, $myarr);

}

function getWeekHits ($title, $order, &$i, &$myarr) {

	global $opnTables;

	$sql = 'SELECT stat_year, stat_weekno, sum(wcount) AS counter FROM ' . $opnTables['counter_by_date'] . ' group by stat_weekno,stat_year';
	$weeks = create_weeknonamearr ();
	$fields = getDetailResult ($sql, $order);
	if (isset ($weeks[$fields['stat_weekno']]) ) {
		buildArray (sprintf ($title, $weeks[$fields['stat_weekno']], $fields['stat_year']), $fields['counter'], $i, $myarr);
	}

}

function stats_title ($detaillink = true, $backlink = false, $showdetails = false) {

	global $opnConfig, $date;

	$hlp = '<div class="normaltext" align="center"><span class="normaltextbold">' . $opnConfig['sitename'];
	$hlp .= '&nbsp;' . _STATS_BROWSER . '</span><br /><br />' . _STATS_WERECEIVED;
	$hlp .= '&nbsp;<span class="normaltextbold">' . number_format ($opnConfig['opnOption']['stats_total'], 0, _STATS_DEC_POINT, _STATS_THOUSANDS_SEP);
	$hlp .= '</span>&nbsp;' . _STATS_PAGEVIEWS . '&nbsp;' . $opnConfig['startdate'] . '</div><br />';
	if ($showdetails) {
		$i = 0;
		$myarr = array ();
		buildArray (_STATS_DESCRIPTION, _STATS_HITS, $i, $myarr);
		getDayHits (_STAT_TODAYHITS, $date['day'], $date['month'], $date['year'], $i, $myarr);
		$yesterday = date ('Y-m-d', mktime (0, 0, 0, $date['month'], $date['day']-1, $date['year']) );
		$yesterday = explode ('-', $yesterday);
		getDayHits (_STAT_YESTERDAYHITS, $yesterday[2], $yesterday[1], $yesterday[0], $i, $myarr);
		getMonthHits (_STATS_LESSMONTH, 'desc', $i, $myarr);
		getMonthHits (_STATS_MOSTMONTH, 'asc', $i, $myarr);
		getWeekdayHits (_STATS_LESSWEEKDAY, 'desc', $i, $myarr);
		getWeekdayHits (_STATS_MOSTWEEKDAY, 'asc', $i, $myarr);
		getWeekHits (_STATS_LESSWEEK, 'desc', $i, $myarr);
		getWeekHits (_STATS_MOSTWEEK, 'asc', $i, $myarr);
		getHourHits (_STATS_LESSHOUR, 'desc', $i, $myarr);
		getHourHits (_STATS_MOSTHOUR, 'asc', $i, $myarr);
		getMonthHitsTotal (_STATS_LESSMONTH1, 'desc', $i, $myarr);
		getMonthHitsTotal (_STATS_MOSTMONTH1, 'asc', $i, $myarr);
		getWeekdayHitsTotal (_STATS_LESSWEEKDAY1, 'desc', $i, $myarr);
		getWeekdayHitsTotal (_STATS_MOSTWEEKDAY1, 'asc', $i, $myarr);
		getHourHitsTotal (_STATS_LESSHOUR1, 'desc', $i, $myarr);
		getHourHitsTotal (_STATS_MOSTHOUR1, 'asc', $i, $myarr);
		$help = count_show (sprintf (_STATS_TODAYIS, $date['formdate']), $myarr, true);
		$hlp .= '<br />' . $help;
	}
	if ($detaillink) {
		if ($opnConfig['stats_datestats']) {
			$hlp .= '<br /><div class="centertag"><a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/statistics/index.php?op=detail') . '">' . _STATS_DETAILSTATS . '</a></div>';
		}
	}
	if ($backlink) {
		$hlp .= '<br /><div class="centertag"><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/statistics/index.php">' . _STATS_RETURNBASICSTATS . '</a></div>';
	}
	return $hlp;

}

?>