<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');

function theme_group_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;
	if ( (isset ($opnConfig['user_home_allowethemegroupchangebyuser']) ) && ($opnConfig['user_home_allowethemegroupchangebyuser'] == 1) ) {
		$user_theme_group = '';
		$result = &$opnConfig['database']->SelectLimit ('SELECT user_theme_group FROM ' . $opnTables['user_theme_group'] . ' WHERE uid=' . $usernr, 1);
		if ($result !== false) {
			if ($result->RecordCount () == 1) {
				$user_theme_group = $result->fields['user_theme_group'];
			}
			$result->Close ();
		}
		unset ($result);
		if ($user_theme_group == '') {
			$user_theme_group = $opnConfig['opn_startthemegroup'];
		}
		getLanguageDef (_OPN_ROOT_PATH . 'system/theme_group/plugin/user/language/');
		$opnConfig['opnOption']['form']->AddOpenHeadRow ();
		$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
		$opnConfig['opnOption']['form']->AddCloseRow ();
		$opnConfig['opnOption']['form']->ResetAlternate ();
		$opnConfig['opnOption']['form']->AddOpenRow ();
		$opnConfig['opnOption']['form']->AddLabel ('user_theme_group', _THEME_GROUP_THEME_GROUP . ' <span class="alerttextcolor">' . _THEME_GROUP_OPTIONAL . '</span>');
		$options = array ();
		$options[_SEARCH_ALL] = 0;
		$result = &$opnConfig['database']->Execute ('SELECT theme_group_id, theme_group_text FROM ' . $opnTables['opn_theme_group'] . ' ORDER BY theme_group_pos');
		while (! $result->EOF) {
			$theme_group_id = $result->fields['theme_group_id'];
			$theme_group_text = $result->fields['theme_group_text'];
			$options[$theme_group_id] = $theme_group_text;
			$result->MoveNext ();
		}
		$opnConfig['opnOption']['form']->AddSelect ('user_theme_group', $options, $user_theme_group);
		unset ($options);
		$opnConfig['opnOption']['form']->AddCloseRow ();
	}

}

function theme_group_getvar_the_user_addon_info (&$result) {

	$result['tags'] = 'user_theme_group,';

}

function theme_group_getdata_the_user_addon_info ($usernr, &$result) {

	global $opnConfig, $opnTables;

	$user_theme_group = '';
	$result1 = &$opnConfig['database']->SelectLimit ('SELECT user_theme_group FROM ' . $opnTables['user_theme_group'] . ' WHERE uid=' . $usernr, 1);
	if ($result1 !== false) {
		if ($result1->RecordCount () == 1) {
			$user_theme_group = $result1->fields['user_theme_group'];
		}
		$result1->Close ();
	}
	unset ($result1);
	if ($user_theme_group == '') {
		$user_theme_group = $opnConfig['opn_startthemegroup'];
	}
	$result['tags'] = array ('user_theme_group' => $user_theme_group);

}

function theme_group_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_theme_group = '';
	get_var ('user_theme_group', $user_theme_group, 'form', _OOBJ_DTYPE_CLEAN);
	if ( (isset ($opnConfig['user_home_allowethemegroupchangebyuser']) ) && ($opnConfig['user_home_allowethemegroupchangebyuser'] == 0) ) {
		$user_theme_group = $opnConfig['opn_startthemegroup'];
	}
	$_user_theme_group = $opnConfig['opnSQL']->qstr ($user_theme_group);
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_theme_group FROM ' . $opnTables['user_theme_group'] . " WHERE uid=$usernr", 1);
	if ($query->RecordCount () == 1) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_theme_group'] . " set user_theme_group=$_user_theme_group WHERE uid=$usernr");
	} else {
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_theme_group'] . ' (uid,user_theme_group)' . " values ($usernr,$_user_theme_group)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			die ($opnConfig['database']->ErrorMsg () . ' : Could not register new user into ' . $opnTables['user_theme_group'] . " table. $usernr, $user_theme_group");
		}
	}
	$query->Close ();
	unset ($query);

}

function theme_group_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_theme_group = '';
	get_var ('user_theme_group', $user_theme_group, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_theme_group', $user_theme_group);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function theme_group_deletehard_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_theme_group'] . ' WHERE uid=' . $usernr);

}

function theme_group_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			theme_group_get_the_user_addon_info ($uid);
			break;
		case 'save':
			theme_group_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			theme_group_confirm_the_user_addon_info ();
			break;
		case 'getvar':
			theme_group_getvar_the_user_addon_info ($option['data']);
			break;
		case 'getdata':
			theme_group_getdata_the_user_addon_info ($uid, $option['data']);
			break;
		case 'deletehard':
			theme_group_deletehard_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>