<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/user/plugin/search/language/');

function buildwhere ($query) {

	global $opnConfig;

	$hlp = ' WHERE (us.level1<>0)';
	if ($query != '') {
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug,
									'userindex');
		$like_search = $opnConfig['opnSQL']->AddLike ($query);
		$hlp .= " AND ((u.uname LIKE $like_search)";
		if ($opnConfig['permission']->IsWebmaster () ) {
			$hlp .= 'or ' . $opnConfig['opn_searching_class']->MakeGlobalSearchSql ('u.email', $query);
		}
		foreach ($plug as $var) {
			$myfunc = $var['module'] . '_user_dat_api';
			if (function_exists ($myfunc) ) {
				$option = array ();
				$option['op'] = 'get_search';
				$option['uid'] = 1;
				$option['data'] = '';
				$option['content'] = '';
				$option['search'] = $query;
				$myfunc ($option);
				$sql_search = $option['data'];
				if ($sql_search != '') {
					$hlp .= ' OR ' . $sql_search;
				}
			}
		}
		$hlp .= ')';
	}
	return $hlp;

}

function buildtables ($query) {

	global $opnConfig, $opnTables;

	$hlp = ' FROM ' . $opnTables['users'] . ' u left join ' . $opnTables['users_status'] . ' us on us.uid=u.uid';
	if ($query != '') {
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug,
									'userindex');
		foreach ($plug as $var) {
			$searchPath = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/user';
			getLanguageDef ($searchPath . '/' . 'language/');
			include_once ($searchPath . '/index.php');
			$myFunc = $var['module'] . '_get_tables';
			if (function_exists ($myFunc) ) {
				$hlp .= $myFunc ();
			}
		}
	}
	return $hlp;

}

function user_what_search () {

	$type[] = _USER_SEARCH_USER;
	return $type;

}

function user_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'user';
	$button['sel'] = 0;
	$button['label'] = _USER_SEARCH_USER;
	$buttons[] = $button;
	unset ($button);

}

function user_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'user':
			user_retrieve_all ($query, $data, $sap);
		}
	}

	function user_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = user_get_query ($query);
		$q .= user_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		if ($result !== false) {
			$nrows = $result->RecordCount ();
		} else {
			$nrows = 0;
		}
		$hlp1 = array ();
		if ($result !== false) {
			if ($nrows>0) {
				$hlp1['data'] = _USER_SEARCH_USER;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$uname = $result->fields['uname'];
					$hlp1['data'] = user_build_link ($uname);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function user_get_query ($query) {

		$q = 'SELECT uname';
		$q .= buildtables ($query);
		$q .= buildwhere ($query);
		return $q;

}

function user_get_orderby () {
	return ' ORDER BY uname';

}

function user_build_link ($uname) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
				'op' => 'userinfo',
				'uname' => $uname) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . $uname . '</a>';
	return $hlp;

}

?>