<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function user_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_uname = '';
	$user_regdate = '0';
	if ($usernr >= 1) {
		$result = &$opnConfig['database']->SelectLimit ('SELECT uname, user_regdate FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr, 1);
		if ($result !== false) {
			if ($result->RecordCount () == 1) {
				$user_uname = $result->fields['uname'];
				$user_regdate = $result->fields['user_regdate'];
				$opnConfig['opndate']->sqlToopnData ($user_regdate);
				$opnConfig['opndate']->formatTimestamp ($user_regdate, _DATE_DATESTRING4);
			}
			$result->Close ();
		}
		unset ($result);
	}
	getLanguageDef (_OPN_ROOT_PATH . 'system/user/plugin/user/language/');
	$opnConfig['opnOption']['form']->AddOpenHeadRow ();
	$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->ResetAlternate ();
	$opnConfig['opnOption']['form']->AddOpenRow ();
	if ($user_uname != '') {
		$opnConfig['opnOption']['form']->AddCheckField ('uname', 'e', _UAD_INC_ERR_INVALIDNICK);
		$opnConfig['opnOption']['form']->AddCheckField ('uname', 'l', _UAD_INC_ERR_INVALIDNICKLONG, '', 60);
		$opnConfig['opnOption']['form']->AddCheckField ('uname', 'r-', _UAD_INC_ERR_NAMERESERVED, '/^((root)|(adm)|(linux)|(webmaster)|(admin)|(god)|(administrator)|(administrador)|(nobody)|(anonymous)|(anonimo)|(annimo)|(operator))$/i');
		$strict = '^ a-zA-Z0-9_';
		$medium = $strict . '<>,.$%#@!\\';
		$medium = $medium . '\'\"';
		$loose = $medium . "?{}\[\]\(\)\^&*`~;:\\\+=";
		switch ($opnConfig['opn_uname_test_level']) {
			case 0:
				$restriction = $strict;
				break;
			case 1:
				$restriction = $medium;
				break;
			case 2:
				$restriction = $loose;
				break;
		}
		$restriction = $loose;
		$restriction = '/[' . $restriction . '-]/';
		$opnConfig['opnOption']['form']->AddCheckField ('uname', 'r-', _UAD_INC_ERR_INVALIDNICK, $restriction);
		if (!$opnConfig['opn_uname_allow_spaces']) {
			$opnConfig['opnOption']['form']->AddCheckField ('uname', 'b', _UAD_INC_ERR_NAMESPACES);
		}
		$opnConfig['opnOption']['form']->AddLabel ('user_uname', _UAD_NICK);
		$opnConfig['opnOption']['form']->AddTextfield ('user_uname', 30, 60, $user_uname);
		$opnConfig['opnOption']['form']->AddChangeRow ();
		$opnConfig['opnOption']['form']->AddText (_UAD_JOINED);
		$opnConfig['opnOption']['form']->AddText ($user_regdate);
	} else {
		$opnConfig['opnOption']['form']->AddText ('&nbsp;');
		$opnConfig['opnOption']['form']->AddHidden ('user_uname', '');
	}
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_uname = '';
	get_var ('user_uname', $user_uname, 'form', _OOBJ_DTYPE_CLEAN);
	$old_uname = '';
	get_var ('uname', $old_uname, 'form', _OOBJ_DTYPE_CLEAN);
	if ( ($user_uname != '') && ($user_uname != $old_uname) ) {
		$plug = array ();
		$opnConfig['installedPlugins']->getplugin ($plug,
									'repair');
		if ( (isset ($plug) ) && (is_array ($plug) ) ) {
			foreach ($plug as $var) {
				$file = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/repair/userrename.php';
				if (file_exists ($file) ) {
					include_once ($file);
					$myfunc = $var['module'] . '_rename_user';
					if (function_exists ($myfunc) ) {
						$myfunc ($user_uname, $old_uname);
					}
				}
			}
		}
		$query = &$opnConfig['database']->SelectLimit ('SELECT uname FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr, 1);
		if ($query->RecordCount () == 1) {
			$_user_uname = $opnConfig['opnSQL']->qstr ($user_uname);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . " SET uname=$_user_uname WHERE uid=" . $usernr);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_user_dat'] . " SET user_name=$_user_uname WHERE user_uid=" . $usernr);
			$query->Close ();
		}
		unset ($query);
	}

}

function user_show_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	getLanguageDef (_OPN_ROOT_PATH . 'system/user/plugin/user/language/');
	$query = &$opnConfig['database']->Execute ('SELECT user_regdate FROM ' . $opnTables['users'] . ' WHERE uid=' . $usernr);
	if (is_object ($query) ) {
		$user_regdate = $query->fields['user_regdate'];
		$opnConfig['opndate']->sqlToopnData ($user_regdate);
		$opnConfig['opndate']->formatTimestamp ($user_regdate, _DATE_DATESTRING4);
		$query->Close ();
		$help = '<span class="normaltextbold">' . _UAD_JOINED . ' ' . '</span><br />' . $user_regdate . '<br /><br />' . _OPN_HTML_NL;
	}
	unset ($query);
	return $help;

}

function user_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_uname = '';
	get_var ('user_uname', $user_uname, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_uname', $user_uname);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			user_get_the_user_addon_info ($uid);
			break;
		case 'save':
			user_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			user_confirm_the_user_addon_info ();
			break;
		case 'show_page':
			$option['content'] = user_show_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>