<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function user_accessibility_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_accessibility = 0;
	$result = &$opnConfig['database']->SelectLimit ('SELECT user_accessibility FROM ' . $opnTables['user_accessibility'] . ' WHERE uid=' . $usernr, 1);
	if ( ($result !== false) && ($result->RecordCount () == 1) ) {
		$user_accessibility = $result->fields['user_accessibility'];
		$result->Close ();
	}
	unset ($result);
	if ($user_accessibility == 0) {
		$user_accessibility = $opnConfig['opn_default_accessibility'];
	}
	getLanguageDef (_OPN_ROOT_PATH . 'system/user_accessibility/plugin/user/language/');
	$opnConfig['opnOption']['form']->AddOpenHeadRow ();
	$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->ResetAlternate ();
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddLabel ('user_accessibility', _USER_ACCESSIBILITY_USEACCESSIBILITY . ' <span class="alerttextcolor">' . _USER_ACCESSIBILITY_OPTIONAL . '</span>');
	include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');
	$_options = get_accessibility_options ();
	$options = array ();
	foreach ($_options as $key => $option) {
		$options[$option] = $key;
	}
	$opnConfig['opnOption']['form']->AddSelect ('user_accessibility', $options, $user_accessibility);
	$opnConfig['opnOption']['form']->AddCloseRow ();
	unset ($options);

}

function user_accessibility_getdata_the_user_addon_info ($usernr, &$result) {

	global $opnConfig, $opnTables;

	$user_accessibility = 0;
	$result1 = &$opnConfig['database']->SelectLimit ('SELECT user_accessibility FROM ' . $opnTables['user_accessibility'] . ' WHERE uid=' . $usernr, 1);
	if ( ($result1 !== false) && ($result1->RecordCount () == 1) ) {
		$user_accessibility = $result1->fields['user_accessibility'];
		$result1->Close ();
	}
	unset ($result1);
	if ($user_accessibility == 0) {
		$user_accessibility = $opnConfig['opn_default_accessibility'];
	}
	$result['tags'] = array ('user_accessibility' => $user_accessibility);

}

function user_accessibility_getvar_the_user_addon_info (&$result) {

	$result['tags'] = 'user_accessibility,';

}

function user_accessibility_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_accessibility = 0;
	get_var ('user_accessibility', $user_accessibility, 'form', _OOBJ_DTYPE_INT);
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_accessibility FROM ' . $opnTables['user_accessibility'] . " WHERE uid=$usernr", 1);
	if ($query->RecordCount () == 1) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_accessibility'] . " SET user_accessibility=$user_accessibility WHERE uid=$usernr");
	} else {
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_accessibility'] . ' (uid,user_accessibility)' . " VALUES ($usernr,$user_accessibility)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			die ($opnConfig['database']->ErrorMsg () . ' : Could not register new user into ' . $opnTables['user_accessibility'] . " table. $usernr, $user_accessibility");
		}
	}
	$query->Close ();
	unset ($query);

}

function user_accessibility_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_accessibility = 0;
	get_var ('user_accessibility', $user_accessibility, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_accessibility', $user_accessibility);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_accessibility_deletehard_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_accessibility'] . ' WHERE uid=' . $usernr);

}

function user_accessibility_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			user_accessibility_get_the_user_addon_info ($uid);
			break;
		case 'save':
			user_accessibility_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			user_accessibility_confirm_the_user_addon_info ();
			break;
		case 'getvar':
			user_accessibility_getvar_the_user_addon_info ($option['data']);
			break;
		case 'getdata':
			user_accessibility_getdata_the_user_addon_info ($uid, $option['data']);
			break;
		case 'deletehard':
			user_accessibility_deletehard_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>