<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_SETTING, _PERM_ADMIN) );
$opnConfig['module']->InitModule ('system/user_avatar');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/user_avatar/admin/language/');

function user_avatarConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_USAV_ADMIN_CONFIG);
	$menu->InsertEntry (_USAV_ADMIN_MAIN, $opnConfig['opn_url'] . '/system/user_avatar/admin/index.php');
	if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_USAV_ADMIN_IMPORT,
											array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
			'op' => 'import') );
	}
	if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_USAV_ADMIN_DELETEALL,
											array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
			'op' => 'UserAvatarDelAll') );
	}
	if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_SETTING, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_USAV_ADMIN_SETTINGS,
											$opnConfig['opn_url'] . '/system/user_avatar/admin/settings.php');
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function UserAvatarAdmin () {

	global $opnConfig, $opnTables;

	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$sortby = 'asc_id';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['user_avatar_dat'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$sql = 'SELECT id, avatar_url, avatar_text, avatar_user, avatar_usergroup FROM ' . $opnTables['user_avatar_dat'];
	$sortby1 = _USAV_ORDERBY . " ";
	$newsortby = $sortby;
	$order = '';
	$progurl = array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php');
	$search = array ('asc_',
			'desc_');
	$replace = array ('',
			'');
	$s = str_replace ($search, $replace, $sortby);
	switch ($s) {
		case 'id':
			$sortby1 .= _USAV_ID . '&nbsp;';
			break;
		case 'avatar_text':
			$sortby1 .= _USAV_ADMIN_AVATEXT . '&nbsp;';
			break;
		case 'avatar_user':
			$sortby1 .= _USAV_ADMIN_USER . '&nbsp;';
			break;
		case 'avatar_usergroup':
			$sortby1 .= _USAV_ADMIN_USERGROUP . '&nbsp;';
			break;
	}
	if (substr_count ($sortby, 'desc_')>0) {
		$sortby1 .= _USAV_ORDERDESC;
	} else {
		$sortby1 .= _USAV_ORDERASC;
	}
	$boxtxt = '<div class="centertag">' . $sortby1 . '</div><br /><br />';
	$table = & new opn_TableClass ('alternator');
	$table->get_sort_order ($order, array ('id',
						'avatar_text',
						'avatar_user',
						'avatar_usergroup'),
						$newsortby);
	$getUserAvatar = &$opnConfig['database']->SelectLimit ($sql . ' ' . $order, $maxperpage, $offset);
	$table->AddHeaderRow (array ($table->get_sort_feld ('id', _USAV_ID, $progurl), $table->get_sort_feld ('avatar_text', _USAV_ADMIN_AVATEXT, $progurl), $table->get_sort_feld ('avatar_user', _USAV_ADMIN_USER, $progurl), $table->get_sort_feld ('avatar_usergroup', _USAV_ADMIN_USERGROUP, $progurl), _USAV_ADMIN_FUNCTIONS) );
	while (! $getUserAvatar->EOF) {
		$UserAvatar = $getUserAvatar->GetRowAssoc ('0');
		$table->AddOpenRow ();
		$table->AddDataCol ('<img src="' . $UserAvatar['avatar_url'] . '" alt="" />', 'center');
		$table->AddDataCol ($UserAvatar['avatar_text'], 'center');
		if ($UserAvatar['avatar_user'] >= 2) {
			$tui = $opnConfig['permission']->GetUser ($UserAvatar['avatar_user'], 'uid', '');
			$name = $tui['uname'];
		} else {
			$name = _SEARCH_ALL;
		}
		$table->AddDataCol ($name, 'center');
		$table->AddDataCol ($UserAvatar['avatar_usergroup'], 'center');
		$hlp = '';
		if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
			$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
										'op' => 'UserAvatarEdit',
										_OPN_VAR_TABLE_SORT_VAR => $sortby,
										'offset' => $offset,
										'id' => $UserAvatar['id']) ) . ' ';
		}
		if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
			$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
										'op' => 'UserAvatarDel',
										_OPN_VAR_TABLE_SORT_VAR => $sortby,
										'offset' => $offset,
										'id' => $UserAvatar['id']) );
		}
		$table->AddDataCol ($hlp, 'center');
		$table->AddCloseRow ();
		$getUserAvatar->MoveNext ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
					'sortby' => $sortby),
					$reccount,
					$maxperpage,
					$offset,
					_USAV_ALLAVATARSINOURDATABASEARE . _USAV_ADMIN_AVA);
	if ($opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_AVATAR_10_', 'user_avatar');
		$form->Init ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php', 'post', '', 'multipart/form-data');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('avatar_text', _USAV_ADMIN_AVATEXT);
		$form->AddTextfield ('avatar_text', 50, 250);
		$form->AddChangeRow ();
		$form->AddLabel ('avatar_url', _USAV_ADMIN_AVAURL);
		$form->AddTextfield ('avatar_url', 50, 250);
		$form->AddChangeRow ();
		$form->AddLabel ('avatar_user', _USAV_ADMIN_USER);
		$result = &$opnConfig['database']->Execute ('SELECT uid,uname FROM ' . $opnTables['users'] . " WHERE email <> '' ORDER BY uname");
		$options = array ();
		$options[0] = _SEARCH_ALL;
		while (! $result->EOF) {
			$options[$result->fields['uid']] = $result->fields['uname'];
			$result->MoveNext ();
		}
		$form->AddSelect ('avatar_user', $options, '');
		$form->AddChangeRow ();
		$form->AddLabel ('avatar_usergroup', _USAV_ADMIN_USERGROUP);
		$options = array ();
		$result = &$opnConfig['database']->Execute ('SELECT user_group_id, user_group_text FROM ' . $opnTables['user_group']);
		$options = array ();
		while (! $result->EOF) {
			$options[$result->fields['user_group_id']] = $result->fields['user_group_text'];
			$result->MoveNext ();
		}
		$form->AddSelect ('avatar_usergroup', $options, '');
		$form->AddChangeRow ();
		$form->AddLabel ('userupload', _USAV_ADMIN_AVAUPLOAD);
		$form->SetSameCol ();
		$form->AddFile ('userupload');
		$form->AddText ('&nbsp;max:&nbsp;' . $opnConfig['opn_upload_size_limit'] . '&nbsp;bytes');
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'UserAvatarAdd');
		$form->AddSubmit ('submit', _USAV_ADMIN_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	return $boxtxt;

}

function UserAvatarEdit () {

	global $opnConfig, $opnTables;

	$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '<div class="normaltext">';
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	if ($getUserAvatar = &$opnConfig['database']->SelectLimit ('SELECT id, avatar_url, avatar_text, avatar_user, avatar_usergroup FROM ' . $opnTables['user_avatar_dat'] . " WHERE id = $id", 1) ) {
		$numUserAvatar = $getUserAvatar->RecordCount ();
		if ($numUserAvatar == 0) {
			$boxtxt .= sprintf (_USAV_ADMIN_NOAVAS, $opnConfig['opn_url'] . '/system/user_avatar/admin/index.php');
		} else {
			$UserAvatar = $getUserAvatar->GetRowAssoc ('0');
			if ($UserAvatar) {
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_AVATAR_20_', 'user_avatar');
				$form->Init ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php');
				$form->AddTable ();
				$form->AddCols (array ('10%', '90%') );
				$form->AddOpenRow ();
				$form->AddLabel ('avatar_text', _USAV_ADMIN_AVATEXT);
				$form->AddTextfield ('avatar_text', 50, 250, $UserAvatar['avatar_text']);
				$form->AddChangeRow ();
				$form->AddLabel ('avatar_url', _USAV_ADMIN_AVAURL);
				$form->AddTextfield ('avatar_url', 50, 250, $UserAvatar['avatar_url']);
				$form->AddChangeRow ();
				$form->AddLabel ('avatar_user', _USAV_ADMIN_USER);
				$result = &$opnConfig['database']->Execute ('SELECT uid,uname FROM ' . $opnTables['users'] . " WHERE email <> '' ORDER BY uname");
				$options = array ();
				$options[0] = _SEARCH_ALL;
				while (! $result->EOF) {
					$options[$result->fields['uid']] = $result->fields['uname'];
					$result->MoveNext ();
				}
				$form->AddSelect ('avatar_user', $options, $UserAvatar['avatar_user']);
				$form->AddChangeRow ();
				$form->AddLabel ('avatar_usergroup', _USAV_ADMIN_USERGROUP);
				$options = array ();
				$result = &$opnConfig['database']->Execute ('SELECT user_group_id, user_group_text FROM ' . $opnTables['user_group']);
				$options = array ();
				while (! $result->EOF) {
					$options[$result->fields['user_group_id']] = $result->fields['user_group_text'];
					$result->MoveNext ();
				}
				$form->AddSelect ('avatar_usergroup', $options, $UserAvatar['avatar_usergroup']);
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddHidden ('id', $UserAvatar['id']);
				$form->AddHidden ('op', 'UserAvatarSave');
				$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
				$form->AddHidden ('offset', $offset);
				$form->SetEndCol ();
				$form->AddSubmit ('submit', _USAV_ADMIN_SAVE);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
			}
		}
	} else {
		$boxtxt .= _USAV_ADMIN_ERRORDB;
	}
	$boxtxt .= '</div>';
	return $boxtxt;

}

function UserAvatarDel () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_DELETE, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = '';
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_CLEAN);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$result = &$opnConfig['database']->Execute ('SELECT id,avatar_url FROM ' . $opnTables['user_avatar_dat'] . " WHERE id=$id");
		if ($result !== false) {
			$id = 0;
			$id = $result->fields['id'];
			$url = $result->fields['avatar_url'];
			$result->Close ();
			if ($id != 0) {
				$_url = $opnConfig['opnSQL']->qstr ($url);
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_avatar'] . " SET user_avatar='' WHERE user_avatar=$_url");
			}
		}
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_avatar_dat'] . ' WHERE id=' . $id);
		return '';
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= _USAV_ADMIN_WARNING . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
									'op' => 'UserAvatarDel',
									_OPN_VAR_TABLE_SORT_VAR => $sortby,
									'offset' => $offset,
									'id' => $id,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php?op=UserAvatarAdmin') . '">' . _NO . '</a><br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function UserAvatarDelAll () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_DELETE, _PERM_ADMIN) );
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_avatar'] . " SET user_avatar=''");
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_avatar_dat']);
		return '';
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= _USAV_ADMIN_WARNINGDELALL . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php',
									'op' => 'UserAvatarDelAll',
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_avatar/admin/index.php?op=UserAvatarAdmin') . '">' . _NO . '</a><br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function UserAvatarAdd () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_NEW, _PERM_ADMIN) );
	$avatar_url = '';
	get_var ('avatar_url', $avatar_url, 'form', _OOBJ_DTYPE_URL);
	$avatar_text = '';
	get_var ('avatar_text', $avatar_text, 'form', _OOBJ_DTYPE_CHECK);
	$avatar_user = 0;
	get_var ('avatar_user', $avatar_user, 'form', _OOBJ_DTYPE_INT);
	$avatar_usergroup = 0;
	get_var ('avatar_usergroup', $avatar_usergroup, 'form', _OOBJ_DTYPE_INT);
	$userupload = '';
	get_var ('userupload', $userupload, 'file');
	$auto = 0;
	get_var ('auto', $auto, 'form', _OOBJ_DTYPE_INT);
	if ($avatar_text != '') {
		$skipsave = FALSE;

		/*
		if (file_exists($opnConfig['datasave']['user_avatar_url']['path'].'/'.$avatar_url)) {
		$auto = 1;
		$avatar_url = $opnConfig['datasave']['user_avatar_url']['url'].'/'.$avatar_url;
		}
		*/
		if ($auto == 0) {
			if (substr_count ($avatar_url, 'http://')>0) {
				// $avatar_url = $opnConfig['opnSQL']->qstr($avatar_url);
			} else {
				if ($userupload == '') {
					$userupload = 'none';
				}
				$userupload = check_upload ($userupload);
				if ($userupload <> 'none') {
					require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
					$upload = & new file_upload_class;
					$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
					$upload->max_image_size ($opnConfig['user_avatar_width'], $opnConfig['user_avatar_height']);
					if ($upload->upload ('userupload', 'image', '') ) {
						if ($upload->save_file ($opnConfig['datasave']['user_avatar_url']['path'], 3) ) {
							$file = $upload->new_file;
							$filename = $upload->file['name'];
						}
					}
					if (isset ($upload->errors) ) {
						foreach ($upload->errors as $var) {
							echo '<br /><br />' . $var . '<br />';
							$skipsave = TRUE;
						}
					}
				}
				if (isset ($filename) ) {
					$avatar_url = $filename;
				}
				$avatar_url = $opnConfig['datasave']['user_avatar_url']['url'] . '/' . $avatar_url;
			}
		} else {
			$_avatar_url = $opnConfig['opnSQL']->qstr ($avatar_url);
			$result = $opnConfig['database']->Execute ('SELECT COUNT(id) AS counter FROM ' . $opnTables['user_avatar_dat'] . " WHERE avatar_url=$_avatar_url");
			$counter = $result->fields['counter'];
			$result->Close ();
			unset ($result);
			if ($counter >= 1) {
				$skipsave = true;
			}
		}
		$avatar_url = $opnConfig['opnSQL']->qstr ($avatar_url);
		$avatar_text = $opnConfig['opnSQL']->qstr ($avatar_text);
		if ($skipsave == FALSE) {
			$id = $opnConfig['opnSQL']->get_new_number ('user_avatar_dat', 'id');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_avatar_dat'] . " (id, avatar_url, avatar_text, avatar_user, avatar_usergroup) VALUES ($id, $avatar_url,$avatar_text, $avatar_user,$avatar_usergroup)");
			if ($opnConfig['database']->ErrorNo ()>0) {
				$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
				return $boxtxt;
			}
		}
	}
	return '';

}

function UserAvatarSave () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_NEW, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$avatar_url = '';
	get_var ('avatar_url', $avatar_url, 'form', _OOBJ_DTYPE_URL);
	$avatar_text = '';
	get_var ('avatar_text', $avatar_text, 'form', _OOBJ_DTYPE_CHECK);
	$avatar_user = 0;
	get_var ('avatar_user', $avatar_user, 'form', _OOBJ_DTYPE_INT);
	$avatar_usergroup = 0;
	get_var ('avatar_usergroup', $avatar_usergroup, 'form', _OOBJ_DTYPE_INT);
	$avatar_url = $opnConfig['opnSQL']->qstr ($avatar_url);
	$avatar_text = $opnConfig['opnSQL']->qstr ($avatar_text);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_avatar_dat'] . " SET avatar_url = $avatar_url, avatar_text = $avatar_text, avatar_user=$avatar_user, avatar_usergroup = $avatar_usergroup WHERE id = $id");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	return '';

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	default:
		$boxtxt .= UserAvatarAdmin ();
		break;
	case 'UserAvatarAdmin':
		$boxtxt .= UserAvatarAdmin ();
		break;
	case 'UserAvatarEdit':
		$boxtxt .= UserAvatarEdit ();
		break;
	case 'UserAvatarDel':
		$txt = UserAvatarDel ();
		if ($txt == '') {
			$boxtxt .= UserAvatarAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserAvatarDelAll':
		$txt = UserAvatarDelAll ();
		if ($txt == '') {
			$boxtxt .= UserAvatarAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserAvatarAdd':
		$txt = UserAvatarAdd ();
		if ($txt == '') {
			$boxtxt .= UserAvatarAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserAvatarSave':
		$txt = UserAvatarSave ();
		if ($txt == '') {
			$boxtxt .= UserAvatarAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'import':
		$opnConfig['permission']->HasRights ('system/user_avatar', array (_PERM_NEW, _PERM_ADMIN) );
		$filelist = get_file_list (_OPN_ROOT_PATH . 'system/user_avatar/images');
		natcasesort ($filelist);
		reset ($filelist);
		foreach ($filelist as $file) {
			if (!preg_match ('/.gif|.jpg|.png/', $file) ) {
				if ($file == '.' || $file == '..') {
					$a = 1;
				}
			} else {
				set_var ('avatar_url', $opnConfig['opn_url'] . '/system/user_avatar/images/' . $file, 'form');
				set_var ('avatar_text', $file, 'form');
				set_var ('avatar_user', 0, 'form');
				set_var ('avatar_usergroup', 0, 'form');
				set_var ('auto', 1, 'form');
				$txt = UserAvatarAdd ();
				if ($txt != '') {
					$boxtxt .= $txt;
				}
				unset_var ('avatar_url', 'form');
				unset_var ('avatar_text', 'form');
				unset_var ('avatar_user', 'form');
				unset_var ('avatar_usergroup', 'form');
				unset_var ('auto', 'form');
			}
		}
		unset ($filelist);
		$boxtxt .= UserAvatarAdmin ();
		break;
}
user_avatarConfigHeader ();
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_AVATAR_30_';
$_display_dat['module'] = 'system/user_avatar';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_USAV_ADMIN_AVAS, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>