<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function user_invisible_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_invisible = 0;
	if ($opnConfig['permission']->HasRights ('system/user_invisible', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$result = &$opnConfig['database']->SelectLimit ('SELECT user_invisible FROM ' . $opnTables['user_invisible'] . ' WHERE uid=' . $usernr,
											1);
		if ( ($result !== false) && ($result->RecordCount () == 1) ) {
			$user_invisible = $result->fields['user_invisible'];
			$result->Close ();
		}
		unset ($result);
		if ($user_invisible == 0) {
			$user_invisible = 0;
		}
		getLanguageDef (_OPN_ROOT_PATH . 'system/user_invisible/plugin/user/language/');
		$opnConfig['opnOption']['form']->AddOpenHeadRow ();
		$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
		$opnConfig['opnOption']['form']->AddCloseRow ();
		$opnConfig['opnOption']['form']->ResetAlternate ();
		$opnConfig['opnOption']['form']->AddOpenRow ();
		$opnConfig['opnOption']['form']->AddLabel ('user_invisible', _USER_INVISIBLE_USEINVISIBLE . ' <span class="alerttextcolor">' . _USER_INVISIBLE_OPTIONAL . '</span>');
		$options = array ();
		$options[0] = _NO_SUBMIT;
		$options[1] = _YES_SUBMIT;
		$opnConfig['opnOption']['form']->AddSelect ('user_invisible', $options, $user_invisible);
		$opnConfig['opnOption']['form']->AddCloseRow ();
		unset ($options);
	} else {
		$opnConfig['opnOption']['form']->AddOpenRow ();
		$opnConfig['opnOption']['form']->AddText ('&nbsp;');
		$opnConfig['opnOption']['form']->AddHidden ('user_invisible', 0);
		$opnConfig['opnOption']['form']->AddCloseRow ();
	}

}

function user_invisible_getvar_the_user_addon_info (&$result) {

	$result['tags'] = 'user_invisible,';

}

function user_invisible_getdata_the_user_addon_info ($usernr, &$result) {

	global $opnConfig, $opnTables;

	$user_invisible = 0;
	$result1 = &$opnConfig['database']->SelectLimit ('SELECT user_invisible FROM ' . $opnTables['user_invisible'] . ' WHERE uid=' . $usernr, 1);
	if ( ($result1 !== false) && ($result1->RecordCount () == 1) ) {
		$user_invisible = $result1->fields['user_invisible'];
		$result1->Close ();
	}
	unset ($result1);
	$result['tags'] = array ('user_invisible' => $user_invisible);

}

function user_invisible_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_invisible = 0;
	get_var ('user_invisible', $user_invisible, 'form', _OOBJ_DTYPE_INT);
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_invisible FROM ' . $opnTables['user_invisible'] . " WHERE uid=$usernr", 1);
	if ($query->RecordCount () == 1) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_invisible'] . " SET user_invisible=$user_invisible WHERE uid=$usernr");
	} else {
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_invisible'] . ' (uid,user_invisible)' . " VALUES ($usernr,$user_invisible)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			die ($opnConfig['database']->ErrorMsg () . ' : Could not register new user into ' . $opnTables['user_invisible'] . " table. $usernr, $user_invisible");
		}
	}
	$query->Close ();
	unset ($query);

}

function user_invisible_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_invisible = 0;
	get_var ('user_invisible', $user_invisible, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_invisible', $user_invisible);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_invisible_deletehard_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_invisible'] . ' WHERE uid=' . $usernr);

}

function user_invisible_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			user_invisible_get_the_user_addon_info ($uid);
			break;
		case 'save':
			user_invisible_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			user_invisible_confirm_the_user_addon_info ();
			break;
		case 'getvar':
			user_invisible_getvar_the_user_addon_info ($option['data']);
			break;
		case 'getdata':
			user_invisible_getdata_the_user_addon_info ($uid, $option['data']);
			break;
		case 'deletehard':
			user_invisible_deletehard_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>