<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');

function user_lang_get_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_lang = '';
	$result = &$opnConfig['database']->SelectLimit ('SELECT user_lang FROM ' . $opnTables['user_lang'] . ' WHERE uid=' . $usernr, 1);
	if ($result !== false) {
		if ($result->RecordCount () == 1) {
			$user_lang = $result->fields['user_lang'];
		}
		$result->Close ();
	}
	unset ($result);
	if ($user_lang == '') {
		$user_lang = $opnConfig['language'];
	}
	getLanguageDef (_OPN_ROOT_PATH . 'system/user_lang/plugin/user/language/');
	$opnConfig['opnOption']['form']->AddOpenHeadRow ();
	$opnConfig['opnOption']['form']->AddHeaderCol ('&nbsp;', '', '2');
	$opnConfig['opnOption']['form']->AddCloseRow ();
	$opnConfig['opnOption']['form']->ResetAlternate ();
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddLabel ('user_lang', _USLANG_USELANG . ' <span class="alerttextcolor">' . _USLANG_OPTIONAL . '</span>');
	$options = get_language_options ();
	$opnConfig['opnOption']['form']->AddSelect ('user_lang', $options, $user_lang);
	unset ($options);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_lang_getvar_the_user_addon_info (&$result) {

	$result['tags'] = 'user_lang,';

}

function user_lang_getdata_the_user_addon_info ($usernr, &$result) {

	global $opnConfig, $opnTables;

	$user_lang = '';
	$result1 = &$opnConfig['database']->SelectLimit ('SELECT user_lang FROM ' . $opnTables['user_lang'] . ' WHERE uid=' . $usernr, 1);
	if ($result1 !== false) {
		if ($result1->RecordCount () == 1) {
			$user_lang = $result1->fields['user_lang'];
		}
		$result1->Close ();
	}
	unset ($result1);
	if ($user_lang == '') {
		$user_lang = $opnConfig['language'];
	}
	$result['tags'] = array ('user_lang' => $user_lang);

}

function user_lang_write_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$user_lang = '';
	get_var ('user_lang', $user_lang, 'form', _OOBJ_DTYPE_CLEAN);
	$_user_lang = $opnConfig['opnSQL']->qstr ($user_lang);
	$query = &$opnConfig['database']->SelectLimit ('SELECT user_lang FROM ' . $opnTables['user_lang'] . " WHERE uid=$usernr", 1);
	if ($query->RecordCount () == 1) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_lang'] . " set user_lang=$_user_lang WHERE uid=$usernr");
	} else {
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_lang'] . ' (uid,user_lang)' . " values ($usernr,$_user_lang)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			die ($opnConfig['database']->ErrorMsg () . ' : Could not register new user into ' . $opnTables['user_lang'] . " table. $usernr, $user_lang");
		}
	}
	$query->Close ();
	unset ($query);

}

function user_lang_confirm_the_user_addon_info () {

	global $opnConfig;

	$user_lang = '';
	get_var ('user_lang', $user_lang, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['opnOption']['form']->AddOpenRow ();
	$opnConfig['opnOption']['form']->AddText ('&nbsp;');
	$opnConfig['opnOption']['form']->AddHidden ('user_lang', $user_lang);
	$opnConfig['opnOption']['form']->AddCloseRow ();

}

function user_lang_deletehard_the_user_addon_info ($usernr) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_lang'] . ' WHERE uid=' . $usernr);

}

function user_lang_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'input':
			user_lang_get_the_user_addon_info ($uid);
			break;
		case 'save':
			user_lang_write_the_user_addon_info ($uid);
			break;
		case 'confirm':
			user_lang_confirm_the_user_addon_info ();
			break;
		case 'getvar':
			user_lang_getvar_the_user_addon_info ($option['data']);
			break;
		case 'getdata':
			user_lang_getdata_the_user_addon_info ($uid, $option['data']);
			break;
		case 'deletehard':
			user_lang_deletehard_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>