<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* a handler for "who is online?" information
*
* @author	    Stefan Kaletta	<stefan@openphpnuke.info>
*
*/

class opn_whosonline_object {

	/**
	* Constructor
	*
	*/

	function opn_whosonline_object () {

	}

	/**
	* Get an array of online information
	*
	* @param	object  $sql_statement   {@link sql_statement_element}
	* @return	array   Array of associative arrays of online information
	*/

	function &getAll ($sql_statement = null) {

		global $opnTables, $opnConfig;

		$ret = array ();
		$sql = 'SELECT username, host_addr FROM ' . $opnTables['opn_session'];
		if (is_object ($sql_statement) && is_subclass_of ($sql_statement, 'sql_statement_element') ) {
			$sql .= ' ' . $sql_statement->renderWhere ();
			$limit = $sql_statement->getLimit ();
			$start = $sql_statement->getStart ();
			$result = &$opnConfig['database']->SelectLimit ($sql, $limit, $start);
		} else {
			$result = &$opnConfig['database']->Execute ($sql);
		}
		if ($result !== false) {
			$keys = array ('username',
					'host_addr');
			while (! $result->EOF) {
				$opnConfig['opnSQL']->get_result_array ($ret[], $result, $keys);
				$result->MoveNext ();
			}
			unset ($keys);
			return $ret;
		}
		return false;

	}

	/**
	* Count the number of online users
	*
	* @param	object  $sql_statement   {@link sql_statement_element}
	*/

	function getCount ($sql_statement = null) {

		global $opnTables, $opnConfig;

		$sql = 'SELECT COUNT(username) AS counter FROM ' . $opnTables['opn_session'];
		if (is_object ($sql_statement) && is_subclass_of ($sql_statement, 'sql_statement_element') ) {
			$sql .= ' ' . $sql_statement->renderWhere ();
		}
		$result = &$opnConfig['database']->Execute ($sql);
		if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
			return $result->fields['counter'];
		}
		return false;

	}

}

?>